/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/  OPC_SwitchOpcode /*85 cases */, 59|128,2|128,1/*16699*/, TARGET_VAL(ISD::AND),// ->16705
/*     6*/    OPC_Scope, 61, /*->69*/ // 305 children in Scope
/*     8*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*    11*/      OPC_MoveChild0,
/*    12*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*    15*/      OPC_MoveChild0,
/*    16*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*    19*/      OPC_RecordMemRef,
/*    20*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*    21*/      OPC_CheckFoldableChainNode,
/*    22*/      OPC_MoveChild1,
/*    23*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*    26*/      OPC_RecordChild0, // #1 = $addr
/*    27*/      OPC_MoveChild1,
/*    28*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*    31*/      OPC_RecordChild0, // #2 = $off
/*    32*/      OPC_MoveChild0,
/*    33*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*    36*/      OPC_MoveParent,
/*    37*/      OPC_MoveParent,
/*    38*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*    40*/      OPC_CheckType, MVT::i32,
/*    42*/      OPC_MoveParent,
/*    43*/      OPC_MoveChild2,
/*    44*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    47*/      OPC_RecordChild0, // #3 = $val
/*    48*/      OPC_MoveParent,
/*    49*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*    51*/      OPC_MoveParent,
/*    52*/      OPC_MoveParent,
/*    53*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*    55*/      OPC_EmitMergeInputChains1_0,
/*    56*/      OPC_EmitInteger, MVT::i32, 0, 
/*    59*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*    69*/    /*Scope*/ 62, /*->132*/
/*    70*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*    74*/      OPC_MoveChild0,
/*    75*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*    78*/      OPC_MoveChild0,
/*    79*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*    82*/      OPC_RecordMemRef,
/*    83*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*    84*/      OPC_CheckFoldableChainNode,
/*    85*/      OPC_MoveChild1,
/*    86*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*    89*/      OPC_RecordChild0, // #1 = $addr
/*    90*/      OPC_MoveChild1,
/*    91*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*    94*/      OPC_RecordChild0, // #2 = $off
/*    95*/      OPC_MoveChild0,
/*    96*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*    99*/      OPC_MoveParent,
/*   100*/      OPC_MoveParent,
/*   101*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   103*/      OPC_CheckType, MVT::i32,
/*   105*/      OPC_MoveParent,
/*   106*/      OPC_MoveChild2,
/*   107*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   110*/      OPC_RecordChild0, // #3 = $val
/*   111*/      OPC_MoveParent,
/*   112*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*   114*/      OPC_MoveParent,
/*   115*/      OPC_MoveParent,
/*   116*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   118*/      OPC_EmitMergeInputChains1_0,
/*   119*/      OPC_EmitInteger, MVT::i32, 0, 
/*   122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   132*/    /*Scope*/ 61, /*->194*/
/*   133*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*   136*/      OPC_MoveChild0,
/*   137*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   140*/      OPC_MoveChild0,
/*   141*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*   144*/      OPC_RecordMemRef,
/*   145*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   146*/      OPC_CheckFoldableChainNode,
/*   147*/      OPC_MoveChild1,
/*   148*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   151*/      OPC_RecordChild0, // #1 = $addr
/*   152*/      OPC_MoveChild1,
/*   153*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   156*/      OPC_RecordChild0, // #2 = $off
/*   157*/      OPC_MoveChild0,
/*   158*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   161*/      OPC_MoveParent,
/*   162*/      OPC_MoveParent,
/*   163*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   165*/      OPC_CheckType, MVT::i32,
/*   167*/      OPC_MoveParent,
/*   168*/      OPC_MoveChild2,
/*   169*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   172*/      OPC_RecordChild0, // #3 = $val
/*   173*/      OPC_MoveParent,
/*   174*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*   176*/      OPC_MoveParent,
/*   177*/      OPC_MoveParent,
/*   178*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   180*/      OPC_EmitMergeInputChains1_0,
/*   181*/      OPC_EmitInteger, MVT::i32, 0, 
/*   184*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   194*/    /*Scope*/ 62, /*->257*/
/*   195*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*   199*/      OPC_MoveChild0,
/*   200*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   203*/      OPC_MoveChild0,
/*   204*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*   207*/      OPC_RecordMemRef,
/*   208*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   209*/      OPC_CheckFoldableChainNode,
/*   210*/      OPC_MoveChild1,
/*   211*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   214*/      OPC_RecordChild0, // #1 = $addr
/*   215*/      OPC_MoveChild1,
/*   216*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   219*/      OPC_RecordChild0, // #2 = $off
/*   220*/      OPC_MoveChild0,
/*   221*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   224*/      OPC_MoveParent,
/*   225*/      OPC_MoveParent,
/*   226*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   228*/      OPC_CheckType, MVT::i32,
/*   230*/      OPC_MoveParent,
/*   231*/      OPC_MoveChild2,
/*   232*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   235*/      OPC_RecordChild0, // #3 = $val
/*   236*/      OPC_MoveParent,
/*   237*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*   239*/      OPC_MoveParent,
/*   240*/      OPC_MoveParent,
/*   241*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   243*/      OPC_EmitMergeInputChains1_0,
/*   244*/      OPC_EmitInteger, MVT::i32, 0, 
/*   247*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   257*/    /*Scope*/ 61, /*->319*/
/*   258*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*   261*/      OPC_MoveChild0,
/*   262*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   265*/      OPC_MoveChild0,
/*   266*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*   269*/      OPC_RecordMemRef,
/*   270*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   271*/      OPC_CheckFoldableChainNode,
/*   272*/      OPC_MoveChild1,
/*   273*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   276*/      OPC_RecordChild0, // #1 = $addr
/*   277*/      OPC_MoveChild1,
/*   278*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   281*/      OPC_RecordChild0, // #2 = $off
/*   282*/      OPC_MoveChild0,
/*   283*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   286*/      OPC_MoveParent,
/*   287*/      OPC_MoveParent,
/*   288*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   290*/      OPC_CheckType, MVT::i32,
/*   292*/      OPC_MoveParent,
/*   293*/      OPC_MoveChild2,
/*   294*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   297*/      OPC_RecordChild0, // #3 = $val
/*   298*/      OPC_MoveParent,
/*   299*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*   301*/      OPC_MoveParent,
/*   302*/      OPC_MoveParent,
/*   303*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   305*/      OPC_EmitMergeInputChains1_0,
/*   306*/      OPC_EmitInteger, MVT::i32, 0, 
/*   309*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   319*/    /*Scope*/ 62, /*->382*/
/*   320*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*   324*/      OPC_MoveChild0,
/*   325*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   328*/      OPC_MoveChild0,
/*   329*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*   332*/      OPC_RecordMemRef,
/*   333*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   334*/      OPC_CheckFoldableChainNode,
/*   335*/      OPC_MoveChild1,
/*   336*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   339*/      OPC_RecordChild0, // #1 = $addr
/*   340*/      OPC_MoveChild1,
/*   341*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   344*/      OPC_RecordChild0, // #2 = $off
/*   345*/      OPC_MoveChild0,
/*   346*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   349*/      OPC_MoveParent,
/*   350*/      OPC_MoveParent,
/*   351*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   353*/      OPC_CheckType, MVT::i32,
/*   355*/      OPC_MoveParent,
/*   356*/      OPC_MoveChild2,
/*   357*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   360*/      OPC_RecordChild0, // #3 = $val
/*   361*/      OPC_MoveParent,
/*   362*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*   364*/      OPC_MoveParent,
/*   365*/      OPC_MoveParent,
/*   366*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   368*/      OPC_EmitMergeInputChains1_0,
/*   369*/      OPC_EmitInteger, MVT::i32, 0, 
/*   372*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   382*/    /*Scope*/ 61, /*->444*/
/*   383*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*   386*/      OPC_MoveChild0,
/*   387*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   390*/      OPC_MoveChild0,
/*   391*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*   394*/      OPC_RecordMemRef,
/*   395*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   396*/      OPC_CheckFoldableChainNode,
/*   397*/      OPC_MoveChild1,
/*   398*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   401*/      OPC_RecordChild0, // #1 = $addr
/*   402*/      OPC_MoveChild1,
/*   403*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   406*/      OPC_RecordChild0, // #2 = $off
/*   407*/      OPC_MoveChild0,
/*   408*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   411*/      OPC_MoveParent,
/*   412*/      OPC_MoveParent,
/*   413*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   415*/      OPC_CheckType, MVT::i32,
/*   417*/      OPC_MoveParent,
/*   418*/      OPC_MoveChild2,
/*   419*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   422*/      OPC_RecordChild0, // #3 = $val
/*   423*/      OPC_MoveParent,
/*   424*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*   426*/      OPC_MoveParent,
/*   427*/      OPC_MoveParent,
/*   428*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   430*/      OPC_EmitMergeInputChains1_0,
/*   431*/      OPC_EmitInteger, MVT::i32, 0, 
/*   434*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   444*/    /*Scope*/ 62, /*->507*/
/*   445*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*   449*/      OPC_MoveChild0,
/*   450*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   453*/      OPC_MoveChild0,
/*   454*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*   457*/      OPC_RecordMemRef,
/*   458*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   459*/      OPC_CheckFoldableChainNode,
/*   460*/      OPC_MoveChild1,
/*   461*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   464*/      OPC_RecordChild0, // #1 = $addr
/*   465*/      OPC_MoveChild1,
/*   466*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   469*/      OPC_RecordChild0, // #2 = $off
/*   470*/      OPC_MoveChild0,
/*   471*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   474*/      OPC_MoveParent,
/*   475*/      OPC_MoveParent,
/*   476*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   478*/      OPC_CheckType, MVT::i32,
/*   480*/      OPC_MoveParent,
/*   481*/      OPC_MoveChild2,
/*   482*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   485*/      OPC_RecordChild0, // #3 = $val
/*   486*/      OPC_MoveParent,
/*   487*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*   489*/      OPC_MoveParent,
/*   490*/      OPC_MoveParent,
/*   491*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   493*/      OPC_EmitMergeInputChains1_0,
/*   494*/      OPC_EmitInteger, MVT::i32, 0, 
/*   497*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   507*/    /*Scope*/ 61, /*->569*/
/*   508*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*   511*/      OPC_MoveChild0,
/*   512*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   515*/      OPC_MoveChild0,
/*   516*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*   519*/      OPC_RecordMemRef,
/*   520*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   521*/      OPC_CheckFoldableChainNode,
/*   522*/      OPC_MoveChild1,
/*   523*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   526*/      OPC_RecordChild0, // #1 = $addr
/*   527*/      OPC_MoveChild1,
/*   528*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   531*/      OPC_RecordChild0, // #2 = $off
/*   532*/      OPC_MoveChild0,
/*   533*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   536*/      OPC_MoveParent,
/*   537*/      OPC_MoveParent,
/*   538*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   540*/      OPC_CheckType, MVT::i32,
/*   542*/      OPC_MoveParent,
/*   543*/      OPC_MoveChild2,
/*   544*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   547*/      OPC_RecordChild0, // #3 = $val
/*   548*/      OPC_MoveParent,
/*   549*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*   551*/      OPC_MoveParent,
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   555*/      OPC_EmitMergeInputChains1_0,
/*   556*/      OPC_EmitInteger, MVT::i32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   569*/    /*Scope*/ 62, /*->632*/
/*   570*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*   574*/      OPC_MoveChild0,
/*   575*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   578*/      OPC_MoveChild0,
/*   579*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*   582*/      OPC_RecordMemRef,
/*   583*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   584*/      OPC_CheckFoldableChainNode,
/*   585*/      OPC_MoveChild1,
/*   586*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   589*/      OPC_RecordChild0, // #1 = $addr
/*   590*/      OPC_MoveChild1,
/*   591*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   594*/      OPC_RecordChild0, // #2 = $off
/*   595*/      OPC_MoveChild0,
/*   596*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   599*/      OPC_MoveParent,
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   603*/      OPC_CheckType, MVT::i32,
/*   605*/      OPC_MoveParent,
/*   606*/      OPC_MoveChild2,
/*   607*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   610*/      OPC_RecordChild0, // #3 = $val
/*   611*/      OPC_MoveParent,
/*   612*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*   614*/      OPC_MoveParent,
/*   615*/      OPC_MoveParent,
/*   616*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   618*/      OPC_EmitMergeInputChains1_0,
/*   619*/      OPC_EmitInteger, MVT::i32, 0, 
/*   622*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   632*/    /*Scope*/ 61, /*->694*/
/*   633*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*   636*/      OPC_MoveChild0,
/*   637*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   640*/      OPC_MoveChild0,
/*   641*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*   644*/      OPC_RecordMemRef,
/*   645*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   646*/      OPC_CheckFoldableChainNode,
/*   647*/      OPC_MoveChild1,
/*   648*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   651*/      OPC_RecordChild0, // #1 = $addr
/*   652*/      OPC_MoveChild1,
/*   653*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   656*/      OPC_RecordChild0, // #2 = $off
/*   657*/      OPC_MoveChild0,
/*   658*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   661*/      OPC_MoveParent,
/*   662*/      OPC_MoveParent,
/*   663*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   665*/      OPC_CheckType, MVT::i32,
/*   667*/      OPC_MoveParent,
/*   668*/      OPC_MoveChild2,
/*   669*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   672*/      OPC_RecordChild0, // #3 = $val
/*   673*/      OPC_MoveParent,
/*   674*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_MoveParent,
/*   678*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger, MVT::i32, 0, 
/*   684*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   694*/    /*Scope*/ 62, /*->757*/
/*   695*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*   699*/      OPC_MoveChild0,
/*   700*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   703*/      OPC_MoveChild0,
/*   704*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*   707*/      OPC_RecordMemRef,
/*   708*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   709*/      OPC_CheckFoldableChainNode,
/*   710*/      OPC_MoveChild1,
/*   711*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   714*/      OPC_RecordChild0, // #1 = $addr
/*   715*/      OPC_MoveChild1,
/*   716*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   719*/      OPC_RecordChild0, // #2 = $off
/*   720*/      OPC_MoveChild0,
/*   721*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_MoveParent,
/*   726*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   728*/      OPC_CheckType, MVT::i32,
/*   730*/      OPC_MoveParent,
/*   731*/      OPC_MoveChild2,
/*   732*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   735*/      OPC_RecordChild0, // #3 = $val
/*   736*/      OPC_MoveParent,
/*   737*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*   739*/      OPC_MoveParent,
/*   740*/      OPC_MoveParent,
/*   741*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   743*/      OPC_EmitMergeInputChains1_0,
/*   744*/      OPC_EmitInteger, MVT::i32, 0, 
/*   747*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   757*/    /*Scope*/ 61, /*->819*/
/*   758*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*   761*/      OPC_MoveChild0,
/*   762*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   765*/      OPC_MoveChild0,
/*   766*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*   769*/      OPC_RecordMemRef,
/*   770*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   771*/      OPC_CheckFoldableChainNode,
/*   772*/      OPC_MoveChild1,
/*   773*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   776*/      OPC_MoveChild0,
/*   777*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   780*/      OPC_RecordChild0, // #1 = $off
/*   781*/      OPC_MoveChild0,
/*   782*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   785*/      OPC_MoveParent,
/*   786*/      OPC_MoveParent,
/*   787*/      OPC_RecordChild1, // #2 = $addr
/*   788*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   790*/      OPC_CheckType, MVT::i32,
/*   792*/      OPC_MoveParent,
/*   793*/      OPC_MoveChild2,
/*   794*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   797*/      OPC_RecordChild0, // #3 = $val
/*   798*/      OPC_MoveParent,
/*   799*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*   801*/      OPC_MoveParent,
/*   802*/      OPC_MoveParent,
/*   803*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   805*/      OPC_EmitMergeInputChains1_0,
/*   806*/      OPC_EmitInteger, MVT::i32, 0, 
/*   809*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   819*/    /*Scope*/ 62, /*->882*/
/*   820*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*   824*/      OPC_MoveChild0,
/*   825*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   828*/      OPC_MoveChild0,
/*   829*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*   832*/      OPC_RecordMemRef,
/*   833*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   834*/      OPC_CheckFoldableChainNode,
/*   835*/      OPC_MoveChild1,
/*   836*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   839*/      OPC_MoveChild0,
/*   840*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   843*/      OPC_RecordChild0, // #1 = $off
/*   844*/      OPC_MoveChild0,
/*   845*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   848*/      OPC_MoveParent,
/*   849*/      OPC_MoveParent,
/*   850*/      OPC_RecordChild1, // #2 = $addr
/*   851*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   853*/      OPC_CheckType, MVT::i32,
/*   855*/      OPC_MoveParent,
/*   856*/      OPC_MoveChild2,
/*   857*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   860*/      OPC_RecordChild0, // #3 = $val
/*   861*/      OPC_MoveParent,
/*   862*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*   864*/      OPC_MoveParent,
/*   865*/      OPC_MoveParent,
/*   866*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   868*/      OPC_EmitMergeInputChains1_0,
/*   869*/      OPC_EmitInteger, MVT::i32, 0, 
/*   872*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   882*/    /*Scope*/ 61, /*->944*/
/*   883*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*   886*/      OPC_MoveChild0,
/*   887*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   890*/      OPC_MoveChild0,
/*   891*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*   894*/      OPC_RecordMemRef,
/*   895*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   896*/      OPC_CheckFoldableChainNode,
/*   897*/      OPC_MoveChild1,
/*   898*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   901*/      OPC_MoveChild0,
/*   902*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   905*/      OPC_RecordChild0, // #1 = $off
/*   906*/      OPC_MoveChild0,
/*   907*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   910*/      OPC_MoveParent,
/*   911*/      OPC_MoveParent,
/*   912*/      OPC_RecordChild1, // #2 = $addr
/*   913*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   915*/      OPC_CheckType, MVT::i32,
/*   917*/      OPC_MoveParent,
/*   918*/      OPC_MoveChild2,
/*   919*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   922*/      OPC_RecordChild0, // #3 = $val
/*   923*/      OPC_MoveParent,
/*   924*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*   926*/      OPC_MoveParent,
/*   927*/      OPC_MoveParent,
/*   928*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   930*/      OPC_EmitMergeInputChains1_0,
/*   931*/      OPC_EmitInteger, MVT::i32, 0, 
/*   934*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*   944*/    /*Scope*/ 62, /*->1007*/
/*   945*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*   949*/      OPC_MoveChild0,
/*   950*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*   953*/      OPC_MoveChild0,
/*   954*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*   957*/      OPC_RecordMemRef,
/*   958*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   959*/      OPC_CheckFoldableChainNode,
/*   960*/      OPC_MoveChild1,
/*   961*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*   964*/      OPC_MoveChild0,
/*   965*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*   968*/      OPC_RecordChild0, // #1 = $off
/*   969*/      OPC_MoveChild0,
/*   970*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*   973*/      OPC_MoveParent,
/*   974*/      OPC_MoveParent,
/*   975*/      OPC_RecordChild1, // #2 = $addr
/*   976*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*   978*/      OPC_CheckType, MVT::i32,
/*   980*/      OPC_MoveParent,
/*   981*/      OPC_MoveChild2,
/*   982*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   985*/      OPC_RecordChild0, // #3 = $val
/*   986*/      OPC_MoveParent,
/*   987*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*   989*/      OPC_MoveParent,
/*   990*/      OPC_MoveParent,
/*   991*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*   993*/      OPC_EmitMergeInputChains1_0,
/*   994*/      OPC_EmitInteger, MVT::i32, 0, 
/*   997*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1007*/    /*Scope*/ 61, /*->1069*/
/*  1008*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1011*/      OPC_MoveChild0,
/*  1012*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1015*/      OPC_MoveChild0,
/*  1016*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  1019*/      OPC_RecordMemRef,
/*  1020*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1021*/      OPC_CheckFoldableChainNode,
/*  1022*/      OPC_MoveChild1,
/*  1023*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1026*/      OPC_MoveChild0,
/*  1027*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1030*/      OPC_RecordChild0, // #1 = $off
/*  1031*/      OPC_MoveChild0,
/*  1032*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1035*/      OPC_MoveParent,
/*  1036*/      OPC_MoveParent,
/*  1037*/      OPC_RecordChild1, // #2 = $addr
/*  1038*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1040*/      OPC_CheckType, MVT::i32,
/*  1042*/      OPC_MoveParent,
/*  1043*/      OPC_MoveChild2,
/*  1044*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1047*/      OPC_RecordChild0, // #3 = $val
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  1051*/      OPC_MoveParent,
/*  1052*/      OPC_MoveParent,
/*  1053*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1055*/      OPC_EmitMergeInputChains1_0,
/*  1056*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1059*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1069*/    /*Scope*/ 62, /*->1132*/
/*  1070*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1074*/      OPC_MoveChild0,
/*  1075*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1078*/      OPC_MoveChild0,
/*  1079*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  1082*/      OPC_RecordMemRef,
/*  1083*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1084*/      OPC_CheckFoldableChainNode,
/*  1085*/      OPC_MoveChild1,
/*  1086*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1089*/      OPC_MoveChild0,
/*  1090*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1093*/      OPC_RecordChild0, // #1 = $off
/*  1094*/      OPC_MoveChild0,
/*  1095*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1098*/      OPC_MoveParent,
/*  1099*/      OPC_MoveParent,
/*  1100*/      OPC_RecordChild1, // #2 = $addr
/*  1101*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1103*/      OPC_CheckType, MVT::i32,
/*  1105*/      OPC_MoveParent,
/*  1106*/      OPC_MoveChild2,
/*  1107*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1110*/      OPC_RecordChild0, // #3 = $val
/*  1111*/      OPC_MoveParent,
/*  1112*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  1114*/      OPC_MoveParent,
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1118*/      OPC_EmitMergeInputChains1_0,
/*  1119*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1132*/    /*Scope*/ 61, /*->1194*/
/*  1133*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1136*/      OPC_MoveChild0,
/*  1137*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1140*/      OPC_MoveChild0,
/*  1141*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  1144*/      OPC_RecordMemRef,
/*  1145*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1146*/      OPC_CheckFoldableChainNode,
/*  1147*/      OPC_MoveChild1,
/*  1148*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1151*/      OPC_MoveChild0,
/*  1152*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1155*/      OPC_RecordChild0, // #1 = $off
/*  1156*/      OPC_MoveChild0,
/*  1157*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1160*/      OPC_MoveParent,
/*  1161*/      OPC_MoveParent,
/*  1162*/      OPC_RecordChild1, // #2 = $addr
/*  1163*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1165*/      OPC_CheckType, MVT::i32,
/*  1167*/      OPC_MoveParent,
/*  1168*/      OPC_MoveChild2,
/*  1169*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1172*/      OPC_RecordChild0, // #3 = $val
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  1176*/      OPC_MoveParent,
/*  1177*/      OPC_MoveParent,
/*  1178*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1180*/      OPC_EmitMergeInputChains1_0,
/*  1181*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1184*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1194*/    /*Scope*/ 62, /*->1257*/
/*  1195*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1199*/      OPC_MoveChild0,
/*  1200*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1203*/      OPC_MoveChild0,
/*  1204*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  1207*/      OPC_RecordMemRef,
/*  1208*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1209*/      OPC_CheckFoldableChainNode,
/*  1210*/      OPC_MoveChild1,
/*  1211*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1214*/      OPC_MoveChild0,
/*  1215*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1218*/      OPC_RecordChild0, // #1 = $off
/*  1219*/      OPC_MoveChild0,
/*  1220*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1223*/      OPC_MoveParent,
/*  1224*/      OPC_MoveParent,
/*  1225*/      OPC_RecordChild1, // #2 = $addr
/*  1226*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1228*/      OPC_CheckType, MVT::i32,
/*  1230*/      OPC_MoveParent,
/*  1231*/      OPC_MoveChild2,
/*  1232*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1235*/      OPC_RecordChild0, // #3 = $val
/*  1236*/      OPC_MoveParent,
/*  1237*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_MoveParent,
/*  1241*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1247*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1257*/    /*Scope*/ 61, /*->1319*/
/*  1258*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1261*/      OPC_MoveChild0,
/*  1262*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1265*/      OPC_MoveChild0,
/*  1266*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  1269*/      OPC_RecordMemRef,
/*  1270*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1271*/      OPC_CheckFoldableChainNode,
/*  1272*/      OPC_MoveChild1,
/*  1273*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1276*/      OPC_MoveChild0,
/*  1277*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1280*/      OPC_RecordChild0, // #1 = $off
/*  1281*/      OPC_MoveChild0,
/*  1282*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1285*/      OPC_MoveParent,
/*  1286*/      OPC_MoveParent,
/*  1287*/      OPC_RecordChild1, // #2 = $addr
/*  1288*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1290*/      OPC_CheckType, MVT::i32,
/*  1292*/      OPC_MoveParent,
/*  1293*/      OPC_MoveChild2,
/*  1294*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1297*/      OPC_RecordChild0, // #3 = $val
/*  1298*/      OPC_MoveParent,
/*  1299*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  1301*/      OPC_MoveParent,
/*  1302*/      OPC_MoveParent,
/*  1303*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1305*/      OPC_EmitMergeInputChains1_0,
/*  1306*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1309*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1319*/    /*Scope*/ 62, /*->1382*/
/*  1320*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1324*/      OPC_MoveChild0,
/*  1325*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1328*/      OPC_MoveChild0,
/*  1329*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  1332*/      OPC_RecordMemRef,
/*  1333*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1334*/      OPC_CheckFoldableChainNode,
/*  1335*/      OPC_MoveChild1,
/*  1336*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1339*/      OPC_MoveChild0,
/*  1340*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1343*/      OPC_RecordChild0, // #1 = $off
/*  1344*/      OPC_MoveChild0,
/*  1345*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1348*/      OPC_MoveParent,
/*  1349*/      OPC_MoveParent,
/*  1350*/      OPC_RecordChild1, // #2 = $addr
/*  1351*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1353*/      OPC_CheckType, MVT::i32,
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_MoveChild2,
/*  1357*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1360*/      OPC_RecordChild0, // #3 = $val
/*  1361*/      OPC_MoveParent,
/*  1362*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  1364*/      OPC_MoveParent,
/*  1365*/      OPC_MoveParent,
/*  1366*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1368*/      OPC_EmitMergeInputChains1_0,
/*  1369*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1372*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1382*/    /*Scope*/ 61, /*->1444*/
/*  1383*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1386*/      OPC_MoveChild0,
/*  1387*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1390*/      OPC_MoveChild0,
/*  1391*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  1394*/      OPC_RecordMemRef,
/*  1395*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1396*/      OPC_CheckFoldableChainNode,
/*  1397*/      OPC_MoveChild1,
/*  1398*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1401*/      OPC_MoveChild0,
/*  1402*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1405*/      OPC_RecordChild0, // #1 = $off
/*  1406*/      OPC_MoveChild0,
/*  1407*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1410*/      OPC_MoveParent,
/*  1411*/      OPC_MoveParent,
/*  1412*/      OPC_RecordChild1, // #2 = $addr
/*  1413*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1415*/      OPC_CheckType, MVT::i32,
/*  1417*/      OPC_MoveParent,
/*  1418*/      OPC_MoveChild2,
/*  1419*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1422*/      OPC_RecordChild0, // #3 = $val
/*  1423*/      OPC_MoveParent,
/*  1424*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  1426*/      OPC_MoveParent,
/*  1427*/      OPC_MoveParent,
/*  1428*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1430*/      OPC_EmitMergeInputChains1_0,
/*  1431*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1434*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1444*/    /*Scope*/ 62, /*->1507*/
/*  1445*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1449*/      OPC_MoveChild0,
/*  1450*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1453*/      OPC_MoveChild0,
/*  1454*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  1457*/      OPC_RecordMemRef,
/*  1458*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1459*/      OPC_CheckFoldableChainNode,
/*  1460*/      OPC_MoveChild1,
/*  1461*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1464*/      OPC_MoveChild0,
/*  1465*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1468*/      OPC_RecordChild0, // #1 = $off
/*  1469*/      OPC_MoveChild0,
/*  1470*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  1473*/      OPC_MoveParent,
/*  1474*/      OPC_MoveParent,
/*  1475*/      OPC_RecordChild1, // #2 = $addr
/*  1476*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  1478*/      OPC_CheckType, MVT::i32,
/*  1480*/      OPC_MoveParent,
/*  1481*/      OPC_MoveChild2,
/*  1482*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1485*/      OPC_RecordChild0, // #3 = $val
/*  1486*/      OPC_MoveParent,
/*  1487*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  1489*/      OPC_MoveParent,
/*  1490*/      OPC_MoveParent,
/*  1491*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1493*/      OPC_EmitMergeInputChains1_0,
/*  1494*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1497*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 28
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1507*/    /*Scope*/ 59, /*->1567*/
/*  1508*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1511*/      OPC_MoveChild0,
/*  1512*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1515*/      OPC_MoveChild0,
/*  1516*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  1519*/      OPC_RecordMemRef,
/*  1520*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1521*/      OPC_CheckFoldableChainNode,
/*  1522*/      OPC_MoveChild1,
/*  1523*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1526*/      OPC_RecordChild0, // #1 = $addr
/*  1527*/      OPC_MoveChild1,
/*  1528*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1531*/      OPC_RecordChild0, // #2 = $off
/*  1532*/      OPC_MoveChild0,
/*  1533*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1536*/      OPC_MoveParent,
/*  1537*/      OPC_MoveParent,
/*  1538*/      OPC_CheckType, MVT::i32,
/*  1540*/      OPC_MoveParent,
/*  1541*/      OPC_MoveChild2,
/*  1542*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1545*/      OPC_RecordChild0, // #3 = $val
/*  1546*/      OPC_MoveParent,
/*  1547*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  1549*/      OPC_MoveParent,
/*  1550*/      OPC_MoveParent,
/*  1551*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1553*/      OPC_EmitMergeInputChains1_0,
/*  1554*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1557*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1567*/    /*Scope*/ 60, /*->1628*/
/*  1568*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1572*/      OPC_MoveChild0,
/*  1573*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1576*/      OPC_MoveChild0,
/*  1577*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  1580*/      OPC_RecordMemRef,
/*  1581*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1582*/      OPC_CheckFoldableChainNode,
/*  1583*/      OPC_MoveChild1,
/*  1584*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1587*/      OPC_RecordChild0, // #1 = $addr
/*  1588*/      OPC_MoveChild1,
/*  1589*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1592*/      OPC_RecordChild0, // #2 = $off
/*  1593*/      OPC_MoveChild0,
/*  1594*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1597*/      OPC_MoveParent,
/*  1598*/      OPC_MoveParent,
/*  1599*/      OPC_CheckType, MVT::i32,
/*  1601*/      OPC_MoveParent,
/*  1602*/      OPC_MoveChild2,
/*  1603*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/      OPC_RecordChild0, // #3 = $val
/*  1607*/      OPC_MoveParent,
/*  1608*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  1610*/      OPC_MoveParent,
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1614*/      OPC_EmitMergeInputChains1_0,
/*  1615*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1628*/    /*Scope*/ 59, /*->1688*/
/*  1629*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1632*/      OPC_MoveChild0,
/*  1633*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1636*/      OPC_MoveChild0,
/*  1637*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  1640*/      OPC_RecordMemRef,
/*  1641*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1642*/      OPC_CheckFoldableChainNode,
/*  1643*/      OPC_MoveChild1,
/*  1644*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1647*/      OPC_RecordChild0, // #1 = $addr
/*  1648*/      OPC_MoveChild1,
/*  1649*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1652*/      OPC_RecordChild0, // #2 = $off
/*  1653*/      OPC_MoveChild0,
/*  1654*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1657*/      OPC_MoveParent,
/*  1658*/      OPC_MoveParent,
/*  1659*/      OPC_CheckType, MVT::i32,
/*  1661*/      OPC_MoveParent,
/*  1662*/      OPC_MoveChild2,
/*  1663*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1666*/      OPC_RecordChild0, // #3 = $val
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  1670*/      OPC_MoveParent,
/*  1671*/      OPC_MoveParent,
/*  1672*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1674*/      OPC_EmitMergeInputChains1_0,
/*  1675*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1678*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1688*/    /*Scope*/ 60, /*->1749*/
/*  1689*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1693*/      OPC_MoveChild0,
/*  1694*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1697*/      OPC_MoveChild0,
/*  1698*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  1701*/      OPC_RecordMemRef,
/*  1702*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1703*/      OPC_CheckFoldableChainNode,
/*  1704*/      OPC_MoveChild1,
/*  1705*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1708*/      OPC_RecordChild0, // #1 = $addr
/*  1709*/      OPC_MoveChild1,
/*  1710*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1713*/      OPC_RecordChild0, // #2 = $off
/*  1714*/      OPC_MoveChild0,
/*  1715*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1718*/      OPC_MoveParent,
/*  1719*/      OPC_MoveParent,
/*  1720*/      OPC_CheckType, MVT::i32,
/*  1722*/      OPC_MoveParent,
/*  1723*/      OPC_MoveChild2,
/*  1724*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1727*/      OPC_RecordChild0, // #3 = $val
/*  1728*/      OPC_MoveParent,
/*  1729*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  1731*/      OPC_MoveParent,
/*  1732*/      OPC_MoveParent,
/*  1733*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1735*/      OPC_EmitMergeInputChains1_0,
/*  1736*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1739*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1749*/    /*Scope*/ 59, /*->1809*/
/*  1750*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1753*/      OPC_MoveChild0,
/*  1754*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1757*/      OPC_MoveChild0,
/*  1758*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  1761*/      OPC_RecordMemRef,
/*  1762*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1763*/      OPC_CheckFoldableChainNode,
/*  1764*/      OPC_MoveChild1,
/*  1765*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1768*/      OPC_RecordChild0, // #1 = $addr
/*  1769*/      OPC_MoveChild1,
/*  1770*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1773*/      OPC_RecordChild0, // #2 = $off
/*  1774*/      OPC_MoveChild0,
/*  1775*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1778*/      OPC_MoveParent,
/*  1779*/      OPC_MoveParent,
/*  1780*/      OPC_CheckType, MVT::i32,
/*  1782*/      OPC_MoveParent,
/*  1783*/      OPC_MoveChild2,
/*  1784*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1787*/      OPC_RecordChild0, // #3 = $val
/*  1788*/      OPC_MoveParent,
/*  1789*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  1791*/      OPC_MoveParent,
/*  1792*/      OPC_MoveParent,
/*  1793*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1795*/      OPC_EmitMergeInputChains1_0,
/*  1796*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1799*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1809*/    /*Scope*/ 60, /*->1870*/
/*  1810*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1814*/      OPC_MoveChild0,
/*  1815*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1818*/      OPC_MoveChild0,
/*  1819*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  1822*/      OPC_RecordMemRef,
/*  1823*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1824*/      OPC_CheckFoldableChainNode,
/*  1825*/      OPC_MoveChild1,
/*  1826*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1829*/      OPC_RecordChild0, // #1 = $addr
/*  1830*/      OPC_MoveChild1,
/*  1831*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1834*/      OPC_RecordChild0, // #2 = $off
/*  1835*/      OPC_MoveChild0,
/*  1836*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1839*/      OPC_MoveParent,
/*  1840*/      OPC_MoveParent,
/*  1841*/      OPC_CheckType, MVT::i32,
/*  1843*/      OPC_MoveParent,
/*  1844*/      OPC_MoveChild2,
/*  1845*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1848*/      OPC_RecordChild0, // #3 = $val
/*  1849*/      OPC_MoveParent,
/*  1850*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  1852*/      OPC_MoveParent,
/*  1853*/      OPC_MoveParent,
/*  1854*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1856*/      OPC_EmitMergeInputChains1_0,
/*  1857*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1860*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1870*/    /*Scope*/ 59, /*->1930*/
/*  1871*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1874*/      OPC_MoveChild0,
/*  1875*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1878*/      OPC_MoveChild0,
/*  1879*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  1882*/      OPC_RecordMemRef,
/*  1883*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1884*/      OPC_CheckFoldableChainNode,
/*  1885*/      OPC_MoveChild1,
/*  1886*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1889*/      OPC_RecordChild0, // #1 = $addr
/*  1890*/      OPC_MoveChild1,
/*  1891*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1894*/      OPC_RecordChild0, // #2 = $off
/*  1895*/      OPC_MoveChild0,
/*  1896*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1899*/      OPC_MoveParent,
/*  1900*/      OPC_MoveParent,
/*  1901*/      OPC_CheckType, MVT::i32,
/*  1903*/      OPC_MoveParent,
/*  1904*/      OPC_MoveChild2,
/*  1905*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1908*/      OPC_RecordChild0, // #3 = $val
/*  1909*/      OPC_MoveParent,
/*  1910*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  1912*/      OPC_MoveParent,
/*  1913*/      OPC_MoveParent,
/*  1914*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1916*/      OPC_EmitMergeInputChains1_0,
/*  1917*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1920*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1930*/    /*Scope*/ 60, /*->1991*/
/*  1931*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  1935*/      OPC_MoveChild0,
/*  1936*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1939*/      OPC_MoveChild0,
/*  1940*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  1943*/      OPC_RecordMemRef,
/*  1944*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1945*/      OPC_CheckFoldableChainNode,
/*  1946*/      OPC_MoveChild1,
/*  1947*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  1950*/      OPC_RecordChild0, // #1 = $addr
/*  1951*/      OPC_MoveChild1,
/*  1952*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  1955*/      OPC_RecordChild0, // #2 = $off
/*  1956*/      OPC_MoveChild0,
/*  1957*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  1960*/      OPC_MoveParent,
/*  1961*/      OPC_MoveParent,
/*  1962*/      OPC_CheckType, MVT::i32,
/*  1964*/      OPC_MoveParent,
/*  1965*/      OPC_MoveChild2,
/*  1966*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1969*/      OPC_RecordChild0, // #3 = $val
/*  1970*/      OPC_MoveParent,
/*  1971*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_MoveParent,
/*  1975*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1981*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  1991*/    /*Scope*/ 59, /*->2051*/
/*  1992*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  1995*/      OPC_MoveChild0,
/*  1996*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  1999*/      OPC_MoveChild0,
/*  2000*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  2003*/      OPC_RecordMemRef,
/*  2004*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  2005*/      OPC_CheckFoldableChainNode,
/*  2006*/      OPC_MoveChild1,
/*  2007*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2010*/      OPC_RecordChild0, // #1 = $addr
/*  2011*/      OPC_MoveChild1,
/*  2012*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2015*/      OPC_RecordChild0, // #2 = $off
/*  2016*/      OPC_MoveChild0,
/*  2017*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2020*/      OPC_MoveParent,
/*  2021*/      OPC_MoveParent,
/*  2022*/      OPC_CheckType, MVT::i32,
/*  2024*/      OPC_MoveParent,
/*  2025*/      OPC_MoveChild2,
/*  2026*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2029*/      OPC_RecordChild0, // #3 = $val
/*  2030*/      OPC_MoveParent,
/*  2031*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  2033*/      OPC_MoveParent,
/*  2034*/      OPC_MoveParent,
/*  2035*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2037*/      OPC_EmitMergeInputChains1_0,
/*  2038*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2041*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2051*/    /*Scope*/ 60, /*->2112*/
/*  2052*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2056*/      OPC_MoveChild0,
/*  2057*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2060*/      OPC_MoveChild0,
/*  2061*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  2064*/      OPC_RecordMemRef,
/*  2065*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  2066*/      OPC_CheckFoldableChainNode,
/*  2067*/      OPC_MoveChild1,
/*  2068*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2071*/      OPC_RecordChild0, // #1 = $addr
/*  2072*/      OPC_MoveChild1,
/*  2073*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2076*/      OPC_RecordChild0, // #2 = $off
/*  2077*/      OPC_MoveChild0,
/*  2078*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2081*/      OPC_MoveParent,
/*  2082*/      OPC_MoveParent,
/*  2083*/      OPC_CheckType, MVT::i32,
/*  2085*/      OPC_MoveParent,
/*  2086*/      OPC_MoveChild2,
/*  2087*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2090*/      OPC_RecordChild0, // #3 = $val
/*  2091*/      OPC_MoveParent,
/*  2092*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  2094*/      OPC_MoveParent,
/*  2095*/      OPC_MoveParent,
/*  2096*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2098*/      OPC_EmitMergeInputChains1_0,
/*  2099*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2102*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2112*/    /*Scope*/ 59, /*->2172*/
/*  2113*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2116*/      OPC_MoveChild0,
/*  2117*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2120*/      OPC_MoveChild0,
/*  2121*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  2124*/      OPC_RecordMemRef,
/*  2125*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  2126*/      OPC_CheckFoldableChainNode,
/*  2127*/      OPC_MoveChild1,
/*  2128*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2131*/      OPC_RecordChild0, // #1 = $addr
/*  2132*/      OPC_MoveChild1,
/*  2133*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2136*/      OPC_RecordChild0, // #2 = $off
/*  2137*/      OPC_MoveChild0,
/*  2138*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2141*/      OPC_MoveParent,
/*  2142*/      OPC_MoveParent,
/*  2143*/      OPC_CheckType, MVT::i32,
/*  2145*/      OPC_MoveParent,
/*  2146*/      OPC_MoveChild2,
/*  2147*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2150*/      OPC_RecordChild0, // #3 = $val
/*  2151*/      OPC_MoveParent,
/*  2152*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  2154*/      OPC_MoveParent,
/*  2155*/      OPC_MoveParent,
/*  2156*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2158*/      OPC_EmitMergeInputChains1_0,
/*  2159*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2172*/    /*Scope*/ 60, /*->2233*/
/*  2173*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2177*/      OPC_MoveChild0,
/*  2178*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2181*/      OPC_MoveChild0,
/*  2182*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  2185*/      OPC_RecordMemRef,
/*  2186*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  2187*/      OPC_CheckFoldableChainNode,
/*  2188*/      OPC_MoveChild1,
/*  2189*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2192*/      OPC_RecordChild0, // #1 = $addr
/*  2193*/      OPC_MoveChild1,
/*  2194*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2197*/      OPC_RecordChild0, // #2 = $off
/*  2198*/      OPC_MoveChild0,
/*  2199*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2202*/      OPC_MoveParent,
/*  2203*/      OPC_MoveParent,
/*  2204*/      OPC_CheckType, MVT::i32,
/*  2206*/      OPC_MoveParent,
/*  2207*/      OPC_MoveChild2,
/*  2208*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2211*/      OPC_RecordChild0, // #3 = $val
/*  2212*/      OPC_MoveParent,
/*  2213*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  2215*/      OPC_MoveParent,
/*  2216*/      OPC_MoveParent,
/*  2217*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2219*/      OPC_EmitMergeInputChains1_0,
/*  2220*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2223*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2233*/    /*Scope*/ 59, /*->2293*/
/*  2234*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2237*/      OPC_MoveChild0,
/*  2238*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2241*/      OPC_MoveChild0,
/*  2242*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  2245*/      OPC_RecordMemRef,
/*  2246*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  2247*/      OPC_CheckFoldableChainNode,
/*  2248*/      OPC_MoveChild1,
/*  2249*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2252*/      OPC_MoveChild0,
/*  2253*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2256*/      OPC_RecordChild0, // #1 = $off
/*  2257*/      OPC_MoveChild0,
/*  2258*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2261*/      OPC_MoveParent,
/*  2262*/      OPC_MoveParent,
/*  2263*/      OPC_RecordChild1, // #2 = $addr
/*  2264*/      OPC_CheckType, MVT::i32,
/*  2266*/      OPC_MoveParent,
/*  2267*/      OPC_MoveChild2,
/*  2268*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2271*/      OPC_RecordChild0, // #3 = $val
/*  2272*/      OPC_MoveParent,
/*  2273*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  2275*/      OPC_MoveParent,
/*  2276*/      OPC_MoveParent,
/*  2277*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2279*/      OPC_EmitMergeInputChains1_0,
/*  2280*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2283*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2293*/    /*Scope*/ 60, /*->2354*/
/*  2294*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2298*/      OPC_MoveChild0,
/*  2299*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2302*/      OPC_MoveChild0,
/*  2303*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  2306*/      OPC_RecordMemRef,
/*  2307*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  2308*/      OPC_CheckFoldableChainNode,
/*  2309*/      OPC_MoveChild1,
/*  2310*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2313*/      OPC_MoveChild0,
/*  2314*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2317*/      OPC_RecordChild0, // #1 = $off
/*  2318*/      OPC_MoveChild0,
/*  2319*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2322*/      OPC_MoveParent,
/*  2323*/      OPC_MoveParent,
/*  2324*/      OPC_RecordChild1, // #2 = $addr
/*  2325*/      OPC_CheckType, MVT::i32,
/*  2327*/      OPC_MoveParent,
/*  2328*/      OPC_MoveChild2,
/*  2329*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2332*/      OPC_RecordChild0, // #3 = $val
/*  2333*/      OPC_MoveParent,
/*  2334*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  2336*/      OPC_MoveParent,
/*  2337*/      OPC_MoveParent,
/*  2338*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2340*/      OPC_EmitMergeInputChains1_0,
/*  2341*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2344*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2354*/    /*Scope*/ 59, /*->2414*/
/*  2355*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2358*/      OPC_MoveChild0,
/*  2359*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2362*/      OPC_MoveChild0,
/*  2363*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  2366*/      OPC_RecordMemRef,
/*  2367*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  2368*/      OPC_CheckFoldableChainNode,
/*  2369*/      OPC_MoveChild1,
/*  2370*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2373*/      OPC_MoveChild0,
/*  2374*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2377*/      OPC_RecordChild0, // #1 = $off
/*  2378*/      OPC_MoveChild0,
/*  2379*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2382*/      OPC_MoveParent,
/*  2383*/      OPC_MoveParent,
/*  2384*/      OPC_RecordChild1, // #2 = $addr
/*  2385*/      OPC_CheckType, MVT::i32,
/*  2387*/      OPC_MoveParent,
/*  2388*/      OPC_MoveChild2,
/*  2389*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2392*/      OPC_RecordChild0, // #3 = $val
/*  2393*/      OPC_MoveParent,
/*  2394*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  2396*/      OPC_MoveParent,
/*  2397*/      OPC_MoveParent,
/*  2398*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2400*/      OPC_EmitMergeInputChains1_0,
/*  2401*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2404*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2414*/    /*Scope*/ 60, /*->2475*/
/*  2415*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2419*/      OPC_MoveChild0,
/*  2420*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2423*/      OPC_MoveChild0,
/*  2424*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  2427*/      OPC_RecordMemRef,
/*  2428*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  2429*/      OPC_CheckFoldableChainNode,
/*  2430*/      OPC_MoveChild1,
/*  2431*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2434*/      OPC_MoveChild0,
/*  2435*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2438*/      OPC_RecordChild0, // #1 = $off
/*  2439*/      OPC_MoveChild0,
/*  2440*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2443*/      OPC_MoveParent,
/*  2444*/      OPC_MoveParent,
/*  2445*/      OPC_RecordChild1, // #2 = $addr
/*  2446*/      OPC_CheckType, MVT::i32,
/*  2448*/      OPC_MoveParent,
/*  2449*/      OPC_MoveChild2,
/*  2450*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2453*/      OPC_RecordChild0, // #3 = $val
/*  2454*/      OPC_MoveParent,
/*  2455*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  2457*/      OPC_MoveParent,
/*  2458*/      OPC_MoveParent,
/*  2459*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2461*/      OPC_EmitMergeInputChains1_0,
/*  2462*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2465*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2475*/    /*Scope*/ 59, /*->2535*/
/*  2476*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2479*/      OPC_MoveChild0,
/*  2480*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2483*/      OPC_MoveChild0,
/*  2484*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  2487*/      OPC_RecordMemRef,
/*  2488*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  2489*/      OPC_CheckFoldableChainNode,
/*  2490*/      OPC_MoveChild1,
/*  2491*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2494*/      OPC_MoveChild0,
/*  2495*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2498*/      OPC_RecordChild0, // #1 = $off
/*  2499*/      OPC_MoveChild0,
/*  2500*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2503*/      OPC_MoveParent,
/*  2504*/      OPC_MoveParent,
/*  2505*/      OPC_RecordChild1, // #2 = $addr
/*  2506*/      OPC_CheckType, MVT::i32,
/*  2508*/      OPC_MoveParent,
/*  2509*/      OPC_MoveChild2,
/*  2510*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2513*/      OPC_RecordChild0, // #3 = $val
/*  2514*/      OPC_MoveParent,
/*  2515*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  2517*/      OPC_MoveParent,
/*  2518*/      OPC_MoveParent,
/*  2519*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2521*/      OPC_EmitMergeInputChains1_0,
/*  2522*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2525*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2535*/    /*Scope*/ 60, /*->2596*/
/*  2536*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2540*/      OPC_MoveChild0,
/*  2541*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2544*/      OPC_MoveChild0,
/*  2545*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  2548*/      OPC_RecordMemRef,
/*  2549*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  2550*/      OPC_CheckFoldableChainNode,
/*  2551*/      OPC_MoveChild1,
/*  2552*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2555*/      OPC_MoveChild0,
/*  2556*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2559*/      OPC_RecordChild0, // #1 = $off
/*  2560*/      OPC_MoveChild0,
/*  2561*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2564*/      OPC_MoveParent,
/*  2565*/      OPC_MoveParent,
/*  2566*/      OPC_RecordChild1, // #2 = $addr
/*  2567*/      OPC_CheckType, MVT::i32,
/*  2569*/      OPC_MoveParent,
/*  2570*/      OPC_MoveChild2,
/*  2571*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2574*/      OPC_RecordChild0, // #3 = $val
/*  2575*/      OPC_MoveParent,
/*  2576*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  2578*/      OPC_MoveParent,
/*  2579*/      OPC_MoveParent,
/*  2580*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2582*/      OPC_EmitMergeInputChains1_0,
/*  2583*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2586*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2596*/    /*Scope*/ 59, /*->2656*/
/*  2597*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2600*/      OPC_MoveChild0,
/*  2601*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2604*/      OPC_MoveChild0,
/*  2605*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  2608*/      OPC_RecordMemRef,
/*  2609*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  2610*/      OPC_CheckFoldableChainNode,
/*  2611*/      OPC_MoveChild1,
/*  2612*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2615*/      OPC_MoveChild0,
/*  2616*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2619*/      OPC_RecordChild0, // #1 = $off
/*  2620*/      OPC_MoveChild0,
/*  2621*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2624*/      OPC_MoveParent,
/*  2625*/      OPC_MoveParent,
/*  2626*/      OPC_RecordChild1, // #2 = $addr
/*  2627*/      OPC_CheckType, MVT::i32,
/*  2629*/      OPC_MoveParent,
/*  2630*/      OPC_MoveChild2,
/*  2631*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2634*/      OPC_RecordChild0, // #3 = $val
/*  2635*/      OPC_MoveParent,
/*  2636*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  2638*/      OPC_MoveParent,
/*  2639*/      OPC_MoveParent,
/*  2640*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2642*/      OPC_EmitMergeInputChains1_0,
/*  2643*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2646*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2656*/    /*Scope*/ 60, /*->2717*/
/*  2657*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2661*/      OPC_MoveChild0,
/*  2662*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2665*/      OPC_MoveChild0,
/*  2666*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  2669*/      OPC_RecordMemRef,
/*  2670*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  2671*/      OPC_CheckFoldableChainNode,
/*  2672*/      OPC_MoveChild1,
/*  2673*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2676*/      OPC_MoveChild0,
/*  2677*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2680*/      OPC_RecordChild0, // #1 = $off
/*  2681*/      OPC_MoveChild0,
/*  2682*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2685*/      OPC_MoveParent,
/*  2686*/      OPC_MoveParent,
/*  2687*/      OPC_RecordChild1, // #2 = $addr
/*  2688*/      OPC_CheckType, MVT::i32,
/*  2690*/      OPC_MoveParent,
/*  2691*/      OPC_MoveChild2,
/*  2692*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2695*/      OPC_RecordChild0, // #3 = $val
/*  2696*/      OPC_MoveParent,
/*  2697*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  2699*/      OPC_MoveParent,
/*  2700*/      OPC_MoveParent,
/*  2701*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2703*/      OPC_EmitMergeInputChains1_0,
/*  2704*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2707*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2717*/    /*Scope*/ 59, /*->2777*/
/*  2718*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2721*/      OPC_MoveChild0,
/*  2722*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2725*/      OPC_MoveChild0,
/*  2726*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  2729*/      OPC_RecordMemRef,
/*  2730*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  2731*/      OPC_CheckFoldableChainNode,
/*  2732*/      OPC_MoveChild1,
/*  2733*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2736*/      OPC_MoveChild0,
/*  2737*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2740*/      OPC_RecordChild0, // #1 = $off
/*  2741*/      OPC_MoveChild0,
/*  2742*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2745*/      OPC_MoveParent,
/*  2746*/      OPC_MoveParent,
/*  2747*/      OPC_RecordChild1, // #2 = $addr
/*  2748*/      OPC_CheckType, MVT::i32,
/*  2750*/      OPC_MoveParent,
/*  2751*/      OPC_MoveChild2,
/*  2752*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2755*/      OPC_RecordChild0, // #3 = $val
/*  2756*/      OPC_MoveParent,
/*  2757*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  2759*/      OPC_MoveParent,
/*  2760*/      OPC_MoveParent,
/*  2761*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2763*/      OPC_EmitMergeInputChains1_0,
/*  2764*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2767*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2777*/    /*Scope*/ 60, /*->2838*/
/*  2778*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2782*/      OPC_MoveChild0,
/*  2783*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2786*/      OPC_MoveChild0,
/*  2787*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  2790*/      OPC_RecordMemRef,
/*  2791*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  2792*/      OPC_CheckFoldableChainNode,
/*  2793*/      OPC_MoveChild1,
/*  2794*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2797*/      OPC_MoveChild0,
/*  2798*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2801*/      OPC_RecordChild0, // #1 = $off
/*  2802*/      OPC_MoveChild0,
/*  2803*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2806*/      OPC_MoveParent,
/*  2807*/      OPC_MoveParent,
/*  2808*/      OPC_RecordChild1, // #2 = $addr
/*  2809*/      OPC_CheckType, MVT::i32,
/*  2811*/      OPC_MoveParent,
/*  2812*/      OPC_MoveChild2,
/*  2813*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2816*/      OPC_RecordChild0, // #3 = $val
/*  2817*/      OPC_MoveParent,
/*  2818*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  2820*/      OPC_MoveParent,
/*  2821*/      OPC_MoveParent,
/*  2822*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2824*/      OPC_EmitMergeInputChains1_0,
/*  2825*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2828*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2838*/    /*Scope*/ 59, /*->2898*/
/*  2839*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2842*/      OPC_MoveChild0,
/*  2843*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2846*/      OPC_MoveChild0,
/*  2847*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  2850*/      OPC_RecordMemRef,
/*  2851*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  2852*/      OPC_CheckFoldableChainNode,
/*  2853*/      OPC_MoveChild1,
/*  2854*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2857*/      OPC_MoveChild0,
/*  2858*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2861*/      OPC_RecordChild0, // #1 = $off
/*  2862*/      OPC_MoveChild0,
/*  2863*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2866*/      OPC_MoveParent,
/*  2867*/      OPC_MoveParent,
/*  2868*/      OPC_RecordChild1, // #2 = $addr
/*  2869*/      OPC_CheckType, MVT::i32,
/*  2871*/      OPC_MoveParent,
/*  2872*/      OPC_MoveChild2,
/*  2873*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2876*/      OPC_RecordChild0, // #3 = $val
/*  2877*/      OPC_MoveParent,
/*  2878*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  2880*/      OPC_MoveParent,
/*  2881*/      OPC_MoveParent,
/*  2882*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2884*/      OPC_EmitMergeInputChains1_0,
/*  2885*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2888*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2898*/    /*Scope*/ 60, /*->2959*/
/*  2899*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  2903*/      OPC_MoveChild0,
/*  2904*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2907*/      OPC_MoveChild0,
/*  2908*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  2911*/      OPC_RecordMemRef,
/*  2912*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  2913*/      OPC_CheckFoldableChainNode,
/*  2914*/      OPC_MoveChild1,
/*  2915*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2918*/      OPC_MoveChild0,
/*  2919*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2922*/      OPC_RecordChild0, // #1 = $off
/*  2923*/      OPC_MoveChild0,
/*  2924*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  2927*/      OPC_MoveParent,
/*  2928*/      OPC_MoveParent,
/*  2929*/      OPC_RecordChild1, // #2 = $addr
/*  2930*/      OPC_CheckType, MVT::i32,
/*  2932*/      OPC_MoveParent,
/*  2933*/      OPC_MoveChild2,
/*  2934*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2937*/      OPC_RecordChild0, // #3 = $val
/*  2938*/      OPC_MoveParent,
/*  2939*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  2941*/      OPC_MoveParent,
/*  2942*/      OPC_MoveParent,
/*  2943*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  2945*/      OPC_EmitMergeInputChains1_0,
/*  2946*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 27
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2959*/    /*Scope*/ 54, /*->3014*/
/*  2960*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  2963*/      OPC_MoveChild0,
/*  2964*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  2967*/      OPC_MoveChild0,
/*  2968*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  2971*/      OPC_RecordMemRef,
/*  2972*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  2973*/      OPC_CheckFoldableChainNode,
/*  2974*/      OPC_MoveChild1,
/*  2975*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  2978*/      OPC_RecordChild0, // #1 = $addr
/*  2979*/      OPC_MoveChild1,
/*  2980*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2983*/      OPC_RecordChild0, // #2 = $off
/*  2984*/      OPC_MoveChild0,
/*  2985*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  2988*/      OPC_MoveParent,
/*  2989*/      OPC_MoveParent,
/*  2990*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  2992*/      OPC_CheckType, MVT::i32,
/*  2994*/      OPC_MoveParent,
/*  2995*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  2997*/      OPC_MoveParent,
/*  2998*/      OPC_MoveParent,
/*  2999*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3001*/      OPC_EmitMergeInputChains1_0,
/*  3002*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3005*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  3014*/    /*Scope*/ 55, /*->3070*/
/*  3015*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3019*/      OPC_MoveChild0,
/*  3020*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3023*/      OPC_MoveChild0,
/*  3024*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  3027*/      OPC_RecordMemRef,
/*  3028*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  3029*/      OPC_CheckFoldableChainNode,
/*  3030*/      OPC_MoveChild1,
/*  3031*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3034*/      OPC_RecordChild0, // #1 = $addr
/*  3035*/      OPC_MoveChild1,
/*  3036*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3039*/      OPC_RecordChild0, // #2 = $off
/*  3040*/      OPC_MoveChild0,
/*  3041*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3044*/      OPC_MoveParent,
/*  3045*/      OPC_MoveParent,
/*  3046*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  3048*/      OPC_CheckType, MVT::i32,
/*  3050*/      OPC_MoveParent,
/*  3051*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  3053*/      OPC_MoveParent,
/*  3054*/      OPC_MoveParent,
/*  3055*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3057*/      OPC_EmitMergeInputChains1_0,
/*  3058*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3061*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  3070*/    /*Scope*/ 58, /*->3129*/
/*  3071*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3074*/      OPC_MoveChild0,
/*  3075*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3078*/      OPC_MoveChild0,
/*  3079*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  3082*/      OPC_RecordMemRef,
/*  3083*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  3084*/      OPC_CheckFoldableChainNode,
/*  3085*/      OPC_MoveChild1,
/*  3086*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3089*/      OPC_RecordChild0, // #1 = $addr
/*  3090*/      OPC_RecordChild1, // #2 = $off
/*  3091*/      OPC_MoveChild1,
/*  3092*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3095*/      OPC_MoveParent,
/*  3096*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3098*/      OPC_CheckType, MVT::i32,
/*  3100*/      OPC_MoveParent,
/*  3101*/      OPC_MoveChild2,
/*  3102*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3105*/      OPC_RecordChild0, // #3 = $val
/*  3106*/      OPC_MoveParent,
/*  3107*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  3109*/      OPC_MoveParent,
/*  3110*/      OPC_MoveParent,
/*  3111*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3113*/      OPC_EmitMergeInputChains1_0,
/*  3114*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3117*/      OPC_EmitConvertToTarget, 2,
/*  3119*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3129*/    /*Scope*/ 59, /*->3189*/
/*  3130*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3134*/      OPC_MoveChild0,
/*  3135*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3138*/      OPC_MoveChild0,
/*  3139*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  3142*/      OPC_RecordMemRef,
/*  3143*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  3144*/      OPC_CheckFoldableChainNode,
/*  3145*/      OPC_MoveChild1,
/*  3146*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3149*/      OPC_RecordChild0, // #1 = $addr
/*  3150*/      OPC_RecordChild1, // #2 = $off
/*  3151*/      OPC_MoveChild1,
/*  3152*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3155*/      OPC_MoveParent,
/*  3156*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3158*/      OPC_CheckType, MVT::i32,
/*  3160*/      OPC_MoveParent,
/*  3161*/      OPC_MoveChild2,
/*  3162*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3165*/      OPC_RecordChild0, // #3 = $val
/*  3166*/      OPC_MoveParent,
/*  3167*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  3169*/      OPC_MoveParent,
/*  3170*/      OPC_MoveParent,
/*  3171*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3173*/      OPC_EmitMergeInputChains1_0,
/*  3174*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3177*/      OPC_EmitConvertToTarget, 2,
/*  3179*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3189*/    /*Scope*/ 58, /*->3248*/
/*  3190*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3193*/      OPC_MoveChild0,
/*  3194*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3197*/      OPC_MoveChild0,
/*  3198*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  3201*/      OPC_RecordMemRef,
/*  3202*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  3203*/      OPC_CheckFoldableChainNode,
/*  3204*/      OPC_MoveChild1,
/*  3205*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3208*/      OPC_RecordChild0, // #1 = $addr
/*  3209*/      OPC_RecordChild1, // #2 = $off
/*  3210*/      OPC_MoveChild1,
/*  3211*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3214*/      OPC_MoveParent,
/*  3215*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3217*/      OPC_CheckType, MVT::i32,
/*  3219*/      OPC_MoveParent,
/*  3220*/      OPC_MoveChild2,
/*  3221*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3224*/      OPC_RecordChild0, // #3 = $val
/*  3225*/      OPC_MoveParent,
/*  3226*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  3228*/      OPC_MoveParent,
/*  3229*/      OPC_MoveParent,
/*  3230*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3232*/      OPC_EmitMergeInputChains1_0,
/*  3233*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3236*/      OPC_EmitConvertToTarget, 2,
/*  3238*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3248*/    /*Scope*/ 59, /*->3308*/
/*  3249*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3253*/      OPC_MoveChild0,
/*  3254*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3257*/      OPC_MoveChild0,
/*  3258*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  3261*/      OPC_RecordMemRef,
/*  3262*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  3263*/      OPC_CheckFoldableChainNode,
/*  3264*/      OPC_MoveChild1,
/*  3265*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3268*/      OPC_RecordChild0, // #1 = $addr
/*  3269*/      OPC_RecordChild1, // #2 = $off
/*  3270*/      OPC_MoveChild1,
/*  3271*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3274*/      OPC_MoveParent,
/*  3275*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3277*/      OPC_CheckType, MVT::i32,
/*  3279*/      OPC_MoveParent,
/*  3280*/      OPC_MoveChild2,
/*  3281*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3284*/      OPC_RecordChild0, // #3 = $val
/*  3285*/      OPC_MoveParent,
/*  3286*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  3288*/      OPC_MoveParent,
/*  3289*/      OPC_MoveParent,
/*  3290*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3292*/      OPC_EmitMergeInputChains1_0,
/*  3293*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3296*/      OPC_EmitConvertToTarget, 2,
/*  3298*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3308*/    /*Scope*/ 58, /*->3367*/
/*  3309*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3312*/      OPC_MoveChild0,
/*  3313*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3316*/      OPC_MoveChild0,
/*  3317*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  3320*/      OPC_RecordMemRef,
/*  3321*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  3322*/      OPC_CheckFoldableChainNode,
/*  3323*/      OPC_MoveChild1,
/*  3324*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3327*/      OPC_RecordChild0, // #1 = $addr
/*  3328*/      OPC_RecordChild1, // #2 = $off
/*  3329*/      OPC_MoveChild1,
/*  3330*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3333*/      OPC_MoveParent,
/*  3334*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3336*/      OPC_CheckType, MVT::i32,
/*  3338*/      OPC_MoveParent,
/*  3339*/      OPC_MoveChild2,
/*  3340*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3343*/      OPC_RecordChild0, // #3 = $val
/*  3344*/      OPC_MoveParent,
/*  3345*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  3347*/      OPC_MoveParent,
/*  3348*/      OPC_MoveParent,
/*  3349*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3351*/      OPC_EmitMergeInputChains1_0,
/*  3352*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3355*/      OPC_EmitConvertToTarget, 2,
/*  3357*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3367*/    /*Scope*/ 59, /*->3427*/
/*  3368*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3372*/      OPC_MoveChild0,
/*  3373*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3376*/      OPC_MoveChild0,
/*  3377*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  3380*/      OPC_RecordMemRef,
/*  3381*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  3382*/      OPC_CheckFoldableChainNode,
/*  3383*/      OPC_MoveChild1,
/*  3384*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3387*/      OPC_RecordChild0, // #1 = $addr
/*  3388*/      OPC_RecordChild1, // #2 = $off
/*  3389*/      OPC_MoveChild1,
/*  3390*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3393*/      OPC_MoveParent,
/*  3394*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3396*/      OPC_CheckType, MVT::i32,
/*  3398*/      OPC_MoveParent,
/*  3399*/      OPC_MoveChild2,
/*  3400*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3403*/      OPC_RecordChild0, // #3 = $val
/*  3404*/      OPC_MoveParent,
/*  3405*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  3407*/      OPC_MoveParent,
/*  3408*/      OPC_MoveParent,
/*  3409*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3411*/      OPC_EmitMergeInputChains1_0,
/*  3412*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3415*/      OPC_EmitConvertToTarget, 2,
/*  3417*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3427*/    /*Scope*/ 58, /*->3486*/
/*  3428*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3431*/      OPC_MoveChild0,
/*  3432*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3435*/      OPC_MoveChild0,
/*  3436*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  3439*/      OPC_RecordMemRef,
/*  3440*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  3441*/      OPC_CheckFoldableChainNode,
/*  3442*/      OPC_MoveChild1,
/*  3443*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3446*/      OPC_RecordChild0, // #1 = $addr
/*  3447*/      OPC_RecordChild1, // #2 = $off
/*  3448*/      OPC_MoveChild1,
/*  3449*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3452*/      OPC_MoveParent,
/*  3453*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3455*/      OPC_CheckType, MVT::i32,
/*  3457*/      OPC_MoveParent,
/*  3458*/      OPC_MoveChild2,
/*  3459*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3462*/      OPC_RecordChild0, // #3 = $val
/*  3463*/      OPC_MoveParent,
/*  3464*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  3466*/      OPC_MoveParent,
/*  3467*/      OPC_MoveParent,
/*  3468*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3470*/      OPC_EmitMergeInputChains1_0,
/*  3471*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3474*/      OPC_EmitConvertToTarget, 2,
/*  3476*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3486*/    /*Scope*/ 59, /*->3546*/
/*  3487*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3491*/      OPC_MoveChild0,
/*  3492*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3495*/      OPC_MoveChild0,
/*  3496*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  3499*/      OPC_RecordMemRef,
/*  3500*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  3501*/      OPC_CheckFoldableChainNode,
/*  3502*/      OPC_MoveChild1,
/*  3503*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3506*/      OPC_RecordChild0, // #1 = $addr
/*  3507*/      OPC_RecordChild1, // #2 = $off
/*  3508*/      OPC_MoveChild1,
/*  3509*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3512*/      OPC_MoveParent,
/*  3513*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3515*/      OPC_CheckType, MVT::i32,
/*  3517*/      OPC_MoveParent,
/*  3518*/      OPC_MoveChild2,
/*  3519*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3522*/      OPC_RecordChild0, // #3 = $val
/*  3523*/      OPC_MoveParent,
/*  3524*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  3526*/      OPC_MoveParent,
/*  3527*/      OPC_MoveParent,
/*  3528*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3530*/      OPC_EmitMergeInputChains1_0,
/*  3531*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3534*/      OPC_EmitConvertToTarget, 2,
/*  3536*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3546*/    /*Scope*/ 58, /*->3605*/
/*  3547*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3550*/      OPC_MoveChild0,
/*  3551*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3554*/      OPC_MoveChild0,
/*  3555*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  3558*/      OPC_RecordMemRef,
/*  3559*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  3560*/      OPC_CheckFoldableChainNode,
/*  3561*/      OPC_MoveChild1,
/*  3562*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3565*/      OPC_RecordChild0, // #1 = $addr
/*  3566*/      OPC_RecordChild1, // #2 = $off
/*  3567*/      OPC_MoveChild1,
/*  3568*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3571*/      OPC_MoveParent,
/*  3572*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3574*/      OPC_CheckType, MVT::i32,
/*  3576*/      OPC_MoveParent,
/*  3577*/      OPC_MoveChild2,
/*  3578*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3581*/      OPC_RecordChild0, // #3 = $val
/*  3582*/      OPC_MoveParent,
/*  3583*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3585*/      OPC_MoveParent,
/*  3586*/      OPC_MoveParent,
/*  3587*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3589*/      OPC_EmitMergeInputChains1_0,
/*  3590*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3593*/      OPC_EmitConvertToTarget, 2,
/*  3595*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3605*/    /*Scope*/ 59, /*->3665*/
/*  3606*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3610*/      OPC_MoveChild0,
/*  3611*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3614*/      OPC_MoveChild0,
/*  3615*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  3618*/      OPC_RecordMemRef,
/*  3619*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  3620*/      OPC_CheckFoldableChainNode,
/*  3621*/      OPC_MoveChild1,
/*  3622*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3625*/      OPC_RecordChild0, // #1 = $addr
/*  3626*/      OPC_RecordChild1, // #2 = $off
/*  3627*/      OPC_MoveChild1,
/*  3628*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3631*/      OPC_MoveParent,
/*  3632*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3634*/      OPC_CheckType, MVT::i32,
/*  3636*/      OPC_MoveParent,
/*  3637*/      OPC_MoveChild2,
/*  3638*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3641*/      OPC_RecordChild0, // #3 = $val
/*  3642*/      OPC_MoveParent,
/*  3643*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3645*/      OPC_MoveParent,
/*  3646*/      OPC_MoveParent,
/*  3647*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3649*/      OPC_EmitMergeInputChains1_0,
/*  3650*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3653*/      OPC_EmitConvertToTarget, 2,
/*  3655*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3665*/    /*Scope*/ 58, /*->3724*/
/*  3666*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3669*/      OPC_MoveChild0,
/*  3670*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3673*/      OPC_MoveChild0,
/*  3674*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  3677*/      OPC_RecordMemRef,
/*  3678*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  3679*/      OPC_CheckFoldableChainNode,
/*  3680*/      OPC_MoveChild1,
/*  3681*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3684*/      OPC_RecordChild0, // #1 = $addr
/*  3685*/      OPC_RecordChild1, // #2 = $off
/*  3686*/      OPC_MoveChild1,
/*  3687*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3690*/      OPC_MoveParent,
/*  3691*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3693*/      OPC_CheckType, MVT::i32,
/*  3695*/      OPC_MoveParent,
/*  3696*/      OPC_MoveChild2,
/*  3697*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3700*/      OPC_RecordChild0, // #3 = $val
/*  3701*/      OPC_MoveParent,
/*  3702*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  3704*/      OPC_MoveParent,
/*  3705*/      OPC_MoveParent,
/*  3706*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3708*/      OPC_EmitMergeInputChains1_0,
/*  3709*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3712*/      OPC_EmitConvertToTarget, 2,
/*  3714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3724*/    /*Scope*/ 59, /*->3784*/
/*  3725*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3729*/      OPC_MoveChild0,
/*  3730*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3733*/      OPC_MoveChild0,
/*  3734*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  3737*/      OPC_RecordMemRef,
/*  3738*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  3739*/      OPC_CheckFoldableChainNode,
/*  3740*/      OPC_MoveChild1,
/*  3741*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3744*/      OPC_RecordChild0, // #1 = $addr
/*  3745*/      OPC_RecordChild1, // #2 = $off
/*  3746*/      OPC_MoveChild1,
/*  3747*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3750*/      OPC_MoveParent,
/*  3751*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3753*/      OPC_CheckType, MVT::i32,
/*  3755*/      OPC_MoveParent,
/*  3756*/      OPC_MoveChild2,
/*  3757*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3760*/      OPC_RecordChild0, // #3 = $val
/*  3761*/      OPC_MoveParent,
/*  3762*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  3764*/      OPC_MoveParent,
/*  3765*/      OPC_MoveParent,
/*  3766*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3768*/      OPC_EmitMergeInputChains1_0,
/*  3769*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3772*/      OPC_EmitConvertToTarget, 2,
/*  3774*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3784*/    /*Scope*/ 58, /*->3843*/
/*  3785*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3788*/      OPC_MoveChild0,
/*  3789*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3792*/      OPC_MoveChild0,
/*  3793*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  3796*/      OPC_RecordMemRef,
/*  3797*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  3798*/      OPC_CheckFoldableChainNode,
/*  3799*/      OPC_MoveChild1,
/*  3800*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3803*/      OPC_RecordChild0, // #1 = $addr
/*  3804*/      OPC_RecordChild1, // #2 = $off
/*  3805*/      OPC_MoveChild1,
/*  3806*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3809*/      OPC_MoveParent,
/*  3810*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3812*/      OPC_CheckType, MVT::i32,
/*  3814*/      OPC_MoveParent,
/*  3815*/      OPC_MoveChild2,
/*  3816*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3819*/      OPC_RecordChild0, // #3 = $val
/*  3820*/      OPC_MoveParent,
/*  3821*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  3823*/      OPC_MoveParent,
/*  3824*/      OPC_MoveParent,
/*  3825*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3827*/      OPC_EmitMergeInputChains1_0,
/*  3828*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3831*/      OPC_EmitConvertToTarget, 2,
/*  3833*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3843*/    /*Scope*/ 59, /*->3903*/
/*  3844*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3848*/      OPC_MoveChild0,
/*  3849*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3852*/      OPC_MoveChild0,
/*  3853*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  3856*/      OPC_RecordMemRef,
/*  3857*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  3858*/      OPC_CheckFoldableChainNode,
/*  3859*/      OPC_MoveChild1,
/*  3860*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  3863*/      OPC_RecordChild0, // #1 = $addr
/*  3864*/      OPC_RecordChild1, // #2 = $off
/*  3865*/      OPC_MoveChild1,
/*  3866*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3869*/      OPC_MoveParent,
/*  3870*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  3872*/      OPC_CheckType, MVT::i32,
/*  3874*/      OPC_MoveParent,
/*  3875*/      OPC_MoveChild2,
/*  3876*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3879*/      OPC_RecordChild0, // #3 = $val
/*  3880*/      OPC_MoveParent,
/*  3881*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  3883*/      OPC_MoveParent,
/*  3884*/      OPC_MoveParent,
/*  3885*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3887*/      OPC_EmitMergeInputChains1_0,
/*  3888*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3891*/      OPC_EmitConvertToTarget, 2,
/*  3893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3903*/    /*Scope*/ 58, /*->3962*/
/*  3904*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  3907*/      OPC_MoveChild0,
/*  3908*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3911*/      OPC_MoveChild0,
/*  3912*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  3915*/      OPC_RecordMemRef,
/*  3916*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  3917*/      OPC_CheckFoldableChainNode,
/*  3918*/      OPC_MoveChild1,
/*  3919*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3922*/      OPC_RecordChild0, // #1 = $addr
/*  3923*/      OPC_RecordChild1, // #2 = $off
/*  3924*/      OPC_MoveChild1,
/*  3925*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3928*/      OPC_MoveParent,
/*  3929*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3931*/      OPC_CheckType, MVT::i32,
/*  3933*/      OPC_MoveParent,
/*  3934*/      OPC_MoveChild2,
/*  3935*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3938*/      OPC_RecordChild0, // #3 = $val
/*  3939*/      OPC_MoveParent,
/*  3940*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  3942*/      OPC_MoveParent,
/*  3943*/      OPC_MoveParent,
/*  3944*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  3946*/      OPC_EmitMergeInputChains1_0,
/*  3947*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3950*/      OPC_EmitConvertToTarget, 2,
/*  3952*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3962*/    /*Scope*/ 59, /*->4022*/
/*  3963*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  3967*/      OPC_MoveChild0,
/*  3968*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  3971*/      OPC_MoveChild0,
/*  3972*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  3975*/      OPC_RecordMemRef,
/*  3976*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  3977*/      OPC_CheckFoldableChainNode,
/*  3978*/      OPC_MoveChild1,
/*  3979*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  3982*/      OPC_RecordChild0, // #1 = $addr
/*  3983*/      OPC_RecordChild1, // #2 = $off
/*  3984*/      OPC_MoveChild1,
/*  3985*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3988*/      OPC_MoveParent,
/*  3989*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  3991*/      OPC_CheckType, MVT::i32,
/*  3993*/      OPC_MoveParent,
/*  3994*/      OPC_MoveChild2,
/*  3995*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3998*/      OPC_RecordChild0, // #3 = $val
/*  3999*/      OPC_MoveParent,
/*  4000*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  4002*/      OPC_MoveParent,
/*  4003*/      OPC_MoveParent,
/*  4004*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4006*/      OPC_EmitMergeInputChains1_0,
/*  4007*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4010*/      OPC_EmitConvertToTarget, 2,
/*  4012*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4022*/    /*Scope*/ 58, /*->4081*/
/*  4023*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4026*/      OPC_MoveChild0,
/*  4027*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4030*/      OPC_MoveChild0,
/*  4031*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  4034*/      OPC_RecordMemRef,
/*  4035*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  4036*/      OPC_CheckFoldableChainNode,
/*  4037*/      OPC_MoveChild1,
/*  4038*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4041*/      OPC_RecordChild0, // #1 = $addr
/*  4042*/      OPC_RecordChild1, // #2 = $off
/*  4043*/      OPC_MoveChild1,
/*  4044*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4047*/      OPC_MoveParent,
/*  4048*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  4050*/      OPC_CheckType, MVT::i32,
/*  4052*/      OPC_MoveParent,
/*  4053*/      OPC_MoveChild2,
/*  4054*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4057*/      OPC_RecordChild0, // #3 = $val
/*  4058*/      OPC_MoveParent,
/*  4059*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  4061*/      OPC_MoveParent,
/*  4062*/      OPC_MoveParent,
/*  4063*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4065*/      OPC_EmitMergeInputChains1_0,
/*  4066*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4069*/      OPC_EmitConvertToTarget, 2,
/*  4071*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4081*/    /*Scope*/ 59, /*->4141*/
/*  4082*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4086*/      OPC_MoveChild0,
/*  4087*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4090*/      OPC_MoveChild0,
/*  4091*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  4094*/      OPC_RecordMemRef,
/*  4095*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  4096*/      OPC_CheckFoldableChainNode,
/*  4097*/      OPC_MoveChild1,
/*  4098*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4101*/      OPC_RecordChild0, // #1 = $addr
/*  4102*/      OPC_RecordChild1, // #2 = $off
/*  4103*/      OPC_MoveChild1,
/*  4104*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4107*/      OPC_MoveParent,
/*  4108*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  4110*/      OPC_CheckType, MVT::i32,
/*  4112*/      OPC_MoveParent,
/*  4113*/      OPC_MoveChild2,
/*  4114*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4117*/      OPC_RecordChild0, // #3 = $val
/*  4118*/      OPC_MoveParent,
/*  4119*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  4121*/      OPC_MoveParent,
/*  4122*/      OPC_MoveParent,
/*  4123*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4125*/      OPC_EmitMergeInputChains1_0,
/*  4126*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4129*/      OPC_EmitConvertToTarget, 2,
/*  4131*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4141*/    /*Scope*/ 58, /*->4200*/
/*  4142*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4145*/      OPC_MoveChild0,
/*  4146*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4149*/      OPC_MoveChild0,
/*  4150*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  4153*/      OPC_RecordMemRef,
/*  4154*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  4155*/      OPC_CheckFoldableChainNode,
/*  4156*/      OPC_MoveChild1,
/*  4157*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  4160*/      OPC_RecordChild0, // #1 = $addr
/*  4161*/      OPC_RecordChild1, // #2 = $off
/*  4162*/      OPC_MoveChild1,
/*  4163*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4166*/      OPC_MoveParent,
/*  4167*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  4169*/      OPC_CheckType, MVT::i32,
/*  4171*/      OPC_MoveParent,
/*  4172*/      OPC_MoveChild2,
/*  4173*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4176*/      OPC_RecordChild0, // #3 = $val
/*  4177*/      OPC_MoveParent,
/*  4178*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  4180*/      OPC_MoveParent,
/*  4181*/      OPC_MoveParent,
/*  4182*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4184*/      OPC_EmitMergeInputChains1_0,
/*  4185*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4188*/      OPC_EmitConvertToTarget, 2,
/*  4190*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4200*/    /*Scope*/ 59, /*->4260*/
/*  4201*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4205*/      OPC_MoveChild0,
/*  4206*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4209*/      OPC_MoveChild0,
/*  4210*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  4213*/      OPC_RecordMemRef,
/*  4214*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  4215*/      OPC_CheckFoldableChainNode,
/*  4216*/      OPC_MoveChild1,
/*  4217*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  4220*/      OPC_RecordChild0, // #1 = $addr
/*  4221*/      OPC_RecordChild1, // #2 = $off
/*  4222*/      OPC_MoveChild1,
/*  4223*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4226*/      OPC_MoveParent,
/*  4227*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  4229*/      OPC_CheckType, MVT::i32,
/*  4231*/      OPC_MoveParent,
/*  4232*/      OPC_MoveChild2,
/*  4233*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4236*/      OPC_RecordChild0, // #3 = $val
/*  4237*/      OPC_MoveParent,
/*  4238*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  4240*/      OPC_MoveParent,
/*  4241*/      OPC_MoveParent,
/*  4242*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4244*/      OPC_EmitMergeInputChains1_0,
/*  4245*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4248*/      OPC_EmitConvertToTarget, 2,
/*  4250*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4260*/    /*Scope*/ 58, /*->4319*/
/*  4261*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4264*/      OPC_MoveChild0,
/*  4265*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4268*/      OPC_MoveChild0,
/*  4269*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  4272*/      OPC_RecordMemRef,
/*  4273*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  4274*/      OPC_CheckFoldableChainNode,
/*  4275*/      OPC_MoveChild1,
/*  4276*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4279*/      OPC_RecordChild0, // #1 = $addr
/*  4280*/      OPC_RecordChild1, // #2 = $off
/*  4281*/      OPC_MoveChild1,
/*  4282*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4285*/      OPC_MoveParent,
/*  4286*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  4288*/      OPC_CheckType, MVT::i32,
/*  4290*/      OPC_MoveParent,
/*  4291*/      OPC_MoveChild2,
/*  4292*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4295*/      OPC_RecordChild0, // #3 = $val
/*  4296*/      OPC_MoveParent,
/*  4297*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  4299*/      OPC_MoveParent,
/*  4300*/      OPC_MoveParent,
/*  4301*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4303*/      OPC_EmitMergeInputChains1_0,
/*  4304*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4307*/      OPC_EmitConvertToTarget, 2,
/*  4309*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4319*/    /*Scope*/ 59, /*->4379*/
/*  4320*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4324*/      OPC_MoveChild0,
/*  4325*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4328*/      OPC_MoveChild0,
/*  4329*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  4332*/      OPC_RecordMemRef,
/*  4333*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  4334*/      OPC_CheckFoldableChainNode,
/*  4335*/      OPC_MoveChild1,
/*  4336*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4339*/      OPC_RecordChild0, // #1 = $addr
/*  4340*/      OPC_RecordChild1, // #2 = $off
/*  4341*/      OPC_MoveChild1,
/*  4342*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4345*/      OPC_MoveParent,
/*  4346*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  4348*/      OPC_CheckType, MVT::i32,
/*  4350*/      OPC_MoveParent,
/*  4351*/      OPC_MoveChild2,
/*  4352*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4355*/      OPC_RecordChild0, // #3 = $val
/*  4356*/      OPC_MoveParent,
/*  4357*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  4359*/      OPC_MoveParent,
/*  4360*/      OPC_MoveParent,
/*  4361*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4363*/      OPC_EmitMergeInputChains1_0,
/*  4364*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4367*/      OPC_EmitConvertToTarget, 2,
/*  4369*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4379*/    /*Scope*/ 58, /*->4438*/
/*  4380*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4383*/      OPC_MoveChild0,
/*  4384*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4387*/      OPC_MoveChild0,
/*  4388*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  4391*/      OPC_RecordMemRef,
/*  4392*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  4393*/      OPC_CheckFoldableChainNode,
/*  4394*/      OPC_MoveChild1,
/*  4395*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  4398*/      OPC_RecordChild0, // #1 = $addr
/*  4399*/      OPC_RecordChild1, // #2 = $off
/*  4400*/      OPC_MoveChild1,
/*  4401*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4404*/      OPC_MoveParent,
/*  4405*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  4407*/      OPC_CheckType, MVT::i32,
/*  4409*/      OPC_MoveParent,
/*  4410*/      OPC_MoveChild2,
/*  4411*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4414*/      OPC_RecordChild0, // #3 = $val
/*  4415*/      OPC_MoveParent,
/*  4416*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  4418*/      OPC_MoveParent,
/*  4419*/      OPC_MoveParent,
/*  4420*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4422*/      OPC_EmitMergeInputChains1_0,
/*  4423*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4426*/      OPC_EmitConvertToTarget, 2,
/*  4428*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4438*/    /*Scope*/ 59, /*->4498*/
/*  4439*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4443*/      OPC_MoveChild0,
/*  4444*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4447*/      OPC_MoveChild0,
/*  4448*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  4451*/      OPC_RecordMemRef,
/*  4452*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  4453*/      OPC_CheckFoldableChainNode,
/*  4454*/      OPC_MoveChild1,
/*  4455*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  4458*/      OPC_RecordChild0, // #1 = $addr
/*  4459*/      OPC_RecordChild1, // #2 = $off
/*  4460*/      OPC_MoveChild1,
/*  4461*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4464*/      OPC_MoveParent,
/*  4465*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  4467*/      OPC_CheckType, MVT::i32,
/*  4469*/      OPC_MoveParent,
/*  4470*/      OPC_MoveChild2,
/*  4471*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4474*/      OPC_RecordChild0, // #3 = $val
/*  4475*/      OPC_MoveParent,
/*  4476*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  4478*/      OPC_MoveParent,
/*  4479*/      OPC_MoveParent,
/*  4480*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4482*/      OPC_EmitMergeInputChains1_0,
/*  4483*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4486*/      OPC_EmitConvertToTarget, 2,
/*  4488*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  4498*/    /*Scope*/ 54, /*->4553*/
/*  4499*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4502*/      OPC_MoveChild0,
/*  4503*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4506*/      OPC_MoveChild0,
/*  4507*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  4510*/      OPC_RecordMemRef,
/*  4511*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  4512*/      OPC_CheckFoldableChainNode,
/*  4513*/      OPC_MoveChild1,
/*  4514*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4517*/      OPC_MoveChild0,
/*  4518*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4521*/      OPC_RecordChild0, // #1 = $off
/*  4522*/      OPC_MoveChild0,
/*  4523*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4526*/      OPC_MoveParent,
/*  4527*/      OPC_MoveParent,
/*  4528*/      OPC_RecordChild1, // #2 = $addr
/*  4529*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  4531*/      OPC_CheckType, MVT::i32,
/*  4533*/      OPC_MoveParent,
/*  4534*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  4536*/      OPC_MoveParent,
/*  4537*/      OPC_MoveParent,
/*  4538*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4540*/      OPC_EmitMergeInputChains1_0,
/*  4541*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4544*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  4553*/    /*Scope*/ 55, /*->4609*/
/*  4554*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4558*/      OPC_MoveChild0,
/*  4559*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4562*/      OPC_MoveChild0,
/*  4563*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  4566*/      OPC_RecordMemRef,
/*  4567*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  4568*/      OPC_CheckFoldableChainNode,
/*  4569*/      OPC_MoveChild1,
/*  4570*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4573*/      OPC_MoveChild0,
/*  4574*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4577*/      OPC_RecordChild0, // #1 = $off
/*  4578*/      OPC_MoveChild0,
/*  4579*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4582*/      OPC_MoveParent,
/*  4583*/      OPC_MoveParent,
/*  4584*/      OPC_RecordChild1, // #2 = $addr
/*  4585*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  4587*/      OPC_CheckType, MVT::i32,
/*  4589*/      OPC_MoveParent,
/*  4590*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  4592*/      OPC_MoveParent,
/*  4593*/      OPC_MoveParent,
/*  4594*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4596*/      OPC_EmitMergeInputChains1_0,
/*  4597*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4600*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 25
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  4609*/    /*Scope*/ 52, /*->4662*/
/*  4610*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4613*/      OPC_MoveChild0,
/*  4614*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4617*/      OPC_MoveChild0,
/*  4618*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  4621*/      OPC_RecordMemRef,
/*  4622*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  4623*/      OPC_CheckFoldableChainNode,
/*  4624*/      OPC_MoveChild1,
/*  4625*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4628*/      OPC_RecordChild0, // #1 = $addr
/*  4629*/      OPC_MoveChild1,
/*  4630*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4633*/      OPC_RecordChild0, // #2 = $off
/*  4634*/      OPC_MoveChild0,
/*  4635*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  4638*/      OPC_MoveParent,
/*  4639*/      OPC_MoveParent,
/*  4640*/      OPC_CheckType, MVT::i32,
/*  4642*/      OPC_MoveParent,
/*  4643*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  4645*/      OPC_MoveParent,
/*  4646*/      OPC_MoveParent,
/*  4647*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4649*/      OPC_EmitMergeInputChains1_0,
/*  4650*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4653*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  4662*/    /*Scope*/ 53, /*->4716*/
/*  4663*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4667*/      OPC_MoveChild0,
/*  4668*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4671*/      OPC_MoveChild0,
/*  4672*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  4675*/      OPC_RecordMemRef,
/*  4676*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  4677*/      OPC_CheckFoldableChainNode,
/*  4678*/      OPC_MoveChild1,
/*  4679*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4682*/      OPC_RecordChild0, // #1 = $addr
/*  4683*/      OPC_MoveChild1,
/*  4684*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4687*/      OPC_RecordChild0, // #2 = $off
/*  4688*/      OPC_MoveChild0,
/*  4689*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  4692*/      OPC_MoveParent,
/*  4693*/      OPC_MoveParent,
/*  4694*/      OPC_CheckType, MVT::i32,
/*  4696*/      OPC_MoveParent,
/*  4697*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  4699*/      OPC_MoveParent,
/*  4700*/      OPC_MoveParent,
/*  4701*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4703*/      OPC_EmitMergeInputChains1_0,
/*  4704*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4707*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  4716*/    /*Scope*/ 52, /*->4769*/
/*  4717*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4720*/      OPC_MoveChild0,
/*  4721*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4724*/      OPC_MoveChild0,
/*  4725*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  4728*/      OPC_RecordMemRef,
/*  4729*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  4730*/      OPC_CheckFoldableChainNode,
/*  4731*/      OPC_MoveChild1,
/*  4732*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4735*/      OPC_MoveChild0,
/*  4736*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4739*/      OPC_RecordChild0, // #1 = $off
/*  4740*/      OPC_MoveChild0,
/*  4741*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  4744*/      OPC_MoveParent,
/*  4745*/      OPC_MoveParent,
/*  4746*/      OPC_RecordChild1, // #2 = $addr
/*  4747*/      OPC_CheckType, MVT::i32,
/*  4749*/      OPC_MoveParent,
/*  4750*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  4752*/      OPC_MoveParent,
/*  4753*/      OPC_MoveParent,
/*  4754*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4756*/      OPC_EmitMergeInputChains1_0,
/*  4757*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4760*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  4769*/    /*Scope*/ 53, /*->4823*/
/*  4770*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4774*/      OPC_MoveChild0,
/*  4775*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4778*/      OPC_MoveChild0,
/*  4779*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  4782*/      OPC_RecordMemRef,
/*  4783*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  4784*/      OPC_CheckFoldableChainNode,
/*  4785*/      OPC_MoveChild1,
/*  4786*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  4789*/      OPC_MoveChild0,
/*  4790*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4793*/      OPC_RecordChild0, // #1 = $off
/*  4794*/      OPC_MoveChild0,
/*  4795*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  4798*/      OPC_MoveParent,
/*  4799*/      OPC_MoveParent,
/*  4800*/      OPC_RecordChild1, // #2 = $addr
/*  4801*/      OPC_CheckType, MVT::i32,
/*  4803*/      OPC_MoveParent,
/*  4804*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  4806*/      OPC_MoveParent,
/*  4807*/      OPC_MoveParent,
/*  4808*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4810*/      OPC_EmitMergeInputChains1_0,
/*  4811*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4814*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  4823*/    /*Scope*/ 61, /*->4885*/
/*  4824*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4827*/      OPC_MoveChild0,
/*  4828*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4831*/      OPC_MoveChild0,
/*  4832*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  4835*/      OPC_RecordMemRef,
/*  4836*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  4837*/      OPC_CheckFoldableChainNode,
/*  4838*/      OPC_MoveChild1,
/*  4839*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4842*/      OPC_RecordChild0, // #1 = $off
/*  4843*/      OPC_MoveChild0,
/*  4844*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4847*/      OPC_MoveParent,
/*  4848*/      OPC_MoveParent,
/*  4849*/      OPC_MoveChild2,
/*  4850*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4853*/      OPC_RecordChild0, // #2 = $val
/*  4854*/      OPC_MoveParent,
/*  4855*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  4857*/      OPC_MoveParent,
/*  4858*/      OPC_MoveParent,
/*  4859*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4861*/      OPC_EmitMergeInputChains1_0,
/*  4862*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4865*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4868*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  4875*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4885*/    /*Scope*/ 62, /*->4948*/
/*  4886*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4890*/      OPC_MoveChild0,
/*  4891*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4894*/      OPC_MoveChild0,
/*  4895*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  4898*/      OPC_RecordMemRef,
/*  4899*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  4900*/      OPC_CheckFoldableChainNode,
/*  4901*/      OPC_MoveChild1,
/*  4902*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4905*/      OPC_RecordChild0, // #1 = $off
/*  4906*/      OPC_MoveChild0,
/*  4907*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4910*/      OPC_MoveParent,
/*  4911*/      OPC_MoveParent,
/*  4912*/      OPC_MoveChild2,
/*  4913*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4916*/      OPC_RecordChild0, // #2 = $val
/*  4917*/      OPC_MoveParent,
/*  4918*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  4920*/      OPC_MoveParent,
/*  4921*/      OPC_MoveParent,
/*  4922*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4924*/      OPC_EmitMergeInputChains1_0,
/*  4925*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4928*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4931*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  4938*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  4948*/    /*Scope*/ 61, /*->5010*/
/*  4949*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4952*/      OPC_MoveChild0,
/*  4953*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  4956*/      OPC_MoveChild0,
/*  4957*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  4960*/      OPC_RecordMemRef,
/*  4961*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  4962*/      OPC_CheckFoldableChainNode,
/*  4963*/      OPC_MoveChild1,
/*  4964*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4967*/      OPC_RecordChild0, // #1 = $off
/*  4968*/      OPC_MoveChild0,
/*  4969*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  4972*/      OPC_MoveParent,
/*  4973*/      OPC_MoveParent,
/*  4974*/      OPC_MoveChild2,
/*  4975*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4978*/      OPC_RecordChild0, // #2 = $val
/*  4979*/      OPC_MoveParent,
/*  4980*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  4982*/      OPC_MoveParent,
/*  4983*/      OPC_MoveParent,
/*  4984*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  4986*/      OPC_EmitMergeInputChains1_0,
/*  4987*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4990*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4993*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5000*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5010*/    /*Scope*/ 62, /*->5073*/
/*  5011*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5015*/      OPC_MoveChild0,
/*  5016*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5019*/      OPC_MoveChild0,
/*  5020*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  5023*/      OPC_RecordMemRef,
/*  5024*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  5025*/      OPC_CheckFoldableChainNode,
/*  5026*/      OPC_MoveChild1,
/*  5027*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5030*/      OPC_RecordChild0, // #1 = $off
/*  5031*/      OPC_MoveChild0,
/*  5032*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5035*/      OPC_MoveParent,
/*  5036*/      OPC_MoveParent,
/*  5037*/      OPC_MoveChild2,
/*  5038*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5041*/      OPC_RecordChild0, // #2 = $val
/*  5042*/      OPC_MoveParent,
/*  5043*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  5045*/      OPC_MoveParent,
/*  5046*/      OPC_MoveParent,
/*  5047*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5049*/      OPC_EmitMergeInputChains1_0,
/*  5050*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5053*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5056*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5063*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5073*/    /*Scope*/ 61, /*->5135*/
/*  5074*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5077*/      OPC_MoveChild0,
/*  5078*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5081*/      OPC_MoveChild0,
/*  5082*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  5085*/      OPC_RecordMemRef,
/*  5086*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  5087*/      OPC_CheckFoldableChainNode,
/*  5088*/      OPC_MoveChild1,
/*  5089*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5092*/      OPC_RecordChild0, // #1 = $off
/*  5093*/      OPC_MoveChild0,
/*  5094*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5097*/      OPC_MoveParent,
/*  5098*/      OPC_MoveParent,
/*  5099*/      OPC_MoveChild2,
/*  5100*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5103*/      OPC_RecordChild0, // #2 = $val
/*  5104*/      OPC_MoveParent,
/*  5105*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  5107*/      OPC_MoveParent,
/*  5108*/      OPC_MoveParent,
/*  5109*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5111*/      OPC_EmitMergeInputChains1_0,
/*  5112*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5115*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5118*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5125*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5135*/    /*Scope*/ 62, /*->5198*/
/*  5136*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5140*/      OPC_MoveChild0,
/*  5141*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5144*/      OPC_MoveChild0,
/*  5145*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  5148*/      OPC_RecordMemRef,
/*  5149*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  5150*/      OPC_CheckFoldableChainNode,
/*  5151*/      OPC_MoveChild1,
/*  5152*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5155*/      OPC_RecordChild0, // #1 = $off
/*  5156*/      OPC_MoveChild0,
/*  5157*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5160*/      OPC_MoveParent,
/*  5161*/      OPC_MoveParent,
/*  5162*/      OPC_MoveChild2,
/*  5163*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5166*/      OPC_RecordChild0, // #2 = $val
/*  5167*/      OPC_MoveParent,
/*  5168*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  5170*/      OPC_MoveParent,
/*  5171*/      OPC_MoveParent,
/*  5172*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5174*/      OPC_EmitMergeInputChains1_0,
/*  5175*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5178*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5181*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5188*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5198*/    /*Scope*/ 61, /*->5260*/
/*  5199*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5202*/      OPC_MoveChild0,
/*  5203*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5206*/      OPC_MoveChild0,
/*  5207*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  5210*/      OPC_RecordMemRef,
/*  5211*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  5212*/      OPC_CheckFoldableChainNode,
/*  5213*/      OPC_MoveChild1,
/*  5214*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5217*/      OPC_RecordChild0, // #1 = $off
/*  5218*/      OPC_MoveChild0,
/*  5219*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5222*/      OPC_MoveParent,
/*  5223*/      OPC_MoveParent,
/*  5224*/      OPC_MoveChild2,
/*  5225*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5228*/      OPC_RecordChild0, // #2 = $val
/*  5229*/      OPC_MoveParent,
/*  5230*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  5232*/      OPC_MoveParent,
/*  5233*/      OPC_MoveParent,
/*  5234*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5236*/      OPC_EmitMergeInputChains1_0,
/*  5237*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5240*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5243*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5250*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5260*/    /*Scope*/ 62, /*->5323*/
/*  5261*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5265*/      OPC_MoveChild0,
/*  5266*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5269*/      OPC_MoveChild0,
/*  5270*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  5273*/      OPC_RecordMemRef,
/*  5274*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  5275*/      OPC_CheckFoldableChainNode,
/*  5276*/      OPC_MoveChild1,
/*  5277*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5280*/      OPC_RecordChild0, // #1 = $off
/*  5281*/      OPC_MoveChild0,
/*  5282*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5285*/      OPC_MoveParent,
/*  5286*/      OPC_MoveParent,
/*  5287*/      OPC_MoveChild2,
/*  5288*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5291*/      OPC_RecordChild0, // #2 = $val
/*  5292*/      OPC_MoveParent,
/*  5293*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  5295*/      OPC_MoveParent,
/*  5296*/      OPC_MoveParent,
/*  5297*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5299*/      OPC_EmitMergeInputChains1_0,
/*  5300*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5303*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5306*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5313*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5323*/    /*Scope*/ 61, /*->5385*/
/*  5324*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5327*/      OPC_MoveChild0,
/*  5328*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5331*/      OPC_MoveChild0,
/*  5332*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  5335*/      OPC_RecordMemRef,
/*  5336*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  5337*/      OPC_CheckFoldableChainNode,
/*  5338*/      OPC_MoveChild1,
/*  5339*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5342*/      OPC_RecordChild0, // #1 = $off
/*  5343*/      OPC_MoveChild0,
/*  5344*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5347*/      OPC_MoveParent,
/*  5348*/      OPC_MoveParent,
/*  5349*/      OPC_MoveChild2,
/*  5350*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5353*/      OPC_RecordChild0, // #2 = $val
/*  5354*/      OPC_MoveParent,
/*  5355*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  5357*/      OPC_MoveParent,
/*  5358*/      OPC_MoveParent,
/*  5359*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5361*/      OPC_EmitMergeInputChains1_0,
/*  5362*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5365*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5368*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5375*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5385*/    /*Scope*/ 62, /*->5448*/
/*  5386*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5390*/      OPC_MoveChild0,
/*  5391*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5394*/      OPC_MoveChild0,
/*  5395*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  5398*/      OPC_RecordMemRef,
/*  5399*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  5400*/      OPC_CheckFoldableChainNode,
/*  5401*/      OPC_MoveChild1,
/*  5402*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5405*/      OPC_RecordChild0, // #1 = $off
/*  5406*/      OPC_MoveChild0,
/*  5407*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5410*/      OPC_MoveParent,
/*  5411*/      OPC_MoveParent,
/*  5412*/      OPC_MoveChild2,
/*  5413*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5416*/      OPC_RecordChild0, // #2 = $val
/*  5417*/      OPC_MoveParent,
/*  5418*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  5420*/      OPC_MoveParent,
/*  5421*/      OPC_MoveParent,
/*  5422*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5424*/      OPC_EmitMergeInputChains1_0,
/*  5425*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5428*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5431*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5438*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5448*/    /*Scope*/ 61, /*->5510*/
/*  5449*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5452*/      OPC_MoveChild0,
/*  5453*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5456*/      OPC_MoveChild0,
/*  5457*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  5460*/      OPC_RecordMemRef,
/*  5461*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  5462*/      OPC_CheckFoldableChainNode,
/*  5463*/      OPC_MoveChild1,
/*  5464*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5467*/      OPC_RecordChild0, // #1 = $off
/*  5468*/      OPC_MoveChild0,
/*  5469*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5472*/      OPC_MoveParent,
/*  5473*/      OPC_MoveParent,
/*  5474*/      OPC_MoveChild2,
/*  5475*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5478*/      OPC_RecordChild0, // #2 = $val
/*  5479*/      OPC_MoveParent,
/*  5480*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  5482*/      OPC_MoveParent,
/*  5483*/      OPC_MoveParent,
/*  5484*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5486*/      OPC_EmitMergeInputChains1_0,
/*  5487*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5490*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5493*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5500*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5510*/    /*Scope*/ 62, /*->5573*/
/*  5511*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5515*/      OPC_MoveChild0,
/*  5516*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5519*/      OPC_MoveChild0,
/*  5520*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  5523*/      OPC_RecordMemRef,
/*  5524*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  5525*/      OPC_CheckFoldableChainNode,
/*  5526*/      OPC_MoveChild1,
/*  5527*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5530*/      OPC_RecordChild0, // #1 = $off
/*  5531*/      OPC_MoveChild0,
/*  5532*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5535*/      OPC_MoveParent,
/*  5536*/      OPC_MoveParent,
/*  5537*/      OPC_MoveChild2,
/*  5538*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5541*/      OPC_RecordChild0, // #2 = $val
/*  5542*/      OPC_MoveParent,
/*  5543*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  5545*/      OPC_MoveParent,
/*  5546*/      OPC_MoveParent,
/*  5547*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5549*/      OPC_EmitMergeInputChains1_0,
/*  5550*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5553*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5556*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5563*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5573*/    /*Scope*/ 61, /*->5635*/
/*  5574*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5577*/      OPC_MoveChild0,
/*  5578*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5581*/      OPC_MoveChild0,
/*  5582*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  5585*/      OPC_RecordMemRef,
/*  5586*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  5587*/      OPC_CheckFoldableChainNode,
/*  5588*/      OPC_MoveChild1,
/*  5589*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5592*/      OPC_RecordChild0, // #1 = $off
/*  5593*/      OPC_MoveChild0,
/*  5594*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5597*/      OPC_MoveParent,
/*  5598*/      OPC_MoveParent,
/*  5599*/      OPC_MoveChild2,
/*  5600*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5603*/      OPC_RecordChild0, // #2 = $val
/*  5604*/      OPC_MoveParent,
/*  5605*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  5607*/      OPC_MoveParent,
/*  5608*/      OPC_MoveParent,
/*  5609*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5611*/      OPC_EmitMergeInputChains1_0,
/*  5612*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5615*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5618*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5625*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5635*/    /*Scope*/ 62, /*->5698*/
/*  5636*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5640*/      OPC_MoveChild0,
/*  5641*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5644*/      OPC_MoveChild0,
/*  5645*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  5648*/      OPC_RecordMemRef,
/*  5649*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  5650*/      OPC_CheckFoldableChainNode,
/*  5651*/      OPC_MoveChild1,
/*  5652*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5655*/      OPC_RecordChild0, // #1 = $off
/*  5656*/      OPC_MoveChild0,
/*  5657*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5660*/      OPC_MoveParent,
/*  5661*/      OPC_MoveParent,
/*  5662*/      OPC_MoveChild2,
/*  5663*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5666*/      OPC_RecordChild0, // #2 = $val
/*  5667*/      OPC_MoveParent,
/*  5668*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  5670*/      OPC_MoveParent,
/*  5671*/      OPC_MoveParent,
/*  5672*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5674*/      OPC_EmitMergeInputChains1_0,
/*  5675*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5678*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5681*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5688*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5698*/    /*Scope*/ 61, /*->5760*/
/*  5699*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5702*/      OPC_MoveChild0,
/*  5703*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5706*/      OPC_MoveChild0,
/*  5707*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  5710*/      OPC_RecordMemRef,
/*  5711*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  5712*/      OPC_CheckFoldableChainNode,
/*  5713*/      OPC_MoveChild1,
/*  5714*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5717*/      OPC_RecordChild0, // #1 = $off
/*  5718*/      OPC_MoveChild0,
/*  5719*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5722*/      OPC_MoveParent,
/*  5723*/      OPC_MoveParent,
/*  5724*/      OPC_MoveChild2,
/*  5725*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5728*/      OPC_RecordChild0, // #2 = $val
/*  5729*/      OPC_MoveParent,
/*  5730*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  5732*/      OPC_MoveParent,
/*  5733*/      OPC_MoveParent,
/*  5734*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5736*/      OPC_EmitMergeInputChains1_0,
/*  5737*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5740*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5743*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5760*/    /*Scope*/ 62, /*->5823*/
/*  5761*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5765*/      OPC_MoveChild0,
/*  5766*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5769*/      OPC_MoveChild0,
/*  5770*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  5773*/      OPC_RecordMemRef,
/*  5774*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  5775*/      OPC_CheckFoldableChainNode,
/*  5776*/      OPC_MoveChild1,
/*  5777*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5780*/      OPC_RecordChild0, // #1 = $off
/*  5781*/      OPC_MoveChild0,
/*  5782*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5785*/      OPC_MoveParent,
/*  5786*/      OPC_MoveParent,
/*  5787*/      OPC_MoveChild2,
/*  5788*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5791*/      OPC_RecordChild0, // #2 = $val
/*  5792*/      OPC_MoveParent,
/*  5793*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  5795*/      OPC_MoveParent,
/*  5796*/      OPC_MoveParent,
/*  5797*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5799*/      OPC_EmitMergeInputChains1_0,
/*  5800*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5803*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5806*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5813*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5823*/    /*Scope*/ 61, /*->5885*/
/*  5824*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5827*/      OPC_MoveChild0,
/*  5828*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5831*/      OPC_MoveChild0,
/*  5832*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  5835*/      OPC_RecordMemRef,
/*  5836*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  5837*/      OPC_CheckFoldableChainNode,
/*  5838*/      OPC_MoveChild1,
/*  5839*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5842*/      OPC_RecordChild0, // #1 = $off
/*  5843*/      OPC_MoveChild0,
/*  5844*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5847*/      OPC_MoveParent,
/*  5848*/      OPC_MoveParent,
/*  5849*/      OPC_MoveChild2,
/*  5850*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5853*/      OPC_RecordChild0, // #2 = $val
/*  5854*/      OPC_MoveParent,
/*  5855*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5857*/      OPC_MoveParent,
/*  5858*/      OPC_MoveParent,
/*  5859*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5861*/      OPC_EmitMergeInputChains1_0,
/*  5862*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5865*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5868*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5875*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5885*/    /*Scope*/ 62, /*->5948*/
/*  5886*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  5890*/      OPC_MoveChild0,
/*  5891*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5894*/      OPC_MoveChild0,
/*  5895*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  5898*/      OPC_RecordMemRef,
/*  5899*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  5900*/      OPC_CheckFoldableChainNode,
/*  5901*/      OPC_MoveChild1,
/*  5902*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5905*/      OPC_RecordChild0, // #1 = $off
/*  5906*/      OPC_MoveChild0,
/*  5907*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  5910*/      OPC_MoveParent,
/*  5911*/      OPC_MoveParent,
/*  5912*/      OPC_MoveChild2,
/*  5913*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5916*/      OPC_RecordChild0, // #2 = $val
/*  5917*/      OPC_MoveParent,
/*  5918*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  5920*/      OPC_MoveParent,
/*  5921*/      OPC_MoveParent,
/*  5922*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5924*/      OPC_EmitMergeInputChains1_0,
/*  5925*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5928*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5931*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  5938*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  5948*/    /*Scope*/ 61, /*->6010*/
/*  5949*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  5952*/      OPC_MoveChild0,
/*  5953*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  5956*/      OPC_MoveChild0,
/*  5957*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  5960*/      OPC_RecordMemRef,
/*  5961*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  5962*/      OPC_CheckFoldableChainNode,
/*  5963*/      OPC_MoveChild1,
/*  5964*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  5967*/      OPC_RecordChild0, // #1 = $off
/*  5968*/      OPC_MoveChild0,
/*  5969*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  5972*/      OPC_MoveParent,
/*  5973*/      OPC_MoveParent,
/*  5974*/      OPC_MoveChild2,
/*  5975*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  5978*/      OPC_RecordChild0, // #2 = $val
/*  5979*/      OPC_MoveParent,
/*  5980*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  5982*/      OPC_MoveParent,
/*  5983*/      OPC_MoveParent,
/*  5984*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  5986*/      OPC_EmitMergeInputChains1_0,
/*  5987*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5990*/      OPC_EmitInteger, MVT::i32, 0, 
/*  5993*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6000*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6010*/    /*Scope*/ 62, /*->6073*/
/*  6011*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6015*/      OPC_MoveChild0,
/*  6016*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6019*/      OPC_MoveChild0,
/*  6020*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  6023*/      OPC_RecordMemRef,
/*  6024*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  6025*/      OPC_CheckFoldableChainNode,
/*  6026*/      OPC_MoveChild1,
/*  6027*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6030*/      OPC_RecordChild0, // #1 = $off
/*  6031*/      OPC_MoveChild0,
/*  6032*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  6035*/      OPC_MoveParent,
/*  6036*/      OPC_MoveParent,
/*  6037*/      OPC_MoveChild2,
/*  6038*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6041*/      OPC_RecordChild0, // #2 = $val
/*  6042*/      OPC_MoveParent,
/*  6043*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  6045*/      OPC_MoveParent,
/*  6046*/      OPC_MoveParent,
/*  6047*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6049*/      OPC_EmitMergeInputChains1_0,
/*  6050*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6053*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6056*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6063*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6073*/    /*Scope*/ 61, /*->6135*/
/*  6074*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6077*/      OPC_MoveChild0,
/*  6078*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6081*/      OPC_MoveChild0,
/*  6082*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  6085*/      OPC_RecordMemRef,
/*  6086*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  6087*/      OPC_CheckFoldableChainNode,
/*  6088*/      OPC_MoveChild1,
/*  6089*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6092*/      OPC_RecordChild0, // #1 = $off
/*  6093*/      OPC_MoveChild0,
/*  6094*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6097*/      OPC_MoveParent,
/*  6098*/      OPC_MoveParent,
/*  6099*/      OPC_MoveChild2,
/*  6100*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6103*/      OPC_RecordChild0, // #2 = $val
/*  6104*/      OPC_MoveParent,
/*  6105*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  6107*/      OPC_MoveParent,
/*  6108*/      OPC_MoveParent,
/*  6109*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6111*/      OPC_EmitMergeInputChains1_0,
/*  6112*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6115*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6118*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6125*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6135*/    /*Scope*/ 62, /*->6198*/
/*  6136*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6140*/      OPC_MoveChild0,
/*  6141*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6144*/      OPC_MoveChild0,
/*  6145*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  6148*/      OPC_RecordMemRef,
/*  6149*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  6150*/      OPC_CheckFoldableChainNode,
/*  6151*/      OPC_MoveChild1,
/*  6152*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6155*/      OPC_RecordChild0, // #1 = $off
/*  6156*/      OPC_MoveChild0,
/*  6157*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6160*/      OPC_MoveParent,
/*  6161*/      OPC_MoveParent,
/*  6162*/      OPC_MoveChild2,
/*  6163*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6166*/      OPC_RecordChild0, // #2 = $val
/*  6167*/      OPC_MoveParent,
/*  6168*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6170*/      OPC_MoveParent,
/*  6171*/      OPC_MoveParent,
/*  6172*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6174*/      OPC_EmitMergeInputChains1_0,
/*  6175*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6178*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6181*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6188*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6198*/    /*Scope*/ 61, /*->6260*/
/*  6199*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6202*/      OPC_MoveChild0,
/*  6203*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6206*/      OPC_MoveChild0,
/*  6207*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  6210*/      OPC_RecordMemRef,
/*  6211*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  6212*/      OPC_CheckFoldableChainNode,
/*  6213*/      OPC_MoveChild1,
/*  6214*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6217*/      OPC_RecordChild0, // #1 = $off
/*  6218*/      OPC_MoveChild0,
/*  6219*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  6222*/      OPC_MoveParent,
/*  6223*/      OPC_MoveParent,
/*  6224*/      OPC_MoveChild2,
/*  6225*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6228*/      OPC_RecordChild0, // #2 = $val
/*  6229*/      OPC_MoveParent,
/*  6230*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  6232*/      OPC_MoveParent,
/*  6233*/      OPC_MoveParent,
/*  6234*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6236*/      OPC_EmitMergeInputChains1_0,
/*  6237*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6240*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6243*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6250*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6260*/    /*Scope*/ 62, /*->6323*/
/*  6261*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6265*/      OPC_MoveChild0,
/*  6266*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6269*/      OPC_MoveChild0,
/*  6270*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  6273*/      OPC_RecordMemRef,
/*  6274*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  6275*/      OPC_CheckFoldableChainNode,
/*  6276*/      OPC_MoveChild1,
/*  6277*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6280*/      OPC_RecordChild0, // #1 = $off
/*  6281*/      OPC_MoveChild0,
/*  6282*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  6285*/      OPC_MoveParent,
/*  6286*/      OPC_MoveParent,
/*  6287*/      OPC_MoveChild2,
/*  6288*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  6291*/      OPC_RecordChild0, // #2 = $val
/*  6292*/      OPC_MoveParent,
/*  6293*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  6295*/      OPC_MoveParent,
/*  6296*/      OPC_MoveParent,
/*  6297*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6299*/      OPC_EmitMergeInputChains1_0,
/*  6300*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6303*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6306*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/*  6313*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 24
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/*  6323*/    /*Scope*/ 51, /*->6375*/
/*  6324*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6327*/      OPC_MoveChild0,
/*  6328*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6331*/      OPC_MoveChild0,
/*  6332*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  6335*/      OPC_RecordMemRef,
/*  6336*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  6337*/      OPC_CheckFoldableChainNode,
/*  6338*/      OPC_MoveChild1,
/*  6339*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6342*/      OPC_RecordChild0, // #1 = $addr
/*  6343*/      OPC_RecordChild1, // #2 = $off
/*  6344*/      OPC_MoveChild1,
/*  6345*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  6348*/      OPC_MoveParent,
/*  6349*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  6351*/      OPC_CheckType, MVT::i32,
/*  6353*/      OPC_MoveParent,
/*  6354*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  6356*/      OPC_MoveParent,
/*  6357*/      OPC_MoveParent,
/*  6358*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6360*/      OPC_EmitMergeInputChains1_0,
/*  6361*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6364*/      OPC_EmitConvertToTarget, 2,
/*  6366*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6375*/    /*Scope*/ 52, /*->6428*/
/*  6376*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6380*/      OPC_MoveChild0,
/*  6381*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6384*/      OPC_MoveChild0,
/*  6385*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  6388*/      OPC_RecordMemRef,
/*  6389*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  6390*/      OPC_CheckFoldableChainNode,
/*  6391*/      OPC_MoveChild1,
/*  6392*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6395*/      OPC_RecordChild0, // #1 = $addr
/*  6396*/      OPC_RecordChild1, // #2 = $off
/*  6397*/      OPC_MoveChild1,
/*  6398*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  6401*/      OPC_MoveParent,
/*  6402*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/*  6404*/      OPC_CheckType, MVT::i32,
/*  6406*/      OPC_MoveParent,
/*  6407*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  6409*/      OPC_MoveParent,
/*  6410*/      OPC_MoveParent,
/*  6411*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6413*/      OPC_EmitMergeInputChains1_0,
/*  6414*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6417*/      OPC_EmitConvertToTarget, 2,
/*  6419*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6428*/    /*Scope*/ 51, /*->6480*/
/*  6429*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6432*/      OPC_MoveChild0,
/*  6433*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6436*/      OPC_MoveChild0,
/*  6437*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  6440*/      OPC_RecordMemRef,
/*  6441*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  6442*/      OPC_CheckFoldableChainNode,
/*  6443*/      OPC_MoveChild1,
/*  6444*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  6447*/      OPC_RecordChild0, // #1 = $addr
/*  6448*/      OPC_RecordChild1, // #2 = $off
/*  6449*/      OPC_MoveChild1,
/*  6450*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  6453*/      OPC_MoveParent,
/*  6454*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  6456*/      OPC_CheckType, MVT::i32,
/*  6458*/      OPC_MoveParent,
/*  6459*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  6461*/      OPC_MoveParent,
/*  6462*/      OPC_MoveParent,
/*  6463*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6465*/      OPC_EmitMergeInputChains1_0,
/*  6466*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6469*/      OPC_EmitConvertToTarget, 2,
/*  6471*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6480*/    /*Scope*/ 52, /*->6533*/
/*  6481*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6485*/      OPC_MoveChild0,
/*  6486*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  6489*/      OPC_MoveChild0,
/*  6490*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  6493*/      OPC_RecordMemRef,
/*  6494*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  6495*/      OPC_CheckFoldableChainNode,
/*  6496*/      OPC_MoveChild1,
/*  6497*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/*  6500*/      OPC_RecordChild0, // #1 = $addr
/*  6501*/      OPC_RecordChild1, // #2 = $off
/*  6502*/      OPC_MoveChild1,
/*  6503*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  6506*/      OPC_MoveParent,
/*  6507*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/*  6509*/      OPC_CheckType, MVT::i32,
/*  6511*/      OPC_MoveParent,
/*  6512*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  6514*/      OPC_MoveParent,
/*  6515*/      OPC_MoveParent,
/*  6516*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6518*/      OPC_EmitMergeInputChains1_0,
/*  6519*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6522*/      OPC_EmitConvertToTarget, 2,
/*  6524*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6533*/    /*Scope*/ 51, /*->6585*/
/*  6534*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6537*/      OPC_MoveChild0,
/*  6538*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  6541*/      OPC_RecordMemRef,
/*  6542*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  6543*/      OPC_CheckFoldableChainNode,
/*  6544*/      OPC_MoveChild1,
/*  6545*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6548*/      OPC_RecordChild0, // #1 = $addr
/*  6549*/      OPC_MoveChild1,
/*  6550*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6553*/      OPC_RecordChild0, // #2 = $off
/*  6554*/      OPC_MoveChild0,
/*  6555*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6558*/      OPC_MoveParent,
/*  6559*/      OPC_MoveParent,
/*  6560*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6562*/      OPC_CheckType, MVT::i32,
/*  6564*/      OPC_MoveParent,
/*  6565*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  6567*/      OPC_MoveParent,
/*  6568*/      OPC_CheckType, MVT::i32,
/*  6570*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6572*/      OPC_EmitMergeInputChains1_0,
/*  6573*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6576*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6585*/    /*Scope*/ 52, /*->6638*/
/*  6586*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6590*/      OPC_MoveChild0,
/*  6591*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  6594*/      OPC_RecordMemRef,
/*  6595*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  6596*/      OPC_CheckFoldableChainNode,
/*  6597*/      OPC_MoveChild1,
/*  6598*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6601*/      OPC_RecordChild0, // #1 = $addr
/*  6602*/      OPC_MoveChild1,
/*  6603*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6606*/      OPC_RecordChild0, // #2 = $off
/*  6607*/      OPC_MoveChild0,
/*  6608*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6611*/      OPC_MoveParent,
/*  6612*/      OPC_MoveParent,
/*  6613*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6615*/      OPC_CheckType, MVT::i32,
/*  6617*/      OPC_MoveParent,
/*  6618*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  6620*/      OPC_MoveParent,
/*  6621*/      OPC_CheckType, MVT::i32,
/*  6623*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6625*/      OPC_EmitMergeInputChains1_0,
/*  6626*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6629*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  6638*/    /*Scope*/ 53, /*->6692*/
/*  6639*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6642*/      OPC_MoveChild0,
/*  6643*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  6646*/      OPC_RecordMemRef,
/*  6647*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  6648*/      OPC_CheckFoldableChainNode,
/*  6649*/      OPC_MoveChild1,
/*  6650*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6653*/      OPC_RecordChild0, // #1 = $addr
/*  6654*/      OPC_MoveChild1,
/*  6655*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6658*/      OPC_RecordChild0, // #2 = $off
/*  6659*/      OPC_MoveChild0,
/*  6660*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6663*/      OPC_MoveParent,
/*  6664*/      OPC_MoveParent,
/*  6665*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6667*/      OPC_CheckType, MVT::i32,
/*  6669*/      OPC_MoveParent,
/*  6670*/      OPC_RecordChild2, // #3 = $val
/*  6671*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  6673*/      OPC_MoveParent,
/*  6674*/      OPC_CheckType, MVT::i32,
/*  6676*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6678*/      OPC_EmitMergeInputChains1_0,
/*  6679*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6682*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  6692*/    /*Scope*/ 54, /*->6747*/
/*  6693*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6697*/      OPC_MoveChild0,
/*  6698*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  6701*/      OPC_RecordMemRef,
/*  6702*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  6703*/      OPC_CheckFoldableChainNode,
/*  6704*/      OPC_MoveChild1,
/*  6705*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6708*/      OPC_RecordChild0, // #1 = $addr
/*  6709*/      OPC_MoveChild1,
/*  6710*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6713*/      OPC_RecordChild0, // #2 = $off
/*  6714*/      OPC_MoveChild0,
/*  6715*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6718*/      OPC_MoveParent,
/*  6719*/      OPC_MoveParent,
/*  6720*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6722*/      OPC_CheckType, MVT::i32,
/*  6724*/      OPC_MoveParent,
/*  6725*/      OPC_RecordChild2, // #3 = $val
/*  6726*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  6728*/      OPC_MoveParent,
/*  6729*/      OPC_CheckType, MVT::i32,
/*  6731*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6733*/      OPC_EmitMergeInputChains1_0,
/*  6734*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6737*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  6747*/    /*Scope*/ 53, /*->6801*/
/*  6748*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6751*/      OPC_MoveChild0,
/*  6752*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  6755*/      OPC_RecordMemRef,
/*  6756*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  6757*/      OPC_CheckFoldableChainNode,
/*  6758*/      OPC_MoveChild1,
/*  6759*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6762*/      OPC_RecordChild0, // #1 = $addr
/*  6763*/      OPC_MoveChild1,
/*  6764*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6767*/      OPC_RecordChild0, // #2 = $off
/*  6768*/      OPC_MoveChild0,
/*  6769*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6772*/      OPC_MoveParent,
/*  6773*/      OPC_MoveParent,
/*  6774*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6776*/      OPC_CheckType, MVT::i32,
/*  6778*/      OPC_MoveParent,
/*  6779*/      OPC_RecordChild2, // #3 = $val
/*  6780*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  6782*/      OPC_MoveParent,
/*  6783*/      OPC_CheckType, MVT::i32,
/*  6785*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6787*/      OPC_EmitMergeInputChains1_0,
/*  6788*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6791*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  6801*/    /*Scope*/ 54, /*->6856*/
/*  6802*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6806*/      OPC_MoveChild0,
/*  6807*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  6810*/      OPC_RecordMemRef,
/*  6811*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  6812*/      OPC_CheckFoldableChainNode,
/*  6813*/      OPC_MoveChild1,
/*  6814*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6817*/      OPC_RecordChild0, // #1 = $addr
/*  6818*/      OPC_MoveChild1,
/*  6819*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6822*/      OPC_RecordChild0, // #2 = $off
/*  6823*/      OPC_MoveChild0,
/*  6824*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6827*/      OPC_MoveParent,
/*  6828*/      OPC_MoveParent,
/*  6829*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6831*/      OPC_CheckType, MVT::i32,
/*  6833*/      OPC_MoveParent,
/*  6834*/      OPC_RecordChild2, // #3 = $val
/*  6835*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  6837*/      OPC_MoveParent,
/*  6838*/      OPC_CheckType, MVT::i32,
/*  6840*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6842*/      OPC_EmitMergeInputChains1_0,
/*  6843*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6846*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  6856*/    /*Scope*/ 53, /*->6910*/
/*  6857*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6860*/      OPC_MoveChild0,
/*  6861*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  6864*/      OPC_RecordMemRef,
/*  6865*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  6866*/      OPC_CheckFoldableChainNode,
/*  6867*/      OPC_MoveChild1,
/*  6868*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6871*/      OPC_RecordChild0, // #1 = $addr
/*  6872*/      OPC_MoveChild1,
/*  6873*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6876*/      OPC_RecordChild0, // #2 = $off
/*  6877*/      OPC_MoveChild0,
/*  6878*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6881*/      OPC_MoveParent,
/*  6882*/      OPC_MoveParent,
/*  6883*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6885*/      OPC_CheckType, MVT::i32,
/*  6887*/      OPC_MoveParent,
/*  6888*/      OPC_RecordChild2, // #3 = $val
/*  6889*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  6891*/      OPC_MoveParent,
/*  6892*/      OPC_CheckType, MVT::i32,
/*  6894*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6896*/      OPC_EmitMergeInputChains1_0,
/*  6897*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6900*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  6910*/    /*Scope*/ 54, /*->6965*/
/*  6911*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  6915*/      OPC_MoveChild0,
/*  6916*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  6919*/      OPC_RecordMemRef,
/*  6920*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  6921*/      OPC_CheckFoldableChainNode,
/*  6922*/      OPC_MoveChild1,
/*  6923*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6926*/      OPC_RecordChild0, // #1 = $addr
/*  6927*/      OPC_MoveChild1,
/*  6928*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6931*/      OPC_RecordChild0, // #2 = $off
/*  6932*/      OPC_MoveChild0,
/*  6933*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6936*/      OPC_MoveParent,
/*  6937*/      OPC_MoveParent,
/*  6938*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6940*/      OPC_CheckType, MVT::i32,
/*  6942*/      OPC_MoveParent,
/*  6943*/      OPC_RecordChild2, // #3 = $val
/*  6944*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  6946*/      OPC_MoveParent,
/*  6947*/      OPC_CheckType, MVT::i32,
/*  6949*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  6951*/      OPC_EmitMergeInputChains1_0,
/*  6952*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6955*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  6965*/    /*Scope*/ 53, /*->7019*/
/*  6966*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  6969*/      OPC_MoveChild0,
/*  6970*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  6973*/      OPC_RecordMemRef,
/*  6974*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  6975*/      OPC_CheckFoldableChainNode,
/*  6976*/      OPC_MoveChild1,
/*  6977*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  6980*/      OPC_RecordChild0, // #1 = $addr
/*  6981*/      OPC_MoveChild1,
/*  6982*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  6985*/      OPC_RecordChild0, // #2 = $off
/*  6986*/      OPC_MoveChild0,
/*  6987*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  6990*/      OPC_MoveParent,
/*  6991*/      OPC_MoveParent,
/*  6992*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  6994*/      OPC_CheckType, MVT::i32,
/*  6996*/      OPC_MoveParent,
/*  6997*/      OPC_RecordChild2, // #3 = $val
/*  6998*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  7000*/      OPC_MoveParent,
/*  7001*/      OPC_CheckType, MVT::i32,
/*  7003*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7005*/      OPC_EmitMergeInputChains1_0,
/*  7006*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7009*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7019*/    /*Scope*/ 54, /*->7074*/
/*  7020*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7024*/      OPC_MoveChild0,
/*  7025*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  7028*/      OPC_RecordMemRef,
/*  7029*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  7030*/      OPC_CheckFoldableChainNode,
/*  7031*/      OPC_MoveChild1,
/*  7032*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7035*/      OPC_RecordChild0, // #1 = $addr
/*  7036*/      OPC_MoveChild1,
/*  7037*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7040*/      OPC_RecordChild0, // #2 = $off
/*  7041*/      OPC_MoveChild0,
/*  7042*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7045*/      OPC_MoveParent,
/*  7046*/      OPC_MoveParent,
/*  7047*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7049*/      OPC_CheckType, MVT::i32,
/*  7051*/      OPC_MoveParent,
/*  7052*/      OPC_RecordChild2, // #3 = $val
/*  7053*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  7055*/      OPC_MoveParent,
/*  7056*/      OPC_CheckType, MVT::i32,
/*  7058*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7060*/      OPC_EmitMergeInputChains1_0,
/*  7061*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7064*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7074*/    /*Scope*/ 53, /*->7128*/
/*  7075*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7078*/      OPC_MoveChild0,
/*  7079*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  7082*/      OPC_RecordMemRef,
/*  7083*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  7084*/      OPC_CheckFoldableChainNode,
/*  7085*/      OPC_MoveChild1,
/*  7086*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7089*/      OPC_RecordChild0, // #1 = $addr
/*  7090*/      OPC_MoveChild1,
/*  7091*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7094*/      OPC_RecordChild0, // #2 = $off
/*  7095*/      OPC_MoveChild0,
/*  7096*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7099*/      OPC_MoveParent,
/*  7100*/      OPC_MoveParent,
/*  7101*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7103*/      OPC_CheckType, MVT::i32,
/*  7105*/      OPC_MoveParent,
/*  7106*/      OPC_RecordChild2, // #3 = $val
/*  7107*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  7109*/      OPC_MoveParent,
/*  7110*/      OPC_CheckType, MVT::i32,
/*  7112*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7114*/      OPC_EmitMergeInputChains1_0,
/*  7115*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7128*/    /*Scope*/ 54, /*->7183*/
/*  7129*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7133*/      OPC_MoveChild0,
/*  7134*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  7137*/      OPC_RecordMemRef,
/*  7138*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  7139*/      OPC_CheckFoldableChainNode,
/*  7140*/      OPC_MoveChild1,
/*  7141*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7144*/      OPC_RecordChild0, // #1 = $addr
/*  7145*/      OPC_MoveChild1,
/*  7146*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7149*/      OPC_RecordChild0, // #2 = $off
/*  7150*/      OPC_MoveChild0,
/*  7151*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7154*/      OPC_MoveParent,
/*  7155*/      OPC_MoveParent,
/*  7156*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7158*/      OPC_CheckType, MVT::i32,
/*  7160*/      OPC_MoveParent,
/*  7161*/      OPC_RecordChild2, // #3 = $val
/*  7162*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  7164*/      OPC_MoveParent,
/*  7165*/      OPC_CheckType, MVT::i32,
/*  7167*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7169*/      OPC_EmitMergeInputChains1_0,
/*  7170*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7173*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7183*/    /*Scope*/ 53, /*->7237*/
/*  7184*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7187*/      OPC_MoveChild0,
/*  7188*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  7191*/      OPC_RecordMemRef,
/*  7192*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  7193*/      OPC_CheckFoldableChainNode,
/*  7194*/      OPC_MoveChild1,
/*  7195*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7198*/      OPC_RecordChild0, // #1 = $addr
/*  7199*/      OPC_MoveChild1,
/*  7200*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7203*/      OPC_RecordChild0, // #2 = $off
/*  7204*/      OPC_MoveChild0,
/*  7205*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7208*/      OPC_MoveParent,
/*  7209*/      OPC_MoveParent,
/*  7210*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7212*/      OPC_CheckType, MVT::i32,
/*  7214*/      OPC_MoveParent,
/*  7215*/      OPC_RecordChild2, // #3 = $val
/*  7216*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  7218*/      OPC_MoveParent,
/*  7219*/      OPC_CheckType, MVT::i32,
/*  7221*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7223*/      OPC_EmitMergeInputChains1_0,
/*  7224*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7227*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7237*/    /*Scope*/ 54, /*->7292*/
/*  7238*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7242*/      OPC_MoveChild0,
/*  7243*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  7246*/      OPC_RecordMemRef,
/*  7247*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  7248*/      OPC_CheckFoldableChainNode,
/*  7249*/      OPC_MoveChild1,
/*  7250*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7253*/      OPC_RecordChild0, // #1 = $addr
/*  7254*/      OPC_MoveChild1,
/*  7255*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7258*/      OPC_RecordChild0, // #2 = $off
/*  7259*/      OPC_MoveChild0,
/*  7260*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7263*/      OPC_MoveParent,
/*  7264*/      OPC_MoveParent,
/*  7265*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7267*/      OPC_CheckType, MVT::i32,
/*  7269*/      OPC_MoveParent,
/*  7270*/      OPC_RecordChild2, // #3 = $val
/*  7271*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  7273*/      OPC_MoveParent,
/*  7274*/      OPC_CheckType, MVT::i32,
/*  7276*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7278*/      OPC_EmitMergeInputChains1_0,
/*  7279*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7282*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7292*/    /*Scope*/ 55, /*->7348*/
/*  7293*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7296*/      OPC_MoveChild0,
/*  7297*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  7300*/      OPC_RecordMemRef,
/*  7301*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  7302*/      OPC_CheckFoldableChainNode,
/*  7303*/      OPC_MoveChild1,
/*  7304*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7307*/      OPC_RecordChild0, // #1 = $addr
/*  7308*/      OPC_MoveChild1,
/*  7309*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7312*/      OPC_RecordChild0, // #2 = $off
/*  7313*/      OPC_MoveChild0,
/*  7314*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7317*/      OPC_MoveParent,
/*  7318*/      OPC_MoveParent,
/*  7319*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7321*/      OPC_CheckType, MVT::i32,
/*  7323*/      OPC_MoveParent,
/*  7324*/      OPC_RecordChild2, // #3 = $exp
/*  7325*/      OPC_RecordChild3, // #4 = $new
/*  7326*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  7328*/      OPC_MoveParent,
/*  7329*/      OPC_CheckType, MVT::i32,
/*  7331*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7333*/      OPC_EmitMergeInputChains1_0,
/*  7334*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7337*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  7348*/    /*Scope*/ 56, /*->7405*/
/*  7349*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7353*/      OPC_MoveChild0,
/*  7354*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  7357*/      OPC_RecordMemRef,
/*  7358*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  7359*/      OPC_CheckFoldableChainNode,
/*  7360*/      OPC_MoveChild1,
/*  7361*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7364*/      OPC_RecordChild0, // #1 = $addr
/*  7365*/      OPC_MoveChild1,
/*  7366*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7369*/      OPC_RecordChild0, // #2 = $off
/*  7370*/      OPC_MoveChild0,
/*  7371*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7374*/      OPC_MoveParent,
/*  7375*/      OPC_MoveParent,
/*  7376*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7378*/      OPC_CheckType, MVT::i32,
/*  7380*/      OPC_MoveParent,
/*  7381*/      OPC_RecordChild2, // #3 = $exp
/*  7382*/      OPC_RecordChild3, // #4 = $new
/*  7383*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  7385*/      OPC_MoveParent,
/*  7386*/      OPC_CheckType, MVT::i32,
/*  7388*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7390*/      OPC_EmitMergeInputChains1_0,
/*  7391*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7394*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  7405*/    /*Scope*/ 51, /*->7457*/
/*  7406*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7409*/      OPC_MoveChild0,
/*  7410*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  7413*/      OPC_RecordMemRef,
/*  7414*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7415*/      OPC_CheckFoldableChainNode,
/*  7416*/      OPC_MoveChild1,
/*  7417*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7420*/      OPC_MoveChild0,
/*  7421*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7424*/      OPC_RecordChild0, // #1 = $off
/*  7425*/      OPC_MoveChild0,
/*  7426*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7429*/      OPC_MoveParent,
/*  7430*/      OPC_MoveParent,
/*  7431*/      OPC_RecordChild1, // #2 = $addr
/*  7432*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7434*/      OPC_CheckType, MVT::i32,
/*  7436*/      OPC_MoveParent,
/*  7437*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  7439*/      OPC_MoveParent,
/*  7440*/      OPC_CheckType, MVT::i32,
/*  7442*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7444*/      OPC_EmitMergeInputChains1_0,
/*  7445*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7448*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  7457*/    /*Scope*/ 52, /*->7510*/
/*  7458*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7462*/      OPC_MoveChild0,
/*  7463*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  7466*/      OPC_RecordMemRef,
/*  7467*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7468*/      OPC_CheckFoldableChainNode,
/*  7469*/      OPC_MoveChild1,
/*  7470*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7473*/      OPC_MoveChild0,
/*  7474*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7477*/      OPC_RecordChild0, // #1 = $off
/*  7478*/      OPC_MoveChild0,
/*  7479*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7482*/      OPC_MoveParent,
/*  7483*/      OPC_MoveParent,
/*  7484*/      OPC_RecordChild1, // #2 = $addr
/*  7485*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7487*/      OPC_CheckType, MVT::i32,
/*  7489*/      OPC_MoveParent,
/*  7490*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  7492*/      OPC_MoveParent,
/*  7493*/      OPC_CheckType, MVT::i32,
/*  7495*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7497*/      OPC_EmitMergeInputChains1_0,
/*  7498*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7501*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  7510*/    /*Scope*/ 53, /*->7564*/
/*  7511*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7514*/      OPC_MoveChild0,
/*  7515*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  7518*/      OPC_RecordMemRef,
/*  7519*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7520*/      OPC_CheckFoldableChainNode,
/*  7521*/      OPC_MoveChild1,
/*  7522*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7525*/      OPC_MoveChild0,
/*  7526*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7529*/      OPC_RecordChild0, // #1 = $off
/*  7530*/      OPC_MoveChild0,
/*  7531*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7534*/      OPC_MoveParent,
/*  7535*/      OPC_MoveParent,
/*  7536*/      OPC_RecordChild1, // #2 = $addr
/*  7537*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7539*/      OPC_CheckType, MVT::i32,
/*  7541*/      OPC_MoveParent,
/*  7542*/      OPC_RecordChild2, // #3 = $val
/*  7543*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  7545*/      OPC_MoveParent,
/*  7546*/      OPC_CheckType, MVT::i32,
/*  7548*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7550*/      OPC_EmitMergeInputChains1_0,
/*  7551*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7554*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7564*/    /*Scope*/ 54, /*->7619*/
/*  7565*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7569*/      OPC_MoveChild0,
/*  7570*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  7573*/      OPC_RecordMemRef,
/*  7574*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7575*/      OPC_CheckFoldableChainNode,
/*  7576*/      OPC_MoveChild1,
/*  7577*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7580*/      OPC_MoveChild0,
/*  7581*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7584*/      OPC_RecordChild0, // #1 = $off
/*  7585*/      OPC_MoveChild0,
/*  7586*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7589*/      OPC_MoveParent,
/*  7590*/      OPC_MoveParent,
/*  7591*/      OPC_RecordChild1, // #2 = $addr
/*  7592*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7594*/      OPC_CheckType, MVT::i32,
/*  7596*/      OPC_MoveParent,
/*  7597*/      OPC_RecordChild2, // #3 = $val
/*  7598*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  7600*/      OPC_MoveParent,
/*  7601*/      OPC_CheckType, MVT::i32,
/*  7603*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7605*/      OPC_EmitMergeInputChains1_0,
/*  7606*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7609*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7619*/    /*Scope*/ 53, /*->7673*/
/*  7620*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7623*/      OPC_MoveChild0,
/*  7624*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  7627*/      OPC_RecordMemRef,
/*  7628*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7629*/      OPC_CheckFoldableChainNode,
/*  7630*/      OPC_MoveChild1,
/*  7631*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7634*/      OPC_MoveChild0,
/*  7635*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7638*/      OPC_RecordChild0, // #1 = $off
/*  7639*/      OPC_MoveChild0,
/*  7640*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7643*/      OPC_MoveParent,
/*  7644*/      OPC_MoveParent,
/*  7645*/      OPC_RecordChild1, // #2 = $addr
/*  7646*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7648*/      OPC_CheckType, MVT::i32,
/*  7650*/      OPC_MoveParent,
/*  7651*/      OPC_RecordChild2, // #3 = $val
/*  7652*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  7654*/      OPC_MoveParent,
/*  7655*/      OPC_CheckType, MVT::i32,
/*  7657*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7659*/      OPC_EmitMergeInputChains1_0,
/*  7660*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7663*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7673*/    /*Scope*/ 54, /*->7728*/
/*  7674*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7678*/      OPC_MoveChild0,
/*  7679*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  7682*/      OPC_RecordMemRef,
/*  7683*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7684*/      OPC_CheckFoldableChainNode,
/*  7685*/      OPC_MoveChild1,
/*  7686*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7689*/      OPC_MoveChild0,
/*  7690*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7693*/      OPC_RecordChild0, // #1 = $off
/*  7694*/      OPC_MoveChild0,
/*  7695*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7698*/      OPC_MoveParent,
/*  7699*/      OPC_MoveParent,
/*  7700*/      OPC_RecordChild1, // #2 = $addr
/*  7701*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7703*/      OPC_CheckType, MVT::i32,
/*  7705*/      OPC_MoveParent,
/*  7706*/      OPC_RecordChild2, // #3 = $val
/*  7707*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  7709*/      OPC_MoveParent,
/*  7710*/      OPC_CheckType, MVT::i32,
/*  7712*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7714*/      OPC_EmitMergeInputChains1_0,
/*  7715*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7718*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7728*/    /*Scope*/ 53, /*->7782*/
/*  7729*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7732*/      OPC_MoveChild0,
/*  7733*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  7736*/      OPC_RecordMemRef,
/*  7737*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  7738*/      OPC_CheckFoldableChainNode,
/*  7739*/      OPC_MoveChild1,
/*  7740*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7743*/      OPC_MoveChild0,
/*  7744*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7747*/      OPC_RecordChild0, // #1 = $off
/*  7748*/      OPC_MoveChild0,
/*  7749*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7752*/      OPC_MoveParent,
/*  7753*/      OPC_MoveParent,
/*  7754*/      OPC_RecordChild1, // #2 = $addr
/*  7755*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7757*/      OPC_CheckType, MVT::i32,
/*  7759*/      OPC_MoveParent,
/*  7760*/      OPC_RecordChild2, // #3 = $val
/*  7761*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  7763*/      OPC_MoveParent,
/*  7764*/      OPC_CheckType, MVT::i32,
/*  7766*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7768*/      OPC_EmitMergeInputChains1_0,
/*  7769*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7772*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7782*/    /*Scope*/ 54, /*->7837*/
/*  7783*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7787*/      OPC_MoveChild0,
/*  7788*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  7791*/      OPC_RecordMemRef,
/*  7792*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  7793*/      OPC_CheckFoldableChainNode,
/*  7794*/      OPC_MoveChild1,
/*  7795*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7798*/      OPC_MoveChild0,
/*  7799*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7802*/      OPC_RecordChild0, // #1 = $off
/*  7803*/      OPC_MoveChild0,
/*  7804*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7807*/      OPC_MoveParent,
/*  7808*/      OPC_MoveParent,
/*  7809*/      OPC_RecordChild1, // #2 = $addr
/*  7810*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7812*/      OPC_CheckType, MVT::i32,
/*  7814*/      OPC_MoveParent,
/*  7815*/      OPC_RecordChild2, // #3 = $val
/*  7816*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  7818*/      OPC_MoveParent,
/*  7819*/      OPC_CheckType, MVT::i32,
/*  7821*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7823*/      OPC_EmitMergeInputChains1_0,
/*  7824*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7827*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7837*/    /*Scope*/ 53, /*->7891*/
/*  7838*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7841*/      OPC_MoveChild0,
/*  7842*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  7845*/      OPC_RecordMemRef,
/*  7846*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  7847*/      OPC_CheckFoldableChainNode,
/*  7848*/      OPC_MoveChild1,
/*  7849*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7852*/      OPC_MoveChild0,
/*  7853*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7856*/      OPC_RecordChild0, // #1 = $off
/*  7857*/      OPC_MoveChild0,
/*  7858*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7861*/      OPC_MoveParent,
/*  7862*/      OPC_MoveParent,
/*  7863*/      OPC_RecordChild1, // #2 = $addr
/*  7864*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7866*/      OPC_CheckType, MVT::i32,
/*  7868*/      OPC_MoveParent,
/*  7869*/      OPC_RecordChild2, // #3 = $val
/*  7870*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  7872*/      OPC_MoveParent,
/*  7873*/      OPC_CheckType, MVT::i32,
/*  7875*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7877*/      OPC_EmitMergeInputChains1_0,
/*  7878*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7881*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7891*/    /*Scope*/ 54, /*->7946*/
/*  7892*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  7896*/      OPC_MoveChild0,
/*  7897*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  7900*/      OPC_RecordMemRef,
/*  7901*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  7902*/      OPC_CheckFoldableChainNode,
/*  7903*/      OPC_MoveChild1,
/*  7904*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7907*/      OPC_MoveChild0,
/*  7908*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7911*/      OPC_RecordChild0, // #1 = $off
/*  7912*/      OPC_MoveChild0,
/*  7913*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7916*/      OPC_MoveParent,
/*  7917*/      OPC_MoveParent,
/*  7918*/      OPC_RecordChild1, // #2 = $addr
/*  7919*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7921*/      OPC_CheckType, MVT::i32,
/*  7923*/      OPC_MoveParent,
/*  7924*/      OPC_RecordChild2, // #3 = $val
/*  7925*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  7927*/      OPC_MoveParent,
/*  7928*/      OPC_CheckType, MVT::i32,
/*  7930*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7932*/      OPC_EmitMergeInputChains1_0,
/*  7933*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7936*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  7946*/    /*Scope*/ 53, /*->8000*/
/*  7947*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  7950*/      OPC_MoveChild0,
/*  7951*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  7954*/      OPC_RecordMemRef,
/*  7955*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  7956*/      OPC_CheckFoldableChainNode,
/*  7957*/      OPC_MoveChild1,
/*  7958*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  7961*/      OPC_MoveChild0,
/*  7962*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  7965*/      OPC_RecordChild0, // #1 = $off
/*  7966*/      OPC_MoveChild0,
/*  7967*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  7970*/      OPC_MoveParent,
/*  7971*/      OPC_MoveParent,
/*  7972*/      OPC_RecordChild1, // #2 = $addr
/*  7973*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  7975*/      OPC_CheckType, MVT::i32,
/*  7977*/      OPC_MoveParent,
/*  7978*/      OPC_RecordChild2, // #3 = $val
/*  7979*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  7981*/      OPC_MoveParent,
/*  7982*/      OPC_CheckType, MVT::i32,
/*  7984*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  7986*/      OPC_EmitMergeInputChains1_0,
/*  7987*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7990*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8000*/    /*Scope*/ 54, /*->8055*/
/*  8001*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8005*/      OPC_MoveChild0,
/*  8006*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  8009*/      OPC_RecordMemRef,
/*  8010*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8011*/      OPC_CheckFoldableChainNode,
/*  8012*/      OPC_MoveChild1,
/*  8013*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8016*/      OPC_MoveChild0,
/*  8017*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8020*/      OPC_RecordChild0, // #1 = $off
/*  8021*/      OPC_MoveChild0,
/*  8022*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  8025*/      OPC_MoveParent,
/*  8026*/      OPC_MoveParent,
/*  8027*/      OPC_RecordChild1, // #2 = $addr
/*  8028*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  8030*/      OPC_CheckType, MVT::i32,
/*  8032*/      OPC_MoveParent,
/*  8033*/      OPC_RecordChild2, // #3 = $val
/*  8034*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  8036*/      OPC_MoveParent,
/*  8037*/      OPC_CheckType, MVT::i32,
/*  8039*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8041*/      OPC_EmitMergeInputChains1_0,
/*  8042*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8045*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8055*/    /*Scope*/ 53, /*->8109*/
/*  8056*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8059*/      OPC_MoveChild0,
/*  8060*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  8063*/      OPC_RecordMemRef,
/*  8064*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8065*/      OPC_CheckFoldableChainNode,
/*  8066*/      OPC_MoveChild1,
/*  8067*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8070*/      OPC_MoveChild0,
/*  8071*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8074*/      OPC_RecordChild0, // #1 = $off
/*  8075*/      OPC_MoveChild0,
/*  8076*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  8079*/      OPC_MoveParent,
/*  8080*/      OPC_MoveParent,
/*  8081*/      OPC_RecordChild1, // #2 = $addr
/*  8082*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  8084*/      OPC_CheckType, MVT::i32,
/*  8086*/      OPC_MoveParent,
/*  8087*/      OPC_RecordChild2, // #3 = $val
/*  8088*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  8090*/      OPC_MoveParent,
/*  8091*/      OPC_CheckType, MVT::i32,
/*  8093*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8095*/      OPC_EmitMergeInputChains1_0,
/*  8096*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8099*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8109*/    /*Scope*/ 54, /*->8164*/
/*  8110*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8114*/      OPC_MoveChild0,
/*  8115*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  8118*/      OPC_RecordMemRef,
/*  8119*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8120*/      OPC_CheckFoldableChainNode,
/*  8121*/      OPC_MoveChild1,
/*  8122*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8125*/      OPC_MoveChild0,
/*  8126*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8129*/      OPC_RecordChild0, // #1 = $off
/*  8130*/      OPC_MoveChild0,
/*  8131*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  8134*/      OPC_MoveParent,
/*  8135*/      OPC_MoveParent,
/*  8136*/      OPC_RecordChild1, // #2 = $addr
/*  8137*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  8139*/      OPC_CheckType, MVT::i32,
/*  8141*/      OPC_MoveParent,
/*  8142*/      OPC_RecordChild2, // #3 = $val
/*  8143*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  8145*/      OPC_MoveParent,
/*  8146*/      OPC_CheckType, MVT::i32,
/*  8148*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8150*/      OPC_EmitMergeInputChains1_0,
/*  8151*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8154*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8164*/    /*Scope*/ 55, /*->8220*/
/*  8165*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8168*/      OPC_MoveChild0,
/*  8169*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  8172*/      OPC_RecordMemRef,
/*  8173*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  8174*/      OPC_CheckFoldableChainNode,
/*  8175*/      OPC_MoveChild1,
/*  8176*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8179*/      OPC_MoveChild0,
/*  8180*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8183*/      OPC_RecordChild0, // #1 = $off
/*  8184*/      OPC_MoveChild0,
/*  8185*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  8188*/      OPC_MoveParent,
/*  8189*/      OPC_MoveParent,
/*  8190*/      OPC_RecordChild1, // #2 = $addr
/*  8191*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  8193*/      OPC_CheckType, MVT::i32,
/*  8195*/      OPC_MoveParent,
/*  8196*/      OPC_RecordChild2, // #3 = $exp
/*  8197*/      OPC_RecordChild3, // #4 = $new
/*  8198*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  8200*/      OPC_MoveParent,
/*  8201*/      OPC_CheckType, MVT::i32,
/*  8203*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8205*/      OPC_EmitMergeInputChains1_0,
/*  8206*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8209*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  8220*/    /*Scope*/ 56, /*->8277*/
/*  8221*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8225*/      OPC_MoveChild0,
/*  8226*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  8229*/      OPC_RecordMemRef,
/*  8230*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  8231*/      OPC_CheckFoldableChainNode,
/*  8232*/      OPC_MoveChild1,
/*  8233*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8236*/      OPC_MoveChild0,
/*  8237*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8240*/      OPC_RecordChild0, // #1 = $off
/*  8241*/      OPC_MoveChild0,
/*  8242*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  8245*/      OPC_MoveParent,
/*  8246*/      OPC_MoveParent,
/*  8247*/      OPC_RecordChild1, // #2 = $addr
/*  8248*/      OPC_CheckPredicate, 0, // Predicate_regPlusGA
/*  8250*/      OPC_CheckType, MVT::i32,
/*  8252*/      OPC_MoveParent,
/*  8253*/      OPC_RecordChild2, // #3 = $exp
/*  8254*/      OPC_RecordChild3, // #4 = $new
/*  8255*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  8257*/      OPC_MoveParent,
/*  8258*/      OPC_CheckType, MVT::i32,
/*  8260*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8262*/      OPC_EmitMergeInputChains1_0,
/*  8263*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8266*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 22
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  8277*/    /*Scope*/ 49, /*->8327*/
/*  8278*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8281*/      OPC_MoveChild0,
/*  8282*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  8285*/      OPC_RecordMemRef,
/*  8286*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  8287*/      OPC_CheckFoldableChainNode,
/*  8288*/      OPC_MoveChild1,
/*  8289*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8292*/      OPC_RecordChild0, // #1 = $addr
/*  8293*/      OPC_MoveChild1,
/*  8294*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8297*/      OPC_RecordChild0, // #2 = $off
/*  8298*/      OPC_MoveChild0,
/*  8299*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8302*/      OPC_MoveParent,
/*  8303*/      OPC_MoveParent,
/*  8304*/      OPC_CheckType, MVT::i32,
/*  8306*/      OPC_MoveParent,
/*  8307*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  8309*/      OPC_MoveParent,
/*  8310*/      OPC_CheckType, MVT::i32,
/*  8312*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8314*/      OPC_EmitMergeInputChains1_0,
/*  8315*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8318*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  8327*/    /*Scope*/ 50, /*->8378*/
/*  8328*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8332*/      OPC_MoveChild0,
/*  8333*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  8336*/      OPC_RecordMemRef,
/*  8337*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  8338*/      OPC_CheckFoldableChainNode,
/*  8339*/      OPC_MoveChild1,
/*  8340*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8343*/      OPC_RecordChild0, // #1 = $addr
/*  8344*/      OPC_MoveChild1,
/*  8345*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8348*/      OPC_RecordChild0, // #2 = $off
/*  8349*/      OPC_MoveChild0,
/*  8350*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8353*/      OPC_MoveParent,
/*  8354*/      OPC_MoveParent,
/*  8355*/      OPC_CheckType, MVT::i32,
/*  8357*/      OPC_MoveParent,
/*  8358*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  8360*/      OPC_MoveParent,
/*  8361*/      OPC_CheckType, MVT::i32,
/*  8363*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8365*/      OPC_EmitMergeInputChains1_0,
/*  8366*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8369*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  8378*/    /*Scope*/ 51, /*->8430*/
/*  8379*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8382*/      OPC_MoveChild0,
/*  8383*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  8386*/      OPC_RecordMemRef,
/*  8387*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  8388*/      OPC_CheckFoldableChainNode,
/*  8389*/      OPC_MoveChild1,
/*  8390*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8393*/      OPC_RecordChild0, // #1 = $addr
/*  8394*/      OPC_MoveChild1,
/*  8395*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8398*/      OPC_RecordChild0, // #2 = $off
/*  8399*/      OPC_MoveChild0,
/*  8400*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8403*/      OPC_MoveParent,
/*  8404*/      OPC_MoveParent,
/*  8405*/      OPC_CheckType, MVT::i32,
/*  8407*/      OPC_MoveParent,
/*  8408*/      OPC_RecordChild2, // #3 = $val
/*  8409*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  8411*/      OPC_MoveParent,
/*  8412*/      OPC_CheckType, MVT::i32,
/*  8414*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8416*/      OPC_EmitMergeInputChains1_0,
/*  8417*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8420*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8430*/    /*Scope*/ 52, /*->8483*/
/*  8431*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8435*/      OPC_MoveChild0,
/*  8436*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  8439*/      OPC_RecordMemRef,
/*  8440*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  8441*/      OPC_CheckFoldableChainNode,
/*  8442*/      OPC_MoveChild1,
/*  8443*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8446*/      OPC_RecordChild0, // #1 = $addr
/*  8447*/      OPC_MoveChild1,
/*  8448*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8451*/      OPC_RecordChild0, // #2 = $off
/*  8452*/      OPC_MoveChild0,
/*  8453*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8456*/      OPC_MoveParent,
/*  8457*/      OPC_MoveParent,
/*  8458*/      OPC_CheckType, MVT::i32,
/*  8460*/      OPC_MoveParent,
/*  8461*/      OPC_RecordChild2, // #3 = $val
/*  8462*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  8464*/      OPC_MoveParent,
/*  8465*/      OPC_CheckType, MVT::i32,
/*  8467*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8469*/      OPC_EmitMergeInputChains1_0,
/*  8470*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8473*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8483*/    /*Scope*/ 51, /*->8535*/
/*  8484*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8487*/      OPC_MoveChild0,
/*  8488*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  8491*/      OPC_RecordMemRef,
/*  8492*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  8493*/      OPC_CheckFoldableChainNode,
/*  8494*/      OPC_MoveChild1,
/*  8495*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8498*/      OPC_RecordChild0, // #1 = $addr
/*  8499*/      OPC_MoveChild1,
/*  8500*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8503*/      OPC_RecordChild0, // #2 = $off
/*  8504*/      OPC_MoveChild0,
/*  8505*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8508*/      OPC_MoveParent,
/*  8509*/      OPC_MoveParent,
/*  8510*/      OPC_CheckType, MVT::i32,
/*  8512*/      OPC_MoveParent,
/*  8513*/      OPC_RecordChild2, // #3 = $val
/*  8514*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  8516*/      OPC_MoveParent,
/*  8517*/      OPC_CheckType, MVT::i32,
/*  8519*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8521*/      OPC_EmitMergeInputChains1_0,
/*  8522*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8525*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8535*/    /*Scope*/ 52, /*->8588*/
/*  8536*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8540*/      OPC_MoveChild0,
/*  8541*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  8544*/      OPC_RecordMemRef,
/*  8545*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  8546*/      OPC_CheckFoldableChainNode,
/*  8547*/      OPC_MoveChild1,
/*  8548*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8551*/      OPC_RecordChild0, // #1 = $addr
/*  8552*/      OPC_MoveChild1,
/*  8553*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8556*/      OPC_RecordChild0, // #2 = $off
/*  8557*/      OPC_MoveChild0,
/*  8558*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8561*/      OPC_MoveParent,
/*  8562*/      OPC_MoveParent,
/*  8563*/      OPC_CheckType, MVT::i32,
/*  8565*/      OPC_MoveParent,
/*  8566*/      OPC_RecordChild2, // #3 = $val
/*  8567*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  8569*/      OPC_MoveParent,
/*  8570*/      OPC_CheckType, MVT::i32,
/*  8572*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8574*/      OPC_EmitMergeInputChains1_0,
/*  8575*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8578*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8588*/    /*Scope*/ 51, /*->8640*/
/*  8589*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8592*/      OPC_MoveChild0,
/*  8593*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  8596*/      OPC_RecordMemRef,
/*  8597*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8598*/      OPC_CheckFoldableChainNode,
/*  8599*/      OPC_MoveChild1,
/*  8600*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8603*/      OPC_RecordChild0, // #1 = $addr
/*  8604*/      OPC_MoveChild1,
/*  8605*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8608*/      OPC_RecordChild0, // #2 = $off
/*  8609*/      OPC_MoveChild0,
/*  8610*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8613*/      OPC_MoveParent,
/*  8614*/      OPC_MoveParent,
/*  8615*/      OPC_CheckType, MVT::i32,
/*  8617*/      OPC_MoveParent,
/*  8618*/      OPC_RecordChild2, // #3 = $val
/*  8619*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  8621*/      OPC_MoveParent,
/*  8622*/      OPC_CheckType, MVT::i32,
/*  8624*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8626*/      OPC_EmitMergeInputChains1_0,
/*  8627*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8630*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8640*/    /*Scope*/ 52, /*->8693*/
/*  8641*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8645*/      OPC_MoveChild0,
/*  8646*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  8649*/      OPC_RecordMemRef,
/*  8650*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8651*/      OPC_CheckFoldableChainNode,
/*  8652*/      OPC_MoveChild1,
/*  8653*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8656*/      OPC_RecordChild0, // #1 = $addr
/*  8657*/      OPC_MoveChild1,
/*  8658*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8661*/      OPC_RecordChild0, // #2 = $off
/*  8662*/      OPC_MoveChild0,
/*  8663*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8666*/      OPC_MoveParent,
/*  8667*/      OPC_MoveParent,
/*  8668*/      OPC_CheckType, MVT::i32,
/*  8670*/      OPC_MoveParent,
/*  8671*/      OPC_RecordChild2, // #3 = $val
/*  8672*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  8674*/      OPC_MoveParent,
/*  8675*/      OPC_CheckType, MVT::i32,
/*  8677*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8679*/      OPC_EmitMergeInputChains1_0,
/*  8680*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8693*/    /*Scope*/ 51, /*->8745*/
/*  8694*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8697*/      OPC_MoveChild0,
/*  8698*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  8701*/      OPC_RecordMemRef,
/*  8702*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8703*/      OPC_CheckFoldableChainNode,
/*  8704*/      OPC_MoveChild1,
/*  8705*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8708*/      OPC_RecordChild0, // #1 = $addr
/*  8709*/      OPC_MoveChild1,
/*  8710*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8713*/      OPC_RecordChild0, // #2 = $off
/*  8714*/      OPC_MoveChild0,
/*  8715*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8718*/      OPC_MoveParent,
/*  8719*/      OPC_MoveParent,
/*  8720*/      OPC_CheckType, MVT::i32,
/*  8722*/      OPC_MoveParent,
/*  8723*/      OPC_RecordChild2, // #3 = $val
/*  8724*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  8726*/      OPC_MoveParent,
/*  8727*/      OPC_CheckType, MVT::i32,
/*  8729*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8731*/      OPC_EmitMergeInputChains1_0,
/*  8732*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8735*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8745*/    /*Scope*/ 52, /*->8798*/
/*  8746*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8750*/      OPC_MoveChild0,
/*  8751*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  8754*/      OPC_RecordMemRef,
/*  8755*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8756*/      OPC_CheckFoldableChainNode,
/*  8757*/      OPC_MoveChild1,
/*  8758*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8761*/      OPC_RecordChild0, // #1 = $addr
/*  8762*/      OPC_MoveChild1,
/*  8763*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8766*/      OPC_RecordChild0, // #2 = $off
/*  8767*/      OPC_MoveChild0,
/*  8768*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8771*/      OPC_MoveParent,
/*  8772*/      OPC_MoveParent,
/*  8773*/      OPC_CheckType, MVT::i32,
/*  8775*/      OPC_MoveParent,
/*  8776*/      OPC_RecordChild2, // #3 = $val
/*  8777*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  8779*/      OPC_MoveParent,
/*  8780*/      OPC_CheckType, MVT::i32,
/*  8782*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8784*/      OPC_EmitMergeInputChains1_0,
/*  8785*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8788*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8798*/    /*Scope*/ 51, /*->8850*/
/*  8799*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8802*/      OPC_MoveChild0,
/*  8803*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  8806*/      OPC_RecordMemRef,
/*  8807*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8808*/      OPC_CheckFoldableChainNode,
/*  8809*/      OPC_MoveChild1,
/*  8810*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8813*/      OPC_RecordChild0, // #1 = $addr
/*  8814*/      OPC_MoveChild1,
/*  8815*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8818*/      OPC_RecordChild0, // #2 = $off
/*  8819*/      OPC_MoveChild0,
/*  8820*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8823*/      OPC_MoveParent,
/*  8824*/      OPC_MoveParent,
/*  8825*/      OPC_CheckType, MVT::i32,
/*  8827*/      OPC_MoveParent,
/*  8828*/      OPC_RecordChild2, // #3 = $val
/*  8829*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  8831*/      OPC_MoveParent,
/*  8832*/      OPC_CheckType, MVT::i32,
/*  8834*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8836*/      OPC_EmitMergeInputChains1_0,
/*  8837*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8840*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8850*/    /*Scope*/ 52, /*->8903*/
/*  8851*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8855*/      OPC_MoveChild0,
/*  8856*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  8859*/      OPC_RecordMemRef,
/*  8860*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8861*/      OPC_CheckFoldableChainNode,
/*  8862*/      OPC_MoveChild1,
/*  8863*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8866*/      OPC_RecordChild0, // #1 = $addr
/*  8867*/      OPC_MoveChild1,
/*  8868*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8871*/      OPC_RecordChild0, // #2 = $off
/*  8872*/      OPC_MoveChild0,
/*  8873*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8876*/      OPC_MoveParent,
/*  8877*/      OPC_MoveParent,
/*  8878*/      OPC_CheckType, MVT::i32,
/*  8880*/      OPC_MoveParent,
/*  8881*/      OPC_RecordChild2, // #3 = $val
/*  8882*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  8884*/      OPC_MoveParent,
/*  8885*/      OPC_CheckType, MVT::i32,
/*  8887*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8889*/      OPC_EmitMergeInputChains1_0,
/*  8890*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8903*/    /*Scope*/ 51, /*->8955*/
/*  8904*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  8907*/      OPC_MoveChild0,
/*  8908*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  8911*/      OPC_RecordMemRef,
/*  8912*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8913*/      OPC_CheckFoldableChainNode,
/*  8914*/      OPC_MoveChild1,
/*  8915*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8918*/      OPC_RecordChild0, // #1 = $addr
/*  8919*/      OPC_MoveChild1,
/*  8920*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8923*/      OPC_RecordChild0, // #2 = $off
/*  8924*/      OPC_MoveChild0,
/*  8925*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8928*/      OPC_MoveParent,
/*  8929*/      OPC_MoveParent,
/*  8930*/      OPC_CheckType, MVT::i32,
/*  8932*/      OPC_MoveParent,
/*  8933*/      OPC_RecordChild2, // #3 = $val
/*  8934*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  8936*/      OPC_MoveParent,
/*  8937*/      OPC_CheckType, MVT::i32,
/*  8939*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8941*/      OPC_EmitMergeInputChains1_0,
/*  8942*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8945*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  8955*/    /*Scope*/ 52, /*->9008*/
/*  8956*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  8960*/      OPC_MoveChild0,
/*  8961*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  8964*/      OPC_RecordMemRef,
/*  8965*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8966*/      OPC_CheckFoldableChainNode,
/*  8967*/      OPC_MoveChild1,
/*  8968*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  8971*/      OPC_RecordChild0, // #1 = $addr
/*  8972*/      OPC_MoveChild1,
/*  8973*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  8976*/      OPC_RecordChild0, // #2 = $off
/*  8977*/      OPC_MoveChild0,
/*  8978*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  8981*/      OPC_MoveParent,
/*  8982*/      OPC_MoveParent,
/*  8983*/      OPC_CheckType, MVT::i32,
/*  8985*/      OPC_MoveParent,
/*  8986*/      OPC_RecordChild2, // #3 = $val
/*  8987*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  8989*/      OPC_MoveParent,
/*  8990*/      OPC_CheckType, MVT::i32,
/*  8992*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  8994*/      OPC_EmitMergeInputChains1_0,
/*  8995*/      OPC_EmitInteger, MVT::i32, 0, 
/*  8998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9008*/    /*Scope*/ 53, /*->9062*/
/*  9009*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9012*/      OPC_MoveChild0,
/*  9013*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  9016*/      OPC_RecordMemRef,
/*  9017*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9018*/      OPC_CheckFoldableChainNode,
/*  9019*/      OPC_MoveChild1,
/*  9020*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9023*/      OPC_RecordChild0, // #1 = $addr
/*  9024*/      OPC_MoveChild1,
/*  9025*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9028*/      OPC_RecordChild0, // #2 = $off
/*  9029*/      OPC_MoveChild0,
/*  9030*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9033*/      OPC_MoveParent,
/*  9034*/      OPC_MoveParent,
/*  9035*/      OPC_CheckType, MVT::i32,
/*  9037*/      OPC_MoveParent,
/*  9038*/      OPC_RecordChild2, // #3 = $exp
/*  9039*/      OPC_RecordChild3, // #4 = $new
/*  9040*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  9042*/      OPC_MoveParent,
/*  9043*/      OPC_CheckType, MVT::i32,
/*  9045*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9047*/      OPC_EmitMergeInputChains1_0,
/*  9048*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9051*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  9062*/    /*Scope*/ 54, /*->9117*/
/*  9063*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9067*/      OPC_MoveChild0,
/*  9068*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  9071*/      OPC_RecordMemRef,
/*  9072*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9073*/      OPC_CheckFoldableChainNode,
/*  9074*/      OPC_MoveChild1,
/*  9075*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9078*/      OPC_RecordChild0, // #1 = $addr
/*  9079*/      OPC_MoveChild1,
/*  9080*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9083*/      OPC_RecordChild0, // #2 = $off
/*  9084*/      OPC_MoveChild0,
/*  9085*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9088*/      OPC_MoveParent,
/*  9089*/      OPC_MoveParent,
/*  9090*/      OPC_CheckType, MVT::i32,
/*  9092*/      OPC_MoveParent,
/*  9093*/      OPC_RecordChild2, // #3 = $exp
/*  9094*/      OPC_RecordChild3, // #4 = $new
/*  9095*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  9097*/      OPC_MoveParent,
/*  9098*/      OPC_CheckType, MVT::i32,
/*  9100*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9102*/      OPC_EmitMergeInputChains1_0,
/*  9103*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9106*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  9117*/    /*Scope*/ 49, /*->9167*/
/*  9118*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9121*/      OPC_MoveChild0,
/*  9122*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  9125*/      OPC_RecordMemRef,
/*  9126*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  9127*/      OPC_CheckFoldableChainNode,
/*  9128*/      OPC_MoveChild1,
/*  9129*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9132*/      OPC_MoveChild0,
/*  9133*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9136*/      OPC_RecordChild0, // #1 = $off
/*  9137*/      OPC_MoveChild0,
/*  9138*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9141*/      OPC_MoveParent,
/*  9142*/      OPC_MoveParent,
/*  9143*/      OPC_RecordChild1, // #2 = $addr
/*  9144*/      OPC_CheckType, MVT::i32,
/*  9146*/      OPC_MoveParent,
/*  9147*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  9149*/      OPC_MoveParent,
/*  9150*/      OPC_CheckType, MVT::i32,
/*  9152*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9154*/      OPC_EmitMergeInputChains1_0,
/*  9155*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9158*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  9167*/    /*Scope*/ 50, /*->9218*/
/*  9168*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9172*/      OPC_MoveChild0,
/*  9173*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  9176*/      OPC_RecordMemRef,
/*  9177*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  9178*/      OPC_CheckFoldableChainNode,
/*  9179*/      OPC_MoveChild1,
/*  9180*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9183*/      OPC_MoveChild0,
/*  9184*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9187*/      OPC_RecordChild0, // #1 = $off
/*  9188*/      OPC_MoveChild0,
/*  9189*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9192*/      OPC_MoveParent,
/*  9193*/      OPC_MoveParent,
/*  9194*/      OPC_RecordChild1, // #2 = $addr
/*  9195*/      OPC_CheckType, MVT::i32,
/*  9197*/      OPC_MoveParent,
/*  9198*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/*  9200*/      OPC_MoveParent,
/*  9201*/      OPC_CheckType, MVT::i32,
/*  9203*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9205*/      OPC_EmitMergeInputChains1_0,
/*  9206*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9209*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/*  9218*/    /*Scope*/ 51, /*->9270*/
/*  9219*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9222*/      OPC_MoveChild0,
/*  9223*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  9226*/      OPC_RecordMemRef,
/*  9227*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  9228*/      OPC_CheckFoldableChainNode,
/*  9229*/      OPC_MoveChild1,
/*  9230*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9233*/      OPC_MoveChild0,
/*  9234*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9237*/      OPC_RecordChild0, // #1 = $off
/*  9238*/      OPC_MoveChild0,
/*  9239*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9242*/      OPC_MoveParent,
/*  9243*/      OPC_MoveParent,
/*  9244*/      OPC_RecordChild1, // #2 = $addr
/*  9245*/      OPC_CheckType, MVT::i32,
/*  9247*/      OPC_MoveParent,
/*  9248*/      OPC_RecordChild2, // #3 = $val
/*  9249*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/*  9251*/      OPC_MoveParent,
/*  9252*/      OPC_CheckType, MVT::i32,
/*  9254*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9256*/      OPC_EmitMergeInputChains1_0,
/*  9257*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9260*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9270*/    /*Scope*/ 52, /*->9323*/
/*  9271*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9275*/      OPC_MoveChild0,
/*  9276*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/*  9279*/      OPC_RecordMemRef,
/*  9280*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  9281*/      OPC_CheckFoldableChainNode,
/*  9282*/      OPC_MoveChild1,
/*  9283*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9286*/      OPC_MoveChild0,
/*  9287*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9290*/      OPC_RecordChild0, // #1 = $off
/*  9291*/      OPC_MoveChild0,
/*  9292*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9295*/      OPC_MoveParent,
/*  9296*/      OPC_MoveParent,
/*  9297*/      OPC_RecordChild1, // #2 = $addr
/*  9298*/      OPC_CheckType, MVT::i32,
/*  9300*/      OPC_MoveParent,
/*  9301*/      OPC_RecordChild2, // #3 = $val
/*  9302*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/*  9304*/      OPC_MoveParent,
/*  9305*/      OPC_CheckType, MVT::i32,
/*  9307*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9309*/      OPC_EmitMergeInputChains1_0,
/*  9310*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9313*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9323*/    /*Scope*/ 51, /*->9375*/
/*  9324*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9327*/      OPC_MoveChild0,
/*  9328*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  9331*/      OPC_RecordMemRef,
/*  9332*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  9333*/      OPC_CheckFoldableChainNode,
/*  9334*/      OPC_MoveChild1,
/*  9335*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9338*/      OPC_MoveChild0,
/*  9339*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9342*/      OPC_RecordChild0, // #1 = $off
/*  9343*/      OPC_MoveChild0,
/*  9344*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9347*/      OPC_MoveParent,
/*  9348*/      OPC_MoveParent,
/*  9349*/      OPC_RecordChild1, // #2 = $addr
/*  9350*/      OPC_CheckType, MVT::i32,
/*  9352*/      OPC_MoveParent,
/*  9353*/      OPC_RecordChild2, // #3 = $val
/*  9354*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/*  9356*/      OPC_MoveParent,
/*  9357*/      OPC_CheckType, MVT::i32,
/*  9359*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9361*/      OPC_EmitMergeInputChains1_0,
/*  9362*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9365*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9375*/    /*Scope*/ 52, /*->9428*/
/*  9376*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9380*/      OPC_MoveChild0,
/*  9381*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/*  9384*/      OPC_RecordMemRef,
/*  9385*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  9386*/      OPC_CheckFoldableChainNode,
/*  9387*/      OPC_MoveChild1,
/*  9388*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9391*/      OPC_MoveChild0,
/*  9392*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9395*/      OPC_RecordChild0, // #1 = $off
/*  9396*/      OPC_MoveChild0,
/*  9397*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9400*/      OPC_MoveParent,
/*  9401*/      OPC_MoveParent,
/*  9402*/      OPC_RecordChild1, // #2 = $addr
/*  9403*/      OPC_CheckType, MVT::i32,
/*  9405*/      OPC_MoveParent,
/*  9406*/      OPC_RecordChild2, // #3 = $val
/*  9407*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/*  9409*/      OPC_MoveParent,
/*  9410*/      OPC_CheckType, MVT::i32,
/*  9412*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9414*/      OPC_EmitMergeInputChains1_0,
/*  9415*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9418*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9428*/    /*Scope*/ 51, /*->9480*/
/*  9429*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9432*/      OPC_MoveChild0,
/*  9433*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  9436*/      OPC_RecordMemRef,
/*  9437*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  9438*/      OPC_CheckFoldableChainNode,
/*  9439*/      OPC_MoveChild1,
/*  9440*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9443*/      OPC_MoveChild0,
/*  9444*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9447*/      OPC_RecordChild0, // #1 = $off
/*  9448*/      OPC_MoveChild0,
/*  9449*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9452*/      OPC_MoveParent,
/*  9453*/      OPC_MoveParent,
/*  9454*/      OPC_RecordChild1, // #2 = $addr
/*  9455*/      OPC_CheckType, MVT::i32,
/*  9457*/      OPC_MoveParent,
/*  9458*/      OPC_RecordChild2, // #3 = $val
/*  9459*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/*  9461*/      OPC_MoveParent,
/*  9462*/      OPC_CheckType, MVT::i32,
/*  9464*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9466*/      OPC_EmitMergeInputChains1_0,
/*  9467*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9470*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9480*/    /*Scope*/ 52, /*->9533*/
/*  9481*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9485*/      OPC_MoveChild0,
/*  9486*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/*  9489*/      OPC_RecordMemRef,
/*  9490*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  9491*/      OPC_CheckFoldableChainNode,
/*  9492*/      OPC_MoveChild1,
/*  9493*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9496*/      OPC_MoveChild0,
/*  9497*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9500*/      OPC_RecordChild0, // #1 = $off
/*  9501*/      OPC_MoveChild0,
/*  9502*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9505*/      OPC_MoveParent,
/*  9506*/      OPC_MoveParent,
/*  9507*/      OPC_RecordChild1, // #2 = $addr
/*  9508*/      OPC_CheckType, MVT::i32,
/*  9510*/      OPC_MoveParent,
/*  9511*/      OPC_RecordChild2, // #3 = $val
/*  9512*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/*  9514*/      OPC_MoveParent,
/*  9515*/      OPC_CheckType, MVT::i32,
/*  9517*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9519*/      OPC_EmitMergeInputChains1_0,
/*  9520*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9523*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9533*/    /*Scope*/ 51, /*->9585*/
/*  9534*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9537*/      OPC_MoveChild0,
/*  9538*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  9541*/      OPC_RecordMemRef,
/*  9542*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  9543*/      OPC_CheckFoldableChainNode,
/*  9544*/      OPC_MoveChild1,
/*  9545*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9548*/      OPC_MoveChild0,
/*  9549*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9552*/      OPC_RecordChild0, // #1 = $off
/*  9553*/      OPC_MoveChild0,
/*  9554*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9557*/      OPC_MoveParent,
/*  9558*/      OPC_MoveParent,
/*  9559*/      OPC_RecordChild1, // #2 = $addr
/*  9560*/      OPC_CheckType, MVT::i32,
/*  9562*/      OPC_MoveParent,
/*  9563*/      OPC_RecordChild2, // #3 = $val
/*  9564*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/*  9566*/      OPC_MoveParent,
/*  9567*/      OPC_CheckType, MVT::i32,
/*  9569*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9571*/      OPC_EmitMergeInputChains1_0,
/*  9572*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9575*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9585*/    /*Scope*/ 52, /*->9638*/
/*  9586*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9590*/      OPC_MoveChild0,
/*  9591*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/*  9594*/      OPC_RecordMemRef,
/*  9595*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  9596*/      OPC_CheckFoldableChainNode,
/*  9597*/      OPC_MoveChild1,
/*  9598*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9601*/      OPC_MoveChild0,
/*  9602*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9605*/      OPC_RecordChild0, // #1 = $off
/*  9606*/      OPC_MoveChild0,
/*  9607*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9610*/      OPC_MoveParent,
/*  9611*/      OPC_MoveParent,
/*  9612*/      OPC_RecordChild1, // #2 = $addr
/*  9613*/      OPC_CheckType, MVT::i32,
/*  9615*/      OPC_MoveParent,
/*  9616*/      OPC_RecordChild2, // #3 = $val
/*  9617*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/*  9619*/      OPC_MoveParent,
/*  9620*/      OPC_CheckType, MVT::i32,
/*  9622*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9624*/      OPC_EmitMergeInputChains1_0,
/*  9625*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9628*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9638*/    /*Scope*/ 51, /*->9690*/
/*  9639*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9642*/      OPC_MoveChild0,
/*  9643*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  9646*/      OPC_RecordMemRef,
/*  9647*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  9648*/      OPC_CheckFoldableChainNode,
/*  9649*/      OPC_MoveChild1,
/*  9650*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9653*/      OPC_MoveChild0,
/*  9654*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9657*/      OPC_RecordChild0, // #1 = $off
/*  9658*/      OPC_MoveChild0,
/*  9659*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9662*/      OPC_MoveParent,
/*  9663*/      OPC_MoveParent,
/*  9664*/      OPC_RecordChild1, // #2 = $addr
/*  9665*/      OPC_CheckType, MVT::i32,
/*  9667*/      OPC_MoveParent,
/*  9668*/      OPC_RecordChild2, // #3 = $val
/*  9669*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/*  9671*/      OPC_MoveParent,
/*  9672*/      OPC_CheckType, MVT::i32,
/*  9674*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9676*/      OPC_EmitMergeInputChains1_0,
/*  9677*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9680*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9690*/    /*Scope*/ 52, /*->9743*/
/*  9691*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9695*/      OPC_MoveChild0,
/*  9696*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/*  9699*/      OPC_RecordMemRef,
/*  9700*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  9701*/      OPC_CheckFoldableChainNode,
/*  9702*/      OPC_MoveChild1,
/*  9703*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9706*/      OPC_MoveChild0,
/*  9707*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9710*/      OPC_RecordChild0, // #1 = $off
/*  9711*/      OPC_MoveChild0,
/*  9712*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9715*/      OPC_MoveParent,
/*  9716*/      OPC_MoveParent,
/*  9717*/      OPC_RecordChild1, // #2 = $addr
/*  9718*/      OPC_CheckType, MVT::i32,
/*  9720*/      OPC_MoveParent,
/*  9721*/      OPC_RecordChild2, // #3 = $val
/*  9722*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/*  9724*/      OPC_MoveParent,
/*  9725*/      OPC_CheckType, MVT::i32,
/*  9727*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9729*/      OPC_EmitMergeInputChains1_0,
/*  9730*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9733*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9743*/    /*Scope*/ 51, /*->9795*/
/*  9744*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9747*/      OPC_MoveChild0,
/*  9748*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  9751*/      OPC_RecordMemRef,
/*  9752*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  9753*/      OPC_CheckFoldableChainNode,
/*  9754*/      OPC_MoveChild1,
/*  9755*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9758*/      OPC_MoveChild0,
/*  9759*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9762*/      OPC_RecordChild0, // #1 = $off
/*  9763*/      OPC_MoveChild0,
/*  9764*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9767*/      OPC_MoveParent,
/*  9768*/      OPC_MoveParent,
/*  9769*/      OPC_RecordChild1, // #2 = $addr
/*  9770*/      OPC_CheckType, MVT::i32,
/*  9772*/      OPC_MoveParent,
/*  9773*/      OPC_RecordChild2, // #3 = $val
/*  9774*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/*  9776*/      OPC_MoveParent,
/*  9777*/      OPC_CheckType, MVT::i32,
/*  9779*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9781*/      OPC_EmitMergeInputChains1_0,
/*  9782*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9785*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9795*/    /*Scope*/ 52, /*->9848*/
/*  9796*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9800*/      OPC_MoveChild0,
/*  9801*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/*  9804*/      OPC_RecordMemRef,
/*  9805*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  9806*/      OPC_CheckFoldableChainNode,
/*  9807*/      OPC_MoveChild1,
/*  9808*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9811*/      OPC_MoveChild0,
/*  9812*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9815*/      OPC_RecordChild0, // #1 = $off
/*  9816*/      OPC_MoveChild0,
/*  9817*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9820*/      OPC_MoveParent,
/*  9821*/      OPC_MoveParent,
/*  9822*/      OPC_RecordChild1, // #2 = $addr
/*  9823*/      OPC_CheckType, MVT::i32,
/*  9825*/      OPC_MoveParent,
/*  9826*/      OPC_RecordChild2, // #3 = $val
/*  9827*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/*  9829*/      OPC_MoveParent,
/*  9830*/      OPC_CheckType, MVT::i32,
/*  9832*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9834*/      OPC_EmitMergeInputChains1_0,
/*  9835*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9838*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  9848*/    /*Scope*/ 53, /*->9902*/
/*  9849*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9852*/      OPC_MoveChild0,
/*  9853*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  9856*/      OPC_RecordMemRef,
/*  9857*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9858*/      OPC_CheckFoldableChainNode,
/*  9859*/      OPC_MoveChild1,
/*  9860*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9863*/      OPC_MoveChild0,
/*  9864*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9867*/      OPC_RecordChild0, // #1 = $off
/*  9868*/      OPC_MoveChild0,
/*  9869*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9872*/      OPC_MoveParent,
/*  9873*/      OPC_MoveParent,
/*  9874*/      OPC_RecordChild1, // #2 = $addr
/*  9875*/      OPC_CheckType, MVT::i32,
/*  9877*/      OPC_MoveParent,
/*  9878*/      OPC_RecordChild2, // #3 = $exp
/*  9879*/      OPC_RecordChild3, // #4 = $new
/*  9880*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/*  9882*/      OPC_MoveParent,
/*  9883*/      OPC_CheckType, MVT::i32,
/*  9885*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9887*/      OPC_EmitMergeInputChains1_0,
/*  9888*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9891*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  9902*/    /*Scope*/ 54, /*->9957*/
/*  9903*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  9907*/      OPC_MoveChild0,
/*  9908*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  9911*/      OPC_RecordMemRef,
/*  9912*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9913*/      OPC_CheckFoldableChainNode,
/*  9914*/      OPC_MoveChild1,
/*  9915*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/*  9918*/      OPC_MoveChild0,
/*  9919*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9922*/      OPC_RecordChild0, // #1 = $off
/*  9923*/      OPC_MoveChild0,
/*  9924*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/*  9927*/      OPC_MoveParent,
/*  9928*/      OPC_MoveParent,
/*  9929*/      OPC_RecordChild1, // #2 = $addr
/*  9930*/      OPC_CheckType, MVT::i32,
/*  9932*/      OPC_MoveParent,
/*  9933*/      OPC_RecordChild2, // #3 = $exp
/*  9934*/      OPC_RecordChild3, // #4 = $new
/*  9935*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/*  9937*/      OPC_MoveParent,
/*  9938*/      OPC_CheckType, MVT::i32,
/*  9940*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9942*/      OPC_EmitMergeInputChains1_0,
/*  9943*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9946*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/*  9957*/    /*Scope*/ 54, /*->10012*/
/*  9958*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/*  9961*/      OPC_MoveChild0,
/*  9962*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/*  9965*/      OPC_MoveChild0,
/*  9966*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/*  9969*/      OPC_RecordMemRef,
/*  9970*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  9971*/      OPC_CheckFoldableChainNode,
/*  9972*/      OPC_MoveChild1,
/*  9973*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  9976*/      OPC_RecordChild0, // #1 = $off
/*  9977*/      OPC_MoveChild0,
/*  9978*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  9981*/      OPC_MoveParent,
/*  9982*/      OPC_MoveParent,
/*  9983*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/*  9985*/      OPC_MoveParent,
/*  9986*/      OPC_MoveParent,
/*  9987*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/*  9989*/      OPC_EmitMergeInputChains1_0,
/*  9990*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9993*/      OPC_EmitInteger, MVT::i32, 0, 
/*  9996*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 10003*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 10012*/    /*Scope*/ 55, /*->10068*/
/* 10013*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10017*/      OPC_MoveChild0,
/* 10018*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10021*/      OPC_MoveChild0,
/* 10022*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 10025*/      OPC_RecordMemRef,
/* 10026*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 10027*/      OPC_CheckFoldableChainNode,
/* 10028*/      OPC_MoveChild1,
/* 10029*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10032*/      OPC_RecordChild0, // #1 = $off
/* 10033*/      OPC_MoveChild0,
/* 10034*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10037*/      OPC_MoveParent,
/* 10038*/      OPC_MoveParent,
/* 10039*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 10041*/      OPC_MoveParent,
/* 10042*/      OPC_MoveParent,
/* 10043*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10045*/      OPC_EmitMergeInputChains1_0,
/* 10046*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10049*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10052*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 10059*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 10068*/    /*Scope*/ 54, /*->10123*/
/* 10069*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10072*/      OPC_MoveChild0,
/* 10073*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10076*/      OPC_MoveChild0,
/* 10077*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 10080*/      OPC_RecordMemRef,
/* 10081*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 10082*/      OPC_CheckFoldableChainNode,
/* 10083*/      OPC_MoveChild1,
/* 10084*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10087*/      OPC_RecordChild0, // #1 = $off
/* 10088*/      OPC_MoveChild0,
/* 10089*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 10092*/      OPC_MoveParent,
/* 10093*/      OPC_MoveParent,
/* 10094*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 10096*/      OPC_MoveParent,
/* 10097*/      OPC_MoveParent,
/* 10098*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10100*/      OPC_EmitMergeInputChains1_0,
/* 10101*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10104*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10107*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 10114*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 10123*/    /*Scope*/ 55, /*->10179*/
/* 10124*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10128*/      OPC_MoveChild0,
/* 10129*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10132*/      OPC_MoveChild0,
/* 10133*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 10136*/      OPC_RecordMemRef,
/* 10137*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 10138*/      OPC_CheckFoldableChainNode,
/* 10139*/      OPC_MoveChild1,
/* 10140*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10143*/      OPC_RecordChild0, // #1 = $off
/* 10144*/      OPC_MoveChild0,
/* 10145*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 10148*/      OPC_MoveParent,
/* 10149*/      OPC_MoveParent,
/* 10150*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 10152*/      OPC_MoveParent,
/* 10153*/      OPC_MoveParent,
/* 10154*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10156*/      OPC_EmitMergeInputChains1_0,
/* 10157*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10160*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10163*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 10170*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 10179*/    /*Scope*/ 58, /*->10238*/
/* 10180*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10183*/      OPC_MoveChild0,
/* 10184*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10187*/      OPC_MoveChild0,
/* 10188*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 10191*/      OPC_RecordMemRef,
/* 10192*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 10193*/      OPC_CheckFoldableChainNode,
/* 10194*/      OPC_RecordChild1, // #1 = $off
/* 10195*/      OPC_MoveChild1,
/* 10196*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10199*/      OPC_MoveParent,
/* 10200*/      OPC_MoveChild2,
/* 10201*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10204*/      OPC_RecordChild0, // #2 = $val
/* 10205*/      OPC_MoveParent,
/* 10206*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 10208*/      OPC_MoveParent,
/* 10209*/      OPC_MoveParent,
/* 10210*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10212*/      OPC_EmitMergeInputChains1_0,
/* 10213*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10216*/      OPC_EmitConvertToTarget, 1,
/* 10218*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10221*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10228*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10238*/    /*Scope*/ 59, /*->10298*/
/* 10239*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10243*/      OPC_MoveChild0,
/* 10244*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10247*/      OPC_MoveChild0,
/* 10248*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 10251*/      OPC_RecordMemRef,
/* 10252*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 10253*/      OPC_CheckFoldableChainNode,
/* 10254*/      OPC_RecordChild1, // #1 = $off
/* 10255*/      OPC_MoveChild1,
/* 10256*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10259*/      OPC_MoveParent,
/* 10260*/      OPC_MoveChild2,
/* 10261*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10264*/      OPC_RecordChild0, // #2 = $val
/* 10265*/      OPC_MoveParent,
/* 10266*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 10268*/      OPC_MoveParent,
/* 10269*/      OPC_MoveParent,
/* 10270*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10272*/      OPC_EmitMergeInputChains1_0,
/* 10273*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10276*/      OPC_EmitConvertToTarget, 1,
/* 10278*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10281*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10288*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10298*/    /*Scope*/ 58, /*->10357*/
/* 10299*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10302*/      OPC_MoveChild0,
/* 10303*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10306*/      OPC_MoveChild0,
/* 10307*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 10310*/      OPC_RecordMemRef,
/* 10311*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 10312*/      OPC_CheckFoldableChainNode,
/* 10313*/      OPC_RecordChild1, // #1 = $off
/* 10314*/      OPC_MoveChild1,
/* 10315*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10318*/      OPC_MoveParent,
/* 10319*/      OPC_MoveChild2,
/* 10320*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10323*/      OPC_RecordChild0, // #2 = $val
/* 10324*/      OPC_MoveParent,
/* 10325*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 10327*/      OPC_MoveParent,
/* 10328*/      OPC_MoveParent,
/* 10329*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10331*/      OPC_EmitMergeInputChains1_0,
/* 10332*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10335*/      OPC_EmitConvertToTarget, 1,
/* 10337*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10340*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10347*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10357*/    /*Scope*/ 59, /*->10417*/
/* 10358*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10362*/      OPC_MoveChild0,
/* 10363*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10366*/      OPC_MoveChild0,
/* 10367*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 10370*/      OPC_RecordMemRef,
/* 10371*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 10372*/      OPC_CheckFoldableChainNode,
/* 10373*/      OPC_RecordChild1, // #1 = $off
/* 10374*/      OPC_MoveChild1,
/* 10375*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10378*/      OPC_MoveParent,
/* 10379*/      OPC_MoveChild2,
/* 10380*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10383*/      OPC_RecordChild0, // #2 = $val
/* 10384*/      OPC_MoveParent,
/* 10385*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 10387*/      OPC_MoveParent,
/* 10388*/      OPC_MoveParent,
/* 10389*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10391*/      OPC_EmitMergeInputChains1_0,
/* 10392*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10395*/      OPC_EmitConvertToTarget, 1,
/* 10397*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10400*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10407*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10417*/    /*Scope*/ 58, /*->10476*/
/* 10418*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10421*/      OPC_MoveChild0,
/* 10422*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10425*/      OPC_MoveChild0,
/* 10426*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 10429*/      OPC_RecordMemRef,
/* 10430*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 10431*/      OPC_CheckFoldableChainNode,
/* 10432*/      OPC_RecordChild1, // #1 = $off
/* 10433*/      OPC_MoveChild1,
/* 10434*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10437*/      OPC_MoveParent,
/* 10438*/      OPC_MoveChild2,
/* 10439*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10442*/      OPC_RecordChild0, // #2 = $val
/* 10443*/      OPC_MoveParent,
/* 10444*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 10446*/      OPC_MoveParent,
/* 10447*/      OPC_MoveParent,
/* 10448*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10450*/      OPC_EmitMergeInputChains1_0,
/* 10451*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10454*/      OPC_EmitConvertToTarget, 1,
/* 10456*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10459*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10476*/    /*Scope*/ 59, /*->10536*/
/* 10477*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10481*/      OPC_MoveChild0,
/* 10482*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10485*/      OPC_MoveChild0,
/* 10486*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 10489*/      OPC_RecordMemRef,
/* 10490*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 10491*/      OPC_CheckFoldableChainNode,
/* 10492*/      OPC_RecordChild1, // #1 = $off
/* 10493*/      OPC_MoveChild1,
/* 10494*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10497*/      OPC_MoveParent,
/* 10498*/      OPC_MoveChild2,
/* 10499*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10502*/      OPC_RecordChild0, // #2 = $val
/* 10503*/      OPC_MoveParent,
/* 10504*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 10506*/      OPC_MoveParent,
/* 10507*/      OPC_MoveParent,
/* 10508*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10510*/      OPC_EmitMergeInputChains1_0,
/* 10511*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10514*/      OPC_EmitConvertToTarget, 1,
/* 10516*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10519*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10526*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10536*/    /*Scope*/ 58, /*->10595*/
/* 10537*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10540*/      OPC_MoveChild0,
/* 10541*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10544*/      OPC_MoveChild0,
/* 10545*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 10548*/      OPC_RecordMemRef,
/* 10549*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 10550*/      OPC_CheckFoldableChainNode,
/* 10551*/      OPC_RecordChild1, // #1 = $off
/* 10552*/      OPC_MoveChild1,
/* 10553*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10556*/      OPC_MoveParent,
/* 10557*/      OPC_MoveChild2,
/* 10558*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10561*/      OPC_RecordChild0, // #2 = $val
/* 10562*/      OPC_MoveParent,
/* 10563*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 10565*/      OPC_MoveParent,
/* 10566*/      OPC_MoveParent,
/* 10567*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10569*/      OPC_EmitMergeInputChains1_0,
/* 10570*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10573*/      OPC_EmitConvertToTarget, 1,
/* 10575*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10578*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10585*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10595*/    /*Scope*/ 59, /*->10655*/
/* 10596*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10600*/      OPC_MoveChild0,
/* 10601*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10604*/      OPC_MoveChild0,
/* 10605*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 10608*/      OPC_RecordMemRef,
/* 10609*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 10610*/      OPC_CheckFoldableChainNode,
/* 10611*/      OPC_RecordChild1, // #1 = $off
/* 10612*/      OPC_MoveChild1,
/* 10613*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10616*/      OPC_MoveParent,
/* 10617*/      OPC_MoveChild2,
/* 10618*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10621*/      OPC_RecordChild0, // #2 = $val
/* 10622*/      OPC_MoveParent,
/* 10623*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 10625*/      OPC_MoveParent,
/* 10626*/      OPC_MoveParent,
/* 10627*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10629*/      OPC_EmitMergeInputChains1_0,
/* 10630*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10633*/      OPC_EmitConvertToTarget, 1,
/* 10635*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10638*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10645*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10655*/    /*Scope*/ 58, /*->10714*/
/* 10656*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10659*/      OPC_MoveChild0,
/* 10660*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10663*/      OPC_MoveChild0,
/* 10664*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 10667*/      OPC_RecordMemRef,
/* 10668*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 10669*/      OPC_CheckFoldableChainNode,
/* 10670*/      OPC_RecordChild1, // #1 = $off
/* 10671*/      OPC_MoveChild1,
/* 10672*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10675*/      OPC_MoveParent,
/* 10676*/      OPC_MoveChild2,
/* 10677*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10680*/      OPC_RecordChild0, // #2 = $val
/* 10681*/      OPC_MoveParent,
/* 10682*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 10684*/      OPC_MoveParent,
/* 10685*/      OPC_MoveParent,
/* 10686*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10688*/      OPC_EmitMergeInputChains1_0,
/* 10689*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10692*/      OPC_EmitConvertToTarget, 1,
/* 10694*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10697*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10704*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10714*/    /*Scope*/ 59, /*->10774*/
/* 10715*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10719*/      OPC_MoveChild0,
/* 10720*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10723*/      OPC_MoveChild0,
/* 10724*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 10727*/      OPC_RecordMemRef,
/* 10728*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 10729*/      OPC_CheckFoldableChainNode,
/* 10730*/      OPC_RecordChild1, // #1 = $off
/* 10731*/      OPC_MoveChild1,
/* 10732*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10735*/      OPC_MoveParent,
/* 10736*/      OPC_MoveChild2,
/* 10737*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10740*/      OPC_RecordChild0, // #2 = $val
/* 10741*/      OPC_MoveParent,
/* 10742*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 10744*/      OPC_MoveParent,
/* 10745*/      OPC_MoveParent,
/* 10746*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10748*/      OPC_EmitMergeInputChains1_0,
/* 10749*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10752*/      OPC_EmitConvertToTarget, 1,
/* 10754*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10757*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10764*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10774*/    /*Scope*/ 58, /*->10833*/
/* 10775*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10778*/      OPC_MoveChild0,
/* 10779*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10782*/      OPC_MoveChild0,
/* 10783*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 10786*/      OPC_RecordMemRef,
/* 10787*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 10788*/      OPC_CheckFoldableChainNode,
/* 10789*/      OPC_RecordChild1, // #1 = $off
/* 10790*/      OPC_MoveChild1,
/* 10791*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10794*/      OPC_MoveParent,
/* 10795*/      OPC_MoveChild2,
/* 10796*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10799*/      OPC_RecordChild0, // #2 = $val
/* 10800*/      OPC_MoveParent,
/* 10801*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 10803*/      OPC_MoveParent,
/* 10804*/      OPC_MoveParent,
/* 10805*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10807*/      OPC_EmitMergeInputChains1_0,
/* 10808*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10811*/      OPC_EmitConvertToTarget, 1,
/* 10813*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10816*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10823*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10833*/    /*Scope*/ 59, /*->10893*/
/* 10834*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10838*/      OPC_MoveChild0,
/* 10839*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 10842*/      OPC_MoveChild0,
/* 10843*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 10846*/      OPC_RecordMemRef,
/* 10847*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 10848*/      OPC_CheckFoldableChainNode,
/* 10849*/      OPC_RecordChild1, // #1 = $off
/* 10850*/      OPC_MoveChild1,
/* 10851*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10854*/      OPC_MoveParent,
/* 10855*/      OPC_MoveChild2,
/* 10856*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 10859*/      OPC_RecordChild0, // #2 = $val
/* 10860*/      OPC_MoveParent,
/* 10861*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 10863*/      OPC_MoveParent,
/* 10864*/      OPC_MoveParent,
/* 10865*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10867*/      OPC_EmitMergeInputChains1_0,
/* 10868*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10871*/      OPC_EmitConvertToTarget, 1,
/* 10873*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10876*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 10883*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 21
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 10893*/    /*Scope*/ 48, /*->10942*/
/* 10894*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10897*/      OPC_MoveChild0,
/* 10898*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 10901*/      OPC_RecordMemRef,
/* 10902*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 10903*/      OPC_CheckFoldableChainNode,
/* 10904*/      OPC_MoveChild1,
/* 10905*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 10908*/      OPC_RecordChild0, // #1 = $addr
/* 10909*/      OPC_RecordChild1, // #2 = $off
/* 10910*/      OPC_MoveChild1,
/* 10911*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10914*/      OPC_MoveParent,
/* 10915*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 10917*/      OPC_CheckType, MVT::i32,
/* 10919*/      OPC_MoveParent,
/* 10920*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 10922*/      OPC_MoveParent,
/* 10923*/      OPC_CheckType, MVT::i32,
/* 10925*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10927*/      OPC_EmitMergeInputChains1_0,
/* 10928*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10931*/      OPC_EmitConvertToTarget, 2,
/* 10933*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 10942*/    /*Scope*/ 49, /*->10992*/
/* 10943*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 10947*/      OPC_MoveChild0,
/* 10948*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 10951*/      OPC_RecordMemRef,
/* 10952*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 10953*/      OPC_CheckFoldableChainNode,
/* 10954*/      OPC_MoveChild1,
/* 10955*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 10958*/      OPC_RecordChild0, // #1 = $addr
/* 10959*/      OPC_RecordChild1, // #2 = $off
/* 10960*/      OPC_MoveChild1,
/* 10961*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10964*/      OPC_MoveParent,
/* 10965*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 10967*/      OPC_CheckType, MVT::i32,
/* 10969*/      OPC_MoveParent,
/* 10970*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 10972*/      OPC_MoveParent,
/* 10973*/      OPC_CheckType, MVT::i32,
/* 10975*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 10977*/      OPC_EmitMergeInputChains1_0,
/* 10978*/      OPC_EmitInteger, MVT::i32, 0, 
/* 10981*/      OPC_EmitConvertToTarget, 2,
/* 10983*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 10992*/    /*Scope*/ 48, /*->11041*/
/* 10993*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 10996*/      OPC_MoveChild0,
/* 10997*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 11000*/      OPC_RecordMemRef,
/* 11001*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 11002*/      OPC_CheckFoldableChainNode,
/* 11003*/      OPC_MoveChild1,
/* 11004*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11007*/      OPC_RecordChild0, // #1 = $addr
/* 11008*/      OPC_RecordChild1, // #2 = $off
/* 11009*/      OPC_MoveChild1,
/* 11010*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11013*/      OPC_MoveParent,
/* 11014*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11016*/      OPC_CheckType, MVT::i32,
/* 11018*/      OPC_MoveParent,
/* 11019*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 11021*/      OPC_MoveParent,
/* 11022*/      OPC_CheckType, MVT::i32,
/* 11024*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11026*/      OPC_EmitMergeInputChains1_0,
/* 11027*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11030*/      OPC_EmitConvertToTarget, 2,
/* 11032*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 11041*/    /*Scope*/ 49, /*->11091*/
/* 11042*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11046*/      OPC_MoveChild0,
/* 11047*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 11050*/      OPC_RecordMemRef,
/* 11051*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 11052*/      OPC_CheckFoldableChainNode,
/* 11053*/      OPC_MoveChild1,
/* 11054*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11057*/      OPC_RecordChild0, // #1 = $addr
/* 11058*/      OPC_RecordChild1, // #2 = $off
/* 11059*/      OPC_MoveChild1,
/* 11060*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11063*/      OPC_MoveParent,
/* 11064*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11066*/      OPC_CheckType, MVT::i32,
/* 11068*/      OPC_MoveParent,
/* 11069*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 11071*/      OPC_MoveParent,
/* 11072*/      OPC_CheckType, MVT::i32,
/* 11074*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11076*/      OPC_EmitMergeInputChains1_0,
/* 11077*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11080*/      OPC_EmitConvertToTarget, 2,
/* 11082*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 11091*/    /*Scope*/ 50, /*->11142*/
/* 11092*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11095*/      OPC_MoveChild0,
/* 11096*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 11099*/      OPC_RecordMemRef,
/* 11100*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 11101*/      OPC_CheckFoldableChainNode,
/* 11102*/      OPC_MoveChild1,
/* 11103*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11106*/      OPC_RecordChild0, // #1 = $addr
/* 11107*/      OPC_RecordChild1, // #2 = $off
/* 11108*/      OPC_MoveChild1,
/* 11109*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11112*/      OPC_MoveParent,
/* 11113*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11115*/      OPC_CheckType, MVT::i32,
/* 11117*/      OPC_MoveParent,
/* 11118*/      OPC_RecordChild2, // #3 = $val
/* 11119*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 11121*/      OPC_MoveParent,
/* 11122*/      OPC_CheckType, MVT::i32,
/* 11124*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11126*/      OPC_EmitMergeInputChains1_0,
/* 11127*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11130*/      OPC_EmitConvertToTarget, 2,
/* 11132*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11142*/    /*Scope*/ 51, /*->11194*/
/* 11143*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11147*/      OPC_MoveChild0,
/* 11148*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 11151*/      OPC_RecordMemRef,
/* 11152*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 11153*/      OPC_CheckFoldableChainNode,
/* 11154*/      OPC_MoveChild1,
/* 11155*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11158*/      OPC_RecordChild0, // #1 = $addr
/* 11159*/      OPC_RecordChild1, // #2 = $off
/* 11160*/      OPC_MoveChild1,
/* 11161*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11164*/      OPC_MoveParent,
/* 11165*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11167*/      OPC_CheckType, MVT::i32,
/* 11169*/      OPC_MoveParent,
/* 11170*/      OPC_RecordChild2, // #3 = $val
/* 11171*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 11173*/      OPC_MoveParent,
/* 11174*/      OPC_CheckType, MVT::i32,
/* 11176*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11178*/      OPC_EmitMergeInputChains1_0,
/* 11179*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11182*/      OPC_EmitConvertToTarget, 2,
/* 11184*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11194*/    /*Scope*/ 50, /*->11245*/
/* 11195*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11198*/      OPC_MoveChild0,
/* 11199*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 11202*/      OPC_RecordMemRef,
/* 11203*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 11204*/      OPC_CheckFoldableChainNode,
/* 11205*/      OPC_MoveChild1,
/* 11206*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11209*/      OPC_RecordChild0, // #1 = $addr
/* 11210*/      OPC_RecordChild1, // #2 = $off
/* 11211*/      OPC_MoveChild1,
/* 11212*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11215*/      OPC_MoveParent,
/* 11216*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11218*/      OPC_CheckType, MVT::i32,
/* 11220*/      OPC_MoveParent,
/* 11221*/      OPC_RecordChild2, // #3 = $val
/* 11222*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 11224*/      OPC_MoveParent,
/* 11225*/      OPC_CheckType, MVT::i32,
/* 11227*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11229*/      OPC_EmitMergeInputChains1_0,
/* 11230*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11233*/      OPC_EmitConvertToTarget, 2,
/* 11235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11245*/    /*Scope*/ 51, /*->11297*/
/* 11246*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11250*/      OPC_MoveChild0,
/* 11251*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 11254*/      OPC_RecordMemRef,
/* 11255*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 11256*/      OPC_CheckFoldableChainNode,
/* 11257*/      OPC_MoveChild1,
/* 11258*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11261*/      OPC_RecordChild0, // #1 = $addr
/* 11262*/      OPC_RecordChild1, // #2 = $off
/* 11263*/      OPC_MoveChild1,
/* 11264*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11267*/      OPC_MoveParent,
/* 11268*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11270*/      OPC_CheckType, MVT::i32,
/* 11272*/      OPC_MoveParent,
/* 11273*/      OPC_RecordChild2, // #3 = $val
/* 11274*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 11276*/      OPC_MoveParent,
/* 11277*/      OPC_CheckType, MVT::i32,
/* 11279*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11281*/      OPC_EmitMergeInputChains1_0,
/* 11282*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11285*/      OPC_EmitConvertToTarget, 2,
/* 11287*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11297*/    /*Scope*/ 50, /*->11348*/
/* 11298*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11301*/      OPC_MoveChild0,
/* 11302*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 11305*/      OPC_RecordMemRef,
/* 11306*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 11307*/      OPC_CheckFoldableChainNode,
/* 11308*/      OPC_MoveChild1,
/* 11309*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11312*/      OPC_RecordChild0, // #1 = $addr
/* 11313*/      OPC_RecordChild1, // #2 = $off
/* 11314*/      OPC_MoveChild1,
/* 11315*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11318*/      OPC_MoveParent,
/* 11319*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11321*/      OPC_CheckType, MVT::i32,
/* 11323*/      OPC_MoveParent,
/* 11324*/      OPC_RecordChild2, // #3 = $val
/* 11325*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 11327*/      OPC_MoveParent,
/* 11328*/      OPC_CheckType, MVT::i32,
/* 11330*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11332*/      OPC_EmitMergeInputChains1_0,
/* 11333*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11336*/      OPC_EmitConvertToTarget, 2,
/* 11338*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11348*/    /*Scope*/ 51, /*->11400*/
/* 11349*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11353*/      OPC_MoveChild0,
/* 11354*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 11357*/      OPC_RecordMemRef,
/* 11358*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 11359*/      OPC_CheckFoldableChainNode,
/* 11360*/      OPC_MoveChild1,
/* 11361*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11364*/      OPC_RecordChild0, // #1 = $addr
/* 11365*/      OPC_RecordChild1, // #2 = $off
/* 11366*/      OPC_MoveChild1,
/* 11367*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11370*/      OPC_MoveParent,
/* 11371*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11373*/      OPC_CheckType, MVT::i32,
/* 11375*/      OPC_MoveParent,
/* 11376*/      OPC_RecordChild2, // #3 = $val
/* 11377*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 11379*/      OPC_MoveParent,
/* 11380*/      OPC_CheckType, MVT::i32,
/* 11382*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11384*/      OPC_EmitMergeInputChains1_0,
/* 11385*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11388*/      OPC_EmitConvertToTarget, 2,
/* 11390*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11400*/    /*Scope*/ 50, /*->11451*/
/* 11401*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11404*/      OPC_MoveChild0,
/* 11405*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 11408*/      OPC_RecordMemRef,
/* 11409*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 11410*/      OPC_CheckFoldableChainNode,
/* 11411*/      OPC_MoveChild1,
/* 11412*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11415*/      OPC_RecordChild0, // #1 = $addr
/* 11416*/      OPC_RecordChild1, // #2 = $off
/* 11417*/      OPC_MoveChild1,
/* 11418*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11421*/      OPC_MoveParent,
/* 11422*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11424*/      OPC_CheckType, MVT::i32,
/* 11426*/      OPC_MoveParent,
/* 11427*/      OPC_RecordChild2, // #3 = $val
/* 11428*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 11430*/      OPC_MoveParent,
/* 11431*/      OPC_CheckType, MVT::i32,
/* 11433*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11435*/      OPC_EmitMergeInputChains1_0,
/* 11436*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11439*/      OPC_EmitConvertToTarget, 2,
/* 11441*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11451*/    /*Scope*/ 51, /*->11503*/
/* 11452*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11456*/      OPC_MoveChild0,
/* 11457*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 11460*/      OPC_RecordMemRef,
/* 11461*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 11462*/      OPC_CheckFoldableChainNode,
/* 11463*/      OPC_MoveChild1,
/* 11464*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11467*/      OPC_RecordChild0, // #1 = $addr
/* 11468*/      OPC_RecordChild1, // #2 = $off
/* 11469*/      OPC_MoveChild1,
/* 11470*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11473*/      OPC_MoveParent,
/* 11474*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11476*/      OPC_CheckType, MVT::i32,
/* 11478*/      OPC_MoveParent,
/* 11479*/      OPC_RecordChild2, // #3 = $val
/* 11480*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 11482*/      OPC_MoveParent,
/* 11483*/      OPC_CheckType, MVT::i32,
/* 11485*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11487*/      OPC_EmitMergeInputChains1_0,
/* 11488*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11491*/      OPC_EmitConvertToTarget, 2,
/* 11493*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11503*/    /*Scope*/ 50, /*->11554*/
/* 11504*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11507*/      OPC_MoveChild0,
/* 11508*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 11511*/      OPC_RecordMemRef,
/* 11512*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 11513*/      OPC_CheckFoldableChainNode,
/* 11514*/      OPC_MoveChild1,
/* 11515*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11518*/      OPC_RecordChild0, // #1 = $addr
/* 11519*/      OPC_RecordChild1, // #2 = $off
/* 11520*/      OPC_MoveChild1,
/* 11521*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11524*/      OPC_MoveParent,
/* 11525*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11527*/      OPC_CheckType, MVT::i32,
/* 11529*/      OPC_MoveParent,
/* 11530*/      OPC_RecordChild2, // #3 = $val
/* 11531*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 11533*/      OPC_MoveParent,
/* 11534*/      OPC_CheckType, MVT::i32,
/* 11536*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11538*/      OPC_EmitMergeInputChains1_0,
/* 11539*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11542*/      OPC_EmitConvertToTarget, 2,
/* 11544*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11554*/    /*Scope*/ 51, /*->11606*/
/* 11555*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11559*/      OPC_MoveChild0,
/* 11560*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 11563*/      OPC_RecordMemRef,
/* 11564*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 11565*/      OPC_CheckFoldableChainNode,
/* 11566*/      OPC_MoveChild1,
/* 11567*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11570*/      OPC_RecordChild0, // #1 = $addr
/* 11571*/      OPC_RecordChild1, // #2 = $off
/* 11572*/      OPC_MoveChild1,
/* 11573*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11576*/      OPC_MoveParent,
/* 11577*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11579*/      OPC_CheckType, MVT::i32,
/* 11581*/      OPC_MoveParent,
/* 11582*/      OPC_RecordChild2, // #3 = $val
/* 11583*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 11585*/      OPC_MoveParent,
/* 11586*/      OPC_CheckType, MVT::i32,
/* 11588*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11590*/      OPC_EmitMergeInputChains1_0,
/* 11591*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11594*/      OPC_EmitConvertToTarget, 2,
/* 11596*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11606*/    /*Scope*/ 50, /*->11657*/
/* 11607*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11610*/      OPC_MoveChild0,
/* 11611*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 11614*/      OPC_RecordMemRef,
/* 11615*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 11616*/      OPC_CheckFoldableChainNode,
/* 11617*/      OPC_MoveChild1,
/* 11618*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11621*/      OPC_RecordChild0, // #1 = $addr
/* 11622*/      OPC_RecordChild1, // #2 = $off
/* 11623*/      OPC_MoveChild1,
/* 11624*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11627*/      OPC_MoveParent,
/* 11628*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11630*/      OPC_CheckType, MVT::i32,
/* 11632*/      OPC_MoveParent,
/* 11633*/      OPC_RecordChild2, // #3 = $val
/* 11634*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 11636*/      OPC_MoveParent,
/* 11637*/      OPC_CheckType, MVT::i32,
/* 11639*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11641*/      OPC_EmitMergeInputChains1_0,
/* 11642*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11645*/      OPC_EmitConvertToTarget, 2,
/* 11647*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11657*/    /*Scope*/ 51, /*->11709*/
/* 11658*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11662*/      OPC_MoveChild0,
/* 11663*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 11666*/      OPC_RecordMemRef,
/* 11667*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 11668*/      OPC_CheckFoldableChainNode,
/* 11669*/      OPC_MoveChild1,
/* 11670*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11673*/      OPC_RecordChild0, // #1 = $addr
/* 11674*/      OPC_RecordChild1, // #2 = $off
/* 11675*/      OPC_MoveChild1,
/* 11676*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11679*/      OPC_MoveParent,
/* 11680*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11682*/      OPC_CheckType, MVT::i32,
/* 11684*/      OPC_MoveParent,
/* 11685*/      OPC_RecordChild2, // #3 = $val
/* 11686*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 11688*/      OPC_MoveParent,
/* 11689*/      OPC_CheckType, MVT::i32,
/* 11691*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11693*/      OPC_EmitMergeInputChains1_0,
/* 11694*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11697*/      OPC_EmitConvertToTarget, 2,
/* 11699*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11709*/    /*Scope*/ 50, /*->11760*/
/* 11710*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11713*/      OPC_MoveChild0,
/* 11714*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 11717*/      OPC_RecordMemRef,
/* 11718*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 11719*/      OPC_CheckFoldableChainNode,
/* 11720*/      OPC_MoveChild1,
/* 11721*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11724*/      OPC_RecordChild0, // #1 = $addr
/* 11725*/      OPC_RecordChild1, // #2 = $off
/* 11726*/      OPC_MoveChild1,
/* 11727*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11730*/      OPC_MoveParent,
/* 11731*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11733*/      OPC_CheckType, MVT::i32,
/* 11735*/      OPC_MoveParent,
/* 11736*/      OPC_RecordChild2, // #3 = $val
/* 11737*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 11739*/      OPC_MoveParent,
/* 11740*/      OPC_CheckType, MVT::i32,
/* 11742*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11744*/      OPC_EmitMergeInputChains1_0,
/* 11745*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11748*/      OPC_EmitConvertToTarget, 2,
/* 11750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11760*/    /*Scope*/ 51, /*->11812*/
/* 11761*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11765*/      OPC_MoveChild0,
/* 11766*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 11769*/      OPC_RecordMemRef,
/* 11770*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 11771*/      OPC_CheckFoldableChainNode,
/* 11772*/      OPC_MoveChild1,
/* 11773*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11776*/      OPC_RecordChild0, // #1 = $addr
/* 11777*/      OPC_RecordChild1, // #2 = $off
/* 11778*/      OPC_MoveChild1,
/* 11779*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11782*/      OPC_MoveParent,
/* 11783*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11785*/      OPC_CheckType, MVT::i32,
/* 11787*/      OPC_MoveParent,
/* 11788*/      OPC_RecordChild2, // #3 = $val
/* 11789*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 11791*/      OPC_MoveParent,
/* 11792*/      OPC_CheckType, MVT::i32,
/* 11794*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11796*/      OPC_EmitMergeInputChains1_0,
/* 11797*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11800*/      OPC_EmitConvertToTarget, 2,
/* 11802*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11812*/    /*Scope*/ 50, /*->11863*/
/* 11813*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11816*/      OPC_MoveChild0,
/* 11817*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 11820*/      OPC_RecordMemRef,
/* 11821*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 11822*/      OPC_CheckFoldableChainNode,
/* 11823*/      OPC_MoveChild1,
/* 11824*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11827*/      OPC_RecordChild0, // #1 = $addr
/* 11828*/      OPC_RecordChild1, // #2 = $off
/* 11829*/      OPC_MoveChild1,
/* 11830*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11833*/      OPC_MoveParent,
/* 11834*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11836*/      OPC_CheckType, MVT::i32,
/* 11838*/      OPC_MoveParent,
/* 11839*/      OPC_RecordChild2, // #3 = $val
/* 11840*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 11842*/      OPC_MoveParent,
/* 11843*/      OPC_CheckType, MVT::i32,
/* 11845*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11847*/      OPC_EmitMergeInputChains1_0,
/* 11848*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11851*/      OPC_EmitConvertToTarget, 2,
/* 11853*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11863*/    /*Scope*/ 51, /*->11915*/
/* 11864*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11868*/      OPC_MoveChild0,
/* 11869*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 11872*/      OPC_RecordMemRef,
/* 11873*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 11874*/      OPC_CheckFoldableChainNode,
/* 11875*/      OPC_MoveChild1,
/* 11876*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 11879*/      OPC_RecordChild0, // #1 = $addr
/* 11880*/      OPC_RecordChild1, // #2 = $off
/* 11881*/      OPC_MoveChild1,
/* 11882*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11885*/      OPC_MoveParent,
/* 11886*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 11888*/      OPC_CheckType, MVT::i32,
/* 11890*/      OPC_MoveParent,
/* 11891*/      OPC_RecordChild2, // #3 = $val
/* 11892*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 11894*/      OPC_MoveParent,
/* 11895*/      OPC_CheckType, MVT::i32,
/* 11897*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11899*/      OPC_EmitMergeInputChains1_0,
/* 11900*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11903*/      OPC_EmitConvertToTarget, 2,
/* 11905*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11915*/    /*Scope*/ 50, /*->11966*/
/* 11916*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 11919*/      OPC_MoveChild0,
/* 11920*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 11923*/      OPC_RecordMemRef,
/* 11924*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 11925*/      OPC_CheckFoldableChainNode,
/* 11926*/      OPC_MoveChild1,
/* 11927*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11930*/      OPC_RecordChild0, // #1 = $addr
/* 11931*/      OPC_RecordChild1, // #2 = $off
/* 11932*/      OPC_MoveChild1,
/* 11933*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11936*/      OPC_MoveParent,
/* 11937*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11939*/      OPC_CheckType, MVT::i32,
/* 11941*/      OPC_MoveParent,
/* 11942*/      OPC_RecordChild2, // #3 = $val
/* 11943*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 11945*/      OPC_MoveParent,
/* 11946*/      OPC_CheckType, MVT::i32,
/* 11948*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 11950*/      OPC_EmitMergeInputChains1_0,
/* 11951*/      OPC_EmitInteger, MVT::i32, 0, 
/* 11954*/      OPC_EmitConvertToTarget, 2,
/* 11956*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 11966*/    /*Scope*/ 51, /*->12018*/
/* 11967*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 11971*/      OPC_MoveChild0,
/* 11972*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 11975*/      OPC_RecordMemRef,
/* 11976*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 11977*/      OPC_CheckFoldableChainNode,
/* 11978*/      OPC_MoveChild1,
/* 11979*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 11982*/      OPC_RecordChild0, // #1 = $addr
/* 11983*/      OPC_RecordChild1, // #2 = $off
/* 11984*/      OPC_MoveChild1,
/* 11985*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11988*/      OPC_MoveParent,
/* 11989*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 11991*/      OPC_CheckType, MVT::i32,
/* 11993*/      OPC_MoveParent,
/* 11994*/      OPC_RecordChild2, // #3 = $val
/* 11995*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 11997*/      OPC_MoveParent,
/* 11998*/      OPC_CheckType, MVT::i32,
/* 12000*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12002*/      OPC_EmitMergeInputChains1_0,
/* 12003*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12006*/      OPC_EmitConvertToTarget, 2,
/* 12008*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 12018*/    /*Scope*/ 50, /*->12069*/
/* 12019*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12022*/      OPC_MoveChild0,
/* 12023*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 12026*/      OPC_RecordMemRef,
/* 12027*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 12028*/      OPC_CheckFoldableChainNode,
/* 12029*/      OPC_MoveChild1,
/* 12030*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 12033*/      OPC_RecordChild0, // #1 = $addr
/* 12034*/      OPC_RecordChild1, // #2 = $off
/* 12035*/      OPC_MoveChild1,
/* 12036*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12039*/      OPC_MoveParent,
/* 12040*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 12042*/      OPC_CheckType, MVT::i32,
/* 12044*/      OPC_MoveParent,
/* 12045*/      OPC_RecordChild2, // #3 = $val
/* 12046*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 12048*/      OPC_MoveParent,
/* 12049*/      OPC_CheckType, MVT::i32,
/* 12051*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12053*/      OPC_EmitMergeInputChains1_0,
/* 12054*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12057*/      OPC_EmitConvertToTarget, 2,
/* 12059*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 12069*/    /*Scope*/ 51, /*->12121*/
/* 12070*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12074*/      OPC_MoveChild0,
/* 12075*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 12078*/      OPC_RecordMemRef,
/* 12079*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 12080*/      OPC_CheckFoldableChainNode,
/* 12081*/      OPC_MoveChild1,
/* 12082*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 12085*/      OPC_RecordChild0, // #1 = $addr
/* 12086*/      OPC_RecordChild1, // #2 = $off
/* 12087*/      OPC_MoveChild1,
/* 12088*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12091*/      OPC_MoveParent,
/* 12092*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 12094*/      OPC_CheckType, MVT::i32,
/* 12096*/      OPC_MoveParent,
/* 12097*/      OPC_RecordChild2, // #3 = $val
/* 12098*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 12100*/      OPC_MoveParent,
/* 12101*/      OPC_CheckType, MVT::i32,
/* 12103*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12105*/      OPC_EmitMergeInputChains1_0,
/* 12106*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12109*/      OPC_EmitConvertToTarget, 2,
/* 12111*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 12121*/    /*Scope*/ 50, /*->12172*/
/* 12122*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12125*/      OPC_MoveChild0,
/* 12126*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 12129*/      OPC_RecordMemRef,
/* 12130*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 12131*/      OPC_CheckFoldableChainNode,
/* 12132*/      OPC_MoveChild1,
/* 12133*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 12136*/      OPC_RecordChild0, // #1 = $addr
/* 12137*/      OPC_RecordChild1, // #2 = $off
/* 12138*/      OPC_MoveChild1,
/* 12139*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12142*/      OPC_MoveParent,
/* 12143*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 12145*/      OPC_CheckType, MVT::i32,
/* 12147*/      OPC_MoveParent,
/* 12148*/      OPC_RecordChild2, // #3 = $val
/* 12149*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 12151*/      OPC_MoveParent,
/* 12152*/      OPC_CheckType, MVT::i32,
/* 12154*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12156*/      OPC_EmitMergeInputChains1_0,
/* 12157*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12160*/      OPC_EmitConvertToTarget, 2,
/* 12162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 12172*/    /*Scope*/ 51, /*->12224*/
/* 12173*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12177*/      OPC_MoveChild0,
/* 12178*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 12181*/      OPC_RecordMemRef,
/* 12182*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 12183*/      OPC_CheckFoldableChainNode,
/* 12184*/      OPC_MoveChild1,
/* 12185*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 12188*/      OPC_RecordChild0, // #1 = $addr
/* 12189*/      OPC_RecordChild1, // #2 = $off
/* 12190*/      OPC_MoveChild1,
/* 12191*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12194*/      OPC_MoveParent,
/* 12195*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 12197*/      OPC_CheckType, MVT::i32,
/* 12199*/      OPC_MoveParent,
/* 12200*/      OPC_RecordChild2, // #3 = $val
/* 12201*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 12203*/      OPC_MoveParent,
/* 12204*/      OPC_CheckType, MVT::i32,
/* 12206*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12208*/      OPC_EmitMergeInputChains1_0,
/* 12209*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12212*/      OPC_EmitConvertToTarget, 2,
/* 12214*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 12224*/    /*Scope*/ 50, /*->12275*/
/* 12225*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12228*/      OPC_MoveChild0,
/* 12229*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 12232*/      OPC_RecordMemRef,
/* 12233*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 12234*/      OPC_CheckFoldableChainNode,
/* 12235*/      OPC_MoveChild1,
/* 12236*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 12239*/      OPC_RecordChild0, // #1 = $addr
/* 12240*/      OPC_RecordChild1, // #2 = $off
/* 12241*/      OPC_MoveChild1,
/* 12242*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12245*/      OPC_MoveParent,
/* 12246*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 12248*/      OPC_CheckType, MVT::i32,
/* 12250*/      OPC_MoveParent,
/* 12251*/      OPC_RecordChild2, // #3 = $val
/* 12252*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 12254*/      OPC_MoveParent,
/* 12255*/      OPC_CheckType, MVT::i32,
/* 12257*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12259*/      OPC_EmitMergeInputChains1_0,
/* 12260*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12263*/      OPC_EmitConvertToTarget, 2,
/* 12265*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 12275*/    /*Scope*/ 51, /*->12327*/
/* 12276*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12280*/      OPC_MoveChild0,
/* 12281*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 12284*/      OPC_RecordMemRef,
/* 12285*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 12286*/      OPC_CheckFoldableChainNode,
/* 12287*/      OPC_MoveChild1,
/* 12288*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 12291*/      OPC_RecordChild0, // #1 = $addr
/* 12292*/      OPC_RecordChild1, // #2 = $off
/* 12293*/      OPC_MoveChild1,
/* 12294*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12297*/      OPC_MoveParent,
/* 12298*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 12300*/      OPC_CheckType, MVT::i32,
/* 12302*/      OPC_MoveParent,
/* 12303*/      OPC_RecordChild2, // #3 = $val
/* 12304*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 12306*/      OPC_MoveParent,
/* 12307*/      OPC_CheckType, MVT::i32,
/* 12309*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12311*/      OPC_EmitMergeInputChains1_0,
/* 12312*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12315*/      OPC_EmitConvertToTarget, 2,
/* 12317*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 12327*/    /*Scope*/ 52, /*->12380*/
/* 12328*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12331*/      OPC_MoveChild0,
/* 12332*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 12335*/      OPC_RecordMemRef,
/* 12336*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 12337*/      OPC_CheckFoldableChainNode,
/* 12338*/      OPC_MoveChild1,
/* 12339*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 12342*/      OPC_RecordChild0, // #1 = $addr
/* 12343*/      OPC_RecordChild1, // #2 = $off
/* 12344*/      OPC_MoveChild1,
/* 12345*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12348*/      OPC_MoveParent,
/* 12349*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 12351*/      OPC_CheckType, MVT::i32,
/* 12353*/      OPC_MoveParent,
/* 12354*/      OPC_RecordChild2, // #3 = $exp
/* 12355*/      OPC_RecordChild3, // #4 = $new
/* 12356*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 12358*/      OPC_MoveParent,
/* 12359*/      OPC_CheckType, MVT::i32,
/* 12361*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12363*/      OPC_EmitMergeInputChains1_0,
/* 12364*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12367*/      OPC_EmitConvertToTarget, 2,
/* 12369*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 12380*/    /*Scope*/ 53, /*->12434*/
/* 12381*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12385*/      OPC_MoveChild0,
/* 12386*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 12389*/      OPC_RecordMemRef,
/* 12390*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 12391*/      OPC_CheckFoldableChainNode,
/* 12392*/      OPC_MoveChild1,
/* 12393*/      OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 12396*/      OPC_RecordChild0, // #1 = $addr
/* 12397*/      OPC_RecordChild1, // #2 = $off
/* 12398*/      OPC_MoveChild1,
/* 12399*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12402*/      OPC_MoveParent,
/* 12403*/      OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 12405*/      OPC_CheckType, MVT::i32,
/* 12407*/      OPC_MoveParent,
/* 12408*/      OPC_RecordChild2, // #3 = $exp
/* 12409*/      OPC_RecordChild3, // #4 = $new
/* 12410*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 12412*/      OPC_MoveParent,
/* 12413*/      OPC_CheckType, MVT::i32,
/* 12415*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12417*/      OPC_EmitMergeInputChains1_0,
/* 12418*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12421*/      OPC_EmitConvertToTarget, 2,
/* 12423*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 12434*/    /*Scope*/ 52, /*->12487*/
/* 12435*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12438*/      OPC_MoveChild0,
/* 12439*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 12442*/      OPC_RecordMemRef,
/* 12443*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 12444*/      OPC_CheckFoldableChainNode,
/* 12445*/      OPC_MoveChild1,
/* 12446*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 12449*/      OPC_RecordChild0, // #1 = $addr
/* 12450*/      OPC_RecordChild1, // #2 = $off
/* 12451*/      OPC_MoveChild1,
/* 12452*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12455*/      OPC_MoveParent,
/* 12456*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 12458*/      OPC_CheckType, MVT::i32,
/* 12460*/      OPC_MoveParent,
/* 12461*/      OPC_RecordChild2, // #3 = $exp
/* 12462*/      OPC_RecordChild3, // #4 = $new
/* 12463*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 12465*/      OPC_MoveParent,
/* 12466*/      OPC_CheckType, MVT::i32,
/* 12468*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12470*/      OPC_EmitMergeInputChains1_0,
/* 12471*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12474*/      OPC_EmitConvertToTarget, 2,
/* 12476*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 12487*/    /*Scope*/ 53, /*->12541*/
/* 12488*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12492*/      OPC_MoveChild0,
/* 12493*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 12496*/      OPC_RecordMemRef,
/* 12497*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 12498*/      OPC_CheckFoldableChainNode,
/* 12499*/      OPC_MoveChild1,
/* 12500*/      OPC_CheckOpcode, TARGET_VAL(ISD::OR),
/* 12503*/      OPC_RecordChild0, // #1 = $addr
/* 12504*/      OPC_RecordChild1, // #2 = $off
/* 12505*/      OPC_MoveChild1,
/* 12506*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12509*/      OPC_MoveParent,
/* 12510*/      OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 12512*/      OPC_CheckType, MVT::i32,
/* 12514*/      OPC_MoveParent,
/* 12515*/      OPC_RecordChild2, // #3 = $exp
/* 12516*/      OPC_RecordChild3, // #4 = $new
/* 12517*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 12519*/      OPC_MoveParent,
/* 12520*/      OPC_CheckType, MVT::i32,
/* 12522*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12524*/      OPC_EmitMergeInputChains1_0,
/* 12525*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12528*/      OPC_EmitConvertToTarget, 2,
/* 12530*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 12541*/    /*Scope*/ 46, /*->12588*/
/* 12542*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12545*/      OPC_MoveChild0,
/* 12546*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12549*/      OPC_MoveChild0,
/* 12550*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 12553*/      OPC_RecordMemRef,
/* 12554*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 12555*/      OPC_CheckFoldableChainNode,
/* 12556*/      OPC_RecordChild1, // #1 = $addr
/* 12557*/      OPC_CheckChild1Type, MVT::i32,
/* 12559*/      OPC_MoveChild2,
/* 12560*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12563*/      OPC_RecordChild0, // #2 = $val
/* 12564*/      OPC_MoveParent,
/* 12565*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 12567*/      OPC_MoveParent,
/* 12568*/      OPC_MoveParent,
/* 12569*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12571*/      OPC_EmitMergeInputChains1_0,
/* 12572*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12575*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12578*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>), 255:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12588*/    /*Scope*/ 47, /*->12636*/
/* 12589*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12593*/      OPC_MoveChild0,
/* 12594*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12597*/      OPC_MoveChild0,
/* 12598*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 12601*/      OPC_RecordMemRef,
/* 12602*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 12603*/      OPC_CheckFoldableChainNode,
/* 12604*/      OPC_RecordChild1, // #1 = $addr
/* 12605*/      OPC_CheckChild1Type, MVT::i32,
/* 12607*/      OPC_MoveChild2,
/* 12608*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12611*/      OPC_RecordChild0, // #2 = $val
/* 12612*/      OPC_MoveParent,
/* 12613*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 12615*/      OPC_MoveParent,
/* 12616*/      OPC_MoveParent,
/* 12617*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12619*/      OPC_EmitMergeInputChains1_0,
/* 12620*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12623*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>), 65535:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12636*/    /*Scope*/ 46, /*->12683*/
/* 12637*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12640*/      OPC_MoveChild0,
/* 12641*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12644*/      OPC_MoveChild0,
/* 12645*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 12648*/      OPC_RecordMemRef,
/* 12649*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 12650*/      OPC_CheckFoldableChainNode,
/* 12651*/      OPC_RecordChild1, // #1 = $addr
/* 12652*/      OPC_CheckChild1Type, MVT::i32,
/* 12654*/      OPC_MoveChild2,
/* 12655*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12658*/      OPC_RecordChild0, // #2 = $val
/* 12659*/      OPC_MoveParent,
/* 12660*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 12662*/      OPC_MoveParent,
/* 12663*/      OPC_MoveParent,
/* 12664*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12666*/      OPC_EmitMergeInputChains1_0,
/* 12667*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12670*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12673*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>), 255:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12683*/    /*Scope*/ 47, /*->12731*/
/* 12684*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12688*/      OPC_MoveChild0,
/* 12689*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12692*/      OPC_MoveChild0,
/* 12693*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 12696*/      OPC_RecordMemRef,
/* 12697*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 12698*/      OPC_CheckFoldableChainNode,
/* 12699*/      OPC_RecordChild1, // #1 = $addr
/* 12700*/      OPC_CheckChild1Type, MVT::i32,
/* 12702*/      OPC_MoveChild2,
/* 12703*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12706*/      OPC_RecordChild0, // #2 = $val
/* 12707*/      OPC_MoveParent,
/* 12708*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 12710*/      OPC_MoveParent,
/* 12711*/      OPC_MoveParent,
/* 12712*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12714*/      OPC_EmitMergeInputChains1_0,
/* 12715*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12718*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12721*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>), 65535:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12731*/    /*Scope*/ 46, /*->12778*/
/* 12732*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12735*/      OPC_MoveChild0,
/* 12736*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12739*/      OPC_MoveChild0,
/* 12740*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 12743*/      OPC_RecordMemRef,
/* 12744*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 12745*/      OPC_CheckFoldableChainNode,
/* 12746*/      OPC_RecordChild1, // #1 = $addr
/* 12747*/      OPC_CheckChild1Type, MVT::i32,
/* 12749*/      OPC_MoveChild2,
/* 12750*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12753*/      OPC_RecordChild0, // #2 = $val
/* 12754*/      OPC_MoveParent,
/* 12755*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 12757*/      OPC_MoveParent,
/* 12758*/      OPC_MoveParent,
/* 12759*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12761*/      OPC_EmitMergeInputChains1_0,
/* 12762*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12765*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12768*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>), 255:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12778*/    /*Scope*/ 47, /*->12826*/
/* 12779*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12783*/      OPC_MoveChild0,
/* 12784*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12787*/      OPC_MoveChild0,
/* 12788*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 12791*/      OPC_RecordMemRef,
/* 12792*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 12793*/      OPC_CheckFoldableChainNode,
/* 12794*/      OPC_RecordChild1, // #1 = $addr
/* 12795*/      OPC_CheckChild1Type, MVT::i32,
/* 12797*/      OPC_MoveChild2,
/* 12798*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12801*/      OPC_RecordChild0, // #2 = $val
/* 12802*/      OPC_MoveParent,
/* 12803*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 12805*/      OPC_MoveParent,
/* 12806*/      OPC_MoveParent,
/* 12807*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12809*/      OPC_EmitMergeInputChains1_0,
/* 12810*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12813*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12816*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>), 65535:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12826*/    /*Scope*/ 46, /*->12873*/
/* 12827*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12830*/      OPC_MoveChild0,
/* 12831*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12834*/      OPC_MoveChild0,
/* 12835*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 12838*/      OPC_RecordMemRef,
/* 12839*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 12840*/      OPC_CheckFoldableChainNode,
/* 12841*/      OPC_RecordChild1, // #1 = $addr
/* 12842*/      OPC_CheckChild1Type, MVT::i32,
/* 12844*/      OPC_MoveChild2,
/* 12845*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12848*/      OPC_RecordChild0, // #2 = $val
/* 12849*/      OPC_MoveParent,
/* 12850*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 12852*/      OPC_MoveParent,
/* 12853*/      OPC_MoveParent,
/* 12854*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12856*/      OPC_EmitMergeInputChains1_0,
/* 12857*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12860*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12863*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>), 255:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12873*/    /*Scope*/ 47, /*->12921*/
/* 12874*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12878*/      OPC_MoveChild0,
/* 12879*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12882*/      OPC_MoveChild0,
/* 12883*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 12886*/      OPC_RecordMemRef,
/* 12887*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 12888*/      OPC_CheckFoldableChainNode,
/* 12889*/      OPC_RecordChild1, // #1 = $addr
/* 12890*/      OPC_CheckChild1Type, MVT::i32,
/* 12892*/      OPC_MoveChild2,
/* 12893*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12896*/      OPC_RecordChild0, // #2 = $val
/* 12897*/      OPC_MoveParent,
/* 12898*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 12900*/      OPC_MoveParent,
/* 12901*/      OPC_MoveParent,
/* 12902*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12904*/      OPC_EmitMergeInputChains1_0,
/* 12905*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12908*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12911*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>), 65535:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12921*/    /*Scope*/ 46, /*->12968*/
/* 12922*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 12925*/      OPC_MoveChild0,
/* 12926*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12929*/      OPC_MoveChild0,
/* 12930*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 12933*/      OPC_RecordMemRef,
/* 12934*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 12935*/      OPC_CheckFoldableChainNode,
/* 12936*/      OPC_RecordChild1, // #1 = $addr
/* 12937*/      OPC_CheckChild1Type, MVT::i32,
/* 12939*/      OPC_MoveChild2,
/* 12940*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12943*/      OPC_RecordChild0, // #2 = $val
/* 12944*/      OPC_MoveParent,
/* 12945*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 12947*/      OPC_MoveParent,
/* 12948*/      OPC_MoveParent,
/* 12949*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12951*/      OPC_EmitMergeInputChains1_0,
/* 12952*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12955*/      OPC_EmitInteger, MVT::i32, 0, 
/* 12958*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>), 255:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 12968*/    /*Scope*/ 47, /*->13016*/
/* 12969*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 12973*/      OPC_MoveChild0,
/* 12974*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 12977*/      OPC_MoveChild0,
/* 12978*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 12981*/      OPC_RecordMemRef,
/* 12982*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 12983*/      OPC_CheckFoldableChainNode,
/* 12984*/      OPC_RecordChild1, // #1 = $addr
/* 12985*/      OPC_CheckChild1Type, MVT::i32,
/* 12987*/      OPC_MoveChild2,
/* 12988*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 12991*/      OPC_RecordChild0, // #2 = $val
/* 12992*/      OPC_MoveParent,
/* 12993*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 12995*/      OPC_MoveParent,
/* 12996*/      OPC_MoveParent,
/* 12997*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 12999*/      OPC_EmitMergeInputChains1_0,
/* 13000*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13003*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13006*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>), 65535:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 13016*/    /*Scope*/ 46, /*->13063*/
/* 13017*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13020*/      OPC_MoveChild0,
/* 13021*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 13024*/      OPC_MoveChild0,
/* 13025*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 13028*/      OPC_RecordMemRef,
/* 13029*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 13030*/      OPC_CheckFoldableChainNode,
/* 13031*/      OPC_RecordChild1, // #1 = $addr
/* 13032*/      OPC_CheckChild1Type, MVT::i32,
/* 13034*/      OPC_MoveChild2,
/* 13035*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 13038*/      OPC_RecordChild0, // #2 = $val
/* 13039*/      OPC_MoveParent,
/* 13040*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 13042*/      OPC_MoveParent,
/* 13043*/      OPC_MoveParent,
/* 13044*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13046*/      OPC_EmitMergeInputChains1_0,
/* 13047*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13050*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13053*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>), 255:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 13063*/    /*Scope*/ 47, /*->13111*/
/* 13064*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13068*/      OPC_MoveChild0,
/* 13069*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 13072*/      OPC_MoveChild0,
/* 13073*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 13076*/      OPC_RecordMemRef,
/* 13077*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 13078*/      OPC_CheckFoldableChainNode,
/* 13079*/      OPC_RecordChild1, // #1 = $addr
/* 13080*/      OPC_CheckChild1Type, MVT::i32,
/* 13082*/      OPC_MoveChild2,
/* 13083*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 13086*/      OPC_RecordChild0, // #2 = $val
/* 13087*/      OPC_MoveParent,
/* 13088*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 13090*/      OPC_MoveParent,
/* 13091*/      OPC_MoveParent,
/* 13092*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13094*/      OPC_EmitMergeInputChains1_0,
/* 13095*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13098*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13101*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>), 65535:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 13111*/    /*Scope*/ 51, /*->13163*/
/* 13112*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13115*/      OPC_MoveChild0,
/* 13116*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 13119*/      OPC_MoveChild0,
/* 13120*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 13123*/      OPC_RecordMemRef,
/* 13124*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 13125*/      OPC_CheckFoldableChainNode,
/* 13126*/      OPC_RecordChild1, // #1 = $off
/* 13127*/      OPC_MoveChild1,
/* 13128*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13131*/      OPC_MoveParent,
/* 13132*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 13134*/      OPC_MoveParent,
/* 13135*/      OPC_MoveParent,
/* 13136*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13138*/      OPC_EmitMergeInputChains1_0,
/* 13139*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13142*/      OPC_EmitConvertToTarget, 1,
/* 13144*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13147*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13154*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 13163*/    /*Scope*/ 52, /*->13216*/
/* 13164*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13168*/      OPC_MoveChild0,
/* 13169*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 13172*/      OPC_MoveChild0,
/* 13173*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 13176*/      OPC_RecordMemRef,
/* 13177*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 13178*/      OPC_CheckFoldableChainNode,
/* 13179*/      OPC_RecordChild1, // #1 = $off
/* 13180*/      OPC_MoveChild1,
/* 13181*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13184*/      OPC_MoveParent,
/* 13185*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 13187*/      OPC_MoveParent,
/* 13188*/      OPC_MoveParent,
/* 13189*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13191*/      OPC_EmitMergeInputChains1_0,
/* 13192*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13195*/      OPC_EmitConvertToTarget, 1,
/* 13197*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13200*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13207*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 18
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 13216*/    /*Scope*/ 51, /*->13268*/
/* 13217*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13220*/      OPC_MoveChild0,
/* 13221*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 13224*/      OPC_RecordMemRef,
/* 13225*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 13226*/      OPC_CheckFoldableChainNode,
/* 13227*/      OPC_MoveChild1,
/* 13228*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13231*/      OPC_RecordChild0, // #1 = $off
/* 13232*/      OPC_MoveChild0,
/* 13233*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13236*/      OPC_MoveParent,
/* 13237*/      OPC_MoveParent,
/* 13238*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 13240*/      OPC_MoveParent,
/* 13241*/      OPC_CheckType, MVT::i32,
/* 13243*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13245*/      OPC_EmitMergeInputChains1_0,
/* 13246*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13249*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13252*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 13259*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 13268*/    /*Scope*/ 52, /*->13321*/
/* 13269*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13273*/      OPC_MoveChild0,
/* 13274*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 13277*/      OPC_RecordMemRef,
/* 13278*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 13279*/      OPC_CheckFoldableChainNode,
/* 13280*/      OPC_MoveChild1,
/* 13281*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13284*/      OPC_RecordChild0, // #1 = $off
/* 13285*/      OPC_MoveChild0,
/* 13286*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13289*/      OPC_MoveParent,
/* 13290*/      OPC_MoveParent,
/* 13291*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 13293*/      OPC_MoveParent,
/* 13294*/      OPC_CheckType, MVT::i32,
/* 13296*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13298*/      OPC_EmitMergeInputChains1_0,
/* 13299*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13302*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13305*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 13312*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 13321*/    /*Scope*/ 51, /*->13373*/
/* 13322*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13325*/      OPC_MoveChild0,
/* 13326*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 13329*/      OPC_RecordMemRef,
/* 13330*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 13331*/      OPC_CheckFoldableChainNode,
/* 13332*/      OPC_MoveChild1,
/* 13333*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13336*/      OPC_RecordChild0, // #1 = $off
/* 13337*/      OPC_MoveChild0,
/* 13338*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 13341*/      OPC_MoveParent,
/* 13342*/      OPC_MoveParent,
/* 13343*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 13345*/      OPC_MoveParent,
/* 13346*/      OPC_CheckType, MVT::i32,
/* 13348*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13350*/      OPC_EmitMergeInputChains1_0,
/* 13351*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13354*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13357*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 13364*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 13373*/    /*Scope*/ 52, /*->13426*/
/* 13374*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13378*/      OPC_MoveChild0,
/* 13379*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 13382*/      OPC_RecordMemRef,
/* 13383*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 13384*/      OPC_CheckFoldableChainNode,
/* 13385*/      OPC_MoveChild1,
/* 13386*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13389*/      OPC_RecordChild0, // #1 = $off
/* 13390*/      OPC_MoveChild0,
/* 13391*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 13394*/      OPC_MoveParent,
/* 13395*/      OPC_MoveParent,
/* 13396*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 13398*/      OPC_MoveParent,
/* 13399*/      OPC_CheckType, MVT::i32,
/* 13401*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13403*/      OPC_EmitMergeInputChains1_0,
/* 13404*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13407*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13410*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 13417*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 13426*/    /*Scope*/ 53, /*->13480*/
/* 13427*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13430*/      OPC_MoveChild0,
/* 13431*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 13434*/      OPC_RecordMemRef,
/* 13435*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 13436*/      OPC_CheckFoldableChainNode,
/* 13437*/      OPC_MoveChild1,
/* 13438*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13441*/      OPC_RecordChild0, // #1 = $off
/* 13442*/      OPC_MoveChild0,
/* 13443*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13446*/      OPC_MoveParent,
/* 13447*/      OPC_MoveParent,
/* 13448*/      OPC_RecordChild2, // #2 = $val
/* 13449*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 13451*/      OPC_MoveParent,
/* 13452*/      OPC_CheckType, MVT::i32,
/* 13454*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13456*/      OPC_EmitMergeInputChains1_0,
/* 13457*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13460*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13463*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13470*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13480*/    /*Scope*/ 54, /*->13535*/
/* 13481*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13485*/      OPC_MoveChild0,
/* 13486*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 13489*/      OPC_RecordMemRef,
/* 13490*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 13491*/      OPC_CheckFoldableChainNode,
/* 13492*/      OPC_MoveChild1,
/* 13493*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13496*/      OPC_RecordChild0, // #1 = $off
/* 13497*/      OPC_MoveChild0,
/* 13498*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13501*/      OPC_MoveParent,
/* 13502*/      OPC_MoveParent,
/* 13503*/      OPC_RecordChild2, // #2 = $val
/* 13504*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 13506*/      OPC_MoveParent,
/* 13507*/      OPC_CheckType, MVT::i32,
/* 13509*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13511*/      OPC_EmitMergeInputChains1_0,
/* 13512*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13515*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13518*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13525*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13535*/    /*Scope*/ 53, /*->13589*/
/* 13536*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13539*/      OPC_MoveChild0,
/* 13540*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 13543*/      OPC_RecordMemRef,
/* 13544*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 13545*/      OPC_CheckFoldableChainNode,
/* 13546*/      OPC_MoveChild1,
/* 13547*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13550*/      OPC_RecordChild0, // #1 = $off
/* 13551*/      OPC_MoveChild0,
/* 13552*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 13555*/      OPC_MoveParent,
/* 13556*/      OPC_MoveParent,
/* 13557*/      OPC_RecordChild2, // #2 = $val
/* 13558*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 13560*/      OPC_MoveParent,
/* 13561*/      OPC_CheckType, MVT::i32,
/* 13563*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13565*/      OPC_EmitMergeInputChains1_0,
/* 13566*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13569*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13572*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13579*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13589*/    /*Scope*/ 54, /*->13644*/
/* 13590*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13594*/      OPC_MoveChild0,
/* 13595*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 13598*/      OPC_RecordMemRef,
/* 13599*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 13600*/      OPC_CheckFoldableChainNode,
/* 13601*/      OPC_MoveChild1,
/* 13602*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13605*/      OPC_RecordChild0, // #1 = $off
/* 13606*/      OPC_MoveChild0,
/* 13607*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 13610*/      OPC_MoveParent,
/* 13611*/      OPC_MoveParent,
/* 13612*/      OPC_RecordChild2, // #2 = $val
/* 13613*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 13615*/      OPC_MoveParent,
/* 13616*/      OPC_CheckType, MVT::i32,
/* 13618*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13620*/      OPC_EmitMergeInputChains1_0,
/* 13621*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13624*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13627*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13634*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13644*/    /*Scope*/ 53, /*->13698*/
/* 13645*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13648*/      OPC_MoveChild0,
/* 13649*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 13652*/      OPC_RecordMemRef,
/* 13653*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 13654*/      OPC_CheckFoldableChainNode,
/* 13655*/      OPC_MoveChild1,
/* 13656*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13659*/      OPC_RecordChild0, // #1 = $off
/* 13660*/      OPC_MoveChild0,
/* 13661*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13664*/      OPC_MoveParent,
/* 13665*/      OPC_MoveParent,
/* 13666*/      OPC_RecordChild2, // #2 = $val
/* 13667*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 13669*/      OPC_MoveParent,
/* 13670*/      OPC_CheckType, MVT::i32,
/* 13672*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13674*/      OPC_EmitMergeInputChains1_0,
/* 13675*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13678*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13681*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13688*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13698*/    /*Scope*/ 54, /*->13753*/
/* 13699*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13703*/      OPC_MoveChild0,
/* 13704*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 13707*/      OPC_RecordMemRef,
/* 13708*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 13709*/      OPC_CheckFoldableChainNode,
/* 13710*/      OPC_MoveChild1,
/* 13711*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13714*/      OPC_RecordChild0, // #1 = $off
/* 13715*/      OPC_MoveChild0,
/* 13716*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13719*/      OPC_MoveParent,
/* 13720*/      OPC_MoveParent,
/* 13721*/      OPC_RecordChild2, // #2 = $val
/* 13722*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 13724*/      OPC_MoveParent,
/* 13725*/      OPC_CheckType, MVT::i32,
/* 13727*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13729*/      OPC_EmitMergeInputChains1_0,
/* 13730*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13733*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13736*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13743*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13753*/    /*Scope*/ 53, /*->13807*/
/* 13754*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13757*/      OPC_MoveChild0,
/* 13758*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 13761*/      OPC_RecordMemRef,
/* 13762*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 13763*/      OPC_CheckFoldableChainNode,
/* 13764*/      OPC_MoveChild1,
/* 13765*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13768*/      OPC_RecordChild0, // #1 = $off
/* 13769*/      OPC_MoveChild0,
/* 13770*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 13773*/      OPC_MoveParent,
/* 13774*/      OPC_MoveParent,
/* 13775*/      OPC_RecordChild2, // #2 = $val
/* 13776*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 13778*/      OPC_MoveParent,
/* 13779*/      OPC_CheckType, MVT::i32,
/* 13781*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13783*/      OPC_EmitMergeInputChains1_0,
/* 13784*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13787*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13790*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13807*/    /*Scope*/ 54, /*->13862*/
/* 13808*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13812*/      OPC_MoveChild0,
/* 13813*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 13816*/      OPC_RecordMemRef,
/* 13817*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 13818*/      OPC_CheckFoldableChainNode,
/* 13819*/      OPC_MoveChild1,
/* 13820*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13823*/      OPC_RecordChild0, // #1 = $off
/* 13824*/      OPC_MoveChild0,
/* 13825*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 13828*/      OPC_MoveParent,
/* 13829*/      OPC_MoveParent,
/* 13830*/      OPC_RecordChild2, // #2 = $val
/* 13831*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 13833*/      OPC_MoveParent,
/* 13834*/      OPC_CheckType, MVT::i32,
/* 13836*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13838*/      OPC_EmitMergeInputChains1_0,
/* 13839*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13842*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13845*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13852*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13862*/    /*Scope*/ 53, /*->13916*/
/* 13863*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13866*/      OPC_MoveChild0,
/* 13867*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 13870*/      OPC_RecordMemRef,
/* 13871*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 13872*/      OPC_CheckFoldableChainNode,
/* 13873*/      OPC_MoveChild1,
/* 13874*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13877*/      OPC_RecordChild0, // #1 = $off
/* 13878*/      OPC_MoveChild0,
/* 13879*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13882*/      OPC_MoveParent,
/* 13883*/      OPC_MoveParent,
/* 13884*/      OPC_RecordChild2, // #2 = $val
/* 13885*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 13887*/      OPC_MoveParent,
/* 13888*/      OPC_CheckType, MVT::i32,
/* 13890*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13892*/      OPC_EmitMergeInputChains1_0,
/* 13893*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13896*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13899*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13916*/    /*Scope*/ 54, /*->13971*/
/* 13917*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 13921*/      OPC_MoveChild0,
/* 13922*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 13925*/      OPC_RecordMemRef,
/* 13926*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 13927*/      OPC_CheckFoldableChainNode,
/* 13928*/      OPC_MoveChild1,
/* 13929*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13932*/      OPC_RecordChild0, // #1 = $off
/* 13933*/      OPC_MoveChild0,
/* 13934*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 13937*/      OPC_MoveParent,
/* 13938*/      OPC_MoveParent,
/* 13939*/      OPC_RecordChild2, // #2 = $val
/* 13940*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 13942*/      OPC_MoveParent,
/* 13943*/      OPC_CheckType, MVT::i32,
/* 13945*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 13947*/      OPC_EmitMergeInputChains1_0,
/* 13948*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13951*/      OPC_EmitInteger, MVT::i32, 0, 
/* 13954*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 13961*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 13971*/    /*Scope*/ 53, /*->14025*/
/* 13972*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 13975*/      OPC_MoveChild0,
/* 13976*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 13979*/      OPC_RecordMemRef,
/* 13980*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 13981*/      OPC_CheckFoldableChainNode,
/* 13982*/      OPC_MoveChild1,
/* 13983*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 13986*/      OPC_RecordChild0, // #1 = $off
/* 13987*/      OPC_MoveChild0,
/* 13988*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 13991*/      OPC_MoveParent,
/* 13992*/      OPC_MoveParent,
/* 13993*/      OPC_RecordChild2, // #2 = $val
/* 13994*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 13996*/      OPC_MoveParent,
/* 13997*/      OPC_CheckType, MVT::i32,
/* 13999*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14001*/      OPC_EmitMergeInputChains1_0,
/* 14002*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14005*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14008*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14015*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14025*/    /*Scope*/ 54, /*->14080*/
/* 14026*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14030*/      OPC_MoveChild0,
/* 14031*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 14034*/      OPC_RecordMemRef,
/* 14035*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 14036*/      OPC_CheckFoldableChainNode,
/* 14037*/      OPC_MoveChild1,
/* 14038*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14041*/      OPC_RecordChild0, // #1 = $off
/* 14042*/      OPC_MoveChild0,
/* 14043*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14046*/      OPC_MoveParent,
/* 14047*/      OPC_MoveParent,
/* 14048*/      OPC_RecordChild2, // #2 = $val
/* 14049*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 14051*/      OPC_MoveParent,
/* 14052*/      OPC_CheckType, MVT::i32,
/* 14054*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14056*/      OPC_EmitMergeInputChains1_0,
/* 14057*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14060*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14063*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14070*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14080*/    /*Scope*/ 53, /*->14134*/
/* 14081*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14084*/      OPC_MoveChild0,
/* 14085*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 14088*/      OPC_RecordMemRef,
/* 14089*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 14090*/      OPC_CheckFoldableChainNode,
/* 14091*/      OPC_MoveChild1,
/* 14092*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14095*/      OPC_RecordChild0, // #1 = $off
/* 14096*/      OPC_MoveChild0,
/* 14097*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14100*/      OPC_MoveParent,
/* 14101*/      OPC_MoveParent,
/* 14102*/      OPC_RecordChild2, // #2 = $val
/* 14103*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 14105*/      OPC_MoveParent,
/* 14106*/      OPC_CheckType, MVT::i32,
/* 14108*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14110*/      OPC_EmitMergeInputChains1_0,
/* 14111*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14114*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14117*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14134*/    /*Scope*/ 54, /*->14189*/
/* 14135*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14139*/      OPC_MoveChild0,
/* 14140*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 14143*/      OPC_RecordMemRef,
/* 14144*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 14145*/      OPC_CheckFoldableChainNode,
/* 14146*/      OPC_MoveChild1,
/* 14147*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14150*/      OPC_RecordChild0, // #1 = $off
/* 14151*/      OPC_MoveChild0,
/* 14152*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14155*/      OPC_MoveParent,
/* 14156*/      OPC_MoveParent,
/* 14157*/      OPC_RecordChild2, // #2 = $val
/* 14158*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 14160*/      OPC_MoveParent,
/* 14161*/      OPC_CheckType, MVT::i32,
/* 14163*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14165*/      OPC_EmitMergeInputChains1_0,
/* 14166*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14169*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14172*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14179*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14189*/    /*Scope*/ 53, /*->14243*/
/* 14190*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14193*/      OPC_MoveChild0,
/* 14194*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 14197*/      OPC_RecordMemRef,
/* 14198*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 14199*/      OPC_CheckFoldableChainNode,
/* 14200*/      OPC_MoveChild1,
/* 14201*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14204*/      OPC_RecordChild0, // #1 = $off
/* 14205*/      OPC_MoveChild0,
/* 14206*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14209*/      OPC_MoveParent,
/* 14210*/      OPC_MoveParent,
/* 14211*/      OPC_RecordChild2, // #2 = $val
/* 14212*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 14214*/      OPC_MoveParent,
/* 14215*/      OPC_CheckType, MVT::i32,
/* 14217*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14219*/      OPC_EmitMergeInputChains1_0,
/* 14220*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14223*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14226*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14233*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14243*/    /*Scope*/ 54, /*->14298*/
/* 14244*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14248*/      OPC_MoveChild0,
/* 14249*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 14252*/      OPC_RecordMemRef,
/* 14253*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 14254*/      OPC_CheckFoldableChainNode,
/* 14255*/      OPC_MoveChild1,
/* 14256*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14259*/      OPC_RecordChild0, // #1 = $off
/* 14260*/      OPC_MoveChild0,
/* 14261*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14264*/      OPC_MoveParent,
/* 14265*/      OPC_MoveParent,
/* 14266*/      OPC_RecordChild2, // #2 = $val
/* 14267*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 14269*/      OPC_MoveParent,
/* 14270*/      OPC_CheckType, MVT::i32,
/* 14272*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14274*/      OPC_EmitMergeInputChains1_0,
/* 14275*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14278*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14281*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14288*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14298*/    /*Scope*/ 53, /*->14352*/
/* 14299*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14302*/      OPC_MoveChild0,
/* 14303*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 14306*/      OPC_RecordMemRef,
/* 14307*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 14308*/      OPC_CheckFoldableChainNode,
/* 14309*/      OPC_MoveChild1,
/* 14310*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14313*/      OPC_RecordChild0, // #1 = $off
/* 14314*/      OPC_MoveChild0,
/* 14315*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14318*/      OPC_MoveParent,
/* 14319*/      OPC_MoveParent,
/* 14320*/      OPC_RecordChild2, // #2 = $val
/* 14321*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 14323*/      OPC_MoveParent,
/* 14324*/      OPC_CheckType, MVT::i32,
/* 14326*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14328*/      OPC_EmitMergeInputChains1_0,
/* 14329*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14332*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14335*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14342*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14352*/    /*Scope*/ 54, /*->14407*/
/* 14353*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14357*/      OPC_MoveChild0,
/* 14358*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 14361*/      OPC_RecordMemRef,
/* 14362*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 14363*/      OPC_CheckFoldableChainNode,
/* 14364*/      OPC_MoveChild1,
/* 14365*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14368*/      OPC_RecordChild0, // #1 = $off
/* 14369*/      OPC_MoveChild0,
/* 14370*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14373*/      OPC_MoveParent,
/* 14374*/      OPC_MoveParent,
/* 14375*/      OPC_RecordChild2, // #2 = $val
/* 14376*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 14378*/      OPC_MoveParent,
/* 14379*/      OPC_CheckType, MVT::i32,
/* 14381*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14383*/      OPC_EmitMergeInputChains1_0,
/* 14384*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14387*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14390*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14407*/    /*Scope*/ 53, /*->14461*/
/* 14408*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14411*/      OPC_MoveChild0,
/* 14412*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 14415*/      OPC_RecordMemRef,
/* 14416*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 14417*/      OPC_CheckFoldableChainNode,
/* 14418*/      OPC_MoveChild1,
/* 14419*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14422*/      OPC_RecordChild0, // #1 = $off
/* 14423*/      OPC_MoveChild0,
/* 14424*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14427*/      OPC_MoveParent,
/* 14428*/      OPC_MoveParent,
/* 14429*/      OPC_RecordChild2, // #2 = $val
/* 14430*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 14432*/      OPC_MoveParent,
/* 14433*/      OPC_CheckType, MVT::i32,
/* 14435*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14437*/      OPC_EmitMergeInputChains1_0,
/* 14438*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14441*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14444*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14451*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14461*/    /*Scope*/ 54, /*->14516*/
/* 14462*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14466*/      OPC_MoveChild0,
/* 14467*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 14470*/      OPC_RecordMemRef,
/* 14471*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 14472*/      OPC_CheckFoldableChainNode,
/* 14473*/      OPC_MoveChild1,
/* 14474*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14477*/      OPC_RecordChild0, // #1 = $off
/* 14478*/      OPC_MoveChild0,
/* 14479*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14482*/      OPC_MoveParent,
/* 14483*/      OPC_MoveParent,
/* 14484*/      OPC_RecordChild2, // #2 = $val
/* 14485*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 14487*/      OPC_MoveParent,
/* 14488*/      OPC_CheckType, MVT::i32,
/* 14490*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14492*/      OPC_EmitMergeInputChains1_0,
/* 14493*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14496*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14499*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14506*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14516*/    /*Scope*/ 53, /*->14570*/
/* 14517*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14520*/      OPC_MoveChild0,
/* 14521*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 14524*/      OPC_RecordMemRef,
/* 14525*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 14526*/      OPC_CheckFoldableChainNode,
/* 14527*/      OPC_MoveChild1,
/* 14528*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14531*/      OPC_RecordChild0, // #1 = $off
/* 14532*/      OPC_MoveChild0,
/* 14533*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14536*/      OPC_MoveParent,
/* 14537*/      OPC_MoveParent,
/* 14538*/      OPC_RecordChild2, // #2 = $val
/* 14539*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 14541*/      OPC_MoveParent,
/* 14542*/      OPC_CheckType, MVT::i32,
/* 14544*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14546*/      OPC_EmitMergeInputChains1_0,
/* 14547*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14550*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14553*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14560*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14570*/    /*Scope*/ 54, /*->14625*/
/* 14571*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14575*/      OPC_MoveChild0,
/* 14576*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 14579*/      OPC_RecordMemRef,
/* 14580*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 14581*/      OPC_CheckFoldableChainNode,
/* 14582*/      OPC_MoveChild1,
/* 14583*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14586*/      OPC_RecordChild0, // #1 = $off
/* 14587*/      OPC_MoveChild0,
/* 14588*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14591*/      OPC_MoveParent,
/* 14592*/      OPC_MoveParent,
/* 14593*/      OPC_RecordChild2, // #2 = $val
/* 14594*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 14596*/      OPC_MoveParent,
/* 14597*/      OPC_CheckType, MVT::i32,
/* 14599*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14601*/      OPC_EmitMergeInputChains1_0,
/* 14602*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14605*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14608*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14615*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14625*/    /*Scope*/ 53, /*->14679*/
/* 14626*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14629*/      OPC_MoveChild0,
/* 14630*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 14633*/      OPC_RecordMemRef,
/* 14634*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 14635*/      OPC_CheckFoldableChainNode,
/* 14636*/      OPC_MoveChild1,
/* 14637*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14640*/      OPC_RecordChild0, // #1 = $off
/* 14641*/      OPC_MoveChild0,
/* 14642*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14645*/      OPC_MoveParent,
/* 14646*/      OPC_MoveParent,
/* 14647*/      OPC_RecordChild2, // #2 = $val
/* 14648*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 14650*/      OPC_MoveParent,
/* 14651*/      OPC_CheckType, MVT::i32,
/* 14653*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14655*/      OPC_EmitMergeInputChains1_0,
/* 14656*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14659*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14662*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14669*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14679*/    /*Scope*/ 54, /*->14734*/
/* 14680*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14684*/      OPC_MoveChild0,
/* 14685*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 14688*/      OPC_RecordMemRef,
/* 14689*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 14690*/      OPC_CheckFoldableChainNode,
/* 14691*/      OPC_MoveChild1,
/* 14692*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14695*/      OPC_RecordChild0, // #1 = $off
/* 14696*/      OPC_MoveChild0,
/* 14697*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14700*/      OPC_MoveParent,
/* 14701*/      OPC_MoveParent,
/* 14702*/      OPC_RecordChild2, // #2 = $val
/* 14703*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 14705*/      OPC_MoveParent,
/* 14706*/      OPC_CheckType, MVT::i32,
/* 14708*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14710*/      OPC_EmitMergeInputChains1_0,
/* 14711*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14714*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14717*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 14724*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 14734*/    /*Scope*/ 55, /*->14790*/
/* 14735*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14738*/      OPC_MoveChild0,
/* 14739*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 14742*/      OPC_RecordMemRef,
/* 14743*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 14744*/      OPC_CheckFoldableChainNode,
/* 14745*/      OPC_MoveChild1,
/* 14746*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14749*/      OPC_RecordChild0, // #1 = $off
/* 14750*/      OPC_MoveChild0,
/* 14751*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14754*/      OPC_MoveParent,
/* 14755*/      OPC_MoveParent,
/* 14756*/      OPC_RecordChild2, // #2 = $exp
/* 14757*/      OPC_RecordChild3, // #3 = $new
/* 14758*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 14760*/      OPC_MoveParent,
/* 14761*/      OPC_CheckType, MVT::i32,
/* 14763*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14765*/      OPC_EmitMergeInputChains1_0,
/* 14766*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14769*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14772*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 14779*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 14790*/    /*Scope*/ 56, /*->14847*/
/* 14791*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14795*/      OPC_MoveChild0,
/* 14796*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 14799*/      OPC_RecordMemRef,
/* 14800*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 14801*/      OPC_CheckFoldableChainNode,
/* 14802*/      OPC_MoveChild1,
/* 14803*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14806*/      OPC_RecordChild0, // #1 = $off
/* 14807*/      OPC_MoveChild0,
/* 14808*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 14811*/      OPC_MoveParent,
/* 14812*/      OPC_MoveParent,
/* 14813*/      OPC_RecordChild2, // #2 = $exp
/* 14814*/      OPC_RecordChild3, // #3 = $new
/* 14815*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 14817*/      OPC_MoveParent,
/* 14818*/      OPC_CheckType, MVT::i32,
/* 14820*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14822*/      OPC_EmitMergeInputChains1_0,
/* 14823*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14826*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14829*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 14836*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 14847*/    /*Scope*/ 55, /*->14903*/
/* 14848*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14851*/      OPC_MoveChild0,
/* 14852*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 14855*/      OPC_RecordMemRef,
/* 14856*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 14857*/      OPC_CheckFoldableChainNode,
/* 14858*/      OPC_MoveChild1,
/* 14859*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14862*/      OPC_RecordChild0, // #1 = $off
/* 14863*/      OPC_MoveChild0,
/* 14864*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14867*/      OPC_MoveParent,
/* 14868*/      OPC_MoveParent,
/* 14869*/      OPC_RecordChild2, // #2 = $exp
/* 14870*/      OPC_RecordChild3, // #3 = $new
/* 14871*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 14873*/      OPC_MoveParent,
/* 14874*/      OPC_CheckType, MVT::i32,
/* 14876*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14878*/      OPC_EmitMergeInputChains1_0,
/* 14879*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14882*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14885*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 14892*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 14903*/    /*Scope*/ 56, /*->14960*/
/* 14904*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 14908*/      OPC_MoveChild0,
/* 14909*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 14912*/      OPC_RecordMemRef,
/* 14913*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 14914*/      OPC_CheckFoldableChainNode,
/* 14915*/      OPC_MoveChild1,
/* 14916*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 14919*/      OPC_RecordChild0, // #1 = $off
/* 14920*/      OPC_MoveChild0,
/* 14921*/      OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 14924*/      OPC_MoveParent,
/* 14925*/      OPC_MoveParent,
/* 14926*/      OPC_RecordChild2, // #2 = $exp
/* 14927*/      OPC_RecordChild3, // #3 = $new
/* 14928*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 14930*/      OPC_MoveParent,
/* 14931*/      OPC_CheckType, MVT::i32,
/* 14933*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14935*/      OPC_EmitMergeInputChains1_0,
/* 14936*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14939*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14942*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 14949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 18
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 14960*/    /*Scope*/ 39, /*->15000*/
/* 14961*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 14964*/      OPC_MoveChild0,
/* 14965*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 14968*/      OPC_MoveChild0,
/* 14969*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 14972*/      OPC_RecordMemRef,
/* 14973*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 14974*/      OPC_CheckFoldableChainNode,
/* 14975*/      OPC_RecordChild1, // #1 = $addr
/* 14976*/      OPC_CheckChild1Type, MVT::i32,
/* 14978*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 14980*/      OPC_MoveParent,
/* 14981*/      OPC_MoveParent,
/* 14982*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 14984*/      OPC_EmitMergeInputChains1_0,
/* 14985*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14988*/      OPC_EmitInteger, MVT::i32, 0, 
/* 14991*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_8>>), 255:{ *:[i64] }) - Complexity = 15
                // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 15000*/    /*Scope*/ 40, /*->15041*/
/* 15001*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15005*/      OPC_MoveChild0,
/* 15006*/      OPC_CheckOpcode, TARGET_VAL(ISD::ANY_EXTEND),
/* 15009*/      OPC_MoveChild0,
/* 15010*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 15013*/      OPC_RecordMemRef,
/* 15014*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 15015*/      OPC_CheckFoldableChainNode,
/* 15016*/      OPC_RecordChild1, // #1 = $addr
/* 15017*/      OPC_CheckChild1Type, MVT::i32,
/* 15019*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 15021*/      OPC_MoveParent,
/* 15022*/      OPC_MoveParent,
/* 15023*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15025*/      OPC_EmitMergeInputChains1_0,
/* 15026*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15029*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15032*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (and:{ *:[i64] } (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_16>>), 65535:{ *:[i64] }) - Complexity = 15
                // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 15041*/    /*Scope*/ 35, /*->15077*/
/* 15042*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15045*/      OPC_MoveChild0,
/* 15046*/      OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 15049*/      OPC_RecordChild0, // #0 = $vec
/* 15050*/      OPC_CheckChild0Type, MVT::v16i8,
/* 15052*/      OPC_RecordChild1, // #1 = $idx
/* 15053*/      OPC_MoveChild1,
/* 15054*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15057*/      OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 15059*/      OPC_CheckType, MVT::i32,
/* 15061*/      OPC_MoveParent,
/* 15062*/      OPC_MoveParent,
/* 15063*/      OPC_CheckType, MVT::i32,
/* 15065*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 15067*/      OPC_EmitConvertToTarget, 1,
/* 15069*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v16i8_u), 0,
                    MVT::i32, 2/*#Ops*/, 0, 2, 
                // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
                // Dst: (EXTRACT_LANE_v16i8_u:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 15077*/    /*Scope*/ 36, /*->15114*/
/* 15078*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15082*/      OPC_MoveChild0,
/* 15083*/      OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 15086*/      OPC_RecordChild0, // #0 = $vec
/* 15087*/      OPC_CheckChild0Type, MVT::v8i16,
/* 15089*/      OPC_RecordChild1, // #1 = $idx
/* 15090*/      OPC_MoveChild1,
/* 15091*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15094*/      OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 15096*/      OPC_CheckType, MVT::i32,
/* 15098*/      OPC_MoveParent,
/* 15099*/      OPC_MoveParent,
/* 15100*/      OPC_CheckType, MVT::i32,
/* 15102*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 15104*/      OPC_EmitConvertToTarget, 1,
/* 15106*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v8i16_u), 0,
                    MVT::i32, 2/*#Ops*/, 0, 2, 
                // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (EXTRACT_LANE_v8i16_u:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 15114*/    /*Scope*/ 48, /*->15163*/
/* 15115*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15118*/      OPC_MoveChild0,
/* 15119*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 15122*/      OPC_RecordMemRef,
/* 15123*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 15124*/      OPC_CheckFoldableChainNode,
/* 15125*/      OPC_RecordChild1, // #1 = $off
/* 15126*/      OPC_MoveChild1,
/* 15127*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15130*/      OPC_MoveParent,
/* 15131*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 15133*/      OPC_MoveParent,
/* 15134*/      OPC_CheckType, MVT::i32,
/* 15136*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15138*/      OPC_EmitMergeInputChains1_0,
/* 15139*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15142*/      OPC_EmitConvertToTarget, 1,
/* 15144*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15147*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 15154*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 15163*/    /*Scope*/ 49, /*->15213*/
/* 15164*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15168*/      OPC_MoveChild0,
/* 15169*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 15172*/      OPC_RecordMemRef,
/* 15173*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 15174*/      OPC_CheckFoldableChainNode,
/* 15175*/      OPC_RecordChild1, // #1 = $off
/* 15176*/      OPC_MoveChild1,
/* 15177*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15180*/      OPC_MoveParent,
/* 15181*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 15183*/      OPC_MoveParent,
/* 15184*/      OPC_CheckType, MVT::i32,
/* 15186*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15188*/      OPC_EmitMergeInputChains1_0,
/* 15189*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15192*/      OPC_EmitConvertToTarget, 1,
/* 15194*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15197*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 15204*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 15213*/    /*Scope*/ 50, /*->15264*/
/* 15214*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15217*/      OPC_MoveChild0,
/* 15218*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 15221*/      OPC_RecordMemRef,
/* 15222*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 15223*/      OPC_CheckFoldableChainNode,
/* 15224*/      OPC_RecordChild1, // #1 = $off
/* 15225*/      OPC_MoveChild1,
/* 15226*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15229*/      OPC_MoveParent,
/* 15230*/      OPC_RecordChild2, // #2 = $val
/* 15231*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 15233*/      OPC_MoveParent,
/* 15234*/      OPC_CheckType, MVT::i32,
/* 15236*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15238*/      OPC_EmitMergeInputChains1_0,
/* 15239*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15242*/      OPC_EmitConvertToTarget, 1,
/* 15244*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15247*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15264*/    /*Scope*/ 51, /*->15316*/
/* 15265*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15269*/      OPC_MoveChild0,
/* 15270*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 15273*/      OPC_RecordMemRef,
/* 15274*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 15275*/      OPC_CheckFoldableChainNode,
/* 15276*/      OPC_RecordChild1, // #1 = $off
/* 15277*/      OPC_MoveChild1,
/* 15278*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15281*/      OPC_MoveParent,
/* 15282*/      OPC_RecordChild2, // #2 = $val
/* 15283*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 15285*/      OPC_MoveParent,
/* 15286*/      OPC_CheckType, MVT::i32,
/* 15288*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15290*/      OPC_EmitMergeInputChains1_0,
/* 15291*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15294*/      OPC_EmitConvertToTarget, 1,
/* 15296*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15299*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15306*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15316*/    /*Scope*/ 50, /*->15367*/
/* 15317*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15320*/      OPC_MoveChild0,
/* 15321*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 15324*/      OPC_RecordMemRef,
/* 15325*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 15326*/      OPC_CheckFoldableChainNode,
/* 15327*/      OPC_RecordChild1, // #1 = $off
/* 15328*/      OPC_MoveChild1,
/* 15329*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15332*/      OPC_MoveParent,
/* 15333*/      OPC_RecordChild2, // #2 = $val
/* 15334*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 15336*/      OPC_MoveParent,
/* 15337*/      OPC_CheckType, MVT::i32,
/* 15339*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15341*/      OPC_EmitMergeInputChains1_0,
/* 15342*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15345*/      OPC_EmitConvertToTarget, 1,
/* 15347*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15350*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15357*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15367*/    /*Scope*/ 51, /*->15419*/
/* 15368*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15372*/      OPC_MoveChild0,
/* 15373*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 15376*/      OPC_RecordMemRef,
/* 15377*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 15378*/      OPC_CheckFoldableChainNode,
/* 15379*/      OPC_RecordChild1, // #1 = $off
/* 15380*/      OPC_MoveChild1,
/* 15381*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15384*/      OPC_MoveParent,
/* 15385*/      OPC_RecordChild2, // #2 = $val
/* 15386*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 15388*/      OPC_MoveParent,
/* 15389*/      OPC_CheckType, MVT::i32,
/* 15391*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15393*/      OPC_EmitMergeInputChains1_0,
/* 15394*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15397*/      OPC_EmitConvertToTarget, 1,
/* 15399*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15402*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15409*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15419*/    /*Scope*/ 50, /*->15470*/
/* 15420*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15423*/      OPC_MoveChild0,
/* 15424*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 15427*/      OPC_RecordMemRef,
/* 15428*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 15429*/      OPC_CheckFoldableChainNode,
/* 15430*/      OPC_RecordChild1, // #1 = $off
/* 15431*/      OPC_MoveChild1,
/* 15432*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15435*/      OPC_MoveParent,
/* 15436*/      OPC_RecordChild2, // #2 = $val
/* 15437*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 15439*/      OPC_MoveParent,
/* 15440*/      OPC_CheckType, MVT::i32,
/* 15442*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15444*/      OPC_EmitMergeInputChains1_0,
/* 15445*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15448*/      OPC_EmitConvertToTarget, 1,
/* 15450*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15453*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15460*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15470*/    /*Scope*/ 51, /*->15522*/
/* 15471*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15475*/      OPC_MoveChild0,
/* 15476*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 15479*/      OPC_RecordMemRef,
/* 15480*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 15481*/      OPC_CheckFoldableChainNode,
/* 15482*/      OPC_RecordChild1, // #1 = $off
/* 15483*/      OPC_MoveChild1,
/* 15484*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15487*/      OPC_MoveParent,
/* 15488*/      OPC_RecordChild2, // #2 = $val
/* 15489*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 15491*/      OPC_MoveParent,
/* 15492*/      OPC_CheckType, MVT::i32,
/* 15494*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15496*/      OPC_EmitMergeInputChains1_0,
/* 15497*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15500*/      OPC_EmitConvertToTarget, 1,
/* 15502*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15505*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15512*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15522*/    /*Scope*/ 50, /*->15573*/
/* 15523*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15526*/      OPC_MoveChild0,
/* 15527*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 15530*/      OPC_RecordMemRef,
/* 15531*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 15532*/      OPC_CheckFoldableChainNode,
/* 15533*/      OPC_RecordChild1, // #1 = $off
/* 15534*/      OPC_MoveChild1,
/* 15535*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15538*/      OPC_MoveParent,
/* 15539*/      OPC_RecordChild2, // #2 = $val
/* 15540*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 15542*/      OPC_MoveParent,
/* 15543*/      OPC_CheckType, MVT::i32,
/* 15545*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15547*/      OPC_EmitMergeInputChains1_0,
/* 15548*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15551*/      OPC_EmitConvertToTarget, 1,
/* 15553*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15556*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15563*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15573*/    /*Scope*/ 51, /*->15625*/
/* 15574*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15578*/      OPC_MoveChild0,
/* 15579*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 15582*/      OPC_RecordMemRef,
/* 15583*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 15584*/      OPC_CheckFoldableChainNode,
/* 15585*/      OPC_RecordChild1, // #1 = $off
/* 15586*/      OPC_MoveChild1,
/* 15587*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15590*/      OPC_MoveParent,
/* 15591*/      OPC_RecordChild2, // #2 = $val
/* 15592*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 15594*/      OPC_MoveParent,
/* 15595*/      OPC_CheckType, MVT::i32,
/* 15597*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15599*/      OPC_EmitMergeInputChains1_0,
/* 15600*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15603*/      OPC_EmitConvertToTarget, 1,
/* 15605*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15608*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15615*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15625*/    /*Scope*/ 50, /*->15676*/
/* 15626*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15629*/      OPC_MoveChild0,
/* 15630*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 15633*/      OPC_RecordMemRef,
/* 15634*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 15635*/      OPC_CheckFoldableChainNode,
/* 15636*/      OPC_RecordChild1, // #1 = $off
/* 15637*/      OPC_MoveChild1,
/* 15638*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15641*/      OPC_MoveParent,
/* 15642*/      OPC_RecordChild2, // #2 = $val
/* 15643*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 15645*/      OPC_MoveParent,
/* 15646*/      OPC_CheckType, MVT::i32,
/* 15648*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15650*/      OPC_EmitMergeInputChains1_0,
/* 15651*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15654*/      OPC_EmitConvertToTarget, 1,
/* 15656*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15659*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15666*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15676*/    /*Scope*/ 51, /*->15728*/
/* 15677*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15681*/      OPC_MoveChild0,
/* 15682*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 15685*/      OPC_RecordMemRef,
/* 15686*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 15687*/      OPC_CheckFoldableChainNode,
/* 15688*/      OPC_RecordChild1, // #1 = $off
/* 15689*/      OPC_MoveChild1,
/* 15690*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15693*/      OPC_MoveParent,
/* 15694*/      OPC_RecordChild2, // #2 = $val
/* 15695*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 15697*/      OPC_MoveParent,
/* 15698*/      OPC_CheckType, MVT::i32,
/* 15700*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15702*/      OPC_EmitMergeInputChains1_0,
/* 15703*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15706*/      OPC_EmitConvertToTarget, 1,
/* 15708*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15711*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15718*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15728*/    /*Scope*/ 50, /*->15779*/
/* 15729*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15732*/      OPC_MoveChild0,
/* 15733*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 15736*/      OPC_RecordMemRef,
/* 15737*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 15738*/      OPC_CheckFoldableChainNode,
/* 15739*/      OPC_RecordChild1, // #1 = $off
/* 15740*/      OPC_MoveChild1,
/* 15741*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15744*/      OPC_MoveParent,
/* 15745*/      OPC_RecordChild2, // #2 = $val
/* 15746*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 15748*/      OPC_MoveParent,
/* 15749*/      OPC_CheckType, MVT::i32,
/* 15751*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15753*/      OPC_EmitMergeInputChains1_0,
/* 15754*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15757*/      OPC_EmitConvertToTarget, 1,
/* 15759*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15762*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15779*/    /*Scope*/ 51, /*->15831*/
/* 15780*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15784*/      OPC_MoveChild0,
/* 15785*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 15788*/      OPC_RecordMemRef,
/* 15789*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 15790*/      OPC_CheckFoldableChainNode,
/* 15791*/      OPC_RecordChild1, // #1 = $off
/* 15792*/      OPC_MoveChild1,
/* 15793*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15796*/      OPC_MoveParent,
/* 15797*/      OPC_RecordChild2, // #2 = $val
/* 15798*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 15800*/      OPC_MoveParent,
/* 15801*/      OPC_CheckType, MVT::i32,
/* 15803*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15805*/      OPC_EmitMergeInputChains1_0,
/* 15806*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15809*/      OPC_EmitConvertToTarget, 1,
/* 15811*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15814*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 15821*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 15831*/    /*Scope*/ 52, /*->15884*/
/* 15832*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15835*/      OPC_MoveChild0,
/* 15836*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 15839*/      OPC_RecordMemRef,
/* 15840*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 15841*/      OPC_CheckFoldableChainNode,
/* 15842*/      OPC_RecordChild1, // #1 = $off
/* 15843*/      OPC_MoveChild1,
/* 15844*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15847*/      OPC_MoveParent,
/* 15848*/      OPC_RecordChild2, // #2 = $exp
/* 15849*/      OPC_RecordChild3, // #3 = $new
/* 15850*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 15852*/      OPC_MoveParent,
/* 15853*/      OPC_CheckType, MVT::i32,
/* 15855*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15857*/      OPC_EmitMergeInputChains1_0,
/* 15858*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15861*/      OPC_EmitConvertToTarget, 1,
/* 15863*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15866*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 15873*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 15884*/    /*Scope*/ 53, /*->15938*/
/* 15885*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15889*/      OPC_MoveChild0,
/* 15890*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 15893*/      OPC_RecordMemRef,
/* 15894*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 15895*/      OPC_CheckFoldableChainNode,
/* 15896*/      OPC_RecordChild1, // #1 = $off
/* 15897*/      OPC_MoveChild1,
/* 15898*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 15901*/      OPC_MoveParent,
/* 15902*/      OPC_RecordChild2, // #2 = $exp
/* 15903*/      OPC_RecordChild3, // #3 = $new
/* 15904*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 15906*/      OPC_MoveParent,
/* 15907*/      OPC_CheckType, MVT::i32,
/* 15909*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 15911*/      OPC_EmitMergeInputChains1_0,
/* 15912*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15915*/      OPC_EmitConvertToTarget, 1,
/* 15917*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15920*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 15927*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 15
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 15938*/    /*Scope*/ 29, /*->15968*/
/* 15939*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 15942*/      OPC_MoveChild0,
/* 15943*/      OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 15946*/      OPC_RecordChild0, // #0 = $vec
/* 15947*/      OPC_CheckChild0Type, MVT::v16i8,
/* 15949*/      OPC_MoveChild1,
/* 15950*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 15953*/      OPC_MoveParent,
/* 15954*/      OPC_MoveParent,
/* 15955*/      OPC_CheckType, MVT::i32,
/* 15957*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15960*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v16i8_u), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (undef:{ *:[iPTR] })), 255:{ *:[i32] }) - Complexity = 14
                // Dst: (EXTRACT_LANE_v16i8_u:{ *:[i32] } V128:{ *:[v16i8] }:$vec, 0:{ *:[i32] })
/* 15968*/    /*Scope*/ 30, /*->15999*/
/* 15969*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 15973*/      OPC_MoveChild0,
/* 15974*/      OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 15977*/      OPC_RecordChild0, // #0 = $vec
/* 15978*/      OPC_CheckChild0Type, MVT::v8i16,
/* 15980*/      OPC_MoveChild1,
/* 15981*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 15984*/      OPC_MoveParent,
/* 15985*/      OPC_MoveParent,
/* 15986*/      OPC_CheckType, MVT::i32,
/* 15988*/      OPC_EmitInteger, MVT::i32, 0, 
/* 15991*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v8i16_u), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (undef:{ *:[iPTR] })), 65535:{ *:[i32] }) - Complexity = 14
                // Dst: (EXTRACT_LANE_v8i16_u:{ *:[i32] } V128:{ *:[v8i16] }:$vec, 0:{ *:[i32] })
/* 15999*/    /*Scope*/ 36, /*->16036*/
/* 16000*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16003*/      OPC_MoveChild0,
/* 16004*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 16007*/      OPC_RecordMemRef,
/* 16008*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 16009*/      OPC_CheckFoldableChainNode,
/* 16010*/      OPC_RecordChild1, // #1 = $addr
/* 16011*/      OPC_CheckChild1Type, MVT::i32,
/* 16013*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 16015*/      OPC_MoveParent,
/* 16016*/      OPC_CheckType, MVT::i32,
/* 16018*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16020*/      OPC_EmitMergeInputChains1_0,
/* 16021*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16024*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16027*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 16036*/    /*Scope*/ 37, /*->16074*/
/* 16037*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16041*/      OPC_MoveChild0,
/* 16042*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD),
/* 16045*/      OPC_RecordMemRef,
/* 16046*/      OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 16047*/      OPC_CheckFoldableChainNode,
/* 16048*/      OPC_RecordChild1, // #1 = $addr
/* 16049*/      OPC_CheckChild1Type, MVT::i32,
/* 16051*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 16053*/      OPC_MoveParent,
/* 16054*/      OPC_CheckType, MVT::i32,
/* 16056*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16058*/      OPC_EmitMergeInputChains1_0,
/* 16059*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16062*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16065*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                // Src: (and:{ *:[i32] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 16074*/    /*Scope*/ 38, /*->16113*/
/* 16075*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16078*/      OPC_MoveChild0,
/* 16079*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 16082*/      OPC_RecordMemRef,
/* 16083*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 16084*/      OPC_CheckFoldableChainNode,
/* 16085*/      OPC_RecordChild1, // #1 = $addr
/* 16086*/      OPC_CheckChild1Type, MVT::i32,
/* 16088*/      OPC_RecordChild2, // #2 = $val
/* 16089*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 16091*/      OPC_MoveParent,
/* 16092*/      OPC_CheckType, MVT::i32,
/* 16094*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16096*/      OPC_EmitMergeInputChains1_0,
/* 16097*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16100*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16113*/    /*Scope*/ 39, /*->16153*/
/* 16114*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16118*/      OPC_MoveChild0,
/* 16119*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),
/* 16122*/      OPC_RecordMemRef,
/* 16123*/      OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 16124*/      OPC_CheckFoldableChainNode,
/* 16125*/      OPC_RecordChild1, // #1 = $addr
/* 16126*/      OPC_CheckChild1Type, MVT::i32,
/* 16128*/      OPC_RecordChild2, // #2 = $val
/* 16129*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 16131*/      OPC_MoveParent,
/* 16132*/      OPC_CheckType, MVT::i32,
/* 16134*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16136*/      OPC_EmitMergeInputChains1_0,
/* 16137*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16140*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16143*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16153*/    /*Scope*/ 38, /*->16192*/
/* 16154*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16157*/      OPC_MoveChild0,
/* 16158*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 16161*/      OPC_RecordMemRef,
/* 16162*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 16163*/      OPC_CheckFoldableChainNode,
/* 16164*/      OPC_RecordChild1, // #1 = $addr
/* 16165*/      OPC_CheckChild1Type, MVT::i32,
/* 16167*/      OPC_RecordChild2, // #2 = $val
/* 16168*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 16170*/      OPC_MoveParent,
/* 16171*/      OPC_CheckType, MVT::i32,
/* 16173*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16175*/      OPC_EmitMergeInputChains1_0,
/* 16176*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16179*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16182*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16192*/    /*Scope*/ 39, /*->16232*/
/* 16193*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16197*/      OPC_MoveChild0,
/* 16198*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),
/* 16201*/      OPC_RecordMemRef,
/* 16202*/      OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 16203*/      OPC_CheckFoldableChainNode,
/* 16204*/      OPC_RecordChild1, // #1 = $addr
/* 16205*/      OPC_CheckChild1Type, MVT::i32,
/* 16207*/      OPC_RecordChild2, // #2 = $val
/* 16208*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 16210*/      OPC_MoveParent,
/* 16211*/      OPC_CheckType, MVT::i32,
/* 16213*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16215*/      OPC_EmitMergeInputChains1_0,
/* 16216*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16219*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16222*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16232*/    /*Scope*/ 38, /*->16271*/
/* 16233*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16236*/      OPC_MoveChild0,
/* 16237*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 16240*/      OPC_RecordMemRef,
/* 16241*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 16242*/      OPC_CheckFoldableChainNode,
/* 16243*/      OPC_RecordChild1, // #1 = $addr
/* 16244*/      OPC_CheckChild1Type, MVT::i32,
/* 16246*/      OPC_RecordChild2, // #2 = $val
/* 16247*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 16249*/      OPC_MoveParent,
/* 16250*/      OPC_CheckType, MVT::i32,
/* 16252*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16254*/      OPC_EmitMergeInputChains1_0,
/* 16255*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16258*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16261*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16271*/    /*Scope*/ 39, /*->16311*/
/* 16272*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16276*/      OPC_MoveChild0,
/* 16277*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_AND),
/* 16280*/      OPC_RecordMemRef,
/* 16281*/      OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 16282*/      OPC_CheckFoldableChainNode,
/* 16283*/      OPC_RecordChild1, // #1 = $addr
/* 16284*/      OPC_CheckChild1Type, MVT::i32,
/* 16286*/      OPC_RecordChild2, // #2 = $val
/* 16287*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 16289*/      OPC_MoveParent,
/* 16290*/      OPC_CheckType, MVT::i32,
/* 16292*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16294*/      OPC_EmitMergeInputChains1_0,
/* 16295*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16298*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16301*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16311*/    /*Scope*/ 38, /*->16350*/
/* 16312*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16315*/      OPC_MoveChild0,
/* 16316*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 16319*/      OPC_RecordMemRef,
/* 16320*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 16321*/      OPC_CheckFoldableChainNode,
/* 16322*/      OPC_RecordChild1, // #1 = $addr
/* 16323*/      OPC_CheckChild1Type, MVT::i32,
/* 16325*/      OPC_RecordChild2, // #2 = $val
/* 16326*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 16328*/      OPC_MoveParent,
/* 16329*/      OPC_CheckType, MVT::i32,
/* 16331*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16333*/      OPC_EmitMergeInputChains1_0,
/* 16334*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16337*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16350*/    /*Scope*/ 39, /*->16390*/
/* 16351*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16355*/      OPC_MoveChild0,
/* 16356*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_OR),
/* 16359*/      OPC_RecordMemRef,
/* 16360*/      OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 16361*/      OPC_CheckFoldableChainNode,
/* 16362*/      OPC_RecordChild1, // #1 = $addr
/* 16363*/      OPC_CheckChild1Type, MVT::i32,
/* 16365*/      OPC_RecordChild2, // #2 = $val
/* 16366*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 16368*/      OPC_MoveParent,
/* 16369*/      OPC_CheckType, MVT::i32,
/* 16371*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16373*/      OPC_EmitMergeInputChains1_0,
/* 16374*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16377*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16380*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16390*/    /*Scope*/ 38, /*->16429*/
/* 16391*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16394*/      OPC_MoveChild0,
/* 16395*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 16398*/      OPC_RecordMemRef,
/* 16399*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 16400*/      OPC_CheckFoldableChainNode,
/* 16401*/      OPC_RecordChild1, // #1 = $addr
/* 16402*/      OPC_CheckChild1Type, MVT::i32,
/* 16404*/      OPC_RecordChild2, // #2 = $val
/* 16405*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 16407*/      OPC_MoveParent,
/* 16408*/      OPC_CheckType, MVT::i32,
/* 16410*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16412*/      OPC_EmitMergeInputChains1_0,
/* 16413*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16416*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16419*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16429*/    /*Scope*/ 39, /*->16469*/
/* 16430*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16434*/      OPC_MoveChild0,
/* 16435*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),
/* 16438*/      OPC_RecordMemRef,
/* 16439*/      OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 16440*/      OPC_CheckFoldableChainNode,
/* 16441*/      OPC_RecordChild1, // #1 = $addr
/* 16442*/      OPC_CheckChild1Type, MVT::i32,
/* 16444*/      OPC_RecordChild2, // #2 = $val
/* 16445*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 16447*/      OPC_MoveParent,
/* 16448*/      OPC_CheckType, MVT::i32,
/* 16450*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16452*/      OPC_EmitMergeInputChains1_0,
/* 16453*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16456*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16459*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16469*/    /*Scope*/ 38, /*->16508*/
/* 16470*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16473*/      OPC_MoveChild0,
/* 16474*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 16477*/      OPC_RecordMemRef,
/* 16478*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 16479*/      OPC_CheckFoldableChainNode,
/* 16480*/      OPC_RecordChild1, // #1 = $addr
/* 16481*/      OPC_CheckChild1Type, MVT::i32,
/* 16483*/      OPC_RecordChild2, // #2 = $val
/* 16484*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 16486*/      OPC_MoveParent,
/* 16487*/      OPC_CheckType, MVT::i32,
/* 16489*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16491*/      OPC_EmitMergeInputChains1_0,
/* 16492*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16495*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16498*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16508*/    /*Scope*/ 39, /*->16548*/
/* 16509*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16513*/      OPC_MoveChild0,
/* 16514*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_SWAP),
/* 16517*/      OPC_RecordMemRef,
/* 16518*/      OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 16519*/      OPC_CheckFoldableChainNode,
/* 16520*/      OPC_RecordChild1, // #1 = $addr
/* 16521*/      OPC_CheckChild1Type, MVT::i32,
/* 16523*/      OPC_RecordChild2, // #2 = $val
/* 16524*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 16526*/      OPC_MoveParent,
/* 16527*/      OPC_CheckType, MVT::i32,
/* 16529*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16531*/      OPC_EmitMergeInputChains1_0,
/* 16532*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16535*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16538*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                // Src: (and:{ *:[i32] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 16548*/    /*Scope*/ 40, /*->16589*/
/* 16549*/      OPC_CheckAndImm, 127|128,1/*255*/, 
/* 16552*/      OPC_MoveChild0,
/* 16553*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 16556*/      OPC_RecordMemRef,
/* 16557*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 16558*/      OPC_CheckFoldableChainNode,
/* 16559*/      OPC_RecordChild1, // #1 = $addr
/* 16560*/      OPC_CheckChild1Type, MVT::i32,
/* 16562*/      OPC_RecordChild2, // #2 = $exp
/* 16563*/      OPC_RecordChild3, // #3 = $new
/* 16564*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 16566*/      OPC_MoveParent,
/* 16567*/      OPC_CheckType, MVT::i32,
/* 16569*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16571*/      OPC_EmitMergeInputChains1_0,
/* 16572*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16575*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16578*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>>, 255:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 16589*/    /*Scope*/ 41, /*->16631*/
/* 16590*/      OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/* 16594*/      OPC_MoveChild0,
/* 16595*/      OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 16598*/      OPC_RecordMemRef,
/* 16599*/      OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 16600*/      OPC_CheckFoldableChainNode,
/* 16601*/      OPC_RecordChild1, // #1 = $addr
/* 16602*/      OPC_CheckChild1Type, MVT::i32,
/* 16604*/      OPC_RecordChild2, // #2 = $exp
/* 16605*/      OPC_RecordChild3, // #3 = $new
/* 16606*/      OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 16608*/      OPC_MoveParent,
/* 16609*/      OPC_CheckType, MVT::i32,
/* 16611*/      OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16613*/      OPC_EmitMergeInputChains1_0,
/* 16614*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16617*/      OPC_EmitInteger, MVT::i32, 0, 
/* 16620*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                // Src: (and:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>>, 65535:{ *:[i32] }) - Complexity = 12
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 16631*/    /*Scope*/ 72, /*->16704*/
/* 16632*/      OPC_RecordChild0, // #0 = $lhs
/* 16633*/      OPC_RecordChild1, // #1 = $rhs
/* 16634*/      OPC_SwitchType /*6 cases */, 8, MVT::i32,// ->16645
/* 16637*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 16645*/      /*SwitchType*/ 8, MVT::i64,// ->16655
/* 16647*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 16655*/      /*SwitchType*/ 10, MVT::v16i8,// ->16667
/* 16657*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 16659*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                  // Dst: (AND_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 16667*/      /*SwitchType*/ 10, MVT::v8i16,// ->16679
/* 16669*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 16671*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                  // Dst: (AND_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 16679*/      /*SwitchType*/ 10, MVT::v4i32,// ->16691
/* 16681*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 16683*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
                  // Dst: (AND_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 16691*/      /*SwitchType*/ 10, MVT::v2i64,// ->16703
/* 16693*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 16695*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
                  // Dst: (AND_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 16703*/      0, // EndSwitchType
/* 16704*/    0, /*End of Scope*/
/* 16705*/  /*SwitchOpcode*/ 54|128,33/*4278*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->20987
/* 16709*/    OPC_Scope, 41|128,33/*4265*/, /*->20977*/ // 2 children in Scope
/* 16712*/      OPC_MoveChild0,
/* 16713*/      OPC_SwitchOpcode /*9 cases */, 38|128,6/*806*/, TARGET_VAL(ISD::AssertZext),// ->17524
/* 16718*/        OPC_MoveChild0,
/* 16719*/        OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 16722*/        OPC_RecordMemRef,
/* 16723*/        OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 16724*/        OPC_CheckFoldableChainNode,
/* 16725*/        OPC_Scope, 123|128,4/*635*/, /*->17363*/ // 2 children in Scope
/* 16728*/          OPC_MoveChild1,
/* 16729*/          OPC_SwitchOpcode /*3 cases */, 121|128,2/*377*/, TARGET_VAL(ISD::ADD),// ->17111
/* 16734*/            OPC_Scope, 75, /*->16811*/ // 5 children in Scope
/* 16736*/              OPC_RecordChild0, // #1 = $addr
/* 16737*/              OPC_MoveChild1,
/* 16738*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 16741*/              OPC_RecordChild0, // #2 = $off
/* 16742*/              OPC_MoveChild0,
/* 16743*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 16746*/              OPC_MoveParent,
/* 16747*/              OPC_MoveParent,
/* 16748*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 16750*/              OPC_CheckType, MVT::i32,
/* 16752*/              OPC_MoveParent,
/* 16753*/              OPC_MoveChild2,
/* 16754*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16757*/              OPC_RecordChild0, // #3 = $exp
/* 16758*/              OPC_MoveParent,
/* 16759*/              OPC_MoveChild3,
/* 16760*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16763*/              OPC_RecordChild0, // #4 = $new
/* 16764*/              OPC_MoveParent,
/* 16765*/              OPC_Scope, 21, /*->16788*/ // 2 children in Scope
/* 16767*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 16769*/                OPC_MoveParent,
/* 16770*/                OPC_MoveParent,
/* 16771*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16773*/                OPC_EmitMergeInputChains1_0,
/* 16774*/                OPC_EmitInteger, MVT::i32, 0, 
/* 16777*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 16788*/              /*Scope*/ 21, /*->16810*/
/* 16789*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 16791*/                OPC_MoveParent,
/* 16792*/                OPC_MoveParent,
/* 16793*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16795*/                OPC_EmitMergeInputChains1_0,
/* 16796*/                OPC_EmitInteger, MVT::i32, 0, 
/* 16799*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 16810*/              0, /*End of Scope*/
/* 16811*/            /*Scope*/ 75, /*->16887*/
/* 16812*/              OPC_MoveChild0,
/* 16813*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 16816*/              OPC_RecordChild0, // #1 = $off
/* 16817*/              OPC_MoveChild0,
/* 16818*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 16821*/              OPC_MoveParent,
/* 16822*/              OPC_MoveParent,
/* 16823*/              OPC_RecordChild1, // #2 = $addr
/* 16824*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 16826*/              OPC_CheckType, MVT::i32,
/* 16828*/              OPC_MoveParent,
/* 16829*/              OPC_MoveChild2,
/* 16830*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16833*/              OPC_RecordChild0, // #3 = $exp
/* 16834*/              OPC_MoveParent,
/* 16835*/              OPC_MoveChild3,
/* 16836*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16839*/              OPC_RecordChild0, // #4 = $new
/* 16840*/              OPC_MoveParent,
/* 16841*/              OPC_Scope, 21, /*->16864*/ // 2 children in Scope
/* 16843*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 16845*/                OPC_MoveParent,
/* 16846*/                OPC_MoveParent,
/* 16847*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16849*/                OPC_EmitMergeInputChains1_0,
/* 16850*/                OPC_EmitInteger, MVT::i32, 0, 
/* 16853*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 16864*/              /*Scope*/ 21, /*->16886*/
/* 16865*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 16867*/                OPC_MoveParent,
/* 16868*/                OPC_MoveParent,
/* 16869*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16871*/                OPC_EmitMergeInputChains1_0,
/* 16872*/                OPC_EmitInteger, MVT::i32, 0, 
/* 16875*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 16886*/              0, /*End of Scope*/
/* 16887*/            /*Scope*/ 73, /*->16961*/
/* 16888*/              OPC_RecordChild0, // #1 = $addr
/* 16889*/              OPC_MoveChild1,
/* 16890*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 16893*/              OPC_RecordChild0, // #2 = $off
/* 16894*/              OPC_MoveChild0,
/* 16895*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 16898*/              OPC_MoveParent,
/* 16899*/              OPC_MoveParent,
/* 16900*/              OPC_CheckType, MVT::i32,
/* 16902*/              OPC_MoveParent,
/* 16903*/              OPC_MoveChild2,
/* 16904*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16907*/              OPC_RecordChild0, // #3 = $exp
/* 16908*/              OPC_MoveParent,
/* 16909*/              OPC_MoveChild3,
/* 16910*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16913*/              OPC_RecordChild0, // #4 = $new
/* 16914*/              OPC_MoveParent,
/* 16915*/              OPC_Scope, 21, /*->16938*/ // 2 children in Scope
/* 16917*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 16919*/                OPC_MoveParent,
/* 16920*/                OPC_MoveParent,
/* 16921*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16923*/                OPC_EmitMergeInputChains1_0,
/* 16924*/                OPC_EmitInteger, MVT::i32, 0, 
/* 16927*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 16938*/              /*Scope*/ 21, /*->16960*/
/* 16939*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 16941*/                OPC_MoveParent,
/* 16942*/                OPC_MoveParent,
/* 16943*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16945*/                OPC_EmitMergeInputChains1_0,
/* 16946*/                OPC_EmitInteger, MVT::i32, 0, 
/* 16949*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 16960*/              0, /*End of Scope*/
/* 16961*/            /*Scope*/ 73, /*->17035*/
/* 16962*/              OPC_MoveChild0,
/* 16963*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 16966*/              OPC_RecordChild0, // #1 = $off
/* 16967*/              OPC_MoveChild0,
/* 16968*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 16971*/              OPC_MoveParent,
/* 16972*/              OPC_MoveParent,
/* 16973*/              OPC_RecordChild1, // #2 = $addr
/* 16974*/              OPC_CheckType, MVT::i32,
/* 16976*/              OPC_MoveParent,
/* 16977*/              OPC_MoveChild2,
/* 16978*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16981*/              OPC_RecordChild0, // #3 = $exp
/* 16982*/              OPC_MoveParent,
/* 16983*/              OPC_MoveChild3,
/* 16984*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 16987*/              OPC_RecordChild0, // #4 = $new
/* 16988*/              OPC_MoveParent,
/* 16989*/              OPC_Scope, 21, /*->17012*/ // 2 children in Scope
/* 16991*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 16993*/                OPC_MoveParent,
/* 16994*/                OPC_MoveParent,
/* 16995*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 16997*/                OPC_EmitMergeInputChains1_0,
/* 16998*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17001*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17012*/              /*Scope*/ 21, /*->17034*/
/* 17013*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 17015*/                OPC_MoveParent,
/* 17016*/                OPC_MoveParent,
/* 17017*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17019*/                OPC_EmitMergeInputChains1_0,
/* 17020*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17023*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17034*/              0, /*End of Scope*/
/* 17035*/            /*Scope*/ 74, /*->17110*/
/* 17036*/              OPC_RecordChild0, // #1 = $addr
/* 17037*/              OPC_RecordChild1, // #2 = $off
/* 17038*/              OPC_MoveChild1,
/* 17039*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17042*/              OPC_MoveParent,
/* 17043*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 17045*/              OPC_CheckType, MVT::i32,
/* 17047*/              OPC_MoveParent,
/* 17048*/              OPC_MoveChild2,
/* 17049*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17052*/              OPC_RecordChild0, // #3 = $exp
/* 17053*/              OPC_MoveParent,
/* 17054*/              OPC_MoveChild3,
/* 17055*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17058*/              OPC_RecordChild0, // #4 = $new
/* 17059*/              OPC_MoveParent,
/* 17060*/              OPC_Scope, 23, /*->17085*/ // 2 children in Scope
/* 17062*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 17064*/                OPC_MoveParent,
/* 17065*/                OPC_MoveParent,
/* 17066*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17068*/                OPC_EmitMergeInputChains1_0,
/* 17069*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17072*/                OPC_EmitConvertToTarget, 2,
/* 17074*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17085*/              /*Scope*/ 23, /*->17109*/
/* 17086*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 17088*/                OPC_MoveParent,
/* 17089*/                OPC_MoveParent,
/* 17090*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17092*/                OPC_EmitMergeInputChains1_0,
/* 17093*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17096*/                OPC_EmitConvertToTarget, 2,
/* 17098*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17109*/              0, /*End of Scope*/
/* 17110*/            0, /*End of Scope*/
/* 17111*/          /*SwitchOpcode*/ 74, TARGET_VAL(ISD::OR),// ->17188
/* 17114*/            OPC_RecordChild0, // #1 = $addr
/* 17115*/            OPC_RecordChild1, // #2 = $off
/* 17116*/            OPC_MoveChild1,
/* 17117*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17120*/            OPC_MoveParent,
/* 17121*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 17123*/            OPC_CheckType, MVT::i32,
/* 17125*/            OPC_MoveParent,
/* 17126*/            OPC_MoveChild2,
/* 17127*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17130*/            OPC_RecordChild0, // #3 = $exp
/* 17131*/            OPC_MoveParent,
/* 17132*/            OPC_MoveChild3,
/* 17133*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17136*/            OPC_RecordChild0, // #4 = $new
/* 17137*/            OPC_MoveParent,
/* 17138*/            OPC_Scope, 23, /*->17163*/ // 2 children in Scope
/* 17140*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 17142*/              OPC_MoveParent,
/* 17143*/              OPC_MoveParent,
/* 17144*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17146*/              OPC_EmitMergeInputChains1_0,
/* 17147*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17150*/              OPC_EmitConvertToTarget, 2,
/* 17152*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17163*/            /*Scope*/ 23, /*->17187*/
/* 17164*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 17166*/              OPC_MoveParent,
/* 17167*/              OPC_MoveParent,
/* 17168*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17170*/              OPC_EmitMergeInputChains1_0,
/* 17171*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17174*/              OPC_EmitConvertToTarget, 2,
/* 17176*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17187*/            0, /*End of Scope*/
/* 17188*/          /*SwitchOpcode*/ 42|128,1/*170*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->17362
/* 17192*/            OPC_RecordChild0, // #1 = $off
/* 17193*/            OPC_MoveChild0,
/* 17194*/            OPC_SwitchOpcode /*2 cases */, 80, TARGET_VAL(ISD::TargetGlobalAddress),// ->17278
/* 17198*/              OPC_MoveParent,
/* 17199*/              OPC_MoveParent,
/* 17200*/              OPC_MoveChild2,
/* 17201*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17204*/              OPC_RecordChild0, // #2 = $exp
/* 17205*/              OPC_MoveParent,
/* 17206*/              OPC_MoveChild3,
/* 17207*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17210*/              OPC_RecordChild0, // #3 = $new
/* 17211*/              OPC_MoveParent,
/* 17212*/              OPC_Scope, 31, /*->17245*/ // 2 children in Scope
/* 17214*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 17216*/                OPC_MoveParent,
/* 17217*/                OPC_MoveParent,
/* 17218*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17220*/                OPC_EmitMergeInputChains1_0,
/* 17221*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17224*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17227*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17234*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17245*/              /*Scope*/ 31, /*->17277*/
/* 17246*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 17248*/                OPC_MoveParent,
/* 17249*/                OPC_MoveParent,
/* 17250*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17252*/                OPC_EmitMergeInputChains1_0,
/* 17253*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17256*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17259*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17266*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17277*/              0, /*End of Scope*/
/* 17278*/            /*SwitchOpcode*/ 80, TARGET_VAL(ISD::TargetExternalSymbol),// ->17361
/* 17281*/              OPC_MoveParent,
/* 17282*/              OPC_MoveParent,
/* 17283*/              OPC_MoveChild2,
/* 17284*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17287*/              OPC_RecordChild0, // #2 = $exp
/* 17288*/              OPC_MoveParent,
/* 17289*/              OPC_MoveChild3,
/* 17290*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17293*/              OPC_RecordChild0, // #3 = $new
/* 17294*/              OPC_MoveParent,
/* 17295*/              OPC_Scope, 31, /*->17328*/ // 2 children in Scope
/* 17297*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 17299*/                OPC_MoveParent,
/* 17300*/                OPC_MoveParent,
/* 17301*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17303*/                OPC_EmitMergeInputChains1_0,
/* 17304*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17307*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17310*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17317*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17328*/              /*Scope*/ 31, /*->17360*/
/* 17329*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 17331*/                OPC_MoveParent,
/* 17332*/                OPC_MoveParent,
/* 17333*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17335*/                OPC_EmitMergeInputChains1_0,
/* 17336*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17339*/                OPC_EmitInteger, MVT::i32, 0, 
/* 17342*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17349*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17360*/              0, /*End of Scope*/
/* 17361*/            0, // EndSwitchOpcode
/* 17362*/          0, // EndSwitchOpcode
/* 17363*/        /*Scope*/ 30|128,1/*158*/, /*->17523*/
/* 17365*/          OPC_RecordChild1, // #1 = $off
/* 17366*/          OPC_Scope, 87, /*->17455*/ // 2 children in Scope
/* 17368*/            OPC_MoveChild1,
/* 17369*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17372*/            OPC_MoveParent,
/* 17373*/            OPC_MoveChild2,
/* 17374*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17377*/            OPC_RecordChild0, // #2 = $exp
/* 17378*/            OPC_MoveParent,
/* 17379*/            OPC_MoveChild3,
/* 17380*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17383*/            OPC_RecordChild0, // #3 = $new
/* 17384*/            OPC_MoveParent,
/* 17385*/            OPC_Scope, 33, /*->17420*/ // 2 children in Scope
/* 17387*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 17389*/              OPC_MoveParent,
/* 17390*/              OPC_MoveParent,
/* 17391*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17393*/              OPC_EmitMergeInputChains1_0,
/* 17394*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17397*/              OPC_EmitConvertToTarget, 1,
/* 17399*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17402*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 17409*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                        // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 19
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17420*/            /*Scope*/ 33, /*->17454*/
/* 17421*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 17423*/              OPC_MoveParent,
/* 17424*/              OPC_MoveParent,
/* 17425*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17427*/              OPC_EmitMergeInputChains1_0,
/* 17428*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17431*/              OPC_EmitConvertToTarget, 1,
/* 17433*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17436*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 17443*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                        // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 19
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17454*/            0, /*End of Scope*/
/* 17455*/          /*Scope*/ 66, /*->17522*/
/* 17456*/            OPC_CheckChild1Type, MVT::i32,
/* 17458*/            OPC_MoveChild2,
/* 17459*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17462*/            OPC_RecordChild0, // #2 = $exp
/* 17463*/            OPC_MoveParent,
/* 17464*/            OPC_MoveChild3,
/* 17465*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17468*/            OPC_RecordChild0, // #3 = $new
/* 17469*/            OPC_MoveParent,
/* 17470*/            OPC_Scope, 24, /*->17496*/ // 2 children in Scope
/* 17472*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 17474*/              OPC_MoveParent,
/* 17475*/              OPC_MoveParent,
/* 17476*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17478*/              OPC_EmitMergeInputChains1_0,
/* 17479*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17482*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17485*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 16
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17496*/            /*Scope*/ 24, /*->17521*/
/* 17497*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 17499*/              OPC_MoveParent,
/* 17500*/              OPC_MoveParent,
/* 17501*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17503*/              OPC_EmitMergeInputChains1_0,
/* 17504*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17507*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17510*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 16
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17521*/            0, /*End of Scope*/
/* 17522*/          0, /*End of Scope*/
/* 17523*/        0, /*End of Scope*/
/* 17524*/      /*SwitchOpcode*/ 116|128,3/*500*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->18028
/* 17528*/        OPC_RecordMemRef,
/* 17529*/        OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 17530*/        OPC_Scope, 18|128,3/*402*/, /*->17935*/ // 2 children in Scope
/* 17533*/          OPC_MoveChild1,
/* 17534*/          OPC_SwitchOpcode /*3 cases */, 117|128,1/*245*/, TARGET_VAL(ISD::ADD),// ->17784
/* 17539*/            OPC_Scope, 49, /*->17590*/ // 5 children in Scope
/* 17541*/              OPC_RecordChild0, // #1 = $addr
/* 17542*/              OPC_MoveChild1,
/* 17543*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 17546*/              OPC_RecordChild0, // #2 = $off
/* 17547*/              OPC_MoveChild0,
/* 17548*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 17551*/              OPC_MoveParent,
/* 17552*/              OPC_MoveParent,
/* 17553*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 17555*/              OPC_CheckType, MVT::i32,
/* 17557*/              OPC_MoveParent,
/* 17558*/              OPC_MoveChild2,
/* 17559*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17562*/              OPC_RecordChild0, // #3 = $exp
/* 17563*/              OPC_MoveParent,
/* 17564*/              OPC_MoveChild3,
/* 17565*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17568*/              OPC_RecordChild0, // #4 = $new
/* 17569*/              OPC_MoveParent,
/* 17570*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17572*/              OPC_MoveParent,
/* 17573*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17575*/              OPC_EmitMergeInputChains1_0,
/* 17576*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17579*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 23
                        // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17590*/            /*Scope*/ 49, /*->17640*/
/* 17591*/              OPC_MoveChild0,
/* 17592*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 17595*/              OPC_RecordChild0, // #1 = $off
/* 17596*/              OPC_MoveChild0,
/* 17597*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 17600*/              OPC_MoveParent,
/* 17601*/              OPC_MoveParent,
/* 17602*/              OPC_RecordChild1, // #2 = $addr
/* 17603*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 17605*/              OPC_CheckType, MVT::i32,
/* 17607*/              OPC_MoveParent,
/* 17608*/              OPC_MoveChild2,
/* 17609*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17612*/              OPC_RecordChild0, // #3 = $exp
/* 17613*/              OPC_MoveParent,
/* 17614*/              OPC_MoveChild3,
/* 17615*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17618*/              OPC_RecordChild0, // #4 = $new
/* 17619*/              OPC_MoveParent,
/* 17620*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17622*/              OPC_MoveParent,
/* 17623*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17625*/              OPC_EmitMergeInputChains1_0,
/* 17626*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17629*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 23
                        // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17640*/            /*Scope*/ 47, /*->17688*/
/* 17641*/              OPC_RecordChild0, // #1 = $addr
/* 17642*/              OPC_MoveChild1,
/* 17643*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 17646*/              OPC_RecordChild0, // #2 = $off
/* 17647*/              OPC_MoveChild0,
/* 17648*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 17651*/              OPC_MoveParent,
/* 17652*/              OPC_MoveParent,
/* 17653*/              OPC_CheckType, MVT::i32,
/* 17655*/              OPC_MoveParent,
/* 17656*/              OPC_MoveChild2,
/* 17657*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17660*/              OPC_RecordChild0, // #3 = $exp
/* 17661*/              OPC_MoveParent,
/* 17662*/              OPC_MoveChild3,
/* 17663*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17666*/              OPC_RecordChild0, // #4 = $new
/* 17667*/              OPC_MoveParent,
/* 17668*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17670*/              OPC_MoveParent,
/* 17671*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17673*/              OPC_EmitMergeInputChains1_0,
/* 17674*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17677*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
                        // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17688*/            /*Scope*/ 47, /*->17736*/
/* 17689*/              OPC_MoveChild0,
/* 17690*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 17693*/              OPC_RecordChild0, // #1 = $off
/* 17694*/              OPC_MoveChild0,
/* 17695*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 17698*/              OPC_MoveParent,
/* 17699*/              OPC_MoveParent,
/* 17700*/              OPC_RecordChild1, // #2 = $addr
/* 17701*/              OPC_CheckType, MVT::i32,
/* 17703*/              OPC_MoveParent,
/* 17704*/              OPC_MoveChild2,
/* 17705*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17708*/              OPC_RecordChild0, // #3 = $exp
/* 17709*/              OPC_MoveParent,
/* 17710*/              OPC_MoveChild3,
/* 17711*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17714*/              OPC_RecordChild0, // #4 = $new
/* 17715*/              OPC_MoveParent,
/* 17716*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17718*/              OPC_MoveParent,
/* 17719*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17721*/              OPC_EmitMergeInputChains1_0,
/* 17722*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17725*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
                        // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17736*/            /*Scope*/ 46, /*->17783*/
/* 17737*/              OPC_RecordChild0, // #1 = $addr
/* 17738*/              OPC_RecordChild1, // #2 = $off
/* 17739*/              OPC_MoveChild1,
/* 17740*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17743*/              OPC_MoveParent,
/* 17744*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 17746*/              OPC_CheckType, MVT::i32,
/* 17748*/              OPC_MoveParent,
/* 17749*/              OPC_MoveChild2,
/* 17750*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17753*/              OPC_RecordChild0, // #3 = $exp
/* 17754*/              OPC_MoveParent,
/* 17755*/              OPC_MoveChild3,
/* 17756*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17759*/              OPC_RecordChild0, // #4 = $new
/* 17760*/              OPC_MoveParent,
/* 17761*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17763*/              OPC_MoveParent,
/* 17764*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17766*/              OPC_EmitMergeInputChains1_0,
/* 17767*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17770*/              OPC_EmitConvertToTarget, 2,
/* 17772*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17783*/            0, /*End of Scope*/
/* 17784*/          /*SwitchOpcode*/ 46, TARGET_VAL(ISD::OR),// ->17833
/* 17787*/            OPC_RecordChild0, // #1 = $addr
/* 17788*/            OPC_RecordChild1, // #2 = $off
/* 17789*/            OPC_MoveChild1,
/* 17790*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17793*/            OPC_MoveParent,
/* 17794*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 17796*/            OPC_CheckType, MVT::i32,
/* 17798*/            OPC_MoveParent,
/* 17799*/            OPC_MoveChild2,
/* 17800*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17803*/            OPC_RecordChild0, // #3 = $exp
/* 17804*/            OPC_MoveParent,
/* 17805*/            OPC_MoveChild3,
/* 17806*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17809*/            OPC_RecordChild0, // #4 = $new
/* 17810*/            OPC_MoveParent,
/* 17811*/            OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17813*/            OPC_MoveParent,
/* 17814*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17816*/            OPC_EmitMergeInputChains1_0,
/* 17817*/            OPC_EmitInteger, MVT::i32, 0, 
/* 17820*/            OPC_EmitConvertToTarget, 2,
/* 17822*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                      // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 20
                      // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17833*/          /*SwitchOpcode*/ 98, TARGET_VAL(WebAssemblyISD::Wrapper),// ->17934
/* 17836*/            OPC_RecordChild0, // #1 = $off
/* 17837*/            OPC_MoveChild0,
/* 17838*/            OPC_SwitchOpcode /*2 cases */, 44, TARGET_VAL(ISD::TargetGlobalAddress),// ->17886
/* 17842*/              OPC_MoveParent,
/* 17843*/              OPC_MoveParent,
/* 17844*/              OPC_MoveChild2,
/* 17845*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17848*/              OPC_RecordChild0, // #2 = $exp
/* 17849*/              OPC_MoveParent,
/* 17850*/              OPC_MoveChild3,
/* 17851*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17854*/              OPC_RecordChild0, // #3 = $new
/* 17855*/              OPC_MoveParent,
/* 17856*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17858*/              OPC_MoveParent,
/* 17859*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17861*/              OPC_EmitMergeInputChains1_0,
/* 17862*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17865*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17868*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17875*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17886*/            /*SwitchOpcode*/ 44, TARGET_VAL(ISD::TargetExternalSymbol),// ->17933
/* 17889*/              OPC_MoveParent,
/* 17890*/              OPC_MoveParent,
/* 17891*/              OPC_MoveChild2,
/* 17892*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17895*/              OPC_RecordChild0, // #2 = $exp
/* 17896*/              OPC_MoveParent,
/* 17897*/              OPC_MoveChild3,
/* 17898*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17901*/              OPC_RecordChild0, // #3 = $new
/* 17902*/              OPC_MoveParent,
/* 17903*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17905*/              OPC_MoveParent,
/* 17906*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17908*/              OPC_EmitMergeInputChains1_0,
/* 17909*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17912*/              OPC_EmitInteger, MVT::i32, 0, 
/* 17915*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 17922*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17933*/            0, // EndSwitchOpcode
/* 17934*/          0, // EndSwitchOpcode
/* 17935*/        /*Scope*/ 91, /*->18027*/
/* 17936*/          OPC_RecordChild1, // #1 = $off
/* 17937*/          OPC_Scope, 49, /*->17988*/ // 2 children in Scope
/* 17939*/            OPC_MoveChild1,
/* 17940*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 17943*/            OPC_MoveParent,
/* 17944*/            OPC_MoveChild2,
/* 17945*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17948*/            OPC_RecordChild0, // #2 = $exp
/* 17949*/            OPC_MoveParent,
/* 17950*/            OPC_MoveChild3,
/* 17951*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17954*/            OPC_RecordChild0, // #3 = $new
/* 17955*/            OPC_MoveParent,
/* 17956*/            OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 17958*/            OPC_MoveParent,
/* 17959*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 17961*/            OPC_EmitMergeInputChains1_0,
/* 17962*/            OPC_EmitInteger, MVT::i32, 0, 
/* 17965*/            OPC_EmitConvertToTarget, 1,
/* 17967*/            OPC_EmitInteger, MVT::i32, 0, 
/* 17970*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 17977*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 16
                      // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 17988*/          /*Scope*/ 37, /*->18026*/
/* 17989*/            OPC_CheckChild1Type, MVT::i32,
/* 17991*/            OPC_MoveChild2,
/* 17992*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 17995*/            OPC_RecordChild0, // #2 = $exp
/* 17996*/            OPC_MoveParent,
/* 17997*/            OPC_MoveChild3,
/* 17998*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18001*/            OPC_RecordChild0, // #3 = $new
/* 18002*/            OPC_MoveParent,
/* 18003*/            OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 18005*/            OPC_MoveParent,
/* 18006*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18008*/            OPC_EmitMergeInputChains1_0,
/* 18009*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18012*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18015*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 13
                      // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 18026*/          0, /*End of Scope*/
/* 18027*/        0, /*End of Scope*/
/* 18028*/      /*SwitchOpcode*/ 46|128,3/*430*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->18462
/* 18032*/        OPC_RecordMemRef,
/* 18033*/        OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 18034*/        OPC_Scope, 90|128,2/*346*/, /*->18383*/ // 2 children in Scope
/* 18037*/          OPC_MoveChild1,
/* 18038*/          OPC_SwitchOpcode /*3 cases */, 82|128,1/*210*/, TARGET_VAL(ISD::ADD),// ->18253
/* 18043*/            OPC_Scope, 42, /*->18087*/ // 5 children in Scope
/* 18045*/              OPC_RecordChild0, // #1 = $addr
/* 18046*/              OPC_MoveChild1,
/* 18047*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18050*/              OPC_RecordChild0, // #2 = $off
/* 18051*/              OPC_MoveChild0,
/* 18052*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 18055*/              OPC_MoveParent,
/* 18056*/              OPC_MoveParent,
/* 18057*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 18059*/              OPC_CheckType, MVT::i32,
/* 18061*/              OPC_MoveParent,
/* 18062*/              OPC_MoveChild2,
/* 18063*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18066*/              OPC_RecordChild0, // #3 = $val
/* 18067*/              OPC_MoveParent,
/* 18068*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18070*/              OPC_MoveParent,
/* 18071*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18073*/              OPC_EmitMergeInputChains1_0,
/* 18074*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18077*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18087*/            /*Scope*/ 42, /*->18130*/
/* 18088*/              OPC_MoveChild0,
/* 18089*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18092*/              OPC_RecordChild0, // #1 = $off
/* 18093*/              OPC_MoveChild0,
/* 18094*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 18097*/              OPC_MoveParent,
/* 18098*/              OPC_MoveParent,
/* 18099*/              OPC_RecordChild1, // #2 = $addr
/* 18100*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 18102*/              OPC_CheckType, MVT::i32,
/* 18104*/              OPC_MoveParent,
/* 18105*/              OPC_MoveChild2,
/* 18106*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18109*/              OPC_RecordChild0, // #3 = $val
/* 18110*/              OPC_MoveParent,
/* 18111*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18113*/              OPC_MoveParent,
/* 18114*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18116*/              OPC_EmitMergeInputChains1_0,
/* 18117*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18120*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18130*/            /*Scope*/ 40, /*->18171*/
/* 18131*/              OPC_RecordChild0, // #1 = $addr
/* 18132*/              OPC_MoveChild1,
/* 18133*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18136*/              OPC_RecordChild0, // #2 = $off
/* 18137*/              OPC_MoveChild0,
/* 18138*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 18141*/              OPC_MoveParent,
/* 18142*/              OPC_MoveParent,
/* 18143*/              OPC_CheckType, MVT::i32,
/* 18145*/              OPC_MoveParent,
/* 18146*/              OPC_MoveChild2,
/* 18147*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18150*/              OPC_RecordChild0, // #3 = $val
/* 18151*/              OPC_MoveParent,
/* 18152*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18154*/              OPC_MoveParent,
/* 18155*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18157*/              OPC_EmitMergeInputChains1_0,
/* 18158*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18161*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18171*/            /*Scope*/ 40, /*->18212*/
/* 18172*/              OPC_MoveChild0,
/* 18173*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18176*/              OPC_RecordChild0, // #1 = $off
/* 18177*/              OPC_MoveChild0,
/* 18178*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 18181*/              OPC_MoveParent,
/* 18182*/              OPC_MoveParent,
/* 18183*/              OPC_RecordChild1, // #2 = $addr
/* 18184*/              OPC_CheckType, MVT::i32,
/* 18186*/              OPC_MoveParent,
/* 18187*/              OPC_MoveChild2,
/* 18188*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18191*/              OPC_RecordChild0, // #3 = $val
/* 18192*/              OPC_MoveParent,
/* 18193*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18195*/              OPC_MoveParent,
/* 18196*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18198*/              OPC_EmitMergeInputChains1_0,
/* 18199*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18202*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18212*/            /*Scope*/ 39, /*->18252*/
/* 18213*/              OPC_RecordChild0, // #1 = $addr
/* 18214*/              OPC_RecordChild1, // #2 = $off
/* 18215*/              OPC_MoveChild1,
/* 18216*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18219*/              OPC_MoveParent,
/* 18220*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 18222*/              OPC_CheckType, MVT::i32,
/* 18224*/              OPC_MoveParent,
/* 18225*/              OPC_MoveChild2,
/* 18226*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18229*/              OPC_RecordChild0, // #3 = $val
/* 18230*/              OPC_MoveParent,
/* 18231*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18233*/              OPC_MoveParent,
/* 18234*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18236*/              OPC_EmitMergeInputChains1_0,
/* 18237*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18240*/              OPC_EmitConvertToTarget, 2,
/* 18242*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18252*/            0, /*End of Scope*/
/* 18253*/          /*SwitchOpcode*/ 39, TARGET_VAL(ISD::OR),// ->18295
/* 18256*/            OPC_RecordChild0, // #1 = $addr
/* 18257*/            OPC_RecordChild1, // #2 = $off
/* 18258*/            OPC_MoveChild1,
/* 18259*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18262*/            OPC_MoveParent,
/* 18263*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 18265*/            OPC_CheckType, MVT::i32,
/* 18267*/            OPC_MoveParent,
/* 18268*/            OPC_MoveChild2,
/* 18269*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18272*/            OPC_RecordChild0, // #3 = $val
/* 18273*/            OPC_MoveParent,
/* 18274*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18276*/            OPC_MoveParent,
/* 18277*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18279*/            OPC_EmitMergeInputChains1_0,
/* 18280*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18283*/            OPC_EmitConvertToTarget, 2,
/* 18285*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 17
                      // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18295*/          /*SwitchOpcode*/ 84, TARGET_VAL(WebAssemblyISD::Wrapper),// ->18382
/* 18298*/            OPC_RecordChild0, // #1 = $off
/* 18299*/            OPC_MoveChild0,
/* 18300*/            OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::TargetGlobalAddress),// ->18341
/* 18304*/              OPC_MoveParent,
/* 18305*/              OPC_MoveParent,
/* 18306*/              OPC_MoveChild2,
/* 18307*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18310*/              OPC_RecordChild0, // #2 = $val
/* 18311*/              OPC_MoveParent,
/* 18312*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18314*/              OPC_MoveParent,
/* 18315*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18317*/              OPC_EmitMergeInputChains1_0,
/* 18318*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18321*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18324*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 18331*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 18341*/            /*SwitchOpcode*/ 37, TARGET_VAL(ISD::TargetExternalSymbol),// ->18381
/* 18344*/              OPC_MoveParent,
/* 18345*/              OPC_MoveParent,
/* 18346*/              OPC_MoveChild2,
/* 18347*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18350*/              OPC_RecordChild0, // #2 = $val
/* 18351*/              OPC_MoveParent,
/* 18352*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18354*/              OPC_MoveParent,
/* 18355*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18357*/              OPC_EmitMergeInputChains1_0,
/* 18358*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18361*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18364*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 18371*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 18381*/            0, // EndSwitchOpcode
/* 18382*/          0, // EndSwitchOpcode
/* 18383*/        /*Scope*/ 77, /*->18461*/
/* 18384*/          OPC_RecordChild1, // #1 = $off
/* 18385*/          OPC_Scope, 42, /*->18429*/ // 2 children in Scope
/* 18387*/            OPC_MoveChild1,
/* 18388*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18391*/            OPC_MoveParent,
/* 18392*/            OPC_MoveChild2,
/* 18393*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18396*/            OPC_RecordChild0, // #2 = $val
/* 18397*/            OPC_MoveParent,
/* 18398*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18400*/            OPC_MoveParent,
/* 18401*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18403*/            OPC_EmitMergeInputChains1_0,
/* 18404*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18407*/            OPC_EmitConvertToTarget, 1,
/* 18409*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18412*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 18419*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 13
                      // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 18429*/          /*Scope*/ 30, /*->18460*/
/* 18430*/            OPC_CheckChild1Type, MVT::i32,
/* 18432*/            OPC_MoveChild2,
/* 18433*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18436*/            OPC_RecordChild0, // #2 = $val
/* 18437*/            OPC_MoveParent,
/* 18438*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 18440*/            OPC_MoveParent,
/* 18441*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18443*/            OPC_EmitMergeInputChains1_0,
/* 18444*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18447*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18450*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 10
                      // Dst: (ATOMIC_RMW32_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18460*/          0, /*End of Scope*/
/* 18461*/        0, /*End of Scope*/
/* 18462*/      /*SwitchOpcode*/ 46|128,3/*430*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->18896
/* 18466*/        OPC_RecordMemRef,
/* 18467*/        OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 18468*/        OPC_Scope, 90|128,2/*346*/, /*->18817*/ // 2 children in Scope
/* 18471*/          OPC_MoveChild1,
/* 18472*/          OPC_SwitchOpcode /*3 cases */, 82|128,1/*210*/, TARGET_VAL(ISD::ADD),// ->18687
/* 18477*/            OPC_Scope, 42, /*->18521*/ // 5 children in Scope
/* 18479*/              OPC_RecordChild0, // #1 = $addr
/* 18480*/              OPC_MoveChild1,
/* 18481*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18484*/              OPC_RecordChild0, // #2 = $off
/* 18485*/              OPC_MoveChild0,
/* 18486*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 18489*/              OPC_MoveParent,
/* 18490*/              OPC_MoveParent,
/* 18491*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 18493*/              OPC_CheckType, MVT::i32,
/* 18495*/              OPC_MoveParent,
/* 18496*/              OPC_MoveChild2,
/* 18497*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18500*/              OPC_RecordChild0, // #3 = $val
/* 18501*/              OPC_MoveParent,
/* 18502*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18504*/              OPC_MoveParent,
/* 18505*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18507*/              OPC_EmitMergeInputChains1_0,
/* 18508*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18511*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18521*/            /*Scope*/ 42, /*->18564*/
/* 18522*/              OPC_MoveChild0,
/* 18523*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18526*/              OPC_RecordChild0, // #1 = $off
/* 18527*/              OPC_MoveChild0,
/* 18528*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 18531*/              OPC_MoveParent,
/* 18532*/              OPC_MoveParent,
/* 18533*/              OPC_RecordChild1, // #2 = $addr
/* 18534*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 18536*/              OPC_CheckType, MVT::i32,
/* 18538*/              OPC_MoveParent,
/* 18539*/              OPC_MoveChild2,
/* 18540*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18543*/              OPC_RecordChild0, // #3 = $val
/* 18544*/              OPC_MoveParent,
/* 18545*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18547*/              OPC_MoveParent,
/* 18548*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18550*/              OPC_EmitMergeInputChains1_0,
/* 18551*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18554*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18564*/            /*Scope*/ 40, /*->18605*/
/* 18565*/              OPC_RecordChild0, // #1 = $addr
/* 18566*/              OPC_MoveChild1,
/* 18567*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18570*/              OPC_RecordChild0, // #2 = $off
/* 18571*/              OPC_MoveChild0,
/* 18572*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 18575*/              OPC_MoveParent,
/* 18576*/              OPC_MoveParent,
/* 18577*/              OPC_CheckType, MVT::i32,
/* 18579*/              OPC_MoveParent,
/* 18580*/              OPC_MoveChild2,
/* 18581*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18584*/              OPC_RecordChild0, // #3 = $val
/* 18585*/              OPC_MoveParent,
/* 18586*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18588*/              OPC_MoveParent,
/* 18589*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18591*/              OPC_EmitMergeInputChains1_0,
/* 18592*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18595*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18605*/            /*Scope*/ 40, /*->18646*/
/* 18606*/              OPC_MoveChild0,
/* 18607*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18610*/              OPC_RecordChild0, // #1 = $off
/* 18611*/              OPC_MoveChild0,
/* 18612*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 18615*/              OPC_MoveParent,
/* 18616*/              OPC_MoveParent,
/* 18617*/              OPC_RecordChild1, // #2 = $addr
/* 18618*/              OPC_CheckType, MVT::i32,
/* 18620*/              OPC_MoveParent,
/* 18621*/              OPC_MoveChild2,
/* 18622*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18625*/              OPC_RecordChild0, // #3 = $val
/* 18626*/              OPC_MoveParent,
/* 18627*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18629*/              OPC_MoveParent,
/* 18630*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18632*/              OPC_EmitMergeInputChains1_0,
/* 18633*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18636*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18646*/            /*Scope*/ 39, /*->18686*/
/* 18647*/              OPC_RecordChild0, // #1 = $addr
/* 18648*/              OPC_RecordChild1, // #2 = $off
/* 18649*/              OPC_MoveChild1,
/* 18650*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18653*/              OPC_MoveParent,
/* 18654*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 18656*/              OPC_CheckType, MVT::i32,
/* 18658*/              OPC_MoveParent,
/* 18659*/              OPC_MoveChild2,
/* 18660*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18663*/              OPC_RecordChild0, // #3 = $val
/* 18664*/              OPC_MoveParent,
/* 18665*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18667*/              OPC_MoveParent,
/* 18668*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18670*/              OPC_EmitMergeInputChains1_0,
/* 18671*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18674*/              OPC_EmitConvertToTarget, 2,
/* 18676*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18686*/            0, /*End of Scope*/
/* 18687*/          /*SwitchOpcode*/ 39, TARGET_VAL(ISD::OR),// ->18729
/* 18690*/            OPC_RecordChild0, // #1 = $addr
/* 18691*/            OPC_RecordChild1, // #2 = $off
/* 18692*/            OPC_MoveChild1,
/* 18693*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18696*/            OPC_MoveParent,
/* 18697*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 18699*/            OPC_CheckType, MVT::i32,
/* 18701*/            OPC_MoveParent,
/* 18702*/            OPC_MoveChild2,
/* 18703*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18706*/            OPC_RecordChild0, // #3 = $val
/* 18707*/            OPC_MoveParent,
/* 18708*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18710*/            OPC_MoveParent,
/* 18711*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18713*/            OPC_EmitMergeInputChains1_0,
/* 18714*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18717*/            OPC_EmitConvertToTarget, 2,
/* 18719*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 17
                      // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18729*/          /*SwitchOpcode*/ 84, TARGET_VAL(WebAssemblyISD::Wrapper),// ->18816
/* 18732*/            OPC_RecordChild0, // #1 = $off
/* 18733*/            OPC_MoveChild0,
/* 18734*/            OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::TargetGlobalAddress),// ->18775
/* 18738*/              OPC_MoveParent,
/* 18739*/              OPC_MoveParent,
/* 18740*/              OPC_MoveChild2,
/* 18741*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18744*/              OPC_RecordChild0, // #2 = $val
/* 18745*/              OPC_MoveParent,
/* 18746*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18748*/              OPC_MoveParent,
/* 18749*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18751*/              OPC_EmitMergeInputChains1_0,
/* 18752*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18755*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18758*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 18765*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 18775*/            /*SwitchOpcode*/ 37, TARGET_VAL(ISD::TargetExternalSymbol),// ->18815
/* 18778*/              OPC_MoveParent,
/* 18779*/              OPC_MoveParent,
/* 18780*/              OPC_MoveChild2,
/* 18781*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18784*/              OPC_RecordChild0, // #2 = $val
/* 18785*/              OPC_MoveParent,
/* 18786*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18788*/              OPC_MoveParent,
/* 18789*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18791*/              OPC_EmitMergeInputChains1_0,
/* 18792*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18795*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18798*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 18805*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 18815*/            0, // EndSwitchOpcode
/* 18816*/          0, // EndSwitchOpcode
/* 18817*/        /*Scope*/ 77, /*->18895*/
/* 18818*/          OPC_RecordChild1, // #1 = $off
/* 18819*/          OPC_Scope, 42, /*->18863*/ // 2 children in Scope
/* 18821*/            OPC_MoveChild1,
/* 18822*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18825*/            OPC_MoveParent,
/* 18826*/            OPC_MoveChild2,
/* 18827*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18830*/            OPC_RecordChild0, // #2 = $val
/* 18831*/            OPC_MoveParent,
/* 18832*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18834*/            OPC_MoveParent,
/* 18835*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18837*/            OPC_EmitMergeInputChains1_0,
/* 18838*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18841*/            OPC_EmitConvertToTarget, 1,
/* 18843*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18846*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 18853*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 13
                      // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 18863*/          /*Scope*/ 30, /*->18894*/
/* 18864*/            OPC_CheckChild1Type, MVT::i32,
/* 18866*/            OPC_MoveChild2,
/* 18867*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18870*/            OPC_RecordChild0, // #2 = $val
/* 18871*/            OPC_MoveParent,
/* 18872*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 18874*/            OPC_MoveParent,
/* 18875*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18877*/            OPC_EmitMergeInputChains1_0,
/* 18878*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18881*/            OPC_EmitInteger, MVT::i32, 0, 
/* 18884*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 10
                      // Dst: (ATOMIC_RMW32_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18894*/          0, /*End of Scope*/
/* 18895*/        0, /*End of Scope*/
/* 18896*/      /*SwitchOpcode*/ 46|128,3/*430*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->19330
/* 18900*/        OPC_RecordMemRef,
/* 18901*/        OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 18902*/        OPC_Scope, 90|128,2/*346*/, /*->19251*/ // 2 children in Scope
/* 18905*/          OPC_MoveChild1,
/* 18906*/          OPC_SwitchOpcode /*3 cases */, 82|128,1/*210*/, TARGET_VAL(ISD::ADD),// ->19121
/* 18911*/            OPC_Scope, 42, /*->18955*/ // 5 children in Scope
/* 18913*/              OPC_RecordChild0, // #1 = $addr
/* 18914*/              OPC_MoveChild1,
/* 18915*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18918*/              OPC_RecordChild0, // #2 = $off
/* 18919*/              OPC_MoveChild0,
/* 18920*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 18923*/              OPC_MoveParent,
/* 18924*/              OPC_MoveParent,
/* 18925*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 18927*/              OPC_CheckType, MVT::i32,
/* 18929*/              OPC_MoveParent,
/* 18930*/              OPC_MoveChild2,
/* 18931*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18934*/              OPC_RecordChild0, // #3 = $val
/* 18935*/              OPC_MoveParent,
/* 18936*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 18938*/              OPC_MoveParent,
/* 18939*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18941*/              OPC_EmitMergeInputChains1_0,
/* 18942*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18945*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18955*/            /*Scope*/ 42, /*->18998*/
/* 18956*/              OPC_MoveChild0,
/* 18957*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 18960*/              OPC_RecordChild0, // #1 = $off
/* 18961*/              OPC_MoveChild0,
/* 18962*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 18965*/              OPC_MoveParent,
/* 18966*/              OPC_MoveParent,
/* 18967*/              OPC_RecordChild1, // #2 = $addr
/* 18968*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 18970*/              OPC_CheckType, MVT::i32,
/* 18972*/              OPC_MoveParent,
/* 18973*/              OPC_MoveChild2,
/* 18974*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 18977*/              OPC_RecordChild0, // #3 = $val
/* 18978*/              OPC_MoveParent,
/* 18979*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 18981*/              OPC_MoveParent,
/* 18982*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 18984*/              OPC_EmitMergeInputChains1_0,
/* 18985*/              OPC_EmitInteger, MVT::i32, 0, 
/* 18988*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 18998*/            /*Scope*/ 40, /*->19039*/
/* 18999*/              OPC_RecordChild0, // #1 = $addr
/* 19000*/              OPC_MoveChild1,
/* 19001*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19004*/              OPC_RecordChild0, // #2 = $off
/* 19005*/              OPC_MoveChild0,
/* 19006*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 19009*/              OPC_MoveParent,
/* 19010*/              OPC_MoveParent,
/* 19011*/              OPC_CheckType, MVT::i32,
/* 19013*/              OPC_MoveParent,
/* 19014*/              OPC_MoveChild2,
/* 19015*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19018*/              OPC_RecordChild0, // #3 = $val
/* 19019*/              OPC_MoveParent,
/* 19020*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19022*/              OPC_MoveParent,
/* 19023*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19025*/              OPC_EmitMergeInputChains1_0,
/* 19026*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19029*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19039*/            /*Scope*/ 40, /*->19080*/
/* 19040*/              OPC_MoveChild0,
/* 19041*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19044*/              OPC_RecordChild0, // #1 = $off
/* 19045*/              OPC_MoveChild0,
/* 19046*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 19049*/              OPC_MoveParent,
/* 19050*/              OPC_MoveParent,
/* 19051*/              OPC_RecordChild1, // #2 = $addr
/* 19052*/              OPC_CheckType, MVT::i32,
/* 19054*/              OPC_MoveParent,
/* 19055*/              OPC_MoveChild2,
/* 19056*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19059*/              OPC_RecordChild0, // #3 = $val
/* 19060*/              OPC_MoveParent,
/* 19061*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19063*/              OPC_MoveParent,
/* 19064*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19066*/              OPC_EmitMergeInputChains1_0,
/* 19067*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19070*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19080*/            /*Scope*/ 39, /*->19120*/
/* 19081*/              OPC_RecordChild0, // #1 = $addr
/* 19082*/              OPC_RecordChild1, // #2 = $off
/* 19083*/              OPC_MoveChild1,
/* 19084*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19087*/              OPC_MoveParent,
/* 19088*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 19090*/              OPC_CheckType, MVT::i32,
/* 19092*/              OPC_MoveParent,
/* 19093*/              OPC_MoveChild2,
/* 19094*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19097*/              OPC_RecordChild0, // #3 = $val
/* 19098*/              OPC_MoveParent,
/* 19099*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19101*/              OPC_MoveParent,
/* 19102*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19104*/              OPC_EmitMergeInputChains1_0,
/* 19105*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19108*/              OPC_EmitConvertToTarget, 2,
/* 19110*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19120*/            0, /*End of Scope*/
/* 19121*/          /*SwitchOpcode*/ 39, TARGET_VAL(ISD::OR),// ->19163
/* 19124*/            OPC_RecordChild0, // #1 = $addr
/* 19125*/            OPC_RecordChild1, // #2 = $off
/* 19126*/            OPC_MoveChild1,
/* 19127*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19130*/            OPC_MoveParent,
/* 19131*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 19133*/            OPC_CheckType, MVT::i32,
/* 19135*/            OPC_MoveParent,
/* 19136*/            OPC_MoveChild2,
/* 19137*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19140*/            OPC_RecordChild0, // #3 = $val
/* 19141*/            OPC_MoveParent,
/* 19142*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19144*/            OPC_MoveParent,
/* 19145*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19147*/            OPC_EmitMergeInputChains1_0,
/* 19148*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19151*/            OPC_EmitConvertToTarget, 2,
/* 19153*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 17
                      // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19163*/          /*SwitchOpcode*/ 84, TARGET_VAL(WebAssemblyISD::Wrapper),// ->19250
/* 19166*/            OPC_RecordChild0, // #1 = $off
/* 19167*/            OPC_MoveChild0,
/* 19168*/            OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::TargetGlobalAddress),// ->19209
/* 19172*/              OPC_MoveParent,
/* 19173*/              OPC_MoveParent,
/* 19174*/              OPC_MoveChild2,
/* 19175*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19178*/              OPC_RecordChild0, // #2 = $val
/* 19179*/              OPC_MoveParent,
/* 19180*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19182*/              OPC_MoveParent,
/* 19183*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19185*/              OPC_EmitMergeInputChains1_0,
/* 19186*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19189*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19192*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19199*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19209*/            /*SwitchOpcode*/ 37, TARGET_VAL(ISD::TargetExternalSymbol),// ->19249
/* 19212*/              OPC_MoveParent,
/* 19213*/              OPC_MoveParent,
/* 19214*/              OPC_MoveChild2,
/* 19215*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19218*/              OPC_RecordChild0, // #2 = $val
/* 19219*/              OPC_MoveParent,
/* 19220*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19222*/              OPC_MoveParent,
/* 19223*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19225*/              OPC_EmitMergeInputChains1_0,
/* 19226*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19229*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19232*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19239*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19249*/            0, // EndSwitchOpcode
/* 19250*/          0, // EndSwitchOpcode
/* 19251*/        /*Scope*/ 77, /*->19329*/
/* 19252*/          OPC_RecordChild1, // #1 = $off
/* 19253*/          OPC_Scope, 42, /*->19297*/ // 2 children in Scope
/* 19255*/            OPC_MoveChild1,
/* 19256*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19259*/            OPC_MoveParent,
/* 19260*/            OPC_MoveChild2,
/* 19261*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19264*/            OPC_RecordChild0, // #2 = $val
/* 19265*/            OPC_MoveParent,
/* 19266*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19268*/            OPC_MoveParent,
/* 19269*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19271*/            OPC_EmitMergeInputChains1_0,
/* 19272*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19275*/            OPC_EmitConvertToTarget, 1,
/* 19277*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19280*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 19287*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 13
                      // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19297*/          /*Scope*/ 30, /*->19328*/
/* 19298*/            OPC_CheckChild1Type, MVT::i32,
/* 19300*/            OPC_MoveChild2,
/* 19301*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19304*/            OPC_RecordChild0, // #2 = $val
/* 19305*/            OPC_MoveParent,
/* 19306*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 19308*/            OPC_MoveParent,
/* 19309*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19311*/            OPC_EmitMergeInputChains1_0,
/* 19312*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19315*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19318*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 10
                      // Dst: (ATOMIC_RMW32_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19328*/          0, /*End of Scope*/
/* 19329*/        0, /*End of Scope*/
/* 19330*/      /*SwitchOpcode*/ 46|128,3/*430*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->19764
/* 19334*/        OPC_RecordMemRef,
/* 19335*/        OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 19336*/        OPC_Scope, 90|128,2/*346*/, /*->19685*/ // 2 children in Scope
/* 19339*/          OPC_MoveChild1,
/* 19340*/          OPC_SwitchOpcode /*3 cases */, 82|128,1/*210*/, TARGET_VAL(ISD::ADD),// ->19555
/* 19345*/            OPC_Scope, 42, /*->19389*/ // 5 children in Scope
/* 19347*/              OPC_RecordChild0, // #1 = $addr
/* 19348*/              OPC_MoveChild1,
/* 19349*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19352*/              OPC_RecordChild0, // #2 = $off
/* 19353*/              OPC_MoveChild0,
/* 19354*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 19357*/              OPC_MoveParent,
/* 19358*/              OPC_MoveParent,
/* 19359*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 19361*/              OPC_CheckType, MVT::i32,
/* 19363*/              OPC_MoveParent,
/* 19364*/              OPC_MoveChild2,
/* 19365*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19368*/              OPC_RecordChild0, // #3 = $val
/* 19369*/              OPC_MoveParent,
/* 19370*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19372*/              OPC_MoveParent,
/* 19373*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19375*/              OPC_EmitMergeInputChains1_0,
/* 19376*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19379*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19389*/            /*Scope*/ 42, /*->19432*/
/* 19390*/              OPC_MoveChild0,
/* 19391*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19394*/              OPC_RecordChild0, // #1 = $off
/* 19395*/              OPC_MoveChild0,
/* 19396*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 19399*/              OPC_MoveParent,
/* 19400*/              OPC_MoveParent,
/* 19401*/              OPC_RecordChild1, // #2 = $addr
/* 19402*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 19404*/              OPC_CheckType, MVT::i32,
/* 19406*/              OPC_MoveParent,
/* 19407*/              OPC_MoveChild2,
/* 19408*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19411*/              OPC_RecordChild0, // #3 = $val
/* 19412*/              OPC_MoveParent,
/* 19413*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19415*/              OPC_MoveParent,
/* 19416*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19418*/              OPC_EmitMergeInputChains1_0,
/* 19419*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19422*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19432*/            /*Scope*/ 40, /*->19473*/
/* 19433*/              OPC_RecordChild0, // #1 = $addr
/* 19434*/              OPC_MoveChild1,
/* 19435*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19438*/              OPC_RecordChild0, // #2 = $off
/* 19439*/              OPC_MoveChild0,
/* 19440*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 19443*/              OPC_MoveParent,
/* 19444*/              OPC_MoveParent,
/* 19445*/              OPC_CheckType, MVT::i32,
/* 19447*/              OPC_MoveParent,
/* 19448*/              OPC_MoveChild2,
/* 19449*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19452*/              OPC_RecordChild0, // #3 = $val
/* 19453*/              OPC_MoveParent,
/* 19454*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19456*/              OPC_MoveParent,
/* 19457*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19459*/              OPC_EmitMergeInputChains1_0,
/* 19460*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19463*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19473*/            /*Scope*/ 40, /*->19514*/
/* 19474*/              OPC_MoveChild0,
/* 19475*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19478*/              OPC_RecordChild0, // #1 = $off
/* 19479*/              OPC_MoveChild0,
/* 19480*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 19483*/              OPC_MoveParent,
/* 19484*/              OPC_MoveParent,
/* 19485*/              OPC_RecordChild1, // #2 = $addr
/* 19486*/              OPC_CheckType, MVT::i32,
/* 19488*/              OPC_MoveParent,
/* 19489*/              OPC_MoveChild2,
/* 19490*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19493*/              OPC_RecordChild0, // #3 = $val
/* 19494*/              OPC_MoveParent,
/* 19495*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19497*/              OPC_MoveParent,
/* 19498*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19500*/              OPC_EmitMergeInputChains1_0,
/* 19501*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19504*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19514*/            /*Scope*/ 39, /*->19554*/
/* 19515*/              OPC_RecordChild0, // #1 = $addr
/* 19516*/              OPC_RecordChild1, // #2 = $off
/* 19517*/              OPC_MoveChild1,
/* 19518*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19521*/              OPC_MoveParent,
/* 19522*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 19524*/              OPC_CheckType, MVT::i32,
/* 19526*/              OPC_MoveParent,
/* 19527*/              OPC_MoveChild2,
/* 19528*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19531*/              OPC_RecordChild0, // #3 = $val
/* 19532*/              OPC_MoveParent,
/* 19533*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19535*/              OPC_MoveParent,
/* 19536*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19538*/              OPC_EmitMergeInputChains1_0,
/* 19539*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19542*/              OPC_EmitConvertToTarget, 2,
/* 19544*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19554*/            0, /*End of Scope*/
/* 19555*/          /*SwitchOpcode*/ 39, TARGET_VAL(ISD::OR),// ->19597
/* 19558*/            OPC_RecordChild0, // #1 = $addr
/* 19559*/            OPC_RecordChild1, // #2 = $off
/* 19560*/            OPC_MoveChild1,
/* 19561*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19564*/            OPC_MoveParent,
/* 19565*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 19567*/            OPC_CheckType, MVT::i32,
/* 19569*/            OPC_MoveParent,
/* 19570*/            OPC_MoveChild2,
/* 19571*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19574*/            OPC_RecordChild0, // #3 = $val
/* 19575*/            OPC_MoveParent,
/* 19576*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19578*/            OPC_MoveParent,
/* 19579*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19581*/            OPC_EmitMergeInputChains1_0,
/* 19582*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19585*/            OPC_EmitConvertToTarget, 2,
/* 19587*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 17
                      // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19597*/          /*SwitchOpcode*/ 84, TARGET_VAL(WebAssemblyISD::Wrapper),// ->19684
/* 19600*/            OPC_RecordChild0, // #1 = $off
/* 19601*/            OPC_MoveChild0,
/* 19602*/            OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::TargetGlobalAddress),// ->19643
/* 19606*/              OPC_MoveParent,
/* 19607*/              OPC_MoveParent,
/* 19608*/              OPC_MoveChild2,
/* 19609*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19612*/              OPC_RecordChild0, // #2 = $val
/* 19613*/              OPC_MoveParent,
/* 19614*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19616*/              OPC_MoveParent,
/* 19617*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19619*/              OPC_EmitMergeInputChains1_0,
/* 19620*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19623*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19626*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19633*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19643*/            /*SwitchOpcode*/ 37, TARGET_VAL(ISD::TargetExternalSymbol),// ->19683
/* 19646*/              OPC_MoveParent,
/* 19647*/              OPC_MoveParent,
/* 19648*/              OPC_MoveChild2,
/* 19649*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19652*/              OPC_RecordChild0, // #2 = $val
/* 19653*/              OPC_MoveParent,
/* 19654*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19656*/              OPC_MoveParent,
/* 19657*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19659*/              OPC_EmitMergeInputChains1_0,
/* 19660*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19663*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19666*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 19673*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19683*/            0, // EndSwitchOpcode
/* 19684*/          0, // EndSwitchOpcode
/* 19685*/        /*Scope*/ 77, /*->19763*/
/* 19686*/          OPC_RecordChild1, // #1 = $off
/* 19687*/          OPC_Scope, 42, /*->19731*/ // 2 children in Scope
/* 19689*/            OPC_MoveChild1,
/* 19690*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19693*/            OPC_MoveParent,
/* 19694*/            OPC_MoveChild2,
/* 19695*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19698*/            OPC_RecordChild0, // #2 = $val
/* 19699*/            OPC_MoveParent,
/* 19700*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19702*/            OPC_MoveParent,
/* 19703*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19705*/            OPC_EmitMergeInputChains1_0,
/* 19706*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19709*/            OPC_EmitConvertToTarget, 1,
/* 19711*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19714*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 19721*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 13
                      // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 19731*/          /*Scope*/ 30, /*->19762*/
/* 19732*/            OPC_CheckChild1Type, MVT::i32,
/* 19734*/            OPC_MoveChild2,
/* 19735*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19738*/            OPC_RecordChild0, // #2 = $val
/* 19739*/            OPC_MoveParent,
/* 19740*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 19742*/            OPC_MoveParent,
/* 19743*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19745*/            OPC_EmitMergeInputChains1_0,
/* 19746*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19749*/            OPC_EmitInteger, MVT::i32, 0, 
/* 19752*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 10
                      // Dst: (ATOMIC_RMW32_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19762*/          0, /*End of Scope*/
/* 19763*/        0, /*End of Scope*/
/* 19764*/      /*SwitchOpcode*/ 46|128,3/*430*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->20198
/* 19768*/        OPC_RecordMemRef,
/* 19769*/        OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 19770*/        OPC_Scope, 90|128,2/*346*/, /*->20119*/ // 2 children in Scope
/* 19773*/          OPC_MoveChild1,
/* 19774*/          OPC_SwitchOpcode /*3 cases */, 82|128,1/*210*/, TARGET_VAL(ISD::ADD),// ->19989
/* 19779*/            OPC_Scope, 42, /*->19823*/ // 5 children in Scope
/* 19781*/              OPC_RecordChild0, // #1 = $addr
/* 19782*/              OPC_MoveChild1,
/* 19783*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19786*/              OPC_RecordChild0, // #2 = $off
/* 19787*/              OPC_MoveChild0,
/* 19788*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 19791*/              OPC_MoveParent,
/* 19792*/              OPC_MoveParent,
/* 19793*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 19795*/              OPC_CheckType, MVT::i32,
/* 19797*/              OPC_MoveParent,
/* 19798*/              OPC_MoveChild2,
/* 19799*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19802*/              OPC_RecordChild0, // #3 = $val
/* 19803*/              OPC_MoveParent,
/* 19804*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 19806*/              OPC_MoveParent,
/* 19807*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19809*/              OPC_EmitMergeInputChains1_0,
/* 19810*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19813*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19823*/            /*Scope*/ 42, /*->19866*/
/* 19824*/              OPC_MoveChild0,
/* 19825*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19828*/              OPC_RecordChild0, // #1 = $off
/* 19829*/              OPC_MoveChild0,
/* 19830*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 19833*/              OPC_MoveParent,
/* 19834*/              OPC_MoveParent,
/* 19835*/              OPC_RecordChild1, // #2 = $addr
/* 19836*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 19838*/              OPC_CheckType, MVT::i32,
/* 19840*/              OPC_MoveParent,
/* 19841*/              OPC_MoveChild2,
/* 19842*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19845*/              OPC_RecordChild0, // #3 = $val
/* 19846*/              OPC_MoveParent,
/* 19847*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 19849*/              OPC_MoveParent,
/* 19850*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19852*/              OPC_EmitMergeInputChains1_0,
/* 19853*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19856*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19866*/            /*Scope*/ 40, /*->19907*/
/* 19867*/              OPC_RecordChild0, // #1 = $addr
/* 19868*/              OPC_MoveChild1,
/* 19869*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19872*/              OPC_RecordChild0, // #2 = $off
/* 19873*/              OPC_MoveChild0,
/* 19874*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 19877*/              OPC_MoveParent,
/* 19878*/              OPC_MoveParent,
/* 19879*/              OPC_CheckType, MVT::i32,
/* 19881*/              OPC_MoveParent,
/* 19882*/              OPC_MoveChild2,
/* 19883*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19886*/              OPC_RecordChild0, // #3 = $val
/* 19887*/              OPC_MoveParent,
/* 19888*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 19890*/              OPC_MoveParent,
/* 19891*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19893*/              OPC_EmitMergeInputChains1_0,
/* 19894*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19897*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19907*/            /*Scope*/ 40, /*->19948*/
/* 19908*/              OPC_MoveChild0,
/* 19909*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 19912*/              OPC_RecordChild0, // #1 = $off
/* 19913*/              OPC_MoveChild0,
/* 19914*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 19917*/              OPC_MoveParent,
/* 19918*/              OPC_MoveParent,
/* 19919*/              OPC_RecordChild1, // #2 = $addr
/* 19920*/              OPC_CheckType, MVT::i32,
/* 19922*/              OPC_MoveParent,
/* 19923*/              OPC_MoveChild2,
/* 19924*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19927*/              OPC_RecordChild0, // #3 = $val
/* 19928*/              OPC_MoveParent,
/* 19929*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 19931*/              OPC_MoveParent,
/* 19932*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19934*/              OPC_EmitMergeInputChains1_0,
/* 19935*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19938*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19948*/            /*Scope*/ 39, /*->19988*/
/* 19949*/              OPC_RecordChild0, // #1 = $addr
/* 19950*/              OPC_RecordChild1, // #2 = $off
/* 19951*/              OPC_MoveChild1,
/* 19952*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19955*/              OPC_MoveParent,
/* 19956*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 19958*/              OPC_CheckType, MVT::i32,
/* 19960*/              OPC_MoveParent,
/* 19961*/              OPC_MoveChild2,
/* 19962*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 19965*/              OPC_RecordChild0, // #3 = $val
/* 19966*/              OPC_MoveParent,
/* 19967*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 19969*/              OPC_MoveParent,
/* 19970*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 19972*/              OPC_EmitMergeInputChains1_0,
/* 19973*/              OPC_EmitInteger, MVT::i32, 0, 
/* 19976*/              OPC_EmitConvertToTarget, 2,
/* 19978*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 19988*/            0, /*End of Scope*/
/* 19989*/          /*SwitchOpcode*/ 39, TARGET_VAL(ISD::OR),// ->20031
/* 19992*/            OPC_RecordChild0, // #1 = $addr
/* 19993*/            OPC_RecordChild1, // #2 = $off
/* 19994*/            OPC_MoveChild1,
/* 19995*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19998*/            OPC_MoveParent,
/* 19999*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 20001*/            OPC_CheckType, MVT::i32,
/* 20003*/            OPC_MoveParent,
/* 20004*/            OPC_MoveChild2,
/* 20005*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20008*/            OPC_RecordChild0, // #3 = $val
/* 20009*/            OPC_MoveParent,
/* 20010*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 20012*/            OPC_MoveParent,
/* 20013*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20015*/            OPC_EmitMergeInputChains1_0,
/* 20016*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20019*/            OPC_EmitConvertToTarget, 2,
/* 20021*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 17
                      // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20031*/          /*SwitchOpcode*/ 84, TARGET_VAL(WebAssemblyISD::Wrapper),// ->20118
/* 20034*/            OPC_RecordChild0, // #1 = $off
/* 20035*/            OPC_MoveChild0,
/* 20036*/            OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::TargetGlobalAddress),// ->20077
/* 20040*/              OPC_MoveParent,
/* 20041*/              OPC_MoveParent,
/* 20042*/              OPC_MoveChild2,
/* 20043*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20046*/              OPC_RecordChild0, // #2 = $val
/* 20047*/              OPC_MoveParent,
/* 20048*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 20050*/              OPC_MoveParent,
/* 20051*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20053*/              OPC_EmitMergeInputChains1_0,
/* 20054*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20057*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20060*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 20067*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 20077*/            /*SwitchOpcode*/ 37, TARGET_VAL(ISD::TargetExternalSymbol),// ->20117
/* 20080*/              OPC_MoveParent,
/* 20081*/              OPC_MoveParent,
/* 20082*/              OPC_MoveChild2,
/* 20083*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20086*/              OPC_RecordChild0, // #2 = $val
/* 20087*/              OPC_MoveParent,
/* 20088*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 20090*/              OPC_MoveParent,
/* 20091*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20093*/              OPC_EmitMergeInputChains1_0,
/* 20094*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20097*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20100*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 20107*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 20117*/            0, // EndSwitchOpcode
/* 20118*/          0, // EndSwitchOpcode
/* 20119*/        /*Scope*/ 77, /*->20197*/
/* 20120*/          OPC_RecordChild1, // #1 = $off
/* 20121*/          OPC_Scope, 42, /*->20165*/ // 2 children in Scope
/* 20123*/            OPC_MoveChild1,
/* 20124*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20127*/            OPC_MoveParent,
/* 20128*/            OPC_MoveChild2,
/* 20129*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20132*/            OPC_RecordChild0, // #2 = $val
/* 20133*/            OPC_MoveParent,
/* 20134*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 20136*/            OPC_MoveParent,
/* 20137*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20139*/            OPC_EmitMergeInputChains1_0,
/* 20140*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20143*/            OPC_EmitConvertToTarget, 1,
/* 20145*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20148*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 20155*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 13
                      // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 20165*/          /*Scope*/ 30, /*->20196*/
/* 20166*/            OPC_CheckChild1Type, MVT::i32,
/* 20168*/            OPC_MoveChild2,
/* 20169*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20172*/            OPC_RecordChild0, // #2 = $val
/* 20173*/            OPC_MoveParent,
/* 20174*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 20176*/            OPC_MoveParent,
/* 20177*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20179*/            OPC_EmitMergeInputChains1_0,
/* 20180*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20183*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20186*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 10
                      // Dst: (ATOMIC_RMW32_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20196*/          0, /*End of Scope*/
/* 20197*/        0, /*End of Scope*/
/* 20198*/      /*SwitchOpcode*/ 46|128,3/*430*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->20632
/* 20202*/        OPC_RecordMemRef,
/* 20203*/        OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 20204*/        OPC_Scope, 90|128,2/*346*/, /*->20553*/ // 2 children in Scope
/* 20207*/          OPC_MoveChild1,
/* 20208*/          OPC_SwitchOpcode /*3 cases */, 82|128,1/*210*/, TARGET_VAL(ISD::ADD),// ->20423
/* 20213*/            OPC_Scope, 42, /*->20257*/ // 5 children in Scope
/* 20215*/              OPC_RecordChild0, // #1 = $addr
/* 20216*/              OPC_MoveChild1,
/* 20217*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20220*/              OPC_RecordChild0, // #2 = $off
/* 20221*/              OPC_MoveChild0,
/* 20222*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 20225*/              OPC_MoveParent,
/* 20226*/              OPC_MoveParent,
/* 20227*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 20229*/              OPC_CheckType, MVT::i32,
/* 20231*/              OPC_MoveParent,
/* 20232*/              OPC_MoveChild2,
/* 20233*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20236*/              OPC_RecordChild0, // #3 = $val
/* 20237*/              OPC_MoveParent,
/* 20238*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20240*/              OPC_MoveParent,
/* 20241*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20243*/              OPC_EmitMergeInputChains1_0,
/* 20244*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20247*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20257*/            /*Scope*/ 42, /*->20300*/
/* 20258*/              OPC_MoveChild0,
/* 20259*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20262*/              OPC_RecordChild0, // #1 = $off
/* 20263*/              OPC_MoveChild0,
/* 20264*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 20267*/              OPC_MoveParent,
/* 20268*/              OPC_MoveParent,
/* 20269*/              OPC_RecordChild1, // #2 = $addr
/* 20270*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 20272*/              OPC_CheckType, MVT::i32,
/* 20274*/              OPC_MoveParent,
/* 20275*/              OPC_MoveChild2,
/* 20276*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20279*/              OPC_RecordChild0, // #3 = $val
/* 20280*/              OPC_MoveParent,
/* 20281*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20283*/              OPC_MoveParent,
/* 20284*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20286*/              OPC_EmitMergeInputChains1_0,
/* 20287*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20290*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 20
                        // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20300*/            /*Scope*/ 40, /*->20341*/
/* 20301*/              OPC_RecordChild0, // #1 = $addr
/* 20302*/              OPC_MoveChild1,
/* 20303*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20306*/              OPC_RecordChild0, // #2 = $off
/* 20307*/              OPC_MoveChild0,
/* 20308*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 20311*/              OPC_MoveParent,
/* 20312*/              OPC_MoveParent,
/* 20313*/              OPC_CheckType, MVT::i32,
/* 20315*/              OPC_MoveParent,
/* 20316*/              OPC_MoveChild2,
/* 20317*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20320*/              OPC_RecordChild0, // #3 = $val
/* 20321*/              OPC_MoveParent,
/* 20322*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20324*/              OPC_MoveParent,
/* 20325*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20327*/              OPC_EmitMergeInputChains1_0,
/* 20328*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20331*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20341*/            /*Scope*/ 40, /*->20382*/
/* 20342*/              OPC_MoveChild0,
/* 20343*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20346*/              OPC_RecordChild0, // #1 = $off
/* 20347*/              OPC_MoveChild0,
/* 20348*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 20351*/              OPC_MoveParent,
/* 20352*/              OPC_MoveParent,
/* 20353*/              OPC_RecordChild1, // #2 = $addr
/* 20354*/              OPC_CheckType, MVT::i32,
/* 20356*/              OPC_MoveParent,
/* 20357*/              OPC_MoveChild2,
/* 20358*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20361*/              OPC_RecordChild0, // #3 = $val
/* 20362*/              OPC_MoveParent,
/* 20363*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20365*/              OPC_MoveParent,
/* 20366*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20368*/              OPC_EmitMergeInputChains1_0,
/* 20369*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20372*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                        // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20382*/            /*Scope*/ 39, /*->20422*/
/* 20383*/              OPC_RecordChild0, // #1 = $addr
/* 20384*/              OPC_RecordChild1, // #2 = $off
/* 20385*/              OPC_MoveChild1,
/* 20386*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20389*/              OPC_MoveParent,
/* 20390*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 20392*/              OPC_CheckType, MVT::i32,
/* 20394*/              OPC_MoveParent,
/* 20395*/              OPC_MoveChild2,
/* 20396*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20399*/              OPC_RecordChild0, // #3 = $val
/* 20400*/              OPC_MoveParent,
/* 20401*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20403*/              OPC_MoveParent,
/* 20404*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20406*/              OPC_EmitMergeInputChains1_0,
/* 20407*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20410*/              OPC_EmitConvertToTarget, 2,
/* 20412*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20422*/            0, /*End of Scope*/
/* 20423*/          /*SwitchOpcode*/ 39, TARGET_VAL(ISD::OR),// ->20465
/* 20426*/            OPC_RecordChild0, // #1 = $addr
/* 20427*/            OPC_RecordChild1, // #2 = $off
/* 20428*/            OPC_MoveChild1,
/* 20429*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20432*/            OPC_MoveParent,
/* 20433*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 20435*/            OPC_CheckType, MVT::i32,
/* 20437*/            OPC_MoveParent,
/* 20438*/            OPC_MoveChild2,
/* 20439*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20442*/            OPC_RecordChild0, // #3 = $val
/* 20443*/            OPC_MoveParent,
/* 20444*/            OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20446*/            OPC_MoveParent,
/* 20447*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20449*/            OPC_EmitMergeInputChains1_0,
/* 20450*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20453*/            OPC_EmitConvertToTarget, 2,
/* 20455*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 17
                      // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20465*/          /*SwitchOpcode*/ 84, TARGET_VAL(WebAssemblyISD::Wrapper),// ->20552
/* 20468*/            OPC_RecordChild0, // #1 = $off
/* 20469*/            OPC_MoveChild0,
/* 20470*/            OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::TargetGlobalAddress),// ->20511
/* 20474*/              OPC_MoveParent,
/* 20475*/              OPC_MoveParent,
/* 20476*/              OPC_MoveChild2,
/* 20477*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20480*/              OPC_RecordChild0, // #2 = $val
/* 20481*/              OPC_MoveParent,
/* 20482*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20484*/              OPC_MoveParent,
/* 20485*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20487*/              OPC_EmitMergeInputChains1_0,
/* 20488*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20491*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20494*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 20501*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 20511*/            /*SwitchOpcode*/ 37, TARGET_VAL(ISD::TargetExternalSymbol),// ->20551
/* 20514*/              OPC_MoveParent,
/* 20515*/              OPC_MoveParent,
/* 20516*/              OPC_MoveChild2,
/* 20517*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20520*/              OPC_RecordChild0, // #2 = $val
/* 20521*/              OPC_MoveParent,
/* 20522*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20524*/              OPC_MoveParent,
/* 20525*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20527*/              OPC_EmitMergeInputChains1_0,
/* 20528*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20531*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20534*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 20541*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 16
                        // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 20551*/            0, // EndSwitchOpcode
/* 20552*/          0, // EndSwitchOpcode
/* 20553*/        /*Scope*/ 77, /*->20631*/
/* 20554*/          OPC_RecordChild1, // #1 = $off
/* 20555*/          OPC_Scope, 42, /*->20599*/ // 2 children in Scope
/* 20557*/            OPC_MoveChild1,
/* 20558*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20561*/            OPC_MoveParent,
/* 20562*/            OPC_MoveChild2,
/* 20563*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20566*/            OPC_RecordChild0, // #2 = $val
/* 20567*/            OPC_MoveParent,
/* 20568*/            OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20570*/            OPC_MoveParent,
/* 20571*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20573*/            OPC_EmitMergeInputChains1_0,
/* 20574*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20577*/            OPC_EmitConvertToTarget, 1,
/* 20579*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20582*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 20589*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 13
                      // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 20599*/          /*Scope*/ 30, /*->20630*/
/* 20600*/            OPC_CheckChild1Type, MVT::i32,
/* 20602*/            OPC_MoveChild2,
/* 20603*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 20606*/            OPC_RecordChild0, // #2 = $val
/* 20607*/            OPC_MoveParent,
/* 20608*/            OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 20610*/            OPC_MoveParent,
/* 20611*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20613*/            OPC_EmitMergeInputChains1_0,
/* 20614*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20617*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20620*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 10
                      // Dst: (ATOMIC_RMW32_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 20630*/          0, /*End of Scope*/
/* 20631*/        0, /*End of Scope*/
/* 20632*/      /*SwitchOpcode*/ 84|128,2/*340*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->20976
/* 20636*/        OPC_RecordMemRef,
/* 20637*/        OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 20638*/        OPC_Scope, 18|128,2/*274*/, /*->20915*/ // 2 children in Scope
/* 20641*/          OPC_MoveChild1,
/* 20642*/          OPC_SwitchOpcode /*3 cases */, 37|128,1/*165*/, TARGET_VAL(ISD::ADD),// ->20812
/* 20647*/            OPC_Scope, 33, /*->20682*/ // 5 children in Scope
/* 20649*/              OPC_RecordChild0, // #1 = $addr
/* 20650*/              OPC_MoveChild1,
/* 20651*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20654*/              OPC_RecordChild0, // #2 = $off
/* 20655*/              OPC_MoveChild0,
/* 20656*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 20659*/              OPC_MoveParent,
/* 20660*/              OPC_MoveParent,
/* 20661*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 20663*/              OPC_CheckType, MVT::i32,
/* 20665*/              OPC_MoveParent,
/* 20666*/              OPC_MoveParent,
/* 20667*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20669*/              OPC_EmitMergeInputChains1_0,
/* 20670*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20673*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)) - Complexity = 16
                        // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 20682*/            /*Scope*/ 33, /*->20716*/
/* 20683*/              OPC_MoveChild0,
/* 20684*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20687*/              OPC_RecordChild0, // #1 = $off
/* 20688*/              OPC_MoveChild0,
/* 20689*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 20692*/              OPC_MoveParent,
/* 20693*/              OPC_MoveParent,
/* 20694*/              OPC_RecordChild1, // #2 = $addr
/* 20695*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 20697*/              OPC_CheckType, MVT::i32,
/* 20699*/              OPC_MoveParent,
/* 20700*/              OPC_MoveParent,
/* 20701*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20703*/              OPC_EmitMergeInputChains1_0,
/* 20704*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20707*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)) - Complexity = 16
                        // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 20716*/            /*Scope*/ 31, /*->20748*/
/* 20717*/              OPC_RecordChild0, // #1 = $addr
/* 20718*/              OPC_MoveChild1,
/* 20719*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20722*/              OPC_RecordChild0, // #2 = $off
/* 20723*/              OPC_MoveChild0,
/* 20724*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 20727*/              OPC_MoveParent,
/* 20728*/              OPC_MoveParent,
/* 20729*/              OPC_CheckType, MVT::i32,
/* 20731*/              OPC_MoveParent,
/* 20732*/              OPC_MoveParent,
/* 20733*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20735*/              OPC_EmitMergeInputChains1_0,
/* 20736*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20739*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))) - Complexity = 15
                        // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 20748*/            /*Scope*/ 31, /*->20780*/
/* 20749*/              OPC_MoveChild0,
/* 20750*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 20753*/              OPC_RecordChild0, // #1 = $off
/* 20754*/              OPC_MoveChild0,
/* 20755*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 20758*/              OPC_MoveParent,
/* 20759*/              OPC_MoveParent,
/* 20760*/              OPC_RecordChild1, // #2 = $addr
/* 20761*/              OPC_CheckType, MVT::i32,
/* 20763*/              OPC_MoveParent,
/* 20764*/              OPC_MoveParent,
/* 20765*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20767*/              OPC_EmitMergeInputChains1_0,
/* 20768*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20771*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))) - Complexity = 15
                        // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 20780*/            /*Scope*/ 30, /*->20811*/
/* 20781*/              OPC_RecordChild0, // #1 = $addr
/* 20782*/              OPC_RecordChild1, // #2 = $off
/* 20783*/              OPC_MoveChild1,
/* 20784*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20787*/              OPC_MoveParent,
/* 20788*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 20790*/              OPC_CheckType, MVT::i32,
/* 20792*/              OPC_MoveParent,
/* 20793*/              OPC_MoveParent,
/* 20794*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20796*/              OPC_EmitMergeInputChains1_0,
/* 20797*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20800*/              OPC_EmitConvertToTarget, 2,
/* 20802*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)) - Complexity = 13
                        // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 20811*/            0, /*End of Scope*/
/* 20812*/          /*SwitchOpcode*/ 30, TARGET_VAL(ISD::OR),// ->20845
/* 20815*/            OPC_RecordChild0, // #1 = $addr
/* 20816*/            OPC_RecordChild1, // #2 = $off
/* 20817*/            OPC_MoveChild1,
/* 20818*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20821*/            OPC_MoveParent,
/* 20822*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 20824*/            OPC_CheckType, MVT::i32,
/* 20826*/            OPC_MoveParent,
/* 20827*/            OPC_MoveParent,
/* 20828*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20830*/            OPC_EmitMergeInputChains1_0,
/* 20831*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20834*/            OPC_EmitConvertToTarget, 2,
/* 20836*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)) - Complexity = 13
                      // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 20845*/          /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::Wrapper),// ->20914
/* 20848*/            OPC_RecordChild0, // #1 = $off
/* 20849*/            OPC_MoveChild0,
/* 20850*/            OPC_SwitchOpcode /*2 cases */, 28, TARGET_VAL(ISD::TargetGlobalAddress),// ->20882
/* 20854*/              OPC_MoveParent,
/* 20855*/              OPC_MoveParent,
/* 20856*/              OPC_MoveParent,
/* 20857*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20859*/              OPC_EmitMergeInputChains1_0,
/* 20860*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20863*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20866*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 20873*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))) - Complexity = 12
                        // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 20882*/            /*SwitchOpcode*/ 28, TARGET_VAL(ISD::TargetExternalSymbol),// ->20913
/* 20885*/              OPC_MoveParent,
/* 20886*/              OPC_MoveParent,
/* 20887*/              OPC_MoveParent,
/* 20888*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20890*/              OPC_EmitMergeInputChains1_0,
/* 20891*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20894*/              OPC_EmitInteger, MVT::i32, 0, 
/* 20897*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 20904*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))) - Complexity = 12
                        // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 20913*/            0, // EndSwitchOpcode
/* 20914*/          0, // EndSwitchOpcode
/* 20915*/        /*Scope*/ 59, /*->20975*/
/* 20916*/          OPC_RecordChild1, // #1 = $off
/* 20917*/          OPC_Scope, 33, /*->20952*/ // 2 children in Scope
/* 20919*/            OPC_MoveChild1,
/* 20920*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20923*/            OPC_MoveParent,
/* 20924*/            OPC_MoveParent,
/* 20925*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20927*/            OPC_EmitMergeInputChains1_0,
/* 20928*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20931*/            OPC_EmitConvertToTarget, 1,
/* 20933*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20936*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 20943*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                      // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)) - Complexity = 9
                      // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 20952*/          /*Scope*/ 21, /*->20974*/
/* 20953*/            OPC_CheckChild1Type, MVT::i32,
/* 20955*/            OPC_MoveParent,
/* 20956*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 20958*/            OPC_EmitMergeInputChains1_0,
/* 20959*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20962*/            OPC_EmitInteger, MVT::i32, 0, 
/* 20965*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                      // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)) - Complexity = 6
                      // Dst: (ATOMIC_LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 20974*/          0, /*End of Scope*/
/* 20975*/        0, /*End of Scope*/
/* 20976*/      0, // EndSwitchOpcode
/* 20977*/    /*Scope*/ 8, /*->20986*/
/* 20978*/      OPC_RecordChild0, // #0 = $src
/* 20979*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                    MVT::i64, 1/*#Ops*/, 0, 
                // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
                // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 20986*/    0, /*End of Scope*/
/* 20987*/  /*SwitchOpcode*/ 48|128,44/*5680*/, TARGET_VAL(ISD::ANY_EXTEND),// ->26671
/* 20991*/    OPC_Scope, 35|128,44/*5667*/, /*->26661*/ // 2 children in Scope
/* 20994*/      OPC_MoveChild0,
/* 20995*/      OPC_SwitchOpcode /*8 cases */, 38|128,6/*806*/, TARGET_VAL(ISD::AssertZext),// ->21806
/* 21000*/        OPC_MoveChild0,
/* 21001*/        OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/* 21004*/        OPC_RecordMemRef,
/* 21005*/        OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 21006*/        OPC_CheckFoldableChainNode,
/* 21007*/        OPC_Scope, 123|128,4/*635*/, /*->21645*/ // 2 children in Scope
/* 21010*/          OPC_MoveChild1,
/* 21011*/          OPC_SwitchOpcode /*3 cases */, 121|128,2/*377*/, TARGET_VAL(ISD::ADD),// ->21393
/* 21016*/            OPC_Scope, 75, /*->21093*/ // 5 children in Scope
/* 21018*/              OPC_RecordChild0, // #1 = $addr
/* 21019*/              OPC_MoveChild1,
/* 21020*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 21023*/              OPC_RecordChild0, // #2 = $off
/* 21024*/              OPC_MoveChild0,
/* 21025*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 21028*/              OPC_MoveParent,
/* 21029*/              OPC_MoveParent,
/* 21030*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 21032*/              OPC_CheckType, MVT::i32,
/* 21034*/              OPC_MoveParent,
/* 21035*/              OPC_MoveChild2,
/* 21036*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21039*/              OPC_RecordChild0, // #3 = $exp
/* 21040*/              OPC_MoveParent,
/* 21041*/              OPC_MoveChild3,
/* 21042*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21045*/              OPC_RecordChild0, // #4 = $new
/* 21046*/              OPC_MoveParent,
/* 21047*/              OPC_Scope, 21, /*->21070*/ // 2 children in Scope
/* 21049*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21051*/                OPC_MoveParent,
/* 21052*/                OPC_MoveParent,
/* 21053*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21055*/                OPC_EmitMergeInputChains1_0,
/* 21056*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21059*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21070*/              /*Scope*/ 21, /*->21092*/
/* 21071*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21073*/                OPC_MoveParent,
/* 21074*/                OPC_MoveParent,
/* 21075*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21077*/                OPC_EmitMergeInputChains1_0,
/* 21078*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21081*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21092*/              0, /*End of Scope*/
/* 21093*/            /*Scope*/ 75, /*->21169*/
/* 21094*/              OPC_MoveChild0,
/* 21095*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 21098*/              OPC_RecordChild0, // #1 = $off
/* 21099*/              OPC_MoveChild0,
/* 21100*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 21103*/              OPC_MoveParent,
/* 21104*/              OPC_MoveParent,
/* 21105*/              OPC_RecordChild1, // #2 = $addr
/* 21106*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 21108*/              OPC_CheckType, MVT::i32,
/* 21110*/              OPC_MoveParent,
/* 21111*/              OPC_MoveChild2,
/* 21112*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21115*/              OPC_RecordChild0, // #3 = $exp
/* 21116*/              OPC_MoveParent,
/* 21117*/              OPC_MoveChild3,
/* 21118*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21121*/              OPC_RecordChild0, // #4 = $new
/* 21122*/              OPC_MoveParent,
/* 21123*/              OPC_Scope, 21, /*->21146*/ // 2 children in Scope
/* 21125*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21127*/                OPC_MoveParent,
/* 21128*/                OPC_MoveParent,
/* 21129*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21131*/                OPC_EmitMergeInputChains1_0,
/* 21132*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21135*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21146*/              /*Scope*/ 21, /*->21168*/
/* 21147*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21149*/                OPC_MoveParent,
/* 21150*/                OPC_MoveParent,
/* 21151*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21153*/                OPC_EmitMergeInputChains1_0,
/* 21154*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21157*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 26
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21168*/              0, /*End of Scope*/
/* 21169*/            /*Scope*/ 73, /*->21243*/
/* 21170*/              OPC_RecordChild0, // #1 = $addr
/* 21171*/              OPC_MoveChild1,
/* 21172*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 21175*/              OPC_RecordChild0, // #2 = $off
/* 21176*/              OPC_MoveChild0,
/* 21177*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 21180*/              OPC_MoveParent,
/* 21181*/              OPC_MoveParent,
/* 21182*/              OPC_CheckType, MVT::i32,
/* 21184*/              OPC_MoveParent,
/* 21185*/              OPC_MoveChild2,
/* 21186*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21189*/              OPC_RecordChild0, // #3 = $exp
/* 21190*/              OPC_MoveParent,
/* 21191*/              OPC_MoveChild3,
/* 21192*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21195*/              OPC_RecordChild0, // #4 = $new
/* 21196*/              OPC_MoveParent,
/* 21197*/              OPC_Scope, 21, /*->21220*/ // 2 children in Scope
/* 21199*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21201*/                OPC_MoveParent,
/* 21202*/                OPC_MoveParent,
/* 21203*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21205*/                OPC_EmitMergeInputChains1_0,
/* 21206*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21209*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21220*/              /*Scope*/ 21, /*->21242*/
/* 21221*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21223*/                OPC_MoveParent,
/* 21224*/                OPC_MoveParent,
/* 21225*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21227*/                OPC_EmitMergeInputChains1_0,
/* 21228*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21231*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21242*/              0, /*End of Scope*/
/* 21243*/            /*Scope*/ 73, /*->21317*/
/* 21244*/              OPC_MoveChild0,
/* 21245*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 21248*/              OPC_RecordChild0, // #1 = $off
/* 21249*/              OPC_MoveChild0,
/* 21250*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 21253*/              OPC_MoveParent,
/* 21254*/              OPC_MoveParent,
/* 21255*/              OPC_RecordChild1, // #2 = $addr
/* 21256*/              OPC_CheckType, MVT::i32,
/* 21258*/              OPC_MoveParent,
/* 21259*/              OPC_MoveChild2,
/* 21260*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21263*/              OPC_RecordChild0, // #3 = $exp
/* 21264*/              OPC_MoveParent,
/* 21265*/              OPC_MoveChild3,
/* 21266*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21269*/              OPC_RecordChild0, // #4 = $new
/* 21270*/              OPC_MoveParent,
/* 21271*/              OPC_Scope, 21, /*->21294*/ // 2 children in Scope
/* 21273*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21275*/                OPC_MoveParent,
/* 21276*/                OPC_MoveParent,
/* 21277*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21279*/                OPC_EmitMergeInputChains1_0,
/* 21280*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21283*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21294*/              /*Scope*/ 21, /*->21316*/
/* 21295*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21297*/                OPC_MoveParent,
/* 21298*/                OPC_MoveParent,
/* 21299*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21301*/                OPC_EmitMergeInputChains1_0,
/* 21302*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21305*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21316*/              0, /*End of Scope*/
/* 21317*/            /*Scope*/ 74, /*->21392*/
/* 21318*/              OPC_RecordChild0, // #1 = $addr
/* 21319*/              OPC_RecordChild1, // #2 = $off
/* 21320*/              OPC_MoveChild1,
/* 21321*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21324*/              OPC_MoveParent,
/* 21325*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 21327*/              OPC_CheckType, MVT::i32,
/* 21329*/              OPC_MoveParent,
/* 21330*/              OPC_MoveChild2,
/* 21331*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21334*/              OPC_RecordChild0, // #3 = $exp
/* 21335*/              OPC_MoveParent,
/* 21336*/              OPC_MoveChild3,
/* 21337*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21340*/              OPC_RecordChild0, // #4 = $new
/* 21341*/              OPC_MoveParent,
/* 21342*/              OPC_Scope, 23, /*->21367*/ // 2 children in Scope
/* 21344*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21346*/                OPC_MoveParent,
/* 21347*/                OPC_MoveParent,
/* 21348*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21350*/                OPC_EmitMergeInputChains1_0,
/* 21351*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21354*/                OPC_EmitConvertToTarget, 2,
/* 21356*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21367*/              /*Scope*/ 23, /*->21391*/
/* 21368*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21370*/                OPC_MoveParent,
/* 21371*/                OPC_MoveParent,
/* 21372*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21374*/                OPC_EmitMergeInputChains1_0,
/* 21375*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21378*/                OPC_EmitConvertToTarget, 2,
/* 21380*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21391*/              0, /*End of Scope*/
/* 21392*/            0, /*End of Scope*/
/* 21393*/          /*SwitchOpcode*/ 74, TARGET_VAL(ISD::OR),// ->21470
/* 21396*/            OPC_RecordChild0, // #1 = $addr
/* 21397*/            OPC_RecordChild1, // #2 = $off
/* 21398*/            OPC_MoveChild1,
/* 21399*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21402*/            OPC_MoveParent,
/* 21403*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 21405*/            OPC_CheckType, MVT::i32,
/* 21407*/            OPC_MoveParent,
/* 21408*/            OPC_MoveChild2,
/* 21409*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21412*/            OPC_RecordChild0, // #3 = $exp
/* 21413*/            OPC_MoveParent,
/* 21414*/            OPC_MoveChild3,
/* 21415*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21418*/            OPC_RecordChild0, // #4 = $new
/* 21419*/            OPC_MoveParent,
/* 21420*/            OPC_Scope, 23, /*->21445*/ // 2 children in Scope
/* 21422*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21424*/              OPC_MoveParent,
/* 21425*/              OPC_MoveParent,
/* 21426*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21428*/              OPC_EmitMergeInputChains1_0,
/* 21429*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21432*/              OPC_EmitConvertToTarget, 2,
/* 21434*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 23
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21445*/            /*Scope*/ 23, /*->21469*/
/* 21446*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21448*/              OPC_MoveParent,
/* 21449*/              OPC_MoveParent,
/* 21450*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21452*/              OPC_EmitMergeInputChains1_0,
/* 21453*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21456*/              OPC_EmitConvertToTarget, 2,
/* 21458*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 23
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21469*/            0, /*End of Scope*/
/* 21470*/          /*SwitchOpcode*/ 42|128,1/*170*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->21644
/* 21474*/            OPC_RecordChild0, // #1 = $off
/* 21475*/            OPC_MoveChild0,
/* 21476*/            OPC_SwitchOpcode /*2 cases */, 80, TARGET_VAL(ISD::TargetGlobalAddress),// ->21560
/* 21480*/              OPC_MoveParent,
/* 21481*/              OPC_MoveParent,
/* 21482*/              OPC_MoveChild2,
/* 21483*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21486*/              OPC_RecordChild0, // #2 = $exp
/* 21487*/              OPC_MoveParent,
/* 21488*/              OPC_MoveChild3,
/* 21489*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21492*/              OPC_RecordChild0, // #3 = $new
/* 21493*/              OPC_MoveParent,
/* 21494*/              OPC_Scope, 31, /*->21527*/ // 2 children in Scope
/* 21496*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21498*/                OPC_MoveParent,
/* 21499*/                OPC_MoveParent,
/* 21500*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21502*/                OPC_EmitMergeInputChains1_0,
/* 21503*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21506*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21509*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 21516*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21527*/              /*Scope*/ 31, /*->21559*/
/* 21528*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21530*/                OPC_MoveParent,
/* 21531*/                OPC_MoveParent,
/* 21532*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21534*/                OPC_EmitMergeInputChains1_0,
/* 21535*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21538*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21541*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 21548*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21559*/              0, /*End of Scope*/
/* 21560*/            /*SwitchOpcode*/ 80, TARGET_VAL(ISD::TargetExternalSymbol),// ->21643
/* 21563*/              OPC_MoveParent,
/* 21564*/              OPC_MoveParent,
/* 21565*/              OPC_MoveChild2,
/* 21566*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21569*/              OPC_RecordChild0, // #2 = $exp
/* 21570*/              OPC_MoveParent,
/* 21571*/              OPC_MoveChild3,
/* 21572*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21575*/              OPC_RecordChild0, // #3 = $new
/* 21576*/              OPC_MoveParent,
/* 21577*/              OPC_Scope, 31, /*->21610*/ // 2 children in Scope
/* 21579*/                OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21581*/                OPC_MoveParent,
/* 21582*/                OPC_MoveParent,
/* 21583*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21585*/                OPC_EmitMergeInputChains1_0,
/* 21586*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21589*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21592*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 21599*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21610*/              /*Scope*/ 31, /*->21642*/
/* 21611*/                OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21613*/                OPC_MoveParent,
/* 21614*/                OPC_MoveParent,
/* 21615*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21617*/                OPC_EmitMergeInputChains1_0,
/* 21618*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21621*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21624*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 21631*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 22
                          // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21642*/              0, /*End of Scope*/
/* 21643*/            0, // EndSwitchOpcode
/* 21644*/          0, // EndSwitchOpcode
/* 21645*/        /*Scope*/ 30|128,1/*158*/, /*->21805*/
/* 21647*/          OPC_RecordChild1, // #1 = $off
/* 21648*/          OPC_Scope, 87, /*->21737*/ // 2 children in Scope
/* 21650*/            OPC_MoveChild1,
/* 21651*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21654*/            OPC_MoveParent,
/* 21655*/            OPC_MoveChild2,
/* 21656*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21659*/            OPC_RecordChild0, // #2 = $exp
/* 21660*/            OPC_MoveParent,
/* 21661*/            OPC_MoveChild3,
/* 21662*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21665*/            OPC_RecordChild0, // #3 = $new
/* 21666*/            OPC_MoveParent,
/* 21667*/            OPC_Scope, 33, /*->21702*/ // 2 children in Scope
/* 21669*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21671*/              OPC_MoveParent,
/* 21672*/              OPC_MoveParent,
/* 21673*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21675*/              OPC_EmitMergeInputChains1_0,
/* 21676*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21679*/              OPC_EmitConvertToTarget, 1,
/* 21681*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21684*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 21691*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                        // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 19
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21702*/            /*Scope*/ 33, /*->21736*/
/* 21703*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21705*/              OPC_MoveParent,
/* 21706*/              OPC_MoveParent,
/* 21707*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21709*/              OPC_EmitMergeInputChains1_0,
/* 21710*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21713*/              OPC_EmitConvertToTarget, 1,
/* 21715*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21718*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 21725*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                        // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 19
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21736*/            0, /*End of Scope*/
/* 21737*/          /*Scope*/ 66, /*->21804*/
/* 21738*/            OPC_CheckChild1Type, MVT::i32,
/* 21740*/            OPC_MoveChild2,
/* 21741*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21744*/            OPC_RecordChild0, // #2 = $exp
/* 21745*/            OPC_MoveParent,
/* 21746*/            OPC_MoveChild3,
/* 21747*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21750*/            OPC_RecordChild0, // #3 = $new
/* 21751*/            OPC_MoveParent,
/* 21752*/            OPC_Scope, 24, /*->21778*/ // 2 children in Scope
/* 21754*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 21756*/              OPC_MoveParent,
/* 21757*/              OPC_MoveParent,
/* 21758*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21760*/              OPC_EmitMergeInputChains1_0,
/* 21761*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21764*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21767*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                        // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 16
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21778*/            /*Scope*/ 24, /*->21803*/
/* 21779*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 21781*/              OPC_MoveParent,
/* 21782*/              OPC_MoveParent,
/* 21783*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21785*/              OPC_EmitMergeInputChains1_0,
/* 21786*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21789*/              OPC_EmitInteger, MVT::i32, 0, 
/* 21792*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                        // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 16
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 21803*/            0, /*End of Scope*/
/* 21804*/          0, /*End of Scope*/
/* 21805*/        0, /*End of Scope*/
/* 21806*/      /*SwitchOpcode*/ 61|128,5/*701*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->22511
/* 21810*/        OPC_RecordMemRef,
/* 21811*/        OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 21812*/        OPC_Scope, 43|128,4/*555*/, /*->22370*/ // 2 children in Scope
/* 21815*/          OPC_MoveChild1,
/* 21816*/          OPC_SwitchOpcode /*3 cases */, 71|128,2/*327*/, TARGET_VAL(ISD::ADD),// ->22148
/* 21821*/            OPC_Scope, 65, /*->21888*/ // 5 children in Scope
/* 21823*/              OPC_RecordChild0, // #1 = $addr
/* 21824*/              OPC_MoveChild1,
/* 21825*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 21828*/              OPC_RecordChild0, // #2 = $off
/* 21829*/              OPC_MoveChild0,
/* 21830*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 21833*/              OPC_MoveParent,
/* 21834*/              OPC_MoveParent,
/* 21835*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 21837*/              OPC_CheckType, MVT::i32,
/* 21839*/              OPC_MoveParent,
/* 21840*/              OPC_MoveChild2,
/* 21841*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21844*/              OPC_RecordChild0, // #3 = $val
/* 21845*/              OPC_MoveParent,
/* 21846*/              OPC_Scope, 19, /*->21867*/ // 2 children in Scope
/* 21848*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 21850*/                OPC_MoveParent,
/* 21851*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21853*/                OPC_EmitMergeInputChains1_0,
/* 21854*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21857*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 21867*/              /*Scope*/ 19, /*->21887*/
/* 21868*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 21870*/                OPC_MoveParent,
/* 21871*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21873*/                OPC_EmitMergeInputChains1_0,
/* 21874*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21877*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 21887*/              0, /*End of Scope*/
/* 21888*/            /*Scope*/ 65, /*->21954*/
/* 21889*/              OPC_MoveChild0,
/* 21890*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 21893*/              OPC_RecordChild0, // #1 = $off
/* 21894*/              OPC_MoveChild0,
/* 21895*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 21898*/              OPC_MoveParent,
/* 21899*/              OPC_MoveParent,
/* 21900*/              OPC_RecordChild1, // #2 = $addr
/* 21901*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 21903*/              OPC_CheckType, MVT::i32,
/* 21905*/              OPC_MoveParent,
/* 21906*/              OPC_MoveChild2,
/* 21907*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21910*/              OPC_RecordChild0, // #3 = $val
/* 21911*/              OPC_MoveParent,
/* 21912*/              OPC_Scope, 19, /*->21933*/ // 2 children in Scope
/* 21914*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 21916*/                OPC_MoveParent,
/* 21917*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21919*/                OPC_EmitMergeInputChains1_0,
/* 21920*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21923*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 21933*/              /*Scope*/ 19, /*->21953*/
/* 21934*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 21936*/                OPC_MoveParent,
/* 21937*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21939*/                OPC_EmitMergeInputChains1_0,
/* 21940*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21943*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 21953*/              0, /*End of Scope*/
/* 21954*/            /*Scope*/ 63, /*->22018*/
/* 21955*/              OPC_RecordChild0, // #1 = $addr
/* 21956*/              OPC_MoveChild1,
/* 21957*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 21960*/              OPC_RecordChild0, // #2 = $off
/* 21961*/              OPC_MoveChild0,
/* 21962*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 21965*/              OPC_MoveParent,
/* 21966*/              OPC_MoveParent,
/* 21967*/              OPC_CheckType, MVT::i32,
/* 21969*/              OPC_MoveParent,
/* 21970*/              OPC_MoveChild2,
/* 21971*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21974*/              OPC_RecordChild0, // #3 = $val
/* 21975*/              OPC_MoveParent,
/* 21976*/              OPC_Scope, 19, /*->21997*/ // 2 children in Scope
/* 21978*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 21980*/                OPC_MoveParent,
/* 21981*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 21983*/                OPC_EmitMergeInputChains1_0,
/* 21984*/                OPC_EmitInteger, MVT::i32, 0, 
/* 21987*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 21997*/              /*Scope*/ 19, /*->22017*/
/* 21998*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22000*/                OPC_MoveParent,
/* 22001*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22003*/                OPC_EmitMergeInputChains1_0,
/* 22004*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22007*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22017*/              0, /*End of Scope*/
/* 22018*/            /*Scope*/ 63, /*->22082*/
/* 22019*/              OPC_MoveChild0,
/* 22020*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 22023*/              OPC_RecordChild0, // #1 = $off
/* 22024*/              OPC_MoveChild0,
/* 22025*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 22028*/              OPC_MoveParent,
/* 22029*/              OPC_MoveParent,
/* 22030*/              OPC_RecordChild1, // #2 = $addr
/* 22031*/              OPC_CheckType, MVT::i32,
/* 22033*/              OPC_MoveParent,
/* 22034*/              OPC_MoveChild2,
/* 22035*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22038*/              OPC_RecordChild0, // #3 = $val
/* 22039*/              OPC_MoveParent,
/* 22040*/              OPC_Scope, 19, /*->22061*/ // 2 children in Scope
/* 22042*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 22044*/                OPC_MoveParent,
/* 22045*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22047*/                OPC_EmitMergeInputChains1_0,
/* 22048*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22051*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22061*/              /*Scope*/ 19, /*->22081*/
/* 22062*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22064*/                OPC_MoveParent,
/* 22065*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22067*/                OPC_EmitMergeInputChains1_0,
/* 22068*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22071*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22081*/              0, /*End of Scope*/
/* 22082*/            /*Scope*/ 64, /*->22147*/
/* 22083*/              OPC_RecordChild0, // #1 = $addr
/* 22084*/              OPC_RecordChild1, // #2 = $off
/* 22085*/              OPC_MoveChild1,
/* 22086*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22089*/              OPC_MoveParent,
/* 22090*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 22092*/              OPC_CheckType, MVT::i32,
/* 22094*/              OPC_MoveParent,
/* 22095*/              OPC_MoveChild2,
/* 22096*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22099*/              OPC_RecordChild0, // #3 = $val
/* 22100*/              OPC_MoveParent,
/* 22101*/              OPC_Scope, 21, /*->22124*/ // 2 children in Scope
/* 22103*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 22105*/                OPC_MoveParent,
/* 22106*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22108*/                OPC_EmitMergeInputChains1_0,
/* 22109*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22112*/                OPC_EmitConvertToTarget, 2,
/* 22114*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22124*/              /*Scope*/ 21, /*->22146*/
/* 22125*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22127*/                OPC_MoveParent,
/* 22128*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22130*/                OPC_EmitMergeInputChains1_0,
/* 22131*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22134*/                OPC_EmitConvertToTarget, 2,
/* 22136*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22146*/              0, /*End of Scope*/
/* 22147*/            0, /*End of Scope*/
/* 22148*/          /*SwitchOpcode*/ 64, TARGET_VAL(ISD::OR),// ->22215
/* 22151*/            OPC_RecordChild0, // #1 = $addr
/* 22152*/            OPC_RecordChild1, // #2 = $off
/* 22153*/            OPC_MoveChild1,
/* 22154*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22157*/            OPC_MoveParent,
/* 22158*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 22160*/            OPC_CheckType, MVT::i32,
/* 22162*/            OPC_MoveParent,
/* 22163*/            OPC_MoveChild2,
/* 22164*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22167*/            OPC_RecordChild0, // #3 = $val
/* 22168*/            OPC_MoveParent,
/* 22169*/            OPC_Scope, 21, /*->22192*/ // 2 children in Scope
/* 22171*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 22173*/              OPC_MoveParent,
/* 22174*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22176*/              OPC_EmitMergeInputChains1_0,
/* 22177*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22180*/              OPC_EmitConvertToTarget, 2,
/* 22182*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22192*/            /*Scope*/ 21, /*->22214*/
/* 22193*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22195*/              OPC_MoveParent,
/* 22196*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22198*/              OPC_EmitMergeInputChains1_0,
/* 22199*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22202*/              OPC_EmitConvertToTarget, 2,
/* 22204*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22214*/            0, /*End of Scope*/
/* 22215*/          /*SwitchOpcode*/ 22|128,1/*150*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->22369
/* 22219*/            OPC_RecordChild0, // #1 = $off
/* 22220*/            OPC_MoveChild0,
/* 22221*/            OPC_SwitchOpcode /*2 cases */, 70, TARGET_VAL(ISD::TargetGlobalAddress),// ->22295
/* 22225*/              OPC_MoveParent,
/* 22226*/              OPC_MoveParent,
/* 22227*/              OPC_MoveChild2,
/* 22228*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22231*/              OPC_RecordChild0, // #2 = $val
/* 22232*/              OPC_MoveParent,
/* 22233*/              OPC_Scope, 29, /*->22264*/ // 2 children in Scope
/* 22235*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 22237*/                OPC_MoveParent,
/* 22238*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22240*/                OPC_EmitMergeInputChains1_0,
/* 22241*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22244*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22247*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 22254*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22264*/              /*Scope*/ 29, /*->22294*/
/* 22265*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22267*/                OPC_MoveParent,
/* 22268*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22270*/                OPC_EmitMergeInputChains1_0,
/* 22271*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22274*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22277*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 22284*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22294*/              0, /*End of Scope*/
/* 22295*/            /*SwitchOpcode*/ 70, TARGET_VAL(ISD::TargetExternalSymbol),// ->22368
/* 22298*/              OPC_MoveParent,
/* 22299*/              OPC_MoveParent,
/* 22300*/              OPC_MoveChild2,
/* 22301*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22304*/              OPC_RecordChild0, // #2 = $val
/* 22305*/              OPC_MoveParent,
/* 22306*/              OPC_Scope, 29, /*->22337*/ // 2 children in Scope
/* 22308*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 22310*/                OPC_MoveParent,
/* 22311*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22313*/                OPC_EmitMergeInputChains1_0,
/* 22314*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22317*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22320*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 22327*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22337*/              /*Scope*/ 29, /*->22367*/
/* 22338*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22340*/                OPC_MoveParent,
/* 22341*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22343*/                OPC_EmitMergeInputChains1_0,
/* 22344*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22347*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22350*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 22357*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22367*/              0, /*End of Scope*/
/* 22368*/            0, // EndSwitchOpcode
/* 22369*/          0, // EndSwitchOpcode
/* 22370*/        /*Scope*/ 10|128,1/*138*/, /*->22510*/
/* 22372*/          OPC_RecordChild1, // #1 = $off
/* 22373*/          OPC_Scope, 77, /*->22452*/ // 2 children in Scope
/* 22375*/            OPC_MoveChild1,
/* 22376*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22379*/            OPC_MoveParent,
/* 22380*/            OPC_MoveChild2,
/* 22381*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22384*/            OPC_RecordChild0, // #2 = $val
/* 22385*/            OPC_MoveParent,
/* 22386*/            OPC_Scope, 31, /*->22419*/ // 2 children in Scope
/* 22388*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 22390*/              OPC_MoveParent,
/* 22391*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22393*/              OPC_EmitMergeInputChains1_0,
/* 22394*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22397*/              OPC_EmitConvertToTarget, 1,
/* 22399*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22402*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 22409*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22419*/            /*Scope*/ 31, /*->22451*/
/* 22420*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22422*/              OPC_MoveParent,
/* 22423*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22425*/              OPC_EmitMergeInputChains1_0,
/* 22426*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22429*/              OPC_EmitConvertToTarget, 1,
/* 22431*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22434*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 22441*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22451*/            0, /*End of Scope*/
/* 22452*/          /*Scope*/ 56, /*->22509*/
/* 22453*/            OPC_CheckChild1Type, MVT::i32,
/* 22455*/            OPC_MoveChild2,
/* 22456*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22459*/            OPC_RecordChild0, // #2 = $val
/* 22460*/            OPC_MoveParent,
/* 22461*/            OPC_Scope, 22, /*->22485*/ // 2 children in Scope
/* 22463*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 22465*/              OPC_MoveParent,
/* 22466*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22468*/              OPC_EmitMergeInputChains1_0,
/* 22469*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22472*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22475*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22485*/            /*Scope*/ 22, /*->22508*/
/* 22486*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 22488*/              OPC_MoveParent,
/* 22489*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22491*/              OPC_EmitMergeInputChains1_0,
/* 22492*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22495*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22498*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22508*/            0, /*End of Scope*/
/* 22509*/          0, /*End of Scope*/
/* 22510*/        0, /*End of Scope*/
/* 22511*/      /*SwitchOpcode*/ 61|128,5/*701*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->23216
/* 22515*/        OPC_RecordMemRef,
/* 22516*/        OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 22517*/        OPC_Scope, 43|128,4/*555*/, /*->23075*/ // 2 children in Scope
/* 22520*/          OPC_MoveChild1,
/* 22521*/          OPC_SwitchOpcode /*3 cases */, 71|128,2/*327*/, TARGET_VAL(ISD::ADD),// ->22853
/* 22526*/            OPC_Scope, 65, /*->22593*/ // 5 children in Scope
/* 22528*/              OPC_RecordChild0, // #1 = $addr
/* 22529*/              OPC_MoveChild1,
/* 22530*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 22533*/              OPC_RecordChild0, // #2 = $off
/* 22534*/              OPC_MoveChild0,
/* 22535*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 22538*/              OPC_MoveParent,
/* 22539*/              OPC_MoveParent,
/* 22540*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 22542*/              OPC_CheckType, MVT::i32,
/* 22544*/              OPC_MoveParent,
/* 22545*/              OPC_MoveChild2,
/* 22546*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22549*/              OPC_RecordChild0, // #3 = $val
/* 22550*/              OPC_MoveParent,
/* 22551*/              OPC_Scope, 19, /*->22572*/ // 2 children in Scope
/* 22553*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 22555*/                OPC_MoveParent,
/* 22556*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22558*/                OPC_EmitMergeInputChains1_0,
/* 22559*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22562*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22572*/              /*Scope*/ 19, /*->22592*/
/* 22573*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 22575*/                OPC_MoveParent,
/* 22576*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22578*/                OPC_EmitMergeInputChains1_0,
/* 22579*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22582*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22592*/              0, /*End of Scope*/
/* 22593*/            /*Scope*/ 65, /*->22659*/
/* 22594*/              OPC_MoveChild0,
/* 22595*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 22598*/              OPC_RecordChild0, // #1 = $off
/* 22599*/              OPC_MoveChild0,
/* 22600*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 22603*/              OPC_MoveParent,
/* 22604*/              OPC_MoveParent,
/* 22605*/              OPC_RecordChild1, // #2 = $addr
/* 22606*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 22608*/              OPC_CheckType, MVT::i32,
/* 22610*/              OPC_MoveParent,
/* 22611*/              OPC_MoveChild2,
/* 22612*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22615*/              OPC_RecordChild0, // #3 = $val
/* 22616*/              OPC_MoveParent,
/* 22617*/              OPC_Scope, 19, /*->22638*/ // 2 children in Scope
/* 22619*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 22621*/                OPC_MoveParent,
/* 22622*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22624*/                OPC_EmitMergeInputChains1_0,
/* 22625*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22628*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22638*/              /*Scope*/ 19, /*->22658*/
/* 22639*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 22641*/                OPC_MoveParent,
/* 22642*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22644*/                OPC_EmitMergeInputChains1_0,
/* 22645*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22648*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22658*/              0, /*End of Scope*/
/* 22659*/            /*Scope*/ 63, /*->22723*/
/* 22660*/              OPC_RecordChild0, // #1 = $addr
/* 22661*/              OPC_MoveChild1,
/* 22662*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 22665*/              OPC_RecordChild0, // #2 = $off
/* 22666*/              OPC_MoveChild0,
/* 22667*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 22670*/              OPC_MoveParent,
/* 22671*/              OPC_MoveParent,
/* 22672*/              OPC_CheckType, MVT::i32,
/* 22674*/              OPC_MoveParent,
/* 22675*/              OPC_MoveChild2,
/* 22676*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22679*/              OPC_RecordChild0, // #3 = $val
/* 22680*/              OPC_MoveParent,
/* 22681*/              OPC_Scope, 19, /*->22702*/ // 2 children in Scope
/* 22683*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 22685*/                OPC_MoveParent,
/* 22686*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22688*/                OPC_EmitMergeInputChains1_0,
/* 22689*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22692*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22702*/              /*Scope*/ 19, /*->22722*/
/* 22703*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 22705*/                OPC_MoveParent,
/* 22706*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22708*/                OPC_EmitMergeInputChains1_0,
/* 22709*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22712*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22722*/              0, /*End of Scope*/
/* 22723*/            /*Scope*/ 63, /*->22787*/
/* 22724*/              OPC_MoveChild0,
/* 22725*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 22728*/              OPC_RecordChild0, // #1 = $off
/* 22729*/              OPC_MoveChild0,
/* 22730*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 22733*/              OPC_MoveParent,
/* 22734*/              OPC_MoveParent,
/* 22735*/              OPC_RecordChild1, // #2 = $addr
/* 22736*/              OPC_CheckType, MVT::i32,
/* 22738*/              OPC_MoveParent,
/* 22739*/              OPC_MoveChild2,
/* 22740*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22743*/              OPC_RecordChild0, // #3 = $val
/* 22744*/              OPC_MoveParent,
/* 22745*/              OPC_Scope, 19, /*->22766*/ // 2 children in Scope
/* 22747*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 22749*/                OPC_MoveParent,
/* 22750*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22752*/                OPC_EmitMergeInputChains1_0,
/* 22753*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22756*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22766*/              /*Scope*/ 19, /*->22786*/
/* 22767*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 22769*/                OPC_MoveParent,
/* 22770*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22772*/                OPC_EmitMergeInputChains1_0,
/* 22773*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22776*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22786*/              0, /*End of Scope*/
/* 22787*/            /*Scope*/ 64, /*->22852*/
/* 22788*/              OPC_RecordChild0, // #1 = $addr
/* 22789*/              OPC_RecordChild1, // #2 = $off
/* 22790*/              OPC_MoveChild1,
/* 22791*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22794*/              OPC_MoveParent,
/* 22795*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 22797*/              OPC_CheckType, MVT::i32,
/* 22799*/              OPC_MoveParent,
/* 22800*/              OPC_MoveChild2,
/* 22801*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22804*/              OPC_RecordChild0, // #3 = $val
/* 22805*/              OPC_MoveParent,
/* 22806*/              OPC_Scope, 21, /*->22829*/ // 2 children in Scope
/* 22808*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 22810*/                OPC_MoveParent,
/* 22811*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22813*/                OPC_EmitMergeInputChains1_0,
/* 22814*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22817*/                OPC_EmitConvertToTarget, 2,
/* 22819*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22829*/              /*Scope*/ 21, /*->22851*/
/* 22830*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 22832*/                OPC_MoveParent,
/* 22833*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22835*/                OPC_EmitMergeInputChains1_0,
/* 22836*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22839*/                OPC_EmitConvertToTarget, 2,
/* 22841*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22851*/              0, /*End of Scope*/
/* 22852*/            0, /*End of Scope*/
/* 22853*/          /*SwitchOpcode*/ 64, TARGET_VAL(ISD::OR),// ->22920
/* 22856*/            OPC_RecordChild0, // #1 = $addr
/* 22857*/            OPC_RecordChild1, // #2 = $off
/* 22858*/            OPC_MoveChild1,
/* 22859*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22862*/            OPC_MoveParent,
/* 22863*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 22865*/            OPC_CheckType, MVT::i32,
/* 22867*/            OPC_MoveParent,
/* 22868*/            OPC_MoveChild2,
/* 22869*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22872*/            OPC_RecordChild0, // #3 = $val
/* 22873*/            OPC_MoveParent,
/* 22874*/            OPC_Scope, 21, /*->22897*/ // 2 children in Scope
/* 22876*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 22878*/              OPC_MoveParent,
/* 22879*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22881*/              OPC_EmitMergeInputChains1_0,
/* 22882*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22885*/              OPC_EmitConvertToTarget, 2,
/* 22887*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22897*/            /*Scope*/ 21, /*->22919*/
/* 22898*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 22900*/              OPC_MoveParent,
/* 22901*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22903*/              OPC_EmitMergeInputChains1_0,
/* 22904*/              OPC_EmitInteger, MVT::i32, 0, 
/* 22907*/              OPC_EmitConvertToTarget, 2,
/* 22909*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 22919*/            0, /*End of Scope*/
/* 22920*/          /*SwitchOpcode*/ 22|128,1/*150*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->23074
/* 22924*/            OPC_RecordChild0, // #1 = $off
/* 22925*/            OPC_MoveChild0,
/* 22926*/            OPC_SwitchOpcode /*2 cases */, 70, TARGET_VAL(ISD::TargetGlobalAddress),// ->23000
/* 22930*/              OPC_MoveParent,
/* 22931*/              OPC_MoveParent,
/* 22932*/              OPC_MoveChild2,
/* 22933*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22936*/              OPC_RecordChild0, // #2 = $val
/* 22937*/              OPC_MoveParent,
/* 22938*/              OPC_Scope, 29, /*->22969*/ // 2 children in Scope
/* 22940*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 22942*/                OPC_MoveParent,
/* 22943*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22945*/                OPC_EmitMergeInputChains1_0,
/* 22946*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22949*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22952*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 22959*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22969*/              /*Scope*/ 29, /*->22999*/
/* 22970*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 22972*/                OPC_MoveParent,
/* 22973*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 22975*/                OPC_EmitMergeInputChains1_0,
/* 22976*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22979*/                OPC_EmitInteger, MVT::i32, 0, 
/* 22982*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 22989*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 22999*/              0, /*End of Scope*/
/* 23000*/            /*SwitchOpcode*/ 70, TARGET_VAL(ISD::TargetExternalSymbol),// ->23073
/* 23003*/              OPC_MoveParent,
/* 23004*/              OPC_MoveParent,
/* 23005*/              OPC_MoveChild2,
/* 23006*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23009*/              OPC_RecordChild0, // #2 = $val
/* 23010*/              OPC_MoveParent,
/* 23011*/              OPC_Scope, 29, /*->23042*/ // 2 children in Scope
/* 23013*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 23015*/                OPC_MoveParent,
/* 23016*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23018*/                OPC_EmitMergeInputChains1_0,
/* 23019*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23022*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23025*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23032*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23042*/              /*Scope*/ 29, /*->23072*/
/* 23043*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 23045*/                OPC_MoveParent,
/* 23046*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23048*/                OPC_EmitMergeInputChains1_0,
/* 23049*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23052*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23055*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23062*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23072*/              0, /*End of Scope*/
/* 23073*/            0, // EndSwitchOpcode
/* 23074*/          0, // EndSwitchOpcode
/* 23075*/        /*Scope*/ 10|128,1/*138*/, /*->23215*/
/* 23077*/          OPC_RecordChild1, // #1 = $off
/* 23078*/          OPC_Scope, 77, /*->23157*/ // 2 children in Scope
/* 23080*/            OPC_MoveChild1,
/* 23081*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23084*/            OPC_MoveParent,
/* 23085*/            OPC_MoveChild2,
/* 23086*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23089*/            OPC_RecordChild0, // #2 = $val
/* 23090*/            OPC_MoveParent,
/* 23091*/            OPC_Scope, 31, /*->23124*/ // 2 children in Scope
/* 23093*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 23095*/              OPC_MoveParent,
/* 23096*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23098*/              OPC_EmitMergeInputChains1_0,
/* 23099*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23102*/              OPC_EmitConvertToTarget, 1,
/* 23104*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23107*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 23114*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23124*/            /*Scope*/ 31, /*->23156*/
/* 23125*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 23127*/              OPC_MoveParent,
/* 23128*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23130*/              OPC_EmitMergeInputChains1_0,
/* 23131*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23134*/              OPC_EmitConvertToTarget, 1,
/* 23136*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23139*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 23146*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23156*/            0, /*End of Scope*/
/* 23157*/          /*Scope*/ 56, /*->23214*/
/* 23158*/            OPC_CheckChild1Type, MVT::i32,
/* 23160*/            OPC_MoveChild2,
/* 23161*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23164*/            OPC_RecordChild0, // #2 = $val
/* 23165*/            OPC_MoveParent,
/* 23166*/            OPC_Scope, 22, /*->23190*/ // 2 children in Scope
/* 23168*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 23170*/              OPC_MoveParent,
/* 23171*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23173*/              OPC_EmitMergeInputChains1_0,
/* 23174*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23177*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23180*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23190*/            /*Scope*/ 22, /*->23213*/
/* 23191*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 23193*/              OPC_MoveParent,
/* 23194*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23196*/              OPC_EmitMergeInputChains1_0,
/* 23197*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23200*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23203*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23213*/            0, /*End of Scope*/
/* 23214*/          0, /*End of Scope*/
/* 23215*/        0, /*End of Scope*/
/* 23216*/      /*SwitchOpcode*/ 61|128,5/*701*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->23921
/* 23220*/        OPC_RecordMemRef,
/* 23221*/        OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 23222*/        OPC_Scope, 43|128,4/*555*/, /*->23780*/ // 2 children in Scope
/* 23225*/          OPC_MoveChild1,
/* 23226*/          OPC_SwitchOpcode /*3 cases */, 71|128,2/*327*/, TARGET_VAL(ISD::ADD),// ->23558
/* 23231*/            OPC_Scope, 65, /*->23298*/ // 5 children in Scope
/* 23233*/              OPC_RecordChild0, // #1 = $addr
/* 23234*/              OPC_MoveChild1,
/* 23235*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 23238*/              OPC_RecordChild0, // #2 = $off
/* 23239*/              OPC_MoveChild0,
/* 23240*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 23243*/              OPC_MoveParent,
/* 23244*/              OPC_MoveParent,
/* 23245*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 23247*/              OPC_CheckType, MVT::i32,
/* 23249*/              OPC_MoveParent,
/* 23250*/              OPC_MoveChild2,
/* 23251*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23254*/              OPC_RecordChild0, // #3 = $val
/* 23255*/              OPC_MoveParent,
/* 23256*/              OPC_Scope, 19, /*->23277*/ // 2 children in Scope
/* 23258*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23260*/                OPC_MoveParent,
/* 23261*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23263*/                OPC_EmitMergeInputChains1_0,
/* 23264*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23267*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23277*/              /*Scope*/ 19, /*->23297*/
/* 23278*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23280*/                OPC_MoveParent,
/* 23281*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23283*/                OPC_EmitMergeInputChains1_0,
/* 23284*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23287*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23297*/              0, /*End of Scope*/
/* 23298*/            /*Scope*/ 65, /*->23364*/
/* 23299*/              OPC_MoveChild0,
/* 23300*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 23303*/              OPC_RecordChild0, // #1 = $off
/* 23304*/              OPC_MoveChild0,
/* 23305*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 23308*/              OPC_MoveParent,
/* 23309*/              OPC_MoveParent,
/* 23310*/              OPC_RecordChild1, // #2 = $addr
/* 23311*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 23313*/              OPC_CheckType, MVT::i32,
/* 23315*/              OPC_MoveParent,
/* 23316*/              OPC_MoveChild2,
/* 23317*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23320*/              OPC_RecordChild0, // #3 = $val
/* 23321*/              OPC_MoveParent,
/* 23322*/              OPC_Scope, 19, /*->23343*/ // 2 children in Scope
/* 23324*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23326*/                OPC_MoveParent,
/* 23327*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23329*/                OPC_EmitMergeInputChains1_0,
/* 23330*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23333*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23343*/              /*Scope*/ 19, /*->23363*/
/* 23344*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23346*/                OPC_MoveParent,
/* 23347*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23349*/                OPC_EmitMergeInputChains1_0,
/* 23350*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23353*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23363*/              0, /*End of Scope*/
/* 23364*/            /*Scope*/ 63, /*->23428*/
/* 23365*/              OPC_RecordChild0, // #1 = $addr
/* 23366*/              OPC_MoveChild1,
/* 23367*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 23370*/              OPC_RecordChild0, // #2 = $off
/* 23371*/              OPC_MoveChild0,
/* 23372*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 23375*/              OPC_MoveParent,
/* 23376*/              OPC_MoveParent,
/* 23377*/              OPC_CheckType, MVT::i32,
/* 23379*/              OPC_MoveParent,
/* 23380*/              OPC_MoveChild2,
/* 23381*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23384*/              OPC_RecordChild0, // #3 = $val
/* 23385*/              OPC_MoveParent,
/* 23386*/              OPC_Scope, 19, /*->23407*/ // 2 children in Scope
/* 23388*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23390*/                OPC_MoveParent,
/* 23391*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23393*/                OPC_EmitMergeInputChains1_0,
/* 23394*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23397*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23407*/              /*Scope*/ 19, /*->23427*/
/* 23408*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23410*/                OPC_MoveParent,
/* 23411*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23413*/                OPC_EmitMergeInputChains1_0,
/* 23414*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23417*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23427*/              0, /*End of Scope*/
/* 23428*/            /*Scope*/ 63, /*->23492*/
/* 23429*/              OPC_MoveChild0,
/* 23430*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 23433*/              OPC_RecordChild0, // #1 = $off
/* 23434*/              OPC_MoveChild0,
/* 23435*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 23438*/              OPC_MoveParent,
/* 23439*/              OPC_MoveParent,
/* 23440*/              OPC_RecordChild1, // #2 = $addr
/* 23441*/              OPC_CheckType, MVT::i32,
/* 23443*/              OPC_MoveParent,
/* 23444*/              OPC_MoveChild2,
/* 23445*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23448*/              OPC_RecordChild0, // #3 = $val
/* 23449*/              OPC_MoveParent,
/* 23450*/              OPC_Scope, 19, /*->23471*/ // 2 children in Scope
/* 23452*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23454*/                OPC_MoveParent,
/* 23455*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23457*/                OPC_EmitMergeInputChains1_0,
/* 23458*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23461*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23471*/              /*Scope*/ 19, /*->23491*/
/* 23472*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23474*/                OPC_MoveParent,
/* 23475*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23477*/                OPC_EmitMergeInputChains1_0,
/* 23478*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23481*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23491*/              0, /*End of Scope*/
/* 23492*/            /*Scope*/ 64, /*->23557*/
/* 23493*/              OPC_RecordChild0, // #1 = $addr
/* 23494*/              OPC_RecordChild1, // #2 = $off
/* 23495*/              OPC_MoveChild1,
/* 23496*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23499*/              OPC_MoveParent,
/* 23500*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 23502*/              OPC_CheckType, MVT::i32,
/* 23504*/              OPC_MoveParent,
/* 23505*/              OPC_MoveChild2,
/* 23506*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23509*/              OPC_RecordChild0, // #3 = $val
/* 23510*/              OPC_MoveParent,
/* 23511*/              OPC_Scope, 21, /*->23534*/ // 2 children in Scope
/* 23513*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23515*/                OPC_MoveParent,
/* 23516*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23518*/                OPC_EmitMergeInputChains1_0,
/* 23519*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23522*/                OPC_EmitConvertToTarget, 2,
/* 23524*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23534*/              /*Scope*/ 21, /*->23556*/
/* 23535*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23537*/                OPC_MoveParent,
/* 23538*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23540*/                OPC_EmitMergeInputChains1_0,
/* 23541*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23544*/                OPC_EmitConvertToTarget, 2,
/* 23546*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23556*/              0, /*End of Scope*/
/* 23557*/            0, /*End of Scope*/
/* 23558*/          /*SwitchOpcode*/ 64, TARGET_VAL(ISD::OR),// ->23625
/* 23561*/            OPC_RecordChild0, // #1 = $addr
/* 23562*/            OPC_RecordChild1, // #2 = $off
/* 23563*/            OPC_MoveChild1,
/* 23564*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23567*/            OPC_MoveParent,
/* 23568*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 23570*/            OPC_CheckType, MVT::i32,
/* 23572*/            OPC_MoveParent,
/* 23573*/            OPC_MoveChild2,
/* 23574*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23577*/            OPC_RecordChild0, // #3 = $val
/* 23578*/            OPC_MoveParent,
/* 23579*/            OPC_Scope, 21, /*->23602*/ // 2 children in Scope
/* 23581*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23583*/              OPC_MoveParent,
/* 23584*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23586*/              OPC_EmitMergeInputChains1_0,
/* 23587*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23590*/              OPC_EmitConvertToTarget, 2,
/* 23592*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23602*/            /*Scope*/ 21, /*->23624*/
/* 23603*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23605*/              OPC_MoveParent,
/* 23606*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23608*/              OPC_EmitMergeInputChains1_0,
/* 23609*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23612*/              OPC_EmitConvertToTarget, 2,
/* 23614*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23624*/            0, /*End of Scope*/
/* 23625*/          /*SwitchOpcode*/ 22|128,1/*150*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->23779
/* 23629*/            OPC_RecordChild0, // #1 = $off
/* 23630*/            OPC_MoveChild0,
/* 23631*/            OPC_SwitchOpcode /*2 cases */, 70, TARGET_VAL(ISD::TargetGlobalAddress),// ->23705
/* 23635*/              OPC_MoveParent,
/* 23636*/              OPC_MoveParent,
/* 23637*/              OPC_MoveChild2,
/* 23638*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23641*/              OPC_RecordChild0, // #2 = $val
/* 23642*/              OPC_MoveParent,
/* 23643*/              OPC_Scope, 29, /*->23674*/ // 2 children in Scope
/* 23645*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23647*/                OPC_MoveParent,
/* 23648*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23650*/                OPC_EmitMergeInputChains1_0,
/* 23651*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23654*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23657*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23664*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23674*/              /*Scope*/ 29, /*->23704*/
/* 23675*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23677*/                OPC_MoveParent,
/* 23678*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23680*/                OPC_EmitMergeInputChains1_0,
/* 23681*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23684*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23687*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23694*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23704*/              0, /*End of Scope*/
/* 23705*/            /*SwitchOpcode*/ 70, TARGET_VAL(ISD::TargetExternalSymbol),// ->23778
/* 23708*/              OPC_MoveParent,
/* 23709*/              OPC_MoveParent,
/* 23710*/              OPC_MoveChild2,
/* 23711*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23714*/              OPC_RecordChild0, // #2 = $val
/* 23715*/              OPC_MoveParent,
/* 23716*/              OPC_Scope, 29, /*->23747*/ // 2 children in Scope
/* 23718*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23720*/                OPC_MoveParent,
/* 23721*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23723*/                OPC_EmitMergeInputChains1_0,
/* 23724*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23727*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23730*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23737*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23747*/              /*Scope*/ 29, /*->23777*/
/* 23748*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23750*/                OPC_MoveParent,
/* 23751*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23753*/                OPC_EmitMergeInputChains1_0,
/* 23754*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23757*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23760*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 23767*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23777*/              0, /*End of Scope*/
/* 23778*/            0, // EndSwitchOpcode
/* 23779*/          0, // EndSwitchOpcode
/* 23780*/        /*Scope*/ 10|128,1/*138*/, /*->23920*/
/* 23782*/          OPC_RecordChild1, // #1 = $off
/* 23783*/          OPC_Scope, 77, /*->23862*/ // 2 children in Scope
/* 23785*/            OPC_MoveChild1,
/* 23786*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 23789*/            OPC_MoveParent,
/* 23790*/            OPC_MoveChild2,
/* 23791*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23794*/            OPC_RecordChild0, // #2 = $val
/* 23795*/            OPC_MoveParent,
/* 23796*/            OPC_Scope, 31, /*->23829*/ // 2 children in Scope
/* 23798*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23800*/              OPC_MoveParent,
/* 23801*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23803*/              OPC_EmitMergeInputChains1_0,
/* 23804*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23807*/              OPC_EmitConvertToTarget, 1,
/* 23809*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23812*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 23819*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23829*/            /*Scope*/ 31, /*->23861*/
/* 23830*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23832*/              OPC_MoveParent,
/* 23833*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23835*/              OPC_EmitMergeInputChains1_0,
/* 23836*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23839*/              OPC_EmitConvertToTarget, 1,
/* 23841*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23844*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 23851*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 23861*/            0, /*End of Scope*/
/* 23862*/          /*Scope*/ 56, /*->23919*/
/* 23863*/            OPC_CheckChild1Type, MVT::i32,
/* 23865*/            OPC_MoveChild2,
/* 23866*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23869*/            OPC_RecordChild0, // #2 = $val
/* 23870*/            OPC_MoveParent,
/* 23871*/            OPC_Scope, 22, /*->23895*/ // 2 children in Scope
/* 23873*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 23875*/              OPC_MoveParent,
/* 23876*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23878*/              OPC_EmitMergeInputChains1_0,
/* 23879*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23882*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23885*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23895*/            /*Scope*/ 22, /*->23918*/
/* 23896*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 23898*/              OPC_MoveParent,
/* 23899*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23901*/              OPC_EmitMergeInputChains1_0,
/* 23902*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23905*/              OPC_EmitInteger, MVT::i32, 0, 
/* 23908*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_AND_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23918*/            0, /*End of Scope*/
/* 23919*/          0, /*End of Scope*/
/* 23920*/        0, /*End of Scope*/
/* 23921*/      /*SwitchOpcode*/ 61|128,5/*701*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->24626
/* 23925*/        OPC_RecordMemRef,
/* 23926*/        OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 23927*/        OPC_Scope, 43|128,4/*555*/, /*->24485*/ // 2 children in Scope
/* 23930*/          OPC_MoveChild1,
/* 23931*/          OPC_SwitchOpcode /*3 cases */, 71|128,2/*327*/, TARGET_VAL(ISD::ADD),// ->24263
/* 23936*/            OPC_Scope, 65, /*->24003*/ // 5 children in Scope
/* 23938*/              OPC_RecordChild0, // #1 = $addr
/* 23939*/              OPC_MoveChild1,
/* 23940*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 23943*/              OPC_RecordChild0, // #2 = $off
/* 23944*/              OPC_MoveChild0,
/* 23945*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 23948*/              OPC_MoveParent,
/* 23949*/              OPC_MoveParent,
/* 23950*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 23952*/              OPC_CheckType, MVT::i32,
/* 23954*/              OPC_MoveParent,
/* 23955*/              OPC_MoveChild2,
/* 23956*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23959*/              OPC_RecordChild0, // #3 = $val
/* 23960*/              OPC_MoveParent,
/* 23961*/              OPC_Scope, 19, /*->23982*/ // 2 children in Scope
/* 23963*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 23965*/                OPC_MoveParent,
/* 23966*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23968*/                OPC_EmitMergeInputChains1_0,
/* 23969*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23972*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 23982*/              /*Scope*/ 19, /*->24002*/
/* 23983*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 23985*/                OPC_MoveParent,
/* 23986*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 23988*/                OPC_EmitMergeInputChains1_0,
/* 23989*/                OPC_EmitInteger, MVT::i32, 0, 
/* 23992*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24002*/              0, /*End of Scope*/
/* 24003*/            /*Scope*/ 65, /*->24069*/
/* 24004*/              OPC_MoveChild0,
/* 24005*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 24008*/              OPC_RecordChild0, // #1 = $off
/* 24009*/              OPC_MoveChild0,
/* 24010*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 24013*/              OPC_MoveParent,
/* 24014*/              OPC_MoveParent,
/* 24015*/              OPC_RecordChild1, // #2 = $addr
/* 24016*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 24018*/              OPC_CheckType, MVT::i32,
/* 24020*/              OPC_MoveParent,
/* 24021*/              OPC_MoveChild2,
/* 24022*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24025*/              OPC_RecordChild0, // #3 = $val
/* 24026*/              OPC_MoveParent,
/* 24027*/              OPC_Scope, 19, /*->24048*/ // 2 children in Scope
/* 24029*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24031*/                OPC_MoveParent,
/* 24032*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24034*/                OPC_EmitMergeInputChains1_0,
/* 24035*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24038*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24048*/              /*Scope*/ 19, /*->24068*/
/* 24049*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24051*/                OPC_MoveParent,
/* 24052*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24054*/                OPC_EmitMergeInputChains1_0,
/* 24055*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24058*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24068*/              0, /*End of Scope*/
/* 24069*/            /*Scope*/ 63, /*->24133*/
/* 24070*/              OPC_RecordChild0, // #1 = $addr
/* 24071*/              OPC_MoveChild1,
/* 24072*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 24075*/              OPC_RecordChild0, // #2 = $off
/* 24076*/              OPC_MoveChild0,
/* 24077*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 24080*/              OPC_MoveParent,
/* 24081*/              OPC_MoveParent,
/* 24082*/              OPC_CheckType, MVT::i32,
/* 24084*/              OPC_MoveParent,
/* 24085*/              OPC_MoveChild2,
/* 24086*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24089*/              OPC_RecordChild0, // #3 = $val
/* 24090*/              OPC_MoveParent,
/* 24091*/              OPC_Scope, 19, /*->24112*/ // 2 children in Scope
/* 24093*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24095*/                OPC_MoveParent,
/* 24096*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24098*/                OPC_EmitMergeInputChains1_0,
/* 24099*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24102*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24112*/              /*Scope*/ 19, /*->24132*/
/* 24113*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24115*/                OPC_MoveParent,
/* 24116*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24118*/                OPC_EmitMergeInputChains1_0,
/* 24119*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24122*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24132*/              0, /*End of Scope*/
/* 24133*/            /*Scope*/ 63, /*->24197*/
/* 24134*/              OPC_MoveChild0,
/* 24135*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 24138*/              OPC_RecordChild0, // #1 = $off
/* 24139*/              OPC_MoveChild0,
/* 24140*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 24143*/              OPC_MoveParent,
/* 24144*/              OPC_MoveParent,
/* 24145*/              OPC_RecordChild1, // #2 = $addr
/* 24146*/              OPC_CheckType, MVT::i32,
/* 24148*/              OPC_MoveParent,
/* 24149*/              OPC_MoveChild2,
/* 24150*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24153*/              OPC_RecordChild0, // #3 = $val
/* 24154*/              OPC_MoveParent,
/* 24155*/              OPC_Scope, 19, /*->24176*/ // 2 children in Scope
/* 24157*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24159*/                OPC_MoveParent,
/* 24160*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24162*/                OPC_EmitMergeInputChains1_0,
/* 24163*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24166*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24176*/              /*Scope*/ 19, /*->24196*/
/* 24177*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24179*/                OPC_MoveParent,
/* 24180*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24182*/                OPC_EmitMergeInputChains1_0,
/* 24183*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24186*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24196*/              0, /*End of Scope*/
/* 24197*/            /*Scope*/ 64, /*->24262*/
/* 24198*/              OPC_RecordChild0, // #1 = $addr
/* 24199*/              OPC_RecordChild1, // #2 = $off
/* 24200*/              OPC_MoveChild1,
/* 24201*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24204*/              OPC_MoveParent,
/* 24205*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 24207*/              OPC_CheckType, MVT::i32,
/* 24209*/              OPC_MoveParent,
/* 24210*/              OPC_MoveChild2,
/* 24211*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24214*/              OPC_RecordChild0, // #3 = $val
/* 24215*/              OPC_MoveParent,
/* 24216*/              OPC_Scope, 21, /*->24239*/ // 2 children in Scope
/* 24218*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24220*/                OPC_MoveParent,
/* 24221*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24223*/                OPC_EmitMergeInputChains1_0,
/* 24224*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24227*/                OPC_EmitConvertToTarget, 2,
/* 24229*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24239*/              /*Scope*/ 21, /*->24261*/
/* 24240*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24242*/                OPC_MoveParent,
/* 24243*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24245*/                OPC_EmitMergeInputChains1_0,
/* 24246*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24249*/                OPC_EmitConvertToTarget, 2,
/* 24251*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24261*/              0, /*End of Scope*/
/* 24262*/            0, /*End of Scope*/
/* 24263*/          /*SwitchOpcode*/ 64, TARGET_VAL(ISD::OR),// ->24330
/* 24266*/            OPC_RecordChild0, // #1 = $addr
/* 24267*/            OPC_RecordChild1, // #2 = $off
/* 24268*/            OPC_MoveChild1,
/* 24269*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24272*/            OPC_MoveParent,
/* 24273*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 24275*/            OPC_CheckType, MVT::i32,
/* 24277*/            OPC_MoveParent,
/* 24278*/            OPC_MoveChild2,
/* 24279*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24282*/            OPC_RecordChild0, // #3 = $val
/* 24283*/            OPC_MoveParent,
/* 24284*/            OPC_Scope, 21, /*->24307*/ // 2 children in Scope
/* 24286*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24288*/              OPC_MoveParent,
/* 24289*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24291*/              OPC_EmitMergeInputChains1_0,
/* 24292*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24295*/              OPC_EmitConvertToTarget, 2,
/* 24297*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24307*/            /*Scope*/ 21, /*->24329*/
/* 24308*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24310*/              OPC_MoveParent,
/* 24311*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24313*/              OPC_EmitMergeInputChains1_0,
/* 24314*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24317*/              OPC_EmitConvertToTarget, 2,
/* 24319*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24329*/            0, /*End of Scope*/
/* 24330*/          /*SwitchOpcode*/ 22|128,1/*150*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->24484
/* 24334*/            OPC_RecordChild0, // #1 = $off
/* 24335*/            OPC_MoveChild0,
/* 24336*/            OPC_SwitchOpcode /*2 cases */, 70, TARGET_VAL(ISD::TargetGlobalAddress),// ->24410
/* 24340*/              OPC_MoveParent,
/* 24341*/              OPC_MoveParent,
/* 24342*/              OPC_MoveChild2,
/* 24343*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24346*/              OPC_RecordChild0, // #2 = $val
/* 24347*/              OPC_MoveParent,
/* 24348*/              OPC_Scope, 29, /*->24379*/ // 2 children in Scope
/* 24350*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24352*/                OPC_MoveParent,
/* 24353*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24355*/                OPC_EmitMergeInputChains1_0,
/* 24356*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24359*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24362*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 24369*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 24379*/              /*Scope*/ 29, /*->24409*/
/* 24380*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24382*/                OPC_MoveParent,
/* 24383*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24385*/                OPC_EmitMergeInputChains1_0,
/* 24386*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24389*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24392*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 24399*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 24409*/              0, /*End of Scope*/
/* 24410*/            /*SwitchOpcode*/ 70, TARGET_VAL(ISD::TargetExternalSymbol),// ->24483
/* 24413*/              OPC_MoveParent,
/* 24414*/              OPC_MoveParent,
/* 24415*/              OPC_MoveChild2,
/* 24416*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24419*/              OPC_RecordChild0, // #2 = $val
/* 24420*/              OPC_MoveParent,
/* 24421*/              OPC_Scope, 29, /*->24452*/ // 2 children in Scope
/* 24423*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24425*/                OPC_MoveParent,
/* 24426*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24428*/                OPC_EmitMergeInputChains1_0,
/* 24429*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24432*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24435*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 24442*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 24452*/              /*Scope*/ 29, /*->24482*/
/* 24453*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24455*/                OPC_MoveParent,
/* 24456*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24458*/                OPC_EmitMergeInputChains1_0,
/* 24459*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24462*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24465*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 24472*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 24482*/              0, /*End of Scope*/
/* 24483*/            0, // EndSwitchOpcode
/* 24484*/          0, // EndSwitchOpcode
/* 24485*/        /*Scope*/ 10|128,1/*138*/, /*->24625*/
/* 24487*/          OPC_RecordChild1, // #1 = $off
/* 24488*/          OPC_Scope, 77, /*->24567*/ // 2 children in Scope
/* 24490*/            OPC_MoveChild1,
/* 24491*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24494*/            OPC_MoveParent,
/* 24495*/            OPC_MoveChild2,
/* 24496*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24499*/            OPC_RecordChild0, // #2 = $val
/* 24500*/            OPC_MoveParent,
/* 24501*/            OPC_Scope, 31, /*->24534*/ // 2 children in Scope
/* 24503*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24505*/              OPC_MoveParent,
/* 24506*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24508*/              OPC_EmitMergeInputChains1_0,
/* 24509*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24512*/              OPC_EmitConvertToTarget, 1,
/* 24514*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24517*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 24524*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 24534*/            /*Scope*/ 31, /*->24566*/
/* 24535*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24537*/              OPC_MoveParent,
/* 24538*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24540*/              OPC_EmitMergeInputChains1_0,
/* 24541*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24544*/              OPC_EmitConvertToTarget, 1,
/* 24546*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24549*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 24556*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 24566*/            0, /*End of Scope*/
/* 24567*/          /*Scope*/ 56, /*->24624*/
/* 24568*/            OPC_CheckChild1Type, MVT::i32,
/* 24570*/            OPC_MoveChild2,
/* 24571*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24574*/            OPC_RecordChild0, // #2 = $val
/* 24575*/            OPC_MoveParent,
/* 24576*/            OPC_Scope, 22, /*->24600*/ // 2 children in Scope
/* 24578*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 24580*/              OPC_MoveParent,
/* 24581*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24583*/              OPC_EmitMergeInputChains1_0,
/* 24584*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24587*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24590*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24600*/            /*Scope*/ 22, /*->24623*/
/* 24601*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 24603*/              OPC_MoveParent,
/* 24604*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24606*/              OPC_EmitMergeInputChains1_0,
/* 24607*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24610*/              OPC_EmitInteger, MVT::i32, 0, 
/* 24613*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_OR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24623*/            0, /*End of Scope*/
/* 24624*/          0, /*End of Scope*/
/* 24625*/        0, /*End of Scope*/
/* 24626*/      /*SwitchOpcode*/ 61|128,5/*701*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->25331
/* 24630*/        OPC_RecordMemRef,
/* 24631*/        OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 24632*/        OPC_Scope, 43|128,4/*555*/, /*->25190*/ // 2 children in Scope
/* 24635*/          OPC_MoveChild1,
/* 24636*/          OPC_SwitchOpcode /*3 cases */, 71|128,2/*327*/, TARGET_VAL(ISD::ADD),// ->24968
/* 24641*/            OPC_Scope, 65, /*->24708*/ // 5 children in Scope
/* 24643*/              OPC_RecordChild0, // #1 = $addr
/* 24644*/              OPC_MoveChild1,
/* 24645*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 24648*/              OPC_RecordChild0, // #2 = $off
/* 24649*/              OPC_MoveChild0,
/* 24650*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 24653*/              OPC_MoveParent,
/* 24654*/              OPC_MoveParent,
/* 24655*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 24657*/              OPC_CheckType, MVT::i32,
/* 24659*/              OPC_MoveParent,
/* 24660*/              OPC_MoveChild2,
/* 24661*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24664*/              OPC_RecordChild0, // #3 = $val
/* 24665*/              OPC_MoveParent,
/* 24666*/              OPC_Scope, 19, /*->24687*/ // 2 children in Scope
/* 24668*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 24670*/                OPC_MoveParent,
/* 24671*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24673*/                OPC_EmitMergeInputChains1_0,
/* 24674*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24677*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24687*/              /*Scope*/ 19, /*->24707*/
/* 24688*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 24690*/                OPC_MoveParent,
/* 24691*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24693*/                OPC_EmitMergeInputChains1_0,
/* 24694*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24697*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24707*/              0, /*End of Scope*/
/* 24708*/            /*Scope*/ 65, /*->24774*/
/* 24709*/              OPC_MoveChild0,
/* 24710*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 24713*/              OPC_RecordChild0, // #1 = $off
/* 24714*/              OPC_MoveChild0,
/* 24715*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 24718*/              OPC_MoveParent,
/* 24719*/              OPC_MoveParent,
/* 24720*/              OPC_RecordChild1, // #2 = $addr
/* 24721*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 24723*/              OPC_CheckType, MVT::i32,
/* 24725*/              OPC_MoveParent,
/* 24726*/              OPC_MoveChild2,
/* 24727*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24730*/              OPC_RecordChild0, // #3 = $val
/* 24731*/              OPC_MoveParent,
/* 24732*/              OPC_Scope, 19, /*->24753*/ // 2 children in Scope
/* 24734*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 24736*/                OPC_MoveParent,
/* 24737*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24739*/                OPC_EmitMergeInputChains1_0,
/* 24740*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24743*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24753*/              /*Scope*/ 19, /*->24773*/
/* 24754*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 24756*/                OPC_MoveParent,
/* 24757*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24759*/                OPC_EmitMergeInputChains1_0,
/* 24760*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24763*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24773*/              0, /*End of Scope*/
/* 24774*/            /*Scope*/ 63, /*->24838*/
/* 24775*/              OPC_RecordChild0, // #1 = $addr
/* 24776*/              OPC_MoveChild1,
/* 24777*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 24780*/              OPC_RecordChild0, // #2 = $off
/* 24781*/              OPC_MoveChild0,
/* 24782*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 24785*/              OPC_MoveParent,
/* 24786*/              OPC_MoveParent,
/* 24787*/              OPC_CheckType, MVT::i32,
/* 24789*/              OPC_MoveParent,
/* 24790*/              OPC_MoveChild2,
/* 24791*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24794*/              OPC_RecordChild0, // #3 = $val
/* 24795*/              OPC_MoveParent,
/* 24796*/              OPC_Scope, 19, /*->24817*/ // 2 children in Scope
/* 24798*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 24800*/                OPC_MoveParent,
/* 24801*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24803*/                OPC_EmitMergeInputChains1_0,
/* 24804*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24807*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24817*/              /*Scope*/ 19, /*->24837*/
/* 24818*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 24820*/                OPC_MoveParent,
/* 24821*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24823*/                OPC_EmitMergeInputChains1_0,
/* 24824*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24827*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24837*/              0, /*End of Scope*/
/* 24838*/            /*Scope*/ 63, /*->24902*/
/* 24839*/              OPC_MoveChild0,
/* 24840*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 24843*/              OPC_RecordChild0, // #1 = $off
/* 24844*/              OPC_MoveChild0,
/* 24845*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 24848*/              OPC_MoveParent,
/* 24849*/              OPC_MoveParent,
/* 24850*/              OPC_RecordChild1, // #2 = $addr
/* 24851*/              OPC_CheckType, MVT::i32,
/* 24853*/              OPC_MoveParent,
/* 24854*/              OPC_MoveChild2,
/* 24855*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24858*/              OPC_RecordChild0, // #3 = $val
/* 24859*/              OPC_MoveParent,
/* 24860*/              OPC_Scope, 19, /*->24881*/ // 2 children in Scope
/* 24862*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 24864*/                OPC_MoveParent,
/* 24865*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24867*/                OPC_EmitMergeInputChains1_0,
/* 24868*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24871*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24881*/              /*Scope*/ 19, /*->24901*/
/* 24882*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 24884*/                OPC_MoveParent,
/* 24885*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24887*/                OPC_EmitMergeInputChains1_0,
/* 24888*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24891*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24901*/              0, /*End of Scope*/
/* 24902*/            /*Scope*/ 64, /*->24967*/
/* 24903*/              OPC_RecordChild0, // #1 = $addr
/* 24904*/              OPC_RecordChild1, // #2 = $off
/* 24905*/              OPC_MoveChild1,
/* 24906*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24909*/              OPC_MoveParent,
/* 24910*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 24912*/              OPC_CheckType, MVT::i32,
/* 24914*/              OPC_MoveParent,
/* 24915*/              OPC_MoveChild2,
/* 24916*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24919*/              OPC_RecordChild0, // #3 = $val
/* 24920*/              OPC_MoveParent,
/* 24921*/              OPC_Scope, 21, /*->24944*/ // 2 children in Scope
/* 24923*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 24925*/                OPC_MoveParent,
/* 24926*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24928*/                OPC_EmitMergeInputChains1_0,
/* 24929*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24932*/                OPC_EmitConvertToTarget, 2,
/* 24934*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24944*/              /*Scope*/ 21, /*->24966*/
/* 24945*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 24947*/                OPC_MoveParent,
/* 24948*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24950*/                OPC_EmitMergeInputChains1_0,
/* 24951*/                OPC_EmitInteger, MVT::i32, 0, 
/* 24954*/                OPC_EmitConvertToTarget, 2,
/* 24956*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 24966*/              0, /*End of Scope*/
/* 24967*/            0, /*End of Scope*/
/* 24968*/          /*SwitchOpcode*/ 64, TARGET_VAL(ISD::OR),// ->25035
/* 24971*/            OPC_RecordChild0, // #1 = $addr
/* 24972*/            OPC_RecordChild1, // #2 = $off
/* 24973*/            OPC_MoveChild1,
/* 24974*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 24977*/            OPC_MoveParent,
/* 24978*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 24980*/            OPC_CheckType, MVT::i32,
/* 24982*/            OPC_MoveParent,
/* 24983*/            OPC_MoveChild2,
/* 24984*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 24987*/            OPC_RecordChild0, // #3 = $val
/* 24988*/            OPC_MoveParent,
/* 24989*/            OPC_Scope, 21, /*->25012*/ // 2 children in Scope
/* 24991*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 24993*/              OPC_MoveParent,
/* 24994*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 24996*/              OPC_EmitMergeInputChains1_0,
/* 24997*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25000*/              OPC_EmitConvertToTarget, 2,
/* 25002*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25012*/            /*Scope*/ 21, /*->25034*/
/* 25013*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 25015*/              OPC_MoveParent,
/* 25016*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25018*/              OPC_EmitMergeInputChains1_0,
/* 25019*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25022*/              OPC_EmitConvertToTarget, 2,
/* 25024*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25034*/            0, /*End of Scope*/
/* 25035*/          /*SwitchOpcode*/ 22|128,1/*150*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->25189
/* 25039*/            OPC_RecordChild0, // #1 = $off
/* 25040*/            OPC_MoveChild0,
/* 25041*/            OPC_SwitchOpcode /*2 cases */, 70, TARGET_VAL(ISD::TargetGlobalAddress),// ->25115
/* 25045*/              OPC_MoveParent,
/* 25046*/              OPC_MoveParent,
/* 25047*/              OPC_MoveChild2,
/* 25048*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25051*/              OPC_RecordChild0, // #2 = $val
/* 25052*/              OPC_MoveParent,
/* 25053*/              OPC_Scope, 29, /*->25084*/ // 2 children in Scope
/* 25055*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 25057*/                OPC_MoveParent,
/* 25058*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25060*/                OPC_EmitMergeInputChains1_0,
/* 25061*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25064*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25067*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25074*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25084*/              /*Scope*/ 29, /*->25114*/
/* 25085*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 25087*/                OPC_MoveParent,
/* 25088*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25090*/                OPC_EmitMergeInputChains1_0,
/* 25091*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25094*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25097*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25104*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25114*/              0, /*End of Scope*/
/* 25115*/            /*SwitchOpcode*/ 70, TARGET_VAL(ISD::TargetExternalSymbol),// ->25188
/* 25118*/              OPC_MoveParent,
/* 25119*/              OPC_MoveParent,
/* 25120*/              OPC_MoveChild2,
/* 25121*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25124*/              OPC_RecordChild0, // #2 = $val
/* 25125*/              OPC_MoveParent,
/* 25126*/              OPC_Scope, 29, /*->25157*/ // 2 children in Scope
/* 25128*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 25130*/                OPC_MoveParent,
/* 25131*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25133*/                OPC_EmitMergeInputChains1_0,
/* 25134*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25137*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25140*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25147*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25157*/              /*Scope*/ 29, /*->25187*/
/* 25158*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 25160*/                OPC_MoveParent,
/* 25161*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25163*/                OPC_EmitMergeInputChains1_0,
/* 25164*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25167*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25170*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25177*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25187*/              0, /*End of Scope*/
/* 25188*/            0, // EndSwitchOpcode
/* 25189*/          0, // EndSwitchOpcode
/* 25190*/        /*Scope*/ 10|128,1/*138*/, /*->25330*/
/* 25192*/          OPC_RecordChild1, // #1 = $off
/* 25193*/          OPC_Scope, 77, /*->25272*/ // 2 children in Scope
/* 25195*/            OPC_MoveChild1,
/* 25196*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 25199*/            OPC_MoveParent,
/* 25200*/            OPC_MoveChild2,
/* 25201*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25204*/            OPC_RecordChild0, // #2 = $val
/* 25205*/            OPC_MoveParent,
/* 25206*/            OPC_Scope, 31, /*->25239*/ // 2 children in Scope
/* 25208*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 25210*/              OPC_MoveParent,
/* 25211*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25213*/              OPC_EmitMergeInputChains1_0,
/* 25214*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25217*/              OPC_EmitConvertToTarget, 1,
/* 25219*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25222*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 25229*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25239*/            /*Scope*/ 31, /*->25271*/
/* 25240*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 25242*/              OPC_MoveParent,
/* 25243*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25245*/              OPC_EmitMergeInputChains1_0,
/* 25246*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25249*/              OPC_EmitConvertToTarget, 1,
/* 25251*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25254*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 25261*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25271*/            0, /*End of Scope*/
/* 25272*/          /*Scope*/ 56, /*->25329*/
/* 25273*/            OPC_CheckChild1Type, MVT::i32,
/* 25275*/            OPC_MoveChild2,
/* 25276*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25279*/            OPC_RecordChild0, // #2 = $val
/* 25280*/            OPC_MoveParent,
/* 25281*/            OPC_Scope, 22, /*->25305*/ // 2 children in Scope
/* 25283*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 25285*/              OPC_MoveParent,
/* 25286*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25288*/              OPC_EmitMergeInputChains1_0,
/* 25289*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25292*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25295*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25305*/            /*Scope*/ 22, /*->25328*/
/* 25306*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 25308*/              OPC_MoveParent,
/* 25309*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25311*/              OPC_EmitMergeInputChains1_0,
/* 25312*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25315*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25318*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25328*/            0, /*End of Scope*/
/* 25329*/          0, /*End of Scope*/
/* 25330*/        0, /*End of Scope*/
/* 25331*/      /*SwitchOpcode*/ 61|128,5/*701*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->26036
/* 25335*/        OPC_RecordMemRef,
/* 25336*/        OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 25337*/        OPC_Scope, 43|128,4/*555*/, /*->25895*/ // 2 children in Scope
/* 25340*/          OPC_MoveChild1,
/* 25341*/          OPC_SwitchOpcode /*3 cases */, 71|128,2/*327*/, TARGET_VAL(ISD::ADD),// ->25673
/* 25346*/            OPC_Scope, 65, /*->25413*/ // 5 children in Scope
/* 25348*/              OPC_RecordChild0, // #1 = $addr
/* 25349*/              OPC_MoveChild1,
/* 25350*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 25353*/              OPC_RecordChild0, // #2 = $off
/* 25354*/              OPC_MoveChild0,
/* 25355*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 25358*/              OPC_MoveParent,
/* 25359*/              OPC_MoveParent,
/* 25360*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 25362*/              OPC_CheckType, MVT::i32,
/* 25364*/              OPC_MoveParent,
/* 25365*/              OPC_MoveChild2,
/* 25366*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25369*/              OPC_RecordChild0, // #3 = $val
/* 25370*/              OPC_MoveParent,
/* 25371*/              OPC_Scope, 19, /*->25392*/ // 2 children in Scope
/* 25373*/                OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25375*/                OPC_MoveParent,
/* 25376*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25378*/                OPC_EmitMergeInputChains1_0,
/* 25379*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25382*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25392*/              /*Scope*/ 19, /*->25412*/
/* 25393*/                OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25395*/                OPC_MoveParent,
/* 25396*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25398*/                OPC_EmitMergeInputChains1_0,
/* 25399*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25402*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25412*/              0, /*End of Scope*/
/* 25413*/            /*Scope*/ 65, /*->25479*/
/* 25414*/              OPC_MoveChild0,
/* 25415*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 25418*/              OPC_RecordChild0, // #1 = $off
/* 25419*/              OPC_MoveChild0,
/* 25420*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 25423*/              OPC_MoveParent,
/* 25424*/              OPC_MoveParent,
/* 25425*/              OPC_RecordChild1, // #2 = $addr
/* 25426*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 25428*/              OPC_CheckType, MVT::i32,
/* 25430*/              OPC_MoveParent,
/* 25431*/              OPC_MoveChild2,
/* 25432*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25435*/              OPC_RecordChild0, // #3 = $val
/* 25436*/              OPC_MoveParent,
/* 25437*/              OPC_Scope, 19, /*->25458*/ // 2 children in Scope
/* 25439*/                OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25441*/                OPC_MoveParent,
/* 25442*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25444*/                OPC_EmitMergeInputChains1_0,
/* 25445*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25448*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25458*/              /*Scope*/ 19, /*->25478*/
/* 25459*/                OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25461*/                OPC_MoveParent,
/* 25462*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25464*/                OPC_EmitMergeInputChains1_0,
/* 25465*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25468*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 20
                          // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25478*/              0, /*End of Scope*/
/* 25479*/            /*Scope*/ 63, /*->25543*/
/* 25480*/              OPC_RecordChild0, // #1 = $addr
/* 25481*/              OPC_MoveChild1,
/* 25482*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 25485*/              OPC_RecordChild0, // #2 = $off
/* 25486*/              OPC_MoveChild0,
/* 25487*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 25490*/              OPC_MoveParent,
/* 25491*/              OPC_MoveParent,
/* 25492*/              OPC_CheckType, MVT::i32,
/* 25494*/              OPC_MoveParent,
/* 25495*/              OPC_MoveChild2,
/* 25496*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25499*/              OPC_RecordChild0, // #3 = $val
/* 25500*/              OPC_MoveParent,
/* 25501*/              OPC_Scope, 19, /*->25522*/ // 2 children in Scope
/* 25503*/                OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25505*/                OPC_MoveParent,
/* 25506*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25508*/                OPC_EmitMergeInputChains1_0,
/* 25509*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25512*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25522*/              /*Scope*/ 19, /*->25542*/
/* 25523*/                OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25525*/                OPC_MoveParent,
/* 25526*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25528*/                OPC_EmitMergeInputChains1_0,
/* 25529*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25532*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25542*/              0, /*End of Scope*/
/* 25543*/            /*Scope*/ 63, /*->25607*/
/* 25544*/              OPC_MoveChild0,
/* 25545*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 25548*/              OPC_RecordChild0, // #1 = $off
/* 25549*/              OPC_MoveChild0,
/* 25550*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 25553*/              OPC_MoveParent,
/* 25554*/              OPC_MoveParent,
/* 25555*/              OPC_RecordChild1, // #2 = $addr
/* 25556*/              OPC_CheckType, MVT::i32,
/* 25558*/              OPC_MoveParent,
/* 25559*/              OPC_MoveChild2,
/* 25560*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25563*/              OPC_RecordChild0, // #3 = $val
/* 25564*/              OPC_MoveParent,
/* 25565*/              OPC_Scope, 19, /*->25586*/ // 2 children in Scope
/* 25567*/                OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25569*/                OPC_MoveParent,
/* 25570*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25572*/                OPC_EmitMergeInputChains1_0,
/* 25573*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25576*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25586*/              /*Scope*/ 19, /*->25606*/
/* 25587*/                OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25589*/                OPC_MoveParent,
/* 25590*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25592*/                OPC_EmitMergeInputChains1_0,
/* 25593*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25596*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                          // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25606*/              0, /*End of Scope*/
/* 25607*/            /*Scope*/ 64, /*->25672*/
/* 25608*/              OPC_RecordChild0, // #1 = $addr
/* 25609*/              OPC_RecordChild1, // #2 = $off
/* 25610*/              OPC_MoveChild1,
/* 25611*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 25614*/              OPC_MoveParent,
/* 25615*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 25617*/              OPC_CheckType, MVT::i32,
/* 25619*/              OPC_MoveParent,
/* 25620*/              OPC_MoveChild2,
/* 25621*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25624*/              OPC_RecordChild0, // #3 = $val
/* 25625*/              OPC_MoveParent,
/* 25626*/              OPC_Scope, 21, /*->25649*/ // 2 children in Scope
/* 25628*/                OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25630*/                OPC_MoveParent,
/* 25631*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25633*/                OPC_EmitMergeInputChains1_0,
/* 25634*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25637*/                OPC_EmitConvertToTarget, 2,
/* 25639*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25649*/              /*Scope*/ 21, /*->25671*/
/* 25650*/                OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25652*/                OPC_MoveParent,
/* 25653*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25655*/                OPC_EmitMergeInputChains1_0,
/* 25656*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25659*/                OPC_EmitConvertToTarget, 2,
/* 25661*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                          // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25671*/              0, /*End of Scope*/
/* 25672*/            0, /*End of Scope*/
/* 25673*/          /*SwitchOpcode*/ 64, TARGET_VAL(ISD::OR),// ->25740
/* 25676*/            OPC_RecordChild0, // #1 = $addr
/* 25677*/            OPC_RecordChild1, // #2 = $off
/* 25678*/            OPC_MoveChild1,
/* 25679*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 25682*/            OPC_MoveParent,
/* 25683*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 25685*/            OPC_CheckType, MVT::i32,
/* 25687*/            OPC_MoveParent,
/* 25688*/            OPC_MoveChild2,
/* 25689*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25692*/            OPC_RecordChild0, // #3 = $val
/* 25693*/            OPC_MoveParent,
/* 25694*/            OPC_Scope, 21, /*->25717*/ // 2 children in Scope
/* 25696*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25698*/              OPC_MoveParent,
/* 25699*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25701*/              OPC_EmitMergeInputChains1_0,
/* 25702*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25705*/              OPC_EmitConvertToTarget, 2,
/* 25707*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25717*/            /*Scope*/ 21, /*->25739*/
/* 25718*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25720*/              OPC_MoveParent,
/* 25721*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25723*/              OPC_EmitMergeInputChains1_0,
/* 25724*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25727*/              OPC_EmitConvertToTarget, 2,
/* 25729*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 17
                        // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 25739*/            0, /*End of Scope*/
/* 25740*/          /*SwitchOpcode*/ 22|128,1/*150*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->25894
/* 25744*/            OPC_RecordChild0, // #1 = $off
/* 25745*/            OPC_MoveChild0,
/* 25746*/            OPC_SwitchOpcode /*2 cases */, 70, TARGET_VAL(ISD::TargetGlobalAddress),// ->25820
/* 25750*/              OPC_MoveParent,
/* 25751*/              OPC_MoveParent,
/* 25752*/              OPC_MoveChild2,
/* 25753*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25756*/              OPC_RecordChild0, // #2 = $val
/* 25757*/              OPC_MoveParent,
/* 25758*/              OPC_Scope, 29, /*->25789*/ // 2 children in Scope
/* 25760*/                OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25762*/                OPC_MoveParent,
/* 25763*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25765*/                OPC_EmitMergeInputChains1_0,
/* 25766*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25769*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25772*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25779*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25789*/              /*Scope*/ 29, /*->25819*/
/* 25790*/                OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25792*/                OPC_MoveParent,
/* 25793*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25795*/                OPC_EmitMergeInputChains1_0,
/* 25796*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25799*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25802*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25809*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25819*/              0, /*End of Scope*/
/* 25820*/            /*SwitchOpcode*/ 70, TARGET_VAL(ISD::TargetExternalSymbol),// ->25893
/* 25823*/              OPC_MoveParent,
/* 25824*/              OPC_MoveParent,
/* 25825*/              OPC_MoveChild2,
/* 25826*/              OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25829*/              OPC_RecordChild0, // #2 = $val
/* 25830*/              OPC_MoveParent,
/* 25831*/              OPC_Scope, 29, /*->25862*/ // 2 children in Scope
/* 25833*/                OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25835*/                OPC_MoveParent,
/* 25836*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25838*/                OPC_EmitMergeInputChains1_0,
/* 25839*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25842*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25845*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25852*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25862*/              /*Scope*/ 29, /*->25892*/
/* 25863*/                OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25865*/                OPC_MoveParent,
/* 25866*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25868*/                OPC_EmitMergeInputChains1_0,
/* 25869*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25872*/                OPC_EmitInteger, MVT::i32, 0, 
/* 25875*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 25882*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 16
                          // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25892*/              0, /*End of Scope*/
/* 25893*/            0, // EndSwitchOpcode
/* 25894*/          0, // EndSwitchOpcode
/* 25895*/        /*Scope*/ 10|128,1/*138*/, /*->26035*/
/* 25897*/          OPC_RecordChild1, // #1 = $off
/* 25898*/          OPC_Scope, 77, /*->25977*/ // 2 children in Scope
/* 25900*/            OPC_MoveChild1,
/* 25901*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 25904*/            OPC_MoveParent,
/* 25905*/            OPC_MoveChild2,
/* 25906*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25909*/            OPC_RecordChild0, // #2 = $val
/* 25910*/            OPC_MoveParent,
/* 25911*/            OPC_Scope, 31, /*->25944*/ // 2 children in Scope
/* 25913*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25915*/              OPC_MoveParent,
/* 25916*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25918*/              OPC_EmitMergeInputChains1_0,
/* 25919*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25922*/              OPC_EmitConvertToTarget, 1,
/* 25924*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25927*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 25934*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25944*/            /*Scope*/ 31, /*->25976*/
/* 25945*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 25947*/              OPC_MoveParent,
/* 25948*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25950*/              OPC_EmitMergeInputChains1_0,
/* 25951*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25954*/              OPC_EmitConvertToTarget, 1,
/* 25956*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25959*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 25966*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 25976*/            0, /*End of Scope*/
/* 25977*/          /*Scope*/ 56, /*->26034*/
/* 25978*/            OPC_CheckChild1Type, MVT::i32,
/* 25980*/            OPC_MoveChild2,
/* 25981*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 25984*/            OPC_RecordChild0, // #2 = $val
/* 25985*/            OPC_MoveParent,
/* 25986*/            OPC_Scope, 22, /*->26010*/ // 2 children in Scope
/* 25988*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 25990*/              OPC_MoveParent,
/* 25991*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 25993*/              OPC_EmitMergeInputChains1_0,
/* 25994*/              OPC_EmitInteger, MVT::i32, 0, 
/* 25997*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26000*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 26010*/            /*Scope*/ 22, /*->26033*/
/* 26011*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 26013*/              OPC_MoveParent,
/* 26014*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26016*/              OPC_EmitMergeInputChains1_0,
/* 26017*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26020*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26023*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                        // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 26033*/            0, /*End of Scope*/
/* 26034*/          0, /*End of Scope*/
/* 26035*/        0, /*End of Scope*/
/* 26036*/      /*SwitchOpcode*/ 108|128,4/*620*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->26660
/* 26040*/        OPC_RecordMemRef,
/* 26041*/        OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 26042*/        OPC_Scope, 107|128,3/*491*/, /*->26536*/ // 2 children in Scope
/* 26045*/          OPC_MoveChild1,
/* 26046*/          OPC_SwitchOpcode /*3 cases */, 31|128,2/*287*/, TARGET_VAL(ISD::ADD),// ->26338
/* 26051*/            OPC_Scope, 57, /*->26110*/ // 5 children in Scope
/* 26053*/              OPC_RecordChild0, // #1 = $addr
/* 26054*/              OPC_MoveChild1,
/* 26055*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26058*/              OPC_RecordChild0, // #2 = $off
/* 26059*/              OPC_MoveChild0,
/* 26060*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 26063*/              OPC_MoveParent,
/* 26064*/              OPC_MoveParent,
/* 26065*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 26067*/              OPC_CheckType, MVT::i32,
/* 26069*/              OPC_MoveParent,
/* 26070*/              OPC_Scope, 18, /*->26090*/ // 2 children in Scope
/* 26072*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26074*/                OPC_MoveParent,
/* 26075*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26077*/                OPC_EmitMergeInputChains1_0,
/* 26078*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26081*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>>) - Complexity = 17
                          // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26090*/              /*Scope*/ 18, /*->26109*/
/* 26091*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26093*/                OPC_MoveParent,
/* 26094*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26096*/                OPC_EmitMergeInputChains1_0,
/* 26097*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26100*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>>) - Complexity = 17
                          // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26109*/              0, /*End of Scope*/
/* 26110*/            /*Scope*/ 57, /*->26168*/
/* 26111*/              OPC_MoveChild0,
/* 26112*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26115*/              OPC_RecordChild0, // #1 = $off
/* 26116*/              OPC_MoveChild0,
/* 26117*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 26120*/              OPC_MoveParent,
/* 26121*/              OPC_MoveParent,
/* 26122*/              OPC_RecordChild1, // #2 = $addr
/* 26123*/              OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 26125*/              OPC_CheckType, MVT::i32,
/* 26127*/              OPC_MoveParent,
/* 26128*/              OPC_Scope, 18, /*->26148*/ // 2 children in Scope
/* 26130*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26132*/                OPC_MoveParent,
/* 26133*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26135*/                OPC_EmitMergeInputChains1_0,
/* 26136*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26139*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>>) - Complexity = 17
                          // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26148*/              /*Scope*/ 18, /*->26167*/
/* 26149*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26151*/                OPC_MoveParent,
/* 26152*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26154*/                OPC_EmitMergeInputChains1_0,
/* 26155*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26158*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>>) - Complexity = 17
                          // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26167*/              0, /*End of Scope*/
/* 26168*/            /*Scope*/ 55, /*->26224*/
/* 26169*/              OPC_RecordChild0, // #1 = $addr
/* 26170*/              OPC_MoveChild1,
/* 26171*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26174*/              OPC_RecordChild0, // #2 = $off
/* 26175*/              OPC_MoveChild0,
/* 26176*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 26179*/              OPC_MoveParent,
/* 26180*/              OPC_MoveParent,
/* 26181*/              OPC_CheckType, MVT::i32,
/* 26183*/              OPC_MoveParent,
/* 26184*/              OPC_Scope, 18, /*->26204*/ // 2 children in Scope
/* 26186*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26188*/                OPC_MoveParent,
/* 26189*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26191*/                OPC_EmitMergeInputChains1_0,
/* 26192*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26195*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                          // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26204*/              /*Scope*/ 18, /*->26223*/
/* 26205*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26207*/                OPC_MoveParent,
/* 26208*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26210*/                OPC_EmitMergeInputChains1_0,
/* 26211*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26214*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                          // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26223*/              0, /*End of Scope*/
/* 26224*/            /*Scope*/ 55, /*->26280*/
/* 26225*/              OPC_MoveChild0,
/* 26226*/              OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26229*/              OPC_RecordChild0, // #1 = $off
/* 26230*/              OPC_MoveChild0,
/* 26231*/              OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 26234*/              OPC_MoveParent,
/* 26235*/              OPC_MoveParent,
/* 26236*/              OPC_RecordChild1, // #2 = $addr
/* 26237*/              OPC_CheckType, MVT::i32,
/* 26239*/              OPC_MoveParent,
/* 26240*/              OPC_Scope, 18, /*->26260*/ // 2 children in Scope
/* 26242*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26244*/                OPC_MoveParent,
/* 26245*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26247*/                OPC_EmitMergeInputChains1_0,
/* 26248*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26251*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                          // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26260*/              /*Scope*/ 18, /*->26279*/
/* 26261*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26263*/                OPC_MoveParent,
/* 26264*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26266*/                OPC_EmitMergeInputChains1_0,
/* 26267*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26270*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                          // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26279*/              0, /*End of Scope*/
/* 26280*/            /*Scope*/ 56, /*->26337*/
/* 26281*/              OPC_RecordChild0, // #1 = $addr
/* 26282*/              OPC_RecordChild1, // #2 = $off
/* 26283*/              OPC_MoveChild1,
/* 26284*/              OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 26287*/              OPC_MoveParent,
/* 26288*/              OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 26290*/              OPC_CheckType, MVT::i32,
/* 26292*/              OPC_MoveParent,
/* 26293*/              OPC_Scope, 20, /*->26315*/ // 2 children in Scope
/* 26295*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26297*/                OPC_MoveParent,
/* 26298*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26300*/                OPC_EmitMergeInputChains1_0,
/* 26301*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26304*/                OPC_EmitConvertToTarget, 2,
/* 26306*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                          // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26315*/              /*Scope*/ 20, /*->26336*/
/* 26316*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26318*/                OPC_MoveParent,
/* 26319*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26321*/                OPC_EmitMergeInputChains1_0,
/* 26322*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26325*/                OPC_EmitConvertToTarget, 2,
/* 26327*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                          // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26336*/              0, /*End of Scope*/
/* 26337*/            0, /*End of Scope*/
/* 26338*/          /*SwitchOpcode*/ 56, TARGET_VAL(ISD::OR),// ->26397
/* 26341*/            OPC_RecordChild0, // #1 = $addr
/* 26342*/            OPC_RecordChild1, // #2 = $off
/* 26343*/            OPC_MoveChild1,
/* 26344*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 26347*/            OPC_MoveParent,
/* 26348*/            OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 26350*/            OPC_CheckType, MVT::i32,
/* 26352*/            OPC_MoveParent,
/* 26353*/            OPC_Scope, 20, /*->26375*/ // 2 children in Scope
/* 26355*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26357*/              OPC_MoveParent,
/* 26358*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26360*/              OPC_EmitMergeInputChains1_0,
/* 26361*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26364*/              OPC_EmitConvertToTarget, 2,
/* 26366*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>>) - Complexity = 14
                        // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26375*/            /*Scope*/ 20, /*->26396*/
/* 26376*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26378*/              OPC_MoveParent,
/* 26379*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26381*/              OPC_EmitMergeInputChains1_0,
/* 26382*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26385*/              OPC_EmitConvertToTarget, 2,
/* 26387*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>>) - Complexity = 14
                        // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 26396*/            0, /*End of Scope*/
/* 26397*/          /*SwitchOpcode*/ 6|128,1/*134*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->26535
/* 26401*/            OPC_RecordChild0, // #1 = $off
/* 26402*/            OPC_MoveChild0,
/* 26403*/            OPC_SwitchOpcode /*2 cases */, 62, TARGET_VAL(ISD::TargetGlobalAddress),// ->26469
/* 26407*/              OPC_MoveParent,
/* 26408*/              OPC_MoveParent,
/* 26409*/              OPC_Scope, 28, /*->26439*/ // 2 children in Scope
/* 26411*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26413*/                OPC_MoveParent,
/* 26414*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26416*/                OPC_EmitMergeInputChains1_0,
/* 26417*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26420*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26423*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26430*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>) - Complexity = 13
                          // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26439*/              /*Scope*/ 28, /*->26468*/
/* 26440*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26442*/                OPC_MoveParent,
/* 26443*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26445*/                OPC_EmitMergeInputChains1_0,
/* 26446*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26449*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26452*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26459*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>) - Complexity = 13
                          // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26468*/              0, /*End of Scope*/
/* 26469*/            /*SwitchOpcode*/ 62, TARGET_VAL(ISD::TargetExternalSymbol),// ->26534
/* 26472*/              OPC_MoveParent,
/* 26473*/              OPC_MoveParent,
/* 26474*/              OPC_Scope, 28, /*->26504*/ // 2 children in Scope
/* 26476*/                OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26478*/                OPC_MoveParent,
/* 26479*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26481*/                OPC_EmitMergeInputChains1_0,
/* 26482*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26485*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26488*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26495*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>>) - Complexity = 13
                          // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26504*/              /*Scope*/ 28, /*->26533*/
/* 26505*/                OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26507*/                OPC_MoveParent,
/* 26508*/                OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26510*/                OPC_EmitMergeInputChains1_0,
/* 26511*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26514*/                OPC_EmitInteger, MVT::i32, 0, 
/* 26517*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 26524*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>>) - Complexity = 13
                          // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26533*/              0, /*End of Scope*/
/* 26534*/            0, // EndSwitchOpcode
/* 26535*/          0, // EndSwitchOpcode
/* 26536*/        /*Scope*/ 122, /*->26659*/
/* 26537*/          OPC_RecordChild1, // #1 = $off
/* 26538*/          OPC_Scope, 69, /*->26609*/ // 2 children in Scope
/* 26540*/            OPC_MoveChild1,
/* 26541*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 26544*/            OPC_MoveParent,
/* 26545*/            OPC_Scope, 30, /*->26577*/ // 2 children in Scope
/* 26547*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26549*/              OPC_MoveParent,
/* 26550*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26552*/              OPC_EmitMergeInputChains1_0,
/* 26553*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26556*/              OPC_EmitConvertToTarget, 1,
/* 26558*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26561*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 26568*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                        // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>>) - Complexity = 10
                        // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26577*/            /*Scope*/ 30, /*->26608*/
/* 26578*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26580*/              OPC_MoveParent,
/* 26581*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26583*/              OPC_EmitMergeInputChains1_0,
/* 26584*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26587*/              OPC_EmitConvertToTarget, 1,
/* 26589*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26592*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 26599*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                        // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>>) - Complexity = 10
                        // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 26608*/            0, /*End of Scope*/
/* 26609*/          /*Scope*/ 48, /*->26658*/
/* 26610*/            OPC_CheckChild1Type, MVT::i32,
/* 26612*/            OPC_Scope, 21, /*->26635*/ // 2 children in Scope
/* 26614*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 26616*/              OPC_MoveParent,
/* 26617*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26619*/              OPC_EmitMergeInputChains1_0,
/* 26620*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26623*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26626*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                        // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_8>>) - Complexity = 7
                        // Dst: (ATOMIC_LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 26635*/            /*Scope*/ 21, /*->26657*/
/* 26636*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 26638*/              OPC_MoveParent,
/* 26639*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26641*/              OPC_EmitMergeInputChains1_0,
/* 26642*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26645*/              OPC_EmitInteger, MVT::i32, 0, 
/* 26648*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                        // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_16>>) - Complexity = 7
                        // Dst: (ATOMIC_LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 26657*/            0, /*End of Scope*/
/* 26658*/          0, /*End of Scope*/
/* 26659*/        0, /*End of Scope*/
/* 26660*/      0, // EndSwitchOpcode
/* 26661*/    /*Scope*/ 8, /*->26670*/
/* 26662*/      OPC_RecordChild0, // #0 = $src
/* 26663*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                    MVT::i64, 1/*#Ops*/, 0, 
                // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
                // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 26670*/    0, /*End of Scope*/
/* 26671*/  /*SwitchOpcode*/ 54|128,9/*1206*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->27881
/* 26675*/    OPC_Scope, 1|128,7/*897*/, /*->27575*/ // 3 children in Scope
/* 26678*/      OPC_RecordMemRef,
/* 26679*/      OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/* 26680*/      OPC_Scope, 29|128,2/*285*/, /*->26968*/ // 3 children in Scope
/* 26683*/        OPC_CheckChild1Integer, 28|128,43/*5532*/, 
/* 26686*/        OPC_MoveChild2,
/* 26687*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->26862
/* 26692*/          OPC_Scope, 34, /*->26728*/ // 5 children in Scope
/* 26694*/            OPC_RecordChild0, // #1 = $addr
/* 26695*/            OPC_MoveChild1,
/* 26696*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26699*/            OPC_RecordChild0, // #2 = $off
/* 26700*/            OPC_MoveChild0,
/* 26701*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 26704*/            OPC_MoveParent,
/* 26705*/            OPC_MoveParent,
/* 26706*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 26708*/            OPC_CheckType, MVT::i32,
/* 26710*/            OPC_MoveParent,
/* 26711*/            OPC_RecordChild3, // #3 = $count
/* 26712*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26714*/            OPC_EmitMergeInputChains1_0,
/* 26715*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26718*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, I32:{ *:[i32] }:$count) - Complexity = 18
                      // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 26728*/          /*Scope*/ 34, /*->26763*/
/* 26729*/            OPC_MoveChild0,
/* 26730*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26733*/            OPC_RecordChild0, // #1 = $off
/* 26734*/            OPC_MoveChild0,
/* 26735*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 26738*/            OPC_MoveParent,
/* 26739*/            OPC_MoveParent,
/* 26740*/            OPC_RecordChild1, // #2 = $addr
/* 26741*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 26743*/            OPC_CheckType, MVT::i32,
/* 26745*/            OPC_MoveParent,
/* 26746*/            OPC_RecordChild3, // #3 = $count
/* 26747*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26749*/            OPC_EmitMergeInputChains1_0,
/* 26750*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26753*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, I32:{ *:[i32] }:$count) - Complexity = 18
                      // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 26763*/          /*Scope*/ 32, /*->26796*/
/* 26764*/            OPC_RecordChild0, // #1 = $addr
/* 26765*/            OPC_MoveChild1,
/* 26766*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26769*/            OPC_RecordChild0, // #2 = $off
/* 26770*/            OPC_MoveChild0,
/* 26771*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 26774*/            OPC_MoveParent,
/* 26775*/            OPC_MoveParent,
/* 26776*/            OPC_CheckType, MVT::i32,
/* 26778*/            OPC_MoveParent,
/* 26779*/            OPC_RecordChild3, // #3 = $count
/* 26780*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26782*/            OPC_EmitMergeInputChains1_0,
/* 26783*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26786*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), I32:{ *:[i32] }:$count) - Complexity = 17
                      // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 26796*/          /*Scope*/ 32, /*->26829*/
/* 26797*/            OPC_MoveChild0,
/* 26798*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26801*/            OPC_RecordChild0, // #1 = $off
/* 26802*/            OPC_MoveChild0,
/* 26803*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 26806*/            OPC_MoveParent,
/* 26807*/            OPC_MoveParent,
/* 26808*/            OPC_RecordChild1, // #2 = $addr
/* 26809*/            OPC_CheckType, MVT::i32,
/* 26811*/            OPC_MoveParent,
/* 26812*/            OPC_RecordChild3, // #3 = $count
/* 26813*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26815*/            OPC_EmitMergeInputChains1_0,
/* 26816*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26819*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
                      // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 26829*/          /*Scope*/ 31, /*->26861*/
/* 26830*/            OPC_RecordChild0, // #1 = $addr
/* 26831*/            OPC_RecordChild1, // #2 = $off
/* 26832*/            OPC_MoveChild1,
/* 26833*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 26836*/            OPC_MoveParent,
/* 26837*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 26839*/            OPC_CheckType, MVT::i32,
/* 26841*/            OPC_MoveParent,
/* 26842*/            OPC_RecordChild3, // #3 = $count
/* 26843*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26845*/            OPC_EmitMergeInputChains1_0,
/* 26846*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26849*/            OPC_EmitConvertToTarget, 2,
/* 26851*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, I32:{ *:[i32] }:$count) - Complexity = 15
                      // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 26861*/          0, /*End of Scope*/
/* 26862*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->26896
/* 26865*/          OPC_RecordChild0, // #1 = $addr
/* 26866*/          OPC_RecordChild1, // #2 = $off
/* 26867*/          OPC_MoveChild1,
/* 26868*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 26871*/          OPC_MoveParent,
/* 26872*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 26874*/          OPC_CheckType, MVT::i32,
/* 26876*/          OPC_MoveParent,
/* 26877*/          OPC_RecordChild3, // #3 = $count
/* 26878*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26880*/          OPC_EmitMergeInputChains1_0,
/* 26881*/          OPC_EmitInteger, MVT::i32, 0, 
/* 26884*/          OPC_EmitConvertToTarget, 2,
/* 26886*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, I32:{ *:[i32] }:$count) - Complexity = 15
                    // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 26896*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->26967
/* 26899*/          OPC_RecordChild0, // #1 = $off
/* 26900*/          OPC_MoveChild0,
/* 26901*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->26934
/* 26905*/            OPC_MoveParent,
/* 26906*/            OPC_MoveParent,
/* 26907*/            OPC_RecordChild3, // #2 = $count
/* 26908*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26910*/            OPC_EmitMergeInputChains1_0,
/* 26911*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26914*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26917*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 26924*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), I32:{ *:[i32] }:$count) - Complexity = 14
                      // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), I32:{ *:[i32] }:$count)
/* 26934*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->26966
/* 26937*/            OPC_MoveParent,
/* 26938*/            OPC_MoveParent,
/* 26939*/            OPC_RecordChild3, // #2 = $count
/* 26940*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 26942*/            OPC_EmitMergeInputChains1_0,
/* 26943*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26946*/            OPC_EmitInteger, MVT::i32, 0, 
/* 26949*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 26956*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), I32:{ *:[i32] }:$count) - Complexity = 14
                      // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), I32:{ *:[i32] }:$count)
/* 26966*/          0, // EndSwitchOpcode
/* 26967*/        0, // EndSwitchOpcode
/* 26968*/      /*Scope*/ 45|128,2/*301*/, /*->27271*/
/* 26970*/        OPC_CheckChild1Integer, 29|128,43/*5533*/, 
/* 26973*/        OPC_MoveChild2,
/* 26974*/        OPC_SwitchOpcode /*3 cases */, 52|128,1/*180*/, TARGET_VAL(ISD::ADD),// ->27159
/* 26979*/          OPC_Scope, 36, /*->27017*/ // 5 children in Scope
/* 26981*/            OPC_RecordChild0, // #1 = $addr
/* 26982*/            OPC_MoveChild1,
/* 26983*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 26986*/            OPC_RecordChild0, // #2 = $off
/* 26987*/            OPC_MoveChild0,
/* 26988*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 26991*/            OPC_MoveParent,
/* 26992*/            OPC_MoveParent,
/* 26993*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 26995*/            OPC_CheckType, MVT::i32,
/* 26997*/            OPC_MoveParent,
/* 26998*/            OPC_RecordChild3, // #3 = $exp
/* 26999*/            OPC_RecordChild4, // #4 = $timeout
/* 27000*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27002*/            OPC_EmitMergeInputChains1_0,
/* 27003*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27006*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 18
                      // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27017*/          /*Scope*/ 36, /*->27054*/
/* 27018*/            OPC_MoveChild0,
/* 27019*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27022*/            OPC_RecordChild0, // #1 = $off
/* 27023*/            OPC_MoveChild0,
/* 27024*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 27027*/            OPC_MoveParent,
/* 27028*/            OPC_MoveParent,
/* 27029*/            OPC_RecordChild1, // #2 = $addr
/* 27030*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 27032*/            OPC_CheckType, MVT::i32,
/* 27034*/            OPC_MoveParent,
/* 27035*/            OPC_RecordChild3, // #3 = $exp
/* 27036*/            OPC_RecordChild4, // #4 = $timeout
/* 27037*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27039*/            OPC_EmitMergeInputChains1_0,
/* 27040*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27043*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 18
                      // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27054*/          /*Scope*/ 34, /*->27089*/
/* 27055*/            OPC_RecordChild0, // #1 = $addr
/* 27056*/            OPC_MoveChild1,
/* 27057*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27060*/            OPC_RecordChild0, // #2 = $off
/* 27061*/            OPC_MoveChild0,
/* 27062*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 27065*/            OPC_MoveParent,
/* 27066*/            OPC_MoveParent,
/* 27067*/            OPC_CheckType, MVT::i32,
/* 27069*/            OPC_MoveParent,
/* 27070*/            OPC_RecordChild3, // #3 = $exp
/* 27071*/            OPC_RecordChild4, // #4 = $timeout
/* 27072*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27074*/            OPC_EmitMergeInputChains1_0,
/* 27075*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27078*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
                      // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27089*/          /*Scope*/ 34, /*->27124*/
/* 27090*/            OPC_MoveChild0,
/* 27091*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27094*/            OPC_RecordChild0, // #1 = $off
/* 27095*/            OPC_MoveChild0,
/* 27096*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 27099*/            OPC_MoveParent,
/* 27100*/            OPC_MoveParent,
/* 27101*/            OPC_RecordChild1, // #2 = $addr
/* 27102*/            OPC_CheckType, MVT::i32,
/* 27104*/            OPC_MoveParent,
/* 27105*/            OPC_RecordChild3, // #3 = $exp
/* 27106*/            OPC_RecordChild4, // #4 = $timeout
/* 27107*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27109*/            OPC_EmitMergeInputChains1_0,
/* 27110*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27113*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
                      // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27124*/          /*Scope*/ 33, /*->27158*/
/* 27125*/            OPC_RecordChild0, // #1 = $addr
/* 27126*/            OPC_RecordChild1, // #2 = $off
/* 27127*/            OPC_MoveChild1,
/* 27128*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27131*/            OPC_MoveParent,
/* 27132*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 27134*/            OPC_CheckType, MVT::i32,
/* 27136*/            OPC_MoveParent,
/* 27137*/            OPC_RecordChild3, // #3 = $exp
/* 27138*/            OPC_RecordChild4, // #4 = $timeout
/* 27139*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27141*/            OPC_EmitMergeInputChains1_0,
/* 27142*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27145*/            OPC_EmitConvertToTarget, 2,
/* 27147*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                      // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27158*/          0, /*End of Scope*/
/* 27159*/        /*SwitchOpcode*/ 33, TARGET_VAL(ISD::OR),// ->27195
/* 27162*/          OPC_RecordChild0, // #1 = $addr
/* 27163*/          OPC_RecordChild1, // #2 = $off
/* 27164*/          OPC_MoveChild1,
/* 27165*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27168*/          OPC_MoveParent,
/* 27169*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 27171*/          OPC_CheckType, MVT::i32,
/* 27173*/          OPC_MoveParent,
/* 27174*/          OPC_RecordChild3, // #3 = $exp
/* 27175*/          OPC_RecordChild4, // #4 = $timeout
/* 27176*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27178*/          OPC_EmitMergeInputChains1_0,
/* 27179*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27182*/          OPC_EmitConvertToTarget, 2,
/* 27184*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                    // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27195*/        /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::Wrapper),// ->27270
/* 27198*/          OPC_RecordChild0, // #1 = $off
/* 27199*/          OPC_MoveChild0,
/* 27200*/          OPC_SwitchOpcode /*2 cases */, 31, TARGET_VAL(ISD::TargetGlobalAddress),// ->27235
/* 27204*/            OPC_MoveParent,
/* 27205*/            OPC_MoveParent,
/* 27206*/            OPC_RecordChild3, // #2 = $exp
/* 27207*/            OPC_RecordChild4, // #3 = $timeout
/* 27208*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27210*/            OPC_EmitMergeInputChains1_0,
/* 27211*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27214*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27217*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 27224*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                      // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27235*/          /*SwitchOpcode*/ 31, TARGET_VAL(ISD::TargetExternalSymbol),// ->27269
/* 27238*/            OPC_MoveParent,
/* 27239*/            OPC_MoveParent,
/* 27240*/            OPC_RecordChild3, // #2 = $exp
/* 27241*/            OPC_RecordChild4, // #3 = $timeout
/* 27242*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27244*/            OPC_EmitMergeInputChains1_0,
/* 27245*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27248*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27251*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 27258*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                      // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27269*/          0, // EndSwitchOpcode
/* 27270*/        0, // EndSwitchOpcode
/* 27271*/      /*Scope*/ 45|128,2/*301*/, /*->27574*/
/* 27273*/        OPC_CheckChild1Integer, 30|128,43/*5534*/, 
/* 27276*/        OPC_MoveChild2,
/* 27277*/        OPC_SwitchOpcode /*3 cases */, 52|128,1/*180*/, TARGET_VAL(ISD::ADD),// ->27462
/* 27282*/          OPC_Scope, 36, /*->27320*/ // 5 children in Scope
/* 27284*/            OPC_RecordChild0, // #1 = $addr
/* 27285*/            OPC_MoveChild1,
/* 27286*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27289*/            OPC_RecordChild0, // #2 = $off
/* 27290*/            OPC_MoveChild0,
/* 27291*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 27294*/            OPC_MoveParent,
/* 27295*/            OPC_MoveParent,
/* 27296*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 27298*/            OPC_CheckType, MVT::i32,
/* 27300*/            OPC_MoveParent,
/* 27301*/            OPC_RecordChild3, // #3 = $exp
/* 27302*/            OPC_RecordChild4, // #4 = $timeout
/* 27303*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27305*/            OPC_EmitMergeInputChains1_0,
/* 27306*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27309*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 18
                      // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27320*/          /*Scope*/ 36, /*->27357*/
/* 27321*/            OPC_MoveChild0,
/* 27322*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27325*/            OPC_RecordChild0, // #1 = $off
/* 27326*/            OPC_MoveChild0,
/* 27327*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 27330*/            OPC_MoveParent,
/* 27331*/            OPC_MoveParent,
/* 27332*/            OPC_RecordChild1, // #2 = $addr
/* 27333*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 27335*/            OPC_CheckType, MVT::i32,
/* 27337*/            OPC_MoveParent,
/* 27338*/            OPC_RecordChild3, // #3 = $exp
/* 27339*/            OPC_RecordChild4, // #4 = $timeout
/* 27340*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27342*/            OPC_EmitMergeInputChains1_0,
/* 27343*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27346*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 18
                      // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27357*/          /*Scope*/ 34, /*->27392*/
/* 27358*/            OPC_RecordChild0, // #1 = $addr
/* 27359*/            OPC_MoveChild1,
/* 27360*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27363*/            OPC_RecordChild0, // #2 = $off
/* 27364*/            OPC_MoveChild0,
/* 27365*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 27368*/            OPC_MoveParent,
/* 27369*/            OPC_MoveParent,
/* 27370*/            OPC_CheckType, MVT::i32,
/* 27372*/            OPC_MoveParent,
/* 27373*/            OPC_RecordChild3, // #3 = $exp
/* 27374*/            OPC_RecordChild4, // #4 = $timeout
/* 27375*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27377*/            OPC_EmitMergeInputChains1_0,
/* 27378*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27381*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
                      // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27392*/          /*Scope*/ 34, /*->27427*/
/* 27393*/            OPC_MoveChild0,
/* 27394*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27397*/            OPC_RecordChild0, // #1 = $off
/* 27398*/            OPC_MoveChild0,
/* 27399*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 27402*/            OPC_MoveParent,
/* 27403*/            OPC_MoveParent,
/* 27404*/            OPC_RecordChild1, // #2 = $addr
/* 27405*/            OPC_CheckType, MVT::i32,
/* 27407*/            OPC_MoveParent,
/* 27408*/            OPC_RecordChild3, // #3 = $exp
/* 27409*/            OPC_RecordChild4, // #4 = $timeout
/* 27410*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27412*/            OPC_EmitMergeInputChains1_0,
/* 27413*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27416*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
                      // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27427*/          /*Scope*/ 33, /*->27461*/
/* 27428*/            OPC_RecordChild0, // #1 = $addr
/* 27429*/            OPC_RecordChild1, // #2 = $off
/* 27430*/            OPC_MoveChild1,
/* 27431*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27434*/            OPC_MoveParent,
/* 27435*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 27437*/            OPC_CheckType, MVT::i32,
/* 27439*/            OPC_MoveParent,
/* 27440*/            OPC_RecordChild3, // #3 = $exp
/* 27441*/            OPC_RecordChild4, // #4 = $timeout
/* 27442*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27444*/            OPC_EmitMergeInputChains1_0,
/* 27445*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27448*/            OPC_EmitConvertToTarget, 2,
/* 27450*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                      // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27461*/          0, /*End of Scope*/
/* 27462*/        /*SwitchOpcode*/ 33, TARGET_VAL(ISD::OR),// ->27498
/* 27465*/          OPC_RecordChild0, // #1 = $addr
/* 27466*/          OPC_RecordChild1, // #2 = $off
/* 27467*/          OPC_MoveChild1,
/* 27468*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27471*/          OPC_MoveParent,
/* 27472*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 27474*/          OPC_CheckType, MVT::i32,
/* 27476*/          OPC_MoveParent,
/* 27477*/          OPC_RecordChild3, // #3 = $exp
/* 27478*/          OPC_RecordChild4, // #4 = $timeout
/* 27479*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27481*/          OPC_EmitMergeInputChains1_0,
/* 27482*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27485*/          OPC_EmitConvertToTarget, 2,
/* 27487*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 15
                    // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27498*/        /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::Wrapper),// ->27573
/* 27501*/          OPC_RecordChild0, // #1 = $off
/* 27502*/          OPC_MoveChild0,
/* 27503*/          OPC_SwitchOpcode /*2 cases */, 31, TARGET_VAL(ISD::TargetGlobalAddress),// ->27538
/* 27507*/            OPC_MoveParent,
/* 27508*/            OPC_MoveParent,
/* 27509*/            OPC_RecordChild3, // #2 = $exp
/* 27510*/            OPC_RecordChild4, // #3 = $timeout
/* 27511*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27513*/            OPC_EmitMergeInputChains1_0,
/* 27514*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27517*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27520*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 27527*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                      // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27538*/          /*SwitchOpcode*/ 31, TARGET_VAL(ISD::TargetExternalSymbol),// ->27572
/* 27541*/            OPC_MoveParent,
/* 27542*/            OPC_MoveParent,
/* 27543*/            OPC_RecordChild3, // #2 = $exp
/* 27544*/            OPC_RecordChild4, // #3 = $timeout
/* 27545*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27547*/            OPC_EmitMergeInputChains1_0,
/* 27548*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27551*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27554*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 27561*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                      // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 14
                      // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27572*/          0, // EndSwitchOpcode
/* 27573*/        0, // EndSwitchOpcode
/* 27574*/      0, /*End of Scope*/
/* 27575*/    /*Scope*/ 95, /*->27671*/
/* 27576*/      OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/* 27577*/      OPC_Scope, 23, /*->27602*/ // 3 children in Scope
/* 27579*/        OPC_CheckChild1Integer, 38|128,43/*5542*/, 
/* 27582*/        OPC_RecordChild2, // #1 = $flags
/* 27583*/        OPC_MoveChild2,
/* 27584*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27587*/        OPC_MoveParent,
/* 27588*/        OPC_CheckType, MVT::i32,
/* 27590*/        OPC_CheckPatternPredicate, 3, // (!Subtarget->hasAddr64())
/* 27592*/        OPC_EmitMergeInputChains1_0,
/* 27593*/        OPC_EmitConvertToTarget, 1,
/* 27595*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_SIZE_I32), 0|OPFL_Chain,
                      MVT::i32, 1/*#Ops*/, 2, 
                  // Src: (intrinsic_w_chain:{ *:[i32] } 5542:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
                  // Dst: (MEMORY_SIZE_I32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/* 27602*/      /*Scope*/ 27, /*->27630*/
/* 27603*/        OPC_CheckChild1Integer, 37|128,43/*5541*/, 
/* 27606*/        OPC_RecordChild2, // #1 = $flags
/* 27607*/        OPC_MoveChild2,
/* 27608*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27611*/        OPC_MoveParent,
/* 27612*/        OPC_RecordChild3, // #2 = $delta
/* 27613*/        OPC_CheckChild3Type, MVT::i32,
/* 27615*/        OPC_CheckType, MVT::i32,
/* 27617*/        OPC_CheckPatternPredicate, 3, // (!Subtarget->hasAddr64())
/* 27619*/        OPC_EmitMergeInputChains1_0,
/* 27620*/        OPC_EmitConvertToTarget, 1,
/* 27622*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_GROW_I32), 0|OPFL_Chain,
                      MVT::i32, 2/*#Ops*/, 3, 2, 
                  // Src: (intrinsic_w_chain:{ *:[i32] } 5541:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
                  // Dst: (MEMORY_GROW_I32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/* 27630*/      /*Scope*/ 39, /*->27670*/
/* 27631*/        OPC_CheckChild1Integer, 32|128,43/*5536*/, 
/* 27634*/        OPC_RecordChild2, // #1 = $tag
/* 27635*/        OPC_MoveChild2,
/* 27636*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27639*/        OPC_MoveParent,
/* 27640*/        OPC_SwitchType /*2 cases */, 12, MVT::i32,// ->27655
/* 27643*/          OPC_CheckPatternPredicate, 4, // (Subtarget->hasExceptionHandling())
/* 27645*/          OPC_EmitMergeInputChains1_0,
/* 27646*/          OPC_EmitConvertToTarget, 1,
/* 27648*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CATCH_I32), 0|OPFL_Chain,
                        MVT::i32, 1/*#Ops*/, 2, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5536:{ *:[iPTR] }, (imm:{ *:[i32] }):$tag) - Complexity = 11
                    // Dst: (CATCH_I32:{ *:[i32] } (imm:{ *:[i32] }):$tag)
/* 27655*/        /*SwitchType*/ 12, MVT::i64,// ->27669
/* 27657*/          OPC_CheckPatternPredicate, 4, // (Subtarget->hasExceptionHandling())
/* 27659*/          OPC_EmitMergeInputChains1_0,
/* 27660*/          OPC_EmitConvertToTarget, 1,
/* 27662*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CATCH_I64), 0|OPFL_Chain,
                        MVT::i64, 1/*#Ops*/, 2, 
                    // Src: (intrinsic_w_chain:{ *:[i64] } 5536:{ *:[iPTR] }, (imm:{ *:[i32] }):$tag) - Complexity = 11
                    // Dst: (CATCH_I64:{ *:[i64] } (imm:{ *:[i32] }):$tag)
/* 27669*/        0, // EndSwitchType
/* 27670*/      0, /*End of Scope*/
/* 27671*/    /*Scope*/ 79|128,1/*207*/, /*->27880*/
/* 27673*/      OPC_RecordMemRef,
/* 27674*/      OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/* 27675*/      OPC_Scope, 64, /*->27741*/ // 3 children in Scope
/* 27677*/        OPC_CheckChild1Integer, 28|128,43/*5532*/, 
/* 27680*/        OPC_RecordChild2, // #1 = $off
/* 27681*/        OPC_Scope, 34, /*->27717*/ // 2 children in Scope
/* 27683*/          OPC_MoveChild2,
/* 27684*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27687*/          OPC_MoveParent,
/* 27688*/          OPC_RecordChild3, // #2 = $count
/* 27689*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27691*/          OPC_EmitMergeInputChains1_0,
/* 27692*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27695*/          OPC_EmitConvertToTarget, 1,
/* 27697*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27700*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 27707*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, I32:{ *:[i32] }:$count) - Complexity = 11
                    // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), I32:{ *:[i32] }:$count)
/* 27717*/        /*Scope*/ 22, /*->27740*/
/* 27718*/          OPC_CheckChild2Type, MVT::i32,
/* 27720*/          OPC_RecordChild3, // #2 = $count
/* 27721*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27723*/          OPC_EmitMergeInputChains1_0,
/* 27724*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27727*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27730*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_NOTIFY), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5532:{ *:[iPTR] }, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count) - Complexity = 8
                    // Dst: (ATOMIC_NOTIFY:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, I32:{ *:[i32] }:$count)
/* 27740*/        0, /*End of Scope*/
/* 27741*/      /*Scope*/ 68, /*->27810*/
/* 27742*/        OPC_CheckChild1Integer, 29|128,43/*5533*/, 
/* 27745*/        OPC_RecordChild2, // #1 = $off
/* 27746*/        OPC_Scope, 36, /*->27784*/ // 2 children in Scope
/* 27748*/          OPC_MoveChild2,
/* 27749*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27752*/          OPC_MoveParent,
/* 27753*/          OPC_RecordChild3, // #2 = $exp
/* 27754*/          OPC_RecordChild4, // #3 = $timeout
/* 27755*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27757*/          OPC_EmitMergeInputChains1_0,
/* 27758*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27761*/          OPC_EmitConvertToTarget, 1,
/* 27763*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27766*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 27773*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 11
                    // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27784*/        /*Scope*/ 24, /*->27809*/
/* 27785*/          OPC_CheckChild2Type, MVT::i32,
/* 27787*/          OPC_RecordChild3, // #2 = $exp
/* 27788*/          OPC_RecordChild4, // #3 = $timeout
/* 27789*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27791*/          OPC_EmitMergeInputChains1_0,
/* 27792*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27795*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27798*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5533:{ *:[iPTR] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 8
                    // Dst: (ATOMIC_WAIT_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27809*/        0, /*End of Scope*/
/* 27810*/      /*Scope*/ 68, /*->27879*/
/* 27811*/        OPC_CheckChild1Integer, 30|128,43/*5534*/, 
/* 27814*/        OPC_RecordChild2, // #1 = $off
/* 27815*/        OPC_Scope, 36, /*->27853*/ // 2 children in Scope
/* 27817*/          OPC_MoveChild2,
/* 27818*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 27821*/          OPC_MoveParent,
/* 27822*/          OPC_RecordChild3, // #2 = $exp
/* 27823*/          OPC_RecordChild4, // #3 = $timeout
/* 27824*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27826*/          OPC_EmitMergeInputChains1_0,
/* 27827*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27830*/          OPC_EmitConvertToTarget, 1,
/* 27832*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27835*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 27842*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 11
                    // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27853*/        /*Scope*/ 24, /*->27878*/
/* 27854*/          OPC_CheckChild2Type, MVT::i32,
/* 27856*/          OPC_RecordChild3, // #2 = $exp
/* 27857*/          OPC_RecordChild4, // #3 = $timeout
/* 27858*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27860*/          OPC_EmitMergeInputChains1_0,
/* 27861*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27864*/          OPC_EmitInteger, MVT::i32, 0, 
/* 27867*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_WAIT_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                    // Src: (intrinsic_w_chain:{ *:[i32] } 5534:{ *:[iPTR] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 8
                    // Dst: (ATOMIC_WAIT_I64:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout)
/* 27878*/        0, /*End of Scope*/
/* 27879*/      0, /*End of Scope*/
/* 27880*/    0, /*End of Scope*/
/* 27881*/  /*SwitchOpcode*/ 89|128,15/*2009*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->29894
/* 27885*/    OPC_RecordMemRef,
/* 27886*/    OPC_RecordNode, // #0 = 'atomic_store' chained node
/* 27887*/    OPC_Scope, 35|128,11/*1443*/, /*->29333*/ // 4 children in Scope
/* 27890*/      OPC_MoveChild1,
/* 27891*/      OPC_SwitchOpcode /*3 cases */, 24|128,7/*920*/, TARGET_VAL(ISD::ADD),// ->28816
/* 27896*/        OPC_Scope, 79, /*->27977*/ // 9 children in Scope
/* 27898*/          OPC_RecordChild0, // #1 = $addr
/* 27899*/          OPC_MoveChild1,
/* 27900*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27903*/          OPC_RecordChild0, // #2 = $off
/* 27904*/          OPC_MoveChild0,
/* 27905*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 27908*/          OPC_MoveParent,
/* 27909*/          OPC_MoveParent,
/* 27910*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 27912*/          OPC_CheckType, MVT::i32,
/* 27914*/          OPC_MoveParent,
/* 27915*/          OPC_MoveChild2,
/* 27916*/          OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 27919*/          OPC_RecordChild0, // #3 = $val
/* 27920*/          OPC_MoveParent,
/* 27921*/          OPC_Scope, 17, /*->27940*/ // 3 children in Scope
/* 27923*/            OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 27925*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27927*/            OPC_EmitMergeInputChains1_0,
/* 27928*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27931*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 17
                      // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 27940*/          /*Scope*/ 17, /*->27958*/
/* 27941*/            OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 27943*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27945*/            OPC_EmitMergeInputChains1_0,
/* 27946*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27949*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 17
                      // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 27958*/          /*Scope*/ 17, /*->27976*/
/* 27959*/            OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 27961*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 27963*/            OPC_EmitMergeInputChains1_0,
/* 27964*/            OPC_EmitInteger, MVT::i32, 0, 
/* 27967*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 17
                      // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 27976*/          0, /*End of Scope*/
/* 27977*/        /*Scope*/ 79, /*->28057*/
/* 27978*/          OPC_MoveChild0,
/* 27979*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 27982*/          OPC_RecordChild0, // #1 = $off
/* 27983*/          OPC_MoveChild0,
/* 27984*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 27987*/          OPC_MoveParent,
/* 27988*/          OPC_MoveParent,
/* 27989*/          OPC_RecordChild1, // #2 = $addr
/* 27990*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 27992*/          OPC_CheckType, MVT::i32,
/* 27994*/          OPC_MoveParent,
/* 27995*/          OPC_MoveChild2,
/* 27996*/          OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 27999*/          OPC_RecordChild0, // #3 = $val
/* 28000*/          OPC_MoveParent,
/* 28001*/          OPC_Scope, 17, /*->28020*/ // 3 children in Scope
/* 28003*/            OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28005*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28007*/            OPC_EmitMergeInputChains1_0,
/* 28008*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28011*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 17
                      // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28020*/          /*Scope*/ 17, /*->28038*/
/* 28021*/            OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28023*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28025*/            OPC_EmitMergeInputChains1_0,
/* 28026*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28029*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 17
                      // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28038*/          /*Scope*/ 17, /*->28056*/
/* 28039*/            OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28041*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28043*/            OPC_EmitMergeInputChains1_0,
/* 28044*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28047*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 17
                      // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28056*/          0, /*End of Scope*/
/* 28057*/        /*Scope*/ 77, /*->28135*/
/* 28058*/          OPC_RecordChild0, // #1 = $addr
/* 28059*/          OPC_MoveChild1,
/* 28060*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 28063*/          OPC_RecordChild0, // #2 = $off
/* 28064*/          OPC_MoveChild0,
/* 28065*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 28068*/          OPC_MoveParent,
/* 28069*/          OPC_MoveParent,
/* 28070*/          OPC_CheckType, MVT::i32,
/* 28072*/          OPC_MoveParent,
/* 28073*/          OPC_MoveChild2,
/* 28074*/          OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 28077*/          OPC_RecordChild0, // #3 = $val
/* 28078*/          OPC_MoveParent,
/* 28079*/          OPC_Scope, 17, /*->28098*/ // 3 children in Scope
/* 28081*/            OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28083*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28085*/            OPC_EmitMergeInputChains1_0,
/* 28086*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28089*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 16
                      // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28098*/          /*Scope*/ 17, /*->28116*/
/* 28099*/            OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28101*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28103*/            OPC_EmitMergeInputChains1_0,
/* 28104*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28107*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 16
                      // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28116*/          /*Scope*/ 17, /*->28134*/
/* 28117*/            OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28119*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28121*/            OPC_EmitMergeInputChains1_0,
/* 28122*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28125*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 16
                      // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28134*/          0, /*End of Scope*/
/* 28135*/        /*Scope*/ 77, /*->28213*/
/* 28136*/          OPC_MoveChild0,
/* 28137*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 28140*/          OPC_RecordChild0, // #1 = $off
/* 28141*/          OPC_MoveChild0,
/* 28142*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 28145*/          OPC_MoveParent,
/* 28146*/          OPC_MoveParent,
/* 28147*/          OPC_RecordChild1, // #2 = $addr
/* 28148*/          OPC_CheckType, MVT::i32,
/* 28150*/          OPC_MoveParent,
/* 28151*/          OPC_MoveChild2,
/* 28152*/          OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 28155*/          OPC_RecordChild0, // #3 = $val
/* 28156*/          OPC_MoveParent,
/* 28157*/          OPC_Scope, 17, /*->28176*/ // 3 children in Scope
/* 28159*/            OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28161*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28163*/            OPC_EmitMergeInputChains1_0,
/* 28164*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28167*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 16
                      // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28176*/          /*Scope*/ 17, /*->28194*/
/* 28177*/            OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28179*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28181*/            OPC_EmitMergeInputChains1_0,
/* 28182*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28185*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 16
                      // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28194*/          /*Scope*/ 17, /*->28212*/
/* 28195*/            OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28197*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28199*/            OPC_EmitMergeInputChains1_0,
/* 28200*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28203*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 16
                      // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28212*/          0, /*End of Scope*/
/* 28213*/        /*Scope*/ 73|128,1/*201*/, /*->28416*/
/* 28215*/          OPC_RecordChild0, // #1 = $addr
/* 28216*/          OPC_Scope, 59, /*->28277*/ // 3 children in Scope
/* 28218*/            OPC_MoveChild1,
/* 28219*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 28222*/            OPC_RecordChild0, // #2 = $off
/* 28223*/            OPC_MoveChild0,
/* 28224*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 28227*/            OPC_MoveParent,
/* 28228*/            OPC_MoveParent,
/* 28229*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 28231*/            OPC_CheckType, MVT::i32,
/* 28233*/            OPC_MoveParent,
/* 28234*/            OPC_RecordChild2, // #3 = $val
/* 28235*/            OPC_Scope, 19, /*->28256*/ // 2 children in Scope
/* 28237*/              OPC_CheckChild2Type, MVT::i32,
/* 28239*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28241*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28243*/              OPC_EmitMergeInputChains1_0,
/* 28244*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28247*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 14
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28256*/            /*Scope*/ 19, /*->28276*/
/* 28257*/              OPC_CheckChild2Type, MVT::i64,
/* 28259*/              OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 28261*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28263*/              OPC_EmitMergeInputChains1_0,
/* 28264*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28267*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 14
                        // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28276*/            0, /*End of Scope*/
/* 28277*/          /*Scope*/ 79, /*->28357*/
/* 28278*/            OPC_RecordChild1, // #2 = $off
/* 28279*/            OPC_MoveChild1,
/* 28280*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 28283*/            OPC_MoveParent,
/* 28284*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 28286*/            OPC_CheckType, MVT::i32,
/* 28288*/            OPC_MoveParent,
/* 28289*/            OPC_MoveChild2,
/* 28290*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 28293*/            OPC_RecordChild0, // #3 = $val
/* 28294*/            OPC_MoveParent,
/* 28295*/            OPC_Scope, 19, /*->28316*/ // 3 children in Scope
/* 28297*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28299*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28301*/              OPC_EmitMergeInputChains1_0,
/* 28302*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28305*/              OPC_EmitConvertToTarget, 2,
/* 28307*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 14
                        // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28316*/            /*Scope*/ 19, /*->28336*/
/* 28317*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28319*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28321*/              OPC_EmitMergeInputChains1_0,
/* 28322*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28325*/              OPC_EmitConvertToTarget, 2,
/* 28327*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 14
                        // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28336*/            /*Scope*/ 19, /*->28356*/
/* 28337*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28339*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28341*/              OPC_EmitMergeInputChains1_0,
/* 28342*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28345*/              OPC_EmitConvertToTarget, 2,
/* 28347*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 14
                        // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28356*/            0, /*End of Scope*/
/* 28357*/          /*Scope*/ 57, /*->28415*/
/* 28358*/            OPC_MoveChild1,
/* 28359*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 28362*/            OPC_RecordChild0, // #2 = $off
/* 28363*/            OPC_MoveChild0,
/* 28364*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 28367*/            OPC_MoveParent,
/* 28368*/            OPC_MoveParent,
/* 28369*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 28371*/            OPC_CheckType, MVT::i32,
/* 28373*/            OPC_MoveParent,
/* 28374*/            OPC_RecordChild2, // #3 = $val
/* 28375*/            OPC_CheckChild2Type, MVT::i32,
/* 28377*/            OPC_Scope, 17, /*->28396*/ // 2 children in Scope
/* 28379*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28381*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28383*/              OPC_EmitMergeInputChains1_0,
/* 28384*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28387*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 14
                        // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28396*/            /*Scope*/ 17, /*->28414*/
/* 28397*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28399*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28401*/              OPC_EmitMergeInputChains1_0,
/* 28402*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28405*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 14
                        // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28414*/            0, /*End of Scope*/
/* 28415*/          0, /*End of Scope*/
/* 28416*/        /*Scope*/ 99, /*->28516*/
/* 28417*/          OPC_MoveChild0,
/* 28418*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 28421*/          OPC_RecordChild0, // #1 = $off
/* 28422*/          OPC_MoveChild0,
/* 28423*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 28426*/          OPC_MoveParent,
/* 28427*/          OPC_MoveParent,
/* 28428*/          OPC_RecordChild1, // #2 = $addr
/* 28429*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 28431*/          OPC_CheckType, MVT::i32,
/* 28433*/          OPC_MoveParent,
/* 28434*/          OPC_RecordChild2, // #3 = $val
/* 28435*/          OPC_Scope, 58, /*->28495*/ // 2 children in Scope
/* 28437*/            OPC_CheckChild2Type, MVT::i32,
/* 28439*/            OPC_Scope, 17, /*->28458*/ // 3 children in Scope
/* 28441*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28443*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28445*/              OPC_EmitMergeInputChains1_0,
/* 28446*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28449*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 14
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28458*/            /*Scope*/ 17, /*->28476*/
/* 28459*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28461*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28463*/              OPC_EmitMergeInputChains1_0,
/* 28464*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28467*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 14
                        // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28476*/            /*Scope*/ 17, /*->28494*/
/* 28477*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28479*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28481*/              OPC_EmitMergeInputChains1_0,
/* 28482*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28485*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 14
                        // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28494*/            0, /*End of Scope*/
/* 28495*/          /*Scope*/ 19, /*->28515*/
/* 28496*/            OPC_CheckChild2Type, MVT::i64,
/* 28498*/            OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 28500*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28502*/            OPC_EmitMergeInputChains1_0,
/* 28503*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28506*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 14
                      // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28515*/          0, /*End of Scope*/
/* 28516*/        /*Scope*/ 97, /*->28614*/
/* 28517*/          OPC_RecordChild0, // #1 = $addr
/* 28518*/          OPC_MoveChild1,
/* 28519*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 28522*/          OPC_RecordChild0, // #2 = $off
/* 28523*/          OPC_MoveChild0,
/* 28524*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 28527*/          OPC_MoveParent,
/* 28528*/          OPC_MoveParent,
/* 28529*/          OPC_CheckType, MVT::i32,
/* 28531*/          OPC_MoveParent,
/* 28532*/          OPC_RecordChild2, // #3 = $val
/* 28533*/          OPC_Scope, 58, /*->28593*/ // 2 children in Scope
/* 28535*/            OPC_CheckChild2Type, MVT::i32,
/* 28537*/            OPC_Scope, 17, /*->28556*/ // 3 children in Scope
/* 28539*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28541*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28543*/              OPC_EmitMergeInputChains1_0,
/* 28544*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28547*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 13
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28556*/            /*Scope*/ 17, /*->28574*/
/* 28557*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28559*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28561*/              OPC_EmitMergeInputChains1_0,
/* 28562*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28565*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 13
                        // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28574*/            /*Scope*/ 17, /*->28592*/
/* 28575*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28577*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28579*/              OPC_EmitMergeInputChains1_0,
/* 28580*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28583*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 13
                        // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28592*/            0, /*End of Scope*/
/* 28593*/          /*Scope*/ 19, /*->28613*/
/* 28594*/            OPC_CheckChild2Type, MVT::i64,
/* 28596*/            OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 28598*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28600*/            OPC_EmitMergeInputChains1_0,
/* 28601*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28604*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 13
                      // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28613*/          0, /*End of Scope*/
/* 28614*/        /*Scope*/ 97, /*->28712*/
/* 28615*/          OPC_MoveChild0,
/* 28616*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 28619*/          OPC_RecordChild0, // #1 = $off
/* 28620*/          OPC_MoveChild0,
/* 28621*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 28624*/          OPC_MoveParent,
/* 28625*/          OPC_MoveParent,
/* 28626*/          OPC_RecordChild1, // #2 = $addr
/* 28627*/          OPC_CheckType, MVT::i32,
/* 28629*/          OPC_MoveParent,
/* 28630*/          OPC_RecordChild2, // #3 = $val
/* 28631*/          OPC_Scope, 58, /*->28691*/ // 2 children in Scope
/* 28633*/            OPC_CheckChild2Type, MVT::i32,
/* 28635*/            OPC_Scope, 17, /*->28654*/ // 3 children in Scope
/* 28637*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28639*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28641*/              OPC_EmitMergeInputChains1_0,
/* 28642*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28645*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 13
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28654*/            /*Scope*/ 17, /*->28672*/
/* 28655*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28657*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28659*/              OPC_EmitMergeInputChains1_0,
/* 28660*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28663*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 13
                        // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28672*/            /*Scope*/ 17, /*->28690*/
/* 28673*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28675*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28677*/              OPC_EmitMergeInputChains1_0,
/* 28678*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28681*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 13
                        // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28690*/            0, /*End of Scope*/
/* 28691*/          /*Scope*/ 19, /*->28711*/
/* 28692*/            OPC_CheckChild2Type, MVT::i64,
/* 28694*/            OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 28696*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28698*/            OPC_EmitMergeInputChains1_0,
/* 28699*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28702*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 13
                      // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28711*/          0, /*End of Scope*/
/* 28712*/        /*Scope*/ 102, /*->28815*/
/* 28713*/          OPC_RecordChild0, // #1 = $addr
/* 28714*/          OPC_RecordChild1, // #2 = $off
/* 28715*/          OPC_MoveChild1,
/* 28716*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 28719*/          OPC_MoveParent,
/* 28720*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 28722*/          OPC_CheckType, MVT::i32,
/* 28724*/          OPC_MoveParent,
/* 28725*/          OPC_RecordChild2, // #3 = $val
/* 28726*/          OPC_Scope, 64, /*->28792*/ // 2 children in Scope
/* 28728*/            OPC_CheckChild2Type, MVT::i32,
/* 28730*/            OPC_Scope, 19, /*->28751*/ // 3 children in Scope
/* 28732*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28734*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28736*/              OPC_EmitMergeInputChains1_0,
/* 28737*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28740*/              OPC_EmitConvertToTarget, 2,
/* 28742*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 11
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28751*/            /*Scope*/ 19, /*->28771*/
/* 28752*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28754*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28756*/              OPC_EmitMergeInputChains1_0,
/* 28757*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28760*/              OPC_EmitConvertToTarget, 2,
/* 28762*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 11
                        // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28771*/            /*Scope*/ 19, /*->28791*/
/* 28772*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28774*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28776*/              OPC_EmitMergeInputChains1_0,
/* 28777*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28780*/              OPC_EmitConvertToTarget, 2,
/* 28782*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 11
                        // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28791*/            0, /*End of Scope*/
/* 28792*/          /*Scope*/ 21, /*->28814*/
/* 28793*/            OPC_CheckChild2Type, MVT::i64,
/* 28795*/            OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 28797*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28799*/            OPC_EmitMergeInputChains1_0,
/* 28800*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28803*/            OPC_EmitConvertToTarget, 2,
/* 28805*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_store (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 11
                      // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28814*/          0, /*End of Scope*/
/* 28815*/        0, /*End of Scope*/
/* 28816*/      /*SwitchOpcode*/ 46|128,1/*174*/, TARGET_VAL(ISD::OR),// ->28994
/* 28820*/        OPC_RecordChild0, // #1 = $addr
/* 28821*/        OPC_RecordChild1, // #2 = $off
/* 28822*/        OPC_MoveChild1,
/* 28823*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 28826*/        OPC_MoveParent,
/* 28827*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 28829*/        OPC_CheckType, MVT::i32,
/* 28831*/        OPC_MoveParent,
/* 28832*/        OPC_Scope, 68, /*->28902*/ // 2 children in Scope
/* 28834*/          OPC_MoveChild2,
/* 28835*/          OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 28838*/          OPC_RecordChild0, // #3 = $val
/* 28839*/          OPC_MoveParent,
/* 28840*/          OPC_Scope, 19, /*->28861*/ // 3 children in Scope
/* 28842*/            OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28844*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28846*/            OPC_EmitMergeInputChains1_0,
/* 28847*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28850*/            OPC_EmitConvertToTarget, 2,
/* 28852*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 14
                      // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28861*/          /*Scope*/ 19, /*->28881*/
/* 28862*/            OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28864*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28866*/            OPC_EmitMergeInputChains1_0,
/* 28867*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28870*/            OPC_EmitConvertToTarget, 2,
/* 28872*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 14
                      // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28881*/          /*Scope*/ 19, /*->28901*/
/* 28882*/            OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28884*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28886*/            OPC_EmitMergeInputChains1_0,
/* 28887*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28890*/            OPC_EmitConvertToTarget, 2,
/* 28892*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 14
                      // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28901*/          0, /*End of Scope*/
/* 28902*/        /*Scope*/ 90, /*->28993*/
/* 28903*/          OPC_RecordChild2, // #3 = $val
/* 28904*/          OPC_Scope, 64, /*->28970*/ // 2 children in Scope
/* 28906*/            OPC_CheckChild2Type, MVT::i32,
/* 28908*/            OPC_Scope, 19, /*->28929*/ // 3 children in Scope
/* 28910*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 28912*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28914*/              OPC_EmitMergeInputChains1_0,
/* 28915*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28918*/              OPC_EmitConvertToTarget, 2,
/* 28920*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 11
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28929*/            /*Scope*/ 19, /*->28949*/
/* 28930*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 28932*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28934*/              OPC_EmitMergeInputChains1_0,
/* 28935*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28938*/              OPC_EmitConvertToTarget, 2,
/* 28940*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 11
                        // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28949*/            /*Scope*/ 19, /*->28969*/
/* 28950*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 28952*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28954*/              OPC_EmitMergeInputChains1_0,
/* 28955*/              OPC_EmitInteger, MVT::i32, 0, 
/* 28958*/              OPC_EmitConvertToTarget, 2,
/* 28960*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 11
                        // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 28969*/            0, /*End of Scope*/
/* 28970*/          /*Scope*/ 21, /*->28992*/
/* 28971*/            OPC_CheckChild2Type, MVT::i64,
/* 28973*/            OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 28975*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 28977*/            OPC_EmitMergeInputChains1_0,
/* 28978*/            OPC_EmitInteger, MVT::i32, 0, 
/* 28981*/            OPC_EmitConvertToTarget, 2,
/* 28983*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_store (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 11
                      // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 28992*/          0, /*End of Scope*/
/* 28993*/        0, /*End of Scope*/
/* 28994*/      /*SwitchOpcode*/ 78|128,2/*334*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->29332
/* 28998*/        OPC_RecordChild0, // #1 = $off
/* 28999*/        OPC_MoveChild0,
/* 29000*/        OPC_SwitchOpcode /*2 cases */, 33|128,1/*161*/, TARGET_VAL(ISD::TargetGlobalAddress),// ->29166
/* 29005*/          OPC_MoveParent,
/* 29006*/          OPC_MoveParent,
/* 29007*/          OPC_Scope, 92, /*->29101*/ // 2 children in Scope
/* 29009*/            OPC_MoveChild2,
/* 29010*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 29013*/            OPC_RecordChild0, // #2 = $val
/* 29014*/            OPC_MoveParent,
/* 29015*/            OPC_Scope, 27, /*->29044*/ // 3 children in Scope
/* 29017*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29019*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29021*/              OPC_EmitMergeInputChains1_0,
/* 29022*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29025*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29028*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29035*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 13
                        // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29044*/            /*Scope*/ 27, /*->29072*/
/* 29045*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29047*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29049*/              OPC_EmitMergeInputChains1_0,
/* 29050*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29053*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29056*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29063*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 13
                        // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29072*/            /*Scope*/ 27, /*->29100*/
/* 29073*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29075*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29077*/              OPC_EmitMergeInputChains1_0,
/* 29078*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29081*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29084*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29091*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 13
                        // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29100*/            0, /*End of Scope*/
/* 29101*/          /*Scope*/ 63, /*->29165*/
/* 29102*/            OPC_RecordChild2, // #2 = $val
/* 29103*/            OPC_Scope, 29, /*->29134*/ // 2 children in Scope
/* 29105*/              OPC_CheckChild2Type, MVT::i32,
/* 29107*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29109*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29111*/              OPC_EmitMergeInputChains1_0,
/* 29112*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29115*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29118*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29125*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 10
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29134*/            /*Scope*/ 29, /*->29164*/
/* 29135*/              OPC_CheckChild2Type, MVT::i64,
/* 29137*/              OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 29139*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29141*/              OPC_EmitMergeInputChains1_0,
/* 29142*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29145*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29148*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29155*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 10
                        // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29164*/            0, /*End of Scope*/
/* 29165*/          0, /*End of Scope*/
/* 29166*/        /*SwitchOpcode*/ 33|128,1/*161*/, TARGET_VAL(ISD::TargetExternalSymbol),// ->29331
/* 29170*/          OPC_MoveParent,
/* 29171*/          OPC_MoveParent,
/* 29172*/          OPC_Scope, 92, /*->29266*/ // 2 children in Scope
/* 29174*/            OPC_MoveChild2,
/* 29175*/            OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 29178*/            OPC_RecordChild0, // #2 = $val
/* 29179*/            OPC_MoveParent,
/* 29180*/            OPC_Scope, 27, /*->29209*/ // 3 children in Scope
/* 29182*/              OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29184*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29186*/              OPC_EmitMergeInputChains1_0,
/* 29187*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29190*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29193*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29200*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 13
                        // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29209*/            /*Scope*/ 27, /*->29237*/
/* 29210*/              OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29212*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29214*/              OPC_EmitMergeInputChains1_0,
/* 29215*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29218*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29221*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29228*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 13
                        // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29237*/            /*Scope*/ 27, /*->29265*/
/* 29238*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29240*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29242*/              OPC_EmitMergeInputChains1_0,
/* 29243*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29246*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29249*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29256*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 13
                        // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29265*/            0, /*End of Scope*/
/* 29266*/          /*Scope*/ 63, /*->29330*/
/* 29267*/            OPC_RecordChild2, // #2 = $val
/* 29268*/            OPC_Scope, 29, /*->29299*/ // 2 children in Scope
/* 29270*/              OPC_CheckChild2Type, MVT::i32,
/* 29272*/              OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29274*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29276*/              OPC_EmitMergeInputChains1_0,
/* 29277*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29280*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29283*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29290*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 10
                        // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29299*/            /*Scope*/ 29, /*->29329*/
/* 29300*/              OPC_CheckChild2Type, MVT::i64,
/* 29302*/              OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 29304*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29306*/              OPC_EmitMergeInputChains1_0,
/* 29307*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29310*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29313*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29320*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 10
                        // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29329*/            0, /*End of Scope*/
/* 29330*/          0, /*End of Scope*/
/* 29331*/        0, // EndSwitchOpcode
/* 29332*/      0, // EndSwitchOpcode
/* 29333*/    /*Scope*/ 104, /*->29438*/
/* 29334*/      OPC_RecordChild1, // #1 = $off
/* 29335*/      OPC_MoveChild1,
/* 29336*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 29339*/      OPC_MoveParent,
/* 29340*/      OPC_MoveChild2,
/* 29341*/      OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 29344*/      OPC_RecordChild0, // #2 = $val
/* 29345*/      OPC_MoveParent,
/* 29346*/      OPC_Scope, 29, /*->29377*/ // 3 children in Scope
/* 29348*/        OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29350*/        OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29352*/        OPC_EmitMergeInputChains1_0,
/* 29353*/        OPC_EmitInteger, MVT::i32, 0, 
/* 29356*/        OPC_EmitConvertToTarget, 1,
/* 29358*/        OPC_EmitInteger, MVT::i32, 0, 
/* 29361*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 29368*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 10
                  // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29377*/      /*Scope*/ 29, /*->29407*/
/* 29378*/        OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29380*/        OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29382*/        OPC_EmitMergeInputChains1_0,
/* 29383*/        OPC_EmitInteger, MVT::i32, 0, 
/* 29386*/        OPC_EmitConvertToTarget, 1,
/* 29388*/        OPC_EmitInteger, MVT::i32, 0, 
/* 29391*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 29398*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 10
                  // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29407*/      /*Scope*/ 29, /*->29437*/
/* 29408*/        OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29410*/        OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29412*/        OPC_EmitMergeInputChains1_0,
/* 29413*/        OPC_EmitInteger, MVT::i32, 0, 
/* 29416*/        OPC_EmitConvertToTarget, 1,
/* 29418*/        OPC_EmitInteger, MVT::i32, 0, 
/* 29421*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 29428*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                      4/*#Ops*/, 3, 4, 6, 2, 
                  // Src: (atomic_store (imm:{ *:[iPTR] }):$off, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 10
                  // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29437*/      0, /*End of Scope*/
/* 29438*/    /*Scope*/ 12|128,1/*140*/, /*->29580*/
/* 29440*/      OPC_MoveChild1,
/* 29441*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 29444*/      OPC_RecordChild0, // #1 = $off
/* 29445*/      OPC_MoveChild0,
/* 29446*/      OPC_SwitchOpcode /*2 cases */, 63, TARGET_VAL(ISD::TargetGlobalAddress),// ->29513
/* 29450*/        OPC_MoveParent,
/* 29451*/        OPC_MoveParent,
/* 29452*/        OPC_RecordChild2, // #2 = $val
/* 29453*/        OPC_CheckChild2Type, MVT::i32,
/* 29455*/        OPC_Scope, 27, /*->29484*/ // 2 children in Scope
/* 29457*/          OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29459*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29461*/          OPC_EmitMergeInputChains1_0,
/* 29462*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29465*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29468*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29475*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 1, 5, 2, 
                    // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 10
                    // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29484*/        /*Scope*/ 27, /*->29512*/
/* 29485*/          OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29487*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29489*/          OPC_EmitMergeInputChains1_0,
/* 29490*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29493*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29496*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29503*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 1, 5, 2, 
                    // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 10
                    // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29512*/        0, /*End of Scope*/
/* 29513*/      /*SwitchOpcode*/ 63, TARGET_VAL(ISD::TargetExternalSymbol),// ->29579
/* 29516*/        OPC_MoveParent,
/* 29517*/        OPC_MoveParent,
/* 29518*/        OPC_RecordChild2, // #2 = $val
/* 29519*/        OPC_CheckChild2Type, MVT::i32,
/* 29521*/        OPC_Scope, 27, /*->29550*/ // 2 children in Scope
/* 29523*/          OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29525*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29527*/          OPC_EmitMergeInputChains1_0,
/* 29528*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29531*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29534*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29541*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 1, 5, 2, 
                    // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 10
                    // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29550*/        /*Scope*/ 27, /*->29578*/
/* 29551*/          OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29553*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29555*/          OPC_EmitMergeInputChains1_0,
/* 29556*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29559*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29562*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 29569*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 1, 5, 2, 
                    // Src: (atomic_store (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 10
                    // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29578*/        0, /*End of Scope*/
/* 29579*/      0, // EndSwitchOpcode
/* 29580*/    /*Scope*/ 55|128,2/*311*/, /*->29893*/
/* 29582*/      OPC_RecordChild1, // #1 = $addr
/* 29583*/      OPC_Scope, 73, /*->29658*/ // 3 children in Scope
/* 29585*/        OPC_CheckChild1Type, MVT::i32,
/* 29587*/        OPC_MoveChild2,
/* 29588*/        OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 29591*/        OPC_RecordChild0, // #2 = $val
/* 29592*/        OPC_MoveParent,
/* 29593*/        OPC_Scope, 20, /*->29615*/ // 3 children in Scope
/* 29595*/          OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29597*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29599*/          OPC_EmitMergeInputChains1_0,
/* 29600*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29603*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29606*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_store I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 7
                    // Dst: (ATOMIC_STORE8_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 29615*/        /*Scope*/ 20, /*->29636*/
/* 29616*/          OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29618*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29620*/          OPC_EmitMergeInputChains1_0,
/* 29621*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29624*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29627*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_store I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 7
                    // Dst: (ATOMIC_STORE16_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 29636*/        /*Scope*/ 20, /*->29657*/
/* 29637*/          OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29639*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29641*/          OPC_EmitMergeInputChains1_0,
/* 29642*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29645*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29648*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_store I32:{ *:[i32] }:$addr, (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 7
                    // Dst: (ATOMIC_STORE32_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 29657*/        0, /*End of Scope*/
/* 29658*/      /*Scope*/ 7|128,1/*135*/, /*->29795*/
/* 29660*/        OPC_MoveChild1,
/* 29661*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 29664*/        OPC_MoveParent,
/* 29665*/        OPC_RecordChild2, // #2 = $val
/* 29666*/        OPC_Scope, 94, /*->29762*/ // 2 children in Scope
/* 29668*/          OPC_CheckChild2Type, MVT::i32,
/* 29670*/          OPC_Scope, 29, /*->29701*/ // 3 children in Scope
/* 29672*/            OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29674*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29676*/            OPC_EmitMergeInputChains1_0,
/* 29677*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29680*/            OPC_EmitConvertToTarget, 1,
/* 29682*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29685*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 29692*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 7
                      // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29701*/          /*Scope*/ 29, /*->29731*/
/* 29702*/            OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29704*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29706*/            OPC_EmitMergeInputChains1_0,
/* 29707*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29710*/            OPC_EmitConvertToTarget, 1,
/* 29712*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29715*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 29722*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 7
                      // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29731*/          /*Scope*/ 29, /*->29761*/
/* 29732*/            OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29734*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29736*/            OPC_EmitMergeInputChains1_0,
/* 29737*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29740*/            OPC_EmitConvertToTarget, 1,
/* 29742*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29745*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 29752*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 7
                      // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 29761*/          0, /*End of Scope*/
/* 29762*/        /*Scope*/ 31, /*->29794*/
/* 29763*/          OPC_CheckChild2Type, MVT::i64,
/* 29765*/          OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 29767*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29769*/          OPC_EmitMergeInputChains1_0,
/* 29770*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29773*/          OPC_EmitConvertToTarget, 1,
/* 29775*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29778*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 29785*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (atomic_store (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 7
                    // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 29794*/        0, /*End of Scope*/
/* 29795*/      /*Scope*/ 96, /*->29892*/
/* 29796*/        OPC_CheckChild1Type, MVT::i32,
/* 29798*/        OPC_RecordChild2, // #2 = $val
/* 29799*/        OPC_Scope, 67, /*->29868*/ // 2 children in Scope
/* 29801*/          OPC_CheckChild2Type, MVT::i32,
/* 29803*/          OPC_Scope, 20, /*->29825*/ // 3 children in Scope
/* 29805*/            OPC_CheckPredicate, 7, // Predicate_atomic_store_32
/* 29807*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29809*/            OPC_EmitMergeInputChains1_0,
/* 29810*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29813*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29816*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_store I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 4
                      // Dst: (ATOMIC_STORE_I32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 29825*/          /*Scope*/ 20, /*->29846*/
/* 29826*/            OPC_CheckPredicate, 1, // Predicate_atomic_store_8
/* 29828*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29830*/            OPC_EmitMergeInputChains1_0,
/* 29831*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29834*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29837*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_store I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 4
                      // Dst: (ATOMIC_STORE8_I32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 29846*/          /*Scope*/ 20, /*->29867*/
/* 29847*/            OPC_CheckPredicate, 2, // Predicate_atomic_store_16
/* 29849*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29851*/            OPC_EmitMergeInputChains1_0,
/* 29852*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29855*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29858*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_store I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 4
                      // Dst: (ATOMIC_STORE16_I32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 29867*/          0, /*End of Scope*/
/* 29868*/        /*Scope*/ 22, /*->29891*/
/* 29869*/          OPC_CheckChild2Type, MVT::i64,
/* 29871*/          OPC_CheckPredicate, 8, // Predicate_atomic_store_64
/* 29873*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 29875*/          OPC_EmitMergeInputChains1_0,
/* 29876*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29879*/          OPC_EmitInteger, MVT::i32, 0, 
/* 29882*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_store I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 4
                    // Dst: (ATOMIC_STORE_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 29891*/        0, /*End of Scope*/
/* 29892*/      0, /*End of Scope*/
/* 29893*/    0, /*End of Scope*/
/* 29894*/  /*SwitchOpcode*/ 79|128,48/*6223*/, TARGET_VAL(ISD::LOAD),// ->36121
/* 29898*/    OPC_RecordMemRef,
/* 29899*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 29900*/    OPC_Scope, 104|128,24/*3176*/, /*->33079*/ // 8 children in Scope
/* 29903*/      OPC_MoveChild1,
/* 29904*/      OPC_SwitchOpcode /*3 cases */, 97|128,13/*1761*/, TARGET_VAL(ISD::ADD),// ->31670
/* 29909*/        OPC_Scope, 93|128,2/*349*/, /*->30261*/ // 5 children in Scope
/* 29912*/          OPC_RecordChild0, // #1 = $addr
/* 29913*/          OPC_MoveChild1,
/* 29914*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 29917*/          OPC_RecordChild0, // #2 = $off
/* 29918*/          OPC_MoveChild0,
/* 29919*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 29922*/          OPC_MoveParent,
/* 29923*/          OPC_MoveParent,
/* 29924*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 29926*/          OPC_CheckType, MVT::i32,
/* 29928*/          OPC_MoveParent,
/* 29929*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 29931*/          OPC_Scope, 34, /*->29967*/ // 12 children in Scope
/* 29933*/            OPC_CheckPredicate, 10, // Predicate_load
/* 29935*/            OPC_SwitchType /*2 cases */, 13, MVT::i32,// ->29951
/* 29938*/              OPC_EmitMergeInputChains1_0,
/* 29939*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29942*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                        // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 29951*/            /*SwitchType*/ 13, MVT::i64,// ->29966
/* 29953*/              OPC_EmitMergeInputChains1_0,
/* 29954*/              OPC_EmitInteger, MVT::i32, 0, 
/* 29957*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                        // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 29966*/            0, // EndSwitchType
/* 29967*/          /*Scope*/ 19, /*->29987*/
/* 29968*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 29970*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 29972*/            OPC_CheckType, MVT::i32,
/* 29974*/            OPC_EmitMergeInputChains1_0,
/* 29975*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29978*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 14
                      // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 29987*/          /*Scope*/ 19, /*->30007*/
/* 29988*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 29990*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 29992*/            OPC_CheckType, MVT::i32,
/* 29994*/            OPC_EmitMergeInputChains1_0,
/* 29995*/            OPC_EmitInteger, MVT::i32, 0, 
/* 29998*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 14
                      // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30007*/          /*Scope*/ 19, /*->30027*/
/* 30008*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30010*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 30012*/            OPC_CheckType, MVT::i32,
/* 30014*/            OPC_EmitMergeInputChains1_0,
/* 30015*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30018*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 14
                      // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30027*/          /*Scope*/ 19, /*->30047*/
/* 30028*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30030*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 30032*/            OPC_CheckType, MVT::i32,
/* 30034*/            OPC_EmitMergeInputChains1_0,
/* 30035*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30038*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 14
                      // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30047*/          /*Scope*/ 19, /*->30067*/
/* 30048*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30050*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 30052*/            OPC_CheckType, MVT::i64,
/* 30054*/            OPC_EmitMergeInputChains1_0,
/* 30055*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30058*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 14
                      // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30067*/          /*Scope*/ 19, /*->30087*/
/* 30068*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30070*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 30072*/            OPC_CheckType, MVT::i64,
/* 30074*/            OPC_EmitMergeInputChains1_0,
/* 30075*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30078*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 14
                      // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30087*/          /*Scope*/ 19, /*->30107*/
/* 30088*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30090*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 30092*/            OPC_CheckType, MVT::i64,
/* 30094*/            OPC_EmitMergeInputChains1_0,
/* 30095*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30098*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 14
                      // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30107*/          /*Scope*/ 19, /*->30127*/
/* 30108*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30110*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 30112*/            OPC_CheckType, MVT::i64,
/* 30114*/            OPC_EmitMergeInputChains1_0,
/* 30115*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30118*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 14
                      // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30127*/          /*Scope*/ 19, /*->30147*/
/* 30128*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30130*/            OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 30132*/            OPC_CheckType, MVT::i64,
/* 30134*/            OPC_EmitMergeInputChains1_0,
/* 30135*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30138*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 14
                      // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30147*/          /*Scope*/ 19, /*->30167*/
/* 30148*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30150*/            OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 30152*/            OPC_CheckType, MVT::i64,
/* 30154*/            OPC_EmitMergeInputChains1_0,
/* 30155*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30158*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 14
                      // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30167*/          /*Scope*/ 92, /*->30260*/
/* 30168*/            OPC_CheckPredicate, 16, // Predicate_extload
/* 30170*/            OPC_SwitchType /*2 cases */, 34, MVT::i32,// ->30207
/* 30173*/              OPC_Scope, 15, /*->30190*/ // 2 children in Scope
/* 30175*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 30177*/                OPC_EmitMergeInputChains1_0,
/* 30178*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30181*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 14
                          // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30190*/              /*Scope*/ 15, /*->30206*/
/* 30191*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 30193*/                OPC_EmitMergeInputChains1_0,
/* 30194*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30197*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 14
                          // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30206*/              0, /*End of Scope*/
/* 30207*/            /*SwitchType*/ 50, MVT::i64,// ->30259
/* 30209*/              OPC_Scope, 15, /*->30226*/ // 3 children in Scope
/* 30211*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 30213*/                OPC_EmitMergeInputChains1_0,
/* 30214*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30217*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 14
                          // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30226*/              /*Scope*/ 15, /*->30242*/
/* 30227*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 30229*/                OPC_EmitMergeInputChains1_0,
/* 30230*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30233*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 14
                          // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30242*/              /*Scope*/ 15, /*->30258*/
/* 30243*/                OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 30245*/                OPC_EmitMergeInputChains1_0,
/* 30246*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30249*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 14
                          // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30258*/              0, /*End of Scope*/
/* 30259*/            0, // EndSwitchType
/* 30260*/          0, /*End of Scope*/
/* 30261*/        /*Scope*/ 72|128,2/*328*/, /*->30591*/
/* 30263*/          OPC_MoveChild0,
/* 30264*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 30267*/          OPC_RecordChild0, // #1 = $off
/* 30268*/          OPC_MoveChild0,
/* 30269*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 30272*/          OPC_MoveParent,
/* 30273*/          OPC_MoveParent,
/* 30274*/          OPC_RecordChild1, // #2 = $addr
/* 30275*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 30277*/          OPC_CheckType, MVT::i32,
/* 30279*/          OPC_MoveParent,
/* 30280*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 30282*/          OPC_Scope, 19, /*->30303*/ // 10 children in Scope
/* 30284*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30286*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 30288*/            OPC_CheckType, MVT::i32,
/* 30290*/            OPC_EmitMergeInputChains1_0,
/* 30291*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30294*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 14
                      // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30303*/          /*Scope*/ 19, /*->30323*/
/* 30304*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30306*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 30308*/            OPC_CheckType, MVT::i32,
/* 30310*/            OPC_EmitMergeInputChains1_0,
/* 30311*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30314*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 14
                      // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30323*/          /*Scope*/ 38, /*->30362*/
/* 30324*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30326*/            OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->30344
/* 30329*/              OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 30331*/              OPC_EmitMergeInputChains1_0,
/* 30332*/              OPC_EmitInteger, MVT::i32, 0, 
/* 30335*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 14
                        // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30344*/            /*SwitchType*/ 15, MVT::i64,// ->30361
/* 30346*/              OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 30348*/              OPC_EmitMergeInputChains1_0,
/* 30349*/              OPC_EmitInteger, MVT::i32, 0, 
/* 30352*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 14
                        // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30361*/            0, // EndSwitchType
/* 30362*/          /*Scope*/ 19, /*->30382*/
/* 30363*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30365*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 30367*/            OPC_CheckType, MVT::i64,
/* 30369*/            OPC_EmitMergeInputChains1_0,
/* 30370*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30373*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 14
                      // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30382*/          /*Scope*/ 19, /*->30402*/
/* 30383*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30385*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 30387*/            OPC_CheckType, MVT::i64,
/* 30389*/            OPC_EmitMergeInputChains1_0,
/* 30390*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30393*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 14
                      // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30402*/          /*Scope*/ 19, /*->30422*/
/* 30403*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30405*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 30407*/            OPC_CheckType, MVT::i64,
/* 30409*/            OPC_EmitMergeInputChains1_0,
/* 30410*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30413*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 14
                      // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30422*/          /*Scope*/ 19, /*->30442*/
/* 30423*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30425*/            OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 30427*/            OPC_CheckType, MVT::i64,
/* 30429*/            OPC_EmitMergeInputChains1_0,
/* 30430*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30433*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 14
                      // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30442*/          /*Scope*/ 19, /*->30462*/
/* 30443*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30445*/            OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 30447*/            OPC_CheckType, MVT::i64,
/* 30449*/            OPC_EmitMergeInputChains1_0,
/* 30450*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30453*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 14
                      // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30462*/          /*Scope*/ 92, /*->30555*/
/* 30463*/            OPC_CheckPredicate, 16, // Predicate_extload
/* 30465*/            OPC_SwitchType /*2 cases */, 34, MVT::i32,// ->30502
/* 30468*/              OPC_Scope, 15, /*->30485*/ // 2 children in Scope
/* 30470*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 30472*/                OPC_EmitMergeInputChains1_0,
/* 30473*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30476*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 14
                          // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30485*/              /*Scope*/ 15, /*->30501*/
/* 30486*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 30488*/                OPC_EmitMergeInputChains1_0,
/* 30489*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30492*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 14
                          // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30501*/              0, /*End of Scope*/
/* 30502*/            /*SwitchType*/ 50, MVT::i64,// ->30554
/* 30504*/              OPC_Scope, 15, /*->30521*/ // 3 children in Scope
/* 30506*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 30508*/                OPC_EmitMergeInputChains1_0,
/* 30509*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30512*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 14
                          // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30521*/              /*Scope*/ 15, /*->30537*/
/* 30522*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 30524*/                OPC_EmitMergeInputChains1_0,
/* 30525*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30528*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 14
                          // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30537*/              /*Scope*/ 15, /*->30553*/
/* 30538*/                OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 30540*/                OPC_EmitMergeInputChains1_0,
/* 30541*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30544*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 14
                          // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30553*/              0, /*End of Scope*/
/* 30554*/            0, // EndSwitchType
/* 30555*/          /*Scope*/ 34, /*->30590*/
/* 30556*/            OPC_CheckPredicate, 10, // Predicate_load
/* 30558*/            OPC_SwitchType /*2 cases */, 13, MVT::i32,// ->30574
/* 30561*/              OPC_EmitMergeInputChains1_0,
/* 30562*/              OPC_EmitInteger, MVT::i32, 0, 
/* 30565*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                        // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30574*/            /*SwitchType*/ 13, MVT::i64,// ->30589
/* 30576*/              OPC_EmitMergeInputChains1_0,
/* 30577*/              OPC_EmitInteger, MVT::i32, 0, 
/* 30580*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                        // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30589*/            0, // EndSwitchType
/* 30590*/          0, /*End of Scope*/
/* 30591*/        /*Scope*/ 91|128,2/*347*/, /*->30940*/
/* 30593*/          OPC_RecordChild0, // #1 = $addr
/* 30594*/          OPC_MoveChild1,
/* 30595*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 30598*/          OPC_RecordChild0, // #2 = $off
/* 30599*/          OPC_MoveChild0,
/* 30600*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 30603*/          OPC_MoveParent,
/* 30604*/          OPC_MoveParent,
/* 30605*/          OPC_CheckType, MVT::i32,
/* 30607*/          OPC_MoveParent,
/* 30608*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 30610*/          OPC_Scope, 34, /*->30646*/ // 12 children in Scope
/* 30612*/            OPC_CheckPredicate, 10, // Predicate_load
/* 30614*/            OPC_SwitchType /*2 cases */, 13, MVT::i32,// ->30630
/* 30617*/              OPC_EmitMergeInputChains1_0,
/* 30618*/              OPC_EmitInteger, MVT::i32, 0, 
/* 30621*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                        // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30630*/            /*SwitchType*/ 13, MVT::i64,// ->30645
/* 30632*/              OPC_EmitMergeInputChains1_0,
/* 30633*/              OPC_EmitInteger, MVT::i32, 0, 
/* 30636*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                        // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30645*/            0, // EndSwitchType
/* 30646*/          /*Scope*/ 19, /*->30666*/
/* 30647*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30649*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 30651*/            OPC_CheckType, MVT::i32,
/* 30653*/            OPC_EmitMergeInputChains1_0,
/* 30654*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30657*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30666*/          /*Scope*/ 19, /*->30686*/
/* 30667*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30669*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 30671*/            OPC_CheckType, MVT::i32,
/* 30673*/            OPC_EmitMergeInputChains1_0,
/* 30674*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30677*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30686*/          /*Scope*/ 19, /*->30706*/
/* 30687*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30689*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 30691*/            OPC_CheckType, MVT::i32,
/* 30693*/            OPC_EmitMergeInputChains1_0,
/* 30694*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30697*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30706*/          /*Scope*/ 19, /*->30726*/
/* 30707*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30709*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 30711*/            OPC_CheckType, MVT::i32,
/* 30713*/            OPC_EmitMergeInputChains1_0,
/* 30714*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30717*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30726*/          /*Scope*/ 19, /*->30746*/
/* 30727*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30729*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 30731*/            OPC_CheckType, MVT::i64,
/* 30733*/            OPC_EmitMergeInputChains1_0,
/* 30734*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30737*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30746*/          /*Scope*/ 19, /*->30766*/
/* 30747*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30749*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 30751*/            OPC_CheckType, MVT::i64,
/* 30753*/            OPC_EmitMergeInputChains1_0,
/* 30754*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30757*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30766*/          /*Scope*/ 19, /*->30786*/
/* 30767*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30769*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 30771*/            OPC_CheckType, MVT::i64,
/* 30773*/            OPC_EmitMergeInputChains1_0,
/* 30774*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30777*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30786*/          /*Scope*/ 19, /*->30806*/
/* 30787*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30789*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 30791*/            OPC_CheckType, MVT::i64,
/* 30793*/            OPC_EmitMergeInputChains1_0,
/* 30794*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30797*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30806*/          /*Scope*/ 19, /*->30826*/
/* 30807*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30809*/            OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 30811*/            OPC_CheckType, MVT::i64,
/* 30813*/            OPC_EmitMergeInputChains1_0,
/* 30814*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30817*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                      // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30826*/          /*Scope*/ 19, /*->30846*/
/* 30827*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30829*/            OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 30831*/            OPC_CheckType, MVT::i64,
/* 30833*/            OPC_EmitMergeInputChains1_0,
/* 30834*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30837*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                      // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30846*/          /*Scope*/ 92, /*->30939*/
/* 30847*/            OPC_CheckPredicate, 16, // Predicate_extload
/* 30849*/            OPC_SwitchType /*2 cases */, 34, MVT::i32,// ->30886
/* 30852*/              OPC_Scope, 15, /*->30869*/ // 2 children in Scope
/* 30854*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 30856*/                OPC_EmitMergeInputChains1_0,
/* 30857*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30860*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                          // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30869*/              /*Scope*/ 15, /*->30885*/
/* 30870*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 30872*/                OPC_EmitMergeInputChains1_0,
/* 30873*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30876*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                          // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30885*/              0, /*End of Scope*/
/* 30886*/            /*SwitchType*/ 50, MVT::i64,// ->30938
/* 30888*/              OPC_Scope, 15, /*->30905*/ // 3 children in Scope
/* 30890*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 30892*/                OPC_EmitMergeInputChains1_0,
/* 30893*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30896*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                          // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30905*/              /*Scope*/ 15, /*->30921*/
/* 30906*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 30908*/                OPC_EmitMergeInputChains1_0,
/* 30909*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30912*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                          // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30921*/              /*Scope*/ 15, /*->30937*/
/* 30922*/                OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 30924*/                OPC_EmitMergeInputChains1_0,
/* 30925*/                OPC_EmitInteger, MVT::i32, 0, 
/* 30928*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                          // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30937*/              0, /*End of Scope*/
/* 30938*/            0, // EndSwitchType
/* 30939*/          0, /*End of Scope*/
/* 30940*/        /*Scope*/ 91|128,2/*347*/, /*->31289*/
/* 30942*/          OPC_MoveChild0,
/* 30943*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 30946*/          OPC_RecordChild0, // #1 = $off
/* 30947*/          OPC_MoveChild0,
/* 30948*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 30951*/          OPC_MoveParent,
/* 30952*/          OPC_MoveParent,
/* 30953*/          OPC_RecordChild1, // #2 = $addr
/* 30954*/          OPC_CheckType, MVT::i32,
/* 30956*/          OPC_MoveParent,
/* 30957*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 30959*/          OPC_Scope, 19, /*->30980*/ // 12 children in Scope
/* 30961*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 30963*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 30965*/            OPC_CheckType, MVT::i32,
/* 30967*/            OPC_EmitMergeInputChains1_0,
/* 30968*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30971*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 30980*/          /*Scope*/ 19, /*->31000*/
/* 30981*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 30983*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 30985*/            OPC_CheckType, MVT::i32,
/* 30987*/            OPC_EmitMergeInputChains1_0,
/* 30988*/            OPC_EmitInteger, MVT::i32, 0, 
/* 30991*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31000*/          /*Scope*/ 19, /*->31020*/
/* 31001*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31003*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 31005*/            OPC_CheckType, MVT::i32,
/* 31007*/            OPC_EmitMergeInputChains1_0,
/* 31008*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31011*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31020*/          /*Scope*/ 19, /*->31040*/
/* 31021*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31023*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 31025*/            OPC_CheckType, MVT::i32,
/* 31027*/            OPC_EmitMergeInputChains1_0,
/* 31028*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31031*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31040*/          /*Scope*/ 19, /*->31060*/
/* 31041*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31043*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 31045*/            OPC_CheckType, MVT::i64,
/* 31047*/            OPC_EmitMergeInputChains1_0,
/* 31048*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31051*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31060*/          /*Scope*/ 19, /*->31080*/
/* 31061*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31063*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 31065*/            OPC_CheckType, MVT::i64,
/* 31067*/            OPC_EmitMergeInputChains1_0,
/* 31068*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31071*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                      // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31080*/          /*Scope*/ 19, /*->31100*/
/* 31081*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31083*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 31085*/            OPC_CheckType, MVT::i64,
/* 31087*/            OPC_EmitMergeInputChains1_0,
/* 31088*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31091*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31100*/          /*Scope*/ 19, /*->31120*/
/* 31101*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31103*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 31105*/            OPC_CheckType, MVT::i64,
/* 31107*/            OPC_EmitMergeInputChains1_0,
/* 31108*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31111*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                      // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31120*/          /*Scope*/ 19, /*->31140*/
/* 31121*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31123*/            OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 31125*/            OPC_CheckType, MVT::i64,
/* 31127*/            OPC_EmitMergeInputChains1_0,
/* 31128*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31131*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                      // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31140*/          /*Scope*/ 19, /*->31160*/
/* 31141*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31143*/            OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 31145*/            OPC_CheckType, MVT::i64,
/* 31147*/            OPC_EmitMergeInputChains1_0,
/* 31148*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31151*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                      // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31160*/          /*Scope*/ 92, /*->31253*/
/* 31161*/            OPC_CheckPredicate, 16, // Predicate_extload
/* 31163*/            OPC_SwitchType /*2 cases */, 34, MVT::i32,// ->31200
/* 31166*/              OPC_Scope, 15, /*->31183*/ // 2 children in Scope
/* 31168*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 31170*/                OPC_EmitMergeInputChains1_0,
/* 31171*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31174*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                          // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31183*/              /*Scope*/ 15, /*->31199*/
/* 31184*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 31186*/                OPC_EmitMergeInputChains1_0,
/* 31187*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31190*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                          // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31199*/              0, /*End of Scope*/
/* 31200*/            /*SwitchType*/ 50, MVT::i64,// ->31252
/* 31202*/              OPC_Scope, 15, /*->31219*/ // 3 children in Scope
/* 31204*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 31206*/                OPC_EmitMergeInputChains1_0,
/* 31207*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31210*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                          // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31219*/              /*Scope*/ 15, /*->31235*/
/* 31220*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 31222*/                OPC_EmitMergeInputChains1_0,
/* 31223*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31226*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                          // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31235*/              /*Scope*/ 15, /*->31251*/
/* 31236*/                OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 31238*/                OPC_EmitMergeInputChains1_0,
/* 31239*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31242*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                          // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31251*/              0, /*End of Scope*/
/* 31252*/            0, // EndSwitchType
/* 31253*/          /*Scope*/ 34, /*->31288*/
/* 31254*/            OPC_CheckPredicate, 10, // Predicate_load
/* 31256*/            OPC_SwitchType /*2 cases */, 13, MVT::i32,// ->31272
/* 31259*/              OPC_EmitMergeInputChains1_0,
/* 31260*/              OPC_EmitInteger, MVT::i32, 0, 
/* 31263*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (ld:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                        // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31272*/            /*SwitchType*/ 13, MVT::i64,// ->31287
/* 31274*/              OPC_EmitMergeInputChains1_0,
/* 31275*/              OPC_EmitInteger, MVT::i32, 0, 
/* 31278*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (ld:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                        // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31287*/            0, // EndSwitchType
/* 31288*/          0, /*End of Scope*/
/* 31289*/        /*Scope*/ 122|128,2/*378*/, /*->31669*/
/* 31291*/          OPC_RecordChild0, // #1 = $addr
/* 31292*/          OPC_RecordChild1, // #2 = $off
/* 31293*/          OPC_MoveChild1,
/* 31294*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 31297*/          OPC_MoveParent,
/* 31298*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 31300*/          OPC_CheckType, MVT::i32,
/* 31302*/          OPC_MoveParent,
/* 31303*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 31305*/          OPC_Scope, 38, /*->31345*/ // 12 children in Scope
/* 31307*/            OPC_CheckPredicate, 10, // Predicate_load
/* 31309*/            OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->31327
/* 31312*/              OPC_EmitMergeInputChains1_0,
/* 31313*/              OPC_EmitInteger, MVT::i32, 0, 
/* 31316*/              OPC_EmitConvertToTarget, 2,
/* 31318*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                        // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31327*/            /*SwitchType*/ 15, MVT::i64,// ->31344
/* 31329*/              OPC_EmitMergeInputChains1_0,
/* 31330*/              OPC_EmitInteger, MVT::i32, 0, 
/* 31333*/              OPC_EmitConvertToTarget, 2,
/* 31335*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                        // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31344*/            0, // EndSwitchType
/* 31345*/          /*Scope*/ 21, /*->31367*/
/* 31346*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31348*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 31350*/            OPC_CheckType, MVT::i32,
/* 31352*/            OPC_EmitMergeInputChains1_0,
/* 31353*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31356*/            OPC_EmitConvertToTarget, 2,
/* 31358*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                      // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31367*/          /*Scope*/ 21, /*->31389*/
/* 31368*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31370*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 31372*/            OPC_CheckType, MVT::i32,
/* 31374*/            OPC_EmitMergeInputChains1_0,
/* 31375*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31378*/            OPC_EmitConvertToTarget, 2,
/* 31380*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                      // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31389*/          /*Scope*/ 21, /*->31411*/
/* 31390*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31392*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 31394*/            OPC_CheckType, MVT::i32,
/* 31396*/            OPC_EmitMergeInputChains1_0,
/* 31397*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31400*/            OPC_EmitConvertToTarget, 2,
/* 31402*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                      // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31411*/          /*Scope*/ 21, /*->31433*/
/* 31412*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31414*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 31416*/            OPC_CheckType, MVT::i32,
/* 31418*/            OPC_EmitMergeInputChains1_0,
/* 31419*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31422*/            OPC_EmitConvertToTarget, 2,
/* 31424*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                      // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31433*/          /*Scope*/ 21, /*->31455*/
/* 31434*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31436*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 31438*/            OPC_CheckType, MVT::i64,
/* 31440*/            OPC_EmitMergeInputChains1_0,
/* 31441*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31444*/            OPC_EmitConvertToTarget, 2,
/* 31446*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                      // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31455*/          /*Scope*/ 21, /*->31477*/
/* 31456*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31458*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 31460*/            OPC_CheckType, MVT::i64,
/* 31462*/            OPC_EmitMergeInputChains1_0,
/* 31463*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31466*/            OPC_EmitConvertToTarget, 2,
/* 31468*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                      // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31477*/          /*Scope*/ 21, /*->31499*/
/* 31478*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31480*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 31482*/            OPC_CheckType, MVT::i64,
/* 31484*/            OPC_EmitMergeInputChains1_0,
/* 31485*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31488*/            OPC_EmitConvertToTarget, 2,
/* 31490*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                      // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31499*/          /*Scope*/ 21, /*->31521*/
/* 31500*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31502*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 31504*/            OPC_CheckType, MVT::i64,
/* 31506*/            OPC_EmitMergeInputChains1_0,
/* 31507*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31510*/            OPC_EmitConvertToTarget, 2,
/* 31512*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                      // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31521*/          /*Scope*/ 21, /*->31543*/
/* 31522*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 31524*/            OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 31526*/            OPC_CheckType, MVT::i64,
/* 31528*/            OPC_EmitMergeInputChains1_0,
/* 31529*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31532*/            OPC_EmitConvertToTarget, 2,
/* 31534*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 11
                      // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31543*/          /*Scope*/ 21, /*->31565*/
/* 31544*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 31546*/            OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 31548*/            OPC_CheckType, MVT::i64,
/* 31550*/            OPC_EmitMergeInputChains1_0,
/* 31551*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31554*/            OPC_EmitConvertToTarget, 2,
/* 31556*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 11
                      // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31565*/          /*Scope*/ 102, /*->31668*/
/* 31566*/            OPC_CheckPredicate, 16, // Predicate_extload
/* 31568*/            OPC_SwitchType /*2 cases */, 38, MVT::i32,// ->31609
/* 31571*/              OPC_Scope, 17, /*->31590*/ // 2 children in Scope
/* 31573*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 31575*/                OPC_EmitMergeInputChains1_0,
/* 31576*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31579*/                OPC_EmitConvertToTarget, 2,
/* 31581*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                          // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31590*/              /*Scope*/ 17, /*->31608*/
/* 31591*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 31593*/                OPC_EmitMergeInputChains1_0,
/* 31594*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31597*/                OPC_EmitConvertToTarget, 2,
/* 31599*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                          // Src: (ld:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                          // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31608*/              0, /*End of Scope*/
/* 31609*/            /*SwitchType*/ 56, MVT::i64,// ->31667
/* 31611*/              OPC_Scope, 17, /*->31630*/ // 3 children in Scope
/* 31613*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 31615*/                OPC_EmitMergeInputChains1_0,
/* 31616*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31619*/                OPC_EmitConvertToTarget, 2,
/* 31621*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                          // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31630*/              /*Scope*/ 17, /*->31648*/
/* 31631*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 31633*/                OPC_EmitMergeInputChains1_0,
/* 31634*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31637*/                OPC_EmitConvertToTarget, 2,
/* 31639*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                          // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31648*/              /*Scope*/ 17, /*->31666*/
/* 31649*/                OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 31651*/                OPC_EmitMergeInputChains1_0,
/* 31652*/                OPC_EmitInteger, MVT::i32, 0, 
/* 31655*/                OPC_EmitConvertToTarget, 2,
/* 31657*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                          // Src: (ld:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 11
                          // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31666*/              0, /*End of Scope*/
/* 31667*/            0, // EndSwitchType
/* 31668*/          0, /*End of Scope*/
/* 31669*/        0, /*End of Scope*/
/* 31670*/      /*SwitchOpcode*/ 122|128,2/*378*/, TARGET_VAL(ISD::OR),// ->32052
/* 31674*/        OPC_RecordChild0, // #1 = $addr
/* 31675*/        OPC_RecordChild1, // #2 = $off
/* 31676*/        OPC_MoveChild1,
/* 31677*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 31680*/        OPC_MoveParent,
/* 31681*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 31683*/        OPC_CheckType, MVT::i32,
/* 31685*/        OPC_MoveParent,
/* 31686*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 31688*/        OPC_Scope, 38, /*->31728*/ // 12 children in Scope
/* 31690*/          OPC_CheckPredicate, 10, // Predicate_load
/* 31692*/          OPC_SwitchType /*2 cases */, 15, MVT::i32,// ->31710
/* 31695*/            OPC_EmitMergeInputChains1_0,
/* 31696*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31699*/            OPC_EmitConvertToTarget, 2,
/* 31701*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31710*/          /*SwitchType*/ 15, MVT::i64,// ->31727
/* 31712*/            OPC_EmitMergeInputChains1_0,
/* 31713*/            OPC_EmitInteger, MVT::i32, 0, 
/* 31716*/            OPC_EmitConvertToTarget, 2,
/* 31718*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31727*/          0, // EndSwitchType
/* 31728*/        /*Scope*/ 21, /*->31750*/
/* 31729*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 31731*/          OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 31733*/          OPC_CheckType, MVT::i32,
/* 31735*/          OPC_EmitMergeInputChains1_0,
/* 31736*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31739*/          OPC_EmitConvertToTarget, 2,
/* 31741*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                    // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31750*/        /*Scope*/ 21, /*->31772*/
/* 31751*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 31753*/          OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 31755*/          OPC_CheckType, MVT::i32,
/* 31757*/          OPC_EmitMergeInputChains1_0,
/* 31758*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31761*/          OPC_EmitConvertToTarget, 2,
/* 31763*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                    // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31772*/        /*Scope*/ 21, /*->31794*/
/* 31773*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 31775*/          OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 31777*/          OPC_CheckType, MVT::i32,
/* 31779*/          OPC_EmitMergeInputChains1_0,
/* 31780*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31783*/          OPC_EmitConvertToTarget, 2,
/* 31785*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                    // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31794*/        /*Scope*/ 21, /*->31816*/
/* 31795*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 31797*/          OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 31799*/          OPC_CheckType, MVT::i32,
/* 31801*/          OPC_EmitMergeInputChains1_0,
/* 31802*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31805*/          OPC_EmitConvertToTarget, 2,
/* 31807*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                    // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31816*/        /*Scope*/ 21, /*->31838*/
/* 31817*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 31819*/          OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 31821*/          OPC_CheckType, MVT::i64,
/* 31823*/          OPC_EmitMergeInputChains1_0,
/* 31824*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31827*/          OPC_EmitConvertToTarget, 2,
/* 31829*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 11
                    // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31838*/        /*Scope*/ 21, /*->31860*/
/* 31839*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 31841*/          OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 31843*/          OPC_CheckType, MVT::i64,
/* 31845*/          OPC_EmitMergeInputChains1_0,
/* 31846*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31849*/          OPC_EmitConvertToTarget, 2,
/* 31851*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 11
                    // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31860*/        /*Scope*/ 21, /*->31882*/
/* 31861*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 31863*/          OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 31865*/          OPC_CheckType, MVT::i64,
/* 31867*/          OPC_EmitMergeInputChains1_0,
/* 31868*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31871*/          OPC_EmitConvertToTarget, 2,
/* 31873*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 11
                    // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31882*/        /*Scope*/ 21, /*->31904*/
/* 31883*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 31885*/          OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 31887*/          OPC_CheckType, MVT::i64,
/* 31889*/          OPC_EmitMergeInputChains1_0,
/* 31890*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31893*/          OPC_EmitConvertToTarget, 2,
/* 31895*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 11
                    // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31904*/        /*Scope*/ 21, /*->31926*/
/* 31905*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 31907*/          OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 31909*/          OPC_CheckType, MVT::i64,
/* 31911*/          OPC_EmitMergeInputChains1_0,
/* 31912*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31915*/          OPC_EmitConvertToTarget, 2,
/* 31917*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 11
                    // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31926*/        /*Scope*/ 21, /*->31948*/
/* 31927*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 31929*/          OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 31931*/          OPC_CheckType, MVT::i64,
/* 31933*/          OPC_EmitMergeInputChains1_0,
/* 31934*/          OPC_EmitInteger, MVT::i32, 0, 
/* 31937*/          OPC_EmitConvertToTarget, 2,
/* 31939*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 11
                    // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31948*/        /*Scope*/ 102, /*->32051*/
/* 31949*/          OPC_CheckPredicate, 16, // Predicate_extload
/* 31951*/          OPC_SwitchType /*2 cases */, 38, MVT::i32,// ->31992
/* 31954*/            OPC_Scope, 17, /*->31973*/ // 2 children in Scope
/* 31956*/              OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 31958*/              OPC_EmitMergeInputChains1_0,
/* 31959*/              OPC_EmitInteger, MVT::i32, 0, 
/* 31962*/              OPC_EmitConvertToTarget, 2,
/* 31964*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                        // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31973*/            /*Scope*/ 17, /*->31991*/
/* 31974*/              OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 31976*/              OPC_EmitMergeInputChains1_0,
/* 31977*/              OPC_EmitInteger, MVT::i32, 0, 
/* 31980*/              OPC_EmitConvertToTarget, 2,
/* 31982*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (ld:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                        // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 31991*/            0, /*End of Scope*/
/* 31992*/          /*SwitchType*/ 56, MVT::i64,// ->32050
/* 31994*/            OPC_Scope, 17, /*->32013*/ // 3 children in Scope
/* 31996*/              OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 31998*/              OPC_EmitMergeInputChains1_0,
/* 31999*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32002*/              OPC_EmitConvertToTarget, 2,
/* 32004*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 11
                        // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 32013*/            /*Scope*/ 17, /*->32031*/
/* 32014*/              OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 32016*/              OPC_EmitMergeInputChains1_0,
/* 32017*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32020*/              OPC_EmitConvertToTarget, 2,
/* 32022*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 11
                        // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 32031*/            /*Scope*/ 17, /*->32049*/
/* 32032*/              OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 32034*/              OPC_EmitMergeInputChains1_0,
/* 32035*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32038*/              OPC_EmitConvertToTarget, 2,
/* 32040*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (ld:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 11
                        // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 32049*/            0, /*End of Scope*/
/* 32050*/          0, // EndSwitchType
/* 32051*/        0, /*End of Scope*/
/* 32052*/      /*SwitchOpcode*/ 126|128,7/*1022*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->33078
/* 32056*/        OPC_RecordChild0, // #1 = $off
/* 32057*/        OPC_MoveChild0,
/* 32058*/        OPC_SwitchOpcode /*2 cases */, 121|128,3/*505*/, TARGET_VAL(ISD::TargetGlobalAddress),// ->32568
/* 32063*/          OPC_MoveParent,
/* 32064*/          OPC_MoveParent,
/* 32065*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 32067*/          OPC_Scope, 54, /*->32123*/ // 12 children in Scope
/* 32069*/            OPC_CheckPredicate, 10, // Predicate_load
/* 32071*/            OPC_SwitchType /*2 cases */, 23, MVT::i32,// ->32097
/* 32074*/              OPC_EmitMergeInputChains1_0,
/* 32075*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32078*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32081*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32088*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                        // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32097*/            /*SwitchType*/ 23, MVT::i64,// ->32122
/* 32099*/              OPC_EmitMergeInputChains1_0,
/* 32100*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32103*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32106*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32113*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                        // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32122*/            0, // EndSwitchType
/* 32123*/          /*Scope*/ 29, /*->32153*/
/* 32124*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32126*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 32128*/            OPC_CheckType, MVT::i32,
/* 32130*/            OPC_EmitMergeInputChains1_0,
/* 32131*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32134*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32137*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32144*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32153*/          /*Scope*/ 29, /*->32183*/
/* 32154*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32156*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 32158*/            OPC_CheckType, MVT::i32,
/* 32160*/            OPC_EmitMergeInputChains1_0,
/* 32161*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32164*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32167*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32174*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32183*/          /*Scope*/ 29, /*->32213*/
/* 32184*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32186*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 32188*/            OPC_CheckType, MVT::i32,
/* 32190*/            OPC_EmitMergeInputChains1_0,
/* 32191*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32194*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32197*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32204*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32213*/          /*Scope*/ 29, /*->32243*/
/* 32214*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32216*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 32218*/            OPC_CheckType, MVT::i32,
/* 32220*/            OPC_EmitMergeInputChains1_0,
/* 32221*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32224*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32227*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32234*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32243*/          /*Scope*/ 29, /*->32273*/
/* 32244*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32246*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 32248*/            OPC_CheckType, MVT::i64,
/* 32250*/            OPC_EmitMergeInputChains1_0,
/* 32251*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32254*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32257*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32264*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32273*/          /*Scope*/ 29, /*->32303*/
/* 32274*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32276*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 32278*/            OPC_CheckType, MVT::i64,
/* 32280*/            OPC_EmitMergeInputChains1_0,
/* 32281*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32284*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32287*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32294*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32303*/          /*Scope*/ 29, /*->32333*/
/* 32304*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32306*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 32308*/            OPC_CheckType, MVT::i64,
/* 32310*/            OPC_EmitMergeInputChains1_0,
/* 32311*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32314*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32317*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32324*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32333*/          /*Scope*/ 29, /*->32363*/
/* 32334*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32336*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 32338*/            OPC_CheckType, MVT::i64,
/* 32340*/            OPC_EmitMergeInputChains1_0,
/* 32341*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32344*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32347*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32354*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32363*/          /*Scope*/ 29, /*->32393*/
/* 32364*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32366*/            OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 32368*/            OPC_CheckType, MVT::i64,
/* 32370*/            OPC_EmitMergeInputChains1_0,
/* 32371*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32374*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32377*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32384*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 10
                      // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32393*/          /*Scope*/ 29, /*->32423*/
/* 32394*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32396*/            OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 32398*/            OPC_CheckType, MVT::i64,
/* 32400*/            OPC_EmitMergeInputChains1_0,
/* 32401*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32404*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32407*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32414*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 10
                      // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32423*/          /*Scope*/ 14|128,1/*142*/, /*->32567*/
/* 32425*/            OPC_CheckPredicate, 16, // Predicate_extload
/* 32427*/            OPC_SwitchType /*2 cases */, 54, MVT::i32,// ->32484
/* 32430*/              OPC_Scope, 25, /*->32457*/ // 2 children in Scope
/* 32432*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 32434*/                OPC_EmitMergeInputChains1_0,
/* 32435*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32438*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32441*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32448*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                          // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32457*/              /*Scope*/ 25, /*->32483*/
/* 32458*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 32460*/                OPC_EmitMergeInputChains1_0,
/* 32461*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32464*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32467*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32474*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                          // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32483*/              0, /*End of Scope*/
/* 32484*/            /*SwitchType*/ 80, MVT::i64,// ->32566
/* 32486*/              OPC_Scope, 25, /*->32513*/ // 3 children in Scope
/* 32488*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 32490*/                OPC_EmitMergeInputChains1_0,
/* 32491*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32494*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32497*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32504*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                          // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32513*/              /*Scope*/ 25, /*->32539*/
/* 32514*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 32516*/                OPC_EmitMergeInputChains1_0,
/* 32517*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32520*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32523*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32530*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                          // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32539*/              /*Scope*/ 25, /*->32565*/
/* 32540*/                OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 32542*/                OPC_EmitMergeInputChains1_0,
/* 32543*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32546*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32549*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32556*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 10
                          // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32565*/              0, /*End of Scope*/
/* 32566*/            0, // EndSwitchType
/* 32567*/          0, /*End of Scope*/
/* 32568*/        /*SwitchOpcode*/ 121|128,3/*505*/, TARGET_VAL(ISD::TargetExternalSymbol),// ->33077
/* 32572*/          OPC_MoveParent,
/* 32573*/          OPC_MoveParent,
/* 32574*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 32576*/          OPC_Scope, 54, /*->32632*/ // 12 children in Scope
/* 32578*/            OPC_CheckPredicate, 10, // Predicate_load
/* 32580*/            OPC_SwitchType /*2 cases */, 23, MVT::i32,// ->32606
/* 32583*/              OPC_EmitMergeInputChains1_0,
/* 32584*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32587*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32590*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32597*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                        // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32606*/            /*SwitchType*/ 23, MVT::i64,// ->32631
/* 32608*/              OPC_EmitMergeInputChains1_0,
/* 32609*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32612*/              OPC_EmitInteger, MVT::i32, 0, 
/* 32615*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32622*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                        // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32631*/            0, // EndSwitchType
/* 32632*/          /*Scope*/ 29, /*->32662*/
/* 32633*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32635*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 32637*/            OPC_CheckType, MVT::i32,
/* 32639*/            OPC_EmitMergeInputChains1_0,
/* 32640*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32643*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32646*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32653*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32662*/          /*Scope*/ 29, /*->32692*/
/* 32663*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32665*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 32667*/            OPC_CheckType, MVT::i32,
/* 32669*/            OPC_EmitMergeInputChains1_0,
/* 32670*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32673*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32676*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32683*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32692*/          /*Scope*/ 29, /*->32722*/
/* 32693*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32695*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 32697*/            OPC_CheckType, MVT::i32,
/* 32699*/            OPC_EmitMergeInputChains1_0,
/* 32700*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32703*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32706*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32713*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32722*/          /*Scope*/ 29, /*->32752*/
/* 32723*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32725*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 32727*/            OPC_CheckType, MVT::i32,
/* 32729*/            OPC_EmitMergeInputChains1_0,
/* 32730*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32733*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32736*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32743*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32752*/          /*Scope*/ 29, /*->32782*/
/* 32753*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32755*/            OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 32757*/            OPC_CheckType, MVT::i64,
/* 32759*/            OPC_EmitMergeInputChains1_0,
/* 32760*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32763*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32766*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32773*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32782*/          /*Scope*/ 29, /*->32812*/
/* 32783*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32785*/            OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 32787*/            OPC_CheckType, MVT::i64,
/* 32789*/            OPC_EmitMergeInputChains1_0,
/* 32790*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32793*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32796*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32803*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 10
                      // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32812*/          /*Scope*/ 29, /*->32842*/
/* 32813*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32815*/            OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 32817*/            OPC_CheckType, MVT::i64,
/* 32819*/            OPC_EmitMergeInputChains1_0,
/* 32820*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32823*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32826*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32833*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32842*/          /*Scope*/ 29, /*->32872*/
/* 32843*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32845*/            OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 32847*/            OPC_CheckType, MVT::i64,
/* 32849*/            OPC_EmitMergeInputChains1_0,
/* 32850*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32853*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32856*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32863*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 10
                      // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32872*/          /*Scope*/ 29, /*->32902*/
/* 32873*/            OPC_CheckPredicate, 11, // Predicate_sextload
/* 32875*/            OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 32877*/            OPC_CheckType, MVT::i64,
/* 32879*/            OPC_EmitMergeInputChains1_0,
/* 32880*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32883*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32886*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32893*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 10
                      // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32902*/          /*Scope*/ 29, /*->32932*/
/* 32903*/            OPC_CheckPredicate, 13, // Predicate_zextload
/* 32905*/            OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 32907*/            OPC_CheckType, MVT::i64,
/* 32909*/            OPC_EmitMergeInputChains1_0,
/* 32910*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32913*/            OPC_EmitInteger, MVT::i32, 0, 
/* 32916*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32923*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 10
                      // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32932*/          /*Scope*/ 14|128,1/*142*/, /*->33076*/
/* 32934*/            OPC_CheckPredicate, 16, // Predicate_extload
/* 32936*/            OPC_SwitchType /*2 cases */, 54, MVT::i32,// ->32993
/* 32939*/              OPC_Scope, 25, /*->32966*/ // 2 children in Scope
/* 32941*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 32943*/                OPC_EmitMergeInputChains1_0,
/* 32944*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32947*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32950*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32957*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                          // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32966*/              /*Scope*/ 25, /*->32992*/
/* 32967*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 32969*/                OPC_EmitMergeInputChains1_0,
/* 32970*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32973*/                OPC_EmitInteger, MVT::i32, 0, 
/* 32976*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 32983*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                          // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 32992*/              0, /*End of Scope*/
/* 32993*/            /*SwitchType*/ 80, MVT::i64,// ->33075
/* 32995*/              OPC_Scope, 25, /*->33022*/ // 3 children in Scope
/* 32997*/                OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 32999*/                OPC_EmitMergeInputChains1_0,
/* 33000*/                OPC_EmitInteger, MVT::i32, 0, 
/* 33003*/                OPC_EmitInteger, MVT::i32, 0, 
/* 33006*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 33013*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 10
                          // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33022*/              /*Scope*/ 25, /*->33048*/
/* 33023*/                OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 33025*/                OPC_EmitMergeInputChains1_0,
/* 33026*/                OPC_EmitInteger, MVT::i32, 0, 
/* 33029*/                OPC_EmitInteger, MVT::i32, 0, 
/* 33032*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 33039*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 10
                          // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33048*/              /*Scope*/ 25, /*->33074*/
/* 33049*/                OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 33051*/                OPC_EmitMergeInputChains1_0,
/* 33052*/                OPC_EmitInteger, MVT::i32, 0, 
/* 33055*/                OPC_EmitInteger, MVT::i32, 0, 
/* 33058*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 33065*/                OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                          // Src: (ld:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 10
                          // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33074*/              0, /*End of Scope*/
/* 33075*/            0, // EndSwitchType
/* 33076*/          0, /*End of Scope*/
/* 33077*/        0, // EndSwitchOpcode
/* 33078*/      0, // EndSwitchOpcode
/* 33079*/    /*Scope*/ 38|128,7/*934*/, /*->34015*/
/* 33081*/      OPC_RecordChild1, // #1 = $off
/* 33082*/      OPC_Scope, 30|128,4/*542*/, /*->33627*/ // 2 children in Scope
/* 33085*/        OPC_MoveChild1,
/* 33086*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 33089*/        OPC_MoveParent,
/* 33090*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 33092*/        OPC_Scope, 58, /*->33152*/ // 12 children in Scope
/* 33094*/          OPC_CheckPredicate, 10, // Predicate_load
/* 33096*/          OPC_SwitchType /*2 cases */, 25, MVT::i32,// ->33124
/* 33099*/            OPC_EmitMergeInputChains1_0,
/* 33100*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33103*/            OPC_EmitConvertToTarget, 1,
/* 33105*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33108*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33115*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                      // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                      // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33124*/          /*SwitchType*/ 25, MVT::i64,// ->33151
/* 33126*/            OPC_EmitMergeInputChains1_0,
/* 33127*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33130*/            OPC_EmitConvertToTarget, 1,
/* 33132*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33135*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33142*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                      // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                      // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33151*/          0, // EndSwitchType
/* 33152*/        /*Scope*/ 31, /*->33184*/
/* 33153*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33155*/          OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 33157*/          OPC_CheckType, MVT::i32,
/* 33159*/          OPC_EmitMergeInputChains1_0,
/* 33160*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33163*/          OPC_EmitConvertToTarget, 1,
/* 33165*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33168*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33175*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 7
                    // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33184*/        /*Scope*/ 31, /*->33216*/
/* 33185*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33187*/          OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 33189*/          OPC_CheckType, MVT::i32,
/* 33191*/          OPC_EmitMergeInputChains1_0,
/* 33192*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33195*/          OPC_EmitConvertToTarget, 1,
/* 33197*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33200*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33207*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 7
                    // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33216*/        /*Scope*/ 31, /*->33248*/
/* 33217*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33219*/          OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 33221*/          OPC_CheckType, MVT::i32,
/* 33223*/          OPC_EmitMergeInputChains1_0,
/* 33224*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33227*/          OPC_EmitConvertToTarget, 1,
/* 33229*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33232*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33239*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 7
                    // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33248*/        /*Scope*/ 31, /*->33280*/
/* 33249*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33251*/          OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 33253*/          OPC_CheckType, MVT::i32,
/* 33255*/          OPC_EmitMergeInputChains1_0,
/* 33256*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33259*/          OPC_EmitConvertToTarget, 1,
/* 33261*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33264*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33271*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 7
                    // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33280*/        /*Scope*/ 31, /*->33312*/
/* 33281*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33283*/          OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 33285*/          OPC_CheckType, MVT::i64,
/* 33287*/          OPC_EmitMergeInputChains1_0,
/* 33288*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33291*/          OPC_EmitConvertToTarget, 1,
/* 33293*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33296*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33303*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 7
                    // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33312*/        /*Scope*/ 31, /*->33344*/
/* 33313*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33315*/          OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 33317*/          OPC_CheckType, MVT::i64,
/* 33319*/          OPC_EmitMergeInputChains1_0,
/* 33320*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33323*/          OPC_EmitConvertToTarget, 1,
/* 33325*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33328*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33335*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 7
                    // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33344*/        /*Scope*/ 31, /*->33376*/
/* 33345*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33347*/          OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 33349*/          OPC_CheckType, MVT::i64,
/* 33351*/          OPC_EmitMergeInputChains1_0,
/* 33352*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33355*/          OPC_EmitConvertToTarget, 1,
/* 33357*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33360*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33367*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 7
                    // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33376*/        /*Scope*/ 31, /*->33408*/
/* 33377*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33379*/          OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 33381*/          OPC_CheckType, MVT::i64,
/* 33383*/          OPC_EmitMergeInputChains1_0,
/* 33384*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33387*/          OPC_EmitConvertToTarget, 1,
/* 33389*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33392*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33399*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 7
                    // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33408*/        /*Scope*/ 31, /*->33440*/
/* 33409*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33411*/          OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 33413*/          OPC_CheckType, MVT::i64,
/* 33415*/          OPC_EmitMergeInputChains1_0,
/* 33416*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33419*/          OPC_EmitConvertToTarget, 1,
/* 33421*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33424*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33431*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 7
                    // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33440*/        /*Scope*/ 31, /*->33472*/
/* 33441*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33443*/          OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 33445*/          OPC_CheckType, MVT::i64,
/* 33447*/          OPC_EmitMergeInputChains1_0,
/* 33448*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33451*/          OPC_EmitConvertToTarget, 1,
/* 33453*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33456*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33463*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 7
                    // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33472*/        /*Scope*/ 24|128,1/*152*/, /*->33626*/
/* 33474*/          OPC_CheckPredicate, 16, // Predicate_extload
/* 33476*/          OPC_SwitchType /*2 cases */, 58, MVT::i32,// ->33537
/* 33479*/            OPC_Scope, 27, /*->33508*/ // 2 children in Scope
/* 33481*/              OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 33483*/              OPC_EmitMergeInputChains1_0,
/* 33484*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33487*/              OPC_EmitConvertToTarget, 1,
/* 33489*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33492*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33499*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                        // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 7
                        // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33508*/            /*Scope*/ 27, /*->33536*/
/* 33509*/              OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 33511*/              OPC_EmitMergeInputChains1_0,
/* 33512*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33515*/              OPC_EmitConvertToTarget, 1,
/* 33517*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33520*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33527*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                        // Src: (ld:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 7
                        // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33536*/            0, /*End of Scope*/
/* 33537*/          /*SwitchType*/ 86, MVT::i64,// ->33625
/* 33539*/            OPC_Scope, 27, /*->33568*/ // 3 children in Scope
/* 33541*/              OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 33543*/              OPC_EmitMergeInputChains1_0,
/* 33544*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33547*/              OPC_EmitConvertToTarget, 1,
/* 33549*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33552*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33559*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                        // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 7
                        // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33568*/            /*Scope*/ 27, /*->33596*/
/* 33569*/              OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 33571*/              OPC_EmitMergeInputChains1_0,
/* 33572*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33575*/              OPC_EmitConvertToTarget, 1,
/* 33577*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33580*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33587*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                        // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 7
                        // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33596*/            /*Scope*/ 27, /*->33624*/
/* 33597*/              OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 33599*/              OPC_EmitMergeInputChains1_0,
/* 33600*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33603*/              OPC_EmitConvertToTarget, 1,
/* 33605*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33608*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 33615*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                        // Src: (ld:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 7
                        // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 33624*/            0, /*End of Scope*/
/* 33625*/          0, // EndSwitchType
/* 33626*/        0, /*End of Scope*/
/* 33627*/      /*Scope*/ 1|128,3/*385*/, /*->34014*/
/* 33629*/        OPC_CheckChild1Type, MVT::i32,
/* 33631*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 33633*/        OPC_Scope, 40, /*->33675*/ // 12 children in Scope
/* 33635*/          OPC_CheckPredicate, 10, // Predicate_load
/* 33637*/          OPC_SwitchType /*2 cases */, 16, MVT::i32,// ->33656
/* 33640*/            OPC_EmitMergeInputChains1_0,
/* 33641*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33644*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33647*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                      // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                      // Dst: (LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33656*/          /*SwitchType*/ 16, MVT::i64,// ->33674
/* 33658*/            OPC_EmitMergeInputChains1_0,
/* 33659*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33662*/            OPC_EmitInteger, MVT::i32, 0, 
/* 33665*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                      // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                      // Dst: (LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33674*/          0, // EndSwitchType
/* 33675*/        /*Scope*/ 22, /*->33698*/
/* 33676*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33678*/          OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 33680*/          OPC_CheckType, MVT::i32,
/* 33682*/          OPC_EmitMergeInputChains1_0,
/* 33683*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33686*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33689*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 4
                    // Dst: (LOAD8_S_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33698*/        /*Scope*/ 22, /*->33721*/
/* 33699*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33701*/          OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 33703*/          OPC_CheckType, MVT::i32,
/* 33705*/          OPC_EmitMergeInputChains1_0,
/* 33706*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33709*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33712*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 4
                    // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33721*/        /*Scope*/ 22, /*->33744*/
/* 33722*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33724*/          OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 33726*/          OPC_CheckType, MVT::i32,
/* 33728*/          OPC_EmitMergeInputChains1_0,
/* 33729*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33732*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33735*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 4
                    // Dst: (LOAD16_S_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33744*/        /*Scope*/ 22, /*->33767*/
/* 33745*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33747*/          OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 33749*/          OPC_CheckType, MVT::i32,
/* 33751*/          OPC_EmitMergeInputChains1_0,
/* 33752*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33755*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33758*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 4
                    // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33767*/        /*Scope*/ 22, /*->33790*/
/* 33768*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33770*/          OPC_CheckPredicate, 12, // Predicate_sextloadi8
/* 33772*/          OPC_CheckType, MVT::i64,
/* 33774*/          OPC_EmitMergeInputChains1_0,
/* 33775*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33778*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33781*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 4
                    // Dst: (LOAD8_S_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33790*/        /*Scope*/ 22, /*->33813*/
/* 33791*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33793*/          OPC_CheckPredicate, 12, // Predicate_zextloadi8
/* 33795*/          OPC_CheckType, MVT::i64,
/* 33797*/          OPC_EmitMergeInputChains1_0,
/* 33798*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33801*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33804*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 4
                    // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33813*/        /*Scope*/ 22, /*->33836*/
/* 33814*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33816*/          OPC_CheckPredicate, 14, // Predicate_sextloadi16
/* 33818*/          OPC_CheckType, MVT::i64,
/* 33820*/          OPC_EmitMergeInputChains1_0,
/* 33821*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33824*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33827*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 4
                    // Dst: (LOAD16_S_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33836*/        /*Scope*/ 22, /*->33859*/
/* 33837*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33839*/          OPC_CheckPredicate, 14, // Predicate_zextloadi16
/* 33841*/          OPC_CheckType, MVT::i64,
/* 33843*/          OPC_EmitMergeInputChains1_0,
/* 33844*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33847*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33850*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 4
                    // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33859*/        /*Scope*/ 22, /*->33882*/
/* 33860*/          OPC_CheckPredicate, 11, // Predicate_sextload
/* 33862*/          OPC_CheckPredicate, 15, // Predicate_sextloadi32
/* 33864*/          OPC_CheckType, MVT::i64,
/* 33866*/          OPC_EmitMergeInputChains1_0,
/* 33867*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33870*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33873*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 4
                    // Dst: (LOAD32_S_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33882*/        /*Scope*/ 22, /*->33905*/
/* 33883*/          OPC_CheckPredicate, 13, // Predicate_zextload
/* 33885*/          OPC_CheckPredicate, 15, // Predicate_zextloadi32
/* 33887*/          OPC_CheckType, MVT::i64,
/* 33889*/          OPC_EmitMergeInputChains1_0,
/* 33890*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33893*/          OPC_EmitInteger, MVT::i32, 0, 
/* 33896*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 4
                    // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33905*/        /*Scope*/ 107, /*->34013*/
/* 33906*/          OPC_CheckPredicate, 16, // Predicate_extload
/* 33908*/          OPC_SwitchType /*2 cases */, 40, MVT::i32,// ->33951
/* 33911*/            OPC_Scope, 18, /*->33931*/ // 2 children in Scope
/* 33913*/              OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 33915*/              OPC_EmitMergeInputChains1_0,
/* 33916*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33919*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33922*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                        // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 4
                        // Dst: (LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33931*/            /*Scope*/ 18, /*->33950*/
/* 33932*/              OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 33934*/              OPC_EmitMergeInputChains1_0,
/* 33935*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33938*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33941*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                        // Src: (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 4
                        // Dst: (LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33950*/            0, /*End of Scope*/
/* 33951*/          /*SwitchType*/ 59, MVT::i64,// ->34012
/* 33953*/            OPC_Scope, 18, /*->33973*/ // 3 children in Scope
/* 33955*/              OPC_CheckPredicate, 12, // Predicate_extloadi8
/* 33957*/              OPC_EmitMergeInputChains1_0,
/* 33958*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33961*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33964*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                        // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 4
                        // Dst: (LOAD8_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33973*/            /*Scope*/ 18, /*->33992*/
/* 33974*/              OPC_CheckPredicate, 14, // Predicate_extloadi16
/* 33976*/              OPC_EmitMergeInputChains1_0,
/* 33977*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33980*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33983*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                        // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 4
                        // Dst: (LOAD16_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 33992*/            /*Scope*/ 18, /*->34011*/
/* 33993*/              OPC_CheckPredicate, 15, // Predicate_extloadi32
/* 33995*/              OPC_EmitMergeInputChains1_0,
/* 33996*/              OPC_EmitInteger, MVT::i32, 0, 
/* 33999*/              OPC_EmitInteger, MVT::i32, 0, 
/* 34002*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                        // Src: (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 4
                        // Dst: (LOAD32_U_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 34011*/            0, /*End of Scope*/
/* 34012*/          0, // EndSwitchType
/* 34013*/        0, /*End of Scope*/
/* 34014*/      0, /*End of Scope*/
/* 34015*/    /*Scope*/ 74|128,3/*458*/, /*->34475*/
/* 34017*/      OPC_MoveChild1,
/* 34018*/      OPC_SwitchOpcode /*3 cases */, 11|128,2/*267*/, TARGET_VAL(ISD::ADD),// ->34290
/* 34023*/        OPC_Scope, 53, /*->34078*/ // 5 children in Scope
/* 34025*/          OPC_RecordChild0, // #1 = $addr
/* 34026*/          OPC_MoveChild1,
/* 34027*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34030*/          OPC_RecordChild0, // #2 = $off
/* 34031*/          OPC_MoveChild0,
/* 34032*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 34035*/          OPC_MoveParent,
/* 34036*/          OPC_MoveParent,
/* 34037*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 34039*/          OPC_CheckType, MVT::i32,
/* 34041*/          OPC_MoveParent,
/* 34042*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34044*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34046*/          OPC_SwitchType /*2 cases */, 13, MVT::f32,// ->34062
/* 34049*/            OPC_EmitMergeInputChains1_0,
/* 34050*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34053*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34062*/          /*SwitchType*/ 13, MVT::f64,// ->34077
/* 34064*/            OPC_EmitMergeInputChains1_0,
/* 34065*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34068*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34077*/          0, // EndSwitchType
/* 34078*/        /*Scope*/ 53, /*->34132*/
/* 34079*/          OPC_MoveChild0,
/* 34080*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34083*/          OPC_RecordChild0, // #1 = $off
/* 34084*/          OPC_MoveChild0,
/* 34085*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 34088*/          OPC_MoveParent,
/* 34089*/          OPC_MoveParent,
/* 34090*/          OPC_RecordChild1, // #2 = $addr
/* 34091*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 34093*/          OPC_CheckType, MVT::i32,
/* 34095*/          OPC_MoveParent,
/* 34096*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34098*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34100*/          OPC_SwitchType /*2 cases */, 13, MVT::f32,// ->34116
/* 34103*/            OPC_EmitMergeInputChains1_0,
/* 34104*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34107*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[f32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34116*/          /*SwitchType*/ 13, MVT::f64,// ->34131
/* 34118*/            OPC_EmitMergeInputChains1_0,
/* 34119*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34122*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[f64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34131*/          0, // EndSwitchType
/* 34132*/        /*Scope*/ 51, /*->34184*/
/* 34133*/          OPC_RecordChild0, // #1 = $addr
/* 34134*/          OPC_MoveChild1,
/* 34135*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34138*/          OPC_RecordChild0, // #2 = $off
/* 34139*/          OPC_MoveChild0,
/* 34140*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 34143*/          OPC_MoveParent,
/* 34144*/          OPC_MoveParent,
/* 34145*/          OPC_CheckType, MVT::i32,
/* 34147*/          OPC_MoveParent,
/* 34148*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34150*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34152*/          OPC_SwitchType /*2 cases */, 13, MVT::f32,// ->34168
/* 34155*/            OPC_EmitMergeInputChains1_0,
/* 34156*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34159*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34168*/          /*SwitchType*/ 13, MVT::f64,// ->34183
/* 34170*/            OPC_EmitMergeInputChains1_0,
/* 34171*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34174*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34183*/          0, // EndSwitchType
/* 34184*/        /*Scope*/ 51, /*->34236*/
/* 34185*/          OPC_MoveChild0,
/* 34186*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34189*/          OPC_RecordChild0, // #1 = $off
/* 34190*/          OPC_MoveChild0,
/* 34191*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 34194*/          OPC_MoveParent,
/* 34195*/          OPC_MoveParent,
/* 34196*/          OPC_RecordChild1, // #2 = $addr
/* 34197*/          OPC_CheckType, MVT::i32,
/* 34199*/          OPC_MoveParent,
/* 34200*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34202*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34204*/          OPC_SwitchType /*2 cases */, 13, MVT::f32,// ->34220
/* 34207*/            OPC_EmitMergeInputChains1_0,
/* 34208*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34211*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[f32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34220*/          /*SwitchType*/ 13, MVT::f64,// ->34235
/* 34222*/            OPC_EmitMergeInputChains1_0,
/* 34223*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34226*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[f64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34235*/          0, // EndSwitchType
/* 34236*/        /*Scope*/ 52, /*->34289*/
/* 34237*/          OPC_RecordChild0, // #1 = $addr
/* 34238*/          OPC_RecordChild1, // #2 = $off
/* 34239*/          OPC_MoveChild1,
/* 34240*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 34243*/          OPC_MoveParent,
/* 34244*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 34246*/          OPC_CheckType, MVT::i32,
/* 34248*/          OPC_MoveParent,
/* 34249*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34251*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34253*/          OPC_SwitchType /*2 cases */, 15, MVT::f32,// ->34271
/* 34256*/            OPC_EmitMergeInputChains1_0,
/* 34257*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34260*/            OPC_EmitConvertToTarget, 2,
/* 34262*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34271*/          /*SwitchType*/ 15, MVT::f64,// ->34288
/* 34273*/            OPC_EmitMergeInputChains1_0,
/* 34274*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34277*/            OPC_EmitConvertToTarget, 2,
/* 34279*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34288*/          0, // EndSwitchType
/* 34289*/        0, /*End of Scope*/
/* 34290*/      /*SwitchOpcode*/ 52, TARGET_VAL(ISD::OR),// ->34345
/* 34293*/        OPC_RecordChild0, // #1 = $addr
/* 34294*/        OPC_RecordChild1, // #2 = $off
/* 34295*/        OPC_MoveChild1,
/* 34296*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 34299*/        OPC_MoveParent,
/* 34300*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 34302*/        OPC_CheckType, MVT::i32,
/* 34304*/        OPC_MoveParent,
/* 34305*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34307*/        OPC_CheckPredicate, 10, // Predicate_load
/* 34309*/        OPC_SwitchType /*2 cases */, 15, MVT::f32,// ->34327
/* 34312*/          OPC_EmitMergeInputChains1_0,
/* 34313*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34316*/          OPC_EmitConvertToTarget, 2,
/* 34318*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::f32, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[f32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34327*/        /*SwitchType*/ 15, MVT::f64,// ->34344
/* 34329*/          OPC_EmitMergeInputChains1_0,
/* 34330*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34333*/          OPC_EmitConvertToTarget, 2,
/* 34335*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::f64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[f64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34344*/        0, // EndSwitchType
/* 34345*/      /*SwitchOpcode*/ 126, TARGET_VAL(WebAssemblyISD::Wrapper),// ->34474
/* 34348*/        OPC_RecordChild0, // #1 = $off
/* 34349*/        OPC_MoveChild0,
/* 34350*/        OPC_SwitchOpcode /*2 cases */, 58, TARGET_VAL(ISD::TargetGlobalAddress),// ->34412
/* 34354*/          OPC_MoveParent,
/* 34355*/          OPC_MoveParent,
/* 34356*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34358*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34360*/          OPC_SwitchType /*2 cases */, 23, MVT::f32,// ->34386
/* 34363*/            OPC_EmitMergeInputChains1_0,
/* 34364*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34367*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34370*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 34377*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 34386*/          /*SwitchType*/ 23, MVT::f64,// ->34411
/* 34388*/            OPC_EmitMergeInputChains1_0,
/* 34389*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34392*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34395*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 34402*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 34411*/          0, // EndSwitchType
/* 34412*/        /*SwitchOpcode*/ 58, TARGET_VAL(ISD::TargetExternalSymbol),// ->34473
/* 34415*/          OPC_MoveParent,
/* 34416*/          OPC_MoveParent,
/* 34417*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34419*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34421*/          OPC_SwitchType /*2 cases */, 23, MVT::f32,// ->34447
/* 34424*/            OPC_EmitMergeInputChains1_0,
/* 34425*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34428*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34431*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 34438*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[f32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 34447*/          /*SwitchType*/ 23, MVT::f64,// ->34472
/* 34449*/            OPC_EmitMergeInputChains1_0,
/* 34450*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34453*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34456*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 34463*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::f64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[f64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 34472*/          0, // EndSwitchType
/* 34473*/        0, // EndSwitchOpcode
/* 34474*/      0, // EndSwitchOpcode
/* 34475*/    /*Scope*/ 114, /*->34590*/
/* 34476*/      OPC_RecordChild1, // #1 = $off
/* 34477*/      OPC_Scope, 65, /*->34544*/ // 2 children in Scope
/* 34479*/        OPC_MoveChild1,
/* 34480*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 34483*/        OPC_MoveParent,
/* 34484*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34486*/        OPC_CheckPredicate, 10, // Predicate_load
/* 34488*/        OPC_SwitchType /*2 cases */, 25, MVT::f32,// ->34516
/* 34491*/          OPC_EmitMergeInputChains1_0,
/* 34492*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34495*/          OPC_EmitConvertToTarget, 1,
/* 34497*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34500*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 34507*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::f32, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[f32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 34516*/        /*SwitchType*/ 25, MVT::f64,// ->34543
/* 34518*/          OPC_EmitMergeInputChains1_0,
/* 34519*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34522*/          OPC_EmitConvertToTarget, 1,
/* 34524*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34527*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 34534*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::f64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[f64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 34543*/        0, // EndSwitchType
/* 34544*/      /*Scope*/ 44, /*->34589*/
/* 34545*/        OPC_CheckChild1Type, MVT::i32,
/* 34547*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34549*/        OPC_CheckPredicate, 10, // Predicate_load
/* 34551*/        OPC_SwitchType /*2 cases */, 16, MVT::f32,// ->34570
/* 34554*/          OPC_EmitMergeInputChains1_0,
/* 34555*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34558*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34561*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::f32, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_F32:{ *:[f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 34570*/        /*SwitchType*/ 16, MVT::f64,// ->34588
/* 34572*/          OPC_EmitMergeInputChains1_0,
/* 34573*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34576*/          OPC_EmitInteger, MVT::i32, 0, 
/* 34579*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::f64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_F64:{ *:[f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 34588*/        0, // EndSwitchType
/* 34589*/      0, /*End of Scope*/
/* 34590*/    /*Scope*/ 107|128,5/*747*/, /*->35339*/
/* 34592*/      OPC_MoveChild1,
/* 34593*/      OPC_SwitchOpcode /*3 cases */, 37|128,3/*421*/, TARGET_VAL(ISD::ADD),// ->35019
/* 34598*/        OPC_Scope, 83, /*->34683*/ // 5 children in Scope
/* 34600*/          OPC_RecordChild0, // #1 = $addr
/* 34601*/          OPC_MoveChild1,
/* 34602*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34605*/          OPC_RecordChild0, // #2 = $off
/* 34606*/          OPC_MoveChild0,
/* 34607*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 34610*/          OPC_MoveParent,
/* 34611*/          OPC_MoveParent,
/* 34612*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 34614*/          OPC_CheckType, MVT::i32,
/* 34616*/          OPC_MoveParent,
/* 34617*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34619*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34621*/          OPC_SwitchType /*4 cases */, 13, MVT::v16i8,// ->34637
/* 34624*/            OPC_EmitMergeInputChains1_0,
/* 34625*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34628*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v16i8, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v16i8] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34637*/          /*SwitchType*/ 13, MVT::v8i16,// ->34652
/* 34639*/            OPC_EmitMergeInputChains1_0,
/* 34640*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34643*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v8i16, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34652*/          /*SwitchType*/ 13, MVT::v4i32,// ->34667
/* 34654*/            OPC_EmitMergeInputChains1_0,
/* 34655*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34658*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34667*/          /*SwitchType*/ 13, MVT::v2i64,// ->34682
/* 34669*/            OPC_EmitMergeInputChains1_0,
/* 34670*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34673*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34682*/          0, // EndSwitchType
/* 34683*/        /*Scope*/ 83, /*->34767*/
/* 34684*/          OPC_MoveChild0,
/* 34685*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34688*/          OPC_RecordChild0, // #1 = $off
/* 34689*/          OPC_MoveChild0,
/* 34690*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 34693*/          OPC_MoveParent,
/* 34694*/          OPC_MoveParent,
/* 34695*/          OPC_RecordChild1, // #2 = $addr
/* 34696*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 34698*/          OPC_CheckType, MVT::i32,
/* 34700*/          OPC_MoveParent,
/* 34701*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34703*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34705*/          OPC_SwitchType /*4 cases */, 13, MVT::v16i8,// ->34721
/* 34708*/            OPC_EmitMergeInputChains1_0,
/* 34709*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34712*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v16i8, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v16i8] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34721*/          /*SwitchType*/ 13, MVT::v8i16,// ->34736
/* 34723*/            OPC_EmitMergeInputChains1_0,
/* 34724*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34727*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v8i16, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34736*/          /*SwitchType*/ 13, MVT::v4i32,// ->34751
/* 34738*/            OPC_EmitMergeInputChains1_0,
/* 34739*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34742*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34751*/          /*SwitchType*/ 13, MVT::v2i64,// ->34766
/* 34753*/            OPC_EmitMergeInputChains1_0,
/* 34754*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34757*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34766*/          0, // EndSwitchType
/* 34767*/        /*Scope*/ 81, /*->34849*/
/* 34768*/          OPC_RecordChild0, // #1 = $addr
/* 34769*/          OPC_MoveChild1,
/* 34770*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34773*/          OPC_RecordChild0, // #2 = $off
/* 34774*/          OPC_MoveChild0,
/* 34775*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 34778*/          OPC_MoveParent,
/* 34779*/          OPC_MoveParent,
/* 34780*/          OPC_CheckType, MVT::i32,
/* 34782*/          OPC_MoveParent,
/* 34783*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34785*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34787*/          OPC_SwitchType /*4 cases */, 13, MVT::v16i8,// ->34803
/* 34790*/            OPC_EmitMergeInputChains1_0,
/* 34791*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34794*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v16i8, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v16i8] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34803*/          /*SwitchType*/ 13, MVT::v8i16,// ->34818
/* 34805*/            OPC_EmitMergeInputChains1_0,
/* 34806*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34809*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v8i16, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34818*/          /*SwitchType*/ 13, MVT::v4i32,// ->34833
/* 34820*/            OPC_EmitMergeInputChains1_0,
/* 34821*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34824*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4i32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34833*/          /*SwitchType*/ 13, MVT::v2i64,// ->34848
/* 34835*/            OPC_EmitMergeInputChains1_0,
/* 34836*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34839*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34848*/          0, // EndSwitchType
/* 34849*/        /*Scope*/ 81, /*->34931*/
/* 34850*/          OPC_MoveChild0,
/* 34851*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 34854*/          OPC_RecordChild0, // #1 = $off
/* 34855*/          OPC_MoveChild0,
/* 34856*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 34859*/          OPC_MoveParent,
/* 34860*/          OPC_MoveParent,
/* 34861*/          OPC_RecordChild1, // #2 = $addr
/* 34862*/          OPC_CheckType, MVT::i32,
/* 34864*/          OPC_MoveParent,
/* 34865*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34867*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34869*/          OPC_SwitchType /*4 cases */, 13, MVT::v16i8,// ->34885
/* 34872*/            OPC_EmitMergeInputChains1_0,
/* 34873*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34876*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v16i8, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v16i8] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34885*/          /*SwitchType*/ 13, MVT::v8i16,// ->34900
/* 34887*/            OPC_EmitMergeInputChains1_0,
/* 34888*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34891*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v8i16, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34900*/          /*SwitchType*/ 13, MVT::v4i32,// ->34915
/* 34902*/            OPC_EmitMergeInputChains1_0,
/* 34903*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34906*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4i32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34915*/          /*SwitchType*/ 13, MVT::v2i64,// ->34930
/* 34917*/            OPC_EmitMergeInputChains1_0,
/* 34918*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34921*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34930*/          0, // EndSwitchType
/* 34931*/        /*Scope*/ 86, /*->35018*/
/* 34932*/          OPC_RecordChild0, // #1 = $addr
/* 34933*/          OPC_RecordChild1, // #2 = $off
/* 34934*/          OPC_MoveChild1,
/* 34935*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 34938*/          OPC_MoveParent,
/* 34939*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 34941*/          OPC_CheckType, MVT::i32,
/* 34943*/          OPC_MoveParent,
/* 34944*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 34946*/          OPC_CheckPredicate, 10, // Predicate_load
/* 34948*/          OPC_SwitchType /*4 cases */, 15, MVT::v16i8,// ->34966
/* 34951*/            OPC_EmitMergeInputChains1_0,
/* 34952*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34955*/            OPC_EmitConvertToTarget, 2,
/* 34957*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[v16i8] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34966*/          /*SwitchType*/ 15, MVT::v8i16,// ->34983
/* 34968*/            OPC_EmitMergeInputChains1_0,
/* 34969*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34972*/            OPC_EmitConvertToTarget, 2,
/* 34974*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[v8i16] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 34983*/          /*SwitchType*/ 15, MVT::v4i32,// ->35000
/* 34985*/            OPC_EmitMergeInputChains1_0,
/* 34986*/            OPC_EmitInteger, MVT::i32, 0, 
/* 34989*/            OPC_EmitConvertToTarget, 2,
/* 34991*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[v4i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35000*/          /*SwitchType*/ 15, MVT::v2i64,// ->35017
/* 35002*/            OPC_EmitMergeInputChains1_0,
/* 35003*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35006*/            OPC_EmitConvertToTarget, 2,
/* 35008*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[v2i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35017*/          0, // EndSwitchType
/* 35018*/        0, /*End of Scope*/
/* 35019*/      /*SwitchOpcode*/ 86, TARGET_VAL(ISD::OR),// ->35108
/* 35022*/        OPC_RecordChild0, // #1 = $addr
/* 35023*/        OPC_RecordChild1, // #2 = $off
/* 35024*/        OPC_MoveChild1,
/* 35025*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 35028*/        OPC_MoveParent,
/* 35029*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 35031*/        OPC_CheckType, MVT::i32,
/* 35033*/        OPC_MoveParent,
/* 35034*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35036*/        OPC_CheckPredicate, 10, // Predicate_load
/* 35038*/        OPC_SwitchType /*4 cases */, 15, MVT::v16i8,// ->35056
/* 35041*/          OPC_EmitMergeInputChains1_0,
/* 35042*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35045*/          OPC_EmitConvertToTarget, 2,
/* 35047*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v16i8, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[v16i8] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35056*/        /*SwitchType*/ 15, MVT::v8i16,// ->35073
/* 35058*/          OPC_EmitMergeInputChains1_0,
/* 35059*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35062*/          OPC_EmitConvertToTarget, 2,
/* 35064*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v8i16, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[v8i16] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35073*/        /*SwitchType*/ 15, MVT::v4i32,// ->35090
/* 35075*/          OPC_EmitMergeInputChains1_0,
/* 35076*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35079*/          OPC_EmitConvertToTarget, 2,
/* 35081*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v4i32, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[v4i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35090*/        /*SwitchType*/ 15, MVT::v2i64,// ->35107
/* 35092*/          OPC_EmitMergeInputChains1_0,
/* 35093*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35096*/          OPC_EmitConvertToTarget, 2,
/* 35098*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v2i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[v2i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35107*/        0, // EndSwitchType
/* 35108*/      /*SwitchOpcode*/ 98|128,1/*226*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->35338
/* 35112*/        OPC_RecordChild0, // #1 = $off
/* 35113*/        OPC_MoveChild0,
/* 35114*/        OPC_SwitchOpcode /*2 cases */, 108, TARGET_VAL(ISD::TargetGlobalAddress),// ->35226
/* 35118*/          OPC_MoveParent,
/* 35119*/          OPC_MoveParent,
/* 35120*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35122*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35124*/          OPC_SwitchType /*4 cases */, 23, MVT::v16i8,// ->35150
/* 35127*/            OPC_EmitMergeInputChains1_0,
/* 35128*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35131*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35134*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35141*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v16i8, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35150*/          /*SwitchType*/ 23, MVT::v8i16,// ->35175
/* 35152*/            OPC_EmitMergeInputChains1_0,
/* 35153*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35156*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35159*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35166*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35175*/          /*SwitchType*/ 23, MVT::v4i32,// ->35200
/* 35177*/            OPC_EmitMergeInputChains1_0,
/* 35178*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35181*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35184*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35191*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35200*/          /*SwitchType*/ 23, MVT::v2i64,// ->35225
/* 35202*/            OPC_EmitMergeInputChains1_0,
/* 35203*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35206*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35209*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35216*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35225*/          0, // EndSwitchType
/* 35226*/        /*SwitchOpcode*/ 108, TARGET_VAL(ISD::TargetExternalSymbol),// ->35337
/* 35229*/          OPC_MoveParent,
/* 35230*/          OPC_MoveParent,
/* 35231*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35233*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35235*/          OPC_SwitchType /*4 cases */, 23, MVT::v16i8,// ->35261
/* 35238*/            OPC_EmitMergeInputChains1_0,
/* 35239*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35242*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35245*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35252*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v16i8, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35261*/          /*SwitchType*/ 23, MVT::v8i16,// ->35286
/* 35263*/            OPC_EmitMergeInputChains1_0,
/* 35264*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35267*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35270*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35277*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v8i16, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35286*/          /*SwitchType*/ 23, MVT::v4i32,// ->35311
/* 35288*/            OPC_EmitMergeInputChains1_0,
/* 35289*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35292*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35295*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35302*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4i32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35311*/          /*SwitchType*/ 23, MVT::v2i64,// ->35336
/* 35313*/            OPC_EmitMergeInputChains1_0,
/* 35314*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35317*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35320*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35327*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35336*/          0, // EndSwitchType
/* 35337*/        0, // EndSwitchOpcode
/* 35338*/      0, // EndSwitchOpcode
/* 35339*/    /*Scope*/ 76|128,1/*204*/, /*->35545*/
/* 35341*/      OPC_RecordChild1, // #1 = $off
/* 35342*/      OPC_Scope, 119, /*->35463*/ // 2 children in Scope
/* 35344*/        OPC_MoveChild1,
/* 35345*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 35348*/        OPC_MoveParent,
/* 35349*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35351*/        OPC_CheckPredicate, 10, // Predicate_load
/* 35353*/        OPC_SwitchType /*4 cases */, 25, MVT::v16i8,// ->35381
/* 35356*/          OPC_EmitMergeInputChains1_0,
/* 35357*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35360*/          OPC_EmitConvertToTarget, 1,
/* 35362*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35365*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35372*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v16i8, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[v16i8] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35381*/        /*SwitchType*/ 25, MVT::v8i16,// ->35408
/* 35383*/          OPC_EmitMergeInputChains1_0,
/* 35384*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35387*/          OPC_EmitConvertToTarget, 1,
/* 35389*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35392*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35399*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v8i16, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[v8i16] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35408*/        /*SwitchType*/ 25, MVT::v4i32,// ->35435
/* 35410*/          OPC_EmitMergeInputChains1_0,
/* 35411*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35414*/          OPC_EmitConvertToTarget, 1,
/* 35416*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35419*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35426*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v4i32, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[v4i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35435*/        /*SwitchType*/ 25, MVT::v2i64,// ->35462
/* 35437*/          OPC_EmitMergeInputChains1_0,
/* 35438*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35441*/          OPC_EmitConvertToTarget, 1,
/* 35443*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35446*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 35453*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v2i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[v2i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35462*/        0, // EndSwitchType
/* 35463*/      /*Scope*/ 80, /*->35544*/
/* 35464*/        OPC_CheckChild1Type, MVT::i32,
/* 35466*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35468*/        OPC_CheckPredicate, 10, // Predicate_load
/* 35470*/        OPC_SwitchType /*4 cases */, 16, MVT::v16i8,// ->35489
/* 35473*/          OPC_EmitMergeInputChains1_0,
/* 35474*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35477*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35480*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v16i8, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[v16i8] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_v16i8:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 35489*/        /*SwitchType*/ 16, MVT::v8i16,// ->35507
/* 35491*/          OPC_EmitMergeInputChains1_0,
/* 35492*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35495*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35498*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v8i16, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[v8i16] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_v8i16:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 35507*/        /*SwitchType*/ 16, MVT::v4i32,// ->35525
/* 35509*/          OPC_EmitMergeInputChains1_0,
/* 35510*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35513*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35516*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v4i32, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[v4i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_v4i32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 35525*/        /*SwitchType*/ 16, MVT::v2i64,// ->35543
/* 35527*/          OPC_EmitMergeInputChains1_0,
/* 35528*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35531*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35534*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[v2i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_v2i64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 35543*/        0, // EndSwitchType
/* 35544*/      0, /*End of Scope*/
/* 35545*/    /*Scope*/ 74|128,3/*458*/, /*->36005*/
/* 35547*/      OPC_MoveChild1,
/* 35548*/      OPC_SwitchOpcode /*3 cases */, 11|128,2/*267*/, TARGET_VAL(ISD::ADD),// ->35820
/* 35553*/        OPC_Scope, 53, /*->35608*/ // 5 children in Scope
/* 35555*/          OPC_RecordChild0, // #1 = $addr
/* 35556*/          OPC_MoveChild1,
/* 35557*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 35560*/          OPC_RecordChild0, // #2 = $off
/* 35561*/          OPC_MoveChild0,
/* 35562*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 35565*/          OPC_MoveParent,
/* 35566*/          OPC_MoveParent,
/* 35567*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 35569*/          OPC_CheckType, MVT::i32,
/* 35571*/          OPC_MoveParent,
/* 35572*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35574*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35576*/          OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->35592
/* 35579*/            OPC_EmitMergeInputChains1_0,
/* 35580*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35583*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4f32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v4f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35592*/          /*SwitchType*/ 13, MVT::v2f64,// ->35607
/* 35594*/            OPC_EmitMergeInputChains1_0,
/* 35595*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35598*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2f64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v2f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35607*/          0, // EndSwitchType
/* 35608*/        /*Scope*/ 53, /*->35662*/
/* 35609*/          OPC_MoveChild0,
/* 35610*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 35613*/          OPC_RecordChild0, // #1 = $off
/* 35614*/          OPC_MoveChild0,
/* 35615*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 35618*/          OPC_MoveParent,
/* 35619*/          OPC_MoveParent,
/* 35620*/          OPC_RecordChild1, // #2 = $addr
/* 35621*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 35623*/          OPC_CheckType, MVT::i32,
/* 35625*/          OPC_MoveParent,
/* 35626*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35628*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35630*/          OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->35646
/* 35633*/            OPC_EmitMergeInputChains1_0,
/* 35634*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35637*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4f32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v4f32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35646*/          /*SwitchType*/ 13, MVT::v2f64,// ->35661
/* 35648*/            OPC_EmitMergeInputChains1_0,
/* 35649*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35652*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2f64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v2f64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 14
                      // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35661*/          0, // EndSwitchType
/* 35662*/        /*Scope*/ 51, /*->35714*/
/* 35663*/          OPC_RecordChild0, // #1 = $addr
/* 35664*/          OPC_MoveChild1,
/* 35665*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 35668*/          OPC_RecordChild0, // #2 = $off
/* 35669*/          OPC_MoveChild0,
/* 35670*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 35673*/          OPC_MoveParent,
/* 35674*/          OPC_MoveParent,
/* 35675*/          OPC_CheckType, MVT::i32,
/* 35677*/          OPC_MoveParent,
/* 35678*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35680*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35682*/          OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->35698
/* 35685*/            OPC_EmitMergeInputChains1_0,
/* 35686*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35689*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4f32, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v4f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35698*/          /*SwitchType*/ 13, MVT::v2f64,// ->35713
/* 35700*/            OPC_EmitMergeInputChains1_0,
/* 35701*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35704*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2f64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (ld:{ *:[v2f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35713*/          0, // EndSwitchType
/* 35714*/        /*Scope*/ 51, /*->35766*/
/* 35715*/          OPC_MoveChild0,
/* 35716*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 35719*/          OPC_RecordChild0, // #1 = $off
/* 35720*/          OPC_MoveChild0,
/* 35721*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 35724*/          OPC_MoveParent,
/* 35725*/          OPC_MoveParent,
/* 35726*/          OPC_RecordChild1, // #2 = $addr
/* 35727*/          OPC_CheckType, MVT::i32,
/* 35729*/          OPC_MoveParent,
/* 35730*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35732*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35734*/          OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->35750
/* 35737*/            OPC_EmitMergeInputChains1_0,
/* 35738*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35741*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4f32, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v4f32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35750*/          /*SwitchType*/ 13, MVT::v2f64,// ->35765
/* 35752*/            OPC_EmitMergeInputChains1_0,
/* 35753*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35756*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2f64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (ld:{ *:[v2f64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
                      // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35765*/          0, // EndSwitchType
/* 35766*/        /*Scope*/ 52, /*->35819*/
/* 35767*/          OPC_RecordChild0, // #1 = $addr
/* 35768*/          OPC_RecordChild1, // #2 = $off
/* 35769*/          OPC_MoveChild1,
/* 35770*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 35773*/          OPC_MoveParent,
/* 35774*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 35776*/          OPC_CheckType, MVT::i32,
/* 35778*/          OPC_MoveParent,
/* 35779*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35781*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35783*/          OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->35801
/* 35786*/            OPC_EmitMergeInputChains1_0,
/* 35787*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35790*/            OPC_EmitConvertToTarget, 2,
/* 35792*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[v4f32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35801*/          /*SwitchType*/ 15, MVT::v2f64,// ->35818
/* 35803*/            OPC_EmitMergeInputChains1_0,
/* 35804*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35807*/            OPC_EmitConvertToTarget, 2,
/* 35809*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (ld:{ *:[v2f64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                      // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35818*/          0, // EndSwitchType
/* 35819*/        0, /*End of Scope*/
/* 35820*/      /*SwitchOpcode*/ 52, TARGET_VAL(ISD::OR),// ->35875
/* 35823*/        OPC_RecordChild0, // #1 = $addr
/* 35824*/        OPC_RecordChild1, // #2 = $off
/* 35825*/        OPC_MoveChild1,
/* 35826*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 35829*/        OPC_MoveParent,
/* 35830*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 35832*/        OPC_CheckType, MVT::i32,
/* 35834*/        OPC_MoveParent,
/* 35835*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35837*/        OPC_CheckPredicate, 10, // Predicate_load
/* 35839*/        OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->35857
/* 35842*/          OPC_EmitMergeInputChains1_0,
/* 35843*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35846*/          OPC_EmitConvertToTarget, 2,
/* 35848*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v4f32, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[v4f32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35857*/        /*SwitchType*/ 15, MVT::v2f64,// ->35874
/* 35859*/          OPC_EmitMergeInputChains1_0,
/* 35860*/          OPC_EmitInteger, MVT::i32, 0, 
/* 35863*/          OPC_EmitConvertToTarget, 2,
/* 35865*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v2f64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (ld:{ *:[v2f64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 11
                    // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 35874*/        0, // EndSwitchType
/* 35875*/      /*SwitchOpcode*/ 126, TARGET_VAL(WebAssemblyISD::Wrapper),// ->36004
/* 35878*/        OPC_RecordChild0, // #1 = $off
/* 35879*/        OPC_MoveChild0,
/* 35880*/        OPC_SwitchOpcode /*2 cases */, 58, TARGET_VAL(ISD::TargetGlobalAddress),// ->35942
/* 35884*/          OPC_MoveParent,
/* 35885*/          OPC_MoveParent,
/* 35886*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35888*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35890*/          OPC_SwitchType /*2 cases */, 23, MVT::v4f32,// ->35916
/* 35893*/            OPC_EmitMergeInputChains1_0,
/* 35894*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35897*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35900*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35907*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4f32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35916*/          /*SwitchType*/ 23, MVT::v2f64,// ->35941
/* 35918*/            OPC_EmitMergeInputChains1_0,
/* 35919*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35922*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35925*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35932*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2f64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35941*/          0, // EndSwitchType
/* 35942*/        /*SwitchOpcode*/ 58, TARGET_VAL(ISD::TargetExternalSymbol),// ->36003
/* 35945*/          OPC_MoveParent,
/* 35946*/          OPC_MoveParent,
/* 35947*/          OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 35949*/          OPC_CheckPredicate, 10, // Predicate_load
/* 35951*/          OPC_SwitchType /*2 cases */, 23, MVT::v4f32,// ->35977
/* 35954*/            OPC_EmitMergeInputChains1_0,
/* 35955*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35958*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35961*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35968*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v4f32, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 35977*/          /*SwitchType*/ 23, MVT::v2f64,// ->36002
/* 35979*/            OPC_EmitMergeInputChains1_0,
/* 35980*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35983*/            OPC_EmitInteger, MVT::i32, 0, 
/* 35986*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 35993*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::v2f64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (ld:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 10
                      // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 36002*/          0, // EndSwitchType
/* 36003*/        0, // EndSwitchOpcode
/* 36004*/      0, // EndSwitchOpcode
/* 36005*/    /*Scope*/ 114, /*->36120*/
/* 36006*/      OPC_RecordChild1, // #1 = $off
/* 36007*/      OPC_Scope, 65, /*->36074*/ // 2 children in Scope
/* 36009*/        OPC_MoveChild1,
/* 36010*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 36013*/        OPC_MoveParent,
/* 36014*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 36016*/        OPC_CheckPredicate, 10, // Predicate_load
/* 36018*/        OPC_SwitchType /*2 cases */, 25, MVT::v4f32,// ->36046
/* 36021*/          OPC_EmitMergeInputChains1_0,
/* 36022*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36025*/          OPC_EmitConvertToTarget, 1,
/* 36027*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36030*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36037*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v4f32, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[v4f32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 36046*/        /*SwitchType*/ 25, MVT::v2f64,// ->36073
/* 36048*/          OPC_EmitMergeInputChains1_0,
/* 36049*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36052*/          OPC_EmitConvertToTarget, 1,
/* 36054*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36057*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36064*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v2f64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (ld:{ *:[v2f64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 7
                    // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 36073*/        0, // EndSwitchType
/* 36074*/      /*Scope*/ 44, /*->36119*/
/* 36075*/        OPC_CheckChild1Type, MVT::i32,
/* 36077*/        OPC_CheckPredicate, 9, // Predicate_unindexedload
/* 36079*/        OPC_CheckPredicate, 10, // Predicate_load
/* 36081*/        OPC_SwitchType /*2 cases */, 16, MVT::v4f32,// ->36100
/* 36084*/          OPC_EmitMergeInputChains1_0,
/* 36085*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36088*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36091*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v4f32, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[v4f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_v4f32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 36100*/        /*SwitchType*/ 16, MVT::v2f64,// ->36118
/* 36102*/          OPC_EmitMergeInputChains1_0,
/* 36103*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36106*/          OPC_EmitInteger, MVT::i32, 0, 
/* 36109*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::v2f64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 4
                    // Dst: (LOAD_v2f64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 36118*/        0, // EndSwitchType
/* 36119*/      0, /*End of Scope*/
/* 36120*/    0, /*End of Scope*/
/* 36121*/  /*SwitchOpcode*/ 76|128,36/*4684*/, TARGET_VAL(ISD::STORE),// ->40809
/* 36125*/    OPC_RecordMemRef,
/* 36126*/    OPC_RecordNode, // #0 = 'st' chained node
/* 36127*/    OPC_RecordChild1, // #1 = $val
/* 36128*/    OPC_Scope, 62|128,6/*830*/, /*->36961*/ // 10 children in Scope
/* 36131*/      OPC_CheckChild1Type, MVT::i32,
/* 36133*/      OPC_Scope, 11|128,5/*651*/, /*->36787*/ // 2 children in Scope
/* 36136*/        OPC_MoveChild2,
/* 36137*/        OPC_SwitchOpcode /*3 cases */, 118|128,2/*374*/, TARGET_VAL(ISD::ADD),// ->36516
/* 36142*/          OPC_Scope, 74, /*->36218*/ // 5 children in Scope
/* 36144*/            OPC_RecordChild0, // #2 = $addr
/* 36145*/            OPC_MoveChild1,
/* 36146*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 36149*/            OPC_RecordChild0, // #3 = $off
/* 36150*/            OPC_MoveChild0,
/* 36151*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 36154*/            OPC_MoveParent,
/* 36155*/            OPC_MoveParent,
/* 36156*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 36158*/            OPC_CheckType, MVT::i32,
/* 36160*/            OPC_MoveParent,
/* 36161*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36163*/            OPC_Scope, 15, /*->36180*/ // 2 children in Scope
/* 36165*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36167*/              OPC_EmitMergeInputChains1_0,
/* 36168*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36171*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 3, 2, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                        // Dst: (STORE_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36180*/            /*Scope*/ 36, /*->36217*/
/* 36181*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36183*/              OPC_Scope, 15, /*->36200*/ // 2 children in Scope
/* 36185*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36187*/                OPC_EmitMergeInputChains1_0,
/* 36188*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36191*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 14
                          // Dst: (STORE8_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36200*/              /*Scope*/ 15, /*->36216*/
/* 36201*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36203*/                OPC_EmitMergeInputChains1_0,
/* 36204*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36207*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 14
                          // Dst: (STORE16_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36216*/              0, /*End of Scope*/
/* 36217*/            0, /*End of Scope*/
/* 36218*/          /*Scope*/ 74, /*->36293*/
/* 36219*/            OPC_MoveChild0,
/* 36220*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 36223*/            OPC_RecordChild0, // #2 = $off
/* 36224*/            OPC_MoveChild0,
/* 36225*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 36228*/            OPC_MoveParent,
/* 36229*/            OPC_MoveParent,
/* 36230*/            OPC_RecordChild1, // #3 = $addr
/* 36231*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 36233*/            OPC_CheckType, MVT::i32,
/* 36235*/            OPC_MoveParent,
/* 36236*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36238*/            OPC_Scope, 15, /*->36255*/ // 2 children in Scope
/* 36240*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36242*/              OPC_EmitMergeInputChains1_0,
/* 36243*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36246*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 3, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                        // Dst: (STORE_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36255*/            /*Scope*/ 36, /*->36292*/
/* 36256*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36258*/              OPC_Scope, 15, /*->36275*/ // 2 children in Scope
/* 36260*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36262*/                OPC_EmitMergeInputChains1_0,
/* 36263*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36266*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 14
                          // Dst: (STORE8_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36275*/              /*Scope*/ 15, /*->36291*/
/* 36276*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36278*/                OPC_EmitMergeInputChains1_0,
/* 36279*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36282*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 14
                          // Dst: (STORE16_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36291*/              0, /*End of Scope*/
/* 36292*/            0, /*End of Scope*/
/* 36293*/          /*Scope*/ 72, /*->36366*/
/* 36294*/            OPC_RecordChild0, // #2 = $addr
/* 36295*/            OPC_MoveChild1,
/* 36296*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 36299*/            OPC_RecordChild0, // #3 = $off
/* 36300*/            OPC_MoveChild0,
/* 36301*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 36304*/            OPC_MoveParent,
/* 36305*/            OPC_MoveParent,
/* 36306*/            OPC_CheckType, MVT::i32,
/* 36308*/            OPC_MoveParent,
/* 36309*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36311*/            OPC_Scope, 15, /*->36328*/ // 2 children in Scope
/* 36313*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36315*/              OPC_EmitMergeInputChains1_0,
/* 36316*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36319*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 3, 2, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                        // Dst: (STORE_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36328*/            /*Scope*/ 36, /*->36365*/
/* 36329*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36331*/              OPC_Scope, 15, /*->36348*/ // 2 children in Scope
/* 36333*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36335*/                OPC_EmitMergeInputChains1_0,
/* 36336*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36339*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                          // Dst: (STORE8_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36348*/              /*Scope*/ 15, /*->36364*/
/* 36349*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36351*/                OPC_EmitMergeInputChains1_0,
/* 36352*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36355*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                          // Dst: (STORE16_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36364*/              0, /*End of Scope*/
/* 36365*/            0, /*End of Scope*/
/* 36366*/          /*Scope*/ 72, /*->36439*/
/* 36367*/            OPC_MoveChild0,
/* 36368*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 36371*/            OPC_RecordChild0, // #2 = $off
/* 36372*/            OPC_MoveChild0,
/* 36373*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 36376*/            OPC_MoveParent,
/* 36377*/            OPC_MoveParent,
/* 36378*/            OPC_RecordChild1, // #3 = $addr
/* 36379*/            OPC_CheckType, MVT::i32,
/* 36381*/            OPC_MoveParent,
/* 36382*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36384*/            OPC_Scope, 15, /*->36401*/ // 2 children in Scope
/* 36386*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36388*/              OPC_EmitMergeInputChains1_0,
/* 36389*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36392*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 3, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                        // Dst: (STORE_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36401*/            /*Scope*/ 36, /*->36438*/
/* 36402*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36404*/              OPC_Scope, 15, /*->36421*/ // 2 children in Scope
/* 36406*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36408*/                OPC_EmitMergeInputChains1_0,
/* 36409*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36412*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                          // Dst: (STORE8_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36421*/              /*Scope*/ 15, /*->36437*/
/* 36422*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36424*/                OPC_EmitMergeInputChains1_0,
/* 36425*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36428*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                          // Dst: (STORE16_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36437*/              0, /*End of Scope*/
/* 36438*/            0, /*End of Scope*/
/* 36439*/          /*Scope*/ 75, /*->36515*/
/* 36440*/            OPC_RecordChild0, // #2 = $addr
/* 36441*/            OPC_RecordChild1, // #3 = $off
/* 36442*/            OPC_MoveChild1,
/* 36443*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 36446*/            OPC_MoveParent,
/* 36447*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 36449*/            OPC_CheckType, MVT::i32,
/* 36451*/            OPC_MoveParent,
/* 36452*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36454*/            OPC_Scope, 17, /*->36473*/ // 2 children in Scope
/* 36456*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36458*/              OPC_EmitMergeInputChains1_0,
/* 36459*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36462*/              OPC_EmitConvertToTarget, 3,
/* 36464*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 2, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                        // Dst: (STORE_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36473*/            /*Scope*/ 40, /*->36514*/
/* 36474*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36476*/              OPC_Scope, 17, /*->36495*/ // 2 children in Scope
/* 36478*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36480*/                OPC_EmitMergeInputChains1_0,
/* 36481*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36484*/                OPC_EmitConvertToTarget, 3,
/* 36486*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 5, 2, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                          // Dst: (STORE8_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36495*/              /*Scope*/ 17, /*->36513*/
/* 36496*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36498*/                OPC_EmitMergeInputChains1_0,
/* 36499*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36502*/                OPC_EmitConvertToTarget, 3,
/* 36504*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 5, 2, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                          // Dst: (STORE16_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36513*/              0, /*End of Scope*/
/* 36514*/            0, /*End of Scope*/
/* 36515*/          0, /*End of Scope*/
/* 36516*/        /*SwitchOpcode*/ 75, TARGET_VAL(ISD::OR),// ->36594
/* 36519*/          OPC_RecordChild0, // #2 = $addr
/* 36520*/          OPC_RecordChild1, // #3 = $off
/* 36521*/          OPC_MoveChild1,
/* 36522*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 36525*/          OPC_MoveParent,
/* 36526*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 36528*/          OPC_CheckType, MVT::i32,
/* 36530*/          OPC_MoveParent,
/* 36531*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36533*/          OPC_Scope, 17, /*->36552*/ // 2 children in Scope
/* 36535*/            OPC_CheckPredicate, 18, // Predicate_store
/* 36537*/            OPC_EmitMergeInputChains1_0,
/* 36538*/            OPC_EmitInteger, MVT::i32, 0, 
/* 36541*/            OPC_EmitConvertToTarget, 3,
/* 36543*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36552*/          /*Scope*/ 40, /*->36593*/
/* 36553*/            OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36555*/            OPC_Scope, 17, /*->36574*/ // 2 children in Scope
/* 36557*/              OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36559*/              OPC_EmitMergeInputChains1_0,
/* 36560*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36563*/              OPC_EmitConvertToTarget, 3,
/* 36565*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 2, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                        // Dst: (STORE8_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36574*/            /*Scope*/ 17, /*->36592*/
/* 36575*/              OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36577*/              OPC_EmitMergeInputChains1_0,
/* 36578*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36581*/              OPC_EmitConvertToTarget, 3,
/* 36583*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 2, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                        // Dst: (STORE16_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36592*/            0, /*End of Scope*/
/* 36593*/          0, /*End of Scope*/
/* 36594*/        /*SwitchOpcode*/ 60|128,1/*188*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->36786
/* 36598*/          OPC_RecordChild0, // #2 = $off
/* 36599*/          OPC_MoveChild0,
/* 36600*/          OPC_SwitchOpcode /*2 cases */, 89, TARGET_VAL(ISD::TargetGlobalAddress),// ->36693
/* 36604*/            OPC_MoveParent,
/* 36605*/            OPC_MoveParent,
/* 36606*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36608*/            OPC_Scope, 25, /*->36635*/ // 2 children in Scope
/* 36610*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36612*/              OPC_EmitMergeInputChains1_0,
/* 36613*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36616*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36619*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36626*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 2, 5, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                        // Dst: (STORE_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36635*/            /*Scope*/ 56, /*->36692*/
/* 36636*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36638*/              OPC_Scope, 25, /*->36665*/ // 2 children in Scope
/* 36640*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36642*/                OPC_EmitMergeInputChains1_0,
/* 36643*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36646*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36649*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36656*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                          // Dst: (STORE8_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36665*/              /*Scope*/ 25, /*->36691*/
/* 36666*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36668*/                OPC_EmitMergeInputChains1_0,
/* 36669*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36672*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36675*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36682*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                          // Dst: (STORE16_I32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36691*/              0, /*End of Scope*/
/* 36692*/            0, /*End of Scope*/
/* 36693*/          /*SwitchOpcode*/ 89, TARGET_VAL(ISD::TargetExternalSymbol),// ->36785
/* 36696*/            OPC_MoveParent,
/* 36697*/            OPC_MoveParent,
/* 36698*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36700*/            OPC_Scope, 25, /*->36727*/ // 2 children in Scope
/* 36702*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36704*/              OPC_EmitMergeInputChains1_0,
/* 36705*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36708*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36711*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36718*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 2, 5, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                        // Dst: (STORE_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36727*/            /*Scope*/ 56, /*->36784*/
/* 36728*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36730*/              OPC_Scope, 25, /*->36757*/ // 2 children in Scope
/* 36732*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36734*/                OPC_EmitMergeInputChains1_0,
/* 36735*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36738*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36741*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36748*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                          // Dst: (STORE8_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36757*/              /*Scope*/ 25, /*->36783*/
/* 36758*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36760*/                OPC_EmitMergeInputChains1_0,
/* 36761*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36764*/                OPC_EmitInteger, MVT::i32, 0, 
/* 36767*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 36774*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i32:{ *:[i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                          // Dst: (STORE16_I32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36783*/              0, /*End of Scope*/
/* 36784*/            0, /*End of Scope*/
/* 36785*/          0, // EndSwitchOpcode
/* 36786*/        0, // EndSwitchOpcode
/* 36787*/      /*Scope*/ 43|128,1/*171*/, /*->36960*/
/* 36789*/        OPC_RecordChild2, // #2 = $off
/* 36790*/        OPC_Scope, 98, /*->36890*/ // 2 children in Scope
/* 36792*/          OPC_MoveChild2,
/* 36793*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 36796*/          OPC_MoveParent,
/* 36797*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36799*/          OPC_Scope, 27, /*->36828*/ // 2 children in Scope
/* 36801*/            OPC_CheckPredicate, 18, // Predicate_store
/* 36803*/            OPC_EmitMergeInputChains1_0,
/* 36804*/            OPC_EmitInteger, MVT::i32, 0, 
/* 36807*/            OPC_EmitConvertToTarget, 2,
/* 36809*/            OPC_EmitInteger, MVT::i32, 0, 
/* 36812*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 36819*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 6, 1, 
                      // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                      // Dst: (STORE_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36828*/          /*Scope*/ 60, /*->36889*/
/* 36829*/            OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36831*/            OPC_Scope, 27, /*->36860*/ // 2 children in Scope
/* 36833*/              OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36835*/              OPC_EmitMergeInputChains1_0,
/* 36836*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36839*/              OPC_EmitConvertToTarget, 2,
/* 36841*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36844*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 36851*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 6, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 7
                        // Dst: (STORE8_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36860*/            /*Scope*/ 27, /*->36888*/
/* 36861*/              OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36863*/              OPC_EmitMergeInputChains1_0,
/* 36864*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36867*/              OPC_EmitConvertToTarget, 2,
/* 36869*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36872*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 36879*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 6, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 7
                        // Dst: (STORE16_I32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 36888*/            0, /*End of Scope*/
/* 36889*/          0, /*End of Scope*/
/* 36890*/        /*Scope*/ 68, /*->36959*/
/* 36891*/          OPC_CheckChild2Type, MVT::i32,
/* 36893*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36895*/          OPC_Scope, 18, /*->36915*/ // 2 children in Scope
/* 36897*/            OPC_CheckPredicate, 18, // Predicate_store
/* 36899*/            OPC_EmitMergeInputChains1_0,
/* 36900*/            OPC_EmitInteger, MVT::i32, 0, 
/* 36903*/            OPC_EmitInteger, MVT::i32, 0, 
/* 36906*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 2, 1, 
                      // Src: (st i32:{ *:[i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                      // Dst: (STORE_I32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36915*/          /*Scope*/ 42, /*->36958*/
/* 36916*/            OPC_CheckPredicate, 19, // Predicate_truncstore
/* 36918*/            OPC_Scope, 18, /*->36938*/ // 2 children in Scope
/* 36920*/              OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 36922*/              OPC_EmitMergeInputChains1_0,
/* 36923*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36926*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36929*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 2, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 4
                        // Dst: (STORE8_I32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36938*/            /*Scope*/ 18, /*->36957*/
/* 36939*/              OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 36941*/              OPC_EmitMergeInputChains1_0,
/* 36942*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36945*/              OPC_EmitInteger, MVT::i32, 0, 
/* 36948*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 2, 1, 
                        // Src: (st i32:{ *:[i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 4
                        // Dst: (STORE16_I32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 36957*/            0, /*End of Scope*/
/* 36958*/          0, /*End of Scope*/
/* 36959*/        0, /*End of Scope*/
/* 36960*/      0, /*End of Scope*/
/* 36961*/    /*Scope*/ 5|128,8/*1029*/, /*->37992*/
/* 36963*/      OPC_CheckChild1Type, MVT::i64,
/* 36965*/      OPC_Scope, 35|128,6/*803*/, /*->37771*/ // 2 children in Scope
/* 36968*/        OPC_MoveChild2,
/* 36969*/        OPC_SwitchOpcode /*3 cases */, 72|128,3/*456*/, TARGET_VAL(ISD::ADD),// ->37430
/* 36974*/          OPC_Scope, 90, /*->37066*/ // 5 children in Scope
/* 36976*/            OPC_RecordChild0, // #2 = $addr
/* 36977*/            OPC_MoveChild1,
/* 36978*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 36981*/            OPC_RecordChild0, // #3 = $off
/* 36982*/            OPC_MoveChild0,
/* 36983*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 36986*/            OPC_MoveParent,
/* 36987*/            OPC_MoveParent,
/* 36988*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 36990*/            OPC_CheckType, MVT::i32,
/* 36992*/            OPC_MoveParent,
/* 36993*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 36995*/            OPC_Scope, 15, /*->37012*/ // 2 children in Scope
/* 36997*/              OPC_CheckPredicate, 18, // Predicate_store
/* 36999*/              OPC_EmitMergeInputChains1_0,
/* 37000*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37003*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 3, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                        // Dst: (STORE_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37012*/            /*Scope*/ 52, /*->37065*/
/* 37013*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37015*/              OPC_Scope, 15, /*->37032*/ // 3 children in Scope
/* 37017*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37019*/                OPC_EmitMergeInputChains1_0,
/* 37020*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37023*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 14
                          // Dst: (STORE8_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37032*/              /*Scope*/ 15, /*->37048*/
/* 37033*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37035*/                OPC_EmitMergeInputChains1_0,
/* 37036*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37039*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 14
                          // Dst: (STORE16_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37048*/              /*Scope*/ 15, /*->37064*/
/* 37049*/                OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37051*/                OPC_EmitMergeInputChains1_0,
/* 37052*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37055*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 14
                          // Dst: (STORE32_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37064*/              0, /*End of Scope*/
/* 37065*/            0, /*End of Scope*/
/* 37066*/          /*Scope*/ 90, /*->37157*/
/* 37067*/            OPC_MoveChild0,
/* 37068*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 37071*/            OPC_RecordChild0, // #2 = $off
/* 37072*/            OPC_MoveChild0,
/* 37073*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 37076*/            OPC_MoveParent,
/* 37077*/            OPC_MoveParent,
/* 37078*/            OPC_RecordChild1, // #3 = $addr
/* 37079*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 37081*/            OPC_CheckType, MVT::i32,
/* 37083*/            OPC_MoveParent,
/* 37084*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37086*/            OPC_Scope, 15, /*->37103*/ // 2 children in Scope
/* 37088*/              OPC_CheckPredicate, 18, // Predicate_store
/* 37090*/              OPC_EmitMergeInputChains1_0,
/* 37091*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37094*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 3, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                        // Dst: (STORE_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37103*/            /*Scope*/ 52, /*->37156*/
/* 37104*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37106*/              OPC_Scope, 15, /*->37123*/ // 3 children in Scope
/* 37108*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37110*/                OPC_EmitMergeInputChains1_0,
/* 37111*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37114*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 14
                          // Dst: (STORE8_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37123*/              /*Scope*/ 15, /*->37139*/
/* 37124*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37126*/                OPC_EmitMergeInputChains1_0,
/* 37127*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37130*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 14
                          // Dst: (STORE16_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37139*/              /*Scope*/ 15, /*->37155*/
/* 37140*/                OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37142*/                OPC_EmitMergeInputChains1_0,
/* 37143*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37146*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 14
                          // Dst: (STORE32_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37155*/              0, /*End of Scope*/
/* 37156*/            0, /*End of Scope*/
/* 37157*/          /*Scope*/ 88, /*->37246*/
/* 37158*/            OPC_RecordChild0, // #2 = $addr
/* 37159*/            OPC_MoveChild1,
/* 37160*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 37163*/            OPC_RecordChild0, // #3 = $off
/* 37164*/            OPC_MoveChild0,
/* 37165*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 37168*/            OPC_MoveParent,
/* 37169*/            OPC_MoveParent,
/* 37170*/            OPC_CheckType, MVT::i32,
/* 37172*/            OPC_MoveParent,
/* 37173*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37175*/            OPC_Scope, 15, /*->37192*/ // 2 children in Scope
/* 37177*/              OPC_CheckPredicate, 18, // Predicate_store
/* 37179*/              OPC_EmitMergeInputChains1_0,
/* 37180*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37183*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 3, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                        // Dst: (STORE_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37192*/            /*Scope*/ 52, /*->37245*/
/* 37193*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37195*/              OPC_Scope, 15, /*->37212*/ // 3 children in Scope
/* 37197*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37199*/                OPC_EmitMergeInputChains1_0,
/* 37200*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37203*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                          // Dst: (STORE8_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37212*/              /*Scope*/ 15, /*->37228*/
/* 37213*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37215*/                OPC_EmitMergeInputChains1_0,
/* 37216*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37219*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                          // Dst: (STORE16_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37228*/              /*Scope*/ 15, /*->37244*/
/* 37229*/                OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37231*/                OPC_EmitMergeInputChains1_0,
/* 37232*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37235*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 3, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                          // Dst: (STORE32_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37244*/              0, /*End of Scope*/
/* 37245*/            0, /*End of Scope*/
/* 37246*/          /*Scope*/ 88, /*->37335*/
/* 37247*/            OPC_MoveChild0,
/* 37248*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 37251*/            OPC_RecordChild0, // #2 = $off
/* 37252*/            OPC_MoveChild0,
/* 37253*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 37256*/            OPC_MoveParent,
/* 37257*/            OPC_MoveParent,
/* 37258*/            OPC_RecordChild1, // #3 = $addr
/* 37259*/            OPC_CheckType, MVT::i32,
/* 37261*/            OPC_MoveParent,
/* 37262*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37264*/            OPC_Scope, 15, /*->37281*/ // 2 children in Scope
/* 37266*/              OPC_CheckPredicate, 18, // Predicate_store
/* 37268*/              OPC_EmitMergeInputChains1_0,
/* 37269*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37272*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 2, 3, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                        // Dst: (STORE_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37281*/            /*Scope*/ 52, /*->37334*/
/* 37282*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37284*/              OPC_Scope, 15, /*->37301*/ // 3 children in Scope
/* 37286*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37288*/                OPC_EmitMergeInputChains1_0,
/* 37289*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37292*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                          // Dst: (STORE8_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37301*/              /*Scope*/ 15, /*->37317*/
/* 37302*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37304*/                OPC_EmitMergeInputChains1_0,
/* 37305*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37308*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                          // Dst: (STORE16_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37317*/              /*Scope*/ 15, /*->37333*/
/* 37318*/                OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37320*/                OPC_EmitMergeInputChains1_0,
/* 37321*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37324*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 2, 3, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                          // Dst: (STORE32_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37333*/              0, /*End of Scope*/
/* 37334*/            0, /*End of Scope*/
/* 37335*/          /*Scope*/ 93, /*->37429*/
/* 37336*/            OPC_RecordChild0, // #2 = $addr
/* 37337*/            OPC_RecordChild1, // #3 = $off
/* 37338*/            OPC_MoveChild1,
/* 37339*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 37342*/            OPC_MoveParent,
/* 37343*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 37345*/            OPC_CheckType, MVT::i32,
/* 37347*/            OPC_MoveParent,
/* 37348*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37350*/            OPC_Scope, 17, /*->37369*/ // 2 children in Scope
/* 37352*/              OPC_CheckPredicate, 18, // Predicate_store
/* 37354*/              OPC_EmitMergeInputChains1_0,
/* 37355*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37358*/              OPC_EmitConvertToTarget, 3,
/* 37360*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                        // Dst: (STORE_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37369*/            /*Scope*/ 58, /*->37428*/
/* 37370*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37372*/              OPC_Scope, 17, /*->37391*/ // 3 children in Scope
/* 37374*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37376*/                OPC_EmitMergeInputChains1_0,
/* 37377*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37380*/                OPC_EmitConvertToTarget, 3,
/* 37382*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 5, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                          // Dst: (STORE8_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37391*/              /*Scope*/ 17, /*->37409*/
/* 37392*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37394*/                OPC_EmitMergeInputChains1_0,
/* 37395*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37398*/                OPC_EmitConvertToTarget, 3,
/* 37400*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 5, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                          // Dst: (STORE16_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37409*/              /*Scope*/ 17, /*->37427*/
/* 37410*/                OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37412*/                OPC_EmitMergeInputChains1_0,
/* 37413*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37416*/                OPC_EmitConvertToTarget, 3,
/* 37418*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 4, 5, 2, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 11
                          // Dst: (STORE32_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37427*/              0, /*End of Scope*/
/* 37428*/            0, /*End of Scope*/
/* 37429*/          0, /*End of Scope*/
/* 37430*/        /*SwitchOpcode*/ 93, TARGET_VAL(ISD::OR),// ->37526
/* 37433*/          OPC_RecordChild0, // #2 = $addr
/* 37434*/          OPC_RecordChild1, // #3 = $off
/* 37435*/          OPC_MoveChild1,
/* 37436*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 37439*/          OPC_MoveParent,
/* 37440*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 37442*/          OPC_CheckType, MVT::i32,
/* 37444*/          OPC_MoveParent,
/* 37445*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37447*/          OPC_Scope, 17, /*->37466*/ // 2 children in Scope
/* 37449*/            OPC_CheckPredicate, 18, // Predicate_store
/* 37451*/            OPC_EmitMergeInputChains1_0,
/* 37452*/            OPC_EmitInteger, MVT::i32, 0, 
/* 37455*/            OPC_EmitConvertToTarget, 3,
/* 37457*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37466*/          /*Scope*/ 58, /*->37525*/
/* 37467*/            OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37469*/            OPC_Scope, 17, /*->37488*/ // 3 children in Scope
/* 37471*/              OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37473*/              OPC_EmitMergeInputChains1_0,
/* 37474*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37477*/              OPC_EmitConvertToTarget, 3,
/* 37479*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 11
                        // Dst: (STORE8_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37488*/            /*Scope*/ 17, /*->37506*/
/* 37489*/              OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37491*/              OPC_EmitMergeInputChains1_0,
/* 37492*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37495*/              OPC_EmitConvertToTarget, 3,
/* 37497*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 11
                        // Dst: (STORE16_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37506*/            /*Scope*/ 17, /*->37524*/
/* 37507*/              OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37509*/              OPC_EmitMergeInputChains1_0,
/* 37510*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37513*/              OPC_EmitConvertToTarget, 3,
/* 37515*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 4, 5, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 11
                        // Dst: (STORE32_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37524*/            0, /*End of Scope*/
/* 37525*/          0, /*End of Scope*/
/* 37526*/        /*SwitchOpcode*/ 112|128,1/*240*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->37770
/* 37530*/          OPC_RecordChild0, // #2 = $off
/* 37531*/          OPC_MoveChild0,
/* 37532*/          OPC_SwitchOpcode /*2 cases */, 115, TARGET_VAL(ISD::TargetGlobalAddress),// ->37651
/* 37536*/            OPC_MoveParent,
/* 37537*/            OPC_MoveParent,
/* 37538*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37540*/            OPC_Scope, 25, /*->37567*/ // 2 children in Scope
/* 37542*/              OPC_CheckPredicate, 18, // Predicate_store
/* 37544*/              OPC_EmitMergeInputChains1_0,
/* 37545*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37548*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37551*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37558*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 2, 5, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                        // Dst: (STORE_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37567*/            /*Scope*/ 82, /*->37650*/
/* 37568*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37570*/              OPC_Scope, 25, /*->37597*/ // 3 children in Scope
/* 37572*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37574*/                OPC_EmitMergeInputChains1_0,
/* 37575*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37578*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37581*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37588*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                          // Dst: (STORE8_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37597*/              /*Scope*/ 25, /*->37623*/
/* 37598*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37600*/                OPC_EmitMergeInputChains1_0,
/* 37601*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37604*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37607*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37614*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                          // Dst: (STORE16_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37623*/              /*Scope*/ 25, /*->37649*/
/* 37624*/                OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37626*/                OPC_EmitMergeInputChains1_0,
/* 37627*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37630*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37633*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37640*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 10
                          // Dst: (STORE32_I64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37649*/              0, /*End of Scope*/
/* 37650*/            0, /*End of Scope*/
/* 37651*/          /*SwitchOpcode*/ 115, TARGET_VAL(ISD::TargetExternalSymbol),// ->37769
/* 37654*/            OPC_MoveParent,
/* 37655*/            OPC_MoveParent,
/* 37656*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37658*/            OPC_Scope, 25, /*->37685*/ // 2 children in Scope
/* 37660*/              OPC_CheckPredicate, 18, // Predicate_store
/* 37662*/              OPC_EmitMergeInputChains1_0,
/* 37663*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37666*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37669*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37676*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 2, 5, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                        // Dst: (STORE_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37685*/            /*Scope*/ 82, /*->37768*/
/* 37686*/              OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37688*/              OPC_Scope, 25, /*->37715*/ // 3 children in Scope
/* 37690*/                OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37692*/                OPC_EmitMergeInputChains1_0,
/* 37693*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37696*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37699*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37706*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 10
                          // Dst: (STORE8_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37715*/              /*Scope*/ 25, /*->37741*/
/* 37716*/                OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37718*/                OPC_EmitMergeInputChains1_0,
/* 37719*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37722*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37725*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37732*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 10
                          // Dst: (STORE16_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37741*/              /*Scope*/ 25, /*->37767*/
/* 37742*/                OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37744*/                OPC_EmitMergeInputChains1_0,
/* 37745*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37748*/                OPC_EmitInteger, MVT::i32, 0, 
/* 37751*/                OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                              MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 37758*/                OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                              4/*#Ops*/, 3, 2, 5, 1, 
                          // Src: (st i64:{ *:[i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 10
                          // Dst: (STORE32_I64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37767*/              0, /*End of Scope*/
/* 37768*/            0, /*End of Scope*/
/* 37769*/          0, // EndSwitchOpcode
/* 37770*/        0, // EndSwitchOpcode
/* 37771*/      /*Scope*/ 90|128,1/*218*/, /*->37991*/
/* 37773*/        OPC_RecordChild2, // #2 = $off
/* 37774*/        OPC_Scope, 126, /*->37902*/ // 2 children in Scope
/* 37776*/          OPC_MoveChild2,
/* 37777*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 37780*/          OPC_MoveParent,
/* 37781*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37783*/          OPC_Scope, 27, /*->37812*/ // 2 children in Scope
/* 37785*/            OPC_CheckPredicate, 18, // Predicate_store
/* 37787*/            OPC_EmitMergeInputChains1_0,
/* 37788*/            OPC_EmitInteger, MVT::i32, 0, 
/* 37791*/            OPC_EmitConvertToTarget, 2,
/* 37793*/            OPC_EmitInteger, MVT::i32, 0, 
/* 37796*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37803*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 6, 1, 
                      // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                      // Dst: (STORE_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37812*/          /*Scope*/ 88, /*->37901*/
/* 37813*/            OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37815*/            OPC_Scope, 27, /*->37844*/ // 3 children in Scope
/* 37817*/              OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37819*/              OPC_EmitMergeInputChains1_0,
/* 37820*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37823*/              OPC_EmitConvertToTarget, 2,
/* 37825*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37828*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37835*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 6, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 7
                        // Dst: (STORE8_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37844*/            /*Scope*/ 27, /*->37872*/
/* 37845*/              OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37847*/              OPC_EmitMergeInputChains1_0,
/* 37848*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37851*/              OPC_EmitConvertToTarget, 2,
/* 37853*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37856*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37863*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 6, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 7
                        // Dst: (STORE16_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37872*/            /*Scope*/ 27, /*->37900*/
/* 37873*/              OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37875*/              OPC_EmitMergeInputChains1_0,
/* 37876*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37879*/              OPC_EmitConvertToTarget, 2,
/* 37881*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37884*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 37891*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 6, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 7
                        // Dst: (STORE32_I64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 37900*/            0, /*End of Scope*/
/* 37901*/          0, /*End of Scope*/
/* 37902*/        /*Scope*/ 87, /*->37990*/
/* 37903*/          OPC_CheckChild2Type, MVT::i32,
/* 37905*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 37907*/          OPC_Scope, 18, /*->37927*/ // 2 children in Scope
/* 37909*/            OPC_CheckPredicate, 18, // Predicate_store
/* 37911*/            OPC_EmitMergeInputChains1_0,
/* 37912*/            OPC_EmitInteger, MVT::i32, 0, 
/* 37915*/            OPC_EmitInteger, MVT::i32, 0, 
/* 37918*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 4, 2, 1, 
                      // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                      // Dst: (STORE_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37927*/          /*Scope*/ 61, /*->37989*/
/* 37928*/            OPC_CheckPredicate, 19, // Predicate_truncstore
/* 37930*/            OPC_Scope, 18, /*->37950*/ // 3 children in Scope
/* 37932*/              OPC_CheckPredicate, 20, // Predicate_truncstorei8
/* 37934*/              OPC_EmitMergeInputChains1_0,
/* 37935*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37938*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37941*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 4
                        // Dst: (STORE8_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37950*/            /*Scope*/ 18, /*->37969*/
/* 37951*/              OPC_CheckPredicate, 21, // Predicate_truncstorei16
/* 37953*/              OPC_EmitMergeInputChains1_0,
/* 37954*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37957*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37960*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 4
                        // Dst: (STORE16_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37969*/            /*Scope*/ 18, /*->37988*/
/* 37970*/              OPC_CheckPredicate, 22, // Predicate_truncstorei32
/* 37972*/              OPC_EmitMergeInputChains1_0,
/* 37973*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37976*/              OPC_EmitInteger, MVT::i32, 0, 
/* 37979*/              OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64), 0|OPFL_Chain|OPFL_MemRefs,
                            4/*#Ops*/, 3, 4, 2, 1, 
                        // Src: (st i64:{ *:[i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 4
                        // Dst: (STORE32_I64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 37988*/            0, /*End of Scope*/
/* 37989*/          0, /*End of Scope*/
/* 37990*/        0, /*End of Scope*/
/* 37991*/      0, /*End of Scope*/
/* 37992*/    /*Scope*/ 94|128,2/*350*/, /*->38344*/
/* 37994*/      OPC_CheckChild1Type, MVT::f32,
/* 37996*/      OPC_Scope, 26|128,2/*282*/, /*->38281*/ // 2 children in Scope
/* 37999*/        OPC_MoveChild2,
/* 38000*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->38175
/* 38005*/          OPC_Scope, 34, /*->38041*/ // 5 children in Scope
/* 38007*/            OPC_RecordChild0, // #2 = $addr
/* 38008*/            OPC_MoveChild1,
/* 38009*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38012*/            OPC_RecordChild0, // #3 = $off
/* 38013*/            OPC_MoveChild0,
/* 38014*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 38017*/            OPC_MoveParent,
/* 38018*/            OPC_MoveParent,
/* 38019*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 38021*/            OPC_CheckType, MVT::i32,
/* 38023*/            OPC_MoveParent,
/* 38024*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38026*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38028*/            OPC_EmitMergeInputChains1_0,
/* 38029*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38032*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st f32:{ *:[f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_F32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 38041*/          /*Scope*/ 34, /*->38076*/
/* 38042*/            OPC_MoveChild0,
/* 38043*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38046*/            OPC_RecordChild0, // #2 = $off
/* 38047*/            OPC_MoveChild0,
/* 38048*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 38051*/            OPC_MoveParent,
/* 38052*/            OPC_MoveParent,
/* 38053*/            OPC_RecordChild1, // #3 = $addr
/* 38054*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 38056*/            OPC_CheckType, MVT::i32,
/* 38058*/            OPC_MoveParent,
/* 38059*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38061*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38063*/            OPC_EmitMergeInputChains1_0,
/* 38064*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38067*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st f32:{ *:[f32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_F32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 38076*/          /*Scope*/ 32, /*->38109*/
/* 38077*/            OPC_RecordChild0, // #2 = $addr
/* 38078*/            OPC_MoveChild1,
/* 38079*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38082*/            OPC_RecordChild0, // #3 = $off
/* 38083*/            OPC_MoveChild0,
/* 38084*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 38087*/            OPC_MoveParent,
/* 38088*/            OPC_MoveParent,
/* 38089*/            OPC_CheckType, MVT::i32,
/* 38091*/            OPC_MoveParent,
/* 38092*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38094*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38096*/            OPC_EmitMergeInputChains1_0,
/* 38097*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38100*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st f32:{ *:[f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_F32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 38109*/          /*Scope*/ 32, /*->38142*/
/* 38110*/            OPC_MoveChild0,
/* 38111*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38114*/            OPC_RecordChild0, // #2 = $off
/* 38115*/            OPC_MoveChild0,
/* 38116*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 38119*/            OPC_MoveParent,
/* 38120*/            OPC_MoveParent,
/* 38121*/            OPC_RecordChild1, // #3 = $addr
/* 38122*/            OPC_CheckType, MVT::i32,
/* 38124*/            OPC_MoveParent,
/* 38125*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38127*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38129*/            OPC_EmitMergeInputChains1_0,
/* 38130*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38133*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st f32:{ *:[f32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_F32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 38142*/          /*Scope*/ 31, /*->38174*/
/* 38143*/            OPC_RecordChild0, // #2 = $addr
/* 38144*/            OPC_RecordChild1, // #3 = $off
/* 38145*/            OPC_MoveChild1,
/* 38146*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38149*/            OPC_MoveParent,
/* 38150*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 38152*/            OPC_CheckType, MVT::i32,
/* 38154*/            OPC_MoveParent,
/* 38155*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38157*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38159*/            OPC_EmitMergeInputChains1_0,
/* 38160*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38163*/            OPC_EmitConvertToTarget, 3,
/* 38165*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st f32:{ *:[f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_F32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 38174*/          0, /*End of Scope*/
/* 38175*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->38209
/* 38178*/          OPC_RecordChild0, // #2 = $addr
/* 38179*/          OPC_RecordChild1, // #3 = $off
/* 38180*/          OPC_MoveChild1,
/* 38181*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38184*/          OPC_MoveParent,
/* 38185*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 38187*/          OPC_CheckType, MVT::i32,
/* 38189*/          OPC_MoveParent,
/* 38190*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38192*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38194*/          OPC_EmitMergeInputChains1_0,
/* 38195*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38198*/          OPC_EmitConvertToTarget, 3,
/* 38200*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st f32:{ *:[f32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_F32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 38209*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->38280
/* 38212*/          OPC_RecordChild0, // #2 = $off
/* 38213*/          OPC_MoveChild0,
/* 38214*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->38247
/* 38218*/            OPC_MoveParent,
/* 38219*/            OPC_MoveParent,
/* 38220*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38222*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38224*/            OPC_EmitMergeInputChains1_0,
/* 38225*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38228*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38231*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38238*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st f32:{ *:[f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_F32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f32:{ *:[f32] }:$val)
/* 38247*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->38279
/* 38250*/            OPC_MoveParent,
/* 38251*/            OPC_MoveParent,
/* 38252*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38254*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38256*/            OPC_EmitMergeInputChains1_0,
/* 38257*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38260*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38263*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38270*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st f32:{ *:[f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_F32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f32:{ *:[f32] }:$val)
/* 38279*/          0, // EndSwitchOpcode
/* 38280*/        0, // EndSwitchOpcode
/* 38281*/      /*Scope*/ 61, /*->38343*/
/* 38282*/        OPC_RecordChild2, // #2 = $off
/* 38283*/        OPC_Scope, 34, /*->38319*/ // 2 children in Scope
/* 38285*/          OPC_MoveChild2,
/* 38286*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38289*/          OPC_MoveParent,
/* 38290*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38292*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38294*/          OPC_EmitMergeInputChains1_0,
/* 38295*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38298*/          OPC_EmitConvertToTarget, 2,
/* 38300*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38303*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 38310*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st f32:{ *:[f32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_F32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f32:{ *:[f32] }:$val)
/* 38319*/        /*Scope*/ 22, /*->38342*/
/* 38320*/          OPC_CheckChild2Type, MVT::i32,
/* 38322*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38324*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38326*/          OPC_EmitMergeInputChains1_0,
/* 38327*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38330*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38333*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st f32:{ *:[f32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_F32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/* 38342*/        0, /*End of Scope*/
/* 38343*/      0, /*End of Scope*/
/* 38344*/    /*Scope*/ 94|128,2/*350*/, /*->38696*/
/* 38346*/      OPC_CheckChild1Type, MVT::f64,
/* 38348*/      OPC_Scope, 26|128,2/*282*/, /*->38633*/ // 2 children in Scope
/* 38351*/        OPC_MoveChild2,
/* 38352*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->38527
/* 38357*/          OPC_Scope, 34, /*->38393*/ // 5 children in Scope
/* 38359*/            OPC_RecordChild0, // #2 = $addr
/* 38360*/            OPC_MoveChild1,
/* 38361*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38364*/            OPC_RecordChild0, // #3 = $off
/* 38365*/            OPC_MoveChild0,
/* 38366*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 38369*/            OPC_MoveParent,
/* 38370*/            OPC_MoveParent,
/* 38371*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 38373*/            OPC_CheckType, MVT::i32,
/* 38375*/            OPC_MoveParent,
/* 38376*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38378*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38380*/            OPC_EmitMergeInputChains1_0,
/* 38381*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38384*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st f64:{ *:[f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_F64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 38393*/          /*Scope*/ 34, /*->38428*/
/* 38394*/            OPC_MoveChild0,
/* 38395*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38398*/            OPC_RecordChild0, // #2 = $off
/* 38399*/            OPC_MoveChild0,
/* 38400*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 38403*/            OPC_MoveParent,
/* 38404*/            OPC_MoveParent,
/* 38405*/            OPC_RecordChild1, // #3 = $addr
/* 38406*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 38408*/            OPC_CheckType, MVT::i32,
/* 38410*/            OPC_MoveParent,
/* 38411*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38413*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38415*/            OPC_EmitMergeInputChains1_0,
/* 38416*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38419*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st f64:{ *:[f64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_F64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 38428*/          /*Scope*/ 32, /*->38461*/
/* 38429*/            OPC_RecordChild0, // #2 = $addr
/* 38430*/            OPC_MoveChild1,
/* 38431*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38434*/            OPC_RecordChild0, // #3 = $off
/* 38435*/            OPC_MoveChild0,
/* 38436*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 38439*/            OPC_MoveParent,
/* 38440*/            OPC_MoveParent,
/* 38441*/            OPC_CheckType, MVT::i32,
/* 38443*/            OPC_MoveParent,
/* 38444*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38446*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38448*/            OPC_EmitMergeInputChains1_0,
/* 38449*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38452*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st f64:{ *:[f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_F64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 38461*/          /*Scope*/ 32, /*->38494*/
/* 38462*/            OPC_MoveChild0,
/* 38463*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38466*/            OPC_RecordChild0, // #2 = $off
/* 38467*/            OPC_MoveChild0,
/* 38468*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 38471*/            OPC_MoveParent,
/* 38472*/            OPC_MoveParent,
/* 38473*/            OPC_RecordChild1, // #3 = $addr
/* 38474*/            OPC_CheckType, MVT::i32,
/* 38476*/            OPC_MoveParent,
/* 38477*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38479*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38481*/            OPC_EmitMergeInputChains1_0,
/* 38482*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38485*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st f64:{ *:[f64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_F64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 38494*/          /*Scope*/ 31, /*->38526*/
/* 38495*/            OPC_RecordChild0, // #2 = $addr
/* 38496*/            OPC_RecordChild1, // #3 = $off
/* 38497*/            OPC_MoveChild1,
/* 38498*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38501*/            OPC_MoveParent,
/* 38502*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 38504*/            OPC_CheckType, MVT::i32,
/* 38506*/            OPC_MoveParent,
/* 38507*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38509*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38511*/            OPC_EmitMergeInputChains1_0,
/* 38512*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38515*/            OPC_EmitConvertToTarget, 3,
/* 38517*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st f64:{ *:[f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_F64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 38526*/          0, /*End of Scope*/
/* 38527*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->38561
/* 38530*/          OPC_RecordChild0, // #2 = $addr
/* 38531*/          OPC_RecordChild1, // #3 = $off
/* 38532*/          OPC_MoveChild1,
/* 38533*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38536*/          OPC_MoveParent,
/* 38537*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 38539*/          OPC_CheckType, MVT::i32,
/* 38541*/          OPC_MoveParent,
/* 38542*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38544*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38546*/          OPC_EmitMergeInputChains1_0,
/* 38547*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38550*/          OPC_EmitConvertToTarget, 3,
/* 38552*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st f64:{ *:[f64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_F64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 38561*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->38632
/* 38564*/          OPC_RecordChild0, // #2 = $off
/* 38565*/          OPC_MoveChild0,
/* 38566*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->38599
/* 38570*/            OPC_MoveParent,
/* 38571*/            OPC_MoveParent,
/* 38572*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38574*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38576*/            OPC_EmitMergeInputChains1_0,
/* 38577*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38580*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38583*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38590*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st f64:{ *:[f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_F64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f64:{ *:[f64] }:$val)
/* 38599*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->38631
/* 38602*/            OPC_MoveParent,
/* 38603*/            OPC_MoveParent,
/* 38604*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38606*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38608*/            OPC_EmitMergeInputChains1_0,
/* 38609*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38612*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38615*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38622*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st f64:{ *:[f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_F64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f64:{ *:[f64] }:$val)
/* 38631*/          0, // EndSwitchOpcode
/* 38632*/        0, // EndSwitchOpcode
/* 38633*/      /*Scope*/ 61, /*->38695*/
/* 38634*/        OPC_RecordChild2, // #2 = $off
/* 38635*/        OPC_Scope, 34, /*->38671*/ // 2 children in Scope
/* 38637*/          OPC_MoveChild2,
/* 38638*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38641*/          OPC_MoveParent,
/* 38642*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38644*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38646*/          OPC_EmitMergeInputChains1_0,
/* 38647*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38650*/          OPC_EmitConvertToTarget, 2,
/* 38652*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38655*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 38662*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st f64:{ *:[f64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_F64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), f64:{ *:[f64] }:$val)
/* 38671*/        /*Scope*/ 22, /*->38694*/
/* 38672*/          OPC_CheckChild2Type, MVT::i32,
/* 38674*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38676*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38678*/          OPC_EmitMergeInputChains1_0,
/* 38679*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38682*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38685*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st f64:{ *:[f64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_F64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/* 38694*/        0, /*End of Scope*/
/* 38695*/      0, /*End of Scope*/
/* 38696*/    /*Scope*/ 94|128,2/*350*/, /*->39048*/
/* 38698*/      OPC_CheckChild1Type, MVT::v16i8,
/* 38700*/      OPC_Scope, 26|128,2/*282*/, /*->38985*/ // 2 children in Scope
/* 38703*/        OPC_MoveChild2,
/* 38704*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->38879
/* 38709*/          OPC_Scope, 34, /*->38745*/ // 5 children in Scope
/* 38711*/            OPC_RecordChild0, // #2 = $addr
/* 38712*/            OPC_MoveChild1,
/* 38713*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38716*/            OPC_RecordChild0, // #3 = $off
/* 38717*/            OPC_MoveChild0,
/* 38718*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 38721*/            OPC_MoveParent,
/* 38722*/            OPC_MoveParent,
/* 38723*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 38725*/            OPC_CheckType, MVT::i32,
/* 38727*/            OPC_MoveParent,
/* 38728*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38730*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38732*/            OPC_EmitMergeInputChains1_0,
/* 38733*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38736*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v16i8:{ *:[v16i8] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v16i8 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 38745*/          /*Scope*/ 34, /*->38780*/
/* 38746*/            OPC_MoveChild0,
/* 38747*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38750*/            OPC_RecordChild0, // #2 = $off
/* 38751*/            OPC_MoveChild0,
/* 38752*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 38755*/            OPC_MoveParent,
/* 38756*/            OPC_MoveParent,
/* 38757*/            OPC_RecordChild1, // #3 = $addr
/* 38758*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 38760*/            OPC_CheckType, MVT::i32,
/* 38762*/            OPC_MoveParent,
/* 38763*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38765*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38767*/            OPC_EmitMergeInputChains1_0,
/* 38768*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38771*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v16i8:{ *:[v16i8] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v16i8 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 38780*/          /*Scope*/ 32, /*->38813*/
/* 38781*/            OPC_RecordChild0, // #2 = $addr
/* 38782*/            OPC_MoveChild1,
/* 38783*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38786*/            OPC_RecordChild0, // #3 = $off
/* 38787*/            OPC_MoveChild0,
/* 38788*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 38791*/            OPC_MoveParent,
/* 38792*/            OPC_MoveParent,
/* 38793*/            OPC_CheckType, MVT::i32,
/* 38795*/            OPC_MoveParent,
/* 38796*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38798*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38800*/            OPC_EmitMergeInputChains1_0,
/* 38801*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38804*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v16i8:{ *:[v16i8] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v16i8 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 38813*/          /*Scope*/ 32, /*->38846*/
/* 38814*/            OPC_MoveChild0,
/* 38815*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 38818*/            OPC_RecordChild0, // #2 = $off
/* 38819*/            OPC_MoveChild0,
/* 38820*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 38823*/            OPC_MoveParent,
/* 38824*/            OPC_MoveParent,
/* 38825*/            OPC_RecordChild1, // #3 = $addr
/* 38826*/            OPC_CheckType, MVT::i32,
/* 38828*/            OPC_MoveParent,
/* 38829*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38831*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38833*/            OPC_EmitMergeInputChains1_0,
/* 38834*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38837*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v16i8:{ *:[v16i8] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v16i8 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 38846*/          /*Scope*/ 31, /*->38878*/
/* 38847*/            OPC_RecordChild0, // #2 = $addr
/* 38848*/            OPC_RecordChild1, // #3 = $off
/* 38849*/            OPC_MoveChild1,
/* 38850*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38853*/            OPC_MoveParent,
/* 38854*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 38856*/            OPC_CheckType, MVT::i32,
/* 38858*/            OPC_MoveParent,
/* 38859*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38861*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38863*/            OPC_EmitMergeInputChains1_0,
/* 38864*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38867*/            OPC_EmitConvertToTarget, 3,
/* 38869*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st v16i8:{ *:[v16i8] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_v16i8 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 38878*/          0, /*End of Scope*/
/* 38879*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->38913
/* 38882*/          OPC_RecordChild0, // #2 = $addr
/* 38883*/          OPC_RecordChild1, // #3 = $off
/* 38884*/          OPC_MoveChild1,
/* 38885*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38888*/          OPC_MoveParent,
/* 38889*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 38891*/          OPC_CheckType, MVT::i32,
/* 38893*/          OPC_MoveParent,
/* 38894*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38896*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38898*/          OPC_EmitMergeInputChains1_0,
/* 38899*/          OPC_EmitInteger, MVT::i32, 0, 
/* 38902*/          OPC_EmitConvertToTarget, 3,
/* 38904*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st v16i8:{ *:[v16i8] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_v16i8 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 38913*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->38984
/* 38916*/          OPC_RecordChild0, // #2 = $off
/* 38917*/          OPC_MoveChild0,
/* 38918*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->38951
/* 38922*/            OPC_MoveParent,
/* 38923*/            OPC_MoveParent,
/* 38924*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38926*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38928*/            OPC_EmitMergeInputChains1_0,
/* 38929*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38932*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38935*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38942*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v16i8:{ *:[v16i8] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v16i8 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v16i8:{ *:[v16i8] }:$val)
/* 38951*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->38983
/* 38954*/            OPC_MoveParent,
/* 38955*/            OPC_MoveParent,
/* 38956*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38958*/            OPC_CheckPredicate, 18, // Predicate_store
/* 38960*/            OPC_EmitMergeInputChains1_0,
/* 38961*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38964*/            OPC_EmitInteger, MVT::i32, 0, 
/* 38967*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 38974*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v16i8:{ *:[v16i8] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v16i8 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v16i8:{ *:[v16i8] }:$val)
/* 38983*/          0, // EndSwitchOpcode
/* 38984*/        0, // EndSwitchOpcode
/* 38985*/      /*Scope*/ 61, /*->39047*/
/* 38986*/        OPC_RecordChild2, // #2 = $off
/* 38987*/        OPC_Scope, 34, /*->39023*/ // 2 children in Scope
/* 38989*/          OPC_MoveChild2,
/* 38990*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 38993*/          OPC_MoveParent,
/* 38994*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 38996*/          OPC_CheckPredicate, 18, // Predicate_store
/* 38998*/          OPC_EmitMergeInputChains1_0,
/* 38999*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39002*/          OPC_EmitConvertToTarget, 2,
/* 39004*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39007*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 39014*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st v16i8:{ *:[v16i8] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_v16i8 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v16i8:{ *:[v16i8] }:$val)
/* 39023*/        /*Scope*/ 22, /*->39046*/
/* 39024*/          OPC_CheckChild2Type, MVT::i32,
/* 39026*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39028*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39030*/          OPC_EmitMergeInputChains1_0,
/* 39031*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39034*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39037*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v16i8), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st v16i8:{ *:[v16i8] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_v16i8 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/* 39046*/        0, /*End of Scope*/
/* 39047*/      0, /*End of Scope*/
/* 39048*/    /*Scope*/ 94|128,2/*350*/, /*->39400*/
/* 39050*/      OPC_CheckChild1Type, MVT::v8i16,
/* 39052*/      OPC_Scope, 26|128,2/*282*/, /*->39337*/ // 2 children in Scope
/* 39055*/        OPC_MoveChild2,
/* 39056*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->39231
/* 39061*/          OPC_Scope, 34, /*->39097*/ // 5 children in Scope
/* 39063*/            OPC_RecordChild0, // #2 = $addr
/* 39064*/            OPC_MoveChild1,
/* 39065*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39068*/            OPC_RecordChild0, // #3 = $off
/* 39069*/            OPC_MoveChild0,
/* 39070*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 39073*/            OPC_MoveParent,
/* 39074*/            OPC_MoveParent,
/* 39075*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 39077*/            OPC_CheckType, MVT::i32,
/* 39079*/            OPC_MoveParent,
/* 39080*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39082*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39084*/            OPC_EmitMergeInputChains1_0,
/* 39085*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39088*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v8i16 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 39097*/          /*Scope*/ 34, /*->39132*/
/* 39098*/            OPC_MoveChild0,
/* 39099*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39102*/            OPC_RecordChild0, // #2 = $off
/* 39103*/            OPC_MoveChild0,
/* 39104*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 39107*/            OPC_MoveParent,
/* 39108*/            OPC_MoveParent,
/* 39109*/            OPC_RecordChild1, // #3 = $addr
/* 39110*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 39112*/            OPC_CheckType, MVT::i32,
/* 39114*/            OPC_MoveParent,
/* 39115*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39117*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39119*/            OPC_EmitMergeInputChains1_0,
/* 39120*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39123*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v8i16 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 39132*/          /*Scope*/ 32, /*->39165*/
/* 39133*/            OPC_RecordChild0, // #2 = $addr
/* 39134*/            OPC_MoveChild1,
/* 39135*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39138*/            OPC_RecordChild0, // #3 = $off
/* 39139*/            OPC_MoveChild0,
/* 39140*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 39143*/            OPC_MoveParent,
/* 39144*/            OPC_MoveParent,
/* 39145*/            OPC_CheckType, MVT::i32,
/* 39147*/            OPC_MoveParent,
/* 39148*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39150*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39152*/            OPC_EmitMergeInputChains1_0,
/* 39153*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39156*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v8i16 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 39165*/          /*Scope*/ 32, /*->39198*/
/* 39166*/            OPC_MoveChild0,
/* 39167*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39170*/            OPC_RecordChild0, // #2 = $off
/* 39171*/            OPC_MoveChild0,
/* 39172*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 39175*/            OPC_MoveParent,
/* 39176*/            OPC_MoveParent,
/* 39177*/            OPC_RecordChild1, // #3 = $addr
/* 39178*/            OPC_CheckType, MVT::i32,
/* 39180*/            OPC_MoveParent,
/* 39181*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39183*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39185*/            OPC_EmitMergeInputChains1_0,
/* 39186*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39189*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v8i16 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 39198*/          /*Scope*/ 31, /*->39230*/
/* 39199*/            OPC_RecordChild0, // #2 = $addr
/* 39200*/            OPC_RecordChild1, // #3 = $off
/* 39201*/            OPC_MoveChild1,
/* 39202*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39205*/            OPC_MoveParent,
/* 39206*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 39208*/            OPC_CheckType, MVT::i32,
/* 39210*/            OPC_MoveParent,
/* 39211*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39213*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39215*/            OPC_EmitMergeInputChains1_0,
/* 39216*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39219*/            OPC_EmitConvertToTarget, 3,
/* 39221*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st v8i16:{ *:[v8i16] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_v8i16 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 39230*/          0, /*End of Scope*/
/* 39231*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->39265
/* 39234*/          OPC_RecordChild0, // #2 = $addr
/* 39235*/          OPC_RecordChild1, // #3 = $off
/* 39236*/          OPC_MoveChild1,
/* 39237*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39240*/          OPC_MoveParent,
/* 39241*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 39243*/          OPC_CheckType, MVT::i32,
/* 39245*/          OPC_MoveParent,
/* 39246*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39248*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39250*/          OPC_EmitMergeInputChains1_0,
/* 39251*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39254*/          OPC_EmitConvertToTarget, 3,
/* 39256*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st v8i16:{ *:[v8i16] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_v8i16 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 39265*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->39336
/* 39268*/          OPC_RecordChild0, // #2 = $off
/* 39269*/          OPC_MoveChild0,
/* 39270*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->39303
/* 39274*/            OPC_MoveParent,
/* 39275*/            OPC_MoveParent,
/* 39276*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39278*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39280*/            OPC_EmitMergeInputChains1_0,
/* 39281*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39284*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39287*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 39294*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v8i16:{ *:[v8i16] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v8i16 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v8i16:{ *:[v8i16] }:$val)
/* 39303*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->39335
/* 39306*/            OPC_MoveParent,
/* 39307*/            OPC_MoveParent,
/* 39308*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39310*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39312*/            OPC_EmitMergeInputChains1_0,
/* 39313*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39316*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39319*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 39326*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v8i16:{ *:[v8i16] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v8i16 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v8i16:{ *:[v8i16] }:$val)
/* 39335*/          0, // EndSwitchOpcode
/* 39336*/        0, // EndSwitchOpcode
/* 39337*/      /*Scope*/ 61, /*->39399*/
/* 39338*/        OPC_RecordChild2, // #2 = $off
/* 39339*/        OPC_Scope, 34, /*->39375*/ // 2 children in Scope
/* 39341*/          OPC_MoveChild2,
/* 39342*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39345*/          OPC_MoveParent,
/* 39346*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39348*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39350*/          OPC_EmitMergeInputChains1_0,
/* 39351*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39354*/          OPC_EmitConvertToTarget, 2,
/* 39356*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39359*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 39366*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st v8i16:{ *:[v8i16] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_v8i16 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v8i16:{ *:[v8i16] }:$val)
/* 39375*/        /*Scope*/ 22, /*->39398*/
/* 39376*/          OPC_CheckChild2Type, MVT::i32,
/* 39378*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39380*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39382*/          OPC_EmitMergeInputChains1_0,
/* 39383*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39386*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39389*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v8i16), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st v8i16:{ *:[v8i16] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_v8i16 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/* 39398*/        0, /*End of Scope*/
/* 39399*/      0, /*End of Scope*/
/* 39400*/    /*Scope*/ 94|128,2/*350*/, /*->39752*/
/* 39402*/      OPC_CheckChild1Type, MVT::v4i32,
/* 39404*/      OPC_Scope, 26|128,2/*282*/, /*->39689*/ // 2 children in Scope
/* 39407*/        OPC_MoveChild2,
/* 39408*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->39583
/* 39413*/          OPC_Scope, 34, /*->39449*/ // 5 children in Scope
/* 39415*/            OPC_RecordChild0, // #2 = $addr
/* 39416*/            OPC_MoveChild1,
/* 39417*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39420*/            OPC_RecordChild0, // #3 = $off
/* 39421*/            OPC_MoveChild0,
/* 39422*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 39425*/            OPC_MoveParent,
/* 39426*/            OPC_MoveParent,
/* 39427*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 39429*/            OPC_CheckType, MVT::i32,
/* 39431*/            OPC_MoveParent,
/* 39432*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39434*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39436*/            OPC_EmitMergeInputChains1_0,
/* 39437*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39440*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v4i32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 39449*/          /*Scope*/ 34, /*->39484*/
/* 39450*/            OPC_MoveChild0,
/* 39451*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39454*/            OPC_RecordChild0, // #2 = $off
/* 39455*/            OPC_MoveChild0,
/* 39456*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 39459*/            OPC_MoveParent,
/* 39460*/            OPC_MoveParent,
/* 39461*/            OPC_RecordChild1, // #3 = $addr
/* 39462*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 39464*/            OPC_CheckType, MVT::i32,
/* 39466*/            OPC_MoveParent,
/* 39467*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39469*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39471*/            OPC_EmitMergeInputChains1_0,
/* 39472*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39475*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v4i32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 39484*/          /*Scope*/ 32, /*->39517*/
/* 39485*/            OPC_RecordChild0, // #2 = $addr
/* 39486*/            OPC_MoveChild1,
/* 39487*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39490*/            OPC_RecordChild0, // #3 = $off
/* 39491*/            OPC_MoveChild0,
/* 39492*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 39495*/            OPC_MoveParent,
/* 39496*/            OPC_MoveParent,
/* 39497*/            OPC_CheckType, MVT::i32,
/* 39499*/            OPC_MoveParent,
/* 39500*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39502*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39504*/            OPC_EmitMergeInputChains1_0,
/* 39505*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39508*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v4i32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 39517*/          /*Scope*/ 32, /*->39550*/
/* 39518*/            OPC_MoveChild0,
/* 39519*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39522*/            OPC_RecordChild0, // #2 = $off
/* 39523*/            OPC_MoveChild0,
/* 39524*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 39527*/            OPC_MoveParent,
/* 39528*/            OPC_MoveParent,
/* 39529*/            OPC_RecordChild1, // #3 = $addr
/* 39530*/            OPC_CheckType, MVT::i32,
/* 39532*/            OPC_MoveParent,
/* 39533*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39535*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39537*/            OPC_EmitMergeInputChains1_0,
/* 39538*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39541*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v4i32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 39550*/          /*Scope*/ 31, /*->39582*/
/* 39551*/            OPC_RecordChild0, // #2 = $addr
/* 39552*/            OPC_RecordChild1, // #3 = $off
/* 39553*/            OPC_MoveChild1,
/* 39554*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39557*/            OPC_MoveParent,
/* 39558*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 39560*/            OPC_CheckType, MVT::i32,
/* 39562*/            OPC_MoveParent,
/* 39563*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39565*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39567*/            OPC_EmitMergeInputChains1_0,
/* 39568*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39571*/            OPC_EmitConvertToTarget, 3,
/* 39573*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st v4i32:{ *:[v4i32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_v4i32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 39582*/          0, /*End of Scope*/
/* 39583*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->39617
/* 39586*/          OPC_RecordChild0, // #2 = $addr
/* 39587*/          OPC_RecordChild1, // #3 = $off
/* 39588*/          OPC_MoveChild1,
/* 39589*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39592*/          OPC_MoveParent,
/* 39593*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 39595*/          OPC_CheckType, MVT::i32,
/* 39597*/          OPC_MoveParent,
/* 39598*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39600*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39602*/          OPC_EmitMergeInputChains1_0,
/* 39603*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39606*/          OPC_EmitConvertToTarget, 3,
/* 39608*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st v4i32:{ *:[v4i32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_v4i32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 39617*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->39688
/* 39620*/          OPC_RecordChild0, // #2 = $off
/* 39621*/          OPC_MoveChild0,
/* 39622*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->39655
/* 39626*/            OPC_MoveParent,
/* 39627*/            OPC_MoveParent,
/* 39628*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39630*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39632*/            OPC_EmitMergeInputChains1_0,
/* 39633*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39636*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39639*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 39646*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v4i32:{ *:[v4i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v4i32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$val)
/* 39655*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->39687
/* 39658*/            OPC_MoveParent,
/* 39659*/            OPC_MoveParent,
/* 39660*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39662*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39664*/            OPC_EmitMergeInputChains1_0,
/* 39665*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39668*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39671*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 39678*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v4i32:{ *:[v4i32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v4i32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$val)
/* 39687*/          0, // EndSwitchOpcode
/* 39688*/        0, // EndSwitchOpcode
/* 39689*/      /*Scope*/ 61, /*->39751*/
/* 39690*/        OPC_RecordChild2, // #2 = $off
/* 39691*/        OPC_Scope, 34, /*->39727*/ // 2 children in Scope
/* 39693*/          OPC_MoveChild2,
/* 39694*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39697*/          OPC_MoveParent,
/* 39698*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39700*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39702*/          OPC_EmitMergeInputChains1_0,
/* 39703*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39706*/          OPC_EmitConvertToTarget, 2,
/* 39708*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39711*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 39718*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st v4i32:{ *:[v4i32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_v4i32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$val)
/* 39727*/        /*Scope*/ 22, /*->39750*/
/* 39728*/          OPC_CheckChild2Type, MVT::i32,
/* 39730*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39732*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39734*/          OPC_EmitMergeInputChains1_0,
/* 39735*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39738*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39741*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4i32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st v4i32:{ *:[v4i32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_v4i32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/* 39750*/        0, /*End of Scope*/
/* 39751*/      0, /*End of Scope*/
/* 39752*/    /*Scope*/ 94|128,2/*350*/, /*->40104*/
/* 39754*/      OPC_CheckChild1Type, MVT::v2i64,
/* 39756*/      OPC_Scope, 26|128,2/*282*/, /*->40041*/ // 2 children in Scope
/* 39759*/        OPC_MoveChild2,
/* 39760*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->39935
/* 39765*/          OPC_Scope, 34, /*->39801*/ // 5 children in Scope
/* 39767*/            OPC_RecordChild0, // #2 = $addr
/* 39768*/            OPC_MoveChild1,
/* 39769*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39772*/            OPC_RecordChild0, // #3 = $off
/* 39773*/            OPC_MoveChild0,
/* 39774*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 39777*/            OPC_MoveParent,
/* 39778*/            OPC_MoveParent,
/* 39779*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 39781*/            OPC_CheckType, MVT::i32,
/* 39783*/            OPC_MoveParent,
/* 39784*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39786*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39788*/            OPC_EmitMergeInputChains1_0,
/* 39789*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39792*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v2i64:{ *:[v2i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v2i64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 39801*/          /*Scope*/ 34, /*->39836*/
/* 39802*/            OPC_MoveChild0,
/* 39803*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39806*/            OPC_RecordChild0, // #2 = $off
/* 39807*/            OPC_MoveChild0,
/* 39808*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 39811*/            OPC_MoveParent,
/* 39812*/            OPC_MoveParent,
/* 39813*/            OPC_RecordChild1, // #3 = $addr
/* 39814*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 39816*/            OPC_CheckType, MVT::i32,
/* 39818*/            OPC_MoveParent,
/* 39819*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39821*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39823*/            OPC_EmitMergeInputChains1_0,
/* 39824*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39827*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v2i64:{ *:[v2i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v2i64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 39836*/          /*Scope*/ 32, /*->39869*/
/* 39837*/            OPC_RecordChild0, // #2 = $addr
/* 39838*/            OPC_MoveChild1,
/* 39839*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39842*/            OPC_RecordChild0, // #3 = $off
/* 39843*/            OPC_MoveChild0,
/* 39844*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 39847*/            OPC_MoveParent,
/* 39848*/            OPC_MoveParent,
/* 39849*/            OPC_CheckType, MVT::i32,
/* 39851*/            OPC_MoveParent,
/* 39852*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39854*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39856*/            OPC_EmitMergeInputChains1_0,
/* 39857*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39860*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v2i64:{ *:[v2i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v2i64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 39869*/          /*Scope*/ 32, /*->39902*/
/* 39870*/            OPC_MoveChild0,
/* 39871*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 39874*/            OPC_RecordChild0, // #2 = $off
/* 39875*/            OPC_MoveChild0,
/* 39876*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 39879*/            OPC_MoveParent,
/* 39880*/            OPC_MoveParent,
/* 39881*/            OPC_RecordChild1, // #3 = $addr
/* 39882*/            OPC_CheckType, MVT::i32,
/* 39884*/            OPC_MoveParent,
/* 39885*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39887*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39889*/            OPC_EmitMergeInputChains1_0,
/* 39890*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39893*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v2i64:{ *:[v2i64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v2i64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 39902*/          /*Scope*/ 31, /*->39934*/
/* 39903*/            OPC_RecordChild0, // #2 = $addr
/* 39904*/            OPC_RecordChild1, // #3 = $off
/* 39905*/            OPC_MoveChild1,
/* 39906*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39909*/            OPC_MoveParent,
/* 39910*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 39912*/            OPC_CheckType, MVT::i32,
/* 39914*/            OPC_MoveParent,
/* 39915*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39917*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39919*/            OPC_EmitMergeInputChains1_0,
/* 39920*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39923*/            OPC_EmitConvertToTarget, 3,
/* 39925*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st v2i64:{ *:[v2i64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_v2i64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 39934*/          0, /*End of Scope*/
/* 39935*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->39969
/* 39938*/          OPC_RecordChild0, // #2 = $addr
/* 39939*/          OPC_RecordChild1, // #3 = $off
/* 39940*/          OPC_MoveChild1,
/* 39941*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 39944*/          OPC_MoveParent,
/* 39945*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 39947*/          OPC_CheckType, MVT::i32,
/* 39949*/          OPC_MoveParent,
/* 39950*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39952*/          OPC_CheckPredicate, 18, // Predicate_store
/* 39954*/          OPC_EmitMergeInputChains1_0,
/* 39955*/          OPC_EmitInteger, MVT::i32, 0, 
/* 39958*/          OPC_EmitConvertToTarget, 3,
/* 39960*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st v2i64:{ *:[v2i64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_v2i64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 39969*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->40040
/* 39972*/          OPC_RecordChild0, // #2 = $off
/* 39973*/          OPC_MoveChild0,
/* 39974*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->40007
/* 39978*/            OPC_MoveParent,
/* 39979*/            OPC_MoveParent,
/* 39980*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 39982*/            OPC_CheckPredicate, 18, // Predicate_store
/* 39984*/            OPC_EmitMergeInputChains1_0,
/* 39985*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39988*/            OPC_EmitInteger, MVT::i32, 0, 
/* 39991*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 39998*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v2i64:{ *:[v2i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v2i64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2i64:{ *:[v2i64] }:$val)
/* 40007*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->40039
/* 40010*/            OPC_MoveParent,
/* 40011*/            OPC_MoveParent,
/* 40012*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40014*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40016*/            OPC_EmitMergeInputChains1_0,
/* 40017*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40020*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40023*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40030*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v2i64:{ *:[v2i64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v2i64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2i64:{ *:[v2i64] }:$val)
/* 40039*/          0, // EndSwitchOpcode
/* 40040*/        0, // EndSwitchOpcode
/* 40041*/      /*Scope*/ 61, /*->40103*/
/* 40042*/        OPC_RecordChild2, // #2 = $off
/* 40043*/        OPC_Scope, 34, /*->40079*/ // 2 children in Scope
/* 40045*/          OPC_MoveChild2,
/* 40046*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40049*/          OPC_MoveParent,
/* 40050*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40052*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40054*/          OPC_EmitMergeInputChains1_0,
/* 40055*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40058*/          OPC_EmitConvertToTarget, 2,
/* 40060*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40063*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40070*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st v2i64:{ *:[v2i64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_v2i64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2i64:{ *:[v2i64] }:$val)
/* 40079*/        /*Scope*/ 22, /*->40102*/
/* 40080*/          OPC_CheckChild2Type, MVT::i32,
/* 40082*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40084*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40086*/          OPC_EmitMergeInputChains1_0,
/* 40087*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40090*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40093*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2i64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st v2i64:{ *:[v2i64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_v2i64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/* 40102*/        0, /*End of Scope*/
/* 40103*/      0, /*End of Scope*/
/* 40104*/    /*Scope*/ 94|128,2/*350*/, /*->40456*/
/* 40106*/      OPC_CheckChild1Type, MVT::v4f32,
/* 40108*/      OPC_Scope, 26|128,2/*282*/, /*->40393*/ // 2 children in Scope
/* 40111*/        OPC_MoveChild2,
/* 40112*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->40287
/* 40117*/          OPC_Scope, 34, /*->40153*/ // 5 children in Scope
/* 40119*/            OPC_RecordChild0, // #2 = $addr
/* 40120*/            OPC_MoveChild1,
/* 40121*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40124*/            OPC_RecordChild0, // #3 = $off
/* 40125*/            OPC_MoveChild0,
/* 40126*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 40129*/            OPC_MoveParent,
/* 40130*/            OPC_MoveParent,
/* 40131*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 40133*/            OPC_CheckType, MVT::i32,
/* 40135*/            OPC_MoveParent,
/* 40136*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40138*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40140*/            OPC_EmitMergeInputChains1_0,
/* 40141*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40144*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v4f32:{ *:[v4f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v4f32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 40153*/          /*Scope*/ 34, /*->40188*/
/* 40154*/            OPC_MoveChild0,
/* 40155*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40158*/            OPC_RecordChild0, // #2 = $off
/* 40159*/            OPC_MoveChild0,
/* 40160*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 40163*/            OPC_MoveParent,
/* 40164*/            OPC_MoveParent,
/* 40165*/            OPC_RecordChild1, // #3 = $addr
/* 40166*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 40168*/            OPC_CheckType, MVT::i32,
/* 40170*/            OPC_MoveParent,
/* 40171*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40173*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40175*/            OPC_EmitMergeInputChains1_0,
/* 40176*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40179*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v4f32:{ *:[v4f32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v4f32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 40188*/          /*Scope*/ 32, /*->40221*/
/* 40189*/            OPC_RecordChild0, // #2 = $addr
/* 40190*/            OPC_MoveChild1,
/* 40191*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40194*/            OPC_RecordChild0, // #3 = $off
/* 40195*/            OPC_MoveChild0,
/* 40196*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 40199*/            OPC_MoveParent,
/* 40200*/            OPC_MoveParent,
/* 40201*/            OPC_CheckType, MVT::i32,
/* 40203*/            OPC_MoveParent,
/* 40204*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40206*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40208*/            OPC_EmitMergeInputChains1_0,
/* 40209*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40212*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v4f32:{ *:[v4f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v4f32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 40221*/          /*Scope*/ 32, /*->40254*/
/* 40222*/            OPC_MoveChild0,
/* 40223*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40226*/            OPC_RecordChild0, // #2 = $off
/* 40227*/            OPC_MoveChild0,
/* 40228*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 40231*/            OPC_MoveParent,
/* 40232*/            OPC_MoveParent,
/* 40233*/            OPC_RecordChild1, // #3 = $addr
/* 40234*/            OPC_CheckType, MVT::i32,
/* 40236*/            OPC_MoveParent,
/* 40237*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40239*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40241*/            OPC_EmitMergeInputChains1_0,
/* 40242*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40245*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v4f32:{ *:[v4f32] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v4f32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 40254*/          /*Scope*/ 31, /*->40286*/
/* 40255*/            OPC_RecordChild0, // #2 = $addr
/* 40256*/            OPC_RecordChild1, // #3 = $off
/* 40257*/            OPC_MoveChild1,
/* 40258*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40261*/            OPC_MoveParent,
/* 40262*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 40264*/            OPC_CheckType, MVT::i32,
/* 40266*/            OPC_MoveParent,
/* 40267*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40269*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40271*/            OPC_EmitMergeInputChains1_0,
/* 40272*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40275*/            OPC_EmitConvertToTarget, 3,
/* 40277*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st v4f32:{ *:[v4f32] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_v4f32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 40286*/          0, /*End of Scope*/
/* 40287*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->40321
/* 40290*/          OPC_RecordChild0, // #2 = $addr
/* 40291*/          OPC_RecordChild1, // #3 = $off
/* 40292*/          OPC_MoveChild1,
/* 40293*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40296*/          OPC_MoveParent,
/* 40297*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 40299*/          OPC_CheckType, MVT::i32,
/* 40301*/          OPC_MoveParent,
/* 40302*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40304*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40306*/          OPC_EmitMergeInputChains1_0,
/* 40307*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40310*/          OPC_EmitConvertToTarget, 3,
/* 40312*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st v4f32:{ *:[v4f32] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_v4f32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 40321*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->40392
/* 40324*/          OPC_RecordChild0, // #2 = $off
/* 40325*/          OPC_MoveChild0,
/* 40326*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->40359
/* 40330*/            OPC_MoveParent,
/* 40331*/            OPC_MoveParent,
/* 40332*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40334*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40336*/            OPC_EmitMergeInputChains1_0,
/* 40337*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40340*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40343*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40350*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v4f32:{ *:[v4f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v4f32 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4f32:{ *:[v4f32] }:$val)
/* 40359*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->40391
/* 40362*/            OPC_MoveParent,
/* 40363*/            OPC_MoveParent,
/* 40364*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40366*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40368*/            OPC_EmitMergeInputChains1_0,
/* 40369*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40372*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40375*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40382*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v4f32:{ *:[v4f32] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v4f32 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4f32:{ *:[v4f32] }:$val)
/* 40391*/          0, // EndSwitchOpcode
/* 40392*/        0, // EndSwitchOpcode
/* 40393*/      /*Scope*/ 61, /*->40455*/
/* 40394*/        OPC_RecordChild2, // #2 = $off
/* 40395*/        OPC_Scope, 34, /*->40431*/ // 2 children in Scope
/* 40397*/          OPC_MoveChild2,
/* 40398*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40401*/          OPC_MoveParent,
/* 40402*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40404*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40406*/          OPC_EmitMergeInputChains1_0,
/* 40407*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40410*/          OPC_EmitConvertToTarget, 2,
/* 40412*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40415*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40422*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st v4f32:{ *:[v4f32] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_v4f32 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v4f32:{ *:[v4f32] }:$val)
/* 40431*/        /*Scope*/ 22, /*->40454*/
/* 40432*/          OPC_CheckChild2Type, MVT::i32,
/* 40434*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40436*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40438*/          OPC_EmitMergeInputChains1_0,
/* 40439*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40442*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40445*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v4f32), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st v4f32:{ *:[v4f32] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_v4f32 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/* 40454*/        0, /*End of Scope*/
/* 40455*/      0, /*End of Scope*/
/* 40456*/    /*Scope*/ 94|128,2/*350*/, /*->40808*/
/* 40458*/      OPC_CheckChild1Type, MVT::v2f64,
/* 40460*/      OPC_Scope, 26|128,2/*282*/, /*->40745*/ // 2 children in Scope
/* 40463*/        OPC_MoveChild2,
/* 40464*/        OPC_SwitchOpcode /*3 cases */, 42|128,1/*170*/, TARGET_VAL(ISD::ADD),// ->40639
/* 40469*/          OPC_Scope, 34, /*->40505*/ // 5 children in Scope
/* 40471*/            OPC_RecordChild0, // #2 = $addr
/* 40472*/            OPC_MoveChild1,
/* 40473*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40476*/            OPC_RecordChild0, // #3 = $off
/* 40477*/            OPC_MoveChild0,
/* 40478*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 40481*/            OPC_MoveParent,
/* 40482*/            OPC_MoveParent,
/* 40483*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 40485*/            OPC_CheckType, MVT::i32,
/* 40487*/            OPC_MoveParent,
/* 40488*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40490*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40492*/            OPC_EmitMergeInputChains1_0,
/* 40493*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40496*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v2f64:{ *:[v2f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v2f64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 40505*/          /*Scope*/ 34, /*->40540*/
/* 40506*/            OPC_MoveChild0,
/* 40507*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40510*/            OPC_RecordChild0, // #2 = $off
/* 40511*/            OPC_MoveChild0,
/* 40512*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 40515*/            OPC_MoveParent,
/* 40516*/            OPC_MoveParent,
/* 40517*/            OPC_RecordChild1, // #3 = $addr
/* 40518*/            OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 40520*/            OPC_CheckType, MVT::i32,
/* 40522*/            OPC_MoveParent,
/* 40523*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40525*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40527*/            OPC_EmitMergeInputChains1_0,
/* 40528*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40531*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v2f64:{ *:[v2f64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 14
                      // Dst: (STORE_v2f64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 40540*/          /*Scope*/ 32, /*->40573*/
/* 40541*/            OPC_RecordChild0, // #2 = $addr
/* 40542*/            OPC_MoveChild1,
/* 40543*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40546*/            OPC_RecordChild0, // #3 = $off
/* 40547*/            OPC_MoveChild0,
/* 40548*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 40551*/            OPC_MoveParent,
/* 40552*/            OPC_MoveParent,
/* 40553*/            OPC_CheckType, MVT::i32,
/* 40555*/            OPC_MoveParent,
/* 40556*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40558*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40560*/            OPC_EmitMergeInputChains1_0,
/* 40561*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40564*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 3, 2, 1, 
                      // Src: (st v2f64:{ *:[v2f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v2f64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 40573*/          /*Scope*/ 32, /*->40606*/
/* 40574*/            OPC_MoveChild0,
/* 40575*/            OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40578*/            OPC_RecordChild0, // #2 = $off
/* 40579*/            OPC_MoveChild0,
/* 40580*/            OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 40583*/            OPC_MoveParent,
/* 40584*/            OPC_MoveParent,
/* 40585*/            OPC_RecordChild1, // #3 = $addr
/* 40586*/            OPC_CheckType, MVT::i32,
/* 40588*/            OPC_MoveParent,
/* 40589*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40591*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40593*/            OPC_EmitMergeInputChains1_0,
/* 40594*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40597*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 2, 3, 1, 
                      // Src: (st v2f64:{ *:[v2f64] }:$val, (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                      // Dst: (STORE_v2f64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 40606*/          /*Scope*/ 31, /*->40638*/
/* 40607*/            OPC_RecordChild0, // #2 = $addr
/* 40608*/            OPC_RecordChild1, // #3 = $off
/* 40609*/            OPC_MoveChild1,
/* 40610*/            OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40613*/            OPC_MoveParent,
/* 40614*/            OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 40616*/            OPC_CheckType, MVT::i32,
/* 40618*/            OPC_MoveParent,
/* 40619*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40621*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40623*/            OPC_EmitMergeInputChains1_0,
/* 40624*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40627*/            OPC_EmitConvertToTarget, 3,
/* 40629*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 4, 5, 2, 1, 
                      // Src: (st v2f64:{ *:[v2f64] }:$val, (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                      // Dst: (STORE_v2f64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 40638*/          0, /*End of Scope*/
/* 40639*/        /*SwitchOpcode*/ 31, TARGET_VAL(ISD::OR),// ->40673
/* 40642*/          OPC_RecordChild0, // #2 = $addr
/* 40643*/          OPC_RecordChild1, // #3 = $off
/* 40644*/          OPC_MoveChild1,
/* 40645*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40648*/          OPC_MoveParent,
/* 40649*/          OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 40651*/          OPC_CheckType, MVT::i32,
/* 40653*/          OPC_MoveParent,
/* 40654*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40656*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40658*/          OPC_EmitMergeInputChains1_0,
/* 40659*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40662*/          OPC_EmitConvertToTarget, 3,
/* 40664*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 4, 5, 2, 1, 
                    // Src: (st v2f64:{ *:[v2f64] }:$val, (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 11
                    // Dst: (STORE_v2f64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 40673*/        /*SwitchOpcode*/ 68, TARGET_VAL(WebAssemblyISD::Wrapper),// ->40744
/* 40676*/          OPC_RecordChild0, // #2 = $off
/* 40677*/          OPC_MoveChild0,
/* 40678*/          OPC_SwitchOpcode /*2 cases */, 29, TARGET_VAL(ISD::TargetGlobalAddress),// ->40711
/* 40682*/            OPC_MoveParent,
/* 40683*/            OPC_MoveParent,
/* 40684*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40686*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40688*/            OPC_EmitMergeInputChains1_0,
/* 40689*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40692*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40695*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40702*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v2f64:{ *:[v2f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v2f64 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2f64:{ *:[v2f64] }:$val)
/* 40711*/          /*SwitchOpcode*/ 29, TARGET_VAL(ISD::TargetExternalSymbol),// ->40743
/* 40714*/            OPC_MoveParent,
/* 40715*/            OPC_MoveParent,
/* 40716*/            OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40718*/            OPC_CheckPredicate, 18, // Predicate_store
/* 40720*/            OPC_EmitMergeInputChains1_0,
/* 40721*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40724*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40727*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 40734*/            OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                          4/*#Ops*/, 3, 2, 5, 1, 
                      // Src: (st v2f64:{ *:[v2f64] }:$val, (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 10
                      // Dst: (STORE_v2f64 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2f64:{ *:[v2f64] }:$val)
/* 40743*/          0, // EndSwitchOpcode
/* 40744*/        0, // EndSwitchOpcode
/* 40745*/      /*Scope*/ 61, /*->40807*/
/* 40746*/        OPC_RecordChild2, // #2 = $off
/* 40747*/        OPC_Scope, 34, /*->40783*/ // 2 children in Scope
/* 40749*/          OPC_MoveChild2,
/* 40750*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 40753*/          OPC_MoveParent,
/* 40754*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40756*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40758*/          OPC_EmitMergeInputChains1_0,
/* 40759*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40762*/          OPC_EmitConvertToTarget, 2,
/* 40764*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40767*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 40774*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 6, 1, 
                    // Src: (st v2f64:{ *:[v2f64] }:$val, (imm:{ *:[iPTR] }):$off)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 7
                    // Dst: (STORE_v2f64 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), v2f64:{ *:[v2f64] }:$val)
/* 40783*/        /*Scope*/ 22, /*->40806*/
/* 40784*/          OPC_CheckChild2Type, MVT::i32,
/* 40786*/          OPC_CheckPredicate, 17, // Predicate_unindexedstore
/* 40788*/          OPC_CheckPredicate, 18, // Predicate_store
/* 40790*/          OPC_EmitMergeInputChains1_0,
/* 40791*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40794*/          OPC_EmitInteger, MVT::i32, 0, 
/* 40797*/          OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_v2f64), 0|OPFL_Chain|OPFL_MemRefs,
                        4/*#Ops*/, 3, 4, 2, 1, 
                    // Src: (st v2f64:{ *:[v2f64] }:$val, I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 4
                    // Dst: (STORE_v2f64 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/* 40806*/        0, /*End of Scope*/
/* 40807*/      0, /*End of Scope*/
/* 40808*/    0, /*End of Scope*/
/* 40809*/  /*SwitchOpcode*/ 66|128,8/*1090*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->41903
/* 40813*/    OPC_RecordMemRef,
/* 40814*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/* 40815*/    OPC_Scope, 83|128,6/*851*/, /*->41669*/ // 2 children in Scope
/* 40818*/      OPC_MoveChild1,
/* 40819*/      OPC_SwitchOpcode /*3 cases */, 102|128,3/*486*/, TARGET_VAL(ISD::ADD),// ->41310
/* 40824*/        OPC_Scope, 96, /*->40922*/ // 5 children in Scope
/* 40826*/          OPC_RecordChild0, // #1 = $addr
/* 40827*/          OPC_MoveChild1,
/* 40828*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40831*/          OPC_RecordChild0, // #2 = $off
/* 40832*/          OPC_MoveChild0,
/* 40833*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 40836*/          OPC_MoveParent,
/* 40837*/          OPC_MoveParent,
/* 40838*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 40840*/          OPC_CheckType, MVT::i32,
/* 40842*/          OPC_MoveParent,
/* 40843*/          OPC_SwitchType /*2 cases */, 56, MVT::i32,// ->40902
/* 40846*/            OPC_Scope, 17, /*->40865*/ // 3 children in Scope
/* 40848*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 40850*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 40852*/              OPC_EmitMergeInputChains1_0,
/* 40853*/              OPC_EmitInteger, MVT::i32, 0, 
/* 40856*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_32>> - Complexity = 14
                        // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 40865*/            /*Scope*/ 17, /*->40883*/
/* 40866*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 40868*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 40870*/              OPC_EmitMergeInputChains1_0,
/* 40871*/              OPC_EmitInteger, MVT::i32, 0, 
/* 40874*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>> - Complexity = 14
                        // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 40883*/            /*Scope*/ 17, /*->40901*/
/* 40884*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 40886*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 40888*/              OPC_EmitMergeInputChains1_0,
/* 40889*/              OPC_EmitInteger, MVT::i32, 0, 
/* 40892*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>> - Complexity = 14
                        // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 40901*/            0, /*End of Scope*/
/* 40902*/          /*SwitchType*/ 17, MVT::i64,// ->40921
/* 40904*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 40906*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 40908*/            OPC_EmitMergeInputChains1_0,
/* 40909*/            OPC_EmitInteger, MVT::i32, 0, 
/* 40912*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (atomic_load:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_64>> - Complexity = 14
                      // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 40921*/          0, // EndSwitchType
/* 40922*/        /*Scope*/ 96, /*->41019*/
/* 40923*/          OPC_MoveChild0,
/* 40924*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 40927*/          OPC_RecordChild0, // #1 = $off
/* 40928*/          OPC_MoveChild0,
/* 40929*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 40932*/          OPC_MoveParent,
/* 40933*/          OPC_MoveParent,
/* 40934*/          OPC_RecordChild1, // #2 = $addr
/* 40935*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 40937*/          OPC_CheckType, MVT::i32,
/* 40939*/          OPC_MoveParent,
/* 40940*/          OPC_SwitchType /*2 cases */, 56, MVT::i32,// ->40999
/* 40943*/            OPC_Scope, 17, /*->40962*/ // 3 children in Scope
/* 40945*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 40947*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 40949*/              OPC_EmitMergeInputChains1_0,
/* 40950*/              OPC_EmitInteger, MVT::i32, 0, 
/* 40953*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_32>> - Complexity = 14
                        // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 40962*/            /*Scope*/ 17, /*->40980*/
/* 40963*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 40965*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 40967*/              OPC_EmitMergeInputChains1_0,
/* 40968*/              OPC_EmitInteger, MVT::i32, 0, 
/* 40971*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_8>> - Complexity = 14
                        // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 40980*/            /*Scope*/ 17, /*->40998*/
/* 40981*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 40983*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 40985*/              OPC_EmitMergeInputChains1_0,
/* 40986*/              OPC_EmitInteger, MVT::i32, 0, 
/* 40989*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_16>> - Complexity = 14
                        // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 40998*/            0, /*End of Scope*/
/* 40999*/          /*SwitchType*/ 17, MVT::i64,// ->41018
/* 41001*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41003*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41005*/            OPC_EmitMergeInputChains1_0,
/* 41006*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41009*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (atomic_load:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>)<<P:Predicate_atomic_load_64>> - Complexity = 14
                      // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41018*/          0, // EndSwitchType
/* 41019*/        /*Scope*/ 94, /*->41114*/
/* 41020*/          OPC_RecordChild0, // #1 = $addr
/* 41021*/          OPC_MoveChild1,
/* 41022*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 41025*/          OPC_RecordChild0, // #2 = $off
/* 41026*/          OPC_MoveChild0,
/* 41027*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 41030*/          OPC_MoveParent,
/* 41031*/          OPC_MoveParent,
/* 41032*/          OPC_CheckType, MVT::i32,
/* 41034*/          OPC_MoveParent,
/* 41035*/          OPC_SwitchType /*2 cases */, 56, MVT::i32,// ->41094
/* 41038*/            OPC_Scope, 17, /*->41057*/ // 3 children in Scope
/* 41040*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41042*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41044*/              OPC_EmitMergeInputChains1_0,
/* 41045*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41048*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_32>> - Complexity = 13
                        // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41057*/            /*Scope*/ 17, /*->41075*/
/* 41058*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41060*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41062*/              OPC_EmitMergeInputChains1_0,
/* 41063*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41066*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_8>> - Complexity = 13
                        // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41075*/            /*Scope*/ 17, /*->41093*/
/* 41076*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41078*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41080*/              OPC_EmitMergeInputChains1_0,
/* 41081*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41084*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 2, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_16>> - Complexity = 13
                        // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41093*/            0, /*End of Scope*/
/* 41094*/          /*SwitchType*/ 17, MVT::i64,// ->41113
/* 41096*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41098*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41100*/            OPC_EmitMergeInputChains1_0,
/* 41101*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41104*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 2, 1, 
                      // Src: (atomic_load:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)))<<P:Predicate_atomic_load_64>> - Complexity = 13
                      // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41113*/          0, // EndSwitchType
/* 41114*/        /*Scope*/ 94, /*->41209*/
/* 41115*/          OPC_MoveChild0,
/* 41116*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 41119*/          OPC_RecordChild0, // #1 = $off
/* 41120*/          OPC_MoveChild0,
/* 41121*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 41124*/          OPC_MoveParent,
/* 41125*/          OPC_MoveParent,
/* 41126*/          OPC_RecordChild1, // #2 = $addr
/* 41127*/          OPC_CheckType, MVT::i32,
/* 41129*/          OPC_MoveParent,
/* 41130*/          OPC_SwitchType /*2 cases */, 56, MVT::i32,// ->41189
/* 41133*/            OPC_Scope, 17, /*->41152*/ // 3 children in Scope
/* 41135*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41137*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41139*/              OPC_EmitMergeInputChains1_0,
/* 41140*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41143*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
                        // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41152*/            /*Scope*/ 17, /*->41170*/
/* 41153*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41155*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41157*/              OPC_EmitMergeInputChains1_0,
/* 41158*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41161*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
                        // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41170*/            /*Scope*/ 17, /*->41188*/
/* 41171*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41173*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41175*/              OPC_EmitMergeInputChains1_0,
/* 41176*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41179*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 1, 2, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
                        // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41188*/            0, /*End of Scope*/
/* 41189*/          /*SwitchType*/ 17, MVT::i64,// ->41208
/* 41191*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41193*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41195*/            OPC_EmitMergeInputChains1_0,
/* 41196*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41199*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 1, 2, 
                      // Src: (atomic_load:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
                      // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41208*/          0, // EndSwitchType
/* 41209*/        /*Scope*/ 99, /*->41309*/
/* 41210*/          OPC_RecordChild0, // #1 = $addr
/* 41211*/          OPC_RecordChild1, // #2 = $off
/* 41212*/          OPC_MoveChild1,
/* 41213*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 41216*/          OPC_MoveParent,
/* 41217*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 41219*/          OPC_CheckType, MVT::i32,
/* 41221*/          OPC_MoveParent,
/* 41222*/          OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->41287
/* 41225*/            OPC_Scope, 19, /*->41246*/ // 3 children in Scope
/* 41227*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41229*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41231*/              OPC_EmitMergeInputChains1_0,
/* 41232*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41235*/              OPC_EmitConvertToTarget, 2,
/* 41237*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_32>> - Complexity = 11
                        // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41246*/            /*Scope*/ 19, /*->41266*/
/* 41247*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41249*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41251*/              OPC_EmitMergeInputChains1_0,
/* 41252*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41255*/              OPC_EmitConvertToTarget, 2,
/* 41257*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_8>> - Complexity = 11
                        // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41266*/            /*Scope*/ 19, /*->41286*/
/* 41267*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41269*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41271*/              OPC_EmitMergeInputChains1_0,
/* 41272*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41275*/              OPC_EmitConvertToTarget, 2,
/* 41277*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                        // Src: (atomic_load:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_16>> - Complexity = 11
                        // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41286*/            0, /*End of Scope*/
/* 41287*/          /*SwitchType*/ 19, MVT::i64,// ->41308
/* 41289*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41291*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41293*/            OPC_EmitMergeInputChains1_0,
/* 41294*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41297*/            OPC_EmitConvertToTarget, 2,
/* 41299*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (atomic_load:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>)<<P:Predicate_atomic_load_64>> - Complexity = 11
                      // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41308*/          0, // EndSwitchType
/* 41309*/        0, /*End of Scope*/
/* 41310*/      /*SwitchOpcode*/ 99, TARGET_VAL(ISD::OR),// ->41412
/* 41313*/        OPC_RecordChild0, // #1 = $addr
/* 41314*/        OPC_RecordChild1, // #2 = $off
/* 41315*/        OPC_MoveChild1,
/* 41316*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 41319*/        OPC_MoveParent,
/* 41320*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 41322*/        OPC_CheckType, MVT::i32,
/* 41324*/        OPC_MoveParent,
/* 41325*/        OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->41390
/* 41328*/          OPC_Scope, 19, /*->41349*/ // 3 children in Scope
/* 41330*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41332*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41334*/            OPC_EmitMergeInputChains1_0,
/* 41335*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41338*/            OPC_EmitConvertToTarget, 2,
/* 41340*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_32>> - Complexity = 11
                      // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41349*/          /*Scope*/ 19, /*->41369*/
/* 41350*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41352*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41354*/            OPC_EmitMergeInputChains1_0,
/* 41355*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41358*/            OPC_EmitConvertToTarget, 2,
/* 41360*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_8>> - Complexity = 11
                      // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41369*/          /*Scope*/ 19, /*->41389*/
/* 41370*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41372*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41374*/            OPC_EmitMergeInputChains1_0,
/* 41375*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41378*/            OPC_EmitConvertToTarget, 2,
/* 41380*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 3, 4, 1, 
                      // Src: (atomic_load:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_16>> - Complexity = 11
                      // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41389*/          0, /*End of Scope*/
/* 41390*/        /*SwitchType*/ 19, MVT::i64,// ->41411
/* 41392*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41394*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41396*/          OPC_EmitMergeInputChains1_0,
/* 41397*/          OPC_EmitInteger, MVT::i32, 0, 
/* 41400*/          OPC_EmitConvertToTarget, 2,
/* 41402*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 3, 4, 1, 
                    // Src: (atomic_load:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>)<<P:Predicate_atomic_load_64>> - Complexity = 11
                    // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr)
/* 41411*/        0, // EndSwitchType
/* 41412*/      /*SwitchOpcode*/ 124|128,1/*252*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->41668
/* 41416*/        OPC_RecordChild0, // #1 = $off
/* 41417*/        OPC_MoveChild0,
/* 41418*/        OPC_SwitchOpcode /*2 cases */, 121, TARGET_VAL(ISD::TargetGlobalAddress),// ->41543
/* 41422*/          OPC_MoveParent,
/* 41423*/          OPC_MoveParent,
/* 41424*/          OPC_SwitchType /*2 cases */, 86, MVT::i32,// ->41513
/* 41427*/            OPC_Scope, 27, /*->41456*/ // 3 children in Scope
/* 41429*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41431*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41433*/              OPC_EmitMergeInputChains1_0,
/* 41434*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41437*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41440*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41447*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_32>> - Complexity = 10
                        // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41456*/            /*Scope*/ 27, /*->41484*/
/* 41457*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41459*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41461*/              OPC_EmitMergeInputChains1_0,
/* 41462*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41465*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41468*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41475*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>> - Complexity = 10
                        // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41484*/            /*Scope*/ 27, /*->41512*/
/* 41485*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41487*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41489*/              OPC_EmitMergeInputChains1_0,
/* 41490*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41493*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41496*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41503*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>> - Complexity = 10
                        // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41512*/            0, /*End of Scope*/
/* 41513*/          /*SwitchType*/ 27, MVT::i64,// ->41542
/* 41515*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41517*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41519*/            OPC_EmitMergeInputChains1_0,
/* 41520*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41523*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41526*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41533*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (atomic_load:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_64>> - Complexity = 10
                      // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41542*/          0, // EndSwitchType
/* 41543*/        /*SwitchOpcode*/ 121, TARGET_VAL(ISD::TargetExternalSymbol),// ->41667
/* 41546*/          OPC_MoveParent,
/* 41547*/          OPC_MoveParent,
/* 41548*/          OPC_SwitchType /*2 cases */, 86, MVT::i32,// ->41637
/* 41551*/            OPC_Scope, 27, /*->41580*/ // 3 children in Scope
/* 41553*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41555*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41557*/              OPC_EmitMergeInputChains1_0,
/* 41558*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41561*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41564*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41571*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_32>> - Complexity = 10
                        // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41580*/            /*Scope*/ 27, /*->41608*/
/* 41581*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41583*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41585*/              OPC_EmitMergeInputChains1_0,
/* 41586*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41589*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41592*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41599*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_8>> - Complexity = 10
                        // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41608*/            /*Scope*/ 27, /*->41636*/
/* 41609*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41611*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41613*/              OPC_EmitMergeInputChains1_0,
/* 41614*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41617*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41620*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41627*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 3/*#Ops*/, 2, 1, 4, 
                        // Src: (atomic_load:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_16>> - Complexity = 10
                        // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41636*/            0, /*End of Scope*/
/* 41637*/          /*SwitchType*/ 27, MVT::i64,// ->41666
/* 41639*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41641*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41643*/            OPC_EmitMergeInputChains1_0,
/* 41644*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41647*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41650*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 3,  // Results = #4
/* 41657*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 3/*#Ops*/, 2, 1, 4, 
                      // Src: (atomic_load:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off))<<P:Predicate_atomic_load_64>> - Complexity = 10
                      // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41666*/          0, // EndSwitchType
/* 41667*/        0, // EndSwitchOpcode
/* 41668*/      0, // EndSwitchOpcode
/* 41669*/    /*Scope*/ 103|128,1/*231*/, /*->41902*/
/* 41671*/      OPC_RecordChild1, // #1 = $off
/* 41672*/      OPC_Scope, 4|128,1/*132*/, /*->41807*/ // 2 children in Scope
/* 41675*/        OPC_MoveChild1,
/* 41676*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 41679*/        OPC_MoveParent,
/* 41680*/        OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->41775
/* 41683*/          OPC_Scope, 29, /*->41714*/ // 3 children in Scope
/* 41685*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41687*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41689*/            OPC_EmitMergeInputChains1_0,
/* 41690*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41693*/            OPC_EmitConvertToTarget, 1,
/* 41695*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41698*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41705*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                      // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_32>> - Complexity = 7
                      // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41714*/          /*Scope*/ 29, /*->41744*/
/* 41715*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41717*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41719*/            OPC_EmitMergeInputChains1_0,
/* 41720*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41723*/            OPC_EmitConvertToTarget, 1,
/* 41725*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41728*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41735*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                      // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_8>> - Complexity = 7
                      // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41744*/          /*Scope*/ 29, /*->41774*/
/* 41745*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41747*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41749*/            OPC_EmitMergeInputChains1_0,
/* 41750*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41753*/            OPC_EmitConvertToTarget, 1,
/* 41755*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41758*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41765*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 5, 
                      // Src: (atomic_load:{ *:[i32] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_16>> - Complexity = 7
                      // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41774*/          0, /*End of Scope*/
/* 41775*/        /*SwitchType*/ 29, MVT::i64,// ->41806
/* 41777*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41779*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41781*/          OPC_EmitMergeInputChains1_0,
/* 41782*/          OPC_EmitInteger, MVT::i32, 0, 
/* 41785*/          OPC_EmitConvertToTarget, 1,
/* 41787*/          OPC_EmitInteger, MVT::i32, 0, 
/* 41790*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 41797*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 5, 
                    // Src: (atomic_load:{ *:[i64] } (imm:{ *:[iPTR] }):$off)<<P:Predicate_atomic_load_64>> - Complexity = 7
                    // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }))
/* 41806*/        0, // EndSwitchType
/* 41807*/      /*Scope*/ 93, /*->41901*/
/* 41808*/        OPC_CheckChild1Type, MVT::i32,
/* 41810*/        OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->41878
/* 41813*/          OPC_Scope, 20, /*->41835*/ // 3 children in Scope
/* 41815*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_32
/* 41817*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41819*/            OPC_EmitMergeInputChains1_0,
/* 41820*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41823*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41826*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                      // Src: (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_32>> - Complexity = 4
                      // Dst: (ATOMIC_LOAD_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 41835*/          /*Scope*/ 20, /*->41856*/
/* 41836*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_8
/* 41838*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41840*/            OPC_EmitMergeInputChains1_0,
/* 41841*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41844*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41847*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                      // Src: (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_8>> - Complexity = 4
                      // Dst: (ATOMIC_LOAD8_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 41856*/          /*Scope*/ 20, /*->41877*/
/* 41857*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_16
/* 41859*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41861*/            OPC_EmitMergeInputChains1_0,
/* 41862*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41865*/            OPC_EmitInteger, MVT::i32, 0, 
/* 41868*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 3/*#Ops*/, 2, 3, 1, 
                      // Src: (atomic_load:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_16>> - Complexity = 4
                      // Dst: (ATOMIC_LOAD16_U_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 41877*/          0, /*End of Scope*/
/* 41878*/        /*SwitchType*/ 20, MVT::i64,// ->41900
/* 41880*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_64
/* 41882*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41884*/          OPC_EmitMergeInputChains1_0,
/* 41885*/          OPC_EmitInteger, MVT::i32, 0, 
/* 41888*/          OPC_EmitInteger, MVT::i32, 0, 
/* 41891*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 3/*#Ops*/, 2, 3, 1, 
                    // Src: (atomic_load:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_atomic_load_64>> - Complexity = 4
                    // Dst: (ATOMIC_LOAD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr)
/* 41900*/        0, // EndSwitchType
/* 41901*/      0, /*End of Scope*/
/* 41902*/    0, /*End of Scope*/
/* 41903*/  /*SwitchOpcode*/ 116|128,8/*1140*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->43047
/* 41907*/    OPC_RecordMemRef,
/* 41908*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/* 41909*/    OPC_Scope, 123|128,6/*891*/, /*->42803*/ // 2 children in Scope
/* 41912*/      OPC_MoveChild1,
/* 41913*/      OPC_SwitchOpcode /*3 cases */, 127|128,3/*511*/, TARGET_VAL(ISD::ADD),// ->42429
/* 41918*/        OPC_Scope, 101, /*->42021*/ // 5 children in Scope
/* 41920*/          OPC_RecordChild0, // #1 = $addr
/* 41921*/          OPC_MoveChild1,
/* 41922*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 41925*/          OPC_RecordChild0, // #2 = $off
/* 41926*/          OPC_MoveChild0,
/* 41927*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 41930*/          OPC_MoveParent,
/* 41931*/          OPC_MoveParent,
/* 41932*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 41934*/          OPC_CheckType, MVT::i32,
/* 41936*/          OPC_MoveParent,
/* 41937*/          OPC_RecordChild2, // #3 = $val
/* 41938*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->42000
/* 41941*/            OPC_Scope, 18, /*->41961*/ // 3 children in Scope
/* 41943*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 41945*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41947*/              OPC_EmitMergeInputChains1_0,
/* 41948*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41951*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41961*/            /*Scope*/ 18, /*->41980*/
/* 41962*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 41964*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41966*/              OPC_EmitMergeInputChains1_0,
/* 41967*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41970*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41980*/            /*Scope*/ 18, /*->41999*/
/* 41981*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 41983*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 41985*/              OPC_EmitMergeInputChains1_0,
/* 41986*/              OPC_EmitInteger, MVT::i32, 0, 
/* 41989*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 41999*/            0, /*End of Scope*/
/* 42000*/          /*SwitchType*/ 18, MVT::i64,// ->42020
/* 42002*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42004*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42006*/            OPC_EmitMergeInputChains1_0,
/* 42007*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42010*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_add:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42020*/          0, // EndSwitchType
/* 42021*/        /*Scope*/ 101, /*->42123*/
/* 42022*/          OPC_MoveChild0,
/* 42023*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 42026*/          OPC_RecordChild0, // #1 = $off
/* 42027*/          OPC_MoveChild0,
/* 42028*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 42031*/          OPC_MoveParent,
/* 42032*/          OPC_MoveParent,
/* 42033*/          OPC_RecordChild1, // #2 = $addr
/* 42034*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 42036*/          OPC_CheckType, MVT::i32,
/* 42038*/          OPC_MoveParent,
/* 42039*/          OPC_RecordChild2, // #3 = $val
/* 42040*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->42102
/* 42043*/            OPC_Scope, 18, /*->42063*/ // 3 children in Scope
/* 42045*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42047*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42049*/              OPC_EmitMergeInputChains1_0,
/* 42050*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42053*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42063*/            /*Scope*/ 18, /*->42082*/
/* 42064*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42066*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42068*/              OPC_EmitMergeInputChains1_0,
/* 42069*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42072*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42082*/            /*Scope*/ 18, /*->42101*/
/* 42083*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42085*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42087*/              OPC_EmitMergeInputChains1_0,
/* 42088*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42091*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42101*/            0, /*End of Scope*/
/* 42102*/          /*SwitchType*/ 18, MVT::i64,// ->42122
/* 42104*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42106*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42108*/            OPC_EmitMergeInputChains1_0,
/* 42109*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42112*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_add:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42122*/          0, // EndSwitchType
/* 42123*/        /*Scope*/ 99, /*->42223*/
/* 42124*/          OPC_RecordChild0, // #1 = $addr
/* 42125*/          OPC_MoveChild1,
/* 42126*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 42129*/          OPC_RecordChild0, // #2 = $off
/* 42130*/          OPC_MoveChild0,
/* 42131*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 42134*/          OPC_MoveParent,
/* 42135*/          OPC_MoveParent,
/* 42136*/          OPC_CheckType, MVT::i32,
/* 42138*/          OPC_MoveParent,
/* 42139*/          OPC_RecordChild2, // #3 = $val
/* 42140*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->42202
/* 42143*/            OPC_Scope, 18, /*->42163*/ // 3 children in Scope
/* 42145*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42147*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42149*/              OPC_EmitMergeInputChains1_0,
/* 42150*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42153*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42163*/            /*Scope*/ 18, /*->42182*/
/* 42164*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42166*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42168*/              OPC_EmitMergeInputChains1_0,
/* 42169*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42172*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42182*/            /*Scope*/ 18, /*->42201*/
/* 42183*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42185*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42187*/              OPC_EmitMergeInputChains1_0,
/* 42188*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42191*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42201*/            0, /*End of Scope*/
/* 42202*/          /*SwitchType*/ 18, MVT::i64,// ->42222
/* 42204*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42206*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42208*/            OPC_EmitMergeInputChains1_0,
/* 42209*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42212*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_add:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42222*/          0, // EndSwitchType
/* 42223*/        /*Scope*/ 99, /*->42323*/
/* 42224*/          OPC_MoveChild0,
/* 42225*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 42228*/          OPC_RecordChild0, // #1 = $off
/* 42229*/          OPC_MoveChild0,
/* 42230*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 42233*/          OPC_MoveParent,
/* 42234*/          OPC_MoveParent,
/* 42235*/          OPC_RecordChild1, // #2 = $addr
/* 42236*/          OPC_CheckType, MVT::i32,
/* 42238*/          OPC_MoveParent,
/* 42239*/          OPC_RecordChild2, // #3 = $val
/* 42240*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->42302
/* 42243*/            OPC_Scope, 18, /*->42263*/ // 3 children in Scope
/* 42245*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42247*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42249*/              OPC_EmitMergeInputChains1_0,
/* 42250*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42253*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42263*/            /*Scope*/ 18, /*->42282*/
/* 42264*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42266*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42268*/              OPC_EmitMergeInputChains1_0,
/* 42269*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42272*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42282*/            /*Scope*/ 18, /*->42301*/
/* 42283*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42285*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42287*/              OPC_EmitMergeInputChains1_0,
/* 42288*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42291*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42301*/            0, /*End of Scope*/
/* 42302*/          /*SwitchType*/ 18, MVT::i64,// ->42322
/* 42304*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42306*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42308*/            OPC_EmitMergeInputChains1_0,
/* 42309*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42312*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_add:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42322*/          0, // EndSwitchType
/* 42323*/        /*Scope*/ 104, /*->42428*/
/* 42324*/          OPC_RecordChild0, // #1 = $addr
/* 42325*/          OPC_RecordChild1, // #2 = $off
/* 42326*/          OPC_MoveChild1,
/* 42327*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 42330*/          OPC_MoveParent,
/* 42331*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 42333*/          OPC_CheckType, MVT::i32,
/* 42335*/          OPC_MoveParent,
/* 42336*/          OPC_RecordChild2, // #3 = $val
/* 42337*/          OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->42405
/* 42340*/            OPC_Scope, 20, /*->42362*/ // 3 children in Scope
/* 42342*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42344*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42346*/              OPC_EmitMergeInputChains1_0,
/* 42347*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42350*/              OPC_EmitConvertToTarget, 2,
/* 42352*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 11
                        // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42362*/            /*Scope*/ 20, /*->42383*/
/* 42363*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42365*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42367*/              OPC_EmitMergeInputChains1_0,
/* 42368*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42371*/              OPC_EmitConvertToTarget, 2,
/* 42373*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                        // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42383*/            /*Scope*/ 20, /*->42404*/
/* 42384*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42386*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42388*/              OPC_EmitMergeInputChains1_0,
/* 42389*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42392*/              OPC_EmitConvertToTarget, 2,
/* 42394*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_add:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                        // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42404*/            0, /*End of Scope*/
/* 42405*/          /*SwitchType*/ 20, MVT::i64,// ->42427
/* 42407*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42409*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42411*/            OPC_EmitMergeInputChains1_0,
/* 42412*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42415*/            OPC_EmitConvertToTarget, 2,
/* 42417*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_add:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42427*/          0, // EndSwitchType
/* 42428*/        0, /*End of Scope*/
/* 42429*/      /*SwitchOpcode*/ 104, TARGET_VAL(ISD::OR),// ->42536
/* 42432*/        OPC_RecordChild0, // #1 = $addr
/* 42433*/        OPC_RecordChild1, // #2 = $off
/* 42434*/        OPC_MoveChild1,
/* 42435*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 42438*/        OPC_MoveParent,
/* 42439*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 42441*/        OPC_CheckType, MVT::i32,
/* 42443*/        OPC_MoveParent,
/* 42444*/        OPC_RecordChild2, // #3 = $val
/* 42445*/        OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->42513
/* 42448*/          OPC_Scope, 20, /*->42470*/ // 3 children in Scope
/* 42450*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42452*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42454*/            OPC_EmitMergeInputChains1_0,
/* 42455*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42458*/            OPC_EmitConvertToTarget, 2,
/* 42460*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42470*/          /*Scope*/ 20, /*->42491*/
/* 42471*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42473*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42475*/            OPC_EmitMergeInputChains1_0,
/* 42476*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42479*/            OPC_EmitConvertToTarget, 2,
/* 42481*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 11
                      // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42491*/          /*Scope*/ 20, /*->42512*/
/* 42492*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42494*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42496*/            OPC_EmitMergeInputChains1_0,
/* 42497*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42500*/            OPC_EmitConvertToTarget, 2,
/* 42502*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_add:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 11
                      // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42512*/          0, /*End of Scope*/
/* 42513*/        /*SwitchType*/ 20, MVT::i64,// ->42535
/* 42515*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42517*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42519*/          OPC_EmitMergeInputChains1_0,
/* 42520*/          OPC_EmitInteger, MVT::i32, 0, 
/* 42523*/          OPC_EmitConvertToTarget, 2,
/* 42525*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                    // Src: (atomic_load_add:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 11
                    // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 42535*/        0, // EndSwitchType
/* 42536*/      /*SwitchOpcode*/ 6|128,2/*262*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->42802
/* 42540*/        OPC_RecordChild0, // #1 = $off
/* 42541*/        OPC_MoveChild0,
/* 42542*/        OPC_SwitchOpcode /*2 cases */, 126, TARGET_VAL(ISD::TargetGlobalAddress),// ->42672
/* 42546*/          OPC_MoveParent,
/* 42547*/          OPC_MoveParent,
/* 42548*/          OPC_RecordChild2, // #2 = $val
/* 42549*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->42641
/* 42552*/            OPC_Scope, 28, /*->42582*/ // 3 children in Scope
/* 42554*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42556*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42558*/              OPC_EmitMergeInputChains1_0,
/* 42559*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42562*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42565*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42572*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42582*/            /*Scope*/ 28, /*->42611*/
/* 42583*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42585*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42587*/              OPC_EmitMergeInputChains1_0,
/* 42588*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42591*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42594*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42601*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42611*/            /*Scope*/ 28, /*->42640*/
/* 42612*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42614*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42616*/              OPC_EmitMergeInputChains1_0,
/* 42617*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42620*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42623*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42630*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42640*/            0, /*End of Scope*/
/* 42641*/          /*SwitchType*/ 28, MVT::i64,// ->42671
/* 42643*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42645*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42647*/            OPC_EmitMergeInputChains1_0,
/* 42648*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42651*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42654*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42661*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_add:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 42671*/          0, // EndSwitchType
/* 42672*/        /*SwitchOpcode*/ 126, TARGET_VAL(ISD::TargetExternalSymbol),// ->42801
/* 42675*/          OPC_MoveParent,
/* 42676*/          OPC_MoveParent,
/* 42677*/          OPC_RecordChild2, // #2 = $val
/* 42678*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->42770
/* 42681*/            OPC_Scope, 28, /*->42711*/ // 3 children in Scope
/* 42683*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42685*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42687*/              OPC_EmitMergeInputChains1_0,
/* 42688*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42691*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42694*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42701*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42711*/            /*Scope*/ 28, /*->42740*/
/* 42712*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42714*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42716*/              OPC_EmitMergeInputChains1_0,
/* 42717*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42720*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42723*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42730*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42740*/            /*Scope*/ 28, /*->42769*/
/* 42741*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42743*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42745*/              OPC_EmitMergeInputChains1_0,
/* 42746*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42749*/              OPC_EmitInteger, MVT::i32, 0, 
/* 42752*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42759*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_add:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42769*/            0, /*End of Scope*/
/* 42770*/          /*SwitchType*/ 28, MVT::i64,// ->42800
/* 42772*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42774*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42776*/            OPC_EmitMergeInputChains1_0,
/* 42777*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42780*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42783*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 42790*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_add:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 42800*/          0, // EndSwitchType
/* 42801*/        0, // EndSwitchOpcode
/* 42802*/      0, // EndSwitchOpcode
/* 42803*/    /*Scope*/ 113|128,1/*241*/, /*->43046*/
/* 42805*/      OPC_RecordChild1, // #1 = $off
/* 42806*/      OPC_Scope, 9|128,1/*137*/, /*->42946*/ // 2 children in Scope
/* 42809*/        OPC_MoveChild1,
/* 42810*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 42813*/        OPC_MoveParent,
/* 42814*/        OPC_RecordChild2, // #2 = $val
/* 42815*/        OPC_SwitchType /*2 cases */, 95, MVT::i32,// ->42913
/* 42818*/          OPC_Scope, 30, /*->42850*/ // 3 children in Scope
/* 42820*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42822*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42824*/            OPC_EmitMergeInputChains1_0,
/* 42825*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42828*/            OPC_EmitConvertToTarget, 1,
/* 42830*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42833*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42840*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 7
                      // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42850*/          /*Scope*/ 30, /*->42881*/
/* 42851*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42853*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42855*/            OPC_EmitMergeInputChains1_0,
/* 42856*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42859*/            OPC_EmitConvertToTarget, 1,
/* 42861*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42864*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42871*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 7
                      // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42881*/          /*Scope*/ 30, /*->42912*/
/* 42882*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 42884*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42886*/            OPC_EmitMergeInputChains1_0,
/* 42887*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42890*/            OPC_EmitConvertToTarget, 1,
/* 42892*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42895*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42902*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_add:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 7
                      // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 42912*/          0, /*End of Scope*/
/* 42913*/        /*SwitchType*/ 30, MVT::i64,// ->42945
/* 42915*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 42917*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42919*/          OPC_EmitMergeInputChains1_0,
/* 42920*/          OPC_EmitInteger, MVT::i32, 0, 
/* 42923*/          OPC_EmitConvertToTarget, 1,
/* 42925*/          OPC_EmitInteger, MVT::i32, 0, 
/* 42928*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 42935*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (atomic_load_add:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 7
                    // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 42945*/        0, // EndSwitchType
/* 42946*/      /*Scope*/ 98, /*->43045*/
/* 42947*/        OPC_CheckChild1Type, MVT::i32,
/* 42949*/        OPC_RecordChild2, // #2 = $val
/* 42950*/        OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->43021
/* 42953*/          OPC_Scope, 21, /*->42976*/ // 3 children in Scope
/* 42955*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_add_32
/* 42957*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42959*/            OPC_EmitMergeInputChains1_0,
/* 42960*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42963*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42966*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 4
                      // Dst: (ATOMIC_RMW_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42976*/          /*Scope*/ 21, /*->42998*/
/* 42977*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_add_8
/* 42979*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 42981*/            OPC_EmitMergeInputChains1_0,
/* 42982*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42985*/            OPC_EmitInteger, MVT::i32, 0, 
/* 42988*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 4
                      // Dst: (ATOMIC_RMW8_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 42998*/          /*Scope*/ 21, /*->43020*/
/* 42999*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_add_16
/* 43001*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43003*/            OPC_EmitMergeInputChains1_0,
/* 43004*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43007*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43010*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_add:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 4
                      // Dst: (ATOMIC_RMW16_U_ADD_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43020*/          0, /*End of Scope*/
/* 43021*/        /*SwitchType*/ 21, MVT::i64,// ->43044
/* 43023*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_add_64
/* 43025*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43027*/          OPC_EmitMergeInputChains1_0,
/* 43028*/          OPC_EmitInteger, MVT::i32, 0, 
/* 43031*/          OPC_EmitInteger, MVT::i32, 0, 
/* 43034*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_load_add:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 4
                    // Dst: (ATOMIC_RMW_ADD_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43044*/        0, // EndSwitchType
/* 43045*/      0, /*End of Scope*/
/* 43046*/    0, /*End of Scope*/
/* 43047*/  /*SwitchOpcode*/ 116|128,8/*1140*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->44191
/* 43051*/    OPC_RecordMemRef,
/* 43052*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/* 43053*/    OPC_Scope, 123|128,6/*891*/, /*->43947*/ // 2 children in Scope
/* 43056*/      OPC_MoveChild1,
/* 43057*/      OPC_SwitchOpcode /*3 cases */, 127|128,3/*511*/, TARGET_VAL(ISD::ADD),// ->43573
/* 43062*/        OPC_Scope, 101, /*->43165*/ // 5 children in Scope
/* 43064*/          OPC_RecordChild0, // #1 = $addr
/* 43065*/          OPC_MoveChild1,
/* 43066*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 43069*/          OPC_RecordChild0, // #2 = $off
/* 43070*/          OPC_MoveChild0,
/* 43071*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 43074*/          OPC_MoveParent,
/* 43075*/          OPC_MoveParent,
/* 43076*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 43078*/          OPC_CheckType, MVT::i32,
/* 43080*/          OPC_MoveParent,
/* 43081*/          OPC_RecordChild2, // #3 = $val
/* 43082*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->43144
/* 43085*/            OPC_Scope, 18, /*->43105*/ // 3 children in Scope
/* 43087*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43089*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43091*/              OPC_EmitMergeInputChains1_0,
/* 43092*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43095*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43105*/            /*Scope*/ 18, /*->43124*/
/* 43106*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43108*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43110*/              OPC_EmitMergeInputChains1_0,
/* 43111*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43114*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43124*/            /*Scope*/ 18, /*->43143*/
/* 43125*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43127*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43129*/              OPC_EmitMergeInputChains1_0,
/* 43130*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43133*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43143*/            0, /*End of Scope*/
/* 43144*/          /*SwitchType*/ 18, MVT::i64,// ->43164
/* 43146*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43148*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43150*/            OPC_EmitMergeInputChains1_0,
/* 43151*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43154*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_sub:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43164*/          0, // EndSwitchType
/* 43165*/        /*Scope*/ 101, /*->43267*/
/* 43166*/          OPC_MoveChild0,
/* 43167*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 43170*/          OPC_RecordChild0, // #1 = $off
/* 43171*/          OPC_MoveChild0,
/* 43172*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 43175*/          OPC_MoveParent,
/* 43176*/          OPC_MoveParent,
/* 43177*/          OPC_RecordChild1, // #2 = $addr
/* 43178*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 43180*/          OPC_CheckType, MVT::i32,
/* 43182*/          OPC_MoveParent,
/* 43183*/          OPC_RecordChild2, // #3 = $val
/* 43184*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->43246
/* 43187*/            OPC_Scope, 18, /*->43207*/ // 3 children in Scope
/* 43189*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43191*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43193*/              OPC_EmitMergeInputChains1_0,
/* 43194*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43197*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43207*/            /*Scope*/ 18, /*->43226*/
/* 43208*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43210*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43212*/              OPC_EmitMergeInputChains1_0,
/* 43213*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43216*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43226*/            /*Scope*/ 18, /*->43245*/
/* 43227*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43229*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43231*/              OPC_EmitMergeInputChains1_0,
/* 43232*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43235*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43245*/            0, /*End of Scope*/
/* 43246*/          /*SwitchType*/ 18, MVT::i64,// ->43266
/* 43248*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43250*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43252*/            OPC_EmitMergeInputChains1_0,
/* 43253*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43256*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_sub:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43266*/          0, // EndSwitchType
/* 43267*/        /*Scope*/ 99, /*->43367*/
/* 43268*/          OPC_RecordChild0, // #1 = $addr
/* 43269*/          OPC_MoveChild1,
/* 43270*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 43273*/          OPC_RecordChild0, // #2 = $off
/* 43274*/          OPC_MoveChild0,
/* 43275*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 43278*/          OPC_MoveParent,
/* 43279*/          OPC_MoveParent,
/* 43280*/          OPC_CheckType, MVT::i32,
/* 43282*/          OPC_MoveParent,
/* 43283*/          OPC_RecordChild2, // #3 = $val
/* 43284*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->43346
/* 43287*/            OPC_Scope, 18, /*->43307*/ // 3 children in Scope
/* 43289*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43291*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43293*/              OPC_EmitMergeInputChains1_0,
/* 43294*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43297*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43307*/            /*Scope*/ 18, /*->43326*/
/* 43308*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43310*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43312*/              OPC_EmitMergeInputChains1_0,
/* 43313*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43316*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43326*/            /*Scope*/ 18, /*->43345*/
/* 43327*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43329*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43331*/              OPC_EmitMergeInputChains1_0,
/* 43332*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43335*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43345*/            0, /*End of Scope*/
/* 43346*/          /*SwitchType*/ 18, MVT::i64,// ->43366
/* 43348*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43350*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43352*/            OPC_EmitMergeInputChains1_0,
/* 43353*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43356*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_sub:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43366*/          0, // EndSwitchType
/* 43367*/        /*Scope*/ 99, /*->43467*/
/* 43368*/          OPC_MoveChild0,
/* 43369*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 43372*/          OPC_RecordChild0, // #1 = $off
/* 43373*/          OPC_MoveChild0,
/* 43374*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 43377*/          OPC_MoveParent,
/* 43378*/          OPC_MoveParent,
/* 43379*/          OPC_RecordChild1, // #2 = $addr
/* 43380*/          OPC_CheckType, MVT::i32,
/* 43382*/          OPC_MoveParent,
/* 43383*/          OPC_RecordChild2, // #3 = $val
/* 43384*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->43446
/* 43387*/            OPC_Scope, 18, /*->43407*/ // 3 children in Scope
/* 43389*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43391*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43393*/              OPC_EmitMergeInputChains1_0,
/* 43394*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43397*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43407*/            /*Scope*/ 18, /*->43426*/
/* 43408*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43410*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43412*/              OPC_EmitMergeInputChains1_0,
/* 43413*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43416*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43426*/            /*Scope*/ 18, /*->43445*/
/* 43427*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43429*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43431*/              OPC_EmitMergeInputChains1_0,
/* 43432*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43435*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43445*/            0, /*End of Scope*/
/* 43446*/          /*SwitchType*/ 18, MVT::i64,// ->43466
/* 43448*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43450*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43452*/            OPC_EmitMergeInputChains1_0,
/* 43453*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43456*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_sub:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43466*/          0, // EndSwitchType
/* 43467*/        /*Scope*/ 104, /*->43572*/
/* 43468*/          OPC_RecordChild0, // #1 = $addr
/* 43469*/          OPC_RecordChild1, // #2 = $off
/* 43470*/          OPC_MoveChild1,
/* 43471*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 43474*/          OPC_MoveParent,
/* 43475*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 43477*/          OPC_CheckType, MVT::i32,
/* 43479*/          OPC_MoveParent,
/* 43480*/          OPC_RecordChild2, // #3 = $val
/* 43481*/          OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->43549
/* 43484*/            OPC_Scope, 20, /*->43506*/ // 3 children in Scope
/* 43486*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43488*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43490*/              OPC_EmitMergeInputChains1_0,
/* 43491*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43494*/              OPC_EmitConvertToTarget, 2,
/* 43496*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 11
                        // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43506*/            /*Scope*/ 20, /*->43527*/
/* 43507*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43509*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43511*/              OPC_EmitMergeInputChains1_0,
/* 43512*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43515*/              OPC_EmitConvertToTarget, 2,
/* 43517*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                        // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43527*/            /*Scope*/ 20, /*->43548*/
/* 43528*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43530*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43532*/              OPC_EmitMergeInputChains1_0,
/* 43533*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43536*/              OPC_EmitConvertToTarget, 2,
/* 43538*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_sub:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                        // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43548*/            0, /*End of Scope*/
/* 43549*/          /*SwitchType*/ 20, MVT::i64,// ->43571
/* 43551*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43553*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43555*/            OPC_EmitMergeInputChains1_0,
/* 43556*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43559*/            OPC_EmitConvertToTarget, 2,
/* 43561*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_sub:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43571*/          0, // EndSwitchType
/* 43572*/        0, /*End of Scope*/
/* 43573*/      /*SwitchOpcode*/ 104, TARGET_VAL(ISD::OR),// ->43680
/* 43576*/        OPC_RecordChild0, // #1 = $addr
/* 43577*/        OPC_RecordChild1, // #2 = $off
/* 43578*/        OPC_MoveChild1,
/* 43579*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 43582*/        OPC_MoveParent,
/* 43583*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 43585*/        OPC_CheckType, MVT::i32,
/* 43587*/        OPC_MoveParent,
/* 43588*/        OPC_RecordChild2, // #3 = $val
/* 43589*/        OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->43657
/* 43592*/          OPC_Scope, 20, /*->43614*/ // 3 children in Scope
/* 43594*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43596*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43598*/            OPC_EmitMergeInputChains1_0,
/* 43599*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43602*/            OPC_EmitConvertToTarget, 2,
/* 43604*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43614*/          /*Scope*/ 20, /*->43635*/
/* 43615*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43617*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43619*/            OPC_EmitMergeInputChains1_0,
/* 43620*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43623*/            OPC_EmitConvertToTarget, 2,
/* 43625*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 11
                      // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43635*/          /*Scope*/ 20, /*->43656*/
/* 43636*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43638*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43640*/            OPC_EmitMergeInputChains1_0,
/* 43641*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43644*/            OPC_EmitConvertToTarget, 2,
/* 43646*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_sub:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 11
                      // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 43656*/          0, /*End of Scope*/
/* 43657*/        /*SwitchType*/ 20, MVT::i64,// ->43679
/* 43659*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43661*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43663*/          OPC_EmitMergeInputChains1_0,
/* 43664*/          OPC_EmitInteger, MVT::i32, 0, 
/* 43667*/          OPC_EmitConvertToTarget, 2,
/* 43669*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                    // Src: (atomic_load_sub:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 11
                    // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 43679*/        0, // EndSwitchType
/* 43680*/      /*SwitchOpcode*/ 6|128,2/*262*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->43946
/* 43684*/        OPC_RecordChild0, // #1 = $off
/* 43685*/        OPC_MoveChild0,
/* 43686*/        OPC_SwitchOpcode /*2 cases */, 126, TARGET_VAL(ISD::TargetGlobalAddress),// ->43816
/* 43690*/          OPC_MoveParent,
/* 43691*/          OPC_MoveParent,
/* 43692*/          OPC_RecordChild2, // #2 = $val
/* 43693*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->43785
/* 43696*/            OPC_Scope, 28, /*->43726*/ // 3 children in Scope
/* 43698*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43700*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43702*/              OPC_EmitMergeInputChains1_0,
/* 43703*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43706*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43709*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43716*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43726*/            /*Scope*/ 28, /*->43755*/
/* 43727*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43729*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43731*/              OPC_EmitMergeInputChains1_0,
/* 43732*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43735*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43738*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43745*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43755*/            /*Scope*/ 28, /*->43784*/
/* 43756*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43758*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43760*/              OPC_EmitMergeInputChains1_0,
/* 43761*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43764*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43767*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43774*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43784*/            0, /*End of Scope*/
/* 43785*/          /*SwitchType*/ 28, MVT::i64,// ->43815
/* 43787*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43789*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43791*/            OPC_EmitMergeInputChains1_0,
/* 43792*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43795*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43798*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43805*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_sub:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 43815*/          0, // EndSwitchType
/* 43816*/        /*SwitchOpcode*/ 126, TARGET_VAL(ISD::TargetExternalSymbol),// ->43945
/* 43819*/          OPC_MoveParent,
/* 43820*/          OPC_MoveParent,
/* 43821*/          OPC_RecordChild2, // #2 = $val
/* 43822*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->43914
/* 43825*/            OPC_Scope, 28, /*->43855*/ // 3 children in Scope
/* 43827*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43829*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43831*/              OPC_EmitMergeInputChains1_0,
/* 43832*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43835*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43838*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43845*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43855*/            /*Scope*/ 28, /*->43884*/
/* 43856*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43858*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43860*/              OPC_EmitMergeInputChains1_0,
/* 43861*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43864*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43867*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43874*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43884*/            /*Scope*/ 28, /*->43913*/
/* 43885*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 43887*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43889*/              OPC_EmitMergeInputChains1_0,
/* 43890*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43893*/              OPC_EmitInteger, MVT::i32, 0, 
/* 43896*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43903*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_sub:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43913*/            0, /*End of Scope*/
/* 43914*/          /*SwitchType*/ 28, MVT::i64,// ->43944
/* 43916*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 43918*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43920*/            OPC_EmitMergeInputChains1_0,
/* 43921*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43924*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43927*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 43934*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_sub:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 43944*/          0, // EndSwitchType
/* 43945*/        0, // EndSwitchOpcode
/* 43946*/      0, // EndSwitchOpcode
/* 43947*/    /*Scope*/ 113|128,1/*241*/, /*->44190*/
/* 43949*/      OPC_RecordChild1, // #1 = $off
/* 43950*/      OPC_Scope, 9|128,1/*137*/, /*->44090*/ // 2 children in Scope
/* 43953*/        OPC_MoveChild1,
/* 43954*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 43957*/        OPC_MoveParent,
/* 43958*/        OPC_RecordChild2, // #2 = $val
/* 43959*/        OPC_SwitchType /*2 cases */, 95, MVT::i32,// ->44057
/* 43962*/          OPC_Scope, 30, /*->43994*/ // 3 children in Scope
/* 43964*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 43966*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43968*/            OPC_EmitMergeInputChains1_0,
/* 43969*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43972*/            OPC_EmitConvertToTarget, 1,
/* 43974*/            OPC_EmitInteger, MVT::i32, 0, 
/* 43977*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 43984*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 7
                      // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 43994*/          /*Scope*/ 30, /*->44025*/
/* 43995*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 43997*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 43999*/            OPC_EmitMergeInputChains1_0,
/* 44000*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44003*/            OPC_EmitConvertToTarget, 1,
/* 44005*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44008*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 44015*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 7
                      // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 44025*/          /*Scope*/ 30, /*->44056*/
/* 44026*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 44028*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44030*/            OPC_EmitMergeInputChains1_0,
/* 44031*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44034*/            OPC_EmitConvertToTarget, 1,
/* 44036*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44039*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 44046*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_sub:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 7
                      // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 44056*/          0, /*End of Scope*/
/* 44057*/        /*SwitchType*/ 30, MVT::i64,// ->44089
/* 44059*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 44061*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44063*/          OPC_EmitMergeInputChains1_0,
/* 44064*/          OPC_EmitInteger, MVT::i32, 0, 
/* 44067*/          OPC_EmitConvertToTarget, 1,
/* 44069*/          OPC_EmitInteger, MVT::i32, 0, 
/* 44072*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 44079*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (atomic_load_sub:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 7
                    // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 44089*/        0, // EndSwitchType
/* 44090*/      /*Scope*/ 98, /*->44189*/
/* 44091*/        OPC_CheckChild1Type, MVT::i32,
/* 44093*/        OPC_RecordChild2, // #2 = $val
/* 44094*/        OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->44165
/* 44097*/          OPC_Scope, 21, /*->44120*/ // 3 children in Scope
/* 44099*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_sub_32
/* 44101*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44103*/            OPC_EmitMergeInputChains1_0,
/* 44104*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44107*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44110*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 4
                      // Dst: (ATOMIC_RMW_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44120*/          /*Scope*/ 21, /*->44142*/
/* 44121*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_8
/* 44123*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44125*/            OPC_EmitMergeInputChains1_0,
/* 44126*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44129*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44132*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 4
                      // Dst: (ATOMIC_RMW8_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44142*/          /*Scope*/ 21, /*->44164*/
/* 44143*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_16
/* 44145*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44147*/            OPC_EmitMergeInputChains1_0,
/* 44148*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44151*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44154*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_sub:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 4
                      // Dst: (ATOMIC_RMW16_U_SUB_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44164*/          0, /*End of Scope*/
/* 44165*/        /*SwitchType*/ 21, MVT::i64,// ->44188
/* 44167*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_sub_64
/* 44169*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44171*/          OPC_EmitMergeInputChains1_0,
/* 44172*/          OPC_EmitInteger, MVT::i32, 0, 
/* 44175*/          OPC_EmitInteger, MVT::i32, 0, 
/* 44178*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_load_sub:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 4
                    // Dst: (ATOMIC_RMW_SUB_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44188*/        0, // EndSwitchType
/* 44189*/      0, /*End of Scope*/
/* 44190*/    0, /*End of Scope*/
/* 44191*/  /*SwitchOpcode*/ 116|128,8/*1140*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->45335
/* 44195*/    OPC_RecordMemRef,
/* 44196*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/* 44197*/    OPC_Scope, 123|128,6/*891*/, /*->45091*/ // 2 children in Scope
/* 44200*/      OPC_MoveChild1,
/* 44201*/      OPC_SwitchOpcode /*3 cases */, 127|128,3/*511*/, TARGET_VAL(ISD::ADD),// ->44717
/* 44206*/        OPC_Scope, 101, /*->44309*/ // 5 children in Scope
/* 44208*/          OPC_RecordChild0, // #1 = $addr
/* 44209*/          OPC_MoveChild1,
/* 44210*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 44213*/          OPC_RecordChild0, // #2 = $off
/* 44214*/          OPC_MoveChild0,
/* 44215*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 44218*/          OPC_MoveParent,
/* 44219*/          OPC_MoveParent,
/* 44220*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 44222*/          OPC_CheckType, MVT::i32,
/* 44224*/          OPC_MoveParent,
/* 44225*/          OPC_RecordChild2, // #3 = $val
/* 44226*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->44288
/* 44229*/            OPC_Scope, 18, /*->44249*/ // 3 children in Scope
/* 44231*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44233*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44235*/              OPC_EmitMergeInputChains1_0,
/* 44236*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44239*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44249*/            /*Scope*/ 18, /*->44268*/
/* 44250*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 44252*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44254*/              OPC_EmitMergeInputChains1_0,
/* 44255*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44258*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44268*/            /*Scope*/ 18, /*->44287*/
/* 44269*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 44271*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44273*/              OPC_EmitMergeInputChains1_0,
/* 44274*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44277*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44287*/            0, /*End of Scope*/
/* 44288*/          /*SwitchType*/ 18, MVT::i64,// ->44308
/* 44290*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 44292*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44294*/            OPC_EmitMergeInputChains1_0,
/* 44295*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44298*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_and:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44308*/          0, // EndSwitchType
/* 44309*/        /*Scope*/ 101, /*->44411*/
/* 44310*/          OPC_MoveChild0,
/* 44311*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 44314*/          OPC_RecordChild0, // #1 = $off
/* 44315*/          OPC_MoveChild0,
/* 44316*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 44319*/          OPC_MoveParent,
/* 44320*/          OPC_MoveParent,
/* 44321*/          OPC_RecordChild1, // #2 = $addr
/* 44322*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 44324*/          OPC_CheckType, MVT::i32,
/* 44326*/          OPC_MoveParent,
/* 44327*/          OPC_RecordChild2, // #3 = $val
/* 44328*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->44390
/* 44331*/            OPC_Scope, 18, /*->44351*/ // 3 children in Scope
/* 44333*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44335*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44337*/              OPC_EmitMergeInputChains1_0,
/* 44338*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44341*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44351*/            /*Scope*/ 18, /*->44370*/
/* 44352*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 44354*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44356*/              OPC_EmitMergeInputChains1_0,
/* 44357*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44360*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44370*/            /*Scope*/ 18, /*->44389*/
/* 44371*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 44373*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44375*/              OPC_EmitMergeInputChains1_0,
/* 44376*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44379*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44389*/            0, /*End of Scope*/
/* 44390*/          /*SwitchType*/ 18, MVT::i64,// ->44410
/* 44392*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 44394*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44396*/            OPC_EmitMergeInputChains1_0,
/* 44397*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44400*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_and:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44410*/          0, // EndSwitchType
/* 44411*/        /*Scope*/ 99, /*->44511*/
/* 44412*/          OPC_RecordChild0, // #1 = $addr
/* 44413*/          OPC_MoveChild1,
/* 44414*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 44417*/          OPC_RecordChild0, // #2 = $off
/* 44418*/          OPC_MoveChild0,
/* 44419*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 44422*/          OPC_MoveParent,
/* 44423*/          OPC_MoveParent,
/* 44424*/          OPC_CheckType, MVT::i32,
/* 44426*/          OPC_MoveParent,
/* 44427*/          OPC_RecordChild2, // #3 = $val
/* 44428*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->44490
/* 44431*/            OPC_Scope, 18, /*->44451*/ // 3 children in Scope
/* 44433*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44435*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44437*/              OPC_EmitMergeInputChains1_0,
/* 44438*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44441*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44451*/            /*Scope*/ 18, /*->44470*/
/* 44452*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 44454*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44456*/              OPC_EmitMergeInputChains1_0,
/* 44457*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44460*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44470*/            /*Scope*/ 18, /*->44489*/
/* 44471*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 44473*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44475*/              OPC_EmitMergeInputChains1_0,
/* 44476*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44479*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44489*/            0, /*End of Scope*/
/* 44490*/          /*SwitchType*/ 18, MVT::i64,// ->44510
/* 44492*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 44494*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44496*/            OPC_EmitMergeInputChains1_0,
/* 44497*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44500*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_and:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44510*/          0, // EndSwitchType
/* 44511*/        /*Scope*/ 99, /*->44611*/
/* 44512*/          OPC_MoveChild0,
/* 44513*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 44516*/          OPC_RecordChild0, // #1 = $off
/* 44517*/          OPC_MoveChild0,
/* 44518*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 44521*/          OPC_MoveParent,
/* 44522*/          OPC_MoveParent,
/* 44523*/          OPC_RecordChild1, // #2 = $addr
/* 44524*/          OPC_CheckType, MVT::i32,
/* 44526*/          OPC_MoveParent,
/* 44527*/          OPC_RecordChild2, // #3 = $val
/* 44528*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->44590
/* 44531*/            OPC_Scope, 18, /*->44551*/ // 3 children in Scope
/* 44533*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44535*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44537*/              OPC_EmitMergeInputChains1_0,
/* 44538*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44541*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44551*/            /*Scope*/ 18, /*->44570*/
/* 44552*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 44554*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44556*/              OPC_EmitMergeInputChains1_0,
/* 44557*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44560*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44570*/            /*Scope*/ 18, /*->44589*/
/* 44571*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 44573*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44575*/              OPC_EmitMergeInputChains1_0,
/* 44576*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44579*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44589*/            0, /*End of Scope*/
/* 44590*/          /*SwitchType*/ 18, MVT::i64,// ->44610
/* 44592*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 44594*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44596*/            OPC_EmitMergeInputChains1_0,
/* 44597*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44600*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_and:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44610*/          0, // EndSwitchType
/* 44611*/        /*Scope*/ 104, /*->44716*/
/* 44612*/          OPC_RecordChild0, // #1 = $addr
/* 44613*/          OPC_RecordChild1, // #2 = $off
/* 44614*/          OPC_MoveChild1,
/* 44615*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 44618*/          OPC_MoveParent,
/* 44619*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 44621*/          OPC_CheckType, MVT::i32,
/* 44623*/          OPC_MoveParent,
/* 44624*/          OPC_RecordChild2, // #3 = $val
/* 44625*/          OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->44693
/* 44628*/            OPC_Scope, 20, /*->44650*/ // 3 children in Scope
/* 44630*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44632*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44634*/              OPC_EmitMergeInputChains1_0,
/* 44635*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44638*/              OPC_EmitConvertToTarget, 2,
/* 44640*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 11
                        // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44650*/            /*Scope*/ 20, /*->44671*/
/* 44651*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 44653*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44655*/              OPC_EmitMergeInputChains1_0,
/* 44656*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44659*/              OPC_EmitConvertToTarget, 2,
/* 44661*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                        // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44671*/            /*Scope*/ 20, /*->44692*/
/* 44672*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 44674*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44676*/              OPC_EmitMergeInputChains1_0,
/* 44677*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44680*/              OPC_EmitConvertToTarget, 2,
/* 44682*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_and:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                        // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44692*/            0, /*End of Scope*/
/* 44693*/          /*SwitchType*/ 20, MVT::i64,// ->44715
/* 44695*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 44697*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44699*/            OPC_EmitMergeInputChains1_0,
/* 44700*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44703*/            OPC_EmitConvertToTarget, 2,
/* 44705*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_and:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44715*/          0, // EndSwitchType
/* 44716*/        0, /*End of Scope*/
/* 44717*/      /*SwitchOpcode*/ 104, TARGET_VAL(ISD::OR),// ->44824
/* 44720*/        OPC_RecordChild0, // #1 = $addr
/* 44721*/        OPC_RecordChild1, // #2 = $off
/* 44722*/        OPC_MoveChild1,
/* 44723*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 44726*/        OPC_MoveParent,
/* 44727*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 44729*/        OPC_CheckType, MVT::i32,
/* 44731*/        OPC_MoveParent,
/* 44732*/        OPC_RecordChild2, // #3 = $val
/* 44733*/        OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->44801
/* 44736*/          OPC_Scope, 20, /*->44758*/ // 3 children in Scope
/* 44738*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44740*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44742*/            OPC_EmitMergeInputChains1_0,
/* 44743*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44746*/            OPC_EmitConvertToTarget, 2,
/* 44748*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44758*/          /*Scope*/ 20, /*->44779*/
/* 44759*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 44761*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44763*/            OPC_EmitMergeInputChains1_0,
/* 44764*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44767*/            OPC_EmitConvertToTarget, 2,
/* 44769*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 11
                      // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44779*/          /*Scope*/ 20, /*->44800*/
/* 44780*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 44782*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44784*/            OPC_EmitMergeInputChains1_0,
/* 44785*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44788*/            OPC_EmitConvertToTarget, 2,
/* 44790*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_and:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 11
                      // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 44800*/          0, /*End of Scope*/
/* 44801*/        /*SwitchType*/ 20, MVT::i64,// ->44823
/* 44803*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 44805*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44807*/          OPC_EmitMergeInputChains1_0,
/* 44808*/          OPC_EmitInteger, MVT::i32, 0, 
/* 44811*/          OPC_EmitConvertToTarget, 2,
/* 44813*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                    // Src: (atomic_load_and:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 11
                    // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 44823*/        0, // EndSwitchType
/* 44824*/      /*SwitchOpcode*/ 6|128,2/*262*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->45090
/* 44828*/        OPC_RecordChild0, // #1 = $off
/* 44829*/        OPC_MoveChild0,
/* 44830*/        OPC_SwitchOpcode /*2 cases */, 126, TARGET_VAL(ISD::TargetGlobalAddress),// ->44960
/* 44834*/          OPC_MoveParent,
/* 44835*/          OPC_MoveParent,
/* 44836*/          OPC_RecordChild2, // #2 = $val
/* 44837*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->44929
/* 44840*/            OPC_Scope, 28, /*->44870*/ // 3 children in Scope
/* 44842*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44844*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44846*/              OPC_EmitMergeInputChains1_0,
/* 44847*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44850*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44853*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 44860*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 44870*/            /*Scope*/ 28, /*->44899*/
/* 44871*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 44873*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44875*/              OPC_EmitMergeInputChains1_0,
/* 44876*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44879*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44882*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 44889*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 44899*/            /*Scope*/ 28, /*->44928*/
/* 44900*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 44902*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44904*/              OPC_EmitMergeInputChains1_0,
/* 44905*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44908*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44911*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 44918*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 44928*/            0, /*End of Scope*/
/* 44929*/          /*SwitchType*/ 28, MVT::i64,// ->44959
/* 44931*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 44933*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44935*/            OPC_EmitMergeInputChains1_0,
/* 44936*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44939*/            OPC_EmitInteger, MVT::i32, 0, 
/* 44942*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 44949*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_and:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 44959*/          0, // EndSwitchType
/* 44960*/        /*SwitchOpcode*/ 126, TARGET_VAL(ISD::TargetExternalSymbol),// ->45089
/* 44963*/          OPC_MoveParent,
/* 44964*/          OPC_MoveParent,
/* 44965*/          OPC_RecordChild2, // #2 = $val
/* 44966*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->45058
/* 44969*/            OPC_Scope, 28, /*->44999*/ // 3 children in Scope
/* 44971*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 44973*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 44975*/              OPC_EmitMergeInputChains1_0,
/* 44976*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44979*/              OPC_EmitInteger, MVT::i32, 0, 
/* 44982*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 44989*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 44999*/            /*Scope*/ 28, /*->45028*/
/* 45000*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 45002*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45004*/              OPC_EmitMergeInputChains1_0,
/* 45005*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45008*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45011*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45018*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45028*/            /*Scope*/ 28, /*->45057*/
/* 45029*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 45031*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45033*/              OPC_EmitMergeInputChains1_0,
/* 45034*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45037*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45040*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45047*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_and:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45057*/            0, /*End of Scope*/
/* 45058*/          /*SwitchType*/ 28, MVT::i64,// ->45088
/* 45060*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 45062*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45064*/            OPC_EmitMergeInputChains1_0,
/* 45065*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45068*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45071*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 45078*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_and:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 45088*/          0, // EndSwitchType
/* 45089*/        0, // EndSwitchOpcode
/* 45090*/      0, // EndSwitchOpcode
/* 45091*/    /*Scope*/ 113|128,1/*241*/, /*->45334*/
/* 45093*/      OPC_RecordChild1, // #1 = $off
/* 45094*/      OPC_Scope, 9|128,1/*137*/, /*->45234*/ // 2 children in Scope
/* 45097*/        OPC_MoveChild1,
/* 45098*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 45101*/        OPC_MoveParent,
/* 45102*/        OPC_RecordChild2, // #2 = $val
/* 45103*/        OPC_SwitchType /*2 cases */, 95, MVT::i32,// ->45201
/* 45106*/          OPC_Scope, 30, /*->45138*/ // 3 children in Scope
/* 45108*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 45110*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45112*/            OPC_EmitMergeInputChains1_0,
/* 45113*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45116*/            OPC_EmitConvertToTarget, 1,
/* 45118*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45121*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45128*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 7
                      // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45138*/          /*Scope*/ 30, /*->45169*/
/* 45139*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 45141*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45143*/            OPC_EmitMergeInputChains1_0,
/* 45144*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45147*/            OPC_EmitConvertToTarget, 1,
/* 45149*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45152*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45159*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 7
                      // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45169*/          /*Scope*/ 30, /*->45200*/
/* 45170*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 45172*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45174*/            OPC_EmitMergeInputChains1_0,
/* 45175*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45178*/            OPC_EmitConvertToTarget, 1,
/* 45180*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45183*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45190*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_and:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 7
                      // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 45200*/          0, /*End of Scope*/
/* 45201*/        /*SwitchType*/ 30, MVT::i64,// ->45233
/* 45203*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 45205*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45207*/          OPC_EmitMergeInputChains1_0,
/* 45208*/          OPC_EmitInteger, MVT::i32, 0, 
/* 45211*/          OPC_EmitConvertToTarget, 1,
/* 45213*/          OPC_EmitInteger, MVT::i32, 0, 
/* 45216*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 45223*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (atomic_load_and:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 7
                    // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 45233*/        0, // EndSwitchType
/* 45234*/      /*Scope*/ 98, /*->45333*/
/* 45235*/        OPC_CheckChild1Type, MVT::i32,
/* 45237*/        OPC_RecordChild2, // #2 = $val
/* 45238*/        OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->45309
/* 45241*/          OPC_Scope, 21, /*->45264*/ // 3 children in Scope
/* 45243*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_and_32
/* 45245*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45247*/            OPC_EmitMergeInputChains1_0,
/* 45248*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45251*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45254*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 4
                      // Dst: (ATOMIC_RMW_AND_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45264*/          /*Scope*/ 21, /*->45286*/
/* 45265*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_and_8
/* 45267*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45269*/            OPC_EmitMergeInputChains1_0,
/* 45270*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45273*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45276*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 4
                      // Dst: (ATOMIC_RMW8_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45286*/          /*Scope*/ 21, /*->45308*/
/* 45287*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_and_16
/* 45289*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45291*/            OPC_EmitMergeInputChains1_0,
/* 45292*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45295*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45298*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_and:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 4
                      // Dst: (ATOMIC_RMW16_U_AND_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45308*/          0, /*End of Scope*/
/* 45309*/        /*SwitchType*/ 21, MVT::i64,// ->45332
/* 45311*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_and_64
/* 45313*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45315*/          OPC_EmitMergeInputChains1_0,
/* 45316*/          OPC_EmitInteger, MVT::i32, 0, 
/* 45319*/          OPC_EmitInteger, MVT::i32, 0, 
/* 45322*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_load_and:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 4
                    // Dst: (ATOMIC_RMW_AND_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45332*/        0, // EndSwitchType
/* 45333*/      0, /*End of Scope*/
/* 45334*/    0, /*End of Scope*/
/* 45335*/  /*SwitchOpcode*/ 116|128,8/*1140*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->46479
/* 45339*/    OPC_RecordMemRef,
/* 45340*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/* 45341*/    OPC_Scope, 123|128,6/*891*/, /*->46235*/ // 2 children in Scope
/* 45344*/      OPC_MoveChild1,
/* 45345*/      OPC_SwitchOpcode /*3 cases */, 127|128,3/*511*/, TARGET_VAL(ISD::ADD),// ->45861
/* 45350*/        OPC_Scope, 101, /*->45453*/ // 5 children in Scope
/* 45352*/          OPC_RecordChild0, // #1 = $addr
/* 45353*/          OPC_MoveChild1,
/* 45354*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 45357*/          OPC_RecordChild0, // #2 = $off
/* 45358*/          OPC_MoveChild0,
/* 45359*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 45362*/          OPC_MoveParent,
/* 45363*/          OPC_MoveParent,
/* 45364*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 45366*/          OPC_CheckType, MVT::i32,
/* 45368*/          OPC_MoveParent,
/* 45369*/          OPC_RecordChild2, // #3 = $val
/* 45370*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->45432
/* 45373*/            OPC_Scope, 18, /*->45393*/ // 3 children in Scope
/* 45375*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 45377*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45379*/              OPC_EmitMergeInputChains1_0,
/* 45380*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45383*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45393*/            /*Scope*/ 18, /*->45412*/
/* 45394*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 45396*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45398*/              OPC_EmitMergeInputChains1_0,
/* 45399*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45402*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45412*/            /*Scope*/ 18, /*->45431*/
/* 45413*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 45415*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45417*/              OPC_EmitMergeInputChains1_0,
/* 45418*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45421*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45431*/            0, /*End of Scope*/
/* 45432*/          /*SwitchType*/ 18, MVT::i64,// ->45452
/* 45434*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 45436*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45438*/            OPC_EmitMergeInputChains1_0,
/* 45439*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45442*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_or:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45452*/          0, // EndSwitchType
/* 45453*/        /*Scope*/ 101, /*->45555*/
/* 45454*/          OPC_MoveChild0,
/* 45455*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 45458*/          OPC_RecordChild0, // #1 = $off
/* 45459*/          OPC_MoveChild0,
/* 45460*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 45463*/          OPC_MoveParent,
/* 45464*/          OPC_MoveParent,
/* 45465*/          OPC_RecordChild1, // #2 = $addr
/* 45466*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 45468*/          OPC_CheckType, MVT::i32,
/* 45470*/          OPC_MoveParent,
/* 45471*/          OPC_RecordChild2, // #3 = $val
/* 45472*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->45534
/* 45475*/            OPC_Scope, 18, /*->45495*/ // 3 children in Scope
/* 45477*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 45479*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45481*/              OPC_EmitMergeInputChains1_0,
/* 45482*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45485*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45495*/            /*Scope*/ 18, /*->45514*/
/* 45496*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 45498*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45500*/              OPC_EmitMergeInputChains1_0,
/* 45501*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45504*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45514*/            /*Scope*/ 18, /*->45533*/
/* 45515*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 45517*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45519*/              OPC_EmitMergeInputChains1_0,
/* 45520*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45523*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45533*/            0, /*End of Scope*/
/* 45534*/          /*SwitchType*/ 18, MVT::i64,// ->45554
/* 45536*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 45538*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45540*/            OPC_EmitMergeInputChains1_0,
/* 45541*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45544*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_or:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45554*/          0, // EndSwitchType
/* 45555*/        /*Scope*/ 99, /*->45655*/
/* 45556*/          OPC_RecordChild0, // #1 = $addr
/* 45557*/          OPC_MoveChild1,
/* 45558*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 45561*/          OPC_RecordChild0, // #2 = $off
/* 45562*/          OPC_MoveChild0,
/* 45563*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 45566*/          OPC_MoveParent,
/* 45567*/          OPC_MoveParent,
/* 45568*/          OPC_CheckType, MVT::i32,
/* 45570*/          OPC_MoveParent,
/* 45571*/          OPC_RecordChild2, // #3 = $val
/* 45572*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->45634
/* 45575*/            OPC_Scope, 18, /*->45595*/ // 3 children in Scope
/* 45577*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 45579*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45581*/              OPC_EmitMergeInputChains1_0,
/* 45582*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45585*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45595*/            /*Scope*/ 18, /*->45614*/
/* 45596*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 45598*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45600*/              OPC_EmitMergeInputChains1_0,
/* 45601*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45604*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45614*/            /*Scope*/ 18, /*->45633*/
/* 45615*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 45617*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45619*/              OPC_EmitMergeInputChains1_0,
/* 45620*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45623*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45633*/            0, /*End of Scope*/
/* 45634*/          /*SwitchType*/ 18, MVT::i64,// ->45654
/* 45636*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 45638*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45640*/            OPC_EmitMergeInputChains1_0,
/* 45641*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45644*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_or:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45654*/          0, // EndSwitchType
/* 45655*/        /*Scope*/ 99, /*->45755*/
/* 45656*/          OPC_MoveChild0,
/* 45657*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 45660*/          OPC_RecordChild0, // #1 = $off
/* 45661*/          OPC_MoveChild0,
/* 45662*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 45665*/          OPC_MoveParent,
/* 45666*/          OPC_MoveParent,
/* 45667*/          OPC_RecordChild1, // #2 = $addr
/* 45668*/          OPC_CheckType, MVT::i32,
/* 45670*/          OPC_MoveParent,
/* 45671*/          OPC_RecordChild2, // #3 = $val
/* 45672*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->45734
/* 45675*/            OPC_Scope, 18, /*->45695*/ // 3 children in Scope
/* 45677*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 45679*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45681*/              OPC_EmitMergeInputChains1_0,
/* 45682*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45685*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45695*/            /*Scope*/ 18, /*->45714*/
/* 45696*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 45698*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45700*/              OPC_EmitMergeInputChains1_0,
/* 45701*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45704*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45714*/            /*Scope*/ 18, /*->45733*/
/* 45715*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 45717*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45719*/              OPC_EmitMergeInputChains1_0,
/* 45720*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45723*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45733*/            0, /*End of Scope*/
/* 45734*/          /*SwitchType*/ 18, MVT::i64,// ->45754
/* 45736*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 45738*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45740*/            OPC_EmitMergeInputChains1_0,
/* 45741*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45744*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_or:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45754*/          0, // EndSwitchType
/* 45755*/        /*Scope*/ 104, /*->45860*/
/* 45756*/          OPC_RecordChild0, // #1 = $addr
/* 45757*/          OPC_RecordChild1, // #2 = $off
/* 45758*/          OPC_MoveChild1,
/* 45759*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 45762*/          OPC_MoveParent,
/* 45763*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 45765*/          OPC_CheckType, MVT::i32,
/* 45767*/          OPC_MoveParent,
/* 45768*/          OPC_RecordChild2, // #3 = $val
/* 45769*/          OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->45837
/* 45772*/            OPC_Scope, 20, /*->45794*/ // 3 children in Scope
/* 45774*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 45776*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45778*/              OPC_EmitMergeInputChains1_0,
/* 45779*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45782*/              OPC_EmitConvertToTarget, 2,
/* 45784*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 11
                        // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45794*/            /*Scope*/ 20, /*->45815*/
/* 45795*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 45797*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45799*/              OPC_EmitMergeInputChains1_0,
/* 45800*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45803*/              OPC_EmitConvertToTarget, 2,
/* 45805*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                        // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45815*/            /*Scope*/ 20, /*->45836*/
/* 45816*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 45818*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45820*/              OPC_EmitMergeInputChains1_0,
/* 45821*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45824*/              OPC_EmitConvertToTarget, 2,
/* 45826*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_or:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                        // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45836*/            0, /*End of Scope*/
/* 45837*/          /*SwitchType*/ 20, MVT::i64,// ->45859
/* 45839*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 45841*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45843*/            OPC_EmitMergeInputChains1_0,
/* 45844*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45847*/            OPC_EmitConvertToTarget, 2,
/* 45849*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_or:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45859*/          0, // EndSwitchType
/* 45860*/        0, /*End of Scope*/
/* 45861*/      /*SwitchOpcode*/ 104, TARGET_VAL(ISD::OR),// ->45968
/* 45864*/        OPC_RecordChild0, // #1 = $addr
/* 45865*/        OPC_RecordChild1, // #2 = $off
/* 45866*/        OPC_MoveChild1,
/* 45867*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 45870*/        OPC_MoveParent,
/* 45871*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 45873*/        OPC_CheckType, MVT::i32,
/* 45875*/        OPC_MoveParent,
/* 45876*/        OPC_RecordChild2, // #3 = $val
/* 45877*/        OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->45945
/* 45880*/          OPC_Scope, 20, /*->45902*/ // 3 children in Scope
/* 45882*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 45884*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45886*/            OPC_EmitMergeInputChains1_0,
/* 45887*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45890*/            OPC_EmitConvertToTarget, 2,
/* 45892*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45902*/          /*Scope*/ 20, /*->45923*/
/* 45903*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 45905*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45907*/            OPC_EmitMergeInputChains1_0,
/* 45908*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45911*/            OPC_EmitConvertToTarget, 2,
/* 45913*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 11
                      // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45923*/          /*Scope*/ 20, /*->45944*/
/* 45924*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 45926*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45928*/            OPC_EmitMergeInputChains1_0,
/* 45929*/            OPC_EmitInteger, MVT::i32, 0, 
/* 45932*/            OPC_EmitConvertToTarget, 2,
/* 45934*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_or:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 11
                      // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 45944*/          0, /*End of Scope*/
/* 45945*/        /*SwitchType*/ 20, MVT::i64,// ->45967
/* 45947*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 45949*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45951*/          OPC_EmitMergeInputChains1_0,
/* 45952*/          OPC_EmitInteger, MVT::i32, 0, 
/* 45955*/          OPC_EmitConvertToTarget, 2,
/* 45957*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                    // Src: (atomic_load_or:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 11
                    // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 45967*/        0, // EndSwitchType
/* 45968*/      /*SwitchOpcode*/ 6|128,2/*262*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->46234
/* 45972*/        OPC_RecordChild0, // #1 = $off
/* 45973*/        OPC_MoveChild0,
/* 45974*/        OPC_SwitchOpcode /*2 cases */, 126, TARGET_VAL(ISD::TargetGlobalAddress),// ->46104
/* 45978*/          OPC_MoveParent,
/* 45979*/          OPC_MoveParent,
/* 45980*/          OPC_RecordChild2, // #2 = $val
/* 45981*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->46073
/* 45984*/            OPC_Scope, 28, /*->46014*/ // 3 children in Scope
/* 45986*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 45988*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 45990*/              OPC_EmitMergeInputChains1_0,
/* 45991*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45994*/              OPC_EmitInteger, MVT::i32, 0, 
/* 45997*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46004*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46014*/            /*Scope*/ 28, /*->46043*/
/* 46015*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 46017*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46019*/              OPC_EmitMergeInputChains1_0,
/* 46020*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46023*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46026*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46033*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46043*/            /*Scope*/ 28, /*->46072*/
/* 46044*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 46046*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46048*/              OPC_EmitMergeInputChains1_0,
/* 46049*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46052*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46055*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46062*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46072*/            0, /*End of Scope*/
/* 46073*/          /*SwitchType*/ 28, MVT::i64,// ->46103
/* 46075*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 46077*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46079*/            OPC_EmitMergeInputChains1_0,
/* 46080*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46083*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46086*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46093*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_or:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 46103*/          0, // EndSwitchType
/* 46104*/        /*SwitchOpcode*/ 126, TARGET_VAL(ISD::TargetExternalSymbol),// ->46233
/* 46107*/          OPC_MoveParent,
/* 46108*/          OPC_MoveParent,
/* 46109*/          OPC_RecordChild2, // #2 = $val
/* 46110*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->46202
/* 46113*/            OPC_Scope, 28, /*->46143*/ // 3 children in Scope
/* 46115*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 46117*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46119*/              OPC_EmitMergeInputChains1_0,
/* 46120*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46123*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46126*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46133*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46143*/            /*Scope*/ 28, /*->46172*/
/* 46144*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 46146*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46148*/              OPC_EmitMergeInputChains1_0,
/* 46149*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46152*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46155*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46162*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46172*/            /*Scope*/ 28, /*->46201*/
/* 46173*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 46175*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46177*/              OPC_EmitMergeInputChains1_0,
/* 46178*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46181*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46184*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46191*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_or:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46201*/            0, /*End of Scope*/
/* 46202*/          /*SwitchType*/ 28, MVT::i64,// ->46232
/* 46204*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 46206*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46208*/            OPC_EmitMergeInputChains1_0,
/* 46209*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46212*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46215*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 46222*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_or:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 46232*/          0, // EndSwitchType
/* 46233*/        0, // EndSwitchOpcode
/* 46234*/      0, // EndSwitchOpcode
/* 46235*/    /*Scope*/ 113|128,1/*241*/, /*->46478*/
/* 46237*/      OPC_RecordChild1, // #1 = $off
/* 46238*/      OPC_Scope, 9|128,1/*137*/, /*->46378*/ // 2 children in Scope
/* 46241*/        OPC_MoveChild1,
/* 46242*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 46245*/        OPC_MoveParent,
/* 46246*/        OPC_RecordChild2, // #2 = $val
/* 46247*/        OPC_SwitchType /*2 cases */, 95, MVT::i32,// ->46345
/* 46250*/          OPC_Scope, 30, /*->46282*/ // 3 children in Scope
/* 46252*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 46254*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46256*/            OPC_EmitMergeInputChains1_0,
/* 46257*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46260*/            OPC_EmitConvertToTarget, 1,
/* 46262*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46265*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46272*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 7
                      // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46282*/          /*Scope*/ 30, /*->46313*/
/* 46283*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 46285*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46287*/            OPC_EmitMergeInputChains1_0,
/* 46288*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46291*/            OPC_EmitConvertToTarget, 1,
/* 46293*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46296*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46303*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 7
                      // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46313*/          /*Scope*/ 30, /*->46344*/
/* 46314*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 46316*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46318*/            OPC_EmitMergeInputChains1_0,
/* 46319*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46322*/            OPC_EmitConvertToTarget, 1,
/* 46324*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46327*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46334*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_or:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 7
                      // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 46344*/          0, /*End of Scope*/
/* 46345*/        /*SwitchType*/ 30, MVT::i64,// ->46377
/* 46347*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 46349*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46351*/          OPC_EmitMergeInputChains1_0,
/* 46352*/          OPC_EmitInteger, MVT::i32, 0, 
/* 46355*/          OPC_EmitConvertToTarget, 1,
/* 46357*/          OPC_EmitInteger, MVT::i32, 0, 
/* 46360*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 46367*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (atomic_load_or:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 7
                    // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 46377*/        0, // EndSwitchType
/* 46378*/      /*Scope*/ 98, /*->46477*/
/* 46379*/        OPC_CheckChild1Type, MVT::i32,
/* 46381*/        OPC_RecordChild2, // #2 = $val
/* 46382*/        OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->46453
/* 46385*/          OPC_Scope, 21, /*->46408*/ // 3 children in Scope
/* 46387*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_or_32
/* 46389*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46391*/            OPC_EmitMergeInputChains1_0,
/* 46392*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46395*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46398*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 4
                      // Dst: (ATOMIC_RMW_OR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46408*/          /*Scope*/ 21, /*->46430*/
/* 46409*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_or_8
/* 46411*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46413*/            OPC_EmitMergeInputChains1_0,
/* 46414*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46417*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46420*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 4
                      // Dst: (ATOMIC_RMW8_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46430*/          /*Scope*/ 21, /*->46452*/
/* 46431*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_or_16
/* 46433*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46435*/            OPC_EmitMergeInputChains1_0,
/* 46436*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46439*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46442*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_or:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 4
                      // Dst: (ATOMIC_RMW16_U_OR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46452*/          0, /*End of Scope*/
/* 46453*/        /*SwitchType*/ 21, MVT::i64,// ->46476
/* 46455*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_or_64
/* 46457*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46459*/          OPC_EmitMergeInputChains1_0,
/* 46460*/          OPC_EmitInteger, MVT::i32, 0, 
/* 46463*/          OPC_EmitInteger, MVT::i32, 0, 
/* 46466*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_load_or:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 4
                    // Dst: (ATOMIC_RMW_OR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 46476*/        0, // EndSwitchType
/* 46477*/      0, /*End of Scope*/
/* 46478*/    0, /*End of Scope*/
/* 46479*/  /*SwitchOpcode*/ 116|128,8/*1140*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->47623
/* 46483*/    OPC_RecordMemRef,
/* 46484*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/* 46485*/    OPC_Scope, 123|128,6/*891*/, /*->47379*/ // 2 children in Scope
/* 46488*/      OPC_MoveChild1,
/* 46489*/      OPC_SwitchOpcode /*3 cases */, 127|128,3/*511*/, TARGET_VAL(ISD::ADD),// ->47005
/* 46494*/        OPC_Scope, 101, /*->46597*/ // 5 children in Scope
/* 46496*/          OPC_RecordChild0, // #1 = $addr
/* 46497*/          OPC_MoveChild1,
/* 46498*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 46501*/          OPC_RecordChild0, // #2 = $off
/* 46502*/          OPC_MoveChild0,
/* 46503*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 46506*/          OPC_MoveParent,
/* 46507*/          OPC_MoveParent,
/* 46508*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 46510*/          OPC_CheckType, MVT::i32,
/* 46512*/          OPC_MoveParent,
/* 46513*/          OPC_RecordChild2, // #3 = $val
/* 46514*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->46576
/* 46517*/            OPC_Scope, 18, /*->46537*/ // 3 children in Scope
/* 46519*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 46521*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46523*/              OPC_EmitMergeInputChains1_0,
/* 46524*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46527*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46537*/            /*Scope*/ 18, /*->46556*/
/* 46538*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 46540*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46542*/              OPC_EmitMergeInputChains1_0,
/* 46543*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46546*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46556*/            /*Scope*/ 18, /*->46575*/
/* 46557*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 46559*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46561*/              OPC_EmitMergeInputChains1_0,
/* 46562*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46565*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46575*/            0, /*End of Scope*/
/* 46576*/          /*SwitchType*/ 18, MVT::i64,// ->46596
/* 46578*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 46580*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46582*/            OPC_EmitMergeInputChains1_0,
/* 46583*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46586*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_xor:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 46596*/          0, // EndSwitchType
/* 46597*/        /*Scope*/ 101, /*->46699*/
/* 46598*/          OPC_MoveChild0,
/* 46599*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 46602*/          OPC_RecordChild0, // #1 = $off
/* 46603*/          OPC_MoveChild0,
/* 46604*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 46607*/          OPC_MoveParent,
/* 46608*/          OPC_MoveParent,
/* 46609*/          OPC_RecordChild1, // #2 = $addr
/* 46610*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 46612*/          OPC_CheckType, MVT::i32,
/* 46614*/          OPC_MoveParent,
/* 46615*/          OPC_RecordChild2, // #3 = $val
/* 46616*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->46678
/* 46619*/            OPC_Scope, 18, /*->46639*/ // 3 children in Scope
/* 46621*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 46623*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46625*/              OPC_EmitMergeInputChains1_0,
/* 46626*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46629*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46639*/            /*Scope*/ 18, /*->46658*/
/* 46640*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 46642*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46644*/              OPC_EmitMergeInputChains1_0,
/* 46645*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46648*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46658*/            /*Scope*/ 18, /*->46677*/
/* 46659*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 46661*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46663*/              OPC_EmitMergeInputChains1_0,
/* 46664*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46667*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46677*/            0, /*End of Scope*/
/* 46678*/          /*SwitchType*/ 18, MVT::i64,// ->46698
/* 46680*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 46682*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46684*/            OPC_EmitMergeInputChains1_0,
/* 46685*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46688*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_xor:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 46698*/          0, // EndSwitchType
/* 46699*/        /*Scope*/ 99, /*->46799*/
/* 46700*/          OPC_RecordChild0, // #1 = $addr
/* 46701*/          OPC_MoveChild1,
/* 46702*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 46705*/          OPC_RecordChild0, // #2 = $off
/* 46706*/          OPC_MoveChild0,
/* 46707*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 46710*/          OPC_MoveParent,
/* 46711*/          OPC_MoveParent,
/* 46712*/          OPC_CheckType, MVT::i32,
/* 46714*/          OPC_MoveParent,
/* 46715*/          OPC_RecordChild2, // #3 = $val
/* 46716*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->46778
/* 46719*/            OPC_Scope, 18, /*->46739*/ // 3 children in Scope
/* 46721*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 46723*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46725*/              OPC_EmitMergeInputChains1_0,
/* 46726*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46729*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46739*/            /*Scope*/ 18, /*->46758*/
/* 46740*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 46742*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46744*/              OPC_EmitMergeInputChains1_0,
/* 46745*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46748*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46758*/            /*Scope*/ 18, /*->46777*/
/* 46759*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 46761*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46763*/              OPC_EmitMergeInputChains1_0,
/* 46764*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46767*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46777*/            0, /*End of Scope*/
/* 46778*/          /*SwitchType*/ 18, MVT::i64,// ->46798
/* 46780*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 46782*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46784*/            OPC_EmitMergeInputChains1_0,
/* 46785*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46788*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_load_xor:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 46798*/          0, // EndSwitchType
/* 46799*/        /*Scope*/ 99, /*->46899*/
/* 46800*/          OPC_MoveChild0,
/* 46801*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 46804*/          OPC_RecordChild0, // #1 = $off
/* 46805*/          OPC_MoveChild0,
/* 46806*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 46809*/          OPC_MoveParent,
/* 46810*/          OPC_MoveParent,
/* 46811*/          OPC_RecordChild1, // #2 = $addr
/* 46812*/          OPC_CheckType, MVT::i32,
/* 46814*/          OPC_MoveParent,
/* 46815*/          OPC_RecordChild2, // #3 = $val
/* 46816*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->46878
/* 46819*/            OPC_Scope, 18, /*->46839*/ // 3 children in Scope
/* 46821*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 46823*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46825*/              OPC_EmitMergeInputChains1_0,
/* 46826*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46829*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46839*/            /*Scope*/ 18, /*->46858*/
/* 46840*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 46842*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46844*/              OPC_EmitMergeInputChains1_0,
/* 46845*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46848*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46858*/            /*Scope*/ 18, /*->46877*/
/* 46859*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 46861*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46863*/              OPC_EmitMergeInputChains1_0,
/* 46864*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46867*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46877*/            0, /*End of Scope*/
/* 46878*/          /*SwitchType*/ 18, MVT::i64,// ->46898
/* 46880*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 46882*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46884*/            OPC_EmitMergeInputChains1_0,
/* 46885*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46888*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_load_xor:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 46898*/          0, // EndSwitchType
/* 46899*/        /*Scope*/ 104, /*->47004*/
/* 46900*/          OPC_RecordChild0, // #1 = $addr
/* 46901*/          OPC_RecordChild1, // #2 = $off
/* 46902*/          OPC_MoveChild1,
/* 46903*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 46906*/          OPC_MoveParent,
/* 46907*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 46909*/          OPC_CheckType, MVT::i32,
/* 46911*/          OPC_MoveParent,
/* 46912*/          OPC_RecordChild2, // #3 = $val
/* 46913*/          OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->46981
/* 46916*/            OPC_Scope, 20, /*->46938*/ // 3 children in Scope
/* 46918*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 46920*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46922*/              OPC_EmitMergeInputChains1_0,
/* 46923*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46926*/              OPC_EmitConvertToTarget, 2,
/* 46928*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 11
                        // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46938*/            /*Scope*/ 20, /*->46959*/
/* 46939*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 46941*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46943*/              OPC_EmitMergeInputChains1_0,
/* 46944*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46947*/              OPC_EmitConvertToTarget, 2,
/* 46949*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                        // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46959*/            /*Scope*/ 20, /*->46980*/
/* 46960*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 46962*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46964*/              OPC_EmitMergeInputChains1_0,
/* 46965*/              OPC_EmitInteger, MVT::i32, 0, 
/* 46968*/              OPC_EmitConvertToTarget, 2,
/* 46970*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_load_xor:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                        // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 46980*/            0, /*End of Scope*/
/* 46981*/          /*SwitchType*/ 20, MVT::i64,// ->47003
/* 46983*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 46985*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 46987*/            OPC_EmitMergeInputChains1_0,
/* 46988*/            OPC_EmitInteger, MVT::i32, 0, 
/* 46991*/            OPC_EmitConvertToTarget, 2,
/* 46993*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_xor:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 47003*/          0, // EndSwitchType
/* 47004*/        0, /*End of Scope*/
/* 47005*/      /*SwitchOpcode*/ 104, TARGET_VAL(ISD::OR),// ->47112
/* 47008*/        OPC_RecordChild0, // #1 = $addr
/* 47009*/        OPC_RecordChild1, // #2 = $off
/* 47010*/        OPC_MoveChild1,
/* 47011*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 47014*/        OPC_MoveParent,
/* 47015*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 47017*/        OPC_CheckType, MVT::i32,
/* 47019*/        OPC_MoveParent,
/* 47020*/        OPC_RecordChild2, // #3 = $val
/* 47021*/        OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->47089
/* 47024*/          OPC_Scope, 20, /*->47046*/ // 3 children in Scope
/* 47026*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 47028*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47030*/            OPC_EmitMergeInputChains1_0,
/* 47031*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47034*/            OPC_EmitConvertToTarget, 2,
/* 47036*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47046*/          /*Scope*/ 20, /*->47067*/
/* 47047*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 47049*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47051*/            OPC_EmitMergeInputChains1_0,
/* 47052*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47055*/            OPC_EmitConvertToTarget, 2,
/* 47057*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 11
                      // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47067*/          /*Scope*/ 20, /*->47088*/
/* 47068*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 47070*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47072*/            OPC_EmitMergeInputChains1_0,
/* 47073*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47076*/            OPC_EmitConvertToTarget, 2,
/* 47078*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_load_xor:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 11
                      // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47088*/          0, /*End of Scope*/
/* 47089*/        /*SwitchType*/ 20, MVT::i64,// ->47111
/* 47091*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 47093*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47095*/          OPC_EmitMergeInputChains1_0,
/* 47096*/          OPC_EmitInteger, MVT::i32, 0, 
/* 47099*/          OPC_EmitConvertToTarget, 2,
/* 47101*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                    // Src: (atomic_load_xor:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 11
                    // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 47111*/        0, // EndSwitchType
/* 47112*/      /*SwitchOpcode*/ 6|128,2/*262*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->47378
/* 47116*/        OPC_RecordChild0, // #1 = $off
/* 47117*/        OPC_MoveChild0,
/* 47118*/        OPC_SwitchOpcode /*2 cases */, 126, TARGET_VAL(ISD::TargetGlobalAddress),// ->47248
/* 47122*/          OPC_MoveParent,
/* 47123*/          OPC_MoveParent,
/* 47124*/          OPC_RecordChild2, // #2 = $val
/* 47125*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->47217
/* 47128*/            OPC_Scope, 28, /*->47158*/ // 3 children in Scope
/* 47130*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 47132*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47134*/              OPC_EmitMergeInputChains1_0,
/* 47135*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47138*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47141*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47148*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47158*/            /*Scope*/ 28, /*->47187*/
/* 47159*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 47161*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47163*/              OPC_EmitMergeInputChains1_0,
/* 47164*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47167*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47170*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47177*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47187*/            /*Scope*/ 28, /*->47216*/
/* 47188*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 47190*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47192*/              OPC_EmitMergeInputChains1_0,
/* 47193*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47196*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47199*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47206*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47216*/            0, /*End of Scope*/
/* 47217*/          /*SwitchType*/ 28, MVT::i64,// ->47247
/* 47219*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 47221*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47223*/            OPC_EmitMergeInputChains1_0,
/* 47224*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47227*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47230*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47237*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_xor:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 47247*/          0, // EndSwitchType
/* 47248*/        /*SwitchOpcode*/ 126, TARGET_VAL(ISD::TargetExternalSymbol),// ->47377
/* 47251*/          OPC_MoveParent,
/* 47252*/          OPC_MoveParent,
/* 47253*/          OPC_RecordChild2, // #2 = $val
/* 47254*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->47346
/* 47257*/            OPC_Scope, 28, /*->47287*/ // 3 children in Scope
/* 47259*/              OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 47261*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47263*/              OPC_EmitMergeInputChains1_0,
/* 47264*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47267*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47270*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47277*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47287*/            /*Scope*/ 28, /*->47316*/
/* 47288*/              OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 47290*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47292*/              OPC_EmitMergeInputChains1_0,
/* 47293*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47296*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47299*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47306*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47316*/            /*Scope*/ 28, /*->47345*/
/* 47317*/              OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 47319*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47321*/              OPC_EmitMergeInputChains1_0,
/* 47322*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47325*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47328*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47335*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_load_xor:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47345*/            0, /*End of Scope*/
/* 47346*/          /*SwitchType*/ 28, MVT::i64,// ->47376
/* 47348*/            OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 47350*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47352*/            OPC_EmitMergeInputChains1_0,
/* 47353*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47356*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47359*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 47366*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_load_xor:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 47376*/          0, // EndSwitchType
/* 47377*/        0, // EndSwitchOpcode
/* 47378*/      0, // EndSwitchOpcode
/* 47379*/    /*Scope*/ 113|128,1/*241*/, /*->47622*/
/* 47381*/      OPC_RecordChild1, // #1 = $off
/* 47382*/      OPC_Scope, 9|128,1/*137*/, /*->47522*/ // 2 children in Scope
/* 47385*/        OPC_MoveChild1,
/* 47386*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 47389*/        OPC_MoveParent,
/* 47390*/        OPC_RecordChild2, // #2 = $val
/* 47391*/        OPC_SwitchType /*2 cases */, 95, MVT::i32,// ->47489
/* 47394*/          OPC_Scope, 30, /*->47426*/ // 3 children in Scope
/* 47396*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 47398*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47400*/            OPC_EmitMergeInputChains1_0,
/* 47401*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47404*/            OPC_EmitConvertToTarget, 1,
/* 47406*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47409*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 47416*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 7
                      // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47426*/          /*Scope*/ 30, /*->47457*/
/* 47427*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 47429*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47431*/            OPC_EmitMergeInputChains1_0,
/* 47432*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47435*/            OPC_EmitConvertToTarget, 1,
/* 47437*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47440*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 47447*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 7
                      // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47457*/          /*Scope*/ 30, /*->47488*/
/* 47458*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 47460*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47462*/            OPC_EmitMergeInputChains1_0,
/* 47463*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47466*/            OPC_EmitConvertToTarget, 1,
/* 47468*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47471*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 47478*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_load_xor:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 7
                      // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 47488*/          0, /*End of Scope*/
/* 47489*/        /*SwitchType*/ 30, MVT::i64,// ->47521
/* 47491*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 47493*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47495*/          OPC_EmitMergeInputChains1_0,
/* 47496*/          OPC_EmitInteger, MVT::i32, 0, 
/* 47499*/          OPC_EmitConvertToTarget, 1,
/* 47501*/          OPC_EmitInteger, MVT::i32, 0, 
/* 47504*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 47511*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (atomic_load_xor:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 7
                    // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 47521*/        0, // EndSwitchType
/* 47522*/      /*Scope*/ 98, /*->47621*/
/* 47523*/        OPC_CheckChild1Type, MVT::i32,
/* 47525*/        OPC_RecordChild2, // #2 = $val
/* 47526*/        OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->47597
/* 47529*/          OPC_Scope, 21, /*->47552*/ // 3 children in Scope
/* 47531*/            OPC_CheckPredicate, 7, // Predicate_atomic_load_xor_32
/* 47533*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47535*/            OPC_EmitMergeInputChains1_0,
/* 47536*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47539*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47542*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 4
                      // Dst: (ATOMIC_RMW_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47552*/          /*Scope*/ 21, /*->47574*/
/* 47553*/            OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_8
/* 47555*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47557*/            OPC_EmitMergeInputChains1_0,
/* 47558*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47561*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47564*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 4
                      // Dst: (ATOMIC_RMW8_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47574*/          /*Scope*/ 21, /*->47596*/
/* 47575*/            OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_16
/* 47577*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47579*/            OPC_EmitMergeInputChains1_0,
/* 47580*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47583*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47586*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_load_xor:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 4
                      // Dst: (ATOMIC_RMW16_U_XOR_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47596*/          0, /*End of Scope*/
/* 47597*/        /*SwitchType*/ 21, MVT::i64,// ->47620
/* 47599*/          OPC_CheckPredicate, 8, // Predicate_atomic_load_xor_64
/* 47601*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47603*/          OPC_EmitMergeInputChains1_0,
/* 47604*/          OPC_EmitInteger, MVT::i32, 0, 
/* 47607*/          OPC_EmitInteger, MVT::i32, 0, 
/* 47610*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_load_xor:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 4
                    // Dst: (ATOMIC_RMW_XOR_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 47620*/        0, // EndSwitchType
/* 47621*/      0, /*End of Scope*/
/* 47622*/    0, /*End of Scope*/
/* 47623*/  /*SwitchOpcode*/ 116|128,8/*1140*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->48767
/* 47627*/    OPC_RecordMemRef,
/* 47628*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/* 47629*/    OPC_Scope, 123|128,6/*891*/, /*->48523*/ // 2 children in Scope
/* 47632*/      OPC_MoveChild1,
/* 47633*/      OPC_SwitchOpcode /*3 cases */, 127|128,3/*511*/, TARGET_VAL(ISD::ADD),// ->48149
/* 47638*/        OPC_Scope, 101, /*->47741*/ // 5 children in Scope
/* 47640*/          OPC_RecordChild0, // #1 = $addr
/* 47641*/          OPC_MoveChild1,
/* 47642*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 47645*/          OPC_RecordChild0, // #2 = $off
/* 47646*/          OPC_MoveChild0,
/* 47647*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 47650*/          OPC_MoveParent,
/* 47651*/          OPC_MoveParent,
/* 47652*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 47654*/          OPC_CheckType, MVT::i32,
/* 47656*/          OPC_MoveParent,
/* 47657*/          OPC_RecordChild2, // #3 = $val
/* 47658*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->47720
/* 47661*/            OPC_Scope, 18, /*->47681*/ // 3 children in Scope
/* 47663*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 47665*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47667*/              OPC_EmitMergeInputChains1_0,
/* 47668*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47671*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47681*/            /*Scope*/ 18, /*->47700*/
/* 47682*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 47684*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47686*/              OPC_EmitMergeInputChains1_0,
/* 47687*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47690*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47700*/            /*Scope*/ 18, /*->47719*/
/* 47701*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 47703*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47705*/              OPC_EmitMergeInputChains1_0,
/* 47706*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47709*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47719*/            0, /*End of Scope*/
/* 47720*/          /*SwitchType*/ 18, MVT::i64,// ->47740
/* 47722*/            OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 47724*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47726*/            OPC_EmitMergeInputChains1_0,
/* 47727*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47730*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 47740*/          0, // EndSwitchType
/* 47741*/        /*Scope*/ 101, /*->47843*/
/* 47742*/          OPC_MoveChild0,
/* 47743*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 47746*/          OPC_RecordChild0, // #1 = $off
/* 47747*/          OPC_MoveChild0,
/* 47748*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 47751*/          OPC_MoveParent,
/* 47752*/          OPC_MoveParent,
/* 47753*/          OPC_RecordChild1, // #2 = $addr
/* 47754*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 47756*/          OPC_CheckType, MVT::i32,
/* 47758*/          OPC_MoveParent,
/* 47759*/          OPC_RecordChild2, // #3 = $val
/* 47760*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->47822
/* 47763*/            OPC_Scope, 18, /*->47783*/ // 3 children in Scope
/* 47765*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 47767*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47769*/              OPC_EmitMergeInputChains1_0,
/* 47770*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47773*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47783*/            /*Scope*/ 18, /*->47802*/
/* 47784*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 47786*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47788*/              OPC_EmitMergeInputChains1_0,
/* 47789*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47792*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47802*/            /*Scope*/ 18, /*->47821*/
/* 47803*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 47805*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47807*/              OPC_EmitMergeInputChains1_0,
/* 47808*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47811*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47821*/            0, /*End of Scope*/
/* 47822*/          /*SwitchType*/ 18, MVT::i64,// ->47842
/* 47824*/            OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 47826*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47828*/            OPC_EmitMergeInputChains1_0,
/* 47829*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47832*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_swap:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 47842*/          0, // EndSwitchType
/* 47843*/        /*Scope*/ 99, /*->47943*/
/* 47844*/          OPC_RecordChild0, // #1 = $addr
/* 47845*/          OPC_MoveChild1,
/* 47846*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 47849*/          OPC_RecordChild0, // #2 = $off
/* 47850*/          OPC_MoveChild0,
/* 47851*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 47854*/          OPC_MoveParent,
/* 47855*/          OPC_MoveParent,
/* 47856*/          OPC_CheckType, MVT::i32,
/* 47858*/          OPC_MoveParent,
/* 47859*/          OPC_RecordChild2, // #3 = $val
/* 47860*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->47922
/* 47863*/            OPC_Scope, 18, /*->47883*/ // 3 children in Scope
/* 47865*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 47867*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47869*/              OPC_EmitMergeInputChains1_0,
/* 47870*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47873*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47883*/            /*Scope*/ 18, /*->47902*/
/* 47884*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 47886*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47888*/              OPC_EmitMergeInputChains1_0,
/* 47889*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47892*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47902*/            /*Scope*/ 18, /*->47921*/
/* 47903*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 47905*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47907*/              OPC_EmitMergeInputChains1_0,
/* 47908*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47911*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 2, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47921*/            0, /*End of Scope*/
/* 47922*/          /*SwitchType*/ 18, MVT::i64,// ->47942
/* 47924*/            OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 47926*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47928*/            OPC_EmitMergeInputChains1_0,
/* 47929*/            OPC_EmitInteger, MVT::i32, 0, 
/* 47932*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 2, 1, 3, 
                      // Src: (atomic_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 47942*/          0, // EndSwitchType
/* 47943*/        /*Scope*/ 99, /*->48043*/
/* 47944*/          OPC_MoveChild0,
/* 47945*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 47948*/          OPC_RecordChild0, // #1 = $off
/* 47949*/          OPC_MoveChild0,
/* 47950*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 47953*/          OPC_MoveParent,
/* 47954*/          OPC_MoveParent,
/* 47955*/          OPC_RecordChild1, // #2 = $addr
/* 47956*/          OPC_CheckType, MVT::i32,
/* 47958*/          OPC_MoveParent,
/* 47959*/          OPC_RecordChild2, // #3 = $val
/* 47960*/          OPC_SwitchType /*2 cases */, 59, MVT::i32,// ->48022
/* 47963*/            OPC_Scope, 18, /*->47983*/ // 3 children in Scope
/* 47965*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 47967*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47969*/              OPC_EmitMergeInputChains1_0,
/* 47970*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47973*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 47983*/            /*Scope*/ 18, /*->48002*/
/* 47984*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 47986*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 47988*/              OPC_EmitMergeInputChains1_0,
/* 47989*/              OPC_EmitInteger, MVT::i32, 0, 
/* 47992*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48002*/            /*Scope*/ 18, /*->48021*/
/* 48003*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 48005*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48007*/              OPC_EmitMergeInputChains1_0,
/* 48008*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48011*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 1, 2, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48021*/            0, /*End of Scope*/
/* 48022*/          /*SwitchType*/ 18, MVT::i64,// ->48042
/* 48024*/            OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 48026*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48028*/            OPC_EmitMergeInputChains1_0,
/* 48029*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48032*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 1, 2, 3, 
                      // Src: (atomic_swap:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 48042*/          0, // EndSwitchType
/* 48043*/        /*Scope*/ 104, /*->48148*/
/* 48044*/          OPC_RecordChild0, // #1 = $addr
/* 48045*/          OPC_RecordChild1, // #2 = $off
/* 48046*/          OPC_MoveChild1,
/* 48047*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 48050*/          OPC_MoveParent,
/* 48051*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 48053*/          OPC_CheckType, MVT::i32,
/* 48055*/          OPC_MoveParent,
/* 48056*/          OPC_RecordChild2, // #3 = $val
/* 48057*/          OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->48125
/* 48060*/            OPC_Scope, 20, /*->48082*/ // 3 children in Scope
/* 48062*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 48064*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48066*/              OPC_EmitMergeInputChains1_0,
/* 48067*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48070*/              OPC_EmitConvertToTarget, 2,
/* 48072*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 11
                        // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48082*/            /*Scope*/ 20, /*->48103*/
/* 48083*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 48085*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48087*/              OPC_EmitMergeInputChains1_0,
/* 48088*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48091*/              OPC_EmitConvertToTarget, 2,
/* 48093*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                        // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48103*/            /*Scope*/ 20, /*->48124*/
/* 48104*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 48106*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48108*/              OPC_EmitMergeInputChains1_0,
/* 48109*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48112*/              OPC_EmitConvertToTarget, 2,
/* 48114*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                        // Src: (atomic_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                        // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48124*/            0, /*End of Scope*/
/* 48125*/          /*SwitchType*/ 20, MVT::i64,// ->48147
/* 48127*/            OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 48129*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48131*/            OPC_EmitMergeInputChains1_0,
/* 48132*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48135*/            OPC_EmitConvertToTarget, 2,
/* 48137*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 48147*/          0, // EndSwitchType
/* 48148*/        0, /*End of Scope*/
/* 48149*/      /*SwitchOpcode*/ 104, TARGET_VAL(ISD::OR),// ->48256
/* 48152*/        OPC_RecordChild0, // #1 = $addr
/* 48153*/        OPC_RecordChild1, // #2 = $off
/* 48154*/        OPC_MoveChild1,
/* 48155*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 48158*/        OPC_MoveParent,
/* 48159*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 48161*/        OPC_CheckType, MVT::i32,
/* 48163*/        OPC_MoveParent,
/* 48164*/        OPC_RecordChild2, // #3 = $val
/* 48165*/        OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->48233
/* 48168*/          OPC_Scope, 20, /*->48190*/ // 3 children in Scope
/* 48170*/            OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 48172*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48174*/            OPC_EmitMergeInputChains1_0,
/* 48175*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48178*/            OPC_EmitConvertToTarget, 2,
/* 48180*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48190*/          /*Scope*/ 20, /*->48211*/
/* 48191*/            OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 48193*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48195*/            OPC_EmitMergeInputChains1_0,
/* 48196*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48199*/            OPC_EmitConvertToTarget, 2,
/* 48201*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 11
                      // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48211*/          /*Scope*/ 20, /*->48232*/
/* 48212*/            OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 48214*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48216*/            OPC_EmitMergeInputChains1_0,
/* 48217*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48220*/            OPC_EmitConvertToTarget, 2,
/* 48222*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 4, 5, 1, 3, 
                      // Src: (atomic_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 11
                      // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48232*/          0, /*End of Scope*/
/* 48233*/        /*SwitchType*/ 20, MVT::i64,// ->48255
/* 48235*/          OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 48237*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48239*/          OPC_EmitMergeInputChains1_0,
/* 48240*/          OPC_EmitInteger, MVT::i32, 0, 
/* 48243*/          OPC_EmitConvertToTarget, 2,
/* 48245*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 4, 5, 1, 3, 
                    // Src: (atomic_swap:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 11
                    // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 48255*/        0, // EndSwitchType
/* 48256*/      /*SwitchOpcode*/ 6|128,2/*262*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->48522
/* 48260*/        OPC_RecordChild0, // #1 = $off
/* 48261*/        OPC_MoveChild0,
/* 48262*/        OPC_SwitchOpcode /*2 cases */, 126, TARGET_VAL(ISD::TargetGlobalAddress),// ->48392
/* 48266*/          OPC_MoveParent,
/* 48267*/          OPC_MoveParent,
/* 48268*/          OPC_RecordChild2, // #2 = $val
/* 48269*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->48361
/* 48272*/            OPC_Scope, 28, /*->48302*/ // 3 children in Scope
/* 48274*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 48276*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48278*/              OPC_EmitMergeInputChains1_0,
/* 48279*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48282*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48285*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48292*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48302*/            /*Scope*/ 28, /*->48331*/
/* 48303*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 48305*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48307*/              OPC_EmitMergeInputChains1_0,
/* 48308*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48311*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48314*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48321*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48331*/            /*Scope*/ 28, /*->48360*/
/* 48332*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 48334*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48336*/              OPC_EmitMergeInputChains1_0,
/* 48337*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48340*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48343*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48350*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48360*/            0, /*End of Scope*/
/* 48361*/          /*SwitchType*/ 28, MVT::i64,// ->48391
/* 48363*/            OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 48365*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48367*/            OPC_EmitMergeInputChains1_0,
/* 48368*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48371*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48374*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48381*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 48391*/          0, // EndSwitchType
/* 48392*/        /*SwitchOpcode*/ 126, TARGET_VAL(ISD::TargetExternalSymbol),// ->48521
/* 48395*/          OPC_MoveParent,
/* 48396*/          OPC_MoveParent,
/* 48397*/          OPC_RecordChild2, // #2 = $val
/* 48398*/          OPC_SwitchType /*2 cases */, 89, MVT::i32,// ->48490
/* 48401*/            OPC_Scope, 28, /*->48431*/ // 3 children in Scope
/* 48403*/              OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 48405*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48407*/              OPC_EmitMergeInputChains1_0,
/* 48408*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48411*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48414*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48421*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48431*/            /*Scope*/ 28, /*->48460*/
/* 48432*/              OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 48434*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48436*/              OPC_EmitMergeInputChains1_0,
/* 48437*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48440*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48443*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48450*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48460*/            /*Scope*/ 28, /*->48489*/
/* 48461*/              OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 48463*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48465*/              OPC_EmitMergeInputChains1_0,
/* 48466*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48469*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48472*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48479*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 4/*#Ops*/, 3, 1, 5, 2, 
                        // Src: (atomic_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48489*/            0, /*End of Scope*/
/* 48490*/          /*SwitchType*/ 28, MVT::i64,// ->48520
/* 48492*/            OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 48494*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48496*/            OPC_EmitMergeInputChains1_0,
/* 48497*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48500*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48503*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 4,  // Results = #5
/* 48510*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 4/*#Ops*/, 3, 1, 5, 2, 
                      // Src: (atomic_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 48520*/          0, // EndSwitchType
/* 48521*/        0, // EndSwitchOpcode
/* 48522*/      0, // EndSwitchOpcode
/* 48523*/    /*Scope*/ 113|128,1/*241*/, /*->48766*/
/* 48525*/      OPC_RecordChild1, // #1 = $off
/* 48526*/      OPC_Scope, 9|128,1/*137*/, /*->48666*/ // 2 children in Scope
/* 48529*/        OPC_MoveChild1,
/* 48530*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 48533*/        OPC_MoveParent,
/* 48534*/        OPC_RecordChild2, // #2 = $val
/* 48535*/        OPC_SwitchType /*2 cases */, 95, MVT::i32,// ->48633
/* 48538*/          OPC_Scope, 30, /*->48570*/ // 3 children in Scope
/* 48540*/            OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 48542*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48544*/            OPC_EmitMergeInputChains1_0,
/* 48545*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48548*/            OPC_EmitConvertToTarget, 1,
/* 48550*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48553*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 48560*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 7
                      // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48570*/          /*Scope*/ 30, /*->48601*/
/* 48571*/            OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 48573*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48575*/            OPC_EmitMergeInputChains1_0,
/* 48576*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48579*/            OPC_EmitConvertToTarget, 1,
/* 48581*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48584*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 48591*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 7
                      // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48601*/          /*Scope*/ 30, /*->48632*/
/* 48602*/            OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 48604*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48606*/            OPC_EmitMergeInputChains1_0,
/* 48607*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48610*/            OPC_EmitConvertToTarget, 1,
/* 48612*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48615*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 48622*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 6, 2, 
                      // Src: (atomic_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 7
                      // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$val)
/* 48632*/          0, /*End of Scope*/
/* 48633*/        /*SwitchType*/ 30, MVT::i64,// ->48665
/* 48635*/          OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 48637*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48639*/          OPC_EmitMergeInputChains1_0,
/* 48640*/          OPC_EmitInteger, MVT::i32, 0, 
/* 48643*/          OPC_EmitConvertToTarget, 1,
/* 48645*/          OPC_EmitInteger, MVT::i32, 0, 
/* 48648*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 48655*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 6, 2, 
                    // Src: (atomic_swap:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 7
                    // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$val)
/* 48665*/        0, // EndSwitchType
/* 48666*/      /*Scope*/ 98, /*->48765*/
/* 48667*/        OPC_CheckChild1Type, MVT::i32,
/* 48669*/        OPC_RecordChild2, // #2 = $val
/* 48670*/        OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->48741
/* 48673*/          OPC_Scope, 21, /*->48696*/ // 3 children in Scope
/* 48675*/            OPC_CheckPredicate, 7, // Predicate_atomic_swap_32
/* 48677*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48679*/            OPC_EmitMergeInputChains1_0,
/* 48680*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48683*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48686*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 4
                      // Dst: (ATOMIC_RMW_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48696*/          /*Scope*/ 21, /*->48718*/
/* 48697*/            OPC_CheckPredicate, 1, // Predicate_atomic_swap_8
/* 48699*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48701*/            OPC_EmitMergeInputChains1_0,
/* 48702*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48705*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48708*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 4
                      // Dst: (ATOMIC_RMW8_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48718*/          /*Scope*/ 21, /*->48740*/
/* 48719*/            OPC_CheckPredicate, 2, // Predicate_atomic_swap_16
/* 48721*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48723*/            OPC_EmitMergeInputChains1_0,
/* 48724*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48727*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48730*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 4/*#Ops*/, 3, 4, 1, 2, 
                      // Src: (atomic_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 4
                      // Dst: (ATOMIC_RMW16_U_XCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/* 48740*/          0, /*End of Scope*/
/* 48741*/        /*SwitchType*/ 21, MVT::i64,// ->48764
/* 48743*/          OPC_CheckPredicate, 8, // Predicate_atomic_swap_64
/* 48745*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48747*/          OPC_EmitMergeInputChains1_0,
/* 48748*/          OPC_EmitInteger, MVT::i32, 0, 
/* 48751*/          OPC_EmitInteger, MVT::i32, 0, 
/* 48754*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 4/*#Ops*/, 3, 4, 1, 2, 
                    // Src: (atomic_swap:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 4
                    // Dst: (ATOMIC_RMW_XCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/* 48764*/        0, // EndSwitchType
/* 48765*/      0, /*End of Scope*/
/* 48766*/    0, /*End of Scope*/
/* 48767*/  /*SwitchOpcode*/ 40|128,9/*1192*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->49963
/* 48771*/    OPC_RecordMemRef,
/* 48772*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 48773*/    OPC_Scope, 37|128,7/*933*/, /*->49709*/ // 2 children in Scope
/* 48776*/      OPC_MoveChild1,
/* 48777*/      OPC_SwitchOpcode /*3 cases */, 24|128,4/*536*/, TARGET_VAL(ISD::ADD),// ->49318
/* 48782*/        OPC_Scope, 106, /*->48890*/ // 5 children in Scope
/* 48784*/          OPC_RecordChild0, // #1 = $addr
/* 48785*/          OPC_MoveChild1,
/* 48786*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48789*/          OPC_RecordChild0, // #2 = $off
/* 48790*/          OPC_MoveChild0,
/* 48791*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48794*/          OPC_MoveParent,
/* 48795*/          OPC_MoveParent,
/* 48796*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 48798*/          OPC_CheckType, MVT::i32,
/* 48800*/          OPC_MoveParent,
/* 48801*/          OPC_RecordChild2, // #3 = $exp
/* 48802*/          OPC_RecordChild3, // #4 = $new
/* 48803*/          OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->48868
/* 48806*/            OPC_Scope, 19, /*->48827*/ // 3 children in Scope
/* 48808*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 48810*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48812*/              OPC_EmitMergeInputChains1_0,
/* 48813*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48816*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 48827*/            /*Scope*/ 19, /*->48847*/
/* 48828*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 48830*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48832*/              OPC_EmitMergeInputChains1_0,
/* 48833*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48836*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 48847*/            /*Scope*/ 19, /*->48867*/
/* 48848*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 48850*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48852*/              OPC_EmitMergeInputChains1_0,
/* 48853*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48856*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 48867*/            0, /*End of Scope*/
/* 48868*/          /*SwitchType*/ 19, MVT::i64,// ->48889
/* 48870*/            OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 48872*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48874*/            OPC_EmitMergeInputChains1_0,
/* 48875*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48878*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off))<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 48889*/          0, // EndSwitchType
/* 48890*/        /*Scope*/ 106, /*->48997*/
/* 48891*/          OPC_MoveChild0,
/* 48892*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 48895*/          OPC_RecordChild0, // #1 = $off
/* 48896*/          OPC_MoveChild0,
/* 48897*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 48900*/          OPC_MoveParent,
/* 48901*/          OPC_MoveParent,
/* 48902*/          OPC_RecordChild1, // #2 = $addr
/* 48903*/          OPC_CheckPredicate, 0, // Predicate_regPlusGA
/* 48905*/          OPC_CheckType, MVT::i32,
/* 48907*/          OPC_MoveParent,
/* 48908*/          OPC_RecordChild2, // #3 = $exp
/* 48909*/          OPC_RecordChild3, // #4 = $new
/* 48910*/          OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->48975
/* 48913*/            OPC_Scope, 19, /*->48934*/ // 3 children in Scope
/* 48915*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 48917*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48919*/              OPC_EmitMergeInputChains1_0,
/* 48920*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48923*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 14
                        // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 48934*/            /*Scope*/ 19, /*->48954*/
/* 48935*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 48937*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48939*/              OPC_EmitMergeInputChains1_0,
/* 48940*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48943*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 14
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 48954*/            /*Scope*/ 19, /*->48974*/
/* 48955*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 48957*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48959*/              OPC_EmitMergeInputChains1_0,
/* 48960*/              OPC_EmitInteger, MVT::i32, 0, 
/* 48963*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 14
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 48974*/            0, /*End of Scope*/
/* 48975*/          /*SwitchType*/ 19, MVT::i64,// ->48996
/* 48977*/            OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 48979*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 48981*/            OPC_EmitMergeInputChains1_0,
/* 48982*/            OPC_EmitInteger, MVT::i32, 0, 
/* 48985*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr)<<P:Predicate_regPlusGA>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 14
                      // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 48996*/          0, // EndSwitchType
/* 48997*/        /*Scope*/ 104, /*->49102*/
/* 48998*/          OPC_RecordChild0, // #1 = $addr
/* 48999*/          OPC_MoveChild1,
/* 49000*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 49003*/          OPC_RecordChild0, // #2 = $off
/* 49004*/          OPC_MoveChild0,
/* 49005*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 49008*/          OPC_MoveParent,
/* 49009*/          OPC_MoveParent,
/* 49010*/          OPC_CheckType, MVT::i32,
/* 49012*/          OPC_MoveParent,
/* 49013*/          OPC_RecordChild2, // #3 = $exp
/* 49014*/          OPC_RecordChild3, // #4 = $new
/* 49015*/          OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->49080
/* 49018*/            OPC_Scope, 19, /*->49039*/ // 3 children in Scope
/* 49020*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49022*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49024*/              OPC_EmitMergeInputChains1_0,
/* 49025*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49028*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49039*/            /*Scope*/ 19, /*->49059*/
/* 49040*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49042*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49044*/              OPC_EmitMergeInputChains1_0,
/* 49045*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49048*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49059*/            /*Scope*/ 19, /*->49079*/
/* 49060*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49062*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49064*/              OPC_EmitMergeInputChains1_0,
/* 49065*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49068*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49079*/            0, /*End of Scope*/
/* 49080*/          /*SwitchType*/ 19, MVT::i64,// ->49101
/* 49082*/            OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49084*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49086*/            OPC_EmitMergeInputChains1_0,
/* 49087*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49090*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 5, 2, 1, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off)), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49101*/          0, // EndSwitchType
/* 49102*/        /*Scope*/ 104, /*->49207*/
/* 49103*/          OPC_MoveChild0,
/* 49104*/          OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 49107*/          OPC_RecordChild0, // #1 = $off
/* 49108*/          OPC_MoveChild0,
/* 49109*/          OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 49112*/          OPC_MoveParent,
/* 49113*/          OPC_MoveParent,
/* 49114*/          OPC_RecordChild1, // #2 = $addr
/* 49115*/          OPC_CheckType, MVT::i32,
/* 49117*/          OPC_MoveParent,
/* 49118*/          OPC_RecordChild2, // #3 = $exp
/* 49119*/          OPC_RecordChild3, // #4 = $new
/* 49120*/          OPC_SwitchType /*2 cases */, 62, MVT::i32,// ->49185
/* 49123*/            OPC_Scope, 19, /*->49144*/ // 3 children in Scope
/* 49125*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49127*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49129*/              OPC_EmitMergeInputChains1_0,
/* 49130*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49133*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
                        // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49144*/            /*Scope*/ 19, /*->49164*/
/* 49145*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49147*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49149*/              OPC_EmitMergeInputChains1_0,
/* 49150*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49153*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49164*/            /*Scope*/ 19, /*->49184*/
/* 49165*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49167*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49169*/              OPC_EmitMergeInputChains1_0,
/* 49170*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49173*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49184*/            0, /*End of Scope*/
/* 49185*/          /*SwitchType*/ 19, MVT::i64,// ->49206
/* 49187*/            OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49189*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49191*/            OPC_EmitMergeInputChains1_0,
/* 49192*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49195*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 5, 1, 2, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i64] } (add:{ *:[i32] } (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$off), I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
                      // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49206*/          0, // EndSwitchType
/* 49207*/        /*Scope*/ 109, /*->49317*/
/* 49208*/          OPC_RecordChild0, // #1 = $addr
/* 49209*/          OPC_RecordChild1, // #2 = $off
/* 49210*/          OPC_MoveChild1,
/* 49211*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49214*/          OPC_MoveParent,
/* 49215*/          OPC_CheckPredicate, 3, // Predicate_regPlusImm
/* 49217*/          OPC_CheckType, MVT::i32,
/* 49219*/          OPC_MoveParent,
/* 49220*/          OPC_RecordChild2, // #3 = $exp
/* 49221*/          OPC_RecordChild3, // #4 = $new
/* 49222*/          OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->49293
/* 49225*/            OPC_Scope, 21, /*->49248*/ // 3 children in Scope
/* 49227*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49229*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49231*/              OPC_EmitMergeInputChains1_0,
/* 49232*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49235*/              OPC_EmitConvertToTarget, 2,
/* 49237*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 11
                        // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49248*/            /*Scope*/ 21, /*->49270*/
/* 49249*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49251*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49253*/              OPC_EmitMergeInputChains1_0,
/* 49254*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49257*/              OPC_EmitConvertToTarget, 2,
/* 49259*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49270*/            /*Scope*/ 21, /*->49292*/
/* 49271*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49273*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49275*/              OPC_EmitMergeInputChains1_0,
/* 49276*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49279*/              OPC_EmitConvertToTarget, 2,
/* 49281*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49292*/            0, /*End of Scope*/
/* 49293*/          /*SwitchType*/ 21, MVT::i64,// ->49316
/* 49295*/            OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49297*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49299*/            OPC_EmitMergeInputChains1_0,
/* 49300*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49303*/            OPC_EmitConvertToTarget, 2,
/* 49305*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i64] } (add:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_regPlusImm>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49316*/          0, // EndSwitchType
/* 49317*/        0, /*End of Scope*/
/* 49318*/      /*SwitchOpcode*/ 109, TARGET_VAL(ISD::OR),// ->49430
/* 49321*/        OPC_RecordChild0, // #1 = $addr
/* 49322*/        OPC_RecordChild1, // #2 = $off
/* 49323*/        OPC_MoveChild1,
/* 49324*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49327*/        OPC_MoveParent,
/* 49328*/        OPC_CheckPredicate, 4, // Predicate_or_is_add
/* 49330*/        OPC_CheckType, MVT::i32,
/* 49332*/        OPC_MoveParent,
/* 49333*/        OPC_RecordChild2, // #3 = $exp
/* 49334*/        OPC_RecordChild3, // #4 = $new
/* 49335*/        OPC_SwitchType /*2 cases */, 68, MVT::i32,// ->49406
/* 49338*/          OPC_Scope, 21, /*->49361*/ // 3 children in Scope
/* 49340*/            OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49342*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49344*/            OPC_EmitMergeInputChains1_0,
/* 49345*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49348*/            OPC_EmitConvertToTarget, 2,
/* 49350*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 11
                      // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49361*/          /*Scope*/ 21, /*->49383*/
/* 49362*/            OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49364*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49366*/            OPC_EmitMergeInputChains1_0,
/* 49367*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49370*/            OPC_EmitConvertToTarget, 2,
/* 49372*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 11
                      // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49383*/          /*Scope*/ 21, /*->49405*/
/* 49384*/            OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49386*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49388*/            OPC_EmitMergeInputChains1_0,
/* 49389*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49392*/            OPC_EmitConvertToTarget, 2,
/* 49394*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 11
                      // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49405*/          0, /*End of Scope*/
/* 49406*/        /*SwitchType*/ 21, MVT::i64,// ->49429
/* 49408*/          OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49410*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49412*/          OPC_EmitMergeInputChains1_0,
/* 49413*/          OPC_EmitInteger, MVT::i32, 0, 
/* 49416*/          OPC_EmitConvertToTarget, 2,
/* 49418*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 5/*#Ops*/, 5, 6, 1, 3, 4, 
                    // Src: (atomic_cmp_swap:{ *:[i64] } (or:{ *:[i32] } I32:{ *:[i32] }:$addr, (imm:{ *:[i32] }):$off)<<P:Predicate_or_is_add>>, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 11
                    // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49429*/        0, // EndSwitchType
/* 49430*/      /*SwitchOpcode*/ 18|128,2/*274*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->49708
/* 49434*/        OPC_RecordChild0, // #1 = $off
/* 49435*/        OPC_MoveChild0,
/* 49436*/        OPC_SwitchOpcode /*2 cases */, 3|128,1/*131*/, TARGET_VAL(ISD::TargetGlobalAddress),// ->49572
/* 49441*/          OPC_MoveParent,
/* 49442*/          OPC_MoveParent,
/* 49443*/          OPC_RecordChild2, // #2 = $exp
/* 49444*/          OPC_RecordChild3, // #3 = $new
/* 49445*/          OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->49540
/* 49448*/            OPC_Scope, 29, /*->49479*/ // 3 children in Scope
/* 49450*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49452*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49454*/              OPC_EmitMergeInputChains1_0,
/* 49455*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49458*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49461*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49468*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49479*/            /*Scope*/ 29, /*->49509*/
/* 49480*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49482*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49484*/              OPC_EmitMergeInputChains1_0,
/* 49485*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49488*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49491*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49498*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49509*/            /*Scope*/ 29, /*->49539*/
/* 49510*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49512*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49514*/              OPC_EmitMergeInputChains1_0,
/* 49515*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49518*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49521*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49528*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49539*/            0, /*End of Scope*/
/* 49540*/          /*SwitchType*/ 29, MVT::i64,// ->49571
/* 49542*/            OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49544*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49546*/            OPC_EmitMergeInputChains1_0,
/* 49547*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49550*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49553*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49560*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (tglobaladdr:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49571*/          0, // EndSwitchType
/* 49572*/        /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::TargetExternalSymbol),// ->49707
/* 49576*/          OPC_MoveParent,
/* 49577*/          OPC_MoveParent,
/* 49578*/          OPC_RecordChild2, // #2 = $exp
/* 49579*/          OPC_RecordChild3, // #3 = $new
/* 49580*/          OPC_SwitchType /*2 cases */, 92, MVT::i32,// ->49675
/* 49583*/            OPC_Scope, 29, /*->49614*/ // 3 children in Scope
/* 49585*/              OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49587*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49589*/              OPC_EmitMergeInputChains1_0,
/* 49590*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49593*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49596*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49603*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 10
                        // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49614*/            /*Scope*/ 29, /*->49644*/
/* 49615*/              OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49617*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49619*/              OPC_EmitMergeInputChains1_0,
/* 49620*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49623*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49626*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49633*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 10
                        // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49644*/            /*Scope*/ 29, /*->49674*/
/* 49645*/              OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49647*/              OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49649*/              OPC_EmitMergeInputChains1_0,
/* 49650*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49653*/              OPC_EmitInteger, MVT::i32, 0, 
/* 49656*/              OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                            MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49663*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                            MVT::i32, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                        // Src: (atomic_cmp_swap:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 10
                        // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49674*/            0, /*End of Scope*/
/* 49675*/          /*SwitchType*/ 29, MVT::i64,// ->49706
/* 49677*/            OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49679*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49681*/            OPC_EmitMergeInputChains1_0,
/* 49682*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49685*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49688*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 5,  // Results = #6
/* 49695*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i64, 5/*#Ops*/, 4, 1, 6, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$off), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 10
                      // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (texternalsym:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49706*/          0, // EndSwitchType
/* 49707*/        0, // EndSwitchOpcode
/* 49708*/      0, // EndSwitchOpcode
/* 49709*/    /*Scope*/ 123|128,1/*251*/, /*->49962*/
/* 49711*/      OPC_RecordChild1, // #1 = $off
/* 49712*/      OPC_Scope, 14|128,1/*142*/, /*->49857*/ // 2 children in Scope
/* 49715*/        OPC_MoveChild1,
/* 49716*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 49719*/        OPC_MoveParent,
/* 49720*/        OPC_RecordChild2, // #2 = $exp
/* 49721*/        OPC_RecordChild3, // #3 = $new
/* 49722*/        OPC_SwitchType /*2 cases */, 98, MVT::i32,// ->49823
/* 49725*/          OPC_Scope, 31, /*->49758*/ // 3 children in Scope
/* 49727*/            OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49729*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49731*/            OPC_EmitMergeInputChains1_0,
/* 49732*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49735*/            OPC_EmitConvertToTarget, 1,
/* 49737*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49740*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 49747*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 7
                      // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49758*/          /*Scope*/ 31, /*->49790*/
/* 49759*/            OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49761*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49763*/            OPC_EmitMergeInputChains1_0,
/* 49764*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49767*/            OPC_EmitConvertToTarget, 1,
/* 49769*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49772*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 49779*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 7
                      // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49790*/          /*Scope*/ 31, /*->49822*/
/* 49791*/            OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49793*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49795*/            OPC_EmitMergeInputChains1_0,
/* 49796*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49799*/            OPC_EmitConvertToTarget, 1,
/* 49801*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49804*/            OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                          MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 49811*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } (imm:{ *:[iPTR] }):$off, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 7
                      // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49822*/          0, /*End of Scope*/
/* 49823*/        /*SwitchType*/ 31, MVT::i64,// ->49856
/* 49825*/          OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49827*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49829*/          OPC_EmitMergeInputChains1_0,
/* 49830*/          OPC_EmitInteger, MVT::i32, 0, 
/* 49833*/          OPC_EmitConvertToTarget, 1,
/* 49835*/          OPC_EmitInteger, MVT::i32, 0, 
/* 49838*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                        MVT::i32, 1/*#Ops*/, 6,  // Results = #7
/* 49845*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 5/*#Ops*/, 4, 5, 7, 2, 3, 
                    // Src: (atomic_cmp_swap:{ *:[i64] } (imm:{ *:[iPTR] }):$off, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 7
                    // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, (imm:{ *:[i32] }):$off, (CONST_I32:{ *:[i32] } 0:{ *:[i32] }), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49856*/        0, // EndSwitchType
/* 49857*/      /*Scope*/ 103, /*->49961*/
/* 49858*/        OPC_CheckChild1Type, MVT::i32,
/* 49860*/        OPC_RecordChild2, // #2 = $exp
/* 49861*/        OPC_RecordChild3, // #3 = $new
/* 49862*/        OPC_SwitchType /*2 cases */, 71, MVT::i32,// ->49936
/* 49865*/          OPC_Scope, 22, /*->49889*/ // 3 children in Scope
/* 49867*/            OPC_CheckPredicate, 7, // Predicate_atomic_cmp_swap_32
/* 49869*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49871*/            OPC_EmitMergeInputChains1_0,
/* 49872*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49875*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49878*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 4
                      // Dst: (ATOMIC_RMW_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49889*/          /*Scope*/ 22, /*->49912*/
/* 49890*/            OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_8
/* 49892*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49894*/            OPC_EmitMergeInputChains1_0,
/* 49895*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49898*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49901*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 4
                      // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49912*/          /*Scope*/ 22, /*->49935*/
/* 49913*/            OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_16
/* 49915*/            OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49917*/            OPC_EmitMergeInputChains1_0,
/* 49918*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49921*/            OPC_EmitInteger, MVT::i32, 0, 
/* 49924*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32), 0|OPFL_Chain|OPFL_MemRefs,
                          MVT::i32, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                      // Src: (atomic_cmp_swap:{ *:[i32] } I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 4
                      // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32:{ *:[i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)
/* 49935*/          0, /*End of Scope*/
/* 49936*/        /*SwitchType*/ 22, MVT::i64,// ->49960
/* 49938*/          OPC_CheckPredicate, 8, // Predicate_atomic_cmp_swap_64
/* 49940*/          OPC_CheckPatternPredicate, 0, // (Subtarget->hasAtomics())
/* 49942*/          OPC_EmitMergeInputChains1_0,
/* 49943*/          OPC_EmitInteger, MVT::i32, 0, 
/* 49946*/          OPC_EmitInteger, MVT::i32, 0, 
/* 49949*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64), 0|OPFL_Chain|OPFL_MemRefs,
                        MVT::i64, 5/*#Ops*/, 4, 5, 1, 2, 3, 
                    // Src: (atomic_cmp_swap:{ *:[i64] } I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 4
                    // Dst: (ATOMIC_RMW_CMPXCHG_I64:{ *:[i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)
/* 49960*/        0, // EndSwitchType
/* 49961*/      0, /*End of Scope*/
/* 49962*/    0, /*End of Scope*/
/* 49963*/  /*SwitchOpcode*/ 76, TARGET_VAL(ISD::BRCOND),// ->50042
/* 49966*/    OPC_RecordNode, // #0 = 'brcond' chained node
/* 49967*/    OPC_Scope, 54, /*->50023*/ // 2 children in Scope
/* 49969*/      OPC_MoveChild1,
/* 49970*/      OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 49973*/      OPC_RecordChild0, // #1 = $cond
/* 49974*/      OPC_CheckChild0Type, MVT::i32,
/* 49976*/      OPC_CheckChild1Integer, 0, 
/* 49978*/      OPC_MoveChild2,
/* 49979*/      OPC_Scope, 20, /*->50001*/ // 2 children in Scope
/* 49981*/        OPC_CheckCondCode, ISD::SETNE,
/* 49983*/        OPC_MoveParent,
/* 49984*/        OPC_CheckType, MVT::i32,
/* 49986*/        OPC_MoveParent,
/* 49987*/        OPC_RecordChild2, // #2 = $dst
/* 49988*/        OPC_MoveChild2,
/* 49989*/        OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 49992*/        OPC_MoveParent,
/* 49993*/        OPC_EmitMergeInputChains1_0,
/* 49994*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                      2/*#Ops*/, 2, 1, 
                  // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
                  // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 50001*/      /*Scope*/ 20, /*->50022*/
/* 50002*/        OPC_CheckCondCode, ISD::SETEQ,
/* 50004*/        OPC_MoveParent,
/* 50005*/        OPC_CheckType, MVT::i32,
/* 50007*/        OPC_MoveParent,
/* 50008*/        OPC_RecordChild2, // #2 = $dst
/* 50009*/        OPC_MoveChild2,
/* 50010*/        OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 50013*/        OPC_MoveParent,
/* 50014*/        OPC_EmitMergeInputChains1_0,
/* 50015*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_UNLESS), 0|OPFL_Chain,
                      2/*#Ops*/, 2, 1, 
                  // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
                  // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 50022*/      0, /*End of Scope*/
/* 50023*/    /*Scope*/ 17, /*->50041*/
/* 50024*/      OPC_RecordChild1, // #1 = $cond
/* 50025*/      OPC_CheckChild1Type, MVT::i32,
/* 50027*/      OPC_RecordChild2, // #2 = $dst
/* 50028*/      OPC_MoveChild2,
/* 50029*/      OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 50032*/      OPC_MoveParent,
/* 50033*/      OPC_EmitMergeInputChains1_0,
/* 50034*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                    2/*#Ops*/, 2, 1, 
                // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
                // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/* 50041*/    0, /*End of Scope*/
/* 50042*/  /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTL),// ->50112
/* 50045*/    OPC_RecordChild0, // #0 = $lhs
/* 50046*/    OPC_Scope, 35, /*->50083*/ // 2 children in Scope
/* 50048*/      OPC_MoveChild1,
/* 50049*/      OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->50066
/* 50052*/        OPC_CheckAndImm, 31, 
/* 50054*/        OPC_RecordChild0, // #1 = $rhs
/* 50055*/        OPC_MoveParent,
/* 50056*/        OPC_CheckType, MVT::i32,
/* 50058*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
                  // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50066*/      /*SwitchType*/ 14, MVT::i64,// ->50082
/* 50068*/        OPC_CheckAndImm, 63, 
/* 50070*/        OPC_RecordChild0, // #1 = $rhs
/* 50071*/        OPC_MoveParent,
/* 50072*/        OPC_CheckType, MVT::i64,
/* 50074*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
                  // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50082*/      0, // EndSwitchType
/* 50083*/    /*Scope*/ 27, /*->50111*/
/* 50084*/      OPC_RecordChild1, // #1 = $rhs
/* 50085*/      OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->50098
/* 50088*/        OPC_CheckChild1Type, MVT::i32,
/* 50090*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50098*/      /*SwitchType*/ 10, MVT::i64,// ->50110
/* 50100*/        OPC_CheckChild1Type, MVT::i64,
/* 50102*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50110*/      0, // EndSwitchType
/* 50111*/    0, /*End of Scope*/
/* 50112*/  /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTR),// ->50182
/* 50115*/    OPC_RecordChild0, // #0 = $lhs
/* 50116*/    OPC_Scope, 35, /*->50153*/ // 2 children in Scope
/* 50118*/      OPC_MoveChild1,
/* 50119*/      OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->50136
/* 50122*/        OPC_CheckAndImm, 31, 
/* 50124*/        OPC_RecordChild0, // #1 = $rhs
/* 50125*/        OPC_MoveParent,
/* 50126*/        OPC_CheckType, MVT::i32,
/* 50128*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
                  // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50136*/      /*SwitchType*/ 14, MVT::i64,// ->50152
/* 50138*/        OPC_CheckAndImm, 63, 
/* 50140*/        OPC_RecordChild0, // #1 = $rhs
/* 50141*/        OPC_MoveParent,
/* 50142*/        OPC_CheckType, MVT::i64,
/* 50144*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
                  // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50152*/      0, // EndSwitchType
/* 50153*/    /*Scope*/ 27, /*->50181*/
/* 50154*/      OPC_RecordChild1, // #1 = $rhs
/* 50155*/      OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->50168
/* 50158*/        OPC_CheckChild1Type, MVT::i32,
/* 50160*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 50168*/      /*SwitchType*/ 10, MVT::i64,// ->50180
/* 50170*/        OPC_CheckChild1Type, MVT::i64,
/* 50172*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 50180*/      0, // EndSwitchType
/* 50181*/    0, /*End of Scope*/
/* 50182*/  /*SwitchOpcode*/ 52|128,2/*308*/, TARGET_VAL(ISD::SELECT),// ->50494
/* 50186*/    OPC_Scope, 118, /*->50306*/ // 4 children in Scope
/* 50188*/      OPC_MoveChild0,
/* 50189*/      OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 50192*/      OPC_RecordChild0, // #0 = $cond
/* 50193*/      OPC_CheckChild0Type, MVT::i32,
/* 50195*/      OPC_CheckChild1Integer, 0, 
/* 50197*/      OPC_MoveChild2,
/* 50198*/      OPC_Scope, 32, /*->50232*/ // 4 children in Scope
/* 50200*/        OPC_CheckCondCode, ISD::SETNE,
/* 50202*/        OPC_MoveParent,
/* 50203*/        OPC_CheckType, MVT::i32,
/* 50205*/        OPC_MoveParent,
/* 50206*/        OPC_RecordChild1, // #1 = $lhs
/* 50207*/        OPC_RecordChild2, // #2 = $rhs
/* 50208*/        OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->50220
/* 50211*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                        MVT::i32, 3/*#Ops*/, 1, 2, 0, 
                    // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
                    // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50220*/        /*SwitchType*/ 9, MVT::i64,// ->50231
/* 50222*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                        MVT::i64, 3/*#Ops*/, 1, 2, 0, 
                    // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
                    // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50231*/        0, // EndSwitchType
/* 50232*/      /*Scope*/ 32, /*->50265*/
/* 50233*/        OPC_CheckCondCode, ISD::SETEQ,
/* 50235*/        OPC_MoveParent,
/* 50236*/        OPC_CheckType, MVT::i32,
/* 50238*/        OPC_MoveParent,
/* 50239*/        OPC_RecordChild1, // #1 = $lhs
/* 50240*/        OPC_RecordChild2, // #2 = $rhs
/* 50241*/        OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->50253
/* 50244*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                        MVT::i32, 3/*#Ops*/, 2, 1, 0, 
                    // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
                    // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 50253*/        /*SwitchType*/ 9, MVT::i64,// ->50264
/* 50255*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                        MVT::i64, 3/*#Ops*/, 2, 1, 0, 
                    // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
                    // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 50264*/        0, // EndSwitchType
/* 50265*/      /*Scope*/ 19, /*->50285*/
/* 50266*/        OPC_CheckCondCode, ISD::SETNE,
/* 50268*/        OPC_MoveParent,
/* 50269*/        OPC_CheckType, MVT::i32,
/* 50271*/        OPC_MoveParent,
/* 50272*/        OPC_RecordChild1, // #1 = $lhs
/* 50273*/        OPC_RecordChild2, // #2 = $rhs
/* 50274*/        OPC_CheckType, MVT::ExceptRef,
/* 50276*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXCEPT_REF), 0,
                      MVT::ExceptRef, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (select:{ *:[ExceptRef] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXCEPT_REF:{ *:[ExceptRef] }:$lhs, EXCEPT_REF:{ *:[ExceptRef] }:$rhs) - Complexity = 11
                  // Dst: (SELECT_EXCEPT_REF:{ *:[ExceptRef] } EXCEPT_REF:{ *:[ExceptRef] }:$lhs, EXCEPT_REF:{ *:[ExceptRef] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50285*/      /*Scope*/ 19, /*->50305*/
/* 50286*/        OPC_CheckCondCode, ISD::SETEQ,
/* 50288*/        OPC_MoveParent,
/* 50289*/        OPC_CheckType, MVT::i32,
/* 50291*/        OPC_MoveParent,
/* 50292*/        OPC_RecordChild1, // #1 = $lhs
/* 50293*/        OPC_RecordChild2, // #2 = $rhs
/* 50294*/        OPC_CheckType, MVT::ExceptRef,
/* 50296*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXCEPT_REF), 0,
                      MVT::ExceptRef, 3/*#Ops*/, 2, 1, 0, 
                  // Src: (select:{ *:[ExceptRef] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXCEPT_REF:{ *:[ExceptRef] }:$lhs, EXCEPT_REF:{ *:[ExceptRef] }:$rhs) - Complexity = 11
                  // Dst: (SELECT_EXCEPT_REF:{ *:[ExceptRef] } EXCEPT_REF:{ *:[ExceptRef] }:$rhs, EXCEPT_REF:{ *:[ExceptRef] }:$lhs, I32:{ *:[i32] }:$cond)
/* 50305*/      0, /*End of Scope*/
/* 50306*/    /*Scope*/ 40, /*->50347*/
/* 50307*/      OPC_RecordChild0, // #0 = $cond
/* 50308*/      OPC_CheckChild0Type, MVT::i32,
/* 50310*/      OPC_RecordChild1, // #1 = $lhs
/* 50311*/      OPC_RecordChild2, // #2 = $rhs
/* 50312*/      OPC_SwitchType /*3 cases */, 9, MVT::i32,// ->50324
/* 50315*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                      MVT::i32, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50324*/      /*SwitchType*/ 9, MVT::i64,// ->50335
/* 50326*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                      MVT::i64, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50335*/      /*SwitchType*/ 9, MVT::ExceptRef,// ->50346
/* 50337*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXCEPT_REF), 0,
                      MVT::ExceptRef, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (select:{ *:[ExceptRef] } I32:{ *:[i32] }:$cond, EXCEPT_REF:{ *:[ExceptRef] }:$lhs, EXCEPT_REF:{ *:[ExceptRef] }:$rhs) - Complexity = 3
                  // Dst: (SELECT_EXCEPT_REF:{ *:[ExceptRef] } EXCEPT_REF:{ *:[ExceptRef] }:$lhs, EXCEPT_REF:{ *:[ExceptRef] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50346*/      0, // EndSwitchType
/* 50347*/    /*Scope*/ 115, /*->50463*/
/* 50348*/      OPC_MoveChild0,
/* 50349*/      OPC_SwitchOpcode /*2 cases */, 74, TARGET_VAL(ISD::SETCC),// ->50427
/* 50353*/        OPC_RecordChild0, // #0 = $cond
/* 50354*/        OPC_CheckChild0Type, MVT::i32,
/* 50356*/        OPC_CheckChild1Integer, 0, 
/* 50358*/        OPC_MoveChild2,
/* 50359*/        OPC_Scope, 32, /*->50393*/ // 2 children in Scope
/* 50361*/          OPC_CheckCondCode, ISD::SETNE,
/* 50363*/          OPC_MoveParent,
/* 50364*/          OPC_CheckType, MVT::i32,
/* 50366*/          OPC_MoveParent,
/* 50367*/          OPC_RecordChild1, // #1 = $lhs
/* 50368*/          OPC_RecordChild2, // #2 = $rhs
/* 50369*/          OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->50381
/* 50372*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                          MVT::f32, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
                      // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50381*/          /*SwitchType*/ 9, MVT::f64,// ->50392
/* 50383*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                          MVT::f64, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
                      // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50392*/          0, // EndSwitchType
/* 50393*/        /*Scope*/ 32, /*->50426*/
/* 50394*/          OPC_CheckCondCode, ISD::SETEQ,
/* 50396*/          OPC_MoveParent,
/* 50397*/          OPC_CheckType, MVT::i32,
/* 50399*/          OPC_MoveParent,
/* 50400*/          OPC_RecordChild1, // #1 = $lhs
/* 50401*/          OPC_RecordChild2, // #2 = $rhs
/* 50402*/          OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->50414
/* 50405*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                          MVT::f32, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
                      // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 50414*/          /*SwitchType*/ 9, MVT::f64,// ->50425
/* 50416*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                          MVT::f64, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
                      // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 50425*/          0, // EndSwitchType
/* 50426*/        0, /*End of Scope*/
/* 50427*/      /*SwitchOpcode*/ 32, TARGET_VAL(ISD::AND),// ->50462
/* 50430*/        OPC_RecordChild0, // #0 = $cond
/* 50431*/        OPC_CheckChild1Integer, 1, 
/* 50433*/        OPC_CheckType, MVT::i32,
/* 50435*/        OPC_MoveParent,
/* 50436*/        OPC_RecordChild1, // #1 = $lhs
/* 50437*/        OPC_RecordChild2, // #2 = $rhs
/* 50438*/        OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->50450
/* 50441*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                        MVT::f32, 3/*#Ops*/, 1, 2, 0, 
                    // Src: (select:{ *:[f32] } (and:{ *:[i32] } I32:{ *:[i32] }:$cond, 1:{ *:[i32] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
                    // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50450*/        /*SwitchType*/ 9, MVT::f64,// ->50461
/* 50452*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                        MVT::f64, 3/*#Ops*/, 1, 2, 0, 
                    // Src: (select:{ *:[f64] } (and:{ *:[i32] } I32:{ *:[i32] }:$cond, 1:{ *:[i32] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
                    // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50461*/        0, // EndSwitchType
/* 50462*/      0, // EndSwitchOpcode
/* 50463*/    /*Scope*/ 29, /*->50493*/
/* 50464*/      OPC_RecordChild0, // #0 = $cond
/* 50465*/      OPC_CheckChild0Type, MVT::i32,
/* 50467*/      OPC_RecordChild1, // #1 = $lhs
/* 50468*/      OPC_RecordChild2, // #2 = $rhs
/* 50469*/      OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->50481
/* 50472*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                      MVT::f32, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                  // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50481*/      /*SwitchType*/ 9, MVT::f64,// ->50492
/* 50483*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                      MVT::f64, 3/*#Ops*/, 1, 2, 0, 
                  // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                  // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 50492*/      0, // EndSwitchType
/* 50493*/    0, /*End of Scope*/
/* 50494*/  /*SwitchOpcode*/ 74|128,1/*202*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->50700
/* 50498*/    OPC_Scope, 125, /*->50625*/ // 2 children in Scope
/* 50500*/      OPC_MoveChild0,
/* 50501*/      OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 50504*/      OPC_RecordChild0, // #0 = $vec
/* 50505*/      OPC_Scope, 58, /*->50565*/ // 2 children in Scope
/* 50507*/        OPC_CheckChild0Type, MVT::v16i8,
/* 50509*/        OPC_Scope, 29, /*->50540*/ // 2 children in Scope
/* 50511*/          OPC_RecordChild1, // #1 = $idx
/* 50512*/          OPC_MoveChild1,
/* 50513*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 50516*/          OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 50518*/          OPC_CheckType, MVT::i32,
/* 50520*/          OPC_MoveParent,
/* 50521*/          OPC_MoveParent,
/* 50522*/          OPC_MoveChild1,
/* 50523*/          OPC_CheckValueType, MVT::i8,
/* 50525*/          OPC_MoveParent,
/* 50526*/          OPC_CheckType, MVT::i32,
/* 50528*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 50530*/          OPC_EmitConvertToTarget, 1,
/* 50532*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v16i8_s), 0,
                        MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
                    // Dst: (EXTRACT_LANE_v16i8_s:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 50540*/        /*Scope*/ 23, /*->50564*/
/* 50541*/          OPC_MoveChild1,
/* 50542*/          OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 50545*/          OPC_MoveParent,
/* 50546*/          OPC_MoveParent,
/* 50547*/          OPC_MoveChild1,
/* 50548*/          OPC_CheckValueType, MVT::i8,
/* 50550*/          OPC_MoveParent,
/* 50551*/          OPC_CheckType, MVT::i32,
/* 50553*/          OPC_EmitInteger, MVT::i32, 0, 
/* 50556*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v16i8_s), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (undef:{ *:[iPTR] })), i8:{ *:[Other] }) - Complexity = 9
                    // Dst: (EXTRACT_LANE_v16i8_s:{ *:[i32] } V128:{ *:[v16i8] }:$vec, 0:{ *:[i32] })
/* 50564*/        0, /*End of Scope*/
/* 50565*/      /*Scope*/ 58, /*->50624*/
/* 50566*/        OPC_CheckChild0Type, MVT::v8i16,
/* 50568*/        OPC_Scope, 29, /*->50599*/ // 2 children in Scope
/* 50570*/          OPC_RecordChild1, // #1 = $idx
/* 50571*/          OPC_MoveChild1,
/* 50572*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 50575*/          OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 50577*/          OPC_CheckType, MVT::i32,
/* 50579*/          OPC_MoveParent,
/* 50580*/          OPC_MoveParent,
/* 50581*/          OPC_MoveChild1,
/* 50582*/          OPC_CheckValueType, MVT::i16,
/* 50584*/          OPC_MoveParent,
/* 50585*/          OPC_CheckType, MVT::i32,
/* 50587*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 50589*/          OPC_EmitConvertToTarget, 1,
/* 50591*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v8i16_s), 0,
                        MVT::i32, 2/*#Ops*/, 0, 2, 
                    // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
                    // Dst: (EXTRACT_LANE_v8i16_s:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 50599*/        /*Scope*/ 23, /*->50623*/
/* 50600*/          OPC_MoveChild1,
/* 50601*/          OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 50604*/          OPC_MoveParent,
/* 50605*/          OPC_MoveParent,
/* 50606*/          OPC_MoveChild1,
/* 50607*/          OPC_CheckValueType, MVT::i16,
/* 50609*/          OPC_MoveParent,
/* 50610*/          OPC_CheckType, MVT::i32,
/* 50612*/          OPC_EmitInteger, MVT::i32, 0, 
/* 50615*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v8i16_s), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (undef:{ *:[iPTR] })), i16:{ *:[Other] }) - Complexity = 9
                    // Dst: (EXTRACT_LANE_v8i16_s:{ *:[i32] } V128:{ *:[v8i16] }:$vec, 0:{ *:[i32] })
/* 50623*/        0, /*End of Scope*/
/* 50624*/      0, /*End of Scope*/
/* 50625*/    /*Scope*/ 73, /*->50699*/
/* 50626*/      OPC_RecordChild0, // #0 = $src
/* 50627*/      OPC_MoveChild1,
/* 50628*/      OPC_Scope, 27, /*->50657*/ // 3 children in Scope
/* 50630*/        OPC_CheckValueType, MVT::i8,
/* 50632*/        OPC_MoveParent,
/* 50633*/        OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->50645
/* 50636*/          OPC_CheckPatternPredicate, 5, // (Subtarget->hasSignExt())
/* 50638*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
                    // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 50645*/        /*SwitchType*/ 9, MVT::i64,// ->50656
/* 50647*/          OPC_CheckPatternPredicate, 5, // (Subtarget->hasSignExt())
/* 50649*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
                    // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 50656*/        0, // EndSwitchType
/* 50657*/      /*Scope*/ 27, /*->50685*/
/* 50658*/        OPC_CheckValueType, MVT::i16,
/* 50660*/        OPC_MoveParent,
/* 50661*/        OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->50673
/* 50664*/          OPC_CheckPatternPredicate, 5, // (Subtarget->hasSignExt())
/* 50666*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
                    // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 50673*/        /*SwitchType*/ 9, MVT::i64,// ->50684
/* 50675*/          OPC_CheckPatternPredicate, 5, // (Subtarget->hasSignExt())
/* 50677*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
                    // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 50684*/        0, // EndSwitchType
/* 50685*/      /*Scope*/ 12, /*->50698*/
/* 50686*/        OPC_CheckValueType, MVT::i32,
/* 50688*/        OPC_MoveParent,
/* 50689*/        OPC_CheckPatternPredicate, 5, // (Subtarget->hasSignExt())
/* 50691*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64), 0,
                      MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
                  // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 50698*/      0, /*End of Scope*/
/* 50699*/    0, /*End of Scope*/
/* 50700*/  /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_START),// ->50725
/* 50703*/    OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 50704*/    OPC_RecordChild1, // #1 = $amt
/* 50705*/    OPC_MoveChild1,
/* 50706*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 50709*/    OPC_MoveParent,
/* 50710*/    OPC_RecordChild2, // #2 = $amt2
/* 50711*/    OPC_MoveChild2,
/* 50712*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 50715*/    OPC_MoveParent,
/* 50716*/    OPC_EmitMergeInputChains1_0,
/* 50717*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                  MVT::i32, 2/*#Ops*/, 1, 2, 
              // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
              // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 50725*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CALLSEQ_END),// ->50751
/* 50728*/    OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 50729*/    OPC_CaptureGlueInput,
/* 50730*/    OPC_RecordChild1, // #1 = $amt
/* 50731*/    OPC_MoveChild1,
/* 50732*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 50735*/    OPC_MoveParent,
/* 50736*/    OPC_RecordChild2, // #2 = $amt2
/* 50737*/    OPC_MoveChild2,
/* 50738*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 50741*/    OPC_MoveParent,
/* 50742*/    OPC_EmitMergeInputChains1_0,
/* 50743*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                  MVT::i32, 2/*#Ops*/, 1, 2, 
              // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
              // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 50751*/  /*SwitchOpcode*/ 41|128,5/*681*/, TARGET_VAL(WebAssemblyISD::CALL1),// ->51436
/* 50755*/    OPC_RecordNode, // #0 = 'WebAssemblycall1' chained node
/* 50756*/    OPC_Scope, 82, /*->50840*/ // 8 children in Scope
/* 50758*/      OPC_MoveChild1,
/* 50759*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 50762*/      OPC_RecordChild0, // #1 = $callee
/* 50763*/      OPC_MoveChild0,
/* 50764*/      OPC_SwitchOpcode /*2 cases */, 34, TARGET_VAL(ISD::TargetGlobalAddress),// ->50802
/* 50768*/        OPC_MoveParent,
/* 50769*/        OPC_MoveParent,
/* 50770*/        OPC_SwitchType /*3 cases */, 8, MVT::i32,// ->50781
/* 50773*/          OPC_EmitMergeInputChains1_0,
/* 50774*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_I32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$callee)
/* 50781*/        /*SwitchType*/ 8, MVT::i64,// ->50791
/* 50783*/          OPC_EmitMergeInputChains1_0,
/* 50784*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_I64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_I64:{ *:[i64] } (tglobaladdr:{ *:[i32] }):$callee)
/* 50791*/        /*SwitchType*/ 8, MVT::ExceptRef,// ->50801
/* 50793*/          OPC_EmitMergeInputChains1_0,
/* 50794*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_EXCEPT_REF), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::ExceptRef, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[ExceptRef] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_EXCEPT_REF:{ *:[ExceptRef] } (tglobaladdr:{ *:[i32] }):$callee)
/* 50801*/        0, // EndSwitchType
/* 50802*/      /*SwitchOpcode*/ 34, TARGET_VAL(ISD::TargetExternalSymbol),// ->50839
/* 50805*/        OPC_MoveParent,
/* 50806*/        OPC_MoveParent,
/* 50807*/        OPC_SwitchType /*3 cases */, 8, MVT::i32,// ->50818
/* 50810*/          OPC_EmitMergeInputChains1_0,
/* 50811*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_I32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$callee)
/* 50818*/        /*SwitchType*/ 8, MVT::i64,// ->50828
/* 50820*/          OPC_EmitMergeInputChains1_0,
/* 50821*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_I64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_I64:{ *:[i64] } (texternalsym:{ *:[i32] }):$callee)
/* 50828*/        /*SwitchType*/ 8, MVT::ExceptRef,// ->50838
/* 50830*/          OPC_EmitMergeInputChains1_0,
/* 50831*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_EXCEPT_REF), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::ExceptRef, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[ExceptRef] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_EXCEPT_REF:{ *:[ExceptRef] } (texternalsym:{ *:[i32] }):$callee)
/* 50838*/        0, // EndSwitchType
/* 50839*/      0, // EndSwitchOpcode
/* 50840*/    /*Scope*/ 84, /*->50925*/
/* 50841*/      OPC_RecordChild1, // #1 = $callee
/* 50842*/      OPC_Scope, 45, /*->50889*/ // 2 children in Scope
/* 50844*/        OPC_MoveChild1,
/* 50845*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 50848*/        OPC_CheckType, MVT::i32,
/* 50850*/        OPC_MoveParent,
/* 50851*/        OPC_SwitchType /*3 cases */, 10, MVT::i32,// ->50864
/* 50854*/          OPC_EmitMergeInputChains1_0,
/* 50855*/          OPC_EmitConvertToTarget, 1,
/* 50857*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_I32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i32, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[i32] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_I32:{ *:[i32] } (imm:{ *:[i32] }):$callee)
/* 50864*/        /*SwitchType*/ 10, MVT::i64,// ->50876
/* 50866*/          OPC_EmitMergeInputChains1_0,
/* 50867*/          OPC_EmitConvertToTarget, 1,
/* 50869*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_I64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i64, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[i64] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_I64:{ *:[i64] } (imm:{ *:[i32] }):$callee)
/* 50876*/        /*SwitchType*/ 10, MVT::ExceptRef,// ->50888
/* 50878*/          OPC_EmitMergeInputChains1_0,
/* 50879*/          OPC_EmitConvertToTarget, 1,
/* 50881*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_EXCEPT_REF), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::ExceptRef, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[ExceptRef] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_EXCEPT_REF:{ *:[ExceptRef] } (imm:{ *:[i32] }):$callee)
/* 50888*/        0, // EndSwitchType
/* 50889*/      /*Scope*/ 34, /*->50924*/
/* 50890*/        OPC_CheckChild1Type, MVT::i32,
/* 50892*/        OPC_SwitchType /*3 cases */, 8, MVT::i32,// ->50903
/* 50895*/          OPC_EmitMergeInputChains1_0,
/* 50896*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_I32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[i32] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_I32:{ *:[i32] } I32:{ *:[i32] }:$callee)
/* 50903*/        /*SwitchType*/ 8, MVT::i64,// ->50913
/* 50905*/          OPC_EmitMergeInputChains1_0,
/* 50906*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_I64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::i64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[i64] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_I64:{ *:[i64] } I32:{ *:[i32] }:$callee)
/* 50913*/        /*SwitchType*/ 8, MVT::ExceptRef,// ->50923
/* 50915*/          OPC_EmitMergeInputChains1_0,
/* 50916*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_EXCEPT_REF), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::ExceptRef, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[ExceptRef] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_EXCEPT_REF:{ *:[ExceptRef] } I32:{ *:[i32] }:$callee)
/* 50923*/        0, // EndSwitchType
/* 50924*/      0, /*End of Scope*/
/* 50925*/    /*Scope*/ 62, /*->50988*/
/* 50926*/      OPC_MoveChild1,
/* 50927*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 50930*/      OPC_RecordChild0, // #1 = $callee
/* 50931*/      OPC_MoveChild0,
/* 50932*/      OPC_SwitchOpcode /*2 cases */, 24, TARGET_VAL(ISD::TargetGlobalAddress),// ->50960
/* 50936*/        OPC_MoveParent,
/* 50937*/        OPC_MoveParent,
/* 50938*/        OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->50949
/* 50941*/          OPC_EmitMergeInputChains1_0,
/* 50942*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_F32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$callee)
/* 50949*/        /*SwitchType*/ 8, MVT::f64,// ->50959
/* 50951*/          OPC_EmitMergeInputChains1_0,
/* 50952*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_F64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$callee)
/* 50959*/        0, // EndSwitchType
/* 50960*/      /*SwitchOpcode*/ 24, TARGET_VAL(ISD::TargetExternalSymbol),// ->50987
/* 50963*/        OPC_MoveParent,
/* 50964*/        OPC_MoveParent,
/* 50965*/        OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->50976
/* 50968*/          OPC_EmitMergeInputChains1_0,
/* 50969*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_F32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[f32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_F32:{ *:[f32] } (texternalsym:{ *:[i32] }):$callee)
/* 50976*/        /*SwitchType*/ 8, MVT::f64,// ->50986
/* 50978*/          OPC_EmitMergeInputChains1_0,
/* 50979*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_F64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[f64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_F64:{ *:[f64] } (texternalsym:{ *:[i32] }):$callee)
/* 50986*/        0, // EndSwitchType
/* 50987*/      0, // EndSwitchOpcode
/* 50988*/    /*Scope*/ 62, /*->51051*/
/* 50989*/      OPC_RecordChild1, // #1 = $callee
/* 50990*/      OPC_Scope, 33, /*->51025*/ // 2 children in Scope
/* 50992*/        OPC_MoveChild1,
/* 50993*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 50996*/        OPC_CheckType, MVT::i32,
/* 50998*/        OPC_MoveParent,
/* 50999*/        OPC_SwitchType /*2 cases */, 10, MVT::f32,// ->51012
/* 51002*/          OPC_EmitMergeInputChains1_0,
/* 51003*/          OPC_EmitConvertToTarget, 1,
/* 51005*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_F32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f32, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[f32] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_F32:{ *:[f32] } (imm:{ *:[i32] }):$callee)
/* 51012*/        /*SwitchType*/ 10, MVT::f64,// ->51024
/* 51014*/          OPC_EmitMergeInputChains1_0,
/* 51015*/          OPC_EmitConvertToTarget, 1,
/* 51017*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_F64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f64, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[f64] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_F64:{ *:[f64] } (imm:{ *:[i32] }):$callee)
/* 51024*/        0, // EndSwitchType
/* 51025*/      /*Scope*/ 24, /*->51050*/
/* 51026*/        OPC_CheckChild1Type, MVT::i32,
/* 51028*/        OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->51039
/* 51031*/          OPC_EmitMergeInputChains1_0,
/* 51032*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_F32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[f32] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_F32:{ *:[f32] } I32:{ *:[i32] }:$callee)
/* 51039*/        /*SwitchType*/ 8, MVT::f64,// ->51049
/* 51041*/          OPC_EmitMergeInputChains1_0,
/* 51042*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_F64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::f64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[f64] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_F64:{ *:[f64] } I32:{ *:[i32] }:$callee)
/* 51049*/        0, // EndSwitchType
/* 51050*/      0, /*End of Scope*/
/* 51051*/    /*Scope*/ 118, /*->51170*/
/* 51052*/      OPC_MoveChild1,
/* 51053*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 51056*/      OPC_RecordChild0, // #1 = $callee
/* 51057*/      OPC_MoveChild0,
/* 51058*/      OPC_SwitchOpcode /*2 cases */, 52, TARGET_VAL(ISD::TargetGlobalAddress),// ->51114
/* 51062*/        OPC_MoveParent,
/* 51063*/        OPC_MoveParent,
/* 51064*/        OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->51077
/* 51067*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51069*/          OPC_EmitMergeInputChains1_0,
/* 51070*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v16i8), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v16i8, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v16i8:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$callee)
/* 51077*/        /*SwitchType*/ 10, MVT::v8i16,// ->51089
/* 51079*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51081*/          OPC_EmitMergeInputChains1_0,
/* 51082*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v8i16), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v8i16, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v8i16:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$callee)
/* 51089*/        /*SwitchType*/ 10, MVT::v4i32,// ->51101
/* 51091*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51093*/          OPC_EmitMergeInputChains1_0,
/* 51094*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v4i32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4i32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v4i32:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$callee)
/* 51101*/        /*SwitchType*/ 10, MVT::v2i64,// ->51113
/* 51103*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51105*/          OPC_EmitMergeInputChains1_0,
/* 51106*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v2i64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2i64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v2i64:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$callee)
/* 51113*/        0, // EndSwitchType
/* 51114*/      /*SwitchOpcode*/ 52, TARGET_VAL(ISD::TargetExternalSymbol),// ->51169
/* 51117*/        OPC_MoveParent,
/* 51118*/        OPC_MoveParent,
/* 51119*/        OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->51132
/* 51122*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51124*/          OPC_EmitMergeInputChains1_0,
/* 51125*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v16i8), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v16i8, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v16i8] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v16i8:{ *:[v16i8] } (texternalsym:{ *:[i32] }):$callee)
/* 51132*/        /*SwitchType*/ 10, MVT::v8i16,// ->51144
/* 51134*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51136*/          OPC_EmitMergeInputChains1_0,
/* 51137*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v8i16), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v8i16, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v8i16] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v8i16:{ *:[v8i16] } (texternalsym:{ *:[i32] }):$callee)
/* 51144*/        /*SwitchType*/ 10, MVT::v4i32,// ->51156
/* 51146*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51148*/          OPC_EmitMergeInputChains1_0,
/* 51149*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v4i32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4i32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v4i32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v4i32:{ *:[v4i32] } (texternalsym:{ *:[i32] }):$callee)
/* 51156*/        /*SwitchType*/ 10, MVT::v2i64,// ->51168
/* 51158*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51160*/          OPC_EmitMergeInputChains1_0,
/* 51161*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v2i64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2i64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v2i64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v2i64:{ *:[v2i64] } (texternalsym:{ *:[i32] }):$callee)
/* 51168*/        0, // EndSwitchType
/* 51169*/      0, // EndSwitchOpcode
/* 51170*/    /*Scope*/ 122, /*->51293*/
/* 51171*/      OPC_RecordChild1, // #1 = $callee
/* 51172*/      OPC_Scope, 65, /*->51239*/ // 2 children in Scope
/* 51174*/        OPC_MoveChild1,
/* 51175*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 51178*/        OPC_CheckType, MVT::i32,
/* 51180*/        OPC_MoveParent,
/* 51181*/        OPC_SwitchType /*4 cases */, 12, MVT::v16i8,// ->51196
/* 51184*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51186*/          OPC_EmitMergeInputChains1_0,
/* 51187*/          OPC_EmitConvertToTarget, 1,
/* 51189*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v16i8), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v16i8, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[v16i8] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_v16i8:{ *:[v16i8] } (imm:{ *:[i32] }):$callee)
/* 51196*/        /*SwitchType*/ 12, MVT::v8i16,// ->51210
/* 51198*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51200*/          OPC_EmitMergeInputChains1_0,
/* 51201*/          OPC_EmitConvertToTarget, 1,
/* 51203*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v8i16), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v8i16, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[v8i16] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_v8i16:{ *:[v8i16] } (imm:{ *:[i32] }):$callee)
/* 51210*/        /*SwitchType*/ 12, MVT::v4i32,// ->51224
/* 51212*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51214*/          OPC_EmitMergeInputChains1_0,
/* 51215*/          OPC_EmitConvertToTarget, 1,
/* 51217*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v4i32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4i32, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[v4i32] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_v4i32:{ *:[v4i32] } (imm:{ *:[i32] }):$callee)
/* 51224*/        /*SwitchType*/ 12, MVT::v2i64,// ->51238
/* 51226*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51228*/          OPC_EmitMergeInputChains1_0,
/* 51229*/          OPC_EmitConvertToTarget, 1,
/* 51231*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v2i64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2i64, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[v2i64] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_v2i64:{ *:[v2i64] } (imm:{ *:[i32] }):$callee)
/* 51238*/        0, // EndSwitchType
/* 51239*/      /*Scope*/ 52, /*->51292*/
/* 51240*/        OPC_CheckChild1Type, MVT::i32,
/* 51242*/        OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->51255
/* 51245*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51247*/          OPC_EmitMergeInputChains1_0,
/* 51248*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_v16i8), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v16i8, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v16i8] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_v16i8:{ *:[v16i8] } I32:{ *:[i32] }:$callee)
/* 51255*/        /*SwitchType*/ 10, MVT::v8i16,// ->51267
/* 51257*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51259*/          OPC_EmitMergeInputChains1_0,
/* 51260*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_v8i16), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v8i16, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v8i16] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_v8i16:{ *:[v8i16] } I32:{ *:[i32] }:$callee)
/* 51267*/        /*SwitchType*/ 10, MVT::v4i32,// ->51279
/* 51269*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51271*/          OPC_EmitMergeInputChains1_0,
/* 51272*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_v4i32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4i32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v4i32] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_v4i32:{ *:[v4i32] } I32:{ *:[i32] }:$callee)
/* 51279*/        /*SwitchType*/ 10, MVT::v2i64,// ->51291
/* 51281*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51283*/          OPC_EmitMergeInputChains1_0,
/* 51284*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_v2i64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2i64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v2i64] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_v2i64:{ *:[v2i64] } I32:{ *:[i32] }:$callee)
/* 51291*/        0, // EndSwitchType
/* 51292*/      0, /*End of Scope*/
/* 51293*/    /*Scope*/ 70, /*->51364*/
/* 51294*/      OPC_MoveChild1,
/* 51295*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 51298*/      OPC_RecordChild0, // #1 = $callee
/* 51299*/      OPC_MoveChild0,
/* 51300*/      OPC_SwitchOpcode /*2 cases */, 28, TARGET_VAL(ISD::TargetGlobalAddress),// ->51332
/* 51304*/        OPC_MoveParent,
/* 51305*/        OPC_MoveParent,
/* 51306*/        OPC_SwitchType /*2 cases */, 10, MVT::v4f32,// ->51319
/* 51309*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51311*/          OPC_EmitMergeInputChains1_0,
/* 51312*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v4f32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4f32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v4f32:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$callee)
/* 51319*/        /*SwitchType*/ 10, MVT::v2f64,// ->51331
/* 51321*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51323*/          OPC_EmitMergeInputChains1_0,
/* 51324*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v2f64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2f64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v2f64:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$callee)
/* 51331*/        0, // EndSwitchType
/* 51332*/      /*SwitchOpcode*/ 28, TARGET_VAL(ISD::TargetExternalSymbol),// ->51363
/* 51335*/        OPC_MoveParent,
/* 51336*/        OPC_MoveParent,
/* 51337*/        OPC_SwitchType /*2 cases */, 10, MVT::v4f32,// ->51350
/* 51340*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51342*/          OPC_EmitMergeInputChains1_0,
/* 51343*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v4f32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4f32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v4f32] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v4f32:{ *:[v4f32] } (texternalsym:{ *:[i32] }):$callee)
/* 51350*/        /*SwitchType*/ 10, MVT::v2f64,// ->51362
/* 51352*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51354*/          OPC_EmitMergeInputChains1_0,
/* 51355*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v2f64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2f64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v2f64] } (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                    // Dst: (CALL_v2f64:{ *:[v2f64] } (texternalsym:{ *:[i32] }):$callee)
/* 51362*/        0, // EndSwitchType
/* 51363*/      0, // EndSwitchOpcode
/* 51364*/    /*Scope*/ 70, /*->51435*/
/* 51365*/      OPC_RecordChild1, // #1 = $callee
/* 51366*/      OPC_Scope, 37, /*->51405*/ // 2 children in Scope
/* 51368*/        OPC_MoveChild1,
/* 51369*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 51372*/        OPC_CheckType, MVT::i32,
/* 51374*/        OPC_MoveParent,
/* 51375*/        OPC_SwitchType /*2 cases */, 12, MVT::v4f32,// ->51390
/* 51378*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51380*/          OPC_EmitMergeInputChains1_0,
/* 51381*/          OPC_EmitConvertToTarget, 1,
/* 51383*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v4f32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4f32, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[v4f32] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_v4f32:{ *:[v4f32] } (imm:{ *:[i32] }):$callee)
/* 51390*/        /*SwitchType*/ 12, MVT::v2f64,// ->51404
/* 51392*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51394*/          OPC_EmitMergeInputChains1_0,
/* 51395*/          OPC_EmitConvertToTarget, 1,
/* 51397*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CALL_v2f64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2f64, 1/*#Ops*/, 2, 
                    // Src: (WebAssemblycall1:{ *:[v2f64] } (imm:{ *:[i32] }):$callee) - Complexity = 6
                    // Dst: (CALL_v2f64:{ *:[v2f64] } (imm:{ *:[i32] }):$callee)
/* 51404*/        0, // EndSwitchType
/* 51405*/      /*Scope*/ 28, /*->51434*/
/* 51406*/        OPC_CheckChild1Type, MVT::i32,
/* 51408*/        OPC_SwitchType /*2 cases */, 10, MVT::v4f32,// ->51421
/* 51411*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51413*/          OPC_EmitMergeInputChains1_0,
/* 51414*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_v4f32), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v4f32, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v4f32] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_v4f32:{ *:[v4f32] } I32:{ *:[i32] }:$callee)
/* 51421*/        /*SwitchType*/ 10, MVT::v2f64,// ->51433
/* 51423*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 51425*/          OPC_EmitMergeInputChains1_0,
/* 51426*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PCALL_INDIRECT_v2f64), 0|OPFL_Chain|OPFL_Variadic1,
                        MVT::v2f64, 1/*#Ops*/, 1, 
                    // Src: (WebAssemblycall1:{ *:[v2f64] } I32:{ *:[i32] }:$callee) - Complexity = 3
                    // Dst: (PCALL_INDIRECT_v2f64:{ *:[v2f64] } I32:{ *:[i32] }:$callee)
/* 51433*/        0, // EndSwitchType
/* 51434*/      0, /*End of Scope*/
/* 51435*/    0, /*End of Scope*/
/* 51436*/  /*SwitchOpcode*/ 67, TARGET_VAL(WebAssemblyISD::CALL0),// ->51506
/* 51439*/    OPC_RecordNode, // #0 = 'WebAssemblycall0' chained node
/* 51440*/    OPC_Scope, 32, /*->51474*/ // 2 children in Scope
/* 51442*/      OPC_MoveChild1,
/* 51443*/      OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 51446*/      OPC_RecordChild0, // #1 = $callee
/* 51447*/      OPC_MoveChild0,
/* 51448*/      OPC_SwitchOpcode /*2 cases */, 9, TARGET_VAL(ISD::TargetGlobalAddress),// ->51461
/* 51452*/        OPC_MoveParent,
/* 51453*/        OPC_MoveParent,
/* 51454*/        OPC_EmitMergeInputChains1_0,
/* 51455*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CALL_VOID), 0|OPFL_Chain|OPFL_Variadic1,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblycall0 (WebAssemblywrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$callee)) - Complexity = 9
                  // Dst: (CALL_VOID (tglobaladdr:{ *:[i32] }):$callee)
/* 51461*/      /*SwitchOpcode*/ 9, TARGET_VAL(ISD::TargetExternalSymbol),// ->51473
/* 51464*/        OPC_MoveParent,
/* 51465*/        OPC_MoveParent,
/* 51466*/        OPC_EmitMergeInputChains1_0,
/* 51467*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CALL_VOID), 0|OPFL_Chain|OPFL_Variadic1,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblycall0 (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$callee)) - Complexity = 9
                  // Dst: (CALL_VOID (texternalsym:{ *:[i32] }):$callee)
/* 51473*/      0, // EndSwitchOpcode
/* 51474*/    /*Scope*/ 30, /*->51505*/
/* 51475*/      OPC_RecordChild1, // #1 = $callee
/* 51476*/      OPC_Scope, 16, /*->51494*/ // 2 children in Scope
/* 51478*/        OPC_MoveChild1,
/* 51479*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 51482*/        OPC_CheckType, MVT::i32,
/* 51484*/        OPC_MoveParent,
/* 51485*/        OPC_EmitMergeInputChains1_0,
/* 51486*/        OPC_EmitConvertToTarget, 1,
/* 51488*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CALL_VOID), 0|OPFL_Chain|OPFL_Variadic1,
                      1/*#Ops*/, 2, 
                  // Src: (WebAssemblycall0 (imm:{ *:[i32] }):$callee) - Complexity = 6
                  // Dst: (CALL_VOID (imm:{ *:[i32] }):$callee)
/* 51494*/      /*Scope*/ 9, /*->51504*/
/* 51495*/        OPC_CheckChild1Type, MVT::i32,
/* 51497*/        OPC_EmitMergeInputChains1_0,
/* 51498*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::PCALL_INDIRECT_VOID), 0|OPFL_Chain|OPFL_Variadic1,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblycall0 I32:{ *:[i32] }:$callee) - Complexity = 3
                  // Dst: (PCALL_INDIRECT_VOID I32:{ *:[i32] }:$callee)
/* 51504*/      0, /*End of Scope*/
/* 51505*/    0, /*End of Scope*/
/* 51506*/  /*SwitchOpcode*/ 41, TARGET_VAL(WebAssemblyISD::THROW),// ->51550
/* 51509*/    OPC_RecordNode, // #0 = 'WebAssemblythrow' chained node
/* 51510*/    OPC_MoveChild1,
/* 51511*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 51514*/    OPC_RecordChild0, // #1 = $tag
/* 51515*/    OPC_MoveChild0,
/* 51516*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetExternalSymbol),
/* 51519*/    OPC_MoveParent,
/* 51520*/    OPC_MoveParent,
/* 51521*/    OPC_RecordChild2, // #2 = $val
/* 51522*/    OPC_Scope, 12, /*->51536*/ // 2 children in Scope
/* 51524*/      OPC_CheckChild2Type, MVT::i32,
/* 51526*/      OPC_CheckPatternPredicate, 4, // (Subtarget->hasExceptionHandling())
/* 51528*/      OPC_EmitMergeInputChains1_0,
/* 51529*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::THROW_I32), 0|OPFL_Chain,
                    2/*#Ops*/, 1, 2, 
                // Src: (WebAssemblythrow (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$tag), I32:{ *:[i32] }:$val) - Complexity = 9
                // Dst: (THROW_I32 (texternalsym:{ *:[i32] }):$tag, I32:{ *:[i32] }:$val)
/* 51536*/    /*Scope*/ 12, /*->51549*/
/* 51537*/      OPC_CheckChild2Type, MVT::i64,
/* 51539*/      OPC_CheckPatternPredicate, 4, // (Subtarget->hasExceptionHandling())
/* 51541*/      OPC_EmitMergeInputChains1_0,
/* 51542*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::THROW_I64), 0|OPFL_Chain,
                    2/*#Ops*/, 1, 2, 
                // Src: (WebAssemblythrow (WebAssemblywrapper:{ *:[iPTR] } (texternalsym:{ *:[iPTR] }):$tag), I64:{ *:[i64] }:$val) - Complexity = 9
                // Dst: (THROW_I64 (texternalsym:{ *:[i32] }):$tag, I64:{ *:[i64] }:$val)
/* 51549*/    0, /*End of Scope*/
/* 51550*/  /*SwitchOpcode*/ 51|128,11/*1459*/, TARGET_VAL(ISD::SETCC),// ->53013
/* 51554*/    OPC_RecordChild0, // #0 = $src
/* 51555*/    OPC_Scope, 38|128,1/*166*/, /*->51724*/ // 9 children in Scope
/* 51558*/      OPC_CheckChild0Type, MVT::i32,
/* 51560*/      OPC_Scope, 15, /*->51577*/ // 2 children in Scope
/* 51562*/        OPC_CheckChild1Integer, 0, 
/* 51564*/        OPC_MoveChild2,
/* 51565*/        OPC_CheckCondCode, ISD::SETEQ,
/* 51567*/        OPC_MoveParent,
/* 51568*/        OPC_CheckType, MVT::i32,
/* 51570*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I32), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                  // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 51577*/      /*Scope*/ 16|128,1/*144*/, /*->51723*/
/* 51579*/        OPC_RecordChild1, // #1 = $rhs
/* 51580*/        OPC_MoveChild2,
/* 51581*/        OPC_Scope, 13, /*->51596*/ // 10 children in Scope
/* 51583*/          OPC_CheckCondCode, ISD::SETEQ,
/* 51585*/          OPC_MoveParent,
/* 51586*/          OPC_CheckType, MVT::i32,
/* 51588*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                    // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51596*/        /*Scope*/ 13, /*->51610*/
/* 51597*/          OPC_CheckCondCode, ISD::SETNE,
/* 51599*/          OPC_MoveParent,
/* 51600*/          OPC_CheckType, MVT::i32,
/* 51602*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                    // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51610*/        /*Scope*/ 13, /*->51624*/
/* 51611*/          OPC_CheckCondCode, ISD::SETLT,
/* 51613*/          OPC_MoveParent,
/* 51614*/          OPC_CheckType, MVT::i32,
/* 51616*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                    // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51624*/        /*Scope*/ 13, /*->51638*/
/* 51625*/          OPC_CheckCondCode, ISD::SETULT,
/* 51627*/          OPC_MoveParent,
/* 51628*/          OPC_CheckType, MVT::i32,
/* 51630*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                    // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51638*/        /*Scope*/ 13, /*->51652*/
/* 51639*/          OPC_CheckCondCode, ISD::SETGT,
/* 51641*/          OPC_MoveParent,
/* 51642*/          OPC_CheckType, MVT::i32,
/* 51644*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                    // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51652*/        /*Scope*/ 13, /*->51666*/
/* 51653*/          OPC_CheckCondCode, ISD::SETUGT,
/* 51655*/          OPC_MoveParent,
/* 51656*/          OPC_CheckType, MVT::i32,
/* 51658*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                    // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51666*/        /*Scope*/ 13, /*->51680*/
/* 51667*/          OPC_CheckCondCode, ISD::SETLE,
/* 51669*/          OPC_MoveParent,
/* 51670*/          OPC_CheckType, MVT::i32,
/* 51672*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                    // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51680*/        /*Scope*/ 13, /*->51694*/
/* 51681*/          OPC_CheckCondCode, ISD::SETULE,
/* 51683*/          OPC_MoveParent,
/* 51684*/          OPC_CheckType, MVT::i32,
/* 51686*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                    // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51694*/        /*Scope*/ 13, /*->51708*/
/* 51695*/          OPC_CheckCondCode, ISD::SETGE,
/* 51697*/          OPC_MoveParent,
/* 51698*/          OPC_CheckType, MVT::i32,
/* 51700*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                    // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51708*/        /*Scope*/ 13, /*->51722*/
/* 51709*/          OPC_CheckCondCode, ISD::SETUGE,
/* 51711*/          OPC_MoveParent,
/* 51712*/          OPC_CheckType, MVT::i32,
/* 51714*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                    // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 51722*/        0, /*End of Scope*/
/* 51723*/      0, /*End of Scope*/
/* 51724*/    /*Scope*/ 38|128,1/*166*/, /*->51892*/
/* 51726*/      OPC_CheckChild0Type, MVT::i64,
/* 51728*/      OPC_Scope, 15, /*->51745*/ // 2 children in Scope
/* 51730*/        OPC_CheckChild1Integer, 0, 
/* 51732*/        OPC_MoveChild2,
/* 51733*/        OPC_CheckCondCode, ISD::SETEQ,
/* 51735*/        OPC_MoveParent,
/* 51736*/        OPC_CheckType, MVT::i32,
/* 51738*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I64), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                  // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 51745*/      /*Scope*/ 16|128,1/*144*/, /*->51891*/
/* 51747*/        OPC_RecordChild1, // #1 = $rhs
/* 51748*/        OPC_MoveChild2,
/* 51749*/        OPC_Scope, 13, /*->51764*/ // 10 children in Scope
/* 51751*/          OPC_CheckCondCode, ISD::SETEQ,
/* 51753*/          OPC_MoveParent,
/* 51754*/          OPC_CheckType, MVT::i32,
/* 51756*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                    // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51764*/        /*Scope*/ 13, /*->51778*/
/* 51765*/          OPC_CheckCondCode, ISD::SETNE,
/* 51767*/          OPC_MoveParent,
/* 51768*/          OPC_CheckType, MVT::i32,
/* 51770*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                    // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51778*/        /*Scope*/ 13, /*->51792*/
/* 51779*/          OPC_CheckCondCode, ISD::SETLT,
/* 51781*/          OPC_MoveParent,
/* 51782*/          OPC_CheckType, MVT::i32,
/* 51784*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                    // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51792*/        /*Scope*/ 13, /*->51806*/
/* 51793*/          OPC_CheckCondCode, ISD::SETULT,
/* 51795*/          OPC_MoveParent,
/* 51796*/          OPC_CheckType, MVT::i32,
/* 51798*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                    // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51806*/        /*Scope*/ 13, /*->51820*/
/* 51807*/          OPC_CheckCondCode, ISD::SETGT,
/* 51809*/          OPC_MoveParent,
/* 51810*/          OPC_CheckType, MVT::i32,
/* 51812*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                    // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51820*/        /*Scope*/ 13, /*->51834*/
/* 51821*/          OPC_CheckCondCode, ISD::SETUGT,
/* 51823*/          OPC_MoveParent,
/* 51824*/          OPC_CheckType, MVT::i32,
/* 51826*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                    // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51834*/        /*Scope*/ 13, /*->51848*/
/* 51835*/          OPC_CheckCondCode, ISD::SETLE,
/* 51837*/          OPC_MoveParent,
/* 51838*/          OPC_CheckType, MVT::i32,
/* 51840*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                    // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51848*/        /*Scope*/ 13, /*->51862*/
/* 51849*/          OPC_CheckCondCode, ISD::SETULE,
/* 51851*/          OPC_MoveParent,
/* 51852*/          OPC_CheckType, MVT::i32,
/* 51854*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                    // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51862*/        /*Scope*/ 13, /*->51876*/
/* 51863*/          OPC_CheckCondCode, ISD::SETGE,
/* 51865*/          OPC_MoveParent,
/* 51866*/          OPC_CheckType, MVT::i32,
/* 51868*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                    // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51876*/        /*Scope*/ 13, /*->51890*/
/* 51877*/          OPC_CheckCondCode, ISD::SETUGE,
/* 51879*/          OPC_MoveParent,
/* 51880*/          OPC_CheckType, MVT::i32,
/* 51882*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I64), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                    // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 51890*/        0, /*End of Scope*/
/* 51891*/      0, /*End of Scope*/
/* 51892*/    /*Scope*/ 46|128,1/*174*/, /*->52068*/
/* 51894*/      OPC_CheckChild0Type, MVT::f32,
/* 51896*/      OPC_RecordChild1, // #1 = $rhs
/* 51897*/      OPC_MoveChild2,
/* 51898*/      OPC_Scope, 13, /*->51913*/ // 12 children in Scope
/* 51900*/        OPC_CheckCondCode, ISD::SETOEQ,
/* 51902*/        OPC_MoveParent,
/* 51903*/        OPC_CheckType, MVT::i32,
/* 51905*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 51913*/      /*Scope*/ 13, /*->51927*/
/* 51914*/        OPC_CheckCondCode, ISD::SETUNE,
/* 51916*/        OPC_MoveParent,
/* 51917*/        OPC_CheckType, MVT::i32,
/* 51919*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 51927*/      /*Scope*/ 13, /*->51941*/
/* 51928*/        OPC_CheckCondCode, ISD::SETOLT,
/* 51930*/        OPC_MoveParent,
/* 51931*/        OPC_CheckType, MVT::i32,
/* 51933*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 51941*/      /*Scope*/ 13, /*->51955*/
/* 51942*/        OPC_CheckCondCode, ISD::SETOLE,
/* 51944*/        OPC_MoveParent,
/* 51945*/        OPC_CheckType, MVT::i32,
/* 51947*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 51955*/      /*Scope*/ 13, /*->51969*/
/* 51956*/        OPC_CheckCondCode, ISD::SETOGT,
/* 51958*/        OPC_MoveParent,
/* 51959*/        OPC_CheckType, MVT::i32,
/* 51961*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 51969*/      /*Scope*/ 13, /*->51983*/
/* 51970*/        OPC_CheckCondCode, ISD::SETOGE,
/* 51972*/        OPC_MoveParent,
/* 51973*/        OPC_CheckType, MVT::i32,
/* 51975*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 51983*/      /*Scope*/ 13, /*->51997*/
/* 51984*/        OPC_CheckCondCode, ISD::SETEQ,
/* 51986*/        OPC_MoveParent,
/* 51987*/        OPC_CheckType, MVT::i32,
/* 51989*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 51997*/      /*Scope*/ 13, /*->52011*/
/* 51998*/        OPC_CheckCondCode, ISD::SETNE,
/* 52000*/        OPC_MoveParent,
/* 52001*/        OPC_CheckType, MVT::i32,
/* 52003*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 52011*/      /*Scope*/ 13, /*->52025*/
/* 52012*/        OPC_CheckCondCode, ISD::SETLT,
/* 52014*/        OPC_MoveParent,
/* 52015*/        OPC_CheckType, MVT::i32,
/* 52017*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 52025*/      /*Scope*/ 13, /*->52039*/
/* 52026*/        OPC_CheckCondCode, ISD::SETLE,
/* 52028*/        OPC_MoveParent,
/* 52029*/        OPC_CheckType, MVT::i32,
/* 52031*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 52039*/      /*Scope*/ 13, /*->52053*/
/* 52040*/        OPC_CheckCondCode, ISD::SETGT,
/* 52042*/        OPC_MoveParent,
/* 52043*/        OPC_CheckType, MVT::i32,
/* 52045*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 52053*/      /*Scope*/ 13, /*->52067*/
/* 52054*/        OPC_CheckCondCode, ISD::SETGE,
/* 52056*/        OPC_MoveParent,
/* 52057*/        OPC_CheckType, MVT::i32,
/* 52059*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/* 52067*/      0, /*End of Scope*/
/* 52068*/    /*Scope*/ 46|128,1/*174*/, /*->52244*/
/* 52070*/      OPC_CheckChild0Type, MVT::f64,
/* 52072*/      OPC_RecordChild1, // #1 = $rhs
/* 52073*/      OPC_MoveChild2,
/* 52074*/      OPC_Scope, 13, /*->52089*/ // 12 children in Scope
/* 52076*/        OPC_CheckCondCode, ISD::SETOEQ,
/* 52078*/        OPC_MoveParent,
/* 52079*/        OPC_CheckType, MVT::i32,
/* 52081*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52089*/      /*Scope*/ 13, /*->52103*/
/* 52090*/        OPC_CheckCondCode, ISD::SETUNE,
/* 52092*/        OPC_MoveParent,
/* 52093*/        OPC_CheckType, MVT::i32,
/* 52095*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52103*/      /*Scope*/ 13, /*->52117*/
/* 52104*/        OPC_CheckCondCode, ISD::SETOLT,
/* 52106*/        OPC_MoveParent,
/* 52107*/        OPC_CheckType, MVT::i32,
/* 52109*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52117*/      /*Scope*/ 13, /*->52131*/
/* 52118*/        OPC_CheckCondCode, ISD::SETOLE,
/* 52120*/        OPC_MoveParent,
/* 52121*/        OPC_CheckType, MVT::i32,
/* 52123*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52131*/      /*Scope*/ 13, /*->52145*/
/* 52132*/        OPC_CheckCondCode, ISD::SETOGT,
/* 52134*/        OPC_MoveParent,
/* 52135*/        OPC_CheckType, MVT::i32,
/* 52137*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52145*/      /*Scope*/ 13, /*->52159*/
/* 52146*/        OPC_CheckCondCode, ISD::SETOGE,
/* 52148*/        OPC_MoveParent,
/* 52149*/        OPC_CheckType, MVT::i32,
/* 52151*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 52159*/      /*Scope*/ 13, /*->52173*/
/* 52160*/        OPC_CheckCondCode, ISD::SETEQ,
/* 52162*/        OPC_MoveParent,
/* 52163*/        OPC_CheckType, MVT::i32,
/* 52165*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 52173*/      /*Scope*/ 13, /*->52187*/
/* 52174*/        OPC_CheckCondCode, ISD::SETNE,
/* 52176*/        OPC_MoveParent,
/* 52177*/        OPC_CheckType, MVT::i32,
/* 52179*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 52187*/      /*Scope*/ 13, /*->52201*/
/* 52188*/        OPC_CheckCondCode, ISD::SETLT,
/* 52190*/        OPC_MoveParent,
/* 52191*/        OPC_CheckType, MVT::i32,
/* 52193*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 52201*/      /*Scope*/ 13, /*->52215*/
/* 52202*/        OPC_CheckCondCode, ISD::SETLE,
/* 52204*/        OPC_MoveParent,
/* 52205*/        OPC_CheckType, MVT::i32,
/* 52207*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 52215*/      /*Scope*/ 13, /*->52229*/
/* 52216*/        OPC_CheckCondCode, ISD::SETGT,
/* 52218*/        OPC_MoveParent,
/* 52219*/        OPC_CheckType, MVT::i32,
/* 52221*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 52229*/      /*Scope*/ 13, /*->52243*/
/* 52230*/        OPC_CheckCondCode, ISD::SETGE,
/* 52232*/        OPC_MoveParent,
/* 52233*/        OPC_CheckType, MVT::i32,
/* 52235*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/* 52243*/      0, /*End of Scope*/
/* 52244*/    /*Scope*/ 38|128,1/*166*/, /*->52412*/
/* 52246*/      OPC_CheckChild0Type, MVT::v16i8,
/* 52248*/      OPC_RecordChild1, // #1 = $rhs
/* 52249*/      OPC_MoveChild2,
/* 52250*/      OPC_Scope, 15, /*->52267*/ // 10 children in Scope
/* 52252*/        OPC_CheckCondCode, ISD::SETEQ,
/* 52254*/        OPC_MoveParent,
/* 52255*/        OPC_CheckType, MVT::v16i8,
/* 52257*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52259*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52267*/      /*Scope*/ 15, /*->52283*/
/* 52268*/        OPC_CheckCondCode, ISD::SETNE,
/* 52270*/        OPC_MoveParent,
/* 52271*/        OPC_CheckType, MVT::v16i8,
/* 52273*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52275*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52283*/      /*Scope*/ 15, /*->52299*/
/* 52284*/        OPC_CheckCondCode, ISD::SETLT,
/* 52286*/        OPC_MoveParent,
/* 52287*/        OPC_CheckType, MVT::v16i8,
/* 52289*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52291*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_S_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52299*/      /*Scope*/ 15, /*->52315*/
/* 52300*/        OPC_CheckCondCode, ISD::SETULT,
/* 52302*/        OPC_MoveParent,
/* 52303*/        OPC_CheckType, MVT::v16i8,
/* 52305*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52307*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_U_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52315*/      /*Scope*/ 15, /*->52331*/
/* 52316*/        OPC_CheckCondCode, ISD::SETGT,
/* 52318*/        OPC_MoveParent,
/* 52319*/        OPC_CheckType, MVT::v16i8,
/* 52321*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52323*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_S_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52331*/      /*Scope*/ 15, /*->52347*/
/* 52332*/        OPC_CheckCondCode, ISD::SETUGT,
/* 52334*/        OPC_MoveParent,
/* 52335*/        OPC_CheckType, MVT::v16i8,
/* 52337*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52339*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_U_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52347*/      /*Scope*/ 15, /*->52363*/
/* 52348*/        OPC_CheckCondCode, ISD::SETLE,
/* 52350*/        OPC_MoveParent,
/* 52351*/        OPC_CheckType, MVT::v16i8,
/* 52353*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52355*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_S_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52363*/      /*Scope*/ 15, /*->52379*/
/* 52364*/        OPC_CheckCondCode, ISD::SETULE,
/* 52366*/        OPC_MoveParent,
/* 52367*/        OPC_CheckType, MVT::v16i8,
/* 52369*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52371*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_U_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52379*/      /*Scope*/ 15, /*->52395*/
/* 52380*/        OPC_CheckCondCode, ISD::SETGE,
/* 52382*/        OPC_MoveParent,
/* 52383*/        OPC_CheckType, MVT::v16i8,
/* 52385*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52387*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_S_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52395*/      /*Scope*/ 15, /*->52411*/
/* 52396*/        OPC_CheckCondCode, ISD::SETUGE,
/* 52398*/        OPC_MoveParent,
/* 52399*/        OPC_CheckType, MVT::v16i8,
/* 52401*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52403*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_U_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 52411*/      0, /*End of Scope*/
/* 52412*/    /*Scope*/ 38|128,1/*166*/, /*->52580*/
/* 52414*/      OPC_CheckChild0Type, MVT::v8i16,
/* 52416*/      OPC_RecordChild1, // #1 = $rhs
/* 52417*/      OPC_MoveChild2,
/* 52418*/      OPC_Scope, 15, /*->52435*/ // 10 children in Scope
/* 52420*/        OPC_CheckCondCode, ISD::SETEQ,
/* 52422*/        OPC_MoveParent,
/* 52423*/        OPC_CheckType, MVT::v8i16,
/* 52425*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52427*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52435*/      /*Scope*/ 15, /*->52451*/
/* 52436*/        OPC_CheckCondCode, ISD::SETNE,
/* 52438*/        OPC_MoveParent,
/* 52439*/        OPC_CheckType, MVT::v8i16,
/* 52441*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52443*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52451*/      /*Scope*/ 15, /*->52467*/
/* 52452*/        OPC_CheckCondCode, ISD::SETLT,
/* 52454*/        OPC_MoveParent,
/* 52455*/        OPC_CheckType, MVT::v8i16,
/* 52457*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52459*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_S_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52467*/      /*Scope*/ 15, /*->52483*/
/* 52468*/        OPC_CheckCondCode, ISD::SETULT,
/* 52470*/        OPC_MoveParent,
/* 52471*/        OPC_CheckType, MVT::v8i16,
/* 52473*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52475*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_U_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52483*/      /*Scope*/ 15, /*->52499*/
/* 52484*/        OPC_CheckCondCode, ISD::SETGT,
/* 52486*/        OPC_MoveParent,
/* 52487*/        OPC_CheckType, MVT::v8i16,
/* 52489*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52491*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_S_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52499*/      /*Scope*/ 15, /*->52515*/
/* 52500*/        OPC_CheckCondCode, ISD::SETUGT,
/* 52502*/        OPC_MoveParent,
/* 52503*/        OPC_CheckType, MVT::v8i16,
/* 52505*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52507*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_U_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52515*/      /*Scope*/ 15, /*->52531*/
/* 52516*/        OPC_CheckCondCode, ISD::SETLE,
/* 52518*/        OPC_MoveParent,
/* 52519*/        OPC_CheckType, MVT::v8i16,
/* 52521*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52523*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_S_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52531*/      /*Scope*/ 15, /*->52547*/
/* 52532*/        OPC_CheckCondCode, ISD::SETULE,
/* 52534*/        OPC_MoveParent,
/* 52535*/        OPC_CheckType, MVT::v8i16,
/* 52537*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52539*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_U_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52547*/      /*Scope*/ 15, /*->52563*/
/* 52548*/        OPC_CheckCondCode, ISD::SETGE,
/* 52550*/        OPC_MoveParent,
/* 52551*/        OPC_CheckType, MVT::v8i16,
/* 52553*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52555*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_S_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52563*/      /*Scope*/ 15, /*->52579*/
/* 52564*/        OPC_CheckCondCode, ISD::SETUGE,
/* 52566*/        OPC_MoveParent,
/* 52567*/        OPC_CheckType, MVT::v8i16,
/* 52569*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52571*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_U_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 52579*/      0, /*End of Scope*/
/* 52580*/    /*Scope*/ 38|128,1/*166*/, /*->52748*/
/* 52582*/      OPC_CheckChild0Type, MVT::v4i32,
/* 52584*/      OPC_RecordChild1, // #1 = $rhs
/* 52585*/      OPC_MoveChild2,
/* 52586*/      OPC_Scope, 15, /*->52603*/ // 10 children in Scope
/* 52588*/        OPC_CheckCondCode, ISD::SETEQ,
/* 52590*/        OPC_MoveParent,
/* 52591*/        OPC_CheckType, MVT::v4i32,
/* 52593*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52595*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52603*/      /*Scope*/ 15, /*->52619*/
/* 52604*/        OPC_CheckCondCode, ISD::SETNE,
/* 52606*/        OPC_MoveParent,
/* 52607*/        OPC_CheckType, MVT::v4i32,
/* 52609*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52611*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52619*/      /*Scope*/ 15, /*->52635*/
/* 52620*/        OPC_CheckCondCode, ISD::SETLT,
/* 52622*/        OPC_MoveParent,
/* 52623*/        OPC_CheckType, MVT::v4i32,
/* 52625*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52627*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_S_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52635*/      /*Scope*/ 15, /*->52651*/
/* 52636*/        OPC_CheckCondCode, ISD::SETULT,
/* 52638*/        OPC_MoveParent,
/* 52639*/        OPC_CheckType, MVT::v4i32,
/* 52641*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52643*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_U_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52651*/      /*Scope*/ 15, /*->52667*/
/* 52652*/        OPC_CheckCondCode, ISD::SETGT,
/* 52654*/        OPC_MoveParent,
/* 52655*/        OPC_CheckType, MVT::v4i32,
/* 52657*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52659*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_S_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52667*/      /*Scope*/ 15, /*->52683*/
/* 52668*/        OPC_CheckCondCode, ISD::SETUGT,
/* 52670*/        OPC_MoveParent,
/* 52671*/        OPC_CheckType, MVT::v4i32,
/* 52673*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52675*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_U_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52683*/      /*Scope*/ 15, /*->52699*/
/* 52684*/        OPC_CheckCondCode, ISD::SETLE,
/* 52686*/        OPC_MoveParent,
/* 52687*/        OPC_CheckType, MVT::v4i32,
/* 52689*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52691*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_S_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52699*/      /*Scope*/ 15, /*->52715*/
/* 52700*/        OPC_CheckCondCode, ISD::SETULE,
/* 52702*/        OPC_MoveParent,
/* 52703*/        OPC_CheckType, MVT::v4i32,
/* 52705*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52707*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_U_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52715*/      /*Scope*/ 15, /*->52731*/
/* 52716*/        OPC_CheckCondCode, ISD::SETGE,
/* 52718*/        OPC_MoveParent,
/* 52719*/        OPC_CheckType, MVT::v4i32,
/* 52721*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52723*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_S_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52731*/      /*Scope*/ 15, /*->52747*/
/* 52732*/        OPC_CheckCondCode, ISD::SETUGE,
/* 52734*/        OPC_MoveParent,
/* 52735*/        OPC_CheckType, MVT::v4i32,
/* 52737*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52739*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_U_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 52747*/      0, /*End of Scope*/
/* 52748*/    /*Scope*/ 2|128,1/*130*/, /*->52880*/
/* 52750*/      OPC_CheckChild0Type, MVT::v4f32,
/* 52752*/      OPC_RecordChild1, // #1 = $rhs
/* 52753*/      OPC_MoveChild2,
/* 52754*/      OPC_Scope, 15, /*->52771*/ // 8 children in Scope
/* 52756*/        OPC_CheckCondCode, ISD::SETOEQ,
/* 52758*/        OPC_MoveParent,
/* 52759*/        OPC_CheckType, MVT::v4i32,
/* 52761*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52763*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52771*/      /*Scope*/ 15, /*->52787*/
/* 52772*/        OPC_CheckCondCode, ISD::SETUNE,
/* 52774*/        OPC_MoveParent,
/* 52775*/        OPC_CheckType, MVT::v4i32,
/* 52777*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52779*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52787*/      /*Scope*/ 15, /*->52803*/
/* 52788*/        OPC_CheckCondCode, ISD::SETOLT,
/* 52790*/        OPC_MoveParent,
/* 52791*/        OPC_CheckType, MVT::v4i32,
/* 52793*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52795*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52803*/      /*Scope*/ 15, /*->52819*/
/* 52804*/        OPC_CheckCondCode, ISD::SETOGT,
/* 52806*/        OPC_MoveParent,
/* 52807*/        OPC_CheckType, MVT::v4i32,
/* 52809*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52811*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52819*/      /*Scope*/ 15, /*->52835*/
/* 52820*/        OPC_CheckCondCode, ISD::SETOLE,
/* 52822*/        OPC_MoveParent,
/* 52823*/        OPC_CheckType, MVT::v4i32,
/* 52825*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52827*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52835*/      /*Scope*/ 15, /*->52851*/
/* 52836*/        OPC_CheckCondCode, ISD::SETOGE,
/* 52838*/        OPC_MoveParent,
/* 52839*/        OPC_CheckType, MVT::v4i32,
/* 52841*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52843*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52851*/      /*Scope*/ 13, /*->52865*/
/* 52852*/        OPC_CheckCondCode, ISD::SETEQ,
/* 52854*/        OPC_MoveParent,
/* 52855*/        OPC_CheckType, MVT::v4i32,
/* 52857*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52865*/      /*Scope*/ 13, /*->52879*/
/* 52866*/        OPC_CheckCondCode, ISD::SETNE,
/* 52868*/        OPC_MoveParent,
/* 52869*/        OPC_CheckType, MVT::v4i32,
/* 52871*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_v4f32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 52879*/      0, /*End of Scope*/
/* 52880*/    /*Scope*/ 2|128,1/*130*/, /*->53012*/
/* 52882*/      OPC_CheckChild0Type, MVT::v2f64,
/* 52884*/      OPC_RecordChild1, // #1 = $rhs
/* 52885*/      OPC_MoveChild2,
/* 52886*/      OPC_Scope, 15, /*->52903*/ // 8 children in Scope
/* 52888*/        OPC_CheckCondCode, ISD::SETOEQ,
/* 52890*/        OPC_MoveParent,
/* 52891*/        OPC_CheckType, MVT::v2i64,
/* 52893*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52895*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52903*/      /*Scope*/ 15, /*->52919*/
/* 52904*/        OPC_CheckCondCode, ISD::SETUNE,
/* 52906*/        OPC_MoveParent,
/* 52907*/        OPC_CheckType, MVT::v2i64,
/* 52909*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52911*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52919*/      /*Scope*/ 15, /*->52935*/
/* 52920*/        OPC_CheckCondCode, ISD::SETOLT,
/* 52922*/        OPC_MoveParent,
/* 52923*/        OPC_CheckType, MVT::v2i64,
/* 52925*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52927*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                  // Dst: (LT_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52935*/      /*Scope*/ 15, /*->52951*/
/* 52936*/        OPC_CheckCondCode, ISD::SETOGT,
/* 52938*/        OPC_MoveParent,
/* 52939*/        OPC_CheckType, MVT::v2i64,
/* 52941*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52943*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                  // Dst: (GT_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52951*/      /*Scope*/ 15, /*->52967*/
/* 52952*/        OPC_CheckCondCode, ISD::SETOLE,
/* 52954*/        OPC_MoveParent,
/* 52955*/        OPC_CheckType, MVT::v2i64,
/* 52957*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52959*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                  // Dst: (LE_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52967*/      /*Scope*/ 15, /*->52983*/
/* 52968*/        OPC_CheckCondCode, ISD::SETOGE,
/* 52970*/        OPC_MoveParent,
/* 52971*/        OPC_CheckType, MVT::v2i64,
/* 52973*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 52975*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                  // Dst: (GE_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52983*/      /*Scope*/ 13, /*->52997*/
/* 52984*/        OPC_CheckCondCode, ISD::SETEQ,
/* 52986*/        OPC_MoveParent,
/* 52987*/        OPC_CheckType, MVT::v2i64,
/* 52989*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                  // Dst: (EQ_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 52997*/      /*Scope*/ 13, /*->53011*/
/* 52998*/        OPC_CheckCondCode, ISD::SETNE,
/* 53000*/        OPC_MoveParent,
/* 53001*/        OPC_CheckType, MVT::v2i64,
/* 53003*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_v2f64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                  // Dst: (NE_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 53011*/      0, /*End of Scope*/
/* 53012*/    0, /*End of Scope*/
/* 53013*/  /*SwitchOpcode*/ 98|128,3/*482*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->53499
/* 53017*/    OPC_Scope, 76, /*->53095*/ // 7 children in Scope
/* 53019*/      OPC_CheckChild0Integer, 43|128,43/*5547*/, 
/* 53022*/      OPC_RecordChild1, // #0 = $src
/* 53023*/      OPC_Scope, 22, /*->53047*/ // 4 children in Scope
/* 53025*/        OPC_CheckChild1Type, MVT::f32,
/* 53027*/        OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->53037
/* 53030*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i32] } 5547:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
                    // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 53037*/        /*SwitchType*/ 7, MVT::i64,// ->53046
/* 53039*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i64] } 5547:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
                    // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 53046*/        0, // EndSwitchType
/* 53047*/      /*Scope*/ 22, /*->53070*/
/* 53048*/        OPC_CheckChild1Type, MVT::f64,
/* 53050*/        OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->53060
/* 53053*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i32] } 5547:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
                    // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 53060*/        /*SwitchType*/ 7, MVT::i64,// ->53069
/* 53062*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i64] } 5547:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
                    // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 53069*/        0, // EndSwitchType
/* 53070*/      /*Scope*/ 11, /*->53082*/
/* 53071*/        OPC_CheckChild1Type, MVT::v4f32,
/* 53073*/        OPC_CheckType, MVT::v4i32,
/* 53075*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_v4i32_v4f32), 0,
                      MVT::v4i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[v4i32] } 5547:{ *:[iPTR] }, V128:{ *:[v4f32] }:$src) - Complexity = 8
                  // Dst: (fp_to_sint_v4i32_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$src)
/* 53082*/      /*Scope*/ 11, /*->53094*/
/* 53083*/        OPC_CheckChild1Type, MVT::v2f64,
/* 53085*/        OPC_CheckType, MVT::v2i64,
/* 53087*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_v2i64_v2f64), 0,
                      MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[v2i64] } 5547:{ *:[iPTR] }, V128:{ *:[v2f64] }:$src) - Complexity = 8
                  // Dst: (fp_to_sint_v2i64_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$src)
/* 53094*/      0, /*End of Scope*/
/* 53095*/    /*Scope*/ 76, /*->53172*/
/* 53096*/      OPC_CheckChild0Integer, 44|128,43/*5548*/, 
/* 53099*/      OPC_RecordChild1, // #0 = $src
/* 53100*/      OPC_Scope, 22, /*->53124*/ // 4 children in Scope
/* 53102*/        OPC_CheckChild1Type, MVT::f32,
/* 53104*/        OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->53114
/* 53107*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i32] } 5548:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
                    // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 53114*/        /*SwitchType*/ 7, MVT::i64,// ->53123
/* 53116*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i64] } 5548:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
                    // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 53123*/        0, // EndSwitchType
/* 53124*/      /*Scope*/ 22, /*->53147*/
/* 53125*/        OPC_CheckChild1Type, MVT::f64,
/* 53127*/        OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->53137
/* 53130*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i32] } 5548:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
                    // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 53137*/        /*SwitchType*/ 7, MVT::i64,// ->53146
/* 53139*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (intrinsic_wo_chain:{ *:[i64] } 5548:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
                    // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 53146*/        0, // EndSwitchType
/* 53147*/      /*Scope*/ 11, /*->53159*/
/* 53148*/        OPC_CheckChild1Type, MVT::v4f32,
/* 53150*/        OPC_CheckType, MVT::v4i32,
/* 53152*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_v4i32_v4f32), 0,
                      MVT::v4i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[v4i32] } 5548:{ *:[iPTR] }, V128:{ *:[v4f32] }:$src) - Complexity = 8
                  // Dst: (fp_to_uint_v4i32_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$src)
/* 53159*/      /*Scope*/ 11, /*->53171*/
/* 53160*/        OPC_CheckChild1Type, MVT::v2f64,
/* 53162*/        OPC_CheckType, MVT::v2i64,
/* 53164*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_v2i64_v2f64), 0,
                      MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[v2i64] } 5548:{ *:[iPTR] }, V128:{ *:[v2f64] }:$src) - Complexity = 8
                  // Dst: (fp_to_uint_v2i64_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$src)
/* 53171*/      0, /*End of Scope*/
/* 53172*/    /*Scope*/ 54, /*->53227*/
/* 53173*/      OPC_CheckChild0Integer, 27|128,43/*5531*/, 
/* 53176*/      OPC_RecordChild1, // #0 = $vec
/* 53177*/      OPC_Scope, 11, /*->53190*/ // 4 children in Scope
/* 53179*/        OPC_CheckChild1Type, MVT::v16i8,
/* 53181*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53183*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE_v16i8), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5531:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
                  // Dst: (ANYTRUE_v16i8:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 53190*/      /*Scope*/ 11, /*->53202*/
/* 53191*/        OPC_CheckChild1Type, MVT::v8i16,
/* 53193*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53195*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE_v8i16), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5531:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
                  // Dst: (ANYTRUE_v8i16:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 53202*/      /*Scope*/ 11, /*->53214*/
/* 53203*/        OPC_CheckChild1Type, MVT::v4i32,
/* 53205*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53207*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE_v4i32), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5531:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
                  // Dst: (ANYTRUE_v4i32:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 53214*/      /*Scope*/ 11, /*->53226*/
/* 53215*/        OPC_CheckChild1Type, MVT::v2i64,
/* 53217*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53219*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE_v2i64), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
                  // Dst: (ANYTRUE_v2i64:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 53226*/      0, /*End of Scope*/
/* 53227*/    /*Scope*/ 54, /*->53282*/
/* 53228*/      OPC_CheckChild0Integer, 26|128,43/*5530*/, 
/* 53231*/      OPC_RecordChild1, // #0 = $vec
/* 53232*/      OPC_Scope, 11, /*->53245*/ // 4 children in Scope
/* 53234*/        OPC_CheckChild1Type, MVT::v16i8,
/* 53236*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53238*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_v16i8), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5530:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
                  // Dst: (ALLTRUE_v16i8:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 53245*/      /*Scope*/ 11, /*->53257*/
/* 53246*/        OPC_CheckChild1Type, MVT::v8i16,
/* 53248*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53250*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_v8i16), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5530:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
                  // Dst: (ALLTRUE_v8i16:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 53257*/      /*Scope*/ 11, /*->53269*/
/* 53258*/        OPC_CheckChild1Type, MVT::v4i32,
/* 53260*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53262*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_v4i32), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5530:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
                  // Dst: (ALLTRUE_v4i32:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 53269*/      /*Scope*/ 11, /*->53281*/
/* 53270*/        OPC_CheckChild1Type, MVT::v2i64,
/* 53272*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53274*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_v2i64), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (intrinsic_wo_chain:{ *:[i32] } 5530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
                  // Dst: (ALLTRUE_v2i64:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 53281*/      0, /*End of Scope*/
/* 53282*/    /*Scope*/ 4|128,1/*132*/, /*->53416*/
/* 53284*/      OPC_CheckChild0Integer, 31|128,43/*5535*/, 
/* 53287*/      OPC_RecordChild1, // #0 = $v1
/* 53288*/      OPC_SwitchType /*6 cases */, 19, MVT::v16i8,// ->53310
/* 53291*/        OPC_CheckChild1Type, MVT::v16i8,
/* 53293*/        OPC_RecordChild2, // #1 = $v2
/* 53294*/        OPC_CheckChild2Type, MVT::v16i8,
/* 53296*/        OPC_RecordChild3, // #2 = $c
/* 53297*/        OPC_CheckChild3Type, MVT::v16i8,
/* 53299*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53301*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (intrinsic_wo_chain:{ *:[v16i8] } 5535:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
                  // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 53310*/      /*SwitchType*/ 19, MVT::v8i16,// ->53331
/* 53312*/        OPC_CheckChild1Type, MVT::v8i16,
/* 53314*/        OPC_RecordChild2, // #1 = $v2
/* 53315*/        OPC_CheckChild2Type, MVT::v8i16,
/* 53317*/        OPC_RecordChild3, // #2 = $c
/* 53318*/        OPC_CheckChild3Type, MVT::v8i16,
/* 53320*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53322*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (intrinsic_wo_chain:{ *:[v8i16] } 5535:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
                  // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 53331*/      /*SwitchType*/ 19, MVT::v4i32,// ->53352
/* 53333*/        OPC_CheckChild1Type, MVT::v4i32,
/* 53335*/        OPC_RecordChild2, // #1 = $v2
/* 53336*/        OPC_CheckChild2Type, MVT::v4i32,
/* 53338*/        OPC_RecordChild3, // #2 = $c
/* 53339*/        OPC_CheckChild3Type, MVT::v4i32,
/* 53341*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53343*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                      MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (intrinsic_wo_chain:{ *:[v4i32] } 5535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
                  // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 53352*/      /*SwitchType*/ 19, MVT::v2i64,// ->53373
/* 53354*/        OPC_CheckChild1Type, MVT::v2i64,
/* 53356*/        OPC_RecordChild2, // #1 = $v2
/* 53357*/        OPC_CheckChild2Type, MVT::v2i64,
/* 53359*/        OPC_RecordChild3, // #2 = $c
/* 53360*/        OPC_CheckChild3Type, MVT::v2i64,
/* 53362*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53364*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                      MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (intrinsic_wo_chain:{ *:[v2i64] } 5535:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
                  // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 53373*/      /*SwitchType*/ 19, MVT::v4f32,// ->53394
/* 53375*/        OPC_CheckChild1Type, MVT::v4f32,
/* 53377*/        OPC_RecordChild2, // #1 = $v2
/* 53378*/        OPC_CheckChild2Type, MVT::v4f32,
/* 53380*/        OPC_RecordChild3, // #2 = $c
/* 53381*/        OPC_CheckChild3Type, MVT::v4f32,
/* 53383*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53385*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4f32), 0,
                      MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (intrinsic_wo_chain:{ *:[v4f32] } 5535:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
                  // Dst: (BITSELECT_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c)
/* 53394*/      /*SwitchType*/ 19, MVT::v2f64,// ->53415
/* 53396*/        OPC_CheckChild1Type, MVT::v2f64,
/* 53398*/        OPC_RecordChild2, // #1 = $v2
/* 53399*/        OPC_CheckChild2Type, MVT::v2f64,
/* 53401*/        OPC_RecordChild3, // #2 = $c
/* 53402*/        OPC_CheckChild3Type, MVT::v2f64,
/* 53404*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53406*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2f64), 0,
                      MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
                  // Src: (intrinsic_wo_chain:{ *:[v2f64] } 5535:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
                  // Dst: (BITSELECT_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c)
/* 53415*/      0, // EndSwitchType
/* 53416*/    /*Scope*/ 40, /*->53457*/
/* 53417*/      OPC_CheckChild0Integer, 40|128,43/*5544*/, 
/* 53420*/      OPC_RecordChild1, // #0 = $lhs
/* 53421*/      OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->53439
/* 53424*/        OPC_CheckChild1Type, MVT::v16i8,
/* 53426*/        OPC_RecordChild2, // #1 = $rhs
/* 53427*/        OPC_CheckChild2Type, MVT::v16i8,
/* 53429*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53431*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (intrinsic_wo_chain:{ *:[v16i8] } 5544:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
                  // Dst: (SUB_SAT_S_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 53439*/      /*SwitchType*/ 15, MVT::v8i16,// ->53456
/* 53441*/        OPC_CheckChild1Type, MVT::v8i16,
/* 53443*/        OPC_RecordChild2, // #1 = $rhs
/* 53444*/        OPC_CheckChild2Type, MVT::v8i16,
/* 53446*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53448*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (intrinsic_wo_chain:{ *:[v8i16] } 5544:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
                  // Dst: (SUB_SAT_S_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 53456*/      0, // EndSwitchType
/* 53457*/    /*Scope*/ 40, /*->53498*/
/* 53458*/      OPC_CheckChild0Integer, 41|128,43/*5545*/, 
/* 53461*/      OPC_RecordChild1, // #0 = $lhs
/* 53462*/      OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->53480
/* 53465*/        OPC_CheckChild1Type, MVT::v16i8,
/* 53467*/        OPC_RecordChild2, // #1 = $rhs
/* 53468*/        OPC_CheckChild2Type, MVT::v16i8,
/* 53470*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53472*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (intrinsic_wo_chain:{ *:[v16i8] } 5545:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
                  // Dst: (SUB_SAT_U_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 53480*/      /*SwitchType*/ 15, MVT::v8i16,// ->53497
/* 53482*/        OPC_CheckChild1Type, MVT::v8i16,
/* 53484*/        OPC_RecordChild2, // #1 = $rhs
/* 53485*/        OPC_CheckChild2Type, MVT::v8i16,
/* 53487*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53489*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (intrinsic_wo_chain:{ *:[v8i16] } 5545:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
                  // Dst: (SUB_SAT_U_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 53497*/      0, // EndSwitchType
/* 53498*/    0, /*End of Scope*/
/* 53499*/  /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->53796
/* 53503*/    OPC_RecordChild0, // #0 = $vec
/* 53504*/    OPC_Scope, 48, /*->53554*/ // 6 children in Scope
/* 53506*/      OPC_CheckChild0Type, MVT::v4i32,
/* 53508*/      OPC_Scope, 24, /*->53534*/ // 2 children in Scope
/* 53510*/        OPC_RecordChild1, // #1 = $idx
/* 53511*/        OPC_MoveChild1,
/* 53512*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 53515*/        OPC_CheckPredicate, 23, // Predicate_LaneIdx4
/* 53517*/        OPC_CheckType, MVT::i32,
/* 53519*/        OPC_MoveParent,
/* 53520*/        OPC_CheckType, MVT::i32,
/* 53522*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53524*/        OPC_EmitConvertToTarget, 1,
/* 53526*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v4i32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                  // Dst: (EXTRACT_LANE_v4i32:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 53534*/      /*Scope*/ 18, /*->53553*/
/* 53535*/        OPC_MoveChild1,
/* 53536*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 53539*/        OPC_MoveParent,
/* 53540*/        OPC_CheckType, MVT::i32,
/* 53542*/        OPC_EmitInteger, MVT::i32, 0, 
/* 53545*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v4i32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (EXTRACT_LANE_v4i32:{ *:[i32] } V128:{ *:[v4i32] }:$vec, 0:{ *:[i32] })
/* 53553*/      0, /*End of Scope*/
/* 53554*/    /*Scope*/ 48, /*->53603*/
/* 53555*/      OPC_CheckChild0Type, MVT::v2i64,
/* 53557*/      OPC_Scope, 24, /*->53583*/ // 2 children in Scope
/* 53559*/        OPC_RecordChild1, // #1 = $idx
/* 53560*/        OPC_MoveChild1,
/* 53561*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 53564*/        OPC_CheckPredicate, 24, // Predicate_LaneIdx2
/* 53566*/        OPC_CheckType, MVT::i32,
/* 53568*/        OPC_MoveParent,
/* 53569*/        OPC_CheckType, MVT::i64,
/* 53571*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53573*/        OPC_EmitConvertToTarget, 1,
/* 53575*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v2i64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 2, 
                  // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                  // Dst: (EXTRACT_LANE_v2i64:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 53583*/      /*Scope*/ 18, /*->53602*/
/* 53584*/        OPC_MoveChild1,
/* 53585*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 53588*/        OPC_MoveParent,
/* 53589*/        OPC_CheckType, MVT::i64,
/* 53591*/        OPC_EmitInteger, MVT::i32, 0, 
/* 53594*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v2i64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (EXTRACT_LANE_v2i64:{ *:[i64] } V128:{ *:[v2i64] }:$vec, 0:{ *:[i32] })
/* 53602*/      0, /*End of Scope*/
/* 53603*/    /*Scope*/ 46, /*->53650*/
/* 53604*/      OPC_CheckChild0Type, MVT::v16i8,
/* 53606*/      OPC_Scope, 22, /*->53630*/ // 2 children in Scope
/* 53608*/        OPC_RecordChild1, // #1 = $idx
/* 53609*/        OPC_MoveChild1,
/* 53610*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 53613*/        OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 53615*/        OPC_CheckType, MVT::i32,
/* 53617*/        OPC_MoveParent,
/* 53618*/        OPC_CheckType, MVT::i32,
/* 53620*/        OPC_EmitConvertToTarget, 1,
/* 53622*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v16i8_s), 0,
                      MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                  // Dst: (EXTRACT_LANE_v16i8_s:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx)
/* 53630*/      /*Scope*/ 18, /*->53649*/
/* 53631*/        OPC_MoveChild1,
/* 53632*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 53635*/        OPC_MoveParent,
/* 53636*/        OPC_CheckType, MVT::i32,
/* 53638*/        OPC_EmitInteger, MVT::i32, 0, 
/* 53641*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v16i8_u), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (EXTRACT_LANE_v16i8_u:{ *:[i32] } V128:{ *:[v16i8] }:$vec, 0:{ *:[i32] })
/* 53649*/      0, /*End of Scope*/
/* 53650*/    /*Scope*/ 46, /*->53697*/
/* 53651*/      OPC_CheckChild0Type, MVT::v8i16,
/* 53653*/      OPC_Scope, 22, /*->53677*/ // 2 children in Scope
/* 53655*/        OPC_RecordChild1, // #1 = $idx
/* 53656*/        OPC_MoveChild1,
/* 53657*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 53660*/        OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 53662*/        OPC_CheckType, MVT::i32,
/* 53664*/        OPC_MoveParent,
/* 53665*/        OPC_CheckType, MVT::i32,
/* 53667*/        OPC_EmitConvertToTarget, 1,
/* 53669*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v8i16_s), 0,
                      MVT::i32, 2/*#Ops*/, 0, 2, 
                  // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                  // Dst: (EXTRACT_LANE_v8i16_s:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx)
/* 53677*/      /*Scope*/ 18, /*->53696*/
/* 53678*/        OPC_MoveChild1,
/* 53679*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 53682*/        OPC_MoveParent,
/* 53683*/        OPC_CheckType, MVT::i32,
/* 53685*/        OPC_EmitInteger, MVT::i32, 0, 
/* 53688*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v8i16_u), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (EXTRACT_LANE_v8i16_u:{ *:[i32] } V128:{ *:[v8i16] }:$vec, 0:{ *:[i32] })
/* 53696*/      0, /*End of Scope*/
/* 53697*/    /*Scope*/ 48, /*->53746*/
/* 53698*/      OPC_CheckChild0Type, MVT::v4f32,
/* 53700*/      OPC_Scope, 24, /*->53726*/ // 2 children in Scope
/* 53702*/        OPC_RecordChild1, // #1 = $idx
/* 53703*/        OPC_MoveChild1,
/* 53704*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 53707*/        OPC_CheckPredicate, 23, // Predicate_LaneIdx4
/* 53709*/        OPC_CheckType, MVT::i32,
/* 53711*/        OPC_MoveParent,
/* 53712*/        OPC_CheckType, MVT::f32,
/* 53714*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53716*/        OPC_EmitConvertToTarget, 1,
/* 53718*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v4f32), 0,
                      MVT::f32, 2/*#Ops*/, 0, 2, 
                  // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                  // Dst: (EXTRACT_LANE_v4f32:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 53726*/      /*Scope*/ 18, /*->53745*/
/* 53727*/        OPC_MoveChild1,
/* 53728*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 53731*/        OPC_MoveParent,
/* 53732*/        OPC_CheckType, MVT::f32,
/* 53734*/        OPC_EmitInteger, MVT::i32, 0, 
/* 53737*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v4f32), 0,
                      MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (EXTRACT_LANE_v4f32:{ *:[f32] } V128:{ *:[v4f32] }:$vec, 0:{ *:[i32] })
/* 53745*/      0, /*End of Scope*/
/* 53746*/    /*Scope*/ 48, /*->53795*/
/* 53747*/      OPC_CheckChild0Type, MVT::v2f64,
/* 53749*/      OPC_Scope, 24, /*->53775*/ // 2 children in Scope
/* 53751*/        OPC_RecordChild1, // #1 = $idx
/* 53752*/        OPC_MoveChild1,
/* 53753*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 53756*/        OPC_CheckPredicate, 24, // Predicate_LaneIdx2
/* 53758*/        OPC_CheckType, MVT::i32,
/* 53760*/        OPC_MoveParent,
/* 53761*/        OPC_CheckType, MVT::f64,
/* 53763*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 53765*/        OPC_EmitConvertToTarget, 1,
/* 53767*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v2f64), 0,
                      MVT::f64, 2/*#Ops*/, 0, 2, 
                  // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                  // Dst: (EXTRACT_LANE_v2f64:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 53775*/      /*Scope*/ 18, /*->53794*/
/* 53776*/        OPC_MoveChild1,
/* 53777*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 53780*/        OPC_MoveParent,
/* 53781*/        OPC_CheckType, MVT::f64,
/* 53783*/        OPC_EmitInteger, MVT::i32, 0, 
/* 53786*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_v2f64), 0,
                      MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (EXTRACT_LANE_v2f64:{ *:[f64] } V128:{ *:[v2f64] }:$vec, 0:{ *:[i32] })
/* 53794*/      0, /*End of Scope*/
/* 53795*/    0, /*End of Scope*/
/* 53796*/  /*SwitchOpcode*/ 107, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->53906
/* 53799*/    OPC_RecordChild0, // #0 = $argno
/* 53800*/    OPC_MoveChild0,
/* 53801*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 53804*/    OPC_MoveParent,
/* 53805*/    OPC_SwitchType /*11 cases */, 7, MVT::i32,// ->53815
/* 53808*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 53815*/    /*SwitchType*/ 7, MVT::i64,// ->53824
/* 53817*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i64), 0,
                    MVT::i64, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 53824*/    /*SwitchType*/ 7, MVT::ExceptRef,// ->53833
/* 53826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_ExceptRef), 0,
                    MVT::ExceptRef, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[ExceptRef] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_ExceptRef:{ *:[ExceptRef] } (timm:{ *:[i32] }):$argno)
/* 53833*/    /*SwitchType*/ 7, MVT::f32,// ->53842
/* 53835*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 53842*/    /*SwitchType*/ 7, MVT::f64,// ->53851
/* 53844*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 53851*/    /*SwitchType*/ 7, MVT::v16i8,// ->53860
/* 53853*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v16i8), 0,
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 53860*/    /*SwitchType*/ 7, MVT::v8i16,// ->53869
/* 53862*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v8i16), 0,
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 53869*/    /*SwitchType*/ 7, MVT::v4i32,// ->53878
/* 53871*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4i32), 0,
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 53878*/    /*SwitchType*/ 7, MVT::v2i64,// ->53887
/* 53880*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2i64), 0,
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 53887*/    /*SwitchType*/ 7, MVT::v4f32,// ->53896
/* 53889*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4f32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 53896*/    /*SwitchType*/ 7, MVT::v2f64,// ->53905
/* 53898*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2f64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
                // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 53905*/    0, // EndSwitchType
/* 53906*/  /*SwitchOpcode*/ 54, TARGET_VAL(WebAssemblyISD::Wrapper),// ->53963
/* 53909*/    OPC_RecordChild0, // #0 = $addr
/* 53910*/    OPC_MoveChild0,
/* 53911*/    OPC_SwitchOpcode /*3 cases */, 10, TARGET_VAL(ISD::TargetGlobalAddress),// ->53925
/* 53915*/      OPC_MoveParent,
/* 53916*/      OPC_CheckType, MVT::i32,
/* 53918*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (WebAssemblywrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
                // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 53925*/    /*SwitchOpcode*/ 10, TARGET_VAL(ISD::TargetExternalSymbol),// ->53938
/* 53928*/      OPC_MoveParent,
/* 53929*/      OPC_CheckType, MVT::i32,
/* 53931*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (WebAssemblywrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
                // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 53938*/    /*SwitchOpcode*/ 21, TARGET_VAL(ISD::MCSymbol),// ->53962
/* 53941*/      OPC_MoveParent,
/* 53942*/      OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->53952
/* 53945*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                      MVT::i32, 1/*#Ops*/, 0, 
                  // Src: (WebAssemblywrapper:{ *:[i32] } (mcsym:{ *:[i32] }):$sym) - Complexity = 6
                  // Dst: (CONST_I32:{ *:[i32] } (mcsym:{ *:[i32] }):$sym)
/* 53952*/      /*SwitchType*/ 7, MVT::i64,// ->53961
/* 53954*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                      MVT::i64, 1/*#Ops*/, 0, 
                  // Src: (WebAssemblywrapper:{ *:[i64] } (mcsym:{ *:[i64] }):$sym) - Complexity = 6
                  // Dst: (CONST_I64:{ *:[i64] } (mcsym:{ *:[i64] }):$sym)
/* 53961*/      0, // EndSwitchType
/* 53962*/    0, // EndSwitchOpcode
/* 53963*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::Constant),// ->53991
/* 53966*/    OPC_RecordNode, // #0 = $imm
/* 53967*/    OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->53979
/* 53970*/      OPC_EmitConvertToTarget, 0,
/* 53972*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                    MVT::i32, 1/*#Ops*/, 1, 
                // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
                // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 53979*/    /*SwitchType*/ 9, MVT::i64,// ->53990
/* 53981*/      OPC_EmitConvertToTarget, 0,
/* 53983*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                    MVT::i64, 1/*#Ops*/, 1, 
                // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
                // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 53990*/    0, // EndSwitchType
/* 53991*/  /*SwitchOpcode*/ 14, TARGET_VAL(ISD::BR),// ->54008
/* 53994*/    OPC_RecordNode, // #0 = 'br' chained node
/* 53995*/    OPC_RecordChild1, // #1 = $dst
/* 53996*/    OPC_MoveChild1,
/* 53997*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 54000*/    OPC_MoveParent,
/* 54001*/    OPC_EmitMergeInputChains1_0,
/* 54002*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR), 0|OPFL_Chain,
                  1/*#Ops*/, 1, 
              // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
              // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 54008*/  /*SwitchOpcode*/ 24, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->54035
/* 54011*/    OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 54012*/    OPC_RecordChild1, // #1 = $index
/* 54013*/    OPC_Scope, 9, /*->54024*/ // 2 children in Scope
/* 54015*/      OPC_CheckChild1Type, MVT::i32,
/* 54017*/      OPC_EmitMergeInputChains1_0,
/* 54018*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                    1/*#Ops*/, 1, 
                // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
                // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 54024*/    /*Scope*/ 9, /*->54034*/
/* 54025*/      OPC_CheckChild1Type, MVT::i64,
/* 54027*/      OPC_EmitMergeInputChains1_0,
/* 54028*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                    1/*#Ops*/, 1, 
                // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
                // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 54034*/    0, /*End of Scope*/
/* 54035*/  /*SwitchOpcode*/ 8|128,1/*136*/, TARGET_VAL(WebAssemblyISD::RETURN),// ->54175
/* 54039*/    OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 54040*/    OPC_Scope, 125, /*->54167*/ // 2 children in Scope
/* 54042*/      OPC_RecordChild1, // #1 = $val
/* 54043*/      OPC_Scope, 9, /*->54054*/ // 11 children in Scope
/* 54045*/        OPC_CheckChild1Type, MVT::i32,
/* 54047*/        OPC_EmitMergeInputChains1_0,
/* 54048*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_I32), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn I32:{ *:[i32] }:$val) - Complexity = 3
                  // Dst: (RETURN_I32 I32:{ *:[i32] }:$val)
/* 54054*/      /*Scope*/ 9, /*->54064*/
/* 54055*/        OPC_CheckChild1Type, MVT::i64,
/* 54057*/        OPC_EmitMergeInputChains1_0,
/* 54058*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_I64), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn I64:{ *:[i64] }:$val) - Complexity = 3
                  // Dst: (RETURN_I64 I64:{ *:[i64] }:$val)
/* 54064*/      /*Scope*/ 9, /*->54074*/
/* 54065*/        OPC_CheckChild1Type, MVT::f32,
/* 54067*/        OPC_EmitMergeInputChains1_0,
/* 54068*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_F32), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn F32:{ *:[f32] }:$val) - Complexity = 3
                  // Dst: (RETURN_F32 F32:{ *:[f32] }:$val)
/* 54074*/      /*Scope*/ 9, /*->54084*/
/* 54075*/        OPC_CheckChild1Type, MVT::f64,
/* 54077*/        OPC_EmitMergeInputChains1_0,
/* 54078*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_F64), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn F64:{ *:[f64] }:$val) - Complexity = 3
                  // Dst: (RETURN_F64 F64:{ *:[f64] }:$val)
/* 54084*/      /*Scope*/ 9, /*->54094*/
/* 54085*/        OPC_CheckChild1Type, MVT::ExceptRef,
/* 54087*/        OPC_EmitMergeInputChains1_0,
/* 54088*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_EXCEPT_REF), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn EXCEPT_REF:{ *:[ExceptRef] }:$val) - Complexity = 3
                  // Dst: (RETURN_EXCEPT_REF EXCEPT_REF:{ *:[ExceptRef] }:$val)
/* 54094*/      /*Scope*/ 11, /*->54106*/
/* 54095*/        OPC_CheckChild1Type, MVT::v16i8,
/* 54097*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54099*/        OPC_EmitMergeInputChains1_0,
/* 54100*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_v16i8), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn V128:{ *:[v16i8] }:$val) - Complexity = 3
                  // Dst: (RETURN_v16i8 V128:{ *:[v16i8] }:$val)
/* 54106*/      /*Scope*/ 11, /*->54118*/
/* 54107*/        OPC_CheckChild1Type, MVT::v8i16,
/* 54109*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54111*/        OPC_EmitMergeInputChains1_0,
/* 54112*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_v8i16), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn V128:{ *:[v8i16] }:$val) - Complexity = 3
                  // Dst: (RETURN_v8i16 V128:{ *:[v8i16] }:$val)
/* 54118*/      /*Scope*/ 11, /*->54130*/
/* 54119*/        OPC_CheckChild1Type, MVT::v4i32,
/* 54121*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54123*/        OPC_EmitMergeInputChains1_0,
/* 54124*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_v4i32), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn V128:{ *:[v4i32] }:$val) - Complexity = 3
                  // Dst: (RETURN_v4i32 V128:{ *:[v4i32] }:$val)
/* 54130*/      /*Scope*/ 11, /*->54142*/
/* 54131*/        OPC_CheckChild1Type, MVT::v2i64,
/* 54133*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54135*/        OPC_EmitMergeInputChains1_0,
/* 54136*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_v2i64), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn V128:{ *:[v2i64] }:$val) - Complexity = 3
                  // Dst: (RETURN_v2i64 V128:{ *:[v2i64] }:$val)
/* 54142*/      /*Scope*/ 11, /*->54154*/
/* 54143*/        OPC_CheckChild1Type, MVT::v4f32,
/* 54145*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54147*/        OPC_EmitMergeInputChains1_0,
/* 54148*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_v4f32), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn V128:{ *:[v4f32] }:$val) - Complexity = 3
                  // Dst: (RETURN_v4f32 V128:{ *:[v4f32] }:$val)
/* 54154*/      /*Scope*/ 11, /*->54166*/
/* 54155*/        OPC_CheckChild1Type, MVT::v2f64,
/* 54157*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54159*/        OPC_EmitMergeInputChains1_0,
/* 54160*/        OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_v2f64), 0|OPFL_Chain,
                      1/*#Ops*/, 1, 
                  // Src: (WebAssemblyreturn V128:{ *:[v2f64] }:$val) - Complexity = 3
                  // Dst: (RETURN_v2f64 V128:{ *:[v2f64] }:$val)
/* 54166*/      0, /*End of Scope*/
/* 54167*/    /*Scope*/ 6, /*->54174*/
/* 54168*/      OPC_EmitMergeInputChains1_0,
/* 54169*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN_VOID), 0|OPFL_Chain,
                    0/*#Ops*/, 
                // Src: (WebAssemblyreturn) - Complexity = 3
                // Dst: (RETURN_VOID)
/* 54174*/    0, /*End of Scope*/
/* 54175*/  /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRAP),// ->54185
/* 54178*/    OPC_RecordNode, // #0 = 'trap' chained node
/* 54179*/    OPC_EmitMergeInputChains1_0,
/* 54180*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::UNREACHABLE), 0|OPFL_Chain,
                  0/*#Ops*/, 
              // Src: (trap) - Complexity = 3
              // Dst: (UNREACHABLE)
/* 54185*/  /*SwitchOpcode*/ 9, TARGET_VAL(ISD::CLEANUPRET),// ->54197
/* 54188*/    OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 54189*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasExceptionHandling())
/* 54191*/    OPC_EmitMergeInputChains1_0,
/* 54192*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CLEANUPRET), 0|OPFL_Chain,
                  0/*#Ops*/, 
              // Src: (cleanupret) - Complexity = 3
              // Dst: (CLEANUPRET)
/* 54197*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CATCHRET),// ->54223
/* 54200*/    OPC_RecordNode, // #0 = 'catchret' chained node
/* 54201*/    OPC_RecordChild1, // #1 = $dst
/* 54202*/    OPC_MoveChild1,
/* 54203*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 54206*/    OPC_MoveParent,
/* 54207*/    OPC_RecordChild2, // #2 = $from
/* 54208*/    OPC_MoveChild2,
/* 54209*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 54212*/    OPC_MoveParent,
/* 54213*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasExceptionHandling())
/* 54215*/    OPC_EmitMergeInputChains1_0,
/* 54216*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CATCHRET), 0|OPFL_Chain,
                  2/*#Ops*/, 1, 2, 
              // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
              // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 54223*/  /*SwitchOpcode*/ 72, TARGET_VAL(ISD::ADD),// ->54298
/* 54226*/    OPC_RecordChild0, // #0 = $lhs
/* 54227*/    OPC_RecordChild1, // #1 = $rhs
/* 54228*/    OPC_SwitchType /*6 cases */, 8, MVT::i32,// ->54239
/* 54231*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54239*/    /*SwitchType*/ 8, MVT::i64,// ->54249
/* 54241*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I64), 0,
                    MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54249*/    /*SwitchType*/ 10, MVT::v16i8,// ->54261
/* 54251*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54253*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_v16i8), 0,
                    MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                // Dst: (ADD_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 54261*/    /*SwitchType*/ 10, MVT::v8i16,// ->54273
/* 54263*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54265*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_v8i16), 0,
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                // Dst: (ADD_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 54273*/    /*SwitchType*/ 10, MVT::v4i32,// ->54285
/* 54275*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54277*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_v4i32), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
                // Dst: (ADD_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 54285*/    /*SwitchType*/ 10, MVT::v2i64,// ->54297
/* 54287*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54289*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_v2i64), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
                // Dst: (ADD_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 54297*/    0, // EndSwitchType
/* 54298*/  /*SwitchOpcode*/ 7|128,1/*135*/, TARGET_VAL(ISD::SUB),// ->54437
/* 54302*/    OPC_Scope, 24, /*->54328*/ // 3 children in Scope
/* 54304*/      OPC_RecordChild0, // #0 = $lhs
/* 54305*/      OPC_RecordChild1, // #1 = $rhs
/* 54306*/      OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->54317
/* 54309*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54317*/      /*SwitchType*/ 8, MVT::i64,// ->54327
/* 54319*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54327*/      0, // EndSwitchType
/* 54328*/    /*Scope*/ 54, /*->54383*/
/* 54329*/      OPC_MoveChild0,
/* 54330*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54333*/      OPC_CheckPredicate, 25, // Predicate_immAllZerosV
/* 54335*/      OPC_MoveParent,
/* 54336*/      OPC_RecordChild1, // #0 = $vec
/* 54337*/      OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->54349
/* 54340*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54342*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_v16i8), 0,
                      MVT::v16i8, 1/*#Ops*/, 0, 
                  // Src: (sub:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllZerosV>>, V128:{ *:[v16i8] }:$vec) - Complexity = 7
                  // Dst: (NEG_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec)
/* 54349*/      /*SwitchType*/ 9, MVT::v8i16,// ->54360
/* 54351*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54353*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_v8i16), 0,
                      MVT::v8i16, 1/*#Ops*/, 0, 
                  // Src: (sub:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllZerosV>>, V128:{ *:[v8i16] }:$vec) - Complexity = 7
                  // Dst: (NEG_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec)
/* 54360*/      /*SwitchType*/ 9, MVT::v4i32,// ->54371
/* 54362*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54364*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_v4i32), 0,
                      MVT::v4i32, 1/*#Ops*/, 0, 
                  // Src: (sub:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllZerosV>>, V128:{ *:[v4i32] }:$vec) - Complexity = 7
                  // Dst: (NEG_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec)
/* 54371*/      /*SwitchType*/ 9, MVT::v2i64,// ->54382
/* 54373*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54375*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_v2i64), 0,
                      MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (sub:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllZerosV>>, V128:{ *:[v2i64] }:$vec) - Complexity = 7
                  // Dst: (NEG_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec)
/* 54382*/      0, // EndSwitchType
/* 54383*/    /*Scope*/ 52, /*->54436*/
/* 54384*/      OPC_RecordChild0, // #0 = $lhs
/* 54385*/      OPC_RecordChild1, // #1 = $rhs
/* 54386*/      OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->54399
/* 54389*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54391*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                  // Dst: (SUB_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 54399*/      /*SwitchType*/ 10, MVT::v8i16,// ->54411
/* 54401*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54403*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                  // Dst: (SUB_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 54411*/      /*SwitchType*/ 10, MVT::v4i32,// ->54423
/* 54413*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54415*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
                  // Dst: (SUB_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 54423*/      /*SwitchType*/ 10, MVT::v2i64,// ->54435
/* 54425*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54427*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
                  // Dst: (SUB_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 54435*/      0, // EndSwitchType
/* 54436*/    0, /*End of Scope*/
/* 54437*/  /*SwitchOpcode*/ 60, TARGET_VAL(ISD::MUL),// ->54500
/* 54440*/    OPC_RecordChild0, // #0 = $lhs
/* 54441*/    OPC_RecordChild1, // #1 = $rhs
/* 54442*/    OPC_SwitchType /*5 cases */, 8, MVT::i32,// ->54453
/* 54445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54453*/    /*SwitchType*/ 8, MVT::i64,// ->54463
/* 54455*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I64), 0,
                    MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54463*/    /*SwitchType*/ 10, MVT::v16i8,// ->54475
/* 54465*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54467*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_v16i8), 0,
                    MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                // Dst: (MUL_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 54475*/    /*SwitchType*/ 10, MVT::v8i16,// ->54487
/* 54477*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54479*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_v8i16), 0,
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                // Dst: (MUL_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 54487*/    /*SwitchType*/ 10, MVT::v4i32,// ->54499
/* 54489*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 54491*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_v4i32), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
                // Dst: (MUL_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 54499*/    0, // EndSwitchType
/* 54500*/  /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SDIV),// ->54527
/* 54503*/    OPC_RecordChild0, // #0 = $lhs
/* 54504*/    OPC_RecordChild1, // #1 = $rhs
/* 54505*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->54516
/* 54508*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54516*/    /*SwitchType*/ 8, MVT::i64,// ->54526
/* 54518*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I64), 0,
                    MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54526*/    0, // EndSwitchType
/* 54527*/  /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UDIV),// ->54554
/* 54530*/    OPC_RecordChild0, // #0 = $lhs
/* 54531*/    OPC_RecordChild1, // #1 = $rhs
/* 54532*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->54543
/* 54535*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54543*/    /*SwitchType*/ 8, MVT::i64,// ->54553
/* 54545*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I64), 0,
                    MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54553*/    0, // EndSwitchType
/* 54554*/  /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SREM),// ->54581
/* 54557*/    OPC_RecordChild0, // #0 = $lhs
/* 54558*/    OPC_RecordChild1, // #1 = $rhs
/* 54559*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->54570
/* 54562*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54570*/    /*SwitchType*/ 8, MVT::i64,// ->54580
/* 54572*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I64), 0,
                    MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54580*/    0, // EndSwitchType
/* 54581*/  /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UREM),// ->54608
/* 54584*/    OPC_RecordChild0, // #0 = $lhs
/* 54585*/    OPC_RecordChild1, // #1 = $rhs
/* 54586*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->54597
/* 54589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54597*/    /*SwitchType*/ 8, MVT::i64,// ->54607
/* 54599*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I64), 0,
                    MVT::i64, 2/*#Ops*/, 0, 1, 
                // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54607*/    0, // EndSwitchType
/* 54608*/  /*SwitchOpcode*/ 27|128,14/*1819*/, TARGET_VAL(ISD::OR),// ->56431
/* 54612*/    OPC_Scope, 24, /*->54638*/ // 3 children in Scope
/* 54614*/      OPC_RecordChild0, // #0 = $lhs
/* 54615*/      OPC_RecordChild1, // #1 = $rhs
/* 54616*/      OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->54627
/* 54619*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 54627*/      /*SwitchType*/ 8, MVT::i64,// ->54637
/* 54629*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 54637*/      0, // EndSwitchType
/* 54638*/    /*Scope*/ 73|128,13/*1737*/, /*->56377*/
/* 54640*/      OPC_MoveChild0,
/* 54641*/      OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 54644*/      OPC_Scope, 6|128,2/*262*/, /*->54909*/ // 9 children in Scope
/* 54647*/        OPC_RecordChild0, // #0 = $c
/* 54648*/        OPC_RecordChild1, // #1 = $v1
/* 54649*/        OPC_MoveParent,
/* 54650*/        OPC_MoveChild1,
/* 54651*/        OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 54654*/        OPC_Scope, 89, /*->54745*/ // 4 children in Scope
/* 54656*/          OPC_MoveChild0,
/* 54657*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 54660*/          OPC_Scope, 58, /*->54720*/ // 2 children in Scope
/* 54662*/            OPC_CheckChild0Same, 0,
/* 54664*/            OPC_MoveChild1,
/* 54665*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54668*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54670*/            OPC_MoveParent,
/* 54671*/            OPC_MoveParent,
/* 54672*/            OPC_RecordChild1, // #2 = $v2
/* 54673*/            OPC_MoveParent,
/* 54674*/            OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->54686
/* 54677*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                            MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54686*/            /*SwitchType*/ 9, MVT::v8i16,// ->54697
/* 54688*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 54697*/            /*SwitchType*/ 9, MVT::v4i32,// ->54708
/* 54699*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 54708*/            /*SwitchType*/ 9, MVT::v2i64,// ->54719
/* 54710*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                            MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 54719*/            0, // EndSwitchType
/* 54720*/          /*Scope*/ 23, /*->54744*/
/* 54721*/            OPC_MoveChild0,
/* 54722*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54725*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54727*/            OPC_MoveParent,
/* 54728*/            OPC_CheckChild1Same, 0,
/* 54730*/            OPC_MoveParent,
/* 54731*/            OPC_RecordChild1, // #2 = $v2
/* 54732*/            OPC_MoveParent,
/* 54733*/            OPC_CheckType, MVT::v16i8,
/* 54735*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54744*/          0, /*End of Scope*/
/* 54745*/        /*Scope*/ 53, /*->54799*/
/* 54746*/          OPC_RecordChild0, // #2 = $v2
/* 54747*/          OPC_MoveChild1,
/* 54748*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 54751*/          OPC_Scope, 22, /*->54775*/ // 2 children in Scope
/* 54753*/            OPC_CheckChild0Same, 0,
/* 54755*/            OPC_MoveChild1,
/* 54756*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54759*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54761*/            OPC_MoveParent,
/* 54762*/            OPC_MoveParent,
/* 54763*/            OPC_MoveParent,
/* 54764*/            OPC_CheckType, MVT::v16i8,
/* 54766*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54775*/          /*Scope*/ 22, /*->54798*/
/* 54776*/            OPC_MoveChild0,
/* 54777*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54780*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54782*/            OPC_MoveParent,
/* 54783*/            OPC_CheckChild1Same, 0,
/* 54785*/            OPC_MoveParent,
/* 54786*/            OPC_MoveParent,
/* 54787*/            OPC_CheckType, MVT::v16i8,
/* 54789*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c))) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54798*/          0, /*End of Scope*/
/* 54799*/        /*Scope*/ 54, /*->54854*/
/* 54800*/          OPC_MoveChild0,
/* 54801*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 54804*/          OPC_Scope, 23, /*->54829*/ // 2 children in Scope
/* 54806*/            OPC_CheckChild0Same, 1,
/* 54808*/            OPC_MoveChild1,
/* 54809*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54812*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54814*/            OPC_MoveParent,
/* 54815*/            OPC_MoveParent,
/* 54816*/            OPC_RecordChild1, // #2 = $v2
/* 54817*/            OPC_MoveParent,
/* 54818*/            OPC_CheckType, MVT::v16i8,
/* 54820*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54829*/          /*Scope*/ 23, /*->54853*/
/* 54830*/            OPC_MoveChild0,
/* 54831*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54834*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54836*/            OPC_MoveParent,
/* 54837*/            OPC_CheckChild1Same, 1,
/* 54839*/            OPC_MoveParent,
/* 54840*/            OPC_RecordChild1, // #2 = $v2
/* 54841*/            OPC_MoveParent,
/* 54842*/            OPC_CheckType, MVT::v16i8,
/* 54844*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54853*/          0, /*End of Scope*/
/* 54854*/        /*Scope*/ 53, /*->54908*/
/* 54855*/          OPC_RecordChild0, // #2 = $v2
/* 54856*/          OPC_MoveChild1,
/* 54857*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 54860*/          OPC_Scope, 22, /*->54884*/ // 2 children in Scope
/* 54862*/            OPC_CheckChild0Same, 1,
/* 54864*/            OPC_MoveChild1,
/* 54865*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54868*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54870*/            OPC_MoveParent,
/* 54871*/            OPC_MoveParent,
/* 54872*/            OPC_MoveParent,
/* 54873*/            OPC_CheckType, MVT::v16i8,
/* 54875*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54884*/          /*Scope*/ 22, /*->54907*/
/* 54885*/            OPC_MoveChild0,
/* 54886*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54889*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54891*/            OPC_MoveParent,
/* 54892*/            OPC_CheckChild1Same, 1,
/* 54894*/            OPC_MoveParent,
/* 54895*/            OPC_MoveParent,
/* 54896*/            OPC_CheckType, MVT::v16i8,
/* 54898*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c))) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54907*/          0, /*End of Scope*/
/* 54908*/        0, /*End of Scope*/
/* 54909*/      /*Scope*/ 106, /*->55016*/
/* 54910*/        OPC_MoveChild0,
/* 54911*/        OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 54914*/        OPC_Scope, 49, /*->54965*/ // 2 children in Scope
/* 54916*/          OPC_RecordChild0, // #0 = $c
/* 54917*/          OPC_MoveChild1,
/* 54918*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54921*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54923*/          OPC_MoveParent,
/* 54924*/          OPC_MoveParent,
/* 54925*/          OPC_RecordChild1, // #1 = $v2
/* 54926*/          OPC_MoveParent,
/* 54927*/          OPC_MoveChild1,
/* 54928*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 54931*/          OPC_Scope, 15, /*->54948*/ // 2 children in Scope
/* 54933*/            OPC_CheckChild0Same, 0,
/* 54935*/            OPC_RecordChild1, // #2 = $v1
/* 54936*/            OPC_MoveParent,
/* 54937*/            OPC_CheckType, MVT::v16i8,
/* 54939*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54948*/          /*Scope*/ 15, /*->54964*/
/* 54949*/            OPC_RecordChild0, // #2 = $v1
/* 54950*/            OPC_CheckChild1Same, 0,
/* 54952*/            OPC_MoveParent,
/* 54953*/            OPC_CheckType, MVT::v16i8,
/* 54955*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54964*/          0, /*End of Scope*/
/* 54965*/        /*Scope*/ 49, /*->55015*/
/* 54966*/          OPC_MoveChild0,
/* 54967*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 54970*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 54972*/          OPC_MoveParent,
/* 54973*/          OPC_RecordChild1, // #0 = $c
/* 54974*/          OPC_MoveParent,
/* 54975*/          OPC_RecordChild1, // #1 = $v2
/* 54976*/          OPC_MoveParent,
/* 54977*/          OPC_MoveChild1,
/* 54978*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 54981*/          OPC_Scope, 15, /*->54998*/ // 2 children in Scope
/* 54983*/            OPC_CheckChild0Same, 0,
/* 54985*/            OPC_RecordChild1, // #2 = $v1
/* 54986*/            OPC_MoveParent,
/* 54987*/            OPC_CheckType, MVT::v16i8,
/* 54989*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 54998*/          /*Scope*/ 15, /*->55014*/
/* 54999*/            OPC_RecordChild0, // #2 = $v1
/* 55000*/            OPC_CheckChild1Same, 0,
/* 55002*/            OPC_MoveParent,
/* 55003*/            OPC_CheckType, MVT::v16i8,
/* 55005*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                          MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 55014*/          0, /*End of Scope*/
/* 55015*/        0, /*End of Scope*/
/* 55016*/      /*Scope*/ 53|128,2/*309*/, /*->55327*/
/* 55018*/        OPC_RecordChild0, // #0 = $v2
/* 55019*/        OPC_Scope, 104, /*->55125*/ // 2 children in Scope
/* 55021*/          OPC_MoveChild1,
/* 55022*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55025*/          OPC_Scope, 48, /*->55075*/ // 2 children in Scope
/* 55027*/            OPC_RecordChild0, // #1 = $c
/* 55028*/            OPC_MoveChild1,
/* 55029*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55032*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55034*/            OPC_MoveParent,
/* 55035*/            OPC_MoveParent,
/* 55036*/            OPC_MoveParent,
/* 55037*/            OPC_MoveChild1,
/* 55038*/            OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55041*/            OPC_Scope, 15, /*->55058*/ // 2 children in Scope
/* 55043*/              OPC_CheckChild0Same, 1,
/* 55045*/              OPC_RecordChild1, // #2 = $v1
/* 55046*/              OPC_MoveParent,
/* 55047*/              OPC_CheckType, MVT::v16i8,
/* 55049*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                            MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                        // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 55058*/            /*Scope*/ 15, /*->55074*/
/* 55059*/              OPC_RecordChild0, // #2 = $v1
/* 55060*/              OPC_CheckChild1Same, 1,
/* 55062*/              OPC_MoveParent,
/* 55063*/              OPC_CheckType, MVT::v16i8,
/* 55065*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                            MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                        // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 55074*/            0, /*End of Scope*/
/* 55075*/          /*Scope*/ 48, /*->55124*/
/* 55076*/            OPC_MoveChild0,
/* 55077*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55080*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55082*/            OPC_MoveParent,
/* 55083*/            OPC_RecordChild1, // #1 = $c
/* 55084*/            OPC_MoveParent,
/* 55085*/            OPC_MoveParent,
/* 55086*/            OPC_MoveChild1,
/* 55087*/            OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55090*/            OPC_Scope, 15, /*->55107*/ // 2 children in Scope
/* 55092*/              OPC_CheckChild0Same, 1,
/* 55094*/              OPC_RecordChild1, // #2 = $v1
/* 55095*/              OPC_MoveParent,
/* 55096*/              OPC_CheckType, MVT::v16i8,
/* 55098*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                            MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c)), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                        // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 55107*/            /*Scope*/ 15, /*->55123*/
/* 55108*/              OPC_RecordChild0, // #2 = $v1
/* 55109*/              OPC_CheckChild1Same, 1,
/* 55111*/              OPC_MoveParent,
/* 55112*/              OPC_CheckType, MVT::v16i8,
/* 55114*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v16i8), 0,
                            MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$c)), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                        // Dst: (BITSELECT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c)
/* 55123*/            0, /*End of Scope*/
/* 55124*/          0, /*End of Scope*/
/* 55125*/        /*Scope*/ 71|128,1/*199*/, /*->55326*/
/* 55127*/          OPC_RecordChild1, // #1 = $v1
/* 55128*/          OPC_MoveParent,
/* 55129*/          OPC_MoveChild1,
/* 55130*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55133*/          OPC_Scope, 27, /*->55162*/ // 4 children in Scope
/* 55135*/            OPC_MoveChild0,
/* 55136*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55139*/            OPC_MoveChild0,
/* 55140*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55143*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55145*/            OPC_MoveParent,
/* 55146*/            OPC_CheckChild1Same, 0,
/* 55148*/            OPC_MoveParent,
/* 55149*/            OPC_RecordChild1, // #2 = $v2
/* 55150*/            OPC_MoveParent,
/* 55151*/            OPC_CheckType, MVT::v8i16,
/* 55153*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                          MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                      // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55162*/          /*Scope*/ 53, /*->55216*/
/* 55163*/            OPC_RecordChild0, // #2 = $v2
/* 55164*/            OPC_MoveChild1,
/* 55165*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55168*/            OPC_Scope, 22, /*->55192*/ // 2 children in Scope
/* 55170*/              OPC_CheckChild0Same, 0,
/* 55172*/              OPC_MoveChild1,
/* 55173*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55176*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55178*/              OPC_MoveParent,
/* 55179*/              OPC_MoveParent,
/* 55180*/              OPC_MoveParent,
/* 55181*/              OPC_CheckType, MVT::v8i16,
/* 55183*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55192*/            /*Scope*/ 22, /*->55215*/
/* 55193*/              OPC_MoveChild0,
/* 55194*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55197*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55199*/              OPC_MoveParent,
/* 55200*/              OPC_CheckChild1Same, 0,
/* 55202*/              OPC_MoveParent,
/* 55203*/              OPC_MoveParent,
/* 55204*/              OPC_CheckType, MVT::v8i16,
/* 55206*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c))) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55215*/            0, /*End of Scope*/
/* 55216*/          /*Scope*/ 54, /*->55271*/
/* 55217*/            OPC_MoveChild0,
/* 55218*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55221*/            OPC_Scope, 23, /*->55246*/ // 2 children in Scope
/* 55223*/              OPC_CheckChild0Same, 1,
/* 55225*/              OPC_MoveChild1,
/* 55226*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55229*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55231*/              OPC_MoveParent,
/* 55232*/              OPC_MoveParent,
/* 55233*/              OPC_RecordChild1, // #2 = $v2
/* 55234*/              OPC_MoveParent,
/* 55235*/              OPC_CheckType, MVT::v8i16,
/* 55237*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55246*/            /*Scope*/ 23, /*->55270*/
/* 55247*/              OPC_MoveChild0,
/* 55248*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55251*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55253*/              OPC_MoveParent,
/* 55254*/              OPC_CheckChild1Same, 1,
/* 55256*/              OPC_MoveParent,
/* 55257*/              OPC_RecordChild1, // #2 = $v2
/* 55258*/              OPC_MoveParent,
/* 55259*/              OPC_CheckType, MVT::v8i16,
/* 55261*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55270*/            0, /*End of Scope*/
/* 55271*/          /*Scope*/ 53, /*->55325*/
/* 55272*/            OPC_RecordChild0, // #2 = $v2
/* 55273*/            OPC_MoveChild1,
/* 55274*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55277*/            OPC_Scope, 22, /*->55301*/ // 2 children in Scope
/* 55279*/              OPC_CheckChild0Same, 1,
/* 55281*/              OPC_MoveChild1,
/* 55282*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55285*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55287*/              OPC_MoveParent,
/* 55288*/              OPC_MoveParent,
/* 55289*/              OPC_MoveParent,
/* 55290*/              OPC_CheckType, MVT::v8i16,
/* 55292*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55301*/            /*Scope*/ 22, /*->55324*/
/* 55302*/              OPC_MoveChild0,
/* 55303*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55306*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55308*/              OPC_MoveParent,
/* 55309*/              OPC_CheckChild1Same, 1,
/* 55311*/              OPC_MoveParent,
/* 55312*/              OPC_MoveParent,
/* 55313*/              OPC_CheckType, MVT::v8i16,
/* 55315*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c))) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55324*/            0, /*End of Scope*/
/* 55325*/          0, /*End of Scope*/
/* 55326*/        0, /*End of Scope*/
/* 55327*/      /*Scope*/ 106, /*->55434*/
/* 55328*/        OPC_MoveChild0,
/* 55329*/        OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55332*/        OPC_Scope, 49, /*->55383*/ // 2 children in Scope
/* 55334*/          OPC_RecordChild0, // #0 = $c
/* 55335*/          OPC_MoveChild1,
/* 55336*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55339*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55341*/          OPC_MoveParent,
/* 55342*/          OPC_MoveParent,
/* 55343*/          OPC_RecordChild1, // #1 = $v2
/* 55344*/          OPC_MoveParent,
/* 55345*/          OPC_MoveChild1,
/* 55346*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55349*/          OPC_Scope, 15, /*->55366*/ // 2 children in Scope
/* 55351*/            OPC_CheckChild0Same, 0,
/* 55353*/            OPC_RecordChild1, // #2 = $v1
/* 55354*/            OPC_MoveParent,
/* 55355*/            OPC_CheckType, MVT::v8i16,
/* 55357*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                          MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55366*/          /*Scope*/ 15, /*->55382*/
/* 55367*/            OPC_RecordChild0, // #2 = $v1
/* 55368*/            OPC_CheckChild1Same, 0,
/* 55370*/            OPC_MoveParent,
/* 55371*/            OPC_CheckType, MVT::v8i16,
/* 55373*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                          MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55382*/          0, /*End of Scope*/
/* 55383*/        /*Scope*/ 49, /*->55433*/
/* 55384*/          OPC_MoveChild0,
/* 55385*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55388*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55390*/          OPC_MoveParent,
/* 55391*/          OPC_RecordChild1, // #0 = $c
/* 55392*/          OPC_MoveParent,
/* 55393*/          OPC_RecordChild1, // #1 = $v2
/* 55394*/          OPC_MoveParent,
/* 55395*/          OPC_MoveChild1,
/* 55396*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55399*/          OPC_Scope, 15, /*->55416*/ // 2 children in Scope
/* 55401*/            OPC_CheckChild0Same, 0,
/* 55403*/            OPC_RecordChild1, // #2 = $v1
/* 55404*/            OPC_MoveParent,
/* 55405*/            OPC_CheckType, MVT::v8i16,
/* 55407*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                          MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55416*/          /*Scope*/ 15, /*->55432*/
/* 55417*/            OPC_RecordChild0, // #2 = $v1
/* 55418*/            OPC_CheckChild1Same, 0,
/* 55420*/            OPC_MoveParent,
/* 55421*/            OPC_CheckType, MVT::v8i16,
/* 55423*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                          MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55432*/          0, /*End of Scope*/
/* 55433*/        0, /*End of Scope*/
/* 55434*/      /*Scope*/ 53|128,2/*309*/, /*->55745*/
/* 55436*/        OPC_RecordChild0, // #0 = $v2
/* 55437*/        OPC_Scope, 104, /*->55543*/ // 2 children in Scope
/* 55439*/          OPC_MoveChild1,
/* 55440*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55443*/          OPC_Scope, 48, /*->55493*/ // 2 children in Scope
/* 55445*/            OPC_RecordChild0, // #1 = $c
/* 55446*/            OPC_MoveChild1,
/* 55447*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55450*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55452*/            OPC_MoveParent,
/* 55453*/            OPC_MoveParent,
/* 55454*/            OPC_MoveParent,
/* 55455*/            OPC_MoveChild1,
/* 55456*/            OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55459*/            OPC_Scope, 15, /*->55476*/ // 2 children in Scope
/* 55461*/              OPC_CheckChild0Same, 1,
/* 55463*/              OPC_RecordChild1, // #2 = $v1
/* 55464*/              OPC_MoveParent,
/* 55465*/              OPC_CheckType, MVT::v8i16,
/* 55467*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55476*/            /*Scope*/ 15, /*->55492*/
/* 55477*/              OPC_RecordChild0, // #2 = $v1
/* 55478*/              OPC_CheckChild1Same, 1,
/* 55480*/              OPC_MoveParent,
/* 55481*/              OPC_CheckType, MVT::v8i16,
/* 55483*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55492*/            0, /*End of Scope*/
/* 55493*/          /*Scope*/ 48, /*->55542*/
/* 55494*/            OPC_MoveChild0,
/* 55495*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55498*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55500*/            OPC_MoveParent,
/* 55501*/            OPC_RecordChild1, // #1 = $c
/* 55502*/            OPC_MoveParent,
/* 55503*/            OPC_MoveParent,
/* 55504*/            OPC_MoveChild1,
/* 55505*/            OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55508*/            OPC_Scope, 15, /*->55525*/ // 2 children in Scope
/* 55510*/              OPC_CheckChild0Same, 1,
/* 55512*/              OPC_RecordChild1, // #2 = $v1
/* 55513*/              OPC_MoveParent,
/* 55514*/              OPC_CheckType, MVT::v8i16,
/* 55516*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c)), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55525*/            /*Scope*/ 15, /*->55541*/
/* 55526*/              OPC_RecordChild0, // #2 = $v1
/* 55527*/              OPC_CheckChild1Same, 1,
/* 55529*/              OPC_MoveParent,
/* 55530*/              OPC_CheckType, MVT::v8i16,
/* 55532*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v8i16), 0,
                            MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$c)), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                        // Dst: (BITSELECT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c)
/* 55541*/            0, /*End of Scope*/
/* 55542*/          0, /*End of Scope*/
/* 55543*/        /*Scope*/ 71|128,1/*199*/, /*->55744*/
/* 55545*/          OPC_RecordChild1, // #1 = $v1
/* 55546*/          OPC_MoveParent,
/* 55547*/          OPC_MoveChild1,
/* 55548*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55551*/          OPC_Scope, 27, /*->55580*/ // 4 children in Scope
/* 55553*/            OPC_MoveChild0,
/* 55554*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55557*/            OPC_MoveChild0,
/* 55558*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55561*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55563*/            OPC_MoveParent,
/* 55564*/            OPC_CheckChild1Same, 0,
/* 55566*/            OPC_MoveParent,
/* 55567*/            OPC_RecordChild1, // #2 = $v2
/* 55568*/            OPC_MoveParent,
/* 55569*/            OPC_CheckType, MVT::v4i32,
/* 55571*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                          MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                      // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55580*/          /*Scope*/ 53, /*->55634*/
/* 55581*/            OPC_RecordChild0, // #2 = $v2
/* 55582*/            OPC_MoveChild1,
/* 55583*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55586*/            OPC_Scope, 22, /*->55610*/ // 2 children in Scope
/* 55588*/              OPC_CheckChild0Same, 0,
/* 55590*/              OPC_MoveChild1,
/* 55591*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55594*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55596*/              OPC_MoveParent,
/* 55597*/              OPC_MoveParent,
/* 55598*/              OPC_MoveParent,
/* 55599*/              OPC_CheckType, MVT::v4i32,
/* 55601*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55610*/            /*Scope*/ 22, /*->55633*/
/* 55611*/              OPC_MoveChild0,
/* 55612*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55615*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55617*/              OPC_MoveParent,
/* 55618*/              OPC_CheckChild1Same, 0,
/* 55620*/              OPC_MoveParent,
/* 55621*/              OPC_MoveParent,
/* 55622*/              OPC_CheckType, MVT::v4i32,
/* 55624*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c))) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55633*/            0, /*End of Scope*/
/* 55634*/          /*Scope*/ 54, /*->55689*/
/* 55635*/            OPC_MoveChild0,
/* 55636*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55639*/            OPC_Scope, 23, /*->55664*/ // 2 children in Scope
/* 55641*/              OPC_CheckChild0Same, 1,
/* 55643*/              OPC_MoveChild1,
/* 55644*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55647*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55649*/              OPC_MoveParent,
/* 55650*/              OPC_MoveParent,
/* 55651*/              OPC_RecordChild1, // #2 = $v2
/* 55652*/              OPC_MoveParent,
/* 55653*/              OPC_CheckType, MVT::v4i32,
/* 55655*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55664*/            /*Scope*/ 23, /*->55688*/
/* 55665*/              OPC_MoveChild0,
/* 55666*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55669*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55671*/              OPC_MoveParent,
/* 55672*/              OPC_CheckChild1Same, 1,
/* 55674*/              OPC_MoveParent,
/* 55675*/              OPC_RecordChild1, // #2 = $v2
/* 55676*/              OPC_MoveParent,
/* 55677*/              OPC_CheckType, MVT::v4i32,
/* 55679*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55688*/            0, /*End of Scope*/
/* 55689*/          /*Scope*/ 53, /*->55743*/
/* 55690*/            OPC_RecordChild0, // #2 = $v2
/* 55691*/            OPC_MoveChild1,
/* 55692*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55695*/            OPC_Scope, 22, /*->55719*/ // 2 children in Scope
/* 55697*/              OPC_CheckChild0Same, 1,
/* 55699*/              OPC_MoveChild1,
/* 55700*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55703*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55705*/              OPC_MoveParent,
/* 55706*/              OPC_MoveParent,
/* 55707*/              OPC_MoveParent,
/* 55708*/              OPC_CheckType, MVT::v4i32,
/* 55710*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55719*/            /*Scope*/ 22, /*->55742*/
/* 55720*/              OPC_MoveChild0,
/* 55721*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55724*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55726*/              OPC_MoveParent,
/* 55727*/              OPC_CheckChild1Same, 1,
/* 55729*/              OPC_MoveParent,
/* 55730*/              OPC_MoveParent,
/* 55731*/              OPC_CheckType, MVT::v4i32,
/* 55733*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c))) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55742*/            0, /*End of Scope*/
/* 55743*/          0, /*End of Scope*/
/* 55744*/        0, /*End of Scope*/
/* 55745*/      /*Scope*/ 106, /*->55852*/
/* 55746*/        OPC_MoveChild0,
/* 55747*/        OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55750*/        OPC_Scope, 49, /*->55801*/ // 2 children in Scope
/* 55752*/          OPC_RecordChild0, // #0 = $c
/* 55753*/          OPC_MoveChild1,
/* 55754*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55757*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55759*/          OPC_MoveParent,
/* 55760*/          OPC_MoveParent,
/* 55761*/          OPC_RecordChild1, // #1 = $v2
/* 55762*/          OPC_MoveParent,
/* 55763*/          OPC_MoveChild1,
/* 55764*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55767*/          OPC_Scope, 15, /*->55784*/ // 2 children in Scope
/* 55769*/            OPC_CheckChild0Same, 0,
/* 55771*/            OPC_RecordChild1, // #2 = $v1
/* 55772*/            OPC_MoveParent,
/* 55773*/            OPC_CheckType, MVT::v4i32,
/* 55775*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                          MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55784*/          /*Scope*/ 15, /*->55800*/
/* 55785*/            OPC_RecordChild0, // #2 = $v1
/* 55786*/            OPC_CheckChild1Same, 0,
/* 55788*/            OPC_MoveParent,
/* 55789*/            OPC_CheckType, MVT::v4i32,
/* 55791*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                          MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55800*/          0, /*End of Scope*/
/* 55801*/        /*Scope*/ 49, /*->55851*/
/* 55802*/          OPC_MoveChild0,
/* 55803*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55806*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55808*/          OPC_MoveParent,
/* 55809*/          OPC_RecordChild1, // #0 = $c
/* 55810*/          OPC_MoveParent,
/* 55811*/          OPC_RecordChild1, // #1 = $v2
/* 55812*/          OPC_MoveParent,
/* 55813*/          OPC_MoveChild1,
/* 55814*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55817*/          OPC_Scope, 15, /*->55834*/ // 2 children in Scope
/* 55819*/            OPC_CheckChild0Same, 0,
/* 55821*/            OPC_RecordChild1, // #2 = $v1
/* 55822*/            OPC_MoveParent,
/* 55823*/            OPC_CheckType, MVT::v4i32,
/* 55825*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                          MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55834*/          /*Scope*/ 15, /*->55850*/
/* 55835*/            OPC_RecordChild0, // #2 = $v1
/* 55836*/            OPC_CheckChild1Same, 0,
/* 55838*/            OPC_MoveParent,
/* 55839*/            OPC_CheckType, MVT::v4i32,
/* 55841*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                          MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55850*/          0, /*End of Scope*/
/* 55851*/        0, /*End of Scope*/
/* 55852*/      /*Scope*/ 53|128,2/*309*/, /*->56163*/
/* 55854*/        OPC_RecordChild0, // #0 = $v2
/* 55855*/        OPC_Scope, 104, /*->55961*/ // 2 children in Scope
/* 55857*/          OPC_MoveChild1,
/* 55858*/          OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55861*/          OPC_Scope, 48, /*->55911*/ // 2 children in Scope
/* 55863*/            OPC_RecordChild0, // #1 = $c
/* 55864*/            OPC_MoveChild1,
/* 55865*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55868*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55870*/            OPC_MoveParent,
/* 55871*/            OPC_MoveParent,
/* 55872*/            OPC_MoveParent,
/* 55873*/            OPC_MoveChild1,
/* 55874*/            OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55877*/            OPC_Scope, 15, /*->55894*/ // 2 children in Scope
/* 55879*/              OPC_CheckChild0Same, 1,
/* 55881*/              OPC_RecordChild1, // #2 = $v1
/* 55882*/              OPC_MoveParent,
/* 55883*/              OPC_CheckType, MVT::v4i32,
/* 55885*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55894*/            /*Scope*/ 15, /*->55910*/
/* 55895*/              OPC_RecordChild0, // #2 = $v1
/* 55896*/              OPC_CheckChild1Same, 1,
/* 55898*/              OPC_MoveParent,
/* 55899*/              OPC_CheckType, MVT::v4i32,
/* 55901*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55910*/            0, /*End of Scope*/
/* 55911*/          /*Scope*/ 48, /*->55960*/
/* 55912*/            OPC_MoveChild0,
/* 55913*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55916*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55918*/            OPC_MoveParent,
/* 55919*/            OPC_RecordChild1, // #1 = $c
/* 55920*/            OPC_MoveParent,
/* 55921*/            OPC_MoveParent,
/* 55922*/            OPC_MoveChild1,
/* 55923*/            OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55926*/            OPC_Scope, 15, /*->55943*/ // 2 children in Scope
/* 55928*/              OPC_CheckChild0Same, 1,
/* 55930*/              OPC_RecordChild1, // #2 = $v1
/* 55931*/              OPC_MoveParent,
/* 55932*/              OPC_CheckType, MVT::v4i32,
/* 55934*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c)), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55943*/            /*Scope*/ 15, /*->55959*/
/* 55944*/              OPC_RecordChild0, // #2 = $v1
/* 55945*/              OPC_CheckChild1Same, 1,
/* 55947*/              OPC_MoveParent,
/* 55948*/              OPC_CheckType, MVT::v4i32,
/* 55950*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v4i32), 0,
                            MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                        // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$c)), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                        // Dst: (BITSELECT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c)
/* 55959*/            0, /*End of Scope*/
/* 55960*/          0, /*End of Scope*/
/* 55961*/        /*Scope*/ 71|128,1/*199*/, /*->56162*/
/* 55963*/          OPC_RecordChild1, // #1 = $v1
/* 55964*/          OPC_MoveParent,
/* 55965*/          OPC_MoveChild1,
/* 55966*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 55969*/          OPC_Scope, 27, /*->55998*/ // 4 children in Scope
/* 55971*/            OPC_MoveChild0,
/* 55972*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 55975*/            OPC_MoveChild0,
/* 55976*/            OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 55979*/            OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 55981*/            OPC_MoveParent,
/* 55982*/            OPC_CheckChild1Same, 0,
/* 55984*/            OPC_MoveParent,
/* 55985*/            OPC_RecordChild1, // #2 = $v2
/* 55986*/            OPC_MoveParent,
/* 55987*/            OPC_CheckType, MVT::v2i64,
/* 55989*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 55998*/          /*Scope*/ 53, /*->56052*/
/* 55999*/            OPC_RecordChild0, // #2 = $v2
/* 56000*/            OPC_MoveChild1,
/* 56001*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 56004*/            OPC_Scope, 22, /*->56028*/ // 2 children in Scope
/* 56006*/              OPC_CheckChild0Same, 0,
/* 56008*/              OPC_MoveChild1,
/* 56009*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56012*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56014*/              OPC_MoveParent,
/* 56015*/              OPC_MoveParent,
/* 56016*/              OPC_MoveParent,
/* 56017*/              OPC_CheckType, MVT::v2i64,
/* 56019*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                            MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                        // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56028*/            /*Scope*/ 22, /*->56051*/
/* 56029*/              OPC_MoveChild0,
/* 56030*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56033*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56035*/              OPC_MoveParent,
/* 56036*/              OPC_CheckChild1Same, 0,
/* 56038*/              OPC_MoveParent,
/* 56039*/              OPC_MoveParent,
/* 56040*/              OPC_CheckType, MVT::v2i64,
/* 56042*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                            MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                        // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c))) - Complexity = 16
                        // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56051*/            0, /*End of Scope*/
/* 56052*/          /*Scope*/ 54, /*->56107*/
/* 56053*/            OPC_MoveChild0,
/* 56054*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 56057*/            OPC_Scope, 23, /*->56082*/ // 2 children in Scope
/* 56059*/              OPC_CheckChild0Same, 1,
/* 56061*/              OPC_MoveChild1,
/* 56062*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56065*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56067*/              OPC_MoveParent,
/* 56068*/              OPC_MoveParent,
/* 56069*/              OPC_RecordChild1, // #2 = $v2
/* 56070*/              OPC_MoveParent,
/* 56071*/              OPC_CheckType, MVT::v2i64,
/* 56073*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                            MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56082*/            /*Scope*/ 23, /*->56106*/
/* 56083*/              OPC_MoveChild0,
/* 56084*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56087*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56089*/              OPC_MoveParent,
/* 56090*/              OPC_CheckChild1Same, 1,
/* 56092*/              OPC_MoveParent,
/* 56093*/              OPC_RecordChild1, // #2 = $v2
/* 56094*/              OPC_MoveParent,
/* 56095*/              OPC_CheckType, MVT::v2i64,
/* 56097*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                            MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                        // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56106*/            0, /*End of Scope*/
/* 56107*/          /*Scope*/ 53, /*->56161*/
/* 56108*/            OPC_RecordChild0, // #2 = $v2
/* 56109*/            OPC_MoveChild1,
/* 56110*/            OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 56113*/            OPC_Scope, 22, /*->56137*/ // 2 children in Scope
/* 56115*/              OPC_CheckChild0Same, 1,
/* 56117*/              OPC_MoveChild1,
/* 56118*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56121*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56123*/              OPC_MoveParent,
/* 56124*/              OPC_MoveParent,
/* 56125*/              OPC_MoveParent,
/* 56126*/              OPC_CheckType, MVT::v2i64,
/* 56128*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                            MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>))) - Complexity = 16
                        // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56137*/            /*Scope*/ 22, /*->56160*/
/* 56138*/              OPC_MoveChild0,
/* 56139*/              OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56142*/              OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56144*/              OPC_MoveParent,
/* 56145*/              OPC_CheckChild1Same, 1,
/* 56147*/              OPC_MoveParent,
/* 56148*/              OPC_MoveParent,
/* 56149*/              OPC_CheckType, MVT::v2i64,
/* 56151*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                            MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                        // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c))) - Complexity = 16
                        // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56160*/            0, /*End of Scope*/
/* 56161*/          0, /*End of Scope*/
/* 56162*/        0, /*End of Scope*/
/* 56163*/      /*Scope*/ 106, /*->56270*/
/* 56164*/        OPC_MoveChild0,
/* 56165*/        OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 56168*/        OPC_Scope, 49, /*->56219*/ // 2 children in Scope
/* 56170*/          OPC_RecordChild0, // #0 = $c
/* 56171*/          OPC_MoveChild1,
/* 56172*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56175*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56177*/          OPC_MoveParent,
/* 56178*/          OPC_MoveParent,
/* 56179*/          OPC_RecordChild1, // #1 = $v2
/* 56180*/          OPC_MoveParent,
/* 56181*/          OPC_MoveChild1,
/* 56182*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 56185*/          OPC_Scope, 15, /*->56202*/ // 2 children in Scope
/* 56187*/            OPC_CheckChild0Same, 0,
/* 56189*/            OPC_RecordChild1, // #2 = $v1
/* 56190*/            OPC_MoveParent,
/* 56191*/            OPC_CheckType, MVT::v2i64,
/* 56193*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56202*/          /*Scope*/ 15, /*->56218*/
/* 56203*/            OPC_RecordChild0, // #2 = $v1
/* 56204*/            OPC_CheckChild1Same, 0,
/* 56206*/            OPC_MoveParent,
/* 56207*/            OPC_CheckType, MVT::v2i64,
/* 56209*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56218*/          0, /*End of Scope*/
/* 56219*/        /*Scope*/ 49, /*->56269*/
/* 56220*/          OPC_MoveChild0,
/* 56221*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56224*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56226*/          OPC_MoveParent,
/* 56227*/          OPC_RecordChild1, // #0 = $c
/* 56228*/          OPC_MoveParent,
/* 56229*/          OPC_RecordChild1, // #1 = $v2
/* 56230*/          OPC_MoveParent,
/* 56231*/          OPC_MoveChild1,
/* 56232*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 56235*/          OPC_Scope, 15, /*->56252*/ // 2 children in Scope
/* 56237*/            OPC_CheckChild0Same, 0,
/* 56239*/            OPC_RecordChild1, // #2 = $v1
/* 56240*/            OPC_MoveParent,
/* 56241*/            OPC_CheckType, MVT::v2i64,
/* 56243*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56252*/          /*Scope*/ 15, /*->56268*/
/* 56253*/            OPC_RecordChild0, // #2 = $v1
/* 56254*/            OPC_CheckChild1Same, 0,
/* 56256*/            OPC_MoveParent,
/* 56257*/            OPC_CheckType, MVT::v2i64,
/* 56259*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56268*/          0, /*End of Scope*/
/* 56269*/        0, /*End of Scope*/
/* 56270*/      /*Scope*/ 105, /*->56376*/
/* 56271*/        OPC_RecordChild0, // #0 = $v2
/* 56272*/        OPC_MoveChild1,
/* 56273*/        OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 56276*/        OPC_Scope, 48, /*->56326*/ // 2 children in Scope
/* 56278*/          OPC_RecordChild0, // #1 = $c
/* 56279*/          OPC_MoveChild1,
/* 56280*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56283*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56285*/          OPC_MoveParent,
/* 56286*/          OPC_MoveParent,
/* 56287*/          OPC_MoveParent,
/* 56288*/          OPC_MoveChild1,
/* 56289*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 56292*/          OPC_Scope, 15, /*->56309*/ // 2 children in Scope
/* 56294*/            OPC_CheckChild0Same, 1,
/* 56296*/            OPC_RecordChild1, // #2 = $v1
/* 56297*/            OPC_MoveParent,
/* 56298*/            OPC_CheckType, MVT::v2i64,
/* 56300*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56309*/          /*Scope*/ 15, /*->56325*/
/* 56310*/            OPC_RecordChild0, // #2 = $v1
/* 56311*/            OPC_CheckChild1Same, 1,
/* 56313*/            OPC_MoveParent,
/* 56314*/            OPC_CheckType, MVT::v2i64,
/* 56316*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>)), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56325*/          0, /*End of Scope*/
/* 56326*/        /*Scope*/ 48, /*->56375*/
/* 56327*/          OPC_MoveChild0,
/* 56328*/          OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56331*/          OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56333*/          OPC_MoveParent,
/* 56334*/          OPC_RecordChild1, // #1 = $c
/* 56335*/          OPC_MoveParent,
/* 56336*/          OPC_MoveParent,
/* 56337*/          OPC_MoveChild1,
/* 56338*/          OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 56341*/          OPC_Scope, 15, /*->56358*/ // 2 children in Scope
/* 56343*/            OPC_CheckChild0Same, 1,
/* 56345*/            OPC_RecordChild1, // #2 = $v1
/* 56346*/            OPC_MoveParent,
/* 56347*/            OPC_CheckType, MVT::v2i64,
/* 56349*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c)), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56358*/          /*Scope*/ 15, /*->56374*/
/* 56359*/            OPC_RecordChild0, // #2 = $v1
/* 56360*/            OPC_CheckChild1Same, 1,
/* 56362*/            OPC_MoveParent,
/* 56363*/            OPC_CheckType, MVT::v2i64,
/* 56365*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT_v2i64), 0,
                          MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                      // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$c)), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
                      // Dst: (BITSELECT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c)
/* 56374*/          0, /*End of Scope*/
/* 56375*/        0, /*End of Scope*/
/* 56376*/      0, /*End of Scope*/
/* 56377*/    /*Scope*/ 52, /*->56430*/
/* 56378*/      OPC_RecordChild0, // #0 = $lhs
/* 56379*/      OPC_RecordChild1, // #1 = $rhs
/* 56380*/      OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->56393
/* 56383*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56385*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                  // Dst: (OR_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 56393*/      /*SwitchType*/ 10, MVT::v8i16,// ->56405
/* 56395*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56397*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                  // Dst: (OR_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 56405*/      /*SwitchType*/ 10, MVT::v4i32,// ->56417
/* 56407*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56409*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
                  // Dst: (OR_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 56417*/      /*SwitchType*/ 10, MVT::v2i64,// ->56429
/* 56419*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56421*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
                  // Dst: (OR_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 56429*/      0, // EndSwitchType
/* 56430*/    0, /*End of Scope*/
/* 56431*/  /*SwitchOpcode*/ 64|128,1/*192*/, TARGET_VAL(ISD::XOR),// ->56627
/* 56435*/    OPC_Scope, 81, /*->56518*/ // 3 children in Scope
/* 56437*/      OPC_RecordChild0, // #0 = $lhs
/* 56438*/      OPC_Scope, 23, /*->56463*/ // 2 children in Scope
/* 56440*/        OPC_RecordChild1, // #1 = $rhs
/* 56441*/        OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->56452
/* 56444*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I32), 0,
                        MVT::i32, 2/*#Ops*/, 0, 1, 
                    // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                    // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 56452*/        /*SwitchType*/ 8, MVT::i64,// ->56462
/* 56454*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I64), 0,
                        MVT::i64, 2/*#Ops*/, 0, 1, 
                    // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                    // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 56462*/        0, // EndSwitchType
/* 56463*/      /*Scope*/ 53, /*->56517*/
/* 56464*/        OPC_MoveChild1,
/* 56465*/        OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56468*/        OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56470*/        OPC_MoveParent,
/* 56471*/        OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->56483
/* 56474*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56476*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v16i8), 0,
                        MVT::v16i8, 1/*#Ops*/, 0, 
                    // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>) - Complexity = 7
                    // Dst: (NOT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec)
/* 56483*/        /*SwitchType*/ 9, MVT::v8i16,// ->56494
/* 56485*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56487*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v8i16), 0,
                        MVT::v8i16, 1/*#Ops*/, 0, 
                    // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>) - Complexity = 7
                    // Dst: (NOT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec)
/* 56494*/        /*SwitchType*/ 9, MVT::v4i32,// ->56505
/* 56496*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56498*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v4i32), 0,
                        MVT::v4i32, 1/*#Ops*/, 0, 
                    // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>) - Complexity = 7
                    // Dst: (NOT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec)
/* 56505*/        /*SwitchType*/ 9, MVT::v2i64,// ->56516
/* 56507*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56509*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v2i64), 0,
                        MVT::v2i64, 1/*#Ops*/, 0, 
                    // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>) - Complexity = 7
                    // Dst: (NOT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec)
/* 56516*/        0, // EndSwitchType
/* 56517*/      0, /*End of Scope*/
/* 56518*/    /*Scope*/ 54, /*->56573*/
/* 56519*/      OPC_MoveChild0,
/* 56520*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56523*/      OPC_CheckPredicate, 26, // Predicate_immAllOnesV
/* 56525*/      OPC_MoveParent,
/* 56526*/      OPC_RecordChild1, // #0 = $vec
/* 56527*/      OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->56539
/* 56530*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56532*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v16i8), 0,
                      MVT::v16i8, 1/*#Ops*/, 0, 
                  // Src: (xor:{ *:[v16i8] } (build_vector:{ *:[v16i8] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v16i8] }:$vec) - Complexity = 7
                  // Dst: (NOT_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec)
/* 56539*/      /*SwitchType*/ 9, MVT::v8i16,// ->56550
/* 56541*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56543*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v8i16), 0,
                      MVT::v8i16, 1/*#Ops*/, 0, 
                  // Src: (xor:{ *:[v8i16] } (build_vector:{ *:[v8i16] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v8i16] }:$vec) - Complexity = 7
                  // Dst: (NOT_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec)
/* 56550*/      /*SwitchType*/ 9, MVT::v4i32,// ->56561
/* 56552*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56554*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v4i32), 0,
                      MVT::v4i32, 1/*#Ops*/, 0, 
                  // Src: (xor:{ *:[v4i32] } (build_vector:{ *:[v4i32] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v4i32] }:$vec) - Complexity = 7
                  // Dst: (NOT_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec)
/* 56561*/      /*SwitchType*/ 9, MVT::v2i64,// ->56572
/* 56563*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56565*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT_v2i64), 0,
                      MVT::v2i64, 1/*#Ops*/, 0, 
                  // Src: (xor:{ *:[v2i64] } (build_vector:{ *:[v2i64] })<<P:Predicate_immAllOnesV>>, V128:{ *:[v2i64] }:$vec) - Complexity = 7
                  // Dst: (NOT_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec)
/* 56572*/      0, // EndSwitchType
/* 56573*/    /*Scope*/ 52, /*->56626*/
/* 56574*/      OPC_RecordChild0, // #0 = $lhs
/* 56575*/      OPC_RecordChild1, // #1 = $rhs
/* 56576*/      OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->56589
/* 56579*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56581*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_v16i8), 0,
                      MVT::v16i8, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                  // Dst: (XOR_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 56589*/      /*SwitchType*/ 10, MVT::v8i16,// ->56601
/* 56591*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56593*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_v8i16), 0,
                      MVT::v8i16, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                  // Dst: (XOR_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 56601*/      /*SwitchType*/ 10, MVT::v4i32,// ->56613
/* 56603*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56605*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_v4i32), 0,
                      MVT::v4i32, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
                  // Dst: (XOR_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 56613*/      /*SwitchType*/ 10, MVT::v2i64,// ->56625
/* 56615*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56617*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
                  // Dst: (XOR_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 56625*/      0, // EndSwitchType
/* 56626*/    0, /*End of Scope*/
/* 56627*/  /*SwitchOpcode*/ 88|128,1/*216*/, TARGET_VAL(ISD::SHL),// ->56847
/* 56631*/    OPC_RecordChild0, // #0 = $lhs
/* 56632*/    OPC_Scope, 27, /*->56661*/ // 2 children in Scope
/* 56634*/      OPC_RecordChild1, // #1 = $rhs
/* 56635*/      OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->56648
/* 56638*/        OPC_CheckChild1Type, MVT::i32,
/* 56640*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 56648*/      /*SwitchType*/ 10, MVT::i64,// ->56660
/* 56650*/        OPC_CheckChild1Type, MVT::i64,
/* 56652*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 56660*/      0, // EndSwitchType
/* 56661*/    /*Scope*/ 55|128,1/*183*/, /*->56846*/
/* 56663*/      OPC_MoveChild1,
/* 56664*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56667*/      OPC_Scope, 28, /*->56697*/ // 2 children in Scope
/* 56669*/        OPC_MoveChild0,
/* 56670*/        OPC_CheckOpcode, TARGET_VAL(ISD::ZERO_EXTEND),
/* 56673*/        OPC_RecordChild0, // #1 = $x
/* 56674*/        OPC_MoveParent,
/* 56675*/        OPC_MoveChild1,
/* 56676*/        OPC_CheckOpcode, TARGET_VAL(ISD::ZERO_EXTEND),
/* 56679*/        OPC_CheckChild0Same, 1,
/* 56681*/        OPC_MoveParent,
/* 56682*/        OPC_CheckType, MVT::v2i64,
/* 56684*/        OPC_MoveParent,
/* 56685*/        OPC_CheckType, MVT::v2i64,
/* 56687*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56689*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (build_vector:{ *:[v2i64] } (zext:{ *:[i64] } I32:{ *:[i32] }:$x), (zext:{ *:[i64] } I32:{ *:[i32] }:$x))) - Complexity = 12
                  // Dst: (SHL_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 56697*/      /*Scope*/ 18|128,1/*146*/, /*->56845*/
/* 56699*/        OPC_RecordChild0, // #1 = $x
/* 56700*/        OPC_Scope, 117, /*->56819*/ // 2 children in Scope
/* 56702*/          OPC_CheckChild0Type, MVT::i32,
/* 56704*/          OPC_CheckChild1Same, 1,
/* 56706*/          OPC_CheckChild2Same, 1,
/* 56708*/          OPC_CheckChild3Same, 1,
/* 56710*/          OPC_Scope, 90, /*->56802*/ // 2 children in Scope
/* 56712*/            OPC_MoveChild4,
/* 56713*/            OPC_CheckSame, 1,
/* 56715*/            OPC_MoveParent,
/* 56716*/            OPC_MoveChild5,
/* 56717*/            OPC_CheckSame, 1,
/* 56719*/            OPC_MoveParent,
/* 56720*/            OPC_MoveChild6,
/* 56721*/            OPC_CheckSame, 1,
/* 56723*/            OPC_MoveParent,
/* 56724*/            OPC_MoveChild7,
/* 56725*/            OPC_CheckSame, 1,
/* 56727*/            OPC_MoveParent,
/* 56728*/            OPC_Scope, 55, /*->56785*/ // 2 children in Scope
/* 56730*/              OPC_MoveChild, 8,
/* 56732*/              OPC_CheckSame, 1,
/* 56734*/              OPC_MoveParent,
/* 56735*/              OPC_MoveChild, 9,
/* 56737*/              OPC_CheckSame, 1,
/* 56739*/              OPC_MoveParent,
/* 56740*/              OPC_MoveChild, 10,
/* 56742*/              OPC_CheckSame, 1,
/* 56744*/              OPC_MoveParent,
/* 56745*/              OPC_MoveChild, 11,
/* 56747*/              OPC_CheckSame, 1,
/* 56749*/              OPC_MoveParent,
/* 56750*/              OPC_MoveChild, 12,
/* 56752*/              OPC_CheckSame, 1,
/* 56754*/              OPC_MoveParent,
/* 56755*/              OPC_MoveChild, 13,
/* 56757*/              OPC_CheckSame, 1,
/* 56759*/              OPC_MoveParent,
/* 56760*/              OPC_MoveChild, 14,
/* 56762*/              OPC_CheckSame, 1,
/* 56764*/              OPC_MoveParent,
/* 56765*/              OPC_MoveChild, 15,
/* 56767*/              OPC_CheckSame, 1,
/* 56769*/              OPC_MoveParent,
/* 56770*/              OPC_CheckType, MVT::v16i8,
/* 56772*/              OPC_MoveParent,
/* 56773*/              OPC_CheckType, MVT::v16i8,
/* 56775*/              OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56777*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_v16i8), 0,
                            MVT::v16i8, 2/*#Ops*/, 0, 1, 
                        // Src: (shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (build_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                        // Dst: (SHL_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 56785*/            /*Scope*/ 15, /*->56801*/
/* 56786*/              OPC_CheckType, MVT::v8i16,
/* 56788*/              OPC_MoveParent,
/* 56789*/              OPC_CheckType, MVT::v8i16,
/* 56791*/              OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56793*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_v8i16), 0,
                            MVT::v8i16, 2/*#Ops*/, 0, 1, 
                        // Src: (shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (build_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                        // Dst: (SHL_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 56801*/            0, /*End of Scope*/
/* 56802*/          /*Scope*/ 15, /*->56818*/
/* 56803*/            OPC_CheckType, MVT::v4i32,
/* 56805*/            OPC_MoveParent,
/* 56806*/            OPC_CheckType, MVT::v4i32,
/* 56808*/            OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56810*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_v4i32), 0,
                          MVT::v4i32, 2/*#Ops*/, 0, 1, 
                      // Src: (shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (build_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                      // Dst: (SHL_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 56818*/          0, /*End of Scope*/
/* 56819*/        /*Scope*/ 24, /*->56844*/
/* 56820*/          OPC_CheckChild0Type, MVT::i64,
/* 56822*/          OPC_CheckChild1Same, 1,
/* 56824*/          OPC_CheckType, MVT::v2i64,
/* 56826*/          OPC_MoveParent,
/* 56827*/          OPC_CheckType, MVT::v2i64,
/* 56829*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                        MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 56836*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_v2i64), 0,
                        MVT::v2i64, 2/*#Ops*/, 0, 2, 
                    // Src: (shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (build_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$x)) - Complexity = 6
                    // Dst: (SHL_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$x))
/* 56844*/        0, /*End of Scope*/
/* 56845*/      0, /*End of Scope*/
/* 56846*/    0, /*End of Scope*/
/* 56847*/  /*SwitchOpcode*/ 88|128,1/*216*/, TARGET_VAL(ISD::SRA),// ->57067
/* 56851*/    OPC_RecordChild0, // #0 = $lhs
/* 56852*/    OPC_Scope, 27, /*->56881*/ // 2 children in Scope
/* 56854*/      OPC_RecordChild1, // #1 = $rhs
/* 56855*/      OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->56868
/* 56858*/        OPC_CheckChild1Type, MVT::i32,
/* 56860*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 56868*/      /*SwitchType*/ 10, MVT::i64,// ->56880
/* 56870*/        OPC_CheckChild1Type, MVT::i64,
/* 56872*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 56880*/      0, // EndSwitchType
/* 56881*/    /*Scope*/ 55|128,1/*183*/, /*->57066*/
/* 56883*/      OPC_MoveChild1,
/* 56884*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 56887*/      OPC_Scope, 28, /*->56917*/ // 2 children in Scope
/* 56889*/        OPC_MoveChild0,
/* 56890*/        OPC_CheckOpcode, TARGET_VAL(ISD::ZERO_EXTEND),
/* 56893*/        OPC_RecordChild0, // #1 = $x
/* 56894*/        OPC_MoveParent,
/* 56895*/        OPC_MoveChild1,
/* 56896*/        OPC_CheckOpcode, TARGET_VAL(ISD::ZERO_EXTEND),
/* 56899*/        OPC_CheckChild0Same, 1,
/* 56901*/        OPC_MoveParent,
/* 56902*/        OPC_CheckType, MVT::v2i64,
/* 56904*/        OPC_MoveParent,
/* 56905*/        OPC_CheckType, MVT::v2i64,
/* 56907*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56909*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (sra:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (build_vector:{ *:[v2i64] } (zext:{ *:[i64] } I32:{ *:[i32] }:$x), (zext:{ *:[i64] } I32:{ *:[i32] }:$x))) - Complexity = 12
                  // Dst: (SHR_S_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 56917*/      /*Scope*/ 18|128,1/*146*/, /*->57065*/
/* 56919*/        OPC_RecordChild0, // #1 = $x
/* 56920*/        OPC_Scope, 117, /*->57039*/ // 2 children in Scope
/* 56922*/          OPC_CheckChild0Type, MVT::i32,
/* 56924*/          OPC_CheckChild1Same, 1,
/* 56926*/          OPC_CheckChild2Same, 1,
/* 56928*/          OPC_CheckChild3Same, 1,
/* 56930*/          OPC_Scope, 90, /*->57022*/ // 2 children in Scope
/* 56932*/            OPC_MoveChild4,
/* 56933*/            OPC_CheckSame, 1,
/* 56935*/            OPC_MoveParent,
/* 56936*/            OPC_MoveChild5,
/* 56937*/            OPC_CheckSame, 1,
/* 56939*/            OPC_MoveParent,
/* 56940*/            OPC_MoveChild6,
/* 56941*/            OPC_CheckSame, 1,
/* 56943*/            OPC_MoveParent,
/* 56944*/            OPC_MoveChild7,
/* 56945*/            OPC_CheckSame, 1,
/* 56947*/            OPC_MoveParent,
/* 56948*/            OPC_Scope, 55, /*->57005*/ // 2 children in Scope
/* 56950*/              OPC_MoveChild, 8,
/* 56952*/              OPC_CheckSame, 1,
/* 56954*/              OPC_MoveParent,
/* 56955*/              OPC_MoveChild, 9,
/* 56957*/              OPC_CheckSame, 1,
/* 56959*/              OPC_MoveParent,
/* 56960*/              OPC_MoveChild, 10,
/* 56962*/              OPC_CheckSame, 1,
/* 56964*/              OPC_MoveParent,
/* 56965*/              OPC_MoveChild, 11,
/* 56967*/              OPC_CheckSame, 1,
/* 56969*/              OPC_MoveParent,
/* 56970*/              OPC_MoveChild, 12,
/* 56972*/              OPC_CheckSame, 1,
/* 56974*/              OPC_MoveParent,
/* 56975*/              OPC_MoveChild, 13,
/* 56977*/              OPC_CheckSame, 1,
/* 56979*/              OPC_MoveParent,
/* 56980*/              OPC_MoveChild, 14,
/* 56982*/              OPC_CheckSame, 1,
/* 56984*/              OPC_MoveParent,
/* 56985*/              OPC_MoveChild, 15,
/* 56987*/              OPC_CheckSame, 1,
/* 56989*/              OPC_MoveParent,
/* 56990*/              OPC_CheckType, MVT::v16i8,
/* 56992*/              OPC_MoveParent,
/* 56993*/              OPC_CheckType, MVT::v16i8,
/* 56995*/              OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 56997*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_v16i8), 0,
                            MVT::v16i8, 2/*#Ops*/, 0, 1, 
                        // Src: (sra:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (build_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                        // Dst: (SHR_S_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 57005*/            /*Scope*/ 15, /*->57021*/
/* 57006*/              OPC_CheckType, MVT::v8i16,
/* 57008*/              OPC_MoveParent,
/* 57009*/              OPC_CheckType, MVT::v8i16,
/* 57011*/              OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57013*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_v8i16), 0,
                            MVT::v8i16, 2/*#Ops*/, 0, 1, 
                        // Src: (sra:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (build_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                        // Dst: (SHR_S_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 57021*/            0, /*End of Scope*/
/* 57022*/          /*Scope*/ 15, /*->57038*/
/* 57023*/            OPC_CheckType, MVT::v4i32,
/* 57025*/            OPC_MoveParent,
/* 57026*/            OPC_CheckType, MVT::v4i32,
/* 57028*/            OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57030*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_v4i32), 0,
                          MVT::v4i32, 2/*#Ops*/, 0, 1, 
                      // Src: (sra:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (build_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                      // Dst: (SHR_S_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 57038*/          0, /*End of Scope*/
/* 57039*/        /*Scope*/ 24, /*->57064*/
/* 57040*/          OPC_CheckChild0Type, MVT::i64,
/* 57042*/          OPC_CheckChild1Same, 1,
/* 57044*/          OPC_CheckType, MVT::v2i64,
/* 57046*/          OPC_MoveParent,
/* 57047*/          OPC_CheckType, MVT::v2i64,
/* 57049*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                        MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 57056*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_v2i64), 0,
                        MVT::v2i64, 2/*#Ops*/, 0, 2, 
                    // Src: (sra:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (build_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$x)) - Complexity = 6
                    // Dst: (SHR_S_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$x))
/* 57064*/        0, /*End of Scope*/
/* 57065*/      0, /*End of Scope*/
/* 57066*/    0, /*End of Scope*/
/* 57067*/  /*SwitchOpcode*/ 88|128,1/*216*/, TARGET_VAL(ISD::SRL),// ->57287
/* 57071*/    OPC_RecordChild0, // #0 = $lhs
/* 57072*/    OPC_Scope, 27, /*->57101*/ // 2 children in Scope
/* 57074*/      OPC_RecordChild1, // #1 = $rhs
/* 57075*/      OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->57088
/* 57078*/        OPC_CheckChild1Type, MVT::i32,
/* 57080*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32), 0,
                      MVT::i32, 2/*#Ops*/, 0, 1, 
                  // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
                  // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 57088*/      /*SwitchType*/ 10, MVT::i64,// ->57100
/* 57090*/        OPC_CheckChild1Type, MVT::i64,
/* 57092*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64), 0,
                      MVT::i64, 2/*#Ops*/, 0, 1, 
                  // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
                  // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 57100*/      0, // EndSwitchType
/* 57101*/    /*Scope*/ 55|128,1/*183*/, /*->57286*/
/* 57103*/      OPC_MoveChild1,
/* 57104*/      OPC_CheckOpcode, TARGET_VAL(ISD::BUILD_VECTOR),
/* 57107*/      OPC_Scope, 28, /*->57137*/ // 2 children in Scope
/* 57109*/        OPC_MoveChild0,
/* 57110*/        OPC_CheckOpcode, TARGET_VAL(ISD::ZERO_EXTEND),
/* 57113*/        OPC_RecordChild0, // #1 = $x
/* 57114*/        OPC_MoveParent,
/* 57115*/        OPC_MoveChild1,
/* 57116*/        OPC_CheckOpcode, TARGET_VAL(ISD::ZERO_EXTEND),
/* 57119*/        OPC_CheckChild0Same, 1,
/* 57121*/        OPC_MoveParent,
/* 57122*/        OPC_CheckType, MVT::v2i64,
/* 57124*/        OPC_MoveParent,
/* 57125*/        OPC_CheckType, MVT::v2i64,
/* 57127*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57129*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 0, 1, 
                  // Src: (srl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (build_vector:{ *:[v2i64] } (zext:{ *:[i64] } I32:{ *:[i32] }:$x), (zext:{ *:[i64] } I32:{ *:[i32] }:$x))) - Complexity = 12
                  // Dst: (SHR_U_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 57137*/      /*Scope*/ 18|128,1/*146*/, /*->57285*/
/* 57139*/        OPC_RecordChild0, // #1 = $x
/* 57140*/        OPC_Scope, 117, /*->57259*/ // 2 children in Scope
/* 57142*/          OPC_CheckChild0Type, MVT::i32,
/* 57144*/          OPC_CheckChild1Same, 1,
/* 57146*/          OPC_CheckChild2Same, 1,
/* 57148*/          OPC_CheckChild3Same, 1,
/* 57150*/          OPC_Scope, 90, /*->57242*/ // 2 children in Scope
/* 57152*/            OPC_MoveChild4,
/* 57153*/            OPC_CheckSame, 1,
/* 57155*/            OPC_MoveParent,
/* 57156*/            OPC_MoveChild5,
/* 57157*/            OPC_CheckSame, 1,
/* 57159*/            OPC_MoveParent,
/* 57160*/            OPC_MoveChild6,
/* 57161*/            OPC_CheckSame, 1,
/* 57163*/            OPC_MoveParent,
/* 57164*/            OPC_MoveChild7,
/* 57165*/            OPC_CheckSame, 1,
/* 57167*/            OPC_MoveParent,
/* 57168*/            OPC_Scope, 55, /*->57225*/ // 2 children in Scope
/* 57170*/              OPC_MoveChild, 8,
/* 57172*/              OPC_CheckSame, 1,
/* 57174*/              OPC_MoveParent,
/* 57175*/              OPC_MoveChild, 9,
/* 57177*/              OPC_CheckSame, 1,
/* 57179*/              OPC_MoveParent,
/* 57180*/              OPC_MoveChild, 10,
/* 57182*/              OPC_CheckSame, 1,
/* 57184*/              OPC_MoveParent,
/* 57185*/              OPC_MoveChild, 11,
/* 57187*/              OPC_CheckSame, 1,
/* 57189*/              OPC_MoveParent,
/* 57190*/              OPC_MoveChild, 12,
/* 57192*/              OPC_CheckSame, 1,
/* 57194*/              OPC_MoveParent,
/* 57195*/              OPC_MoveChild, 13,
/* 57197*/              OPC_CheckSame, 1,
/* 57199*/              OPC_MoveParent,
/* 57200*/              OPC_MoveChild, 14,
/* 57202*/              OPC_CheckSame, 1,
/* 57204*/              OPC_MoveParent,
/* 57205*/              OPC_MoveChild, 15,
/* 57207*/              OPC_CheckSame, 1,
/* 57209*/              OPC_MoveParent,
/* 57210*/              OPC_CheckType, MVT::v16i8,
/* 57212*/              OPC_MoveParent,
/* 57213*/              OPC_CheckType, MVT::v16i8,
/* 57215*/              OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57217*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_v16i8), 0,
                            MVT::v16i8, 2/*#Ops*/, 0, 1, 
                        // Src: (srl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (build_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                        // Dst: (SHR_U_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 57225*/            /*Scope*/ 15, /*->57241*/
/* 57226*/              OPC_CheckType, MVT::v8i16,
/* 57228*/              OPC_MoveParent,
/* 57229*/              OPC_CheckType, MVT::v8i16,
/* 57231*/              OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57233*/              OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_v8i16), 0,
                            MVT::v8i16, 2/*#Ops*/, 0, 1, 
                        // Src: (srl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (build_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                        // Dst: (SHR_U_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 57241*/            0, /*End of Scope*/
/* 57242*/          /*Scope*/ 15, /*->57258*/
/* 57243*/            OPC_CheckType, MVT::v4i32,
/* 57245*/            OPC_MoveParent,
/* 57246*/            OPC_CheckType, MVT::v4i32,
/* 57248*/            OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57250*/            OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_v4i32), 0,
                          MVT::v4i32, 2/*#Ops*/, 0, 1, 
                      // Src: (srl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (build_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x)) - Complexity = 6
                      // Dst: (SHR_U_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 57258*/          0, /*End of Scope*/
/* 57259*/        /*Scope*/ 24, /*->57284*/
/* 57260*/          OPC_CheckChild0Type, MVT::i64,
/* 57262*/          OPC_CheckChild1Same, 1,
/* 57264*/          OPC_CheckType, MVT::v2i64,
/* 57266*/          OPC_MoveParent,
/* 57267*/          OPC_CheckType, MVT::v2i64,
/* 57269*/          OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                        MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 57276*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_v2i64), 0,
                        MVT::v2i64, 2/*#Ops*/, 0, 2, 
                    // Src: (srl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (build_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$x)) - Complexity = 6
                    // Dst: (SHR_U_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$x))
/* 57284*/        0, /*End of Scope*/
/* 57285*/      0, /*End of Scope*/
/* 57286*/    0, /*End of Scope*/
/* 57287*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->57311
/* 57290*/    OPC_RecordChild0, // #0 = $src
/* 57291*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->57301
/* 57294*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
                // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 57301*/    /*SwitchType*/ 7, MVT::i64,// ->57310
/* 57303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I64), 0,
                    MVT::i64, 1/*#Ops*/, 0, 
                // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
                // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 57310*/    0, // EndSwitchType
/* 57311*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->57335
/* 57314*/    OPC_RecordChild0, // #0 = $src
/* 57315*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->57325
/* 57318*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
                // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 57325*/    /*SwitchType*/ 7, MVT::i64,// ->57334
/* 57327*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I64), 0,
                    MVT::i64, 1/*#Ops*/, 0, 
                // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
                // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 57334*/    0, // EndSwitchType
/* 57335*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTPOP),// ->57359
/* 57338*/    OPC_RecordChild0, // #0 = $src
/* 57339*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->57349
/* 57342*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
                // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 57349*/    /*SwitchType*/ 7, MVT::i64,// ->57358
/* 57351*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I64), 0,
                    MVT::i64, 1/*#Ops*/, 0, 
                // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
                // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 57358*/    0, // EndSwitchType
/* 57359*/  /*SwitchOpcode*/ 8, TARGET_VAL(ISD::TRUNCATE),// ->57370
/* 57362*/    OPC_RecordChild0, // #0 = $src
/* 57363*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 57370*/  /*SwitchOpcode*/ 8, TARGET_VAL(ISD::SIGN_EXTEND),// ->57381
/* 57373*/    OPC_RecordChild0, // #0 = $src
/* 57374*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 57381*/  /*SwitchOpcode*/ 5|128,1/*133*/, TARGET_VAL(ISD::FP_TO_SINT),// ->57518
/* 57385*/    OPC_RecordChild0, // #0 = $src
/* 57386*/    OPC_Scope, 52, /*->57440*/ // 4 children in Scope
/* 57388*/      OPC_CheckChild0Type, MVT::f32,
/* 57390*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->57415
/* 57393*/        OPC_Scope, 9, /*->57404*/ // 2 children in Scope
/* 57395*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57397*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 57404*/        /*Scope*/ 9, /*->57414*/
/* 57405*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57407*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 57414*/        0, /*End of Scope*/
/* 57415*/      /*SwitchType*/ 22, MVT::i64,// ->57439
/* 57417*/        OPC_Scope, 9, /*->57428*/ // 2 children in Scope
/* 57419*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57421*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 57428*/        /*Scope*/ 9, /*->57438*/
/* 57429*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57431*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 57438*/        0, /*End of Scope*/
/* 57439*/      0, // EndSwitchType
/* 57440*/    /*Scope*/ 52, /*->57493*/
/* 57441*/      OPC_CheckChild0Type, MVT::f64,
/* 57443*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->57468
/* 57446*/        OPC_Scope, 9, /*->57457*/ // 2 children in Scope
/* 57448*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57450*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 57457*/        /*Scope*/ 9, /*->57467*/
/* 57458*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57460*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 57467*/        0, /*End of Scope*/
/* 57468*/      /*SwitchType*/ 22, MVT::i64,// ->57492
/* 57470*/        OPC_Scope, 9, /*->57481*/ // 2 children in Scope
/* 57472*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57474*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 57481*/        /*Scope*/ 9, /*->57491*/
/* 57482*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57484*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 57491*/        0, /*End of Scope*/
/* 57492*/      0, // EndSwitchType
/* 57493*/    /*Scope*/ 11, /*->57505*/
/* 57494*/      OPC_CheckType, MVT::v4i32,
/* 57496*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57498*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_v4i32_v4f32), 0,
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
                // Dst: (fp_to_sint_v4i32_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 57505*/    /*Scope*/ 11, /*->57517*/
/* 57506*/      OPC_CheckType, MVT::v2i64,
/* 57508*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57510*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_v2i64_v2f64), 0,
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
                // Dst: (fp_to_sint_v2i64_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$vec)
/* 57517*/    0, /*End of Scope*/
/* 57518*/  /*SwitchOpcode*/ 5|128,1/*133*/, TARGET_VAL(ISD::FP_TO_UINT),// ->57655
/* 57522*/    OPC_RecordChild0, // #0 = $src
/* 57523*/    OPC_Scope, 52, /*->57577*/ // 4 children in Scope
/* 57525*/      OPC_CheckChild0Type, MVT::f32,
/* 57527*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->57552
/* 57530*/        OPC_Scope, 9, /*->57541*/ // 2 children in Scope
/* 57532*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57534*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 57541*/        /*Scope*/ 9, /*->57551*/
/* 57542*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57544*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 57551*/        0, /*End of Scope*/
/* 57552*/      /*SwitchType*/ 22, MVT::i64,// ->57576
/* 57554*/        OPC_Scope, 9, /*->57565*/ // 2 children in Scope
/* 57556*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57558*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 57565*/        /*Scope*/ 9, /*->57575*/
/* 57566*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57568*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
                    // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 57575*/        0, /*End of Scope*/
/* 57576*/      0, // EndSwitchType
/* 57577*/    /*Scope*/ 52, /*->57630*/
/* 57578*/      OPC_CheckChild0Type, MVT::f64,
/* 57580*/      OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->57605
/* 57583*/        OPC_Scope, 9, /*->57594*/ // 2 children in Scope
/* 57585*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57587*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 57594*/        /*Scope*/ 9, /*->57604*/
/* 57595*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57597*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64), 0,
                        MVT::i32, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 57604*/        0, /*End of Scope*/
/* 57605*/      /*SwitchType*/ 22, MVT::i64,// ->57629
/* 57607*/        OPC_Scope, 9, /*->57618*/ // 2 children in Scope
/* 57609*/          OPC_CheckPatternPredicate, 6, // (Subtarget->hasNontrappingFPToInt())
/* 57611*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 57618*/        /*Scope*/ 9, /*->57628*/
/* 57619*/          OPC_CheckPatternPredicate, 7, // (!Subtarget->hasNontrappingFPToInt())
/* 57621*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64), 0,
                        MVT::i64, 1/*#Ops*/, 0, 
                    // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
                    // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 57628*/        0, /*End of Scope*/
/* 57629*/      0, // EndSwitchType
/* 57630*/    /*Scope*/ 11, /*->57642*/
/* 57631*/      OPC_CheckType, MVT::v4i32,
/* 57633*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57635*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_v4i32_v4f32), 0,
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
                // Dst: (fp_to_uint_v4i32_v4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 57642*/    /*Scope*/ 11, /*->57654*/
/* 57643*/      OPC_CheckType, MVT::v2i64,
/* 57645*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57647*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_v2i64_v2f64), 0,
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
                // Dst: (fp_to_uint_v2i64_v2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$vec)
/* 57654*/    0, /*End of Scope*/
/* 57655*/  /*SwitchOpcode*/ 103|128,1/*231*/, TARGET_VAL(ISD::BITCAST),// ->57890
/* 57659*/    OPC_RecordChild0, // #0 = $src
/* 57660*/    OPC_Scope, 11, /*->57673*/ // 10 children in Scope
/* 57662*/      OPC_CheckChild0Type, MVT::f32,
/* 57664*/      OPC_CheckType, MVT::i32,
/* 57666*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 57673*/    /*Scope*/ 11, /*->57685*/
/* 57674*/      OPC_CheckChild0Type, MVT::f64,
/* 57676*/      OPC_CheckType, MVT::i64,
/* 57678*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64), 0,
                    MVT::i64, 1/*#Ops*/, 0, 
                // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 57685*/    /*Scope*/ 11, /*->57697*/
/* 57686*/      OPC_CheckChild0Type, MVT::i32,
/* 57688*/      OPC_CheckType, MVT::f32,
/* 57690*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
                // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 57697*/    /*Scope*/ 11, /*->57709*/
/* 57698*/      OPC_CheckChild0Type, MVT::i64,
/* 57700*/      OPC_CheckType, MVT::f64,
/* 57702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
                // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 57709*/    /*Scope*/ 29, /*->57739*/
/* 57710*/      OPC_CheckChild0Type, MVT::v8i16,
/* 57712*/      OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->57718
/* 57715*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v16i8] }:$v
/* 57718*/      /*SwitchType*/ 3, MVT::v4i32,// ->57723
/* 57720*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4i32] }:$v
/* 57723*/      /*SwitchType*/ 3, MVT::v2i64,// ->57728
/* 57725*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2i64] }:$v
/* 57728*/      /*SwitchType*/ 3, MVT::v4f32,// ->57733
/* 57730*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4f32] }:$v
/* 57733*/      /*SwitchType*/ 3, MVT::v2f64,// ->57738
/* 57735*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2f64] }:$v
/* 57738*/      0, // EndSwitchType
/* 57739*/    /*Scope*/ 29, /*->57769*/
/* 57740*/      OPC_CheckChild0Type, MVT::v4i32,
/* 57742*/      OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->57748
/* 57745*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v16i8] }:$v
/* 57748*/      /*SwitchType*/ 3, MVT::v8i16,// ->57753
/* 57750*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v8i16] }:$v
/* 57753*/      /*SwitchType*/ 3, MVT::v2i64,// ->57758
/* 57755*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2i64] }:$v
/* 57758*/      /*SwitchType*/ 3, MVT::v4f32,// ->57763
/* 57760*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4f32] }:$v
/* 57763*/      /*SwitchType*/ 3, MVT::v2f64,// ->57768
/* 57765*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2f64] }:$v
/* 57768*/      0, // EndSwitchType
/* 57769*/    /*Scope*/ 29, /*->57799*/
/* 57770*/      OPC_CheckChild0Type, MVT::v2i64,
/* 57772*/      OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->57778
/* 57775*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v16i8] }:$v
/* 57778*/      /*SwitchType*/ 3, MVT::v8i16,// ->57783
/* 57780*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v8i16] }:$v
/* 57783*/      /*SwitchType*/ 3, MVT::v4i32,// ->57788
/* 57785*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4i32] }:$v
/* 57788*/      /*SwitchType*/ 3, MVT::v4f32,// ->57793
/* 57790*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4f32] }:$v
/* 57793*/      /*SwitchType*/ 3, MVT::v2f64,// ->57798
/* 57795*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2f64] }:$v
/* 57798*/      0, // EndSwitchType
/* 57799*/    /*Scope*/ 29, /*->57829*/
/* 57800*/      OPC_CheckChild0Type, MVT::v4f32,
/* 57802*/      OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->57808
/* 57805*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v16i8] }:$v
/* 57808*/      /*SwitchType*/ 3, MVT::v8i16,// ->57813
/* 57810*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v8i16] }:$v
/* 57813*/      /*SwitchType*/ 3, MVT::v4i32,// ->57818
/* 57815*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4i32] }:$v
/* 57818*/      /*SwitchType*/ 3, MVT::v2i64,// ->57823
/* 57820*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2i64] }:$v
/* 57823*/      /*SwitchType*/ 3, MVT::v2f64,// ->57828
/* 57825*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2f64] }:$v
/* 57828*/      0, // EndSwitchType
/* 57829*/    /*Scope*/ 29, /*->57859*/
/* 57830*/      OPC_CheckChild0Type, MVT::v2f64,
/* 57832*/      OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->57838
/* 57835*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v16i8] }:$v
/* 57838*/      /*SwitchType*/ 3, MVT::v8i16,// ->57843
/* 57840*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v8i16] }:$v
/* 57843*/      /*SwitchType*/ 3, MVT::v4i32,// ->57848
/* 57845*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4i32] }:$v
/* 57848*/      /*SwitchType*/ 3, MVT::v2i64,// ->57853
/* 57850*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2i64] }:$v
/* 57853*/      /*SwitchType*/ 3, MVT::v4f32,// ->57858
/* 57855*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4f32] }:$v
/* 57858*/      0, // EndSwitchType
/* 57859*/    /*Scope*/ 29, /*->57889*/
/* 57860*/      OPC_CheckChild0Type, MVT::v16i8,
/* 57862*/      OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->57868
/* 57865*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v8i16] }:$v
/* 57868*/      /*SwitchType*/ 3, MVT::v4i32,// ->57873
/* 57870*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4i32] }:$v
/* 57873*/      /*SwitchType*/ 3, MVT::v2i64,// ->57878
/* 57875*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2i64] }:$v
/* 57878*/      /*SwitchType*/ 3, MVT::v4f32,// ->57883
/* 57880*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v4f32] }:$v
/* 57883*/      /*SwitchType*/ 3, MVT::v2f64,// ->57888
/* 57885*/        OPC_CompleteMatch, 1, 0, 
                   // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
                   // Dst: V128:{ *:[v2f64] }:$v
/* 57888*/      0, // EndSwitchType
/* 57889*/    0, /*End of Scope*/
/* 57890*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::ConstantFP),// ->57918
/* 57893*/    OPC_RecordNode, // #0 = $imm
/* 57894*/    OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->57906
/* 57897*/      OPC_EmitConvertToTarget, 0,
/* 57899*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F32), 0,
                    MVT::f32, 1/*#Ops*/, 1, 
                // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
                // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 57906*/    /*SwitchType*/ 9, MVT::f64,// ->57917
/* 57908*/      OPC_EmitConvertToTarget, 0,
/* 57910*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F64), 0,
                    MVT::f64, 1/*#Ops*/, 1, 
                // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
                // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 57917*/    0, // EndSwitchType
/* 57918*/  /*SwitchOpcode*/ 73, TARGET_VAL(ISD::SINT_TO_FP),// ->57994
/* 57921*/    OPC_RecordChild0, // #0 = $src
/* 57922*/    OPC_Scope, 22, /*->57946*/ // 4 children in Scope
/* 57924*/      OPC_CheckChild0Type, MVT::i32,
/* 57926*/      OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->57936
/* 57929*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32), 0,
                      MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
                  // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 57936*/      /*SwitchType*/ 7, MVT::f64,// ->57945
/* 57938*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32), 0,
                      MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
                  // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 57945*/      0, // EndSwitchType
/* 57946*/    /*Scope*/ 22, /*->57969*/
/* 57947*/      OPC_CheckChild0Type, MVT::i64,
/* 57949*/      OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->57959
/* 57952*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64), 0,
                      MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
                  // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 57959*/      /*SwitchType*/ 7, MVT::f64,// ->57968
/* 57961*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64), 0,
                      MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
                  // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 57968*/      0, // EndSwitchType
/* 57969*/    /*Scope*/ 11, /*->57981*/
/* 57970*/      OPC_CheckType, MVT::v4f32,
/* 57972*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57974*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::sint_to_fp_v4f32_v4i32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
                // Dst: (sint_to_fp_v4f32_v4i32:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 57981*/    /*Scope*/ 11, /*->57993*/
/* 57982*/      OPC_CheckType, MVT::v2f64,
/* 57984*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 57986*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::sint_to_fp_v2f64_v2i64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$vec) - Complexity = 3
                // Dst: (sint_to_fp_v2f64_v2i64:{ *:[v2f64] } V128:{ *:[v2i64] }:$vec)
/* 57993*/    0, /*End of Scope*/
/* 57994*/  /*SwitchOpcode*/ 73, TARGET_VAL(ISD::UINT_TO_FP),// ->58070
/* 57997*/    OPC_RecordChild0, // #0 = $src
/* 57998*/    OPC_Scope, 22, /*->58022*/ // 4 children in Scope
/* 58000*/      OPC_CheckChild0Type, MVT::i32,
/* 58002*/      OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->58012
/* 58005*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32), 0,
                      MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
                  // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 58012*/      /*SwitchType*/ 7, MVT::f64,// ->58021
/* 58014*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32), 0,
                      MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
                  // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 58021*/      0, // EndSwitchType
/* 58022*/    /*Scope*/ 22, /*->58045*/
/* 58023*/      OPC_CheckChild0Type, MVT::i64,
/* 58025*/      OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->58035
/* 58028*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64), 0,
                      MVT::f32, 1/*#Ops*/, 0, 
                  // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
                  // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 58035*/      /*SwitchType*/ 7, MVT::f64,// ->58044
/* 58037*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64), 0,
                      MVT::f64, 1/*#Ops*/, 0, 
                  // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
                  // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 58044*/      0, // EndSwitchType
/* 58045*/    /*Scope*/ 11, /*->58057*/
/* 58046*/      OPC_CheckType, MVT::v4f32,
/* 58048*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58050*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::uint_to_fp_v4f32_v4i32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
                // Dst: (uint_to_fp_v4f32_v4i32:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 58057*/    /*Scope*/ 11, /*->58069*/
/* 58058*/      OPC_CheckType, MVT::v2f64,
/* 58060*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58062*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::uint_to_fp_v2f64_v2i64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$vec) - Complexity = 3
                // Dst: (uint_to_fp_v2f64_v2i64:{ *:[v2f64] } V128:{ *:[v2i64] }:$vec)
/* 58069*/    0, /*End of Scope*/
/* 58070*/  /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_EXTEND),// ->58081
/* 58073*/    OPC_RecordChild0, // #0 = $src
/* 58074*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
              // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 58081*/  /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_ROUND),// ->58092
/* 58084*/    OPC_RecordChild0, // #0 = $src
/* 58085*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
              // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 58092*/  /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FADD),// ->58143
/* 58095*/    OPC_RecordChild0, // #0 = $lhs
/* 58096*/    OPC_RecordChild1, // #1 = $rhs
/* 58097*/    OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->58108
/* 58100*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F32), 0,
                    MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 58108*/    /*SwitchType*/ 8, MVT::f64,// ->58118
/* 58110*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F64), 0,
                    MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 58118*/    /*SwitchType*/ 10, MVT::v4f32,// ->58130
/* 58120*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_v4f32), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
                // Dst: (ADD_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58130*/    /*SwitchType*/ 10, MVT::v2f64,// ->58142
/* 58132*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58134*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_v2f64), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
                // Dst: (ADD_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58142*/    0, // EndSwitchType
/* 58143*/  /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSUB),// ->58194
/* 58146*/    OPC_RecordChild0, // #0 = $lhs
/* 58147*/    OPC_RecordChild1, // #1 = $rhs
/* 58148*/    OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->58159
/* 58151*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F32), 0,
                    MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 58159*/    /*SwitchType*/ 8, MVT::f64,// ->58169
/* 58161*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F64), 0,
                    MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 58169*/    /*SwitchType*/ 10, MVT::v4f32,// ->58181
/* 58171*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58173*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_v4f32), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
                // Dst: (SUB_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58181*/    /*SwitchType*/ 10, MVT::v2f64,// ->58193
/* 58183*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58185*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_v2f64), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
                // Dst: (SUB_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58193*/    0, // EndSwitchType
/* 58194*/  /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMUL),// ->58245
/* 58197*/    OPC_RecordChild0, // #0 = $lhs
/* 58198*/    OPC_RecordChild1, // #1 = $rhs
/* 58199*/    OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->58210
/* 58202*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F32), 0,
                    MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 58210*/    /*SwitchType*/ 8, MVT::f64,// ->58220
/* 58212*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F64), 0,
                    MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 58220*/    /*SwitchType*/ 10, MVT::v4f32,// ->58232
/* 58222*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58224*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_v4f32), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
                // Dst: (MUL_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58232*/    /*SwitchType*/ 10, MVT::v2f64,// ->58244
/* 58234*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58236*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_v2f64), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
                // Dst: (MUL_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58244*/    0, // EndSwitchType
/* 58245*/  /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FDIV),// ->58296
/* 58248*/    OPC_RecordChild0, // #0 = $lhs
/* 58249*/    OPC_RecordChild1, // #1 = $rhs
/* 58250*/    OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->58261
/* 58253*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F32), 0,
                    MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 58261*/    /*SwitchType*/ 8, MVT::f64,// ->58271
/* 58263*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F64), 0,
                    MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 58271*/    /*SwitchType*/ 10, MVT::v4f32,// ->58283
/* 58273*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 58275*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_v4f32), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
                // Dst: (DIV_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58283*/    /*SwitchType*/ 10, MVT::v2f64,// ->58295
/* 58285*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 58287*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_v2f64), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
                // Dst: (DIV_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58295*/    0, // EndSwitchType
/* 58296*/  /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FSQRT),// ->58342
/* 58299*/    OPC_RecordChild0, // #0 = $src
/* 58300*/    OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->58310
/* 58303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 58310*/    /*SwitchType*/ 7, MVT::f64,// ->58319
/* 58312*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 58319*/    /*SwitchType*/ 9, MVT::v4f32,// ->58330
/* 58321*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 58323*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_v4f32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
                // Dst: (SQRT_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec)
/* 58330*/    /*SwitchType*/ 9, MVT::v2f64,// ->58341
/* 58332*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 58334*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_v2f64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
                // Dst: (SQRT_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec)
/* 58341*/    0, // EndSwitchType
/* 58342*/  /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FABS),// ->58388
/* 58345*/    OPC_RecordChild0, // #0 = $src
/* 58346*/    OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->58356
/* 58349*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 58356*/    /*SwitchType*/ 7, MVT::f64,// ->58365
/* 58358*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 58365*/    /*SwitchType*/ 9, MVT::v4f32,// ->58376
/* 58367*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58369*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_v4f32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
                // Dst: (ABS_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec)
/* 58376*/    /*SwitchType*/ 9, MVT::v2f64,// ->58387
/* 58378*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58380*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_v2f64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
                // Dst: (ABS_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec)
/* 58387*/    0, // EndSwitchType
/* 58388*/  /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FNEG),// ->58434
/* 58391*/    OPC_RecordChild0, // #0 = $src
/* 58392*/    OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->58402
/* 58395*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 58402*/    /*SwitchType*/ 7, MVT::f64,// ->58411
/* 58404*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 58411*/    /*SwitchType*/ 9, MVT::v4f32,// ->58422
/* 58413*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58415*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_v4f32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
                // Dst: (NEG_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec)
/* 58422*/    /*SwitchType*/ 9, MVT::v2f64,// ->58433
/* 58424*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58426*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_v2f64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
                // Dst: (NEG_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec)
/* 58433*/    0, // EndSwitchType
/* 58434*/  /*SwitchOpcode*/ 68, TARGET_VAL(ISD::FCOPYSIGN),// ->58505
/* 58437*/    OPC_RecordChild0, // #0 = $lhs
/* 58438*/    OPC_RecordChild1, // #1 = $rhs
/* 58439*/    OPC_Scope, 31, /*->58472*/ // 2 children in Scope
/* 58441*/      OPC_CheckChild1Type, MVT::f32,
/* 58443*/      OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->58454
/* 58446*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                      MVT::f32, 2/*#Ops*/, 0, 1, 
                  // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                  // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 58454*/      /*SwitchType*/ 15, MVT::f64,// ->58471
/* 58456*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                      MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 58463*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                      MVT::f64, 2/*#Ops*/, 0, 2, 
                  // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                  // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 58471*/      0, // EndSwitchType
/* 58472*/    /*Scope*/ 31, /*->58504*/
/* 58473*/      OPC_CheckChild1Type, MVT::f64,
/* 58475*/      OPC_SwitchType /*2 cases */, 8, MVT::f64,// ->58486
/* 58478*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                      MVT::f64, 2/*#Ops*/, 0, 1, 
                  // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                  // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 58486*/      /*SwitchType*/ 15, MVT::f32,// ->58503
/* 58488*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                      MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 58495*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                      MVT::f32, 2/*#Ops*/, 0, 2, 
                  // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                  // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 58503*/      0, // EndSwitchType
/* 58504*/    0, /*End of Scope*/
/* 58505*/  /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMINIMUM),// ->58556
/* 58508*/    OPC_RecordChild0, // #0 = $lhs
/* 58509*/    OPC_RecordChild1, // #1 = $rhs
/* 58510*/    OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->58521
/* 58513*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F32), 0,
                    MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 58521*/    /*SwitchType*/ 8, MVT::f64,// ->58531
/* 58523*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F64), 0,
                    MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 58531*/    /*SwitchType*/ 10, MVT::v4f32,// ->58543
/* 58533*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58535*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_v4f32), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
                // Dst: (MIN_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58543*/    /*SwitchType*/ 10, MVT::v2f64,// ->58555
/* 58545*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58547*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_v2f64), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
                // Dst: (MIN_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58555*/    0, // EndSwitchType
/* 58556*/  /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMAXIMUM),// ->58607
/* 58559*/    OPC_RecordChild0, // #0 = $lhs
/* 58560*/    OPC_RecordChild1, // #1 = $rhs
/* 58561*/    OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->58572
/* 58564*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F32), 0,
                    MVT::f32, 2/*#Ops*/, 0, 1, 
                // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
                // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 58572*/    /*SwitchType*/ 8, MVT::f64,// ->58582
/* 58574*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F64), 0,
                    MVT::f64, 2/*#Ops*/, 0, 1, 
                // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
                // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 58582*/    /*SwitchType*/ 10, MVT::v4f32,// ->58594
/* 58584*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58586*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_v4f32), 0,
                    MVT::v4f32, 2/*#Ops*/, 0, 1, 
                // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
                // Dst: (MAX_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 58594*/    /*SwitchType*/ 10, MVT::v2f64,// ->58606
/* 58596*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58598*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_v2f64), 0,
                    MVT::v2f64, 2/*#Ops*/, 0, 1, 
                // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
                // Dst: (MAX_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 58606*/    0, // EndSwitchType
/* 58607*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::FCEIL),// ->58631
/* 58610*/    OPC_RecordChild0, // #0 = $src
/* 58611*/    OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->58621
/* 58614*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 58621*/    /*SwitchType*/ 7, MVT::f64,// ->58630
/* 58623*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 58630*/    0, // EndSwitchType
/* 58631*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::FFLOOR),// ->58655
/* 58634*/    OPC_RecordChild0, // #0 = $src
/* 58635*/    OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->58645
/* 58638*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 58645*/    /*SwitchType*/ 7, MVT::f64,// ->58654
/* 58647*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 58654*/    0, // EndSwitchType
/* 58655*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::FTRUNC),// ->58679
/* 58658*/    OPC_RecordChild0, // #0 = $src
/* 58659*/    OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->58669
/* 58662*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 58669*/    /*SwitchType*/ 7, MVT::f64,// ->58678
/* 58671*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 58678*/    0, // EndSwitchType
/* 58679*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::FNEARBYINT),// ->58703
/* 58682*/    OPC_RecordChild0, // #0 = $src
/* 58683*/    OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->58693
/* 58686*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 58693*/    /*SwitchType*/ 7, MVT::f64,// ->58702
/* 58695*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 58702*/    0, // EndSwitchType
/* 58703*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::FRINT),// ->58727
/* 58706*/    OPC_RecordChild0, // #0 = $src
/* 58707*/    OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->58717
/* 58710*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                    MVT::f32, 1/*#Ops*/, 0, 
                // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
                // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 58717*/    /*SwitchType*/ 7, MVT::f64,// ->58726
/* 58719*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                    MVT::f64, 1/*#Ops*/, 0, 
                // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
                // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 58726*/    0, // EndSwitchType
/* 58727*/  /*SwitchOpcode*/ 38|128,9/*1190*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->59921
/* 58731*/    OPC_RecordChild0, // #0 = $x
/* 58732*/    OPC_Scope, 105, /*->58839*/ // 10 children in Scope
/* 58734*/      OPC_CheckChild0Type, MVT::i32,
/* 58736*/      OPC_CheckChild1Same, 0,
/* 58738*/      OPC_CheckChild2Same, 0,
/* 58740*/      OPC_CheckChild3Same, 0,
/* 58742*/      OPC_Scope, 82, /*->58826*/ // 2 children in Scope
/* 58744*/        OPC_MoveChild4,
/* 58745*/        OPC_CheckSame, 0,
/* 58747*/        OPC_MoveParent,
/* 58748*/        OPC_MoveChild5,
/* 58749*/        OPC_CheckSame, 0,
/* 58751*/        OPC_MoveParent,
/* 58752*/        OPC_MoveChild6,
/* 58753*/        OPC_CheckSame, 0,
/* 58755*/        OPC_MoveParent,
/* 58756*/        OPC_MoveChild7,
/* 58757*/        OPC_CheckSame, 0,
/* 58759*/        OPC_MoveParent,
/* 58760*/        OPC_Scope, 51, /*->58813*/ // 2 children in Scope
/* 58762*/          OPC_MoveChild, 8,
/* 58764*/          OPC_CheckSame, 0,
/* 58766*/          OPC_MoveParent,
/* 58767*/          OPC_MoveChild, 9,
/* 58769*/          OPC_CheckSame, 0,
/* 58771*/          OPC_MoveParent,
/* 58772*/          OPC_MoveChild, 10,
/* 58774*/          OPC_CheckSame, 0,
/* 58776*/          OPC_MoveParent,
/* 58777*/          OPC_MoveChild, 11,
/* 58779*/          OPC_CheckSame, 0,
/* 58781*/          OPC_MoveParent,
/* 58782*/          OPC_MoveChild, 12,
/* 58784*/          OPC_CheckSame, 0,
/* 58786*/          OPC_MoveParent,
/* 58787*/          OPC_MoveChild, 13,
/* 58789*/          OPC_CheckSame, 0,
/* 58791*/          OPC_MoveParent,
/* 58792*/          OPC_MoveChild, 14,
/* 58794*/          OPC_CheckSame, 0,
/* 58796*/          OPC_MoveParent,
/* 58797*/          OPC_MoveChild, 15,
/* 58799*/          OPC_CheckSame, 0,
/* 58801*/          OPC_MoveParent,
/* 58802*/          OPC_CheckType, MVT::v16i8,
/* 58804*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58806*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_v16i8), 0,
                        MVT::v16i8, 1/*#Ops*/, 0, 
                    // Src: (build_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x) - Complexity = 68
                    // Dst: (SPLAT_v16i8:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 58813*/        /*Scope*/ 11, /*->58825*/
/* 58814*/          OPC_CheckType, MVT::v8i16,
/* 58816*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58818*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_v8i16), 0,
                        MVT::v8i16, 1/*#Ops*/, 0, 
                    // Src: (build_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x) - Complexity = 68
                    // Dst: (SPLAT_v8i16:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 58825*/        0, /*End of Scope*/
/* 58826*/      /*Scope*/ 11, /*->58838*/
/* 58827*/        OPC_CheckType, MVT::v4i32,
/* 58829*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58831*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_v4i32), 0,
                      MVT::v4i32, 1/*#Ops*/, 0, 
                  // Src: (build_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x, I32:{ *:[i32] }:$x) - Complexity = 68
                  // Dst: (SPLAT_v4i32:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 58838*/      0, /*End of Scope*/
/* 58839*/    /*Scope*/ 15, /*->58855*/
/* 58840*/      OPC_CheckChild0Type, MVT::i64,
/* 58842*/      OPC_CheckChild1Same, 0,
/* 58844*/      OPC_CheckType, MVT::v2i64,
/* 58846*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 58848*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_v2i64), 0,
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (build_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$x) - Complexity = 68
                // Dst: (SPLAT_v2i64:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 58855*/    /*Scope*/ 31|128,3/*415*/, /*->59272*/
/* 58857*/      OPC_MoveChild0,
/* 58858*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58861*/      OPC_SwitchType /*2 cases */, 123|128,2/*379*/, MVT::i32,// ->59244
/* 58865*/        OPC_Scope, 91|128,1/*219*/, /*->59087*/ // 3 children in Scope
/* 58868*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58870*/          OPC_MoveParent,
/* 58871*/          OPC_RecordChild1, // #1 = $i1
/* 58872*/          OPC_MoveChild1,
/* 58873*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58876*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58878*/          OPC_CheckType, MVT::i32,
/* 58880*/          OPC_MoveParent,
/* 58881*/          OPC_RecordChild2, // #2 = $i2
/* 58882*/          OPC_MoveChild2,
/* 58883*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58886*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58888*/          OPC_CheckType, MVT::i32,
/* 58890*/          OPC_MoveParent,
/* 58891*/          OPC_RecordChild3, // #3 = $i3
/* 58892*/          OPC_MoveChild3,
/* 58893*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58896*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58898*/          OPC_CheckType, MVT::i32,
/* 58900*/          OPC_MoveParent,
/* 58901*/          OPC_RecordChild4, // #4 = $i4
/* 58902*/          OPC_MoveChild4,
/* 58903*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58906*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58908*/          OPC_CheckType, MVT::i32,
/* 58910*/          OPC_MoveParent,
/* 58911*/          OPC_RecordChild5, // #5 = $i5
/* 58912*/          OPC_MoveChild5,
/* 58913*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58916*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58918*/          OPC_CheckType, MVT::i32,
/* 58920*/          OPC_MoveParent,
/* 58921*/          OPC_RecordChild6, // #6 = $i6
/* 58922*/          OPC_MoveChild6,
/* 58923*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58926*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58928*/          OPC_CheckType, MVT::i32,
/* 58930*/          OPC_MoveParent,
/* 58931*/          OPC_RecordChild7, // #7 = $i7
/* 58932*/          OPC_MoveChild7,
/* 58933*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58936*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58938*/          OPC_CheckType, MVT::i32,
/* 58940*/          OPC_MoveParent,
/* 58941*/          OPC_MoveChild, 8,
/* 58943*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58946*/          OPC_RecordNode, // #8 = $i8
/* 58947*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58949*/          OPC_CheckType, MVT::i32,
/* 58951*/          OPC_MoveParent,
/* 58952*/          OPC_MoveChild, 9,
/* 58954*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58957*/          OPC_RecordNode, // #9 = $i9
/* 58958*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58960*/          OPC_CheckType, MVT::i32,
/* 58962*/          OPC_MoveParent,
/* 58963*/          OPC_MoveChild, 10,
/* 58965*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58968*/          OPC_RecordNode, // #10 = $iA
/* 58969*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58971*/          OPC_CheckType, MVT::i32,
/* 58973*/          OPC_MoveParent,
/* 58974*/          OPC_MoveChild, 11,
/* 58976*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58979*/          OPC_RecordNode, // #11 = $iB
/* 58980*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58982*/          OPC_CheckType, MVT::i32,
/* 58984*/          OPC_MoveParent,
/* 58985*/          OPC_MoveChild, 12,
/* 58987*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 58990*/          OPC_RecordNode, // #12 = $iC
/* 58991*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 58993*/          OPC_CheckType, MVT::i32,
/* 58995*/          OPC_MoveParent,
/* 58996*/          OPC_MoveChild, 13,
/* 58998*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59001*/          OPC_RecordNode, // #13 = $iD
/* 59002*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 59004*/          OPC_CheckType, MVT::i32,
/* 59006*/          OPC_MoveParent,
/* 59007*/          OPC_MoveChild, 14,
/* 59009*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59012*/          OPC_RecordNode, // #14 = $iE
/* 59013*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 59015*/          OPC_CheckType, MVT::i32,
/* 59017*/          OPC_MoveParent,
/* 59018*/          OPC_MoveChild, 15,
/* 59020*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59023*/          OPC_RecordNode, // #15 = $iF
/* 59024*/          OPC_CheckPredicate, 27, // Predicate_ImmI8
/* 59026*/          OPC_CheckType, MVT::i32,
/* 59028*/          OPC_MoveParent,
/* 59029*/          OPC_CheckType, MVT::v16i8,
/* 59031*/          OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 59033*/          OPC_EmitConvertToTarget, 0,
/* 59035*/          OPC_EmitConvertToTarget, 1,
/* 59037*/          OPC_EmitConvertToTarget, 2,
/* 59039*/          OPC_EmitConvertToTarget, 3,
/* 59041*/          OPC_EmitConvertToTarget, 4,
/* 59043*/          OPC_EmitConvertToTarget, 5,
/* 59045*/          OPC_EmitConvertToTarget, 6,
/* 59047*/          OPC_EmitConvertToTarget, 7,
/* 59049*/          OPC_EmitConvertToTarget, 8,
/* 59051*/          OPC_EmitConvertToTarget, 9,
/* 59053*/          OPC_EmitConvertToTarget, 10,
/* 59055*/          OPC_EmitConvertToTarget, 11,
/* 59057*/          OPC_EmitConvertToTarget, 12,
/* 59059*/          OPC_EmitConvertToTarget, 13,
/* 59061*/          OPC_EmitConvertToTarget, 14,
/* 59063*/          OPC_EmitConvertToTarget, 15,
/* 59065*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_v16i8), 0,
                        MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
                    // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
                    // Dst: (CONST_V128_v16i8:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 59087*/        /*Scope*/ 107, /*->59195*/
/* 59088*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59090*/          OPC_MoveParent,
/* 59091*/          OPC_RecordChild1, // #1 = $i1
/* 59092*/          OPC_MoveChild1,
/* 59093*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59096*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59098*/          OPC_CheckType, MVT::i32,
/* 59100*/          OPC_MoveParent,
/* 59101*/          OPC_RecordChild2, // #2 = $i2
/* 59102*/          OPC_MoveChild2,
/* 59103*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59106*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59108*/          OPC_CheckType, MVT::i32,
/* 59110*/          OPC_MoveParent,
/* 59111*/          OPC_RecordChild3, // #3 = $i3
/* 59112*/          OPC_MoveChild3,
/* 59113*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59116*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59118*/          OPC_CheckType, MVT::i32,
/* 59120*/          OPC_MoveParent,
/* 59121*/          OPC_RecordChild4, // #4 = $i4
/* 59122*/          OPC_MoveChild4,
/* 59123*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59126*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59128*/          OPC_CheckType, MVT::i32,
/* 59130*/          OPC_MoveParent,
/* 59131*/          OPC_RecordChild5, // #5 = $i5
/* 59132*/          OPC_MoveChild5,
/* 59133*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59136*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59138*/          OPC_CheckType, MVT::i32,
/* 59140*/          OPC_MoveParent,
/* 59141*/          OPC_RecordChild6, // #6 = $i6
/* 59142*/          OPC_MoveChild6,
/* 59143*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59146*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59148*/          OPC_CheckType, MVT::i32,
/* 59150*/          OPC_MoveParent,
/* 59151*/          OPC_RecordChild7, // #7 = $i7
/* 59152*/          OPC_MoveChild7,
/* 59153*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59156*/          OPC_CheckPredicate, 28, // Predicate_ImmI16
/* 59158*/          OPC_CheckType, MVT::i32,
/* 59160*/          OPC_MoveParent,
/* 59161*/          OPC_CheckType, MVT::v8i16,
/* 59163*/          OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 59165*/          OPC_EmitConvertToTarget, 0,
/* 59167*/          OPC_EmitConvertToTarget, 1,
/* 59169*/          OPC_EmitConvertToTarget, 2,
/* 59171*/          OPC_EmitConvertToTarget, 3,
/* 59173*/          OPC_EmitConvertToTarget, 4,
/* 59175*/          OPC_EmitConvertToTarget, 5,
/* 59177*/          OPC_EmitConvertToTarget, 6,
/* 59179*/          OPC_EmitConvertToTarget, 7,
/* 59181*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_v8i16), 0,
                        MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
                    // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
                    // Dst: (CONST_V128_v8i16:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 59195*/        /*Scope*/ 47, /*->59243*/
/* 59196*/          OPC_MoveParent,
/* 59197*/          OPC_RecordChild1, // #1 = $i1
/* 59198*/          OPC_MoveChild1,
/* 59199*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59202*/          OPC_CheckType, MVT::i32,
/* 59204*/          OPC_MoveParent,
/* 59205*/          OPC_RecordChild2, // #2 = $i2
/* 59206*/          OPC_MoveChild2,
/* 59207*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59210*/          OPC_CheckType, MVT::i32,
/* 59212*/          OPC_MoveParent,
/* 59213*/          OPC_RecordChild3, // #3 = $i3
/* 59214*/          OPC_MoveChild3,
/* 59215*/          OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59218*/          OPC_CheckType, MVT::i32,
/* 59220*/          OPC_MoveParent,
/* 59221*/          OPC_CheckType, MVT::v4i32,
/* 59223*/          OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 59225*/          OPC_EmitConvertToTarget, 0,
/* 59227*/          OPC_EmitConvertToTarget, 1,
/* 59229*/          OPC_EmitConvertToTarget, 2,
/* 59231*/          OPC_EmitConvertToTarget, 3,
/* 59233*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_v4i32), 0,
                        MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
                    // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
                    // Dst: (CONST_V128_v4i32:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 59243*/        0, /*End of Scope*/
/* 59244*/      /*SwitchType*/ 25, MVT::i64,// ->59271
/* 59246*/        OPC_MoveParent,
/* 59247*/        OPC_RecordChild1, // #1 = $i1
/* 59248*/        OPC_MoveChild1,
/* 59249*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59252*/        OPC_CheckType, MVT::i64,
/* 59254*/        OPC_MoveParent,
/* 59255*/        OPC_CheckType, MVT::v2i64,
/* 59257*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 59259*/        OPC_EmitConvertToTarget, 0,
/* 59261*/        OPC_EmitConvertToTarget, 1,
/* 59263*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_v2i64), 0,
                      MVT::v2i64, 2/*#Ops*/, 2, 3, 
                  // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
                  // Dst: (CONST_V128_v2i64:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 59271*/      0, // EndSwitchType
/* 59272*/    /*Scope*/ 26, /*->59299*/
/* 59273*/      OPC_CheckChild0Type, MVT::i64,
/* 59275*/      OPC_RecordChild1, // #1 = $x1
/* 59276*/      OPC_CheckChild1Type, MVT::i64,
/* 59278*/      OPC_CheckType, MVT::v2i64,
/* 59280*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::SPLAT_v2i64), 0,
                    MVT::v2i64, 1/*#Ops*/, 0,  // Results = #2
/* 59287*/      OPC_EmitInteger, MVT::i32, 1, 
/* 59290*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v2i64), 0,
                    MVT::v2i64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (build_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x0, I64:{ *:[i64] }:$x1) - Complexity = 3
                // Dst: (REPLACE_LANE_v2i64:{ *:[v2i64] } (SPLAT_v2i64:{ *:[v2i64] } I64:{ *:[i64] }:$x0), 1:{ *:[i32] }, I64:{ *:[i64] }:$x1)
/* 59299*/    /*Scope*/ 32|128,3/*416*/, /*->59717*/
/* 59301*/      OPC_CheckChild0Type, MVT::i32,
/* 59303*/      OPC_RecordChild1, // #1 = $x1
/* 59304*/      OPC_CheckChild1Type, MVT::i32,
/* 59306*/      OPC_RecordChild2, // #2 = $x2
/* 59307*/      OPC_CheckChild2Type, MVT::i32,
/* 59309*/      OPC_RecordChild3, // #3 = $x3
/* 59310*/      OPC_CheckChild3Type, MVT::i32,
/* 59312*/      OPC_Scope, 45, /*->59359*/ // 3 children in Scope
/* 59314*/        OPC_CheckType, MVT::v4i32,
/* 59316*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::SPLAT_v4i32), 0,
                      MVT::v4i32, 1/*#Ops*/, 0,  // Results = #4
/* 59323*/        OPC_EmitInteger, MVT::i32, 1, 
/* 59326*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4i32), 0,
                      MVT::v4i32, 3/*#Ops*/, 4, 5, 1,  // Results = #6
/* 59335*/        OPC_EmitInteger, MVT::i32, 2, 
/* 59338*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4i32), 0,
                      MVT::v4i32, 3/*#Ops*/, 6, 7, 2,  // Results = #8
/* 59347*/        OPC_EmitInteger, MVT::i32, 3, 
/* 59350*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4i32), 0,
                      MVT::v4i32, 3/*#Ops*/, 8, 9, 3, 
                  // Src: (build_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x0, I32:{ *:[i32] }:$x1, I32:{ *:[i32] }:$x2, I32:{ *:[i32] }:$x3) - Complexity = 3
                  // Dst: (REPLACE_LANE_v4i32:{ *:[v4i32] } (REPLACE_LANE_v4i32:{ *:[v4i32] } (REPLACE_LANE_v4i32:{ *:[v4i32] } (SPLAT_v4i32:{ *:[v4i32] } I32:{ *:[i32] }:$x0), 1:{ *:[i32] }, I32:{ *:[i32] }:$x1), 2:{ *:[i32] }, I32:{ *:[i32] }:$x2), 3:{ *:[i32] }, I32:{ *:[i32] }:$x3)
/* 59359*/      /*Scope*/ 105, /*->59465*/
/* 59360*/        OPC_CheckType, MVT::v8i16,
/* 59362*/        OPC_RecordChild4, // #4 = $x4
/* 59363*/        OPC_CheckChild4Type, MVT::i32,
/* 59365*/        OPC_RecordChild5, // #5 = $x5
/* 59366*/        OPC_CheckChild5Type, MVT::i32,
/* 59368*/        OPC_RecordChild6, // #6 = $x6
/* 59369*/        OPC_CheckChild6Type, MVT::i32,
/* 59371*/        OPC_RecordChild7, // #7 = $x7
/* 59372*/        OPC_CheckChild7Type, MVT::i32,
/* 59374*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::SPLAT_v8i16), 0,
                      MVT::v8i16, 1/*#Ops*/, 0,  // Results = #8
/* 59381*/        OPC_EmitInteger, MVT::i32, 1, 
/* 59384*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 8, 9, 1,  // Results = #10
/* 59393*/        OPC_EmitInteger, MVT::i32, 2, 
/* 59396*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 10, 11, 2,  // Results = #12
/* 59405*/        OPC_EmitInteger, MVT::i32, 3, 
/* 59408*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 12, 13, 3,  // Results = #14
/* 59417*/        OPC_EmitInteger, MVT::i32, 4, 
/* 59420*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 14, 15, 4,  // Results = #16
/* 59429*/        OPC_EmitInteger, MVT::i32, 5, 
/* 59432*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 16, 17, 5,  // Results = #18
/* 59441*/        OPC_EmitInteger, MVT::i32, 6, 
/* 59444*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 18, 19, 6,  // Results = #20
/* 59453*/        OPC_EmitInteger, MVT::i32, 7, 
/* 59456*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                      MVT::v8i16, 3/*#Ops*/, 20, 21, 7, 
                  // Src: (build_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x0, I32:{ *:[i32] }:$x1, I32:{ *:[i32] }:$x2, I32:{ *:[i32] }:$x3, I32:{ *:[i32] }:$x4, I32:{ *:[i32] }:$x5, I32:{ *:[i32] }:$x6, I32:{ *:[i32] }:$x7) - Complexity = 3
                  // Dst: (REPLACE_LANE_v8i16:{ *:[v8i16] } (REPLACE_LANE_v8i16:{ *:[v8i16] } (REPLACE_LANE_v8i16:{ *:[v8i16] } (REPLACE_LANE_v8i16:{ *:[v8i16] } (REPLACE_LANE_v8i16:{ *:[v8i16] } (REPLACE_LANE_v8i16:{ *:[v8i16] } (REPLACE_LANE_v8i16:{ *:[v8i16] } (SPLAT_v8i16:{ *:[v8i16] } I32:{ *:[i32] }:$x0), 1:{ *:[i32] }, I32:{ *:[i32] }:$x1), 2:{ *:[i32] }, I32:{ *:[i32] }:$x2), 3:{ *:[i32] }, I32:{ *:[i32] }:$x3), 4:{ *:[i32] }, I32:{ *:[i32] }:$x4), 5:{ *:[i32] }, I32:{ *:[i32] }:$x5), 6:{ *:[i32] }, I32:{ *:[i32] }:$x6), 7:{ *:[i32] }, I32:{ *:[i32] }:$x7)
/* 59465*/      /*Scope*/ 121|128,1/*249*/, /*->59716*/
/* 59467*/        OPC_RecordChild4, // #4 = $x4
/* 59468*/        OPC_CheckChild4Type, MVT::i32,
/* 59470*/        OPC_RecordChild5, // #5 = $x5
/* 59471*/        OPC_CheckChild5Type, MVT::i32,
/* 59473*/        OPC_RecordChild6, // #6 = $x6
/* 59474*/        OPC_CheckChild6Type, MVT::i32,
/* 59476*/        OPC_RecordChild7, // #7 = $x7
/* 59477*/        OPC_CheckChild7Type, MVT::i32,
/* 59479*/        OPC_MoveChild, 8,
/* 59481*/        OPC_RecordNode, // #8 = $x8
/* 59482*/        OPC_CheckType, MVT::i32,
/* 59484*/        OPC_MoveParent,
/* 59485*/        OPC_MoveChild, 9,
/* 59487*/        OPC_RecordNode, // #9 = $x9
/* 59488*/        OPC_CheckType, MVT::i32,
/* 59490*/        OPC_MoveParent,
/* 59491*/        OPC_MoveChild, 10,
/* 59493*/        OPC_RecordNode, // #10 = $x10
/* 59494*/        OPC_CheckType, MVT::i32,
/* 59496*/        OPC_MoveParent,
/* 59497*/        OPC_MoveChild, 11,
/* 59499*/        OPC_RecordNode, // #11 = $x11
/* 59500*/        OPC_CheckType, MVT::i32,
/* 59502*/        OPC_MoveParent,
/* 59503*/        OPC_MoveChild, 12,
/* 59505*/        OPC_RecordNode, // #12 = $x12
/* 59506*/        OPC_CheckType, MVT::i32,
/* 59508*/        OPC_MoveParent,
/* 59509*/        OPC_MoveChild, 13,
/* 59511*/        OPC_RecordNode, // #13 = $x13
/* 59512*/        OPC_CheckType, MVT::i32,
/* 59514*/        OPC_MoveParent,
/* 59515*/        OPC_MoveChild, 14,
/* 59517*/        OPC_RecordNode, // #14 = $x14
/* 59518*/        OPC_CheckType, MVT::i32,
/* 59520*/        OPC_MoveParent,
/* 59521*/        OPC_MoveChild, 15,
/* 59523*/        OPC_RecordNode, // #15 = $x15
/* 59524*/        OPC_CheckType, MVT::i32,
/* 59526*/        OPC_MoveParent,
/* 59527*/        OPC_CheckType, MVT::v16i8,
/* 59529*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::SPLAT_v16i8), 0,
                      MVT::v16i8, 1/*#Ops*/, 0,  // Results = #16
/* 59536*/        OPC_EmitInteger, MVT::i32, 1, 
/* 59539*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 16, 17, 1,  // Results = #18
/* 59548*/        OPC_EmitInteger, MVT::i32, 2, 
/* 59551*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 18, 19, 2,  // Results = #20
/* 59560*/        OPC_EmitInteger, MVT::i32, 3, 
/* 59563*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 20, 21, 3,  // Results = #22
/* 59572*/        OPC_EmitInteger, MVT::i32, 4, 
/* 59575*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 22, 23, 4,  // Results = #24
/* 59584*/        OPC_EmitInteger, MVT::i32, 5, 
/* 59587*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 24, 25, 5,  // Results = #26
/* 59596*/        OPC_EmitInteger, MVT::i32, 6, 
/* 59599*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 26, 27, 6,  // Results = #28
/* 59608*/        OPC_EmitInteger, MVT::i32, 7, 
/* 59611*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 28, 29, 7,  // Results = #30
/* 59620*/        OPC_EmitInteger, MVT::i32, 8, 
/* 59623*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 30, 31, 8,  // Results = #32
/* 59632*/        OPC_EmitInteger, MVT::i32, 9, 
/* 59635*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 32, 33, 9,  // Results = #34
/* 59644*/        OPC_EmitInteger, MVT::i32, 10, 
/* 59647*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 34, 35, 10,  // Results = #36
/* 59656*/        OPC_EmitInteger, MVT::i32, 11, 
/* 59659*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 36, 37, 11,  // Results = #38
/* 59668*/        OPC_EmitInteger, MVT::i32, 12, 
/* 59671*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 38, 39, 12,  // Results = #40
/* 59680*/        OPC_EmitInteger, MVT::i32, 13, 
/* 59683*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 40, 41, 13,  // Results = #42
/* 59692*/        OPC_EmitInteger, MVT::i32, 14, 
/* 59695*/        OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 42, 43, 14,  // Results = #44
/* 59704*/        OPC_EmitInteger, MVT::i32, 15, 
/* 59707*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                      MVT::v16i8, 3/*#Ops*/, 44, 45, 15, 
                  // Src: (build_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x0, I32:{ *:[i32] }:$x1, I32:{ *:[i32] }:$x2, I32:{ *:[i32] }:$x3, I32:{ *:[i32] }:$x4, I32:{ *:[i32] }:$x5, I32:{ *:[i32] }:$x6, I32:{ *:[i32] }:$x7, I32:{ *:[i32] }:$x8, I32:{ *:[i32] }:$x9, I32:{ *:[i32] }:$x10, I32:{ *:[i32] }:$x11, I32:{ *:[i32] }:$x12, I32:{ *:[i32] }:$x13, I32:{ *:[i32] }:$x14, I32:{ *:[i32] }:$x15) - Complexity = 3
                  // Dst: (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (REPLACE_LANE_v16i8:{ *:[v16i8] } (SPLAT_v16i8:{ *:[v16i8] } I32:{ *:[i32] }:$x0), 1:{ *:[i32] }, I32:{ *:[i32] }:$x1), 2:{ *:[i32] }, I32:{ *:[i32] }:$x2), 3:{ *:[i32] }, I32:{ *:[i32] }:$x3), 4:{ *:[i32] }, I32:{ *:[i32] }:$x4), 5:{ *:[i32] }, I32:{ *:[i32] }:$x5), 6:{ *:[i32] }, I32:{ *:[i32] }:$x6), 7:{ *:[i32] }, I32:{ *:[i32] }:$x7), 8:{ *:[i32] }, I32:{ *:[i32] }:$x8), 9:{ *:[i32] }, I32:{ *:[i32] }:$x9), 10:{ *:[i32] }, I32:{ *:[i32] }:$x10), 11:{ *:[i32] }, I32:{ *:[i32] }:$x11), 12:{ *:[i32] }, I32:{ *:[i32] }:$x12), 13:{ *:[i32] }, I32:{ *:[i32] }:$x13), 14:{ *:[i32] }, I32:{ *:[i32] }:$x14), 15:{ *:[i32] }, I32:{ *:[i32] }:$x15)
/* 59716*/      0, /*End of Scope*/
/* 59717*/    /*Scope*/ 19, /*->59737*/
/* 59718*/      OPC_CheckChild0Type, MVT::f32,
/* 59720*/      OPC_CheckChild1Same, 0,
/* 59722*/      OPC_CheckChild2Same, 0,
/* 59724*/      OPC_CheckChild3Same, 0,
/* 59726*/      OPC_CheckType, MVT::v4f32,
/* 59728*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 59730*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_v4f32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0, 
                // Src: (build_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x, F32:{ *:[f32] }:$x, F32:{ *:[f32] }:$x, F32:{ *:[f32] }:$x) - Complexity = 68
                // Dst: (SPLAT_v4f32:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 59737*/    /*Scope*/ 15, /*->59753*/
/* 59738*/      OPC_CheckChild0Type, MVT::f64,
/* 59740*/      OPC_CheckChild1Same, 0,
/* 59742*/      OPC_CheckType, MVT::v2f64,
/* 59744*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 59746*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_v2f64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0, 
                // Src: (build_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x, F64:{ *:[f64] }:$x) - Complexity = 68
                // Dst: (SPLAT_v2f64:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 59753*/    /*Scope*/ 82, /*->59836*/
/* 59754*/      OPC_MoveChild0,
/* 59755*/      OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 59758*/      OPC_SwitchType /*2 cases */, 47, MVT::f32,// ->59808
/* 59761*/        OPC_MoveParent,
/* 59762*/        OPC_RecordChild1, // #1 = $i1
/* 59763*/        OPC_MoveChild1,
/* 59764*/        OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 59767*/        OPC_CheckType, MVT::f32,
/* 59769*/        OPC_MoveParent,
/* 59770*/        OPC_RecordChild2, // #2 = $i2
/* 59771*/        OPC_MoveChild2,
/* 59772*/        OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 59775*/        OPC_CheckType, MVT::f32,
/* 59777*/        OPC_MoveParent,
/* 59778*/        OPC_RecordChild3, // #3 = $i3
/* 59779*/        OPC_MoveChild3,
/* 59780*/        OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 59783*/        OPC_CheckType, MVT::f32,
/* 59785*/        OPC_MoveParent,
/* 59786*/        OPC_CheckType, MVT::v4f32,
/* 59788*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 59790*/        OPC_EmitConvertToTarget, 0,
/* 59792*/        OPC_EmitConvertToTarget, 1,
/* 59794*/        OPC_EmitConvertToTarget, 2,
/* 59796*/        OPC_EmitConvertToTarget, 3,
/* 59798*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_v4f32), 0,
                      MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
                  // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
                  // Dst: (CONST_V128_v4f32:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 59808*/      /*SwitchType*/ 25, MVT::f64,// ->59835
/* 59810*/        OPC_MoveParent,
/* 59811*/        OPC_RecordChild1, // #1 = $i1
/* 59812*/        OPC_MoveChild1,
/* 59813*/        OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 59816*/        OPC_CheckType, MVT::f64,
/* 59818*/        OPC_MoveParent,
/* 59819*/        OPC_CheckType, MVT::v2f64,
/* 59821*/        OPC_CheckPatternPredicate, 1, // (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128())
/* 59823*/        OPC_EmitConvertToTarget, 0,
/* 59825*/        OPC_EmitConvertToTarget, 1,
/* 59827*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_v2f64), 0,
                      MVT::v2f64, 2/*#Ops*/, 2, 3, 
                  // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
                  // Dst: (CONST_V128_v2f64:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 59835*/      0, // EndSwitchType
/* 59836*/    /*Scope*/ 26, /*->59863*/
/* 59837*/      OPC_CheckChild0Type, MVT::f64,
/* 59839*/      OPC_RecordChild1, // #1 = $x1
/* 59840*/      OPC_CheckChild1Type, MVT::f64,
/* 59842*/      OPC_CheckType, MVT::v2f64,
/* 59844*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::SPLAT_v2f64), 0,
                    MVT::v2f64, 1/*#Ops*/, 0,  // Results = #2
/* 59851*/      OPC_EmitInteger, MVT::i32, 1, 
/* 59854*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v2f64), 0,
                    MVT::v2f64, 3/*#Ops*/, 2, 3, 1, 
                // Src: (build_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x0, F64:{ *:[f64] }:$x1) - Complexity = 3
                // Dst: (REPLACE_LANE_v2f64:{ *:[v2f64] } (SPLAT_v2f64:{ *:[v2f64] } F64:{ *:[f64] }:$x0), 1:{ *:[i32] }, F64:{ *:[f64] }:$x1)
/* 59863*/    /*Scope*/ 56, /*->59920*/
/* 59864*/      OPC_CheckChild0Type, MVT::f32,
/* 59866*/      OPC_RecordChild1, // #1 = $x1
/* 59867*/      OPC_CheckChild1Type, MVT::f32,
/* 59869*/      OPC_RecordChild2, // #2 = $x2
/* 59870*/      OPC_CheckChild2Type, MVT::f32,
/* 59872*/      OPC_RecordChild3, // #3 = $x3
/* 59873*/      OPC_CheckChild3Type, MVT::f32,
/* 59875*/      OPC_CheckType, MVT::v4f32,
/* 59877*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::SPLAT_v4f32), 0,
                    MVT::v4f32, 1/*#Ops*/, 0,  // Results = #4
/* 59884*/      OPC_EmitInteger, MVT::i32, 1, 
/* 59887*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4f32), 0,
                    MVT::v4f32, 3/*#Ops*/, 4, 5, 1,  // Results = #6
/* 59896*/      OPC_EmitInteger, MVT::i32, 2, 
/* 59899*/      OPC_EmitNode1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4f32), 0,
                    MVT::v4f32, 3/*#Ops*/, 6, 7, 2,  // Results = #8
/* 59908*/      OPC_EmitInteger, MVT::i32, 3, 
/* 59911*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4f32), 0,
                    MVT::v4f32, 3/*#Ops*/, 8, 9, 3, 
                // Src: (build_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x0, F32:{ *:[f32] }:$x1, F32:{ *:[f32] }:$x2, F32:{ *:[f32] }:$x3) - Complexity = 3
                // Dst: (REPLACE_LANE_v4f32:{ *:[v4f32] } (REPLACE_LANE_v4f32:{ *:[v4f32] } (REPLACE_LANE_v4f32:{ *:[v4f32] } (SPLAT_v4f32:{ *:[v4f32] } F32:{ *:[f32] }:$x0), 1:{ *:[i32] }, F32:{ *:[f32] }:$x1), 2:{ *:[i32] }, F32:{ *:[f32] }:$x2), 3:{ *:[i32] }, F32:{ *:[f32] }:$x3)
/* 59920*/    0, /*End of Scope*/
/* 59921*/  /*SwitchOpcode*/ 5|128,11/*1413*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->61338
/* 59925*/    OPC_RecordChild0, // #0 = $x
/* 59926*/    OPC_Scope, 105|128,1/*233*/, /*->60162*/ // 6 children in Scope
/* 59929*/      OPC_CheckChild0Type, MVT::v16i8,
/* 59931*/      OPC_RecordChild1, // #1 = $y
/* 59932*/      OPC_CheckChild1Type, MVT::v16i8,
/* 59934*/      OPC_RecordChild2, // #2 = $m0
/* 59935*/      OPC_MoveChild2,
/* 59936*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59939*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 59941*/      OPC_CheckType, MVT::i32,
/* 59943*/      OPC_MoveParent,
/* 59944*/      OPC_RecordChild3, // #3 = $m1
/* 59945*/      OPC_MoveChild3,
/* 59946*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59949*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 59951*/      OPC_CheckType, MVT::i32,
/* 59953*/      OPC_MoveParent,
/* 59954*/      OPC_RecordChild4, // #4 = $m2
/* 59955*/      OPC_MoveChild4,
/* 59956*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59959*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 59961*/      OPC_CheckType, MVT::i32,
/* 59963*/      OPC_MoveParent,
/* 59964*/      OPC_RecordChild5, // #5 = $m3
/* 59965*/      OPC_MoveChild5,
/* 59966*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59969*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 59971*/      OPC_CheckType, MVT::i32,
/* 59973*/      OPC_MoveParent,
/* 59974*/      OPC_RecordChild6, // #6 = $m4
/* 59975*/      OPC_MoveChild6,
/* 59976*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59979*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 59981*/      OPC_CheckType, MVT::i32,
/* 59983*/      OPC_MoveParent,
/* 59984*/      OPC_RecordChild7, // #7 = $m5
/* 59985*/      OPC_MoveChild7,
/* 59986*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59989*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 59991*/      OPC_CheckType, MVT::i32,
/* 59993*/      OPC_MoveParent,
/* 59994*/      OPC_MoveChild, 8,
/* 59996*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 59999*/      OPC_RecordNode, // #8 = $m6
/* 60000*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60002*/      OPC_CheckType, MVT::i32,
/* 60004*/      OPC_MoveParent,
/* 60005*/      OPC_MoveChild, 9,
/* 60007*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60010*/      OPC_RecordNode, // #9 = $m7
/* 60011*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60013*/      OPC_CheckType, MVT::i32,
/* 60015*/      OPC_MoveParent,
/* 60016*/      OPC_MoveChild, 10,
/* 60018*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60021*/      OPC_RecordNode, // #10 = $m8
/* 60022*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60024*/      OPC_CheckType, MVT::i32,
/* 60026*/      OPC_MoveParent,
/* 60027*/      OPC_MoveChild, 11,
/* 60029*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60032*/      OPC_RecordNode, // #11 = $m9
/* 60033*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60035*/      OPC_CheckType, MVT::i32,
/* 60037*/      OPC_MoveParent,
/* 60038*/      OPC_MoveChild, 12,
/* 60040*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60043*/      OPC_RecordNode, // #12 = $mA
/* 60044*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60046*/      OPC_CheckType, MVT::i32,
/* 60048*/      OPC_MoveParent,
/* 60049*/      OPC_MoveChild, 13,
/* 60051*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60054*/      OPC_RecordNode, // #13 = $mB
/* 60055*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60057*/      OPC_CheckType, MVT::i32,
/* 60059*/      OPC_MoveParent,
/* 60060*/      OPC_MoveChild, 14,
/* 60062*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60065*/      OPC_RecordNode, // #14 = $mC
/* 60066*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60068*/      OPC_CheckType, MVT::i32,
/* 60070*/      OPC_MoveParent,
/* 60071*/      OPC_MoveChild, 15,
/* 60073*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60076*/      OPC_RecordNode, // #15 = $mD
/* 60077*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60079*/      OPC_CheckType, MVT::i32,
/* 60081*/      OPC_MoveParent,
/* 60082*/      OPC_MoveChild, 16,
/* 60084*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60087*/      OPC_RecordNode, // #16 = $mE
/* 60088*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60090*/      OPC_CheckType, MVT::i32,
/* 60092*/      OPC_MoveParent,
/* 60093*/      OPC_MoveChild, 17,
/* 60095*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60098*/      OPC_RecordNode, // #17 = $mF
/* 60099*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60101*/      OPC_CheckType, MVT::i32,
/* 60103*/      OPC_MoveParent,
/* 60104*/      OPC_CheckType, MVT::v16i8,
/* 60106*/      OPC_EmitConvertToTarget, 2,
/* 60108*/      OPC_EmitConvertToTarget, 3,
/* 60110*/      OPC_EmitConvertToTarget, 4,
/* 60112*/      OPC_EmitConvertToTarget, 5,
/* 60114*/      OPC_EmitConvertToTarget, 6,
/* 60116*/      OPC_EmitConvertToTarget, 7,
/* 60118*/      OPC_EmitConvertToTarget, 8,
/* 60120*/      OPC_EmitConvertToTarget, 9,
/* 60122*/      OPC_EmitConvertToTarget, 10,
/* 60124*/      OPC_EmitConvertToTarget, 11,
/* 60126*/      OPC_EmitConvertToTarget, 12,
/* 60128*/      OPC_EmitConvertToTarget, 13,
/* 60130*/      OPC_EmitConvertToTarget, 14,
/* 60132*/      OPC_EmitConvertToTarget, 15,
/* 60134*/      OPC_EmitConvertToTarget, 16,
/* 60136*/      OPC_EmitConvertToTarget, 17,
/* 60138*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                    MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
                // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
                // Dst: (SHUFFLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF)
/* 60162*/    /*Scope*/ 105|128,1/*233*/, /*->60397*/
/* 60164*/      OPC_CheckChild0Type, MVT::v8i16,
/* 60166*/      OPC_RecordChild1, // #1 = $y
/* 60167*/      OPC_CheckChild1Type, MVT::v8i16,
/* 60169*/      OPC_RecordChild2, // #2 = $m0
/* 60170*/      OPC_MoveChild2,
/* 60171*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60174*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60176*/      OPC_CheckType, MVT::i32,
/* 60178*/      OPC_MoveParent,
/* 60179*/      OPC_RecordChild3, // #3 = $m1
/* 60180*/      OPC_MoveChild3,
/* 60181*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60184*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60186*/      OPC_CheckType, MVT::i32,
/* 60188*/      OPC_MoveParent,
/* 60189*/      OPC_RecordChild4, // #4 = $m2
/* 60190*/      OPC_MoveChild4,
/* 60191*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60194*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60196*/      OPC_CheckType, MVT::i32,
/* 60198*/      OPC_MoveParent,
/* 60199*/      OPC_RecordChild5, // #5 = $m3
/* 60200*/      OPC_MoveChild5,
/* 60201*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60204*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60206*/      OPC_CheckType, MVT::i32,
/* 60208*/      OPC_MoveParent,
/* 60209*/      OPC_RecordChild6, // #6 = $m4
/* 60210*/      OPC_MoveChild6,
/* 60211*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60214*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60216*/      OPC_CheckType, MVT::i32,
/* 60218*/      OPC_MoveParent,
/* 60219*/      OPC_RecordChild7, // #7 = $m5
/* 60220*/      OPC_MoveChild7,
/* 60221*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60224*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60226*/      OPC_CheckType, MVT::i32,
/* 60228*/      OPC_MoveParent,
/* 60229*/      OPC_MoveChild, 8,
/* 60231*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60234*/      OPC_RecordNode, // #8 = $m6
/* 60235*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60237*/      OPC_CheckType, MVT::i32,
/* 60239*/      OPC_MoveParent,
/* 60240*/      OPC_MoveChild, 9,
/* 60242*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60245*/      OPC_RecordNode, // #9 = $m7
/* 60246*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60248*/      OPC_CheckType, MVT::i32,
/* 60250*/      OPC_MoveParent,
/* 60251*/      OPC_MoveChild, 10,
/* 60253*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60256*/      OPC_RecordNode, // #10 = $m8
/* 60257*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60259*/      OPC_CheckType, MVT::i32,
/* 60261*/      OPC_MoveParent,
/* 60262*/      OPC_MoveChild, 11,
/* 60264*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60267*/      OPC_RecordNode, // #11 = $m9
/* 60268*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60270*/      OPC_CheckType, MVT::i32,
/* 60272*/      OPC_MoveParent,
/* 60273*/      OPC_MoveChild, 12,
/* 60275*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60278*/      OPC_RecordNode, // #12 = $mA
/* 60279*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60281*/      OPC_CheckType, MVT::i32,
/* 60283*/      OPC_MoveParent,
/* 60284*/      OPC_MoveChild, 13,
/* 60286*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60289*/      OPC_RecordNode, // #13 = $mB
/* 60290*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60292*/      OPC_CheckType, MVT::i32,
/* 60294*/      OPC_MoveParent,
/* 60295*/      OPC_MoveChild, 14,
/* 60297*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60300*/      OPC_RecordNode, // #14 = $mC
/* 60301*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60303*/      OPC_CheckType, MVT::i32,
/* 60305*/      OPC_MoveParent,
/* 60306*/      OPC_MoveChild, 15,
/* 60308*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60311*/      OPC_RecordNode, // #15 = $mD
/* 60312*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60314*/      OPC_CheckType, MVT::i32,
/* 60316*/      OPC_MoveParent,
/* 60317*/      OPC_MoveChild, 16,
/* 60319*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60322*/      OPC_RecordNode, // #16 = $mE
/* 60323*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60325*/      OPC_CheckType, MVT::i32,
/* 60327*/      OPC_MoveParent,
/* 60328*/      OPC_MoveChild, 17,
/* 60330*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60333*/      OPC_RecordNode, // #17 = $mF
/* 60334*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60336*/      OPC_CheckType, MVT::i32,
/* 60338*/      OPC_MoveParent,
/* 60339*/      OPC_CheckType, MVT::v8i16,
/* 60341*/      OPC_EmitConvertToTarget, 2,
/* 60343*/      OPC_EmitConvertToTarget, 3,
/* 60345*/      OPC_EmitConvertToTarget, 4,
/* 60347*/      OPC_EmitConvertToTarget, 5,
/* 60349*/      OPC_EmitConvertToTarget, 6,
/* 60351*/      OPC_EmitConvertToTarget, 7,
/* 60353*/      OPC_EmitConvertToTarget, 8,
/* 60355*/      OPC_EmitConvertToTarget, 9,
/* 60357*/      OPC_EmitConvertToTarget, 10,
/* 60359*/      OPC_EmitConvertToTarget, 11,
/* 60361*/      OPC_EmitConvertToTarget, 12,
/* 60363*/      OPC_EmitConvertToTarget, 13,
/* 60365*/      OPC_EmitConvertToTarget, 14,
/* 60367*/      OPC_EmitConvertToTarget, 15,
/* 60369*/      OPC_EmitConvertToTarget, 16,
/* 60371*/      OPC_EmitConvertToTarget, 17,
/* 60373*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                    MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
                // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
                // Dst: (SHUFFLE:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF)
/* 60397*/    /*Scope*/ 105|128,1/*233*/, /*->60632*/
/* 60399*/      OPC_CheckChild0Type, MVT::v4i32,
/* 60401*/      OPC_RecordChild1, // #1 = $y
/* 60402*/      OPC_CheckChild1Type, MVT::v4i32,
/* 60404*/      OPC_RecordChild2, // #2 = $m0
/* 60405*/      OPC_MoveChild2,
/* 60406*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60409*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60411*/      OPC_CheckType, MVT::i32,
/* 60413*/      OPC_MoveParent,
/* 60414*/      OPC_RecordChild3, // #3 = $m1
/* 60415*/      OPC_MoveChild3,
/* 60416*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60419*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60421*/      OPC_CheckType, MVT::i32,
/* 60423*/      OPC_MoveParent,
/* 60424*/      OPC_RecordChild4, // #4 = $m2
/* 60425*/      OPC_MoveChild4,
/* 60426*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60429*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60431*/      OPC_CheckType, MVT::i32,
/* 60433*/      OPC_MoveParent,
/* 60434*/      OPC_RecordChild5, // #5 = $m3
/* 60435*/      OPC_MoveChild5,
/* 60436*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60439*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60441*/      OPC_CheckType, MVT::i32,
/* 60443*/      OPC_MoveParent,
/* 60444*/      OPC_RecordChild6, // #6 = $m4
/* 60445*/      OPC_MoveChild6,
/* 60446*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60449*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60451*/      OPC_CheckType, MVT::i32,
/* 60453*/      OPC_MoveParent,
/* 60454*/      OPC_RecordChild7, // #7 = $m5
/* 60455*/      OPC_MoveChild7,
/* 60456*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60459*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60461*/      OPC_CheckType, MVT::i32,
/* 60463*/      OPC_MoveParent,
/* 60464*/      OPC_MoveChild, 8,
/* 60466*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60469*/      OPC_RecordNode, // #8 = $m6
/* 60470*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60472*/      OPC_CheckType, MVT::i32,
/* 60474*/      OPC_MoveParent,
/* 60475*/      OPC_MoveChild, 9,
/* 60477*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60480*/      OPC_RecordNode, // #9 = $m7
/* 60481*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60483*/      OPC_CheckType, MVT::i32,
/* 60485*/      OPC_MoveParent,
/* 60486*/      OPC_MoveChild, 10,
/* 60488*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60491*/      OPC_RecordNode, // #10 = $m8
/* 60492*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60494*/      OPC_CheckType, MVT::i32,
/* 60496*/      OPC_MoveParent,
/* 60497*/      OPC_MoveChild, 11,
/* 60499*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60502*/      OPC_RecordNode, // #11 = $m9
/* 60503*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60505*/      OPC_CheckType, MVT::i32,
/* 60507*/      OPC_MoveParent,
/* 60508*/      OPC_MoveChild, 12,
/* 60510*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60513*/      OPC_RecordNode, // #12 = $mA
/* 60514*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60516*/      OPC_CheckType, MVT::i32,
/* 60518*/      OPC_MoveParent,
/* 60519*/      OPC_MoveChild, 13,
/* 60521*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60524*/      OPC_RecordNode, // #13 = $mB
/* 60525*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60527*/      OPC_CheckType, MVT::i32,
/* 60529*/      OPC_MoveParent,
/* 60530*/      OPC_MoveChild, 14,
/* 60532*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60535*/      OPC_RecordNode, // #14 = $mC
/* 60536*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60538*/      OPC_CheckType, MVT::i32,
/* 60540*/      OPC_MoveParent,
/* 60541*/      OPC_MoveChild, 15,
/* 60543*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60546*/      OPC_RecordNode, // #15 = $mD
/* 60547*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60549*/      OPC_CheckType, MVT::i32,
/* 60551*/      OPC_MoveParent,
/* 60552*/      OPC_MoveChild, 16,
/* 60554*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60557*/      OPC_RecordNode, // #16 = $mE
/* 60558*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60560*/      OPC_CheckType, MVT::i32,
/* 60562*/      OPC_MoveParent,
/* 60563*/      OPC_MoveChild, 17,
/* 60565*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60568*/      OPC_RecordNode, // #17 = $mF
/* 60569*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60571*/      OPC_CheckType, MVT::i32,
/* 60573*/      OPC_MoveParent,
/* 60574*/      OPC_CheckType, MVT::v4i32,
/* 60576*/      OPC_EmitConvertToTarget, 2,
/* 60578*/      OPC_EmitConvertToTarget, 3,
/* 60580*/      OPC_EmitConvertToTarget, 4,
/* 60582*/      OPC_EmitConvertToTarget, 5,
/* 60584*/      OPC_EmitConvertToTarget, 6,
/* 60586*/      OPC_EmitConvertToTarget, 7,
/* 60588*/      OPC_EmitConvertToTarget, 8,
/* 60590*/      OPC_EmitConvertToTarget, 9,
/* 60592*/      OPC_EmitConvertToTarget, 10,
/* 60594*/      OPC_EmitConvertToTarget, 11,
/* 60596*/      OPC_EmitConvertToTarget, 12,
/* 60598*/      OPC_EmitConvertToTarget, 13,
/* 60600*/      OPC_EmitConvertToTarget, 14,
/* 60602*/      OPC_EmitConvertToTarget, 15,
/* 60604*/      OPC_EmitConvertToTarget, 16,
/* 60606*/      OPC_EmitConvertToTarget, 17,
/* 60608*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                    MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
                // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
                // Dst: (SHUFFLE:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF)
/* 60632*/    /*Scope*/ 105|128,1/*233*/, /*->60867*/
/* 60634*/      OPC_CheckChild0Type, MVT::v2i64,
/* 60636*/      OPC_RecordChild1, // #1 = $y
/* 60637*/      OPC_CheckChild1Type, MVT::v2i64,
/* 60639*/      OPC_RecordChild2, // #2 = $m0
/* 60640*/      OPC_MoveChild2,
/* 60641*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60644*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60646*/      OPC_CheckType, MVT::i32,
/* 60648*/      OPC_MoveParent,
/* 60649*/      OPC_RecordChild3, // #3 = $m1
/* 60650*/      OPC_MoveChild3,
/* 60651*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60654*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60656*/      OPC_CheckType, MVT::i32,
/* 60658*/      OPC_MoveParent,
/* 60659*/      OPC_RecordChild4, // #4 = $m2
/* 60660*/      OPC_MoveChild4,
/* 60661*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60664*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60666*/      OPC_CheckType, MVT::i32,
/* 60668*/      OPC_MoveParent,
/* 60669*/      OPC_RecordChild5, // #5 = $m3
/* 60670*/      OPC_MoveChild5,
/* 60671*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60674*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60676*/      OPC_CheckType, MVT::i32,
/* 60678*/      OPC_MoveParent,
/* 60679*/      OPC_RecordChild6, // #6 = $m4
/* 60680*/      OPC_MoveChild6,
/* 60681*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60684*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60686*/      OPC_CheckType, MVT::i32,
/* 60688*/      OPC_MoveParent,
/* 60689*/      OPC_RecordChild7, // #7 = $m5
/* 60690*/      OPC_MoveChild7,
/* 60691*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60694*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60696*/      OPC_CheckType, MVT::i32,
/* 60698*/      OPC_MoveParent,
/* 60699*/      OPC_MoveChild, 8,
/* 60701*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60704*/      OPC_RecordNode, // #8 = $m6
/* 60705*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60707*/      OPC_CheckType, MVT::i32,
/* 60709*/      OPC_MoveParent,
/* 60710*/      OPC_MoveChild, 9,
/* 60712*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60715*/      OPC_RecordNode, // #9 = $m7
/* 60716*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60718*/      OPC_CheckType, MVT::i32,
/* 60720*/      OPC_MoveParent,
/* 60721*/      OPC_MoveChild, 10,
/* 60723*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60726*/      OPC_RecordNode, // #10 = $m8
/* 60727*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60729*/      OPC_CheckType, MVT::i32,
/* 60731*/      OPC_MoveParent,
/* 60732*/      OPC_MoveChild, 11,
/* 60734*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60737*/      OPC_RecordNode, // #11 = $m9
/* 60738*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60740*/      OPC_CheckType, MVT::i32,
/* 60742*/      OPC_MoveParent,
/* 60743*/      OPC_MoveChild, 12,
/* 60745*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60748*/      OPC_RecordNode, // #12 = $mA
/* 60749*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60751*/      OPC_CheckType, MVT::i32,
/* 60753*/      OPC_MoveParent,
/* 60754*/      OPC_MoveChild, 13,
/* 60756*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60759*/      OPC_RecordNode, // #13 = $mB
/* 60760*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60762*/      OPC_CheckType, MVT::i32,
/* 60764*/      OPC_MoveParent,
/* 60765*/      OPC_MoveChild, 14,
/* 60767*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60770*/      OPC_RecordNode, // #14 = $mC
/* 60771*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60773*/      OPC_CheckType, MVT::i32,
/* 60775*/      OPC_MoveParent,
/* 60776*/      OPC_MoveChild, 15,
/* 60778*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60781*/      OPC_RecordNode, // #15 = $mD
/* 60782*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60784*/      OPC_CheckType, MVT::i32,
/* 60786*/      OPC_MoveParent,
/* 60787*/      OPC_MoveChild, 16,
/* 60789*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60792*/      OPC_RecordNode, // #16 = $mE
/* 60793*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60795*/      OPC_CheckType, MVT::i32,
/* 60797*/      OPC_MoveParent,
/* 60798*/      OPC_MoveChild, 17,
/* 60800*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60803*/      OPC_RecordNode, // #17 = $mF
/* 60804*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60806*/      OPC_CheckType, MVT::i32,
/* 60808*/      OPC_MoveParent,
/* 60809*/      OPC_CheckType, MVT::v2i64,
/* 60811*/      OPC_EmitConvertToTarget, 2,
/* 60813*/      OPC_EmitConvertToTarget, 3,
/* 60815*/      OPC_EmitConvertToTarget, 4,
/* 60817*/      OPC_EmitConvertToTarget, 5,
/* 60819*/      OPC_EmitConvertToTarget, 6,
/* 60821*/      OPC_EmitConvertToTarget, 7,
/* 60823*/      OPC_EmitConvertToTarget, 8,
/* 60825*/      OPC_EmitConvertToTarget, 9,
/* 60827*/      OPC_EmitConvertToTarget, 10,
/* 60829*/      OPC_EmitConvertToTarget, 11,
/* 60831*/      OPC_EmitConvertToTarget, 12,
/* 60833*/      OPC_EmitConvertToTarget, 13,
/* 60835*/      OPC_EmitConvertToTarget, 14,
/* 60837*/      OPC_EmitConvertToTarget, 15,
/* 60839*/      OPC_EmitConvertToTarget, 16,
/* 60841*/      OPC_EmitConvertToTarget, 17,
/* 60843*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                    MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
                // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
                // Dst: (SHUFFLE:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF)
/* 60867*/    /*Scope*/ 105|128,1/*233*/, /*->61102*/
/* 60869*/      OPC_CheckChild0Type, MVT::v4f32,
/* 60871*/      OPC_RecordChild1, // #1 = $y
/* 60872*/      OPC_CheckChild1Type, MVT::v4f32,
/* 60874*/      OPC_RecordChild2, // #2 = $m0
/* 60875*/      OPC_MoveChild2,
/* 60876*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60879*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60881*/      OPC_CheckType, MVT::i32,
/* 60883*/      OPC_MoveParent,
/* 60884*/      OPC_RecordChild3, // #3 = $m1
/* 60885*/      OPC_MoveChild3,
/* 60886*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60889*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60891*/      OPC_CheckType, MVT::i32,
/* 60893*/      OPC_MoveParent,
/* 60894*/      OPC_RecordChild4, // #4 = $m2
/* 60895*/      OPC_MoveChild4,
/* 60896*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60899*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60901*/      OPC_CheckType, MVT::i32,
/* 60903*/      OPC_MoveParent,
/* 60904*/      OPC_RecordChild5, // #5 = $m3
/* 60905*/      OPC_MoveChild5,
/* 60906*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60909*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60911*/      OPC_CheckType, MVT::i32,
/* 60913*/      OPC_MoveParent,
/* 60914*/      OPC_RecordChild6, // #6 = $m4
/* 60915*/      OPC_MoveChild6,
/* 60916*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60919*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60921*/      OPC_CheckType, MVT::i32,
/* 60923*/      OPC_MoveParent,
/* 60924*/      OPC_RecordChild7, // #7 = $m5
/* 60925*/      OPC_MoveChild7,
/* 60926*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60929*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60931*/      OPC_CheckType, MVT::i32,
/* 60933*/      OPC_MoveParent,
/* 60934*/      OPC_MoveChild, 8,
/* 60936*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60939*/      OPC_RecordNode, // #8 = $m6
/* 60940*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60942*/      OPC_CheckType, MVT::i32,
/* 60944*/      OPC_MoveParent,
/* 60945*/      OPC_MoveChild, 9,
/* 60947*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60950*/      OPC_RecordNode, // #9 = $m7
/* 60951*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60953*/      OPC_CheckType, MVT::i32,
/* 60955*/      OPC_MoveParent,
/* 60956*/      OPC_MoveChild, 10,
/* 60958*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60961*/      OPC_RecordNode, // #10 = $m8
/* 60962*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60964*/      OPC_CheckType, MVT::i32,
/* 60966*/      OPC_MoveParent,
/* 60967*/      OPC_MoveChild, 11,
/* 60969*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60972*/      OPC_RecordNode, // #11 = $m9
/* 60973*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60975*/      OPC_CheckType, MVT::i32,
/* 60977*/      OPC_MoveParent,
/* 60978*/      OPC_MoveChild, 12,
/* 60980*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60983*/      OPC_RecordNode, // #12 = $mA
/* 60984*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60986*/      OPC_CheckType, MVT::i32,
/* 60988*/      OPC_MoveParent,
/* 60989*/      OPC_MoveChild, 13,
/* 60991*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 60994*/      OPC_RecordNode, // #13 = $mB
/* 60995*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 60997*/      OPC_CheckType, MVT::i32,
/* 60999*/      OPC_MoveParent,
/* 61000*/      OPC_MoveChild, 14,
/* 61002*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61005*/      OPC_RecordNode, // #14 = $mC
/* 61006*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61008*/      OPC_CheckType, MVT::i32,
/* 61010*/      OPC_MoveParent,
/* 61011*/      OPC_MoveChild, 15,
/* 61013*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61016*/      OPC_RecordNode, // #15 = $mD
/* 61017*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61019*/      OPC_CheckType, MVT::i32,
/* 61021*/      OPC_MoveParent,
/* 61022*/      OPC_MoveChild, 16,
/* 61024*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61027*/      OPC_RecordNode, // #16 = $mE
/* 61028*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61030*/      OPC_CheckType, MVT::i32,
/* 61032*/      OPC_MoveParent,
/* 61033*/      OPC_MoveChild, 17,
/* 61035*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61038*/      OPC_RecordNode, // #17 = $mF
/* 61039*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61041*/      OPC_CheckType, MVT::i32,
/* 61043*/      OPC_MoveParent,
/* 61044*/      OPC_CheckType, MVT::v4f32,
/* 61046*/      OPC_EmitConvertToTarget, 2,
/* 61048*/      OPC_EmitConvertToTarget, 3,
/* 61050*/      OPC_EmitConvertToTarget, 4,
/* 61052*/      OPC_EmitConvertToTarget, 5,
/* 61054*/      OPC_EmitConvertToTarget, 6,
/* 61056*/      OPC_EmitConvertToTarget, 7,
/* 61058*/      OPC_EmitConvertToTarget, 8,
/* 61060*/      OPC_EmitConvertToTarget, 9,
/* 61062*/      OPC_EmitConvertToTarget, 10,
/* 61064*/      OPC_EmitConvertToTarget, 11,
/* 61066*/      OPC_EmitConvertToTarget, 12,
/* 61068*/      OPC_EmitConvertToTarget, 13,
/* 61070*/      OPC_EmitConvertToTarget, 14,
/* 61072*/      OPC_EmitConvertToTarget, 15,
/* 61074*/      OPC_EmitConvertToTarget, 16,
/* 61076*/      OPC_EmitConvertToTarget, 17,
/* 61078*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                    MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
                // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
                // Dst: (SHUFFLE:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF)
/* 61102*/    /*Scope*/ 105|128,1/*233*/, /*->61337*/
/* 61104*/      OPC_CheckChild0Type, MVT::v2f64,
/* 61106*/      OPC_RecordChild1, // #1 = $y
/* 61107*/      OPC_CheckChild1Type, MVT::v2f64,
/* 61109*/      OPC_RecordChild2, // #2 = $m0
/* 61110*/      OPC_MoveChild2,
/* 61111*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61114*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61116*/      OPC_CheckType, MVT::i32,
/* 61118*/      OPC_MoveParent,
/* 61119*/      OPC_RecordChild3, // #3 = $m1
/* 61120*/      OPC_MoveChild3,
/* 61121*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61124*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61126*/      OPC_CheckType, MVT::i32,
/* 61128*/      OPC_MoveParent,
/* 61129*/      OPC_RecordChild4, // #4 = $m2
/* 61130*/      OPC_MoveChild4,
/* 61131*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61134*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61136*/      OPC_CheckType, MVT::i32,
/* 61138*/      OPC_MoveParent,
/* 61139*/      OPC_RecordChild5, // #5 = $m3
/* 61140*/      OPC_MoveChild5,
/* 61141*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61144*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61146*/      OPC_CheckType, MVT::i32,
/* 61148*/      OPC_MoveParent,
/* 61149*/      OPC_RecordChild6, // #6 = $m4
/* 61150*/      OPC_MoveChild6,
/* 61151*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61154*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61156*/      OPC_CheckType, MVT::i32,
/* 61158*/      OPC_MoveParent,
/* 61159*/      OPC_RecordChild7, // #7 = $m5
/* 61160*/      OPC_MoveChild7,
/* 61161*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61164*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61166*/      OPC_CheckType, MVT::i32,
/* 61168*/      OPC_MoveParent,
/* 61169*/      OPC_MoveChild, 8,
/* 61171*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61174*/      OPC_RecordNode, // #8 = $m6
/* 61175*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61177*/      OPC_CheckType, MVT::i32,
/* 61179*/      OPC_MoveParent,
/* 61180*/      OPC_MoveChild, 9,
/* 61182*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61185*/      OPC_RecordNode, // #9 = $m7
/* 61186*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61188*/      OPC_CheckType, MVT::i32,
/* 61190*/      OPC_MoveParent,
/* 61191*/      OPC_MoveChild, 10,
/* 61193*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61196*/      OPC_RecordNode, // #10 = $m8
/* 61197*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61199*/      OPC_CheckType, MVT::i32,
/* 61201*/      OPC_MoveParent,
/* 61202*/      OPC_MoveChild, 11,
/* 61204*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61207*/      OPC_RecordNode, // #11 = $m9
/* 61208*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61210*/      OPC_CheckType, MVT::i32,
/* 61212*/      OPC_MoveParent,
/* 61213*/      OPC_MoveChild, 12,
/* 61215*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61218*/      OPC_RecordNode, // #12 = $mA
/* 61219*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61221*/      OPC_CheckType, MVT::i32,
/* 61223*/      OPC_MoveParent,
/* 61224*/      OPC_MoveChild, 13,
/* 61226*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61229*/      OPC_RecordNode, // #13 = $mB
/* 61230*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61232*/      OPC_CheckType, MVT::i32,
/* 61234*/      OPC_MoveParent,
/* 61235*/      OPC_MoveChild, 14,
/* 61237*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61240*/      OPC_RecordNode, // #14 = $mC
/* 61241*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61243*/      OPC_CheckType, MVT::i32,
/* 61245*/      OPC_MoveParent,
/* 61246*/      OPC_MoveChild, 15,
/* 61248*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61251*/      OPC_RecordNode, // #15 = $mD
/* 61252*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61254*/      OPC_CheckType, MVT::i32,
/* 61256*/      OPC_MoveParent,
/* 61257*/      OPC_MoveChild, 16,
/* 61259*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61262*/      OPC_RecordNode, // #16 = $mE
/* 61263*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61265*/      OPC_CheckType, MVT::i32,
/* 61267*/      OPC_MoveParent,
/* 61268*/      OPC_MoveChild, 17,
/* 61270*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61273*/      OPC_RecordNode, // #17 = $mF
/* 61274*/      OPC_CheckPredicate, 29, // Predicate_LaneIdx32
/* 61276*/      OPC_CheckType, MVT::i32,
/* 61278*/      OPC_MoveParent,
/* 61279*/      OPC_CheckType, MVT::v2f64,
/* 61281*/      OPC_EmitConvertToTarget, 2,
/* 61283*/      OPC_EmitConvertToTarget, 3,
/* 61285*/      OPC_EmitConvertToTarget, 4,
/* 61287*/      OPC_EmitConvertToTarget, 5,
/* 61289*/      OPC_EmitConvertToTarget, 6,
/* 61291*/      OPC_EmitConvertToTarget, 7,
/* 61293*/      OPC_EmitConvertToTarget, 8,
/* 61295*/      OPC_EmitConvertToTarget, 9,
/* 61297*/      OPC_EmitConvertToTarget, 10,
/* 61299*/      OPC_EmitConvertToTarget, 11,
/* 61301*/      OPC_EmitConvertToTarget, 12,
/* 61303*/      OPC_EmitConvertToTarget, 13,
/* 61305*/      OPC_EmitConvertToTarget, 14,
/* 61307*/      OPC_EmitConvertToTarget, 15,
/* 61309*/      OPC_EmitConvertToTarget, 16,
/* 61311*/      OPC_EmitConvertToTarget, 17,
/* 61313*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                    MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
                // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
                // Dst: (SHUFFLE:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF)
/* 61337*/    0, /*End of Scope*/
/* 61338*/  /*SwitchOpcode*/ 23|128,2/*279*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->61621
/* 61342*/    OPC_RecordChild0, // #0 = $vec
/* 61343*/    OPC_RecordChild1, // #1 = $x
/* 61344*/    OPC_Scope, 121, /*->61467*/ // 4 children in Scope
/* 61346*/      OPC_CheckChild1Type, MVT::i32,
/* 61348*/      OPC_Scope, 66, /*->61416*/ // 2 children in Scope
/* 61350*/        OPC_RecordChild2, // #2 = $idx
/* 61351*/        OPC_MoveChild2,
/* 61352*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61355*/        OPC_CheckType, MVT::i32,
/* 61357*/        OPC_Scope, 18, /*->61377*/ // 3 children in Scope
/* 61359*/          OPC_CheckPredicate, 5, // Predicate_LaneIdx16
/* 61361*/          OPC_MoveParent,
/* 61362*/          OPC_CheckType, MVT::v16i8,
/* 61364*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61366*/          OPC_EmitConvertToTarget, 2,
/* 61368*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                        MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                    // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                    // Dst: (REPLACE_LANE_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 61377*/        /*Scope*/ 18, /*->61396*/
/* 61378*/          OPC_CheckPredicate, 6, // Predicate_LaneIdx8
/* 61380*/          OPC_MoveParent,
/* 61381*/          OPC_CheckType, MVT::v8i16,
/* 61383*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61385*/          OPC_EmitConvertToTarget, 2,
/* 61387*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                        MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                    // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                    // Dst: (REPLACE_LANE_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 61396*/        /*Scope*/ 18, /*->61415*/
/* 61397*/          OPC_CheckPredicate, 23, // Predicate_LaneIdx4
/* 61399*/          OPC_MoveParent,
/* 61400*/          OPC_CheckType, MVT::v4i32,
/* 61402*/          OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61404*/          OPC_EmitConvertToTarget, 2,
/* 61406*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4i32), 0,
                        MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                    // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                    // Dst: (REPLACE_LANE_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 61415*/        0, /*End of Scope*/
/* 61416*/      /*Scope*/ 49, /*->61466*/
/* 61417*/        OPC_MoveChild2,
/* 61418*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 61421*/        OPC_MoveParent,
/* 61422*/        OPC_SwitchType /*3 cases */, 12, MVT::v16i8,// ->61437
/* 61425*/          OPC_EmitInteger, MVT::i32, 0, 
/* 61428*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v16i8), 0,
                        MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                    // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                    // Dst: (REPLACE_LANE_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, I32:{ *:[i32] }:$x)
/* 61437*/        /*SwitchType*/ 12, MVT::v8i16,// ->61451
/* 61439*/          OPC_EmitInteger, MVT::i32, 0, 
/* 61442*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v8i16), 0,
                        MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                    // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                    // Dst: (REPLACE_LANE_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, I32:{ *:[i32] }:$x)
/* 61451*/        /*SwitchType*/ 12, MVT::v4i32,// ->61465
/* 61453*/          OPC_EmitInteger, MVT::i32, 0, 
/* 61456*/          OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4i32), 0,
                        MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                    // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                    // Dst: (REPLACE_LANE_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, I32:{ *:[i32] }:$x)
/* 61465*/        0, // EndSwitchType
/* 61466*/      0, /*End of Scope*/
/* 61467*/    /*Scope*/ 50, /*->61518*/
/* 61468*/      OPC_CheckChild1Type, MVT::i64,
/* 61470*/      OPC_Scope, 25, /*->61497*/ // 2 children in Scope
/* 61472*/        OPC_RecordChild2, // #2 = $idx
/* 61473*/        OPC_MoveChild2,
/* 61474*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61477*/        OPC_CheckPredicate, 24, // Predicate_LaneIdx2
/* 61479*/        OPC_CheckType, MVT::i32,
/* 61481*/        OPC_MoveParent,
/* 61482*/        OPC_CheckType, MVT::v2i64,
/* 61484*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61486*/        OPC_EmitConvertToTarget, 2,
/* 61488*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v2i64), 0,
                      MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                  // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                  // Dst: (REPLACE_LANE_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 61497*/      /*Scope*/ 19, /*->61517*/
/* 61498*/        OPC_MoveChild2,
/* 61499*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 61502*/        OPC_MoveParent,
/* 61503*/        OPC_CheckType, MVT::v2i64,
/* 61505*/        OPC_EmitInteger, MVT::i32, 0, 
/* 61508*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v2i64), 0,
                      MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                  // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (REPLACE_LANE_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, I64:{ *:[i64] }:$x)
/* 61517*/      0, /*End of Scope*/
/* 61518*/    /*Scope*/ 50, /*->61569*/
/* 61519*/      OPC_CheckChild1Type, MVT::f32,
/* 61521*/      OPC_Scope, 25, /*->61548*/ // 2 children in Scope
/* 61523*/        OPC_RecordChild2, // #2 = $idx
/* 61524*/        OPC_MoveChild2,
/* 61525*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61528*/        OPC_CheckPredicate, 23, // Predicate_LaneIdx4
/* 61530*/        OPC_CheckType, MVT::i32,
/* 61532*/        OPC_MoveParent,
/* 61533*/        OPC_CheckType, MVT::v4f32,
/* 61535*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61537*/        OPC_EmitConvertToTarget, 2,
/* 61539*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4f32), 0,
                      MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                  // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                  // Dst: (REPLACE_LANE_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 61548*/      /*Scope*/ 19, /*->61568*/
/* 61549*/        OPC_MoveChild2,
/* 61550*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 61553*/        OPC_MoveParent,
/* 61554*/        OPC_CheckType, MVT::v4f32,
/* 61556*/        OPC_EmitInteger, MVT::i32, 0, 
/* 61559*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v4f32), 0,
                      MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                  // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (REPLACE_LANE_v4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, F32:{ *:[f32] }:$x)
/* 61568*/      0, /*End of Scope*/
/* 61569*/    /*Scope*/ 50, /*->61620*/
/* 61570*/      OPC_CheckChild1Type, MVT::f64,
/* 61572*/      OPC_Scope, 25, /*->61599*/ // 2 children in Scope
/* 61574*/        OPC_RecordChild2, // #2 = $idx
/* 61575*/        OPC_MoveChild2,
/* 61576*/        OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 61579*/        OPC_CheckPredicate, 24, // Predicate_LaneIdx2
/* 61581*/        OPC_CheckType, MVT::i32,
/* 61583*/        OPC_MoveParent,
/* 61584*/        OPC_CheckType, MVT::v2f64,
/* 61586*/        OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61588*/        OPC_EmitConvertToTarget, 2,
/* 61590*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v2f64), 0,
                      MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                  // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                  // Dst: (REPLACE_LANE_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 61599*/      /*Scope*/ 19, /*->61619*/
/* 61600*/        OPC_MoveChild2,
/* 61601*/        OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 61604*/        OPC_MoveParent,
/* 61605*/        OPC_CheckType, MVT::v2f64,
/* 61607*/        OPC_EmitInteger, MVT::i32, 0, 
/* 61610*/        OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_v2f64), 0,
                      MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                  // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                  // Dst: (REPLACE_LANE_v2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, F64:{ *:[f64] }:$x)
/* 61619*/      0, /*End of Scope*/
/* 61620*/    0, /*End of Scope*/
/* 61621*/  /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->61636
/* 61624*/    OPC_RecordChild0, // #0 = $vec
/* 61625*/    OPC_RecordChild1, // #1 = $x
/* 61626*/    OPC_CheckType, MVT::v2i64,
/* 61628*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_v2i64), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 61636*/  /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->61651
/* 61639*/    OPC_RecordChild0, // #0 = $vec
/* 61640*/    OPC_RecordChild1, // #1 = $x
/* 61641*/    OPC_CheckType, MVT::v2i64,
/* 61643*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_v2i64), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 61651*/  /*SwitchOpcode*/ 12, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->61666
/* 61654*/    OPC_RecordChild0, // #0 = $vec
/* 61655*/    OPC_RecordChild1, // #1 = $x
/* 61656*/    OPC_CheckType, MVT::v2i64,
/* 61658*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_v2i64), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_U_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 61666*/  /*SwitchOpcode*/ 28, TARGET_VAL(ISD::SADDSAT),// ->61697
/* 61669*/    OPC_RecordChild0, // #0 = $lhs
/* 61670*/    OPC_RecordChild1, // #1 = $rhs
/* 61671*/    OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->61684
/* 61674*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61676*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_v16i8), 0,
                    MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                // Dst: (ADD_SAT_S_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 61684*/    /*SwitchType*/ 10, MVT::v8i16,// ->61696
/* 61686*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61688*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_v8i16), 0,
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                // Dst: (ADD_SAT_S_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 61696*/    0, // EndSwitchType
/* 61697*/  /*SwitchOpcode*/ 28, TARGET_VAL(ISD::UADDSAT),// ->61728
/* 61700*/    OPC_RecordChild0, // #0 = $lhs
/* 61701*/    OPC_RecordChild1, // #1 = $rhs
/* 61702*/    OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->61715
/* 61705*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61707*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_v16i8), 0,
                    MVT::v16i8, 2/*#Ops*/, 0, 1, 
                // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
                // Dst: (ADD_SAT_U_v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 61715*/    /*SwitchType*/ 10, MVT::v8i16,// ->61727
/* 61717*/      OPC_CheckPatternPredicate, 2, // (Subtarget->hasSIMD128())
/* 61719*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_v8i16), 0,
                    MVT::v8i16, 2/*#Ops*/, 0, 1, 
                // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
                // Dst: (ADD_SAT_U_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 61727*/    0, // EndSwitchType
/* 61728*/  0, // EndSwitchOpcode
    0
  }; // Total Array size is 61730 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 542
  // #OPC_RecordNode                           = 421
  // #OPC_RecordChild                          = 2081
  // #OPC_RecordMemRef                         = 330
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 2332
  // #OPC_MoveParent                           = 3190
  // #OPC_CheckSame                            = 48
  // #OPC_CheckChildSame                       = 84
  // #OPC_CheckPatternPredicate                = 1202
  // #OPC_CheckPredicate                       = 2027
  // #OPC_CheckOpcode                          = 2159
  // #OPC_SwitchOpcode                         = 97
  // #OPC_CheckType                            = 1127
  // #OPC_SwitchType                           = 230
  // #OPC_CheckChildType                       = 273
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 22
  // #OPC_CheckCondCode                        = 100
  // #OPC_CheckValueType                       = 7
  // #OPC_CheckComplexPat                      = 0
  // #OPC_CheckAndImm                          = 308
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckFoldableChainNode               = 302
  // #OPC_EmitInteger                          = 1977
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 582
  // #OPC_EmitMergeInputChains                 = 1456
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 449
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 30
  // #OPC_MorphNodeTo                          = 1928

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasAtomics());
  case 1: return (Subtarget->hasSIMD128()) && (Subtarget->hasUnimplementedSIMD128());
  case 2: return (Subtarget->hasSIMD128());
  case 3: return (!Subtarget->hasAddr64());
  case 4: return (Subtarget->hasExceptionHandling());
  case 5: return (Subtarget->hasSignExt());
  case 6: return (Subtarget->hasNontrappingFPToInt());
  case 7: return (!Subtarget->hasNontrappingFPToInt());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: { 
    // Predicate_regPlusGA
    SDNode *N = Node;
    (void)N;

  return N->getFlags().hasNoUnsignedWrap();

  }
  case 1: { 
    // Predicate_atomic_load_add_8
    // Predicate_atomic_load_sub_8
    // Predicate_atomic_load_and_8
    // Predicate_atomic_load_or_8
    // Predicate_atomic_load_xor_8
    // Predicate_atomic_swap_8
    // Predicate_atomic_load_8
    // Predicate_atomic_cmp_swap_8
    // Predicate_atomic_store_8
    SDNode *N = Node;
    (void)N;
if (cast<AtomicSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: { 
    // Predicate_atomic_load_add_16
    // Predicate_atomic_load_sub_16
    // Predicate_atomic_load_and_16
    // Predicate_atomic_load_or_16
    // Predicate_atomic_load_xor_16
    // Predicate_atomic_swap_16
    // Predicate_atomic_load_16
    // Predicate_atomic_cmp_swap_16
    // Predicate_atomic_store_16
    SDNode *N = Node;
    (void)N;
if (cast<AtomicSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: { 
    // Predicate_regPlusImm
    SDNode *N = Node;
    (void)N;
 return N->getFlags().hasNoUnsignedWrap(); 
  }
  case 4: { 
    // Predicate_or_is_add
    SDNode *N = Node;
    (void)N;

  if (ConstantSDNode *CN = dyn_cast<ConstantSDNode>(N->getOperand(1)))
    return CurDAG->MaskedValueIsZero(N->getOperand(0), CN->getAPIntValue());

  KnownBits Known0 = CurDAG->computeKnownBits(N->getOperand(0), 0);
  KnownBits Known1 = CurDAG->computeKnownBits(N->getOperand(1), 0);
  return (~Known0.Zero & ~Known1.Zero) == 0;

  }
  case 5: { 
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 6: { 
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 7: { 
    // Predicate_atomic_cmp_swap_32
    // Predicate_atomic_load_add_32
    // Predicate_atomic_load_sub_32
    // Predicate_atomic_load_and_32
    // Predicate_atomic_load_or_32
    // Predicate_atomic_load_xor_32
    // Predicate_atomic_swap_32
    // Predicate_atomic_store_32
    // Predicate_atomic_load_32
    SDNode *N = Node;
    (void)N;
if (cast<AtomicSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 8: { 
    // Predicate_atomic_store_64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_64
    // Predicate_atomic_load_sub_64
    // Predicate_atomic_load_and_64
    // Predicate_atomic_load_or_64
    // Predicate_atomic_load_xor_64
    // Predicate_atomic_swap_64
    // Predicate_atomic_cmp_swap_64
    SDNode *N = Node;
    (void)N;
if (cast<AtomicSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 9: { 
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 10: { 
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 11: { 
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 12: { 
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    // Predicate_extloadi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 13: { 
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 14: { 
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    // Predicate_extloadi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 15: { 
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    // Predicate_extloadi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 16: { 
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 17: { 
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 18: { 
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 19: { 
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: { 
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 21: { 
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 22: { 
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 23: { 
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 24: { 
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 25: { 
    // Predicate_immAllZerosV
    SDNode *N = Node;
    (void)N;

  return ISD::isBuildVectorAllZeros(N);

  }
  case 26: { 
    // Predicate_immAllOnesV
    SDNode *N = Node;
    (void)N;

  return ISD::isBuildVectorAllOnes(N);

  }
  case 27: { 
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return ((uint64_t)Imm & ((1UL << 8) - 1)) == (uint64_t)Imm;
  }
  case 28: { 
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return ((uint64_t)Imm & ((1UL << 16) - 1)) == (uint64_t)Imm;
  }
  case 29: { 
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
